

#include	<stdio.h>
#include	<stdint.h>
#include	"stm32f2xx.h"
#include	"core_cm3.h"
#include	"ra8870.h"
#include	"spi.h"

TIM_TimeBaseInitTypeDef  	TIM_TimeBaseStructure;
TIM_OCInitTypeDef  			TIM_OCInitStructure;

uint32_t    timeCount;
uint32_t    usbflags,beepDuration;

#define		BIT0			1
#define 	BIT1			2
#define 	BIT2			4
#define 	BIT3			8
#define 	BIT4			16
#define 	BIT5			32
#define 	BIT6			64
#define		BIT7			128

#define 	BIT8			256
#define 	BIT9			512
#define 	BIT10			1024
#define 	BIT11			2048
#define		BIT12			4096
#define 	BIT13			8192
#define		BIT14			16384
#define		BIT15			32768

#define		BIT16			0x00010000
#define 	BIT17			0x00020000
#define 	BIT18			0x00040000
#define 	BIT19			0x00080000
#define 	BIT20			0x00100000
#define 	BIT21			0x00200000
#define 	BIT22			0x00400000
#define		BIT23			0x00800000

#define 	BIT24			0x01000000
#define 	BIT25			0x02000000
#define 	BIT26			0x04000000
#define 	BIT27			0x08000000
#define		BIT28			0x10000000
#define 	BIT29			0x20000000
#define		BIT30			0x40000000
#define		BIT31			0x80000000





SOFT_TIMER	softTimer[TIMER_COUNT];


void delayMs(int32_t time)
{
	uint32_t tt ;
	for ( ;time >= 0; time --)
	{
	    for (tt = 0 ; tt < 30000 ;tt++)
		    ;
	}	  
}








#if DUT_DEVICE == LCR_4030

__INLINE uint8_t readData(void)
{   
	return LCD_DATA_ADD;
}
__INLINE uint8_t readCOMM(void)
{
	return LCD_COMM_ADD;
}




void Memory_Clear(void)
{
	uint8_t temp;
	writeCommand(0x8e);//MCLR
	temp = readData();
	temp |= BIT7;
	writeData(temp);
}






/*
  RA8870 
*/
void RA8870_WAITSTATUS(void)
{
	while(!(GPIOD->IDR & GPIO_Pin_6 ));
}
uint8_t LCD_StatusRead(void)
{
	uint16_t Data;
	Data = readCOMM();
	return Data;
}


/*
rICM
*/

void Memory_Clear_with_Font_BgColor(void)
{
	uint8_t temp;
	writeCommand(0x8e);//MCLR
	temp = readData();
	temp |= BIT0;
	writeData(temp);
}





/*
   \:O X Yϰ]w REG[46h]~/EG[49h]
   XL :X_l    XR :X
   YT :Y_l	YB :Y
REG[46h]~REG[49h]
*/
void XY_Coordinate(uint16_t X,uint16_t Y)
{
	  // ] V H ۤϳ]w ҥH X,Y ]wۤ
	writeCommand(0x46);
	writeData(Y);
	writeCommand(0x47);
	writeData(Y>>8);
	writeCommand(0x48);
	writeData(X);
	writeCommand(0x49);
	writeData(X>>8);

}



/**************************************************************************************
\GMLCD̹
JG    ؼC
XG	  L
**************************************************************************************/
void LcdClear(uint16_t color)
{

    uint32_t i;
    XY_Coordinate(0, 0); /* X,Y w */
	writeCommand(0x02);
	for(i = 0 ; i < (480*272) ; i++)
	{
		writeData(color); //IC
//		Chk_Busy();
	}


}



/*
	256 ϧδC0 ]w
*/

//---------------------------------//
//REG[84h]
	/*
void Graphic_Cursor_Color_0(uint8_t setx)
{	  
	writeCommand(0x84);//GCC0
	writeData(setx); 
}  									  
			 */



 //------------------------//
//STATUS 
void Chk_Busy(void)
{
	uint8_t temp;
	do
	{
		temp=LCD_StatusRead();
	}while((temp&0x80)==0x80);
}		 
void Display_ON(void)
{	
	writeCommand(0x01);//PWRR
	writeData(0x80);
	RA8870_WAITSTATUS();
}

void HDIR_SEGn_SEG0(void)
{
	uint8_t temp;
	writeCommand(0x20);//DPCR
	temp = readData();
	temp |= (BIT3) ;
	writeData(temp);
	RA8870_WAITSTATUS();
}	
void VDIR_COMn_COM0(void)
{
	uint8_t temp;
	writeCommand(0x20);//DPCR
	temp = readData();
	temp |= (BIT2) ;
	writeData(temp);
}



void Memory_Write_TopDown_LeftRight(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT3+BIT2) ;
//	temp |= BIT3 ;
	writeData(temp);
} 






void text_mode(void)
{
	uint8_t temp;


	writeCommand(0x21);//
	temp = readData();
	temp &= ~(BIT7+BIT5) ; 
	writeData(temp);

	writeCommand(0x42);//re
	writeData(0xFF);

	writeCommand(0x43);//rI
	writeData(0x03);






}




/*

TFT_LCDİϰ]w

(XL,YT)	W
(XR,YB)	kW



     (0,0) ------------------------------|
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |-----------------------------|
										  (479,271)



*/
void Active_Window(uint16_t XL,uint16_t XR ,uint16_t YT ,uint16_t YB)
{

 	//Active window  set 
	//setting active window X   480 * 272
	writeCommand(0x30); //Horizontal Start Point 0 of Active Window (HSAW0)
	writeData(XL); //Horizontal Start Point of Active Window [7:0]

	writeCommand(0x31); //Horizontal Start Point 1 of Active Window (HSAW1)	   
	writeData(XL >> 8); //Horizontal Start Point of Active Window [9:8]

	writeCommand(0x34); //Horizontal End Point 0 of Active Window (HEAW0)
	writeData(XR); //Horizontal End Point of Active Window [7:0]

	writeCommand(0x35); //Horizontal End Point 1 of Active Window (HEAW1)	   
	writeData(XR >> 8); //Horizontal End Point of Active Window [9:8]


	
	//setting active window Y
	writeCommand(0x32); //Vertical Start Point 0 of Active Window (VSAW0)
	writeData(YT); //Vertical Start Point of Active Window [7:0]

	writeCommand(0x33); //Vertical Start Point 1 of Active Window (VSAW1)	   
	writeData(YT >> 8); //Vertical Start Point of Active Window [8]

	writeCommand(0x36); //Vertical End Point of Active Window 0 (VEAW0)
	writeData(YB); //Vertical End Point of Active Window [7:0]

	writeCommand(0x37); //Vertical End Point of Active Window 1 (VEAW1)	   
	writeData(YB >> 8); //Vertical End Point of Active Window [8]



}


void software_reset(void)
{
/* **** SOFTWARE RESET ***** */
    writeCommand(0x01);
	writeData(0x01);
	delayMs(1);
	writeData(0x00);
	delayMs(100);
/*****************************/
}

void initializeRa8870Pll(void)
{
	writeCommand(0x88);	//SYS_CLK = FIN*(PLLDIVN[4:0] +1)/((PLLDIVM+1)*(2^PLLDIVK[2:0]))   = 8Mhz *(20+1)/16 = 168M/4 = 42Mhz
						//	6-7 : Clock ]wPOѪRתY   480*272 1 8/12 NA NA 10.4MHz	]SYS_CLK /2^*1
	writeData(0x014);	//PLLDIVN[4:0] = 20; FIN = 8MHz  PLLDIVM =0   
		
	writeCommand(0x89);
	writeData(0x01);	//PLLDIVK[2:0] = 1 (2^1 =2)
	delayMs(100);
	
	software_reset();
}

/**
  * @brief  Configures the FSMC and GPIOs to interface with the SRAM memory.
  *         This function must be called before any write/read operation
  *         on the SRAM.
  * @param  None 
  * @retval None
  */
void initializeFSMCSRAM(void)
{
    FSMC_NORSRAMInitTypeDef  FSMC_NORSRAMInitStructure;
    FSMC_NORSRAMTimingInitTypeDef  p;
    GPIO_InitTypeDef GPIO_InitStructure; 
  
    /* Enable GPIOD, GPIOE, GPIOF, GPIOG and AFIO clocks */
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD | RCC_AHB1Periph_GPIOE , ENABLE);
                          
    /*-- GPIO Configuration ------------------------------------------------------*/
    /* SRAM Data lines,  NOE and NWE configuration */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_8 | GPIO_Pin_9 |		 /* D2,D3,D13,D14 	*/
                                GPIO_Pin_10 | GPIO_Pin_14 | GPIO_Pin_15 |				 /* D15,D0,D1 		*/
                                GPIO_Pin_4 |GPIO_Pin_5;;								 /* NOW,NEW			*/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;

    GPIO_Init(GPIOD, &GPIO_InitStructure);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource0, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource1, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource4, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource5, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource8, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource9, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource10, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource14, GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource15, GPIO_AF_FSMC);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 |		/* D4,D5,D6,D7		*/	
                                GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | 	/* D8,D9,D10,D11 	*/
                                GPIO_Pin_15;												/* D12 */
    GPIO_Init(GPIOE, &GPIO_InitStructure);

    GPIO_PinAFConfig(GPIOE, GPIO_PinSource7 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource8 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource9 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource10 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource11 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource12 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource13 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource14 , GPIO_AF_FSMC);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource15 , GPIO_AF_FSMC);

    /* SRAM Address lines A16 configuration */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_Init(GPIOD, &GPIO_InitStructure);  
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource11, GPIO_AF_FSMC);
  
    /* NE1 configuration */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7; 
    GPIO_Init(GPIOD, &GPIO_InitStructure);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource7, GPIO_AF_FSMC);

	/* GPIOC Periph clock enable */
  	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);
    /* Configure PC9 output pushpull mode ,RA8870 clock ~ 8Mhz */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    RCC_MCO2Config(RCC_MCO2Source_HSE,RCC_MCO2Div_1);  // no division

   	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 ;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP ;
  	GPIO_Init(GPIOC, &GPIO_InitStructure); 






  	/* PA4  LCD POWER Pin */
	/* GPIOA Periph clock enable */
  	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
	 GPIO_ResetBits(GPIOA,	  GPIO_Pin_4); // RA8870 DISP PIN LO 
	 
	/* GPIOD Periph clock enable */
  	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
	/* PD3  LCD_INT   PD6 LCD_WAIT */
	GPIO_InitStructure.GPIO_Pin = (GPIO_Pin_3 | GPIO_Pin_6);
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_Init(GPIOD, &GPIO_InitStructure);





    

 
/*-- FSMC Configuration ------------------------------------------------------*/
  
    // Enable FSMC clock 
    RCC_AHB3PeriphClockCmd(RCC_AHB3Periph_FSMC, ENABLE);  
  
    p.FSMC_AddressSetupTime = 0;//0
    p.FSMC_AddressHoldTime = 0; //0
    p.FSMC_DataSetupTime = 2;   //2
    p.FSMC_BusTurnAroundDuration = 0; //0
    p.FSMC_CLKDivision = 0;//0
    p.FSMC_DataLatency = 0;//0
    p.FSMC_AccessMode = FSMC_AccessMode_A;
//    p.FSMC_AccessMode = FSMC_AccessMode_B;

 
    FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM1;
    FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable;
    FSMC_NORSRAMInitStructure.FSMC_MemoryType = FSMC_MemoryType_SRAM;
    FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;
    FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode = FSMC_BurstAccessMode_Disable;
    FSMC_NORSRAMInitStructure.FSMC_AsynchronousWait = FSMC_AsynchronousWait_Disable;
    FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
    FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;
    FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_BeforeWaitState;
    FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;
    FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Disable;
    FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Disable;
    FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable;
    FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &p;
    FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &p;

    FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure); 
  
    // Enable FSMC Bank1_SRAM Bank 
    FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1, ENABLE); 


//	FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM3, ENABLE);	   //oOFH,_hUSB|{... KEN_DEBUG
//	LCD_SetFont (&Font12x12);
}

void InitializeRa8870(void)
{
	
	initializeRa8870Pll();// PLL initial

	writeCommand(0x10);// ƦTFT LCD O, æƿX,O
	writeData(0x06);   // 12-bpp Generic TFT OApϥ4K ,	16-bit MCU ɭ	
	
	writeCommand(0x04);  //PCLK inverse
	writeData(0x81);       // PCLK = SYS_CLK/((2^(Layer Setting Control + 1)) * (2^PPWS))
					       // PPWS = 0,SYS_CLK = 42Mhz ,Layer Setting Control = 0
					       //PCLK = 42Mhz/((2^0+1)) * (2^0)) = 42Mhz/(2*2) = 10.5Mhz.
	delayMs(1);

	//Horizontal set  RA8870 480*272 S ,nq˳]w ==> M90ױy HugV]n
	writeCommand(0x14); //HDWR//Horizontal Display Width Setting Bit[6:0]                      
	writeData(0x21);//Horizontal display width(pixels) = (HDWR + 1)*8      = (33+1)*8 = 272               
//	writeCommand(0x15);//Horizontal Non-Display Period Fine Tuning Option Register (HNDFTR)   
//	writeData(0x03);//Horizontal Non-Display Period Fine Tuning(HNDFT) [3:0]               
	writeCommand(0x16); //HNDR//Horizontal Non-Display Period Bit[4:0]                         
	writeData(0x01);//Horizontal Non-Display Period (pixels) = (HNDR + 1)*8    Dܼeס]pixel^=]HNDR + 1^*8 + HNDFTR+2  = (0+1)*8+ 3+2  = 13               
	writeCommand(0x17); //HSTR//HSYNC Start Position[4:0]                                      
	writeData(0x01);//HSYNC Start Position(PCLK) = (HSTR + 1)*8 = 8                           
	writeCommand(0x18); //HPWR//HSYNC Polarity ,The period width of HSYNC.                     
	writeData(0x09);//HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8 = 24    			;13+8+24 = 45 
	delayMs(1);
	//Vertical set                             
	writeCommand(0x19); //VDHR0 //Vertical Display Height Bit [7:0]                            
	writeData(0xdf);//Vertical pixels = VDHR + 1 = 479+1 = 480                                          
	writeCommand(0x1a); //VDHR1 //Vertical Display Height Bit [8]                              
	writeData(0x01);//Vertical pixels = VDHR + 1 = 1+1 = 2                                           
	writeCommand(0x1b); //VNDR0 //Vertical Non-Display Period Bit [7:0]                        
	writeData(0x01);//Vertical Non-Display area = (VNDR0 ) = (1+1) = 2                               
	writeCommand(0x1c); //VNDR1 //Vertical Non-Display Period Bit [8]                          
	writeData(0x00);//Vertical Non-Display area = (VNDR1 ) = 0                              
	writeCommand(0x1d); //VSTR0 //VSYNC Start Position[7:0]                                    
	writeData(0x01);//VSYNC Start Position(PCLK) = (VSTR0 + 1) = 1 +1 = 2                             
	writeCommand(0x1e); //VSTR1 //VSYNC Start Position[8]                                      
	writeData(0x00);//VSYNC Start Position(PCLK) = (VSTR1 ) = 0                            
	writeCommand(0x1f); //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]                        
	writeData(0x28);//VSYNC Pulse Width(PCLK) = (VPWR + 1) = 9+1 = 10                                 
	delayMs(1);

//	writeCommand(0x20); //]w90
//	writeData(0x01);

	writeCommand(0x20); //`
	writeData(0x03);

	writeCommand(0x22); //`
	writeData(0x10);

	
	Active_Window(0 ,271 ,0 ,479);		/* ĵ]w 4.3" TFT  쥻O(0,479,0,271) ] 90 ҥHx,ybnۤ*/

/********************************************************
     (0,0) ------------------------------|
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |-----------------------------|
										  (479,271)		   */

	HDIR_SEGn_SEG0();
	VDIR_COMn_COM0();
    Memory_Write_TopDown_LeftRight();	 //ѤWӤU  ѥӥk

/*********************************************************/

	Memory_Clear_with_Font_BgColor();	/* clear rIC */
	Memory_Clear();				 		/* OвM */
	Chk_Busy();
	GPIO_SetBits(GPIOA,	  GPIO_Pin_4); // RA8870 DISP PIN HI
	Display_ON();						/* ù */
	LcdClear(0x000F);// BLUE

	text_mode();





}


/*==================================================================================*/
/************ HUO BUZZER PWM drive Cinitial \ **************************/
/* PWM Wb PA8 (TIM1_CH1) X 2KhzWv  duty cycle 50%							*/
/*==================================================================================*/



/*==================================================================================*/
/************ 	iHΦbIIt					   **************************/
/* PWM Wb PC8 (TIM3_CH3) X 20KhzWv  duty cycle 50%							*/
/*==================================================================================*/


void TIM3_CH3_PWMOUT_Init(void)
{
	GPIO_InitTypeDef  			GPIO_InitStructure;
 	
  	/************* TIM3_CH3 (PWM out) *****************/
  	/* TIM3 clock enable */
  	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);

  	/* GPIOC clock enable */
  	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);
  
  	/* GPIOF Configuration: TIM3 CH3 (PC8) */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 ;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP ;
  	GPIO_Init(GPIOC, &GPIO_InitStructure); 
	
  	/* Connect TIM3 pins to AF2 */
  	GPIO_PinAFConfig(GPIOC, GPIO_PinSource8, GPIO_AF_TIM3);

  	/* -----------------------------------------------------------------------
    TIM3 Configuration: generate 1 PWM signal:
    The TIM1CLK frequency is set to SystemCoreClock (Hz), to get TIM3 counter
    clock at 2 MHz the Prescaler is computed as following:
     - Prescaler = (TIM1CLK / TIM1 counter clock) - 1
    SystemCoreClock/2 is set to 60 MHz for STM32F2xx devices

    The TIM3 is running at 2 KHz: TIM3 Frequency = TIM3 counter clock /(ARR + 1)
                                                    = 2000000 / 100 = 20 KHz
    TIM1 Channel1 duty cycle = (TIM3_CCR1/ TIM3_ARR)* 100 = 50%

  	----------------------------------------------------------------------- */


  	/* Time base configuration */
  	TIM_TimeBaseStructure.TIM_Period = 100;
  	TIM_TimeBaseStructure.TIM_Prescaler = (uint16_t) ((SystemCoreClock /2) / 2000000) - 1;
  	TIM_TimeBaseStructure.TIM_ClockDivision = 0;
  	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

  	TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);

  	/* PWM1 Mode configuration: Channel3 */
  	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
  	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStructure.TIM_Pulse = 99;				/* 99/100   99% duty cycle */
  	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;

  	TIM_OC3Init(TIM3, &TIM_OCInitStructure);

  	TIM_OC3PreloadConfig(TIM3, TIM_OCPreload_Enable);

  	TIM_ARRPreloadConfig(TIM3, ENABLE);

  	/* TIM1 enable counter */
  	TIM_Cmd(TIM3, ENABLE);
}
#elif DUT_DEVICE == PVS

uint8_t keyInBuffer[7];
uint8_t displayBuffer[49]={0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
 0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, 0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
} ;																   
uint8_t displayFresh;

uint8_t keyHold, leftRotary, rightRotary;
uint8_t rxVFDBuffer[7];
                                // 	0	1	2	3	4	5	6	7	8	9  10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31  32 //
const uint8_t keyConvertion[33] = { 0, 13, 27, 28, 11,  1, 16, 10,  0, 14, 16, 15, 25, 26,  8,  9,  0, 23, 24,  5,  6,  7,  4,  3,  0, 18, 19, 20, 12, 21, 22,  2, 17};
uint32_t rawKeyCode;
uint8_t  keyCode;




void setVFDCursorOff(void)
{
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x08);				// cursor off
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}
void clearVFD(void)
{
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x01);				// clear screen
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}
void setVFDFlashOff(uint8_t pos, uint8_t len)
{

  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x87);
	sVFD_SendByte(pos-0x40);			// position = real position - 0x30
	sVFD_SendByte(len);
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}



void initializeVFD(void)
{
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x06);				// cursor ON
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1

	clearVFD();
	delay5us(2);
	setVFDFlashOff(0x40, 0x30);
	delay5us(2);
	setVFDCursorOff();
}


void dispVFD48(char* string)
{
    uint8_t i;
	setVFDCursorOff();
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x40);				// character position
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1

  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x84);
	for (i = 0; i <= 48 ; i++) 
	{
	    if (string[i] == 0)
		    string[i] = ' ';
		if (string[i] == '<')
		    string[i] = 0xD3;
		if (string[i] == '>')
		    string[i] = 0xD4;
	    sVFD_SendByte(string[i]);
	}
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}

void delay5us(uint32_t nus)
{
	uint32_t time;
    for (time = 0 ; time < (nus * 47000) ; time++)
	   ;
}

uint8_t getKey(void)
{
	uint8_t ki;
	uint32_t keyMask = 0x00000001;
//    uint32_t rawKeyCode;

    VFD_SPI_CS_LOW;    					// SPI_CS = 0
	sVFD_SendByte(0x81);
	for (ki = 0; ki < 7; ki++)
	{
		delay5us(1);
		rxVFDBuffer[ki] = sVFD_ReadByte();
	}
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
	rawKeyCode = (((uint32_t)rxVFDBuffer[0]) << 24) | (((uint32_t)rxVFDBuffer[1]) << 16) | (((uint32_t)rxVFDBuffer[2]) << 8) | ((uint32_t)rxVFDBuffer[3]);
	leftRotary = rxVFDBuffer[4];
	rightRotary = rxVFDBuffer[5];
	if (rawKeyCode)
	{
		if (!keyHold)
		{
	    	keyHold = 1;
			for (ki = 1; ki < 33; ki++, keyMask = keyMask << 1)
			{
				if (rawKeyCode & keyMask) break; 	
			}
//			beep(70 );
			return(keyConvertion[ki]);
		}
	}
	else keyHold = 0;
	return(0);
}




#endif

void printText(uint16_t Xpos,uint16_t Ypos,uint8_t *str)
{
#if DUT_DEVICE == LCR_4030
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp |= BIT7 ; //text mode
	writeData(temp);

    XY_Coordinate(Xpos, Ypos); /* X,Y w */
	writeCommand(0x02);		//MRWC  REG[02h] -- Memory Read/Write Command
	while ((*str != 0))
		writeData(*str++);	
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~BIT7 ; //ø mode
	writeData(temp);
#elif DUT_DEVICE == PVS
    uint8_t i;
	for (i = 0 ; *str != 0 ;i++ ,str++)
		displayBuffer[11 + i] = *str;
	dispVFD48((void *)displayBuffer);
#endif


}





















