
#ifndef	_RA8870_H
#define _RA8870_H

#define LCR_4030		0
#define PVS				1


#define DUT_DEVICE	PVS  /* Oon Out_bin\hextobin.bat  
								rem copy UsbDFU1.bin ..\..\..\PVS\Out_bin\UsbDFU\UsbDFU.bin
								rem copy UsbDFU.hex ..\..\..\PVS\Out_bin\UsbDFU\UsbDFU.hex
 								copy UsbDFU1.bin ..\..\..\LCR\Out_bin\UsbDFU\UsbDFU.bin
 								copy UsbDFU.hex ..\..\..\LCR\Out_bin\UsbDFU\UsbDFU.hex
							  */
#if DUT_DEVICE == LCR_4030
	// ra8870 d0-d15 -------- D0-D15
	// ra8870 #d/c   -------- A16
	// ra8870 #cs    -------- NE1
	// ra8870 #wr    -------- WR
	// ra8870 #rd    -------- RD
	
	#define LCD_COMM_ADD		*((uint16_t *)0X60020000)	
	#define LCD_DATA_ADD		*((uint16_t *)0X60000000)

	#define writeCommand(cmd)	{RA8870_WAITSTATUS();LCD_COMM_ADD = cmd;}
    #define writeData(data)		{RA8870_WAITSTATUS();LCD_DATA_ADD = data;}




void InitializeRa8870(void);
void RA8870_WAITSTATUS(void);
void Memory_Clear_with_Font_BgColor(void);
void Chk_Busy(void);
void XY_Coordinate(uint16_t X,uint16_t Y);
void initializeFSMCSRAM(void);
void BuzzerPWMInit(uint32_t freq);
void TIM3_CH3_PWMOUT_Init(void);
void beep(uint32_t time);
void stopBeep(void);

#elif  DUT_DEVICE == PVS

extern uint8_t keyInBuffer[7];
extern uint8_t displayBuffer[49];
extern uint8_t displayFresh;
#define VFD_SPI_CS_LOW			GPIO_ResetBits(GPIOC, GPIO_Pin_8)
#define VFD_SPI_CS_HIGH			GPIO_SetBits(GPIOC, GPIO_Pin_8)
void delay5us(uint32_t nus);
void initializeVFD(void);
void dispVFD48(char* string);
uint8_t getKey(void);
extern uint8_t  keyCode;


#define key_OVP			17
#define key_OPP			18
#define key_OCP			19
#define key_LOCK		20
#define key_UP			12
#define key_DOWN		13
#define key_LEFT		14
#define key_RIGHT		15
#define key_OK			16
#define key_SHIFT		21
#define key_ESC			22
#define key_VSET		23
#define key_ISET		24
#define key_RECALL		25
#define key_METER		26
#define key_ONOFF		27
#define key_MENU		28
#define key_0			 1
#define key_1			 2
#define key_2			 3
#define key_3			 4
#define key_4			 5
#define key_5			 6
#define key_6			 7
#define key_7			 8
#define key_8			 9
#define key_9			10 
#define key_DP			11















#endif

 void printText(uint16_t Xpos,uint16_t Ypos,uint8_t *str);


/* 
wq timer c P flag

	flag = 1,ܦcounterbQϥΤ
	count P tmcount  

*/
typedef struct
{
	volatile uint32_t count;	/*  */
	volatile uint8_t flag;		/* ʱ־  */
}SOFT_TIMER;

#define TIMER_COUNT			2		  /* Xtimer */
extern SOFT_TIMER	softTimer[TIMER_COUNT];
#define BUZZER_COUNT		0
#define MAIN_COUNT      1






extern uint32_t   timeCount;
extern uint32_t   usbflags,beepDuration;

#define IS_USB_CONNECTBEEP           usbflags & BIT0
#define SET_USB_CONNECTBEEP          usbflags |= BIT0
#define CLR_USB_CONNECTBEEP          usbflags &= ~(BIT0)

#define IS_USB_DISCONNECTBEEP        usbflags & BIT1
#define SET_USB_DISCONNECTBEEP       usbflags |= BIT1
#define CLR_USB_DISCONNECTBEEP       usbflags &= ~(BIT1)




#endif



