
#include "includes.h"
extern USBH_HOST                    USB_Host;
const uint8_t Model[] = "BK123\0";
const uint8_t SerialNumber[] = "7L123456L10239\0";
const uint8_t Version[] = "1.0001\0";


uint8_t MAC_address;
uint8_t GPIB_address = 15;
uint8_t IP_Mode;
uint8_t IP_Address[] ="192.168.001.100\0";
uint8_t Subnet_Mask[] = "255,255,255,000\0";
uint8_t Geteway[] = "192,168,001,001\0";

uint8_t Current_IP_Address[] = "192.168.001.100\0";
uint8_t Current_Subnet_Mask[] = "255.255.255.000\0";
uint8_t Current_Geteway[] = "192.168.001.001\0";





const uint8_t nCs[] = "Cs ";
const uint8_t nCp[] = "Cp ";
const uint8_t nLs[] = "Ls ";
const uint8_t nLp[] = "Lp ";
const uint8_t nZ[] = "Z  ";
const uint8_t nY[] = "Y  ";
const uint8_t nTH[] = "|  ";
const uint8_t nQ[] = "Q  ";
const uint8_t nD[] = "D  ";
const uint8_t nRs[] = "R  ";
const uint8_t nRp[] = "R  ";
const uint8_t nG[] = "G  ";
const uint8_t nB[] = "B  ";
const uint8_t nX[] = "X  ";
const uint8_t nDCR[] = "DCR";


const uint8_t nFREQ[] = " FREQ  ";
const uint8_t nLEVEL[] = " LEVEL ";
const uint8_t nVAC[] = " VAC   ";
const uint8_t nIAC[] = " IAC   ";





NUMERICAL Cp =
{
   nCp,
   -110.23,
   FARAD
};
NUMERICAL Cs =
{
   nCs,
   223.34,
   FARAD
};
NUMERICAL Ls =
{
   nLs,
   3.45,
   HENRY
};
NUMERICAL Lp =
{
   nLp,
   3.45,
   HENRY
};

NUMERICAL Z =
{
   nZ,
   2.345,
   OHM
};
NUMERICAL Y =
{
   nY,
   9.5986,
   CONDUCTTANCE
};

NUMERICAL TH =
{
   nTH,
   40.5,
   DEGREE
};
NUMERICAL Q =
{
   nQ,
   -20.321,
   EMPTY
};
NUMERICAL D =
{
   nD,
   23.145,
   EMPTY
};
NUMERICAL Rs =
{
   nRs,
   100.203,
   OHM
};
NUMERICAL Rp =
{
   nRp,
   2.345,
   OHM
};
NUMERICAL G =
{
   nG,
   9.876,
   CONDUCTTANCE
};
NUMERICAL B =
{
   nB,
   1000.01,
   CONDUCTTANCE
};
NUMERICAL X =
{
   nX,
   10024.23,
   OHM
};

NUMERICAL DCR =
{
   nDCR,
   10000.234,
   OHM
};



NUMERICAL freq =
{
   nFREQ,
   1000000,
   FREQ
};
NUMERICAL level =
{
   nLEVEL,
   0.02,
   VOLTAGE
};
NUMERICAL vac =
{
   nVAC,
   0.5,
   VOLTAGE
};
NUMERICAL iac =
{
   nIAC,
   0.00001,
   CURRENT
};


NUMERICAL tempBuffer;

float backupValue; //ƥܤƫe 




uint8_t range;
uint8_t speed;


#define FONT2_LINE1       1
#define FONT2_LINE2       17
#define FONT2_LINE3       17+16
#define FONT2_LINE4       17+32
#define FONT2_LINE5       17+48
#define FONT2_LINE6       17+64
#define FONT2_LINE7       17+80
#define FONT2_LINE8       17+96
#define FONT2_LINE9       17+112
#define FONT2_LINE10      17+128
#define FONT2_LINE11      17+144
#define FONT2_LINE12      17+160
#define FONT2_LINE13      17+176

#define FONT2_CHAR1		  1
#define FONT2_CHAR2		  10
#define FONT2_CHAR3       19
#define FONT2_CHAR4       28
#define FONT2_CHAR5       37
#define FONT2_CHAR6		  46
#define FONT2_CHAR7		  55
#define FONT2_CHAR8       64
#define FONT2_CHAR9       73
#define FONT2_CHAR10       82
#define FONT2_CHAR11	   91
#define FONT2_CHAR12	   100
#define FONT2_CHAR13       109
#define FONT2_CHAR14       118
#define FONT2_CHAR15       127
#define FONT2_CHAR16	   136
#define FONT2_CHAR17	   145
#define FONT2_CHAR18       154
#define FONT2_CHAR19       163
#define FONT2_CHAR20       172
#define FONT2_CHAR21	   181
#define FONT2_CHAR22	   190
#define FONT2_CHAR23       199
#define FONT2_CHAR24       208
#define FONT2_CHAR25       217
#define FONT2_CHAR26	   226
#define FONT2_CHAR27	   235
#define FONT2_CHAR28       244
#define FONT2_CHAR29       253
#define FONT2_CHAR30       262
#define FONT2_CHAR31	   271
#define FONT2_CHAR32	   280
#define FONT2_CHAR33       289
#define FONT2_CHAR34       298
#define FONT2_CHAR35       307
#define FONT2_CHAR36 	   316
#define FONT2_CHAR37	   325
#define FONT2_CHAR38       334
#define FONT2_CHAR39       343
#define FONT2_CHAR40       352











uint8_t clzrdcr;  // for MEAS FUNC (C L Z R DCR)
#define  MEAS_C       0
#define  MEAS_L       1
#define  MEAS_Z       2
#define  MEAS_R		  3
#define  MEAS_DCR     4

uint8_t systemInfoState;  // for SYSTEM (SYSTEM INFO SYSTEM CONFIG CAL)

uint8_t tolabs;   // for TOL ABS
#define TOL      0
#define ABS      1

uint8_t bintblhist; // for BIN TBL HIST
#define BIN      0
#define TBL      1
#define HIST     2

uint8_t offonsmart; // for OFF ON SMART
#define OFF      0
#define ON       1
#define SMART    2

uint8_t displayState;	// for DISP(NORM LARGE)
#define NORM        0
#define LARGE       1
uint8_t displayNotation;  
#define DEC         0
#define SCI         1
uint8_t priminaryDigit = 2;

uint8_t secondaryDigit = 2;

qdrg QDRG = CQ;

static const uint8_t measLocation[numberOfDirection * 6] = {
  /*UP  ,DN  ,LT   ,RT */
  0,2,0,3,	// 0
  0,2,1,4,	// 1
  0,2,2,5,	// 2
  3,5,0,3,	// 3
  3,5,1,4,	// 4
  3,5,2,5	// 5
}; 

static const state_id next_state[numberOfStates * numberOfTriggers] = {
//   KEY_B1             KEY_B2             KEY_B3             KEY_B4             KEY_B5             KEY_R1             KEY_R2             KEY_R3             KEY_R4
     MEASFUNCLS,        BINCSTOLBIN,       SWEEPCSLIN,        DISPCSNORM,        SYSTEMINFO,        MEASSPECSTATER1,   MEASFUNCCP,        MEASFUNCCS,        MEASFUNCCS,      // MeasFuncCs   
     MEASFUNCLP,        BINCPTOLBIN,       SWEEPCPLIN,        DISPCPNORM,        SYSTEMINFO,        MEASFUNCCS,        MEASSPECSTATER2,   MEASFUNCCP,        MEASFUNCCP,      // MeasFuncCp   
     MEASFUNCZTH,       BINLSTOLBIN,       SWEEPLSLIN,        DISPLSNORM,        SYSTEMINFO,        MEASSPECSTATER1,   MEASFUNCLP,        MEASFUNCLS,        MEASFUNCLS,      // MeasFuncLs   
     MEASFUNCYTH,       BINLPTOLBIN,       SWEEPLPLIN,        DISPLPNORM,        SYSTEMINFO,        MEASFUNCLS,        MEASSPECSTATER2,   MEASFUNCLP,        MEASFUNCLP,      // MeasFuncLp   
     MEASFUNCRX,        BINZTHTOLBIN,      SWEEPZTHLIN,       DISPZTHNORM,       SYSTEMINFO,        MEASFUNCZTH,       MEASFUNCYTH,       MEASFUNCZTH,       MEASFUNCZTH,     // MeasFuncZth  
     MEASFUNCGB,        BINYTHTOLBIN,      SWEEPYTHLIN,       DISPYTHNORM,       SYSTEMINFO,        MEASFUNCZTH,       MEASFUNCYTH,       MEASFUNCYTH,       MEASFUNCYTH,     // MeasFuncYth  
     MEASFUNCDCR,       BINRXTOLBIN,       SWEEPRXLIN,        DISPRXNORM,        SYSTEMINFO,        MEASFUNCRX,        MEASFUNCGB,        MEASFUNCRX,        MEASFUNCRX,      // MeasFuncRX   
     MEASFUNCDCR,       BINGBTOLBIN,       SWEEPGBLIN,        DISPGBNORM,        SYSTEMINFO,        MEASFUNCRX,        MEASFUNCGB,        MEASFUNCGB,        MEASFUNCGB,      // MeasFuncGB   
     MEASFUNCCS,        BINDCRTOLBIN,      MEASFUNCDCR,       DISPDCRNORM,       SYSTEMINFO,        MEASFUNCDCR,       MEASFUNCDCR,       MEASFUNCDCR,       MEASFUNCDCR,     // MeasFuncDCR  
     MEASFUNCCS,        BINCSABSBIN,       SWEEPCSLIN,        BINCSTOLTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCsTolBin  
     MEASFUNCCS,        BINCSABSTBL,       SWEEPCSLIN,        BINCSTOLHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCsTolTbl  
     MEASFUNCCS,        BINCSABSHIST,      SWEEPCSLIN,        BINCSTOLBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCstolHist 
     MEASFUNCCS,        BINCSTOLBIN,       SWEEPCSLIN,        BINCSABSTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCsAbsBin  
     MEASFUNCCS,        BINCSTOLTBL,       SWEEPCSLIN,        BINCSABSHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCsAbsTbl  
     MEASFUNCCS,        BINCSTOLHIST,      SWEEPCSLIN,        BINCSABSBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCsAbsHist 
     MEASFUNCCP,        BINCPABSBIN,       SWEEPCPLIN,        BINCPTOLTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCpTolBin  
     MEASFUNCCP,        BINCPABSTBL,       SWEEPCPLIN,        BINCPTOLHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCpTolTbl  
     MEASFUNCCP,        BINCPABSHIST,      SWEEPCPLIN,        BINCPTOLBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCpTolHist 
     MEASFUNCCP,        BINCPTOLBIN,       SWEEPCPLIN,        BINCPABSTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCpAbsBin  
     MEASFUNCCP,        BINCPTOLTBL,       SWEEPCPLIN,        BINCPABSHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCpAbsTbl  
     MEASFUNCCP,        BINCPTOLHIST,      SWEEPCPLIN,        BINCPABSBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINCpAbsHist 
     MEASFUNCLS,        BINLSABSBIN,       SWEEPLSLIN,        BINLSTOLTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLsTolBin  
     MEASFUNCLS,        BINLSABSTBL,       SWEEPLSLIN,        BINLSTOLHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLsTolTbl  
     MEASFUNCLS,        BINLSABSHIST,      SWEEPLSLIN,        BINLSTOLBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLsTolHist 
     MEASFUNCLS,        BINLSTOLBIN,       SWEEPLSLIN,        BINLSABSTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLsAbsBin  
     MEASFUNCLS,        BINLSTOLTBL,       SWEEPLSLIN,        BINLSABSHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLsAbsTbl  
     MEASFUNCLS,        BINLSTOLHIST,      SWEEPLSLIN,        BINLSABSBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLsAbsHist 
     MEASFUNCLP,        BINLPABSBIN,       SWEEPLPLIN,        BINLPTOLTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLpTolBin  
     MEASFUNCLP,        BINLPABSTBL,       SWEEPLPLIN,        BINLPTOLHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLpTolTbl  
     MEASFUNCLP,        BINLPABSHIST,      SWEEPLPLIN,        BINLPTOLBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLpTolHist 
     MEASFUNCLP,        BINLPTOLBIN,       SWEEPLPLIN,        BINLPABSTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLpAbsBin  
     MEASFUNCLP,        BINLPTOLTBL,       SWEEPLPLIN,        BINLPABSHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLpAbsTbl  
     MEASFUNCLP,        BINLPTOLHIST,      SWEEPLPLIN,        BINLPABSBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINLpAbsHist 
     MEASFUNCZTH,       BINZTHABSBIN,      SWEEPZTHLIN,       BINZTHTOLTBL,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINZthTolBin 
     MEASFUNCZTH,       BINZTHABSTBL,      SWEEPZTHLIN,       BINZTHTOLHIST,     SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINZthTolTbl 
     MEASFUNCZTH,       BINZTHABSHIST,     SWEEPZTHLIN,       BINZTHTOLBIN,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINZthTolHist
     MEASFUNCZTH,       BINZTHTOLBIN,      SWEEPZTHLIN,       BINZTHABSTBL,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINZthAbsBin 
     MEASFUNCZTH,       BINZTHTOLTBL,      SWEEPZTHLIN,       BINZTHABSHIST,     SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINZthAbsTbl 
     MEASFUNCZTH,       BINZTHTOLHIST,     SWEEPZTHLIN,       BINZTHABSBIN,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINZthAbsHist
     MEASFUNCYTH,       BINYTHABSBIN,      SWEEPYTHLIN,       BINYTHTOLTBL,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINYthTolBin 
     MEASFUNCYTH,       BINYTHABSTBL,      SWEEPYTHLIN,       BINYTHTOLHIST,     SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINYthTolTbl 
     MEASFUNCYTH,       BINYTHABSHIST,     SWEEPYTHLIN,       BINYTHTOLBIN,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINYthTolHist
     MEASFUNCYTH,       BINYTHTOLBIN,      SWEEPYTHLIN,       BINYTHABSTBL,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINYthAbsBin 
     MEASFUNCYTH,       BINYTHTOLTBL,      SWEEPYTHLIN,       BINYTHABSHIST,     SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINYthAbsTbl 
     MEASFUNCYTH,       BINYTHTOLHIST,     SWEEPYTHLIN,       BINYTHABSBIN,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINYthAbsHist
     MEASFUNCRX,        BINRXABSBIN,       SWEEPRXLIN,        BINRXTOLTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINRXTolBin  
     MEASFUNCRX,        BINRXABSTBL,       SWEEPRXLIN,        BINRXTOLHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINRXTolTbl  
     MEASFUNCRX,        BINRXABSHIST,      SWEEPRXLIN,        BINRXTOLBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINRXTolHist 
     MEASFUNCRX,        BINRXTOLBIN,       SWEEPRXLIN,        BINRXABSTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINRXAbsBin  
     MEASFUNCRX,        BINRXTOLTBL,       SWEEPRXLIN,        BINRXABSHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINRXAbsTbl  
     MEASFUNCRX,        BINRXTOLHIST,      SWEEPRXLIN,        BINRXABSBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINRXAbsHist 
     MEASFUNCGB,        BINGBABSBIN,       SWEEPGBLIN,        BINGBTOLTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINGBTolBin  
     MEASFUNCGB,        BINGBABSTBL,       SWEEPGBLIN,        BINGBTOLHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINGBTolTbl  
     MEASFUNCGB,        BINGBABSHIST,      SWEEPGBLIN,        BINGBTOLBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINGBTolHist 
     MEASFUNCGB,        BINGBTOLBIN,       SWEEPGBLIN,        BINGBABSTBL,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINGBAbsBin  
     MEASFUNCGB,        BINGBTOLTBL,       SWEEPGBLIN,        BINGBABSHIST,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINGBAbsTbl  
     MEASFUNCGB,        BINGBTOLHIST,      SWEEPGBLIN,        BINGBABSBIN,       SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINGBAbsHist 
     MEASFUNCDCR,       BINDCRABSBIN,      BINDCRTOLBIN,      BINDCRTOLTBL,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINDCRTolBin 
     MEASFUNCDCR,       BINDCRABSTBL,      BINDCRTOLTBL,      BINDCRTOLHIST,     SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINDCRTolTbl 
     MEASFUNCDCR,       BINDCRABSHIST,     BINDCRTOLHIST,     BINDCRTOLBIN,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINDCRTolHist
     MEASFUNCDCR,       BINDCRTOLBIN,      BINDCRABSBIN,      BINDCRABSTBL,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINDCRAbsBin 
     MEASFUNCDCR,       BINDCRTOLTBL,      BINDCRABSTBL,      BINDCRABSHIST,     SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINDCRAbsTbl 
     MEASFUNCDCR,       BINDCRTOLHIST,     BINDCRABSHIST,     BINDCRABSBIN,      SYSTEMINFO,        SPECSTATER1,       SPECSTATER2,       SPECSTATER3,       SPECSTATER4,     // BINDCRAbsHist
     MEASFUNCCS,        BINCSTOLBIN,       SWEEPCSLIN,        SWEEPCSLOG,        SYSTEMINFO,        SPECSTATER1,       SWEEPCSLIN,        SPECSTATER3,       SWEEPCSLIN,      // SWEEPCsLin   
     MEASFUNCCS,        BINCSTOLBIN,       SWEEPCSLOG,        SWEEPCSLIN,        SYSTEMINFO,        SPECSTATER1,       SWEEPCSLOG,        SPECSTATER3,       SWEEPCSLOG,      // SWEEPCsLog   
     MEASFUNCCP,        BINCPTOLBIN,       SWEEPCPLIN,        SWEEPCPLOG,        SYSTEMINFO,        SPECSTATER1,       SWEEPCPLIN,        SPECSTATER3,       SWEEPCPLIN,      // SWEEPCpLin   
     MEASFUNCCP,        BINCPTOLBIN,       SWEEPCPLOG,        SWEEPCPLIN,        SYSTEMINFO,        SPECSTATER1,       SWEEPCPLOG,        SPECSTATER3,       SWEEPCPLOG,      // SWEEPCpLog   
     MEASFUNCLS,        BINLSTOLBIN,       SWEEPLSLIN,        SWEEPLSLOG,        SYSTEMINFO,        SPECSTATER1,       SWEEPLSLIN,        SPECSTATER3,       SWEEPLSLIN,      // SWEEPLsLin   
     MEASFUNCLS,        BINLSTOLBIN,       SWEEPLSLOG,        SWEEPLSLIN,        SYSTEMINFO,        SPECSTATER1,       SWEEPLSLOG,        SPECSTATER3,       SWEEPLSLOG,      // SWEEPLsLog   
     MEASFUNCLP,        BINLPTOLBIN,       SWEEPLPLIN,        SWEEPLPLOG,        SYSTEMINFO,        SPECSTATER1,       SWEEPLPLIN,        SPECSTATER3,       SWEEPLPLIN,      // SWEEPLpLin   
     MEASFUNCLP,        BINLPTOLBIN,       SWEEPLPLOG,        SWEEPLPLIN,        SYSTEMINFO,        SPECSTATER1,       SWEEPLPLOG,        SPECSTATER3,       SWEEPLPLOG,      // SWEEPLpLog   
     MEASFUNCZTH,       BINZTHTOLBIN,      SWEEPZTHLIN,       SWEEPZTHLOG,       SYSTEMINFO,        SPECSTATER1,       SWEEPZTHLIN,       SPECSTATER3,       SWEEPZTHLIN,     // SWEEPZthLin  
     MEASFUNCZTH,       BINZTHTOLBIN,      SWEEPZTHLOG,       SWEEPZTHLIN,       SYSTEMINFO,        SPECSTATER1,       SWEEPZTHLOG,       SPECSTATER3,       SWEEPZTHLOG,     // SWEEPZthLog  
     MEASFUNCYTH,       BINYTHTOLBIN,      SWEEPYTHLIN,       SWEEPYTHLOG,       SYSTEMINFO,        SPECSTATER1,       SWEEPYTHLIN,       SPECSTATER3,       SWEEPYTHLIN,     // SWEEPYthLin  
     MEASFUNCYTH,       BINYTHTOLBIN,      SWEEPYTHLOG,       SWEEPYTHLIN,       SYSTEMINFO,        SPECSTATER1,       SWEEPYTHLOG,       SPECSTATER3,       SWEEPYTHLOG,     // SWEEPYthLog  
     MEASFUNCRX,        BINRXTOLBIN,       SWEEPRXLIN,        SWEEPRXLOG,        SYSTEMINFO,        SPECSTATER1,       SWEEPRXLIN,        SPECSTATER3,       SWEEPRXLIN,      // SWEEPRXLin   
     MEASFUNCRX,        BINRXTOLBIN,       SWEEPRXLOG,        SWEEPRXLIN,        SYSTEMINFO,        SPECSTATER1,       SWEEPRXLOG,        SPECSTATER3,       SWEEPRXLOG,      // SWEEPRXLog   
     MEASFUNCGB,        BINGBTOLBIN,       SWEEPGBLIN,        SWEEPGBLOG,        SYSTEMINFO,        SPECSTATER1,       SWEEPGBLIN,        SPECSTATER3,       SWEEPGBLIN,      // SWEEPGBLin   
     MEASFUNCGB,        BINGBTOLBIN,       SWEEPGBLOG,        SWEEPGBLIN,        SYSTEMINFO,        SPECSTATER1,       SWEEPGBLOG,        SPECSTATER3,       SWEEPGBLOG,      // SWEEPGBLog   
     MEASFUNCCS,        BINCSTOLBIN,       SWEEPCSLIN,        DISPCSLARGE,       SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPCSNORM,      // DISPCsNorm   
     MEASFUNCCS,        BINCSTOLBIN,       SWEEPCSLIN,        DISPCSNORM,        SYSTEMINFO,        DISPCSLARGE,       DISPCSLARGE,       DISPCSLARGE,       DISPCSLARGE,     // DISPCsLarge  
     MEASFUNCCP,        BINCPTOLBIN,       SWEEPCPLIN,        DISPCPLARGE,       SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPCPNORM,      // DISPCpNorm   
     MEASFUNCCP,        BINCPTOLBIN,       SWEEPCPLIN,        DISPCPNORM,        SYSTEMINFO,        DISPCPLARGE,       DISPCPLARGE,       DISPCPLARGE,       DISPCPLARGE,     // DISPCpLarge  
     MEASFUNCLS,        BINLSTOLBIN,       SWEEPLSLIN,        DISPLSLARGE,       SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPLSNORM,      // DISPLsNorm   
     MEASFUNCLS,        BINLSTOLBIN,       SWEEPLSLIN,        DISPLSNORM,        SYSTEMINFO,        DISPLSLARGE,       DISPLSLARGE,       DISPLSLARGE,       DISPLSLARGE,     // DISPLsLarge  
     MEASFUNCLP,        BINLPTOLBIN,       SWEEPLPLIN,        DISPLPLARGE,       SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPLPNORM,      // DISPLpNorm   
     MEASFUNCLP,        BINLPTOLBIN,       SWEEPLPLIN,        DISPLPNORM,        SYSTEMINFO,        DISPLPLARGE,       DISPLPLARGE,       DISPLPLARGE,       DISPLPLARGE,     // DISPLpLarge  
     MEASFUNCZTH,       BINZTHTOLBIN,      SWEEPZTHLIN,       DISPZTHLARGE,      SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPZTHNORM,     // DISPZthNorm  
     MEASFUNCZTH,       BINZTHTOLBIN,      SWEEPZTHLIN,       DISPZTHNORM,       SYSTEMINFO,        DISPZTHLARGE,      DISPZTHLARGE,      DISPZTHLARGE,      DISPZTHLARGE,    // DISPZthLarge 
     MEASFUNCYTH,       BINYTHTOLBIN,      SWEEPYTHLIN,       DISPYTHLARGE,      SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPYTHNORM,     // DISPYthNorm  
     MEASFUNCYTH,       BINYTHTOLBIN,      SWEEPYTHLIN,       DISPYTHNORM,       SYSTEMINFO,        DISPYTHLARGE,      DISPYTHLARGE,      DISPYTHLARGE,      DISPYTHLARGE,    // DISPYthLarge 
     MEASFUNCRX,        BINRXTOLBIN,       SWEEPRXLIN,        DISPRXLARGE,       SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPRXNORM,      // DISPRXNorm   
     MEASFUNCRX,        BINRXTOLBIN,       SWEEPRXLIN,        DISPRXNORM,        SYSTEMINFO,        DISPRXLARGE,       DISPRXLARGE,       DISPRXLARGE,       DISPRXLARGE,     // DISPRXLarge  
     MEASFUNCGB,        BINGBTOLBIN,       SWEEPGBLIN,        DISPGBLARGE,       SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPGBNORM,      // DISPGBNorm   
     MEASFUNCGB,        BINGBTOLBIN,       SWEEPGBLIN,        DISPGBNORM,        SYSTEMINFO,        DISPGBLARGE,       DISPGBLARGE,       DISPGBLARGE,       DISPGBLARGE,     // DISPGBLarge  
     MEASFUNCDCR,       BINDCRTOLBIN,      DISPDCRNORM,       DISPDCRLARGE,      SYSTEMINFO,        DISPSPECSTATER1,   DISPSPECSTATER2,   DISPSPECSTATER3,   DISPDCRNORM,     // DISPDCRNorm  
     MEASFUNCDCR,       BINDCRTOLBIN,      DISPDCRLARGE,      DISPDCRNORM,       SYSTEMINFO,        DISPDCRLARGE,      DISPDCRLARGE,      DISPDCRLARGE,      DISPDCRLARGE,    // DISPDCRLarge 
     SYSSPECSTATEB1,    SYSSPECSTATEB2,    SYSSPECSTATEB3,    SYSTEMINFO,        SPECRETURN,        SYSTEMINFO,        SYSTEMINFO,        SYSTEMINFO,        SYSTEMINFO,      // SYSTEMInfo  
	 MEASEDIT, 			MEASEDIT,		   MEASEDIT,		  MEASEDIT,			 SPECRETURN,		MEASEDIT,		   MEASEDIT,		  MEASEDIT,			 MEASEDIT,		  // MeasEdit
     SYSSPECSTATEB1,    SYSSPECSTATEB1,    SYSSPECSTATEB1,    SYSSPECSTATEB1,    SYSSPECSTATEB1,    SYSSPECSTATEB1,    SYSSPECSTATEB1,    SYSSPECSTATEB1,    SYSSPECSTATEB1,  // SysSpecStateB1 
     SYSSPECSTATEB2,    SYSSPECSTATEB2,    SYSSPECSTATEB2,    SYSSPECSTATEB2,    SYSSPECSTATEB2,    SYSSPECSTATEB2,    SYSSPECSTATEB2,    SYSSPECSTATEB2,    SYSSPECSTATEB2,  // SysSpecStateB2
	 SYSSPECSTATEB3,    SYSSPECSTATEB3,    SYSSPECSTATEB3,    SYSSPECSTATEB3,    SYSSPECSTATEB3,    SYSSPECSTATEB3,    SYSSPECSTATEB3,    SYSSPECSTATEB3,    SYSSPECSTATEB3,  // SysSpecStateB3 
	 MEASSPECSTATER1,   MEASSPECSTATER1,   MEASSPECSTATER1,   MEASSPECSTATER1,   MEASSPECSTATER1,   MEASSPECSTATER1,   MEASSPECSTATER1,   MEASSPECSTATER1,   MEASSPECSTATER1, // MeasSpecStateR1
	 MEASSPECSTATER2,	MEASSPECSTATER2,   MEASSPECSTATER2,   MEASSPECSTATER2,   MEASSPECSTATER2,   MEASSPECSTATER2,   MEASSPECSTATER2,   MEASSPECSTATER2,   MEASSPECSTATER2, // MeasSpecStateR2
	 DISPSPECSTATER1,	DISPSPECSTATER1,   DISPSPECSTATER1,   DISPSPECSTATER1,   DISPSPECSTATER1,   DISPSPECSTATER1,   DISPSPECSTATER1,   DISPSPECSTATER1,	 DISPSPECSTATER1, // DispSpecStateR1
	 DISPSPECSTATER2,	DISPSPECSTATER2,   DISPSPECSTATER2,   DISPSPECSTATER2,   DISPSPECSTATER2,   DISPSPECSTATER2,   DISPSPECSTATER2,   DISPSPECSTATER2,	 DISPSPECSTATER2, // DispSpecStateR2
	 DISPSPECSTATER3,	DISPSPECSTATER3,   DISPSPECSTATER3,   DISPSPECSTATER3,   DISPSPECSTATER3,   DISPSPECSTATER3,   DISPSPECSTATER3,   DISPSPECSTATER3,	 DISPSPECSTATER3, // DispSpecStateR3
     SPECSTATER1,       SPECSTATER1,       SPECSTATER1,       SPECSTATER1,       SPECSTATER1,       SPECSTATER1,       SPECSTATER1,       SPECSTATER1,       SPECSTATER1,     // SPECStateR1  
     SPECSTATER2,       SPECSTATER2,       SPECSTATER2,       SPECSTATER2,       SPECSTATER2,       SPECSTATER2,       SPECSTATER2,       SPECSTATER2,       SPECSTATER2,     // SPECStateR2  
     SPECSTATER3,       SPECSTATER3,       SPECSTATER3,       SPECSTATER3,       SPECSTATER3,       SPECSTATER3,       SPECSTATER3,       SPECSTATER3,       SPECSTATER3,     // SPECStateR3  
     SPECSTATER4,       SPECSTATER4,       SPECSTATER4,       SPECSTATER4,       SPECSTATER4,       SPECSTATER4,       SPECSTATER4,       SPECSTATER4,       SPECSTATER4,     // SPECStateR4  
     SPECRETURN,        SPECRETURN,        SPECRETURN,        SPECRETURN,        SPECRETURN,        SPECRETURN,        SPECRETURN,        SPECRETURN,        SPECRETURN};     // SPECReturn   

state_id swapState, lastLastState = MEASFUNCCS, lastState = MEASFUNCCS;
state_id actualState;

uint32_t stateChangeFlag = BIT3;

#define IS_CHANGE    	            (stateChangeFlag & (BIT0))
#define SET_CHANGE		            (stateChangeFlag |= (BIT0))
#define CLR_CHANGE                  (stateChangeFlag &= ~(BIT0))

//#define IS_ EDIT                	(stateChangeFlag & BIT1)
//#define SET_EDIT                    (stateChangeFlag |= BIT1)
//#define CLR_EDIT                    (stateChangeFlag &= ~(BIT1))

//#define IS_CPQDRG    	(stateChangeFlag & BIT2)
//#define SET_CPQDRG		(stateChangeFlag |= BIT2)
//#define CLR_CPQDRG      (stateChangeFlag &= ~(BIT2))

#define IS_S           	            (stateChangeFlag & BIT3)
#define SET_S	    	            (stateChangeFlag |= BIT3)   // Cs ,Ls (Series)
#define CLR_S                       (stateChangeFlag &= ~(BIT3)) //Cp ,Lp (parallel)


uint8_t dispbuf[16];

cursorDef cursor;
static uint8_t location = 0x00;


void optimizeValue(uint8_t *str,NUMERICAL *Value)
{
	uint8_t aunit[1] = {'0'};
	int8_t unit_m ;
	float temp = Value->element;
    for (unit_m = 0 ;temp >= 1000 ;temp /= 1000) 
	{
	    unit_m++;    // 1:K  2:M  3:G  4: T
	}
	for ( ; temp < 1 ;temp *= 1000)
	{
	    unit_m--;   // -1: m  -2: u  -3:n  -4: p
	}
    switch(unit_m)
	{
	    case -5:
		    aunit[0] = 'f';
			break;
	    case -4:
		    aunit[0] = 'p';
			break;
		case -3:
		    aunit[0] = 'n';
			break;
	    case -2:
		    aunit[0] = '\\'; // u
			break;
		case -1:
		    aunit[0] = 'm';
			break;
	    case 0:
		    aunit[0] = ' ';
			break;
		case 1:
		    aunit[0] = 'K';
			break;
	    case 2:
		    aunit[0] = 'M';
			break;
		case 3:
		    aunit[0] = 'G';
			break;
		case 4:
		    aunit[0] = 'T';
			break;
		case 5:
		    aunit[0] = 'P';
			break;

	}				
	if(temp >	99.9999)
	    sprintf((void *)str,"%  5.1f",temp);
 	else if (temp > 9.9999)
	    sprintf((void *)str,"%  5.2f",temp);
	else 
	    sprintf((void *)str,"%  5.3f",temp);	
	

    strcat((void *)str,(void *)aunit);
		
		switch(Value->unit)
		{
		    case EMPTY:
                strcat((void *)str,"  \0");
				break;
		    case FARAD:
                strcat((void *)str,"F \0"); // F
				break;
			case OHM:
                strcat((void *)str,"_ \0");  // ohm
				break;
			case HENRY:
                strcat((void *)str,"H \0");
				break;
			case DEGREE:
                strcat((void *)str," {\0");  //
			    break;
			case CONDUCTTANCE:
                strcat((void *)str,"S \0");
				break;
			case VOLTAGE:
			    strcat((void *)str,"V \0");
			    break;
			case FREQ:
			    strcat((void *)str,"Hz\0");
			    break;
			case CURRENT:
			    strcat((void *)str,"A \0");
			    break;
		}

}


void editValue(uint16_t Row,uint16_t Col,uint8_t Length,NUMERICAL *Value)
{
    
	cursor.used = SET_EDIT;cursor.x = cursor.xStart = Row ;cursor.y = Col; cursor.length = Length;
	tempBuffer = *(NUMERICAL *)Value;
	
	
	    optimizeValue((void *)dispbuf, Value);
	    printLcdString((void *)dispbuf,cursor.x,cursor.y,&font2,B0.backcolor,RED,NONE_TRANSPARENT);
		for(cursor.index = 0; dispbuf[cursor.index] == ' ';cursor.index++);	// XЦm
	

}

void editParameterRange(uint16_t Row,uint16_t Col)
{
    cursor.used = SET_EDIT;cursor.x = Row ;cursor.y = Col;
	if (range == 0)
	    strcpy((void *)dispbuf,"AUTO\0");
	else if(range == 1)
		strcpy((void *)dispbuf," R1 \0");
	else if(range == 2)
		strcpy((void *)dispbuf," R2 \0");
	else if(range == 3)
	    strcpy((void *)dispbuf," R3 \0");
	else if(range == 4)
		strcpy((void *)dispbuf," R4 \0");
	else if(range == 5)
		strcpy((void *)dispbuf," R5 \0");


}
void editParameterSpeed(uint16_t Row,uint16_t Col)
{
    cursor.used = SET_EDIT;cursor.x = Row ;cursor.y = Col;
	if (speed == 0)
	    strcpy((void *)dispbuf,"SLOW\0");
	else if(speed == 1)
		strcpy((void *)dispbuf," MED\0");
	else if(range == 2)
		strcpy((void *)dispbuf,"HIGH\0");

}

void highLightNORMLARGE(void)
{
	if (displayState == NORM)
        highLight("NORM",&font1,295, 256,BLACK,WHITE,&B4,HIGH_LIGHT);
	else
	    highLight("LARGE",&font1,295+7*7, 256,BLACK,WHITE,&B4,HIGH_LIGHT);
}

void initializeLcr(void)
{
    actualState = MEASFUNCCS;
	pasteB0ToB9();
    showMEASFUNCB1ToB5();
	highLightNORMLARGE();
	highLightCLZRDCR();
	showMEASFUNCR1ToR4();
}

void processEvent(trigger_id event)
{
    CLR_CHANGE;
    if (keyParameter.keyFunction == KEY_FUNCTION)
	{
		
	        if (event < numberOfTriggers)
	        {
	            state_id nextState;
	            nextState = next_state[actualState * numberOfTriggers + event];
                if (nextState == actualState)
                {  //state not change
                //    CLR_CHANGE;
                }
                else
                {  //state changed
		    
	                lastLastState = lastState;
                    lastState = actualState;
                    actualState = nextState;
                    SET_CHANGE; 
                }
		    }
	     //   else
	       //     CLR_CHANGE;
		
	}
	else if(keyParameter.keyFunction == KEY_DIRECTION) 
	{
	  	uint8_t locationtemp;
	    switch(actualState)
		{
		    case MEASFUNCCS:
			case MEASFUNCCP:
		    case MEASFUNCLS:
			case MEASFUNCLP:
		    case MEASFUNCZTH:
			case MEASFUNCYTH:
		    case MEASFUNCRX:
			case MEASFUNCGB:
			case MEASFUNCDCR:
			    if (IS_EDIT != 1)
				{
	                DRAW_KEY_B1;
	                DRAW_KEY_B2;
	                DRAW_KEY_B3;
	                DRAW_KEY_B4;
	                DRAW_KEY_B5;
	                DRAW_KEY_R4;
	                DRAW_KEY_R3;
	                DRAW_KEY_R2;
	                DRAW_KEY_R1;
					printLcdString("   INC   ",392,20,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("   DEC   ",392,20+56,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("    >    ",392,20+112,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("    <    ",392,20+168,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("   ESC   ",388,242,&font3,B5.backcolor,WHITE,NONE_TRANSPARENT);
					locationtemp = 0;
									    
				}
				else
				    locationtemp = measLocation[location * numberOfDirection + event];
				if (location != locationtemp)
				{
				    location = locationtemp;
		            
					printLcdString("FREQ",FONT2_CHAR2,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	                optimizeValue((void *)displayBuffer,&freq );
		            printLcdString(displayBuffer,FONT2_CHAR10,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT);

		            printLcdString("LEVEL",FONT2_CHAR25,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	                optimizeValue((void *)displayBuffer,&level );
		            printLcdString(displayBuffer,FONT2_CHAR33,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT);

	                sprintf((char*)displayBuffer," RANGE    AUTO          SPEED    SLOW    ");
	                printLcdString(displayBuffer,FONT2_CHAR1,FONT2_LINE11,&font2,blockColor,WHITE,NONE_TRANSPARENT);

		            printLcdString("VAC",FONT2_CHAR2,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	                optimizeValue((void *)displayBuffer,&vac );
		            printLcdString(displayBuffer,FONT2_CHAR10,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);

		            printLcdString("IAC",FONT2_CHAR25,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	                optimizeValue((void *)displayBuffer,&iac );
		            printLcdString(displayBuffer,FONT2_CHAR33,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);
                }
				break;
		}
		switch(location)
		{
		    case 0:
			    editValue(FONT2_CHAR10,FONT2_LINE10,6,&freq);
			    break;
			case 1:
			    editParameterRange(FONT2_CHAR11,FONT2_LINE11);
			    break;
			case 2:
			    editValue(FONT2_CHAR10,FONT2_LINE12,6,&vac);
			    break;
			case 3:
			    editValue(FONT2_CHAR33,FONT2_LINE10,6,&level);
			    break;
			case 4:
			    editParameterSpeed(FONT2_CHAR34,FONT2_LINE11);
			    break;
			case 5:
			    editValue(FONT2_CHAR33,FONT2_LINE12,6,&iac);
			    break;
		}
	}
	else if(keyParameter.keyFunction == KEY_NUMERICAL_FUN)
	{
	    uint8_t i;
	    switch(event)
		{
		    case KEY_ESC: // ESC
			    CLR_EDIT;
				CLR_NUMBER;
				CLR_DP;
	            pasteB0ToB9();
                showMEASFUNCB1ToB5();
	            highLightNORMLARGE();
	            highLightCLZRDCR();
	            showMEASFUNCR1ToR4();
			    break;
			case KEY_SL: // <
			    if (location != 1 && location != 4)
				{
			        if (cursor.index > 1)
				    {
				        highLight((void *)cursor.buf,&font2,cursor.x, cursor.y,RED,RED,&B0,NONE_HIGH_LIGHT);
				        cursor.index--;
					    if (dispbuf[cursor.index] == '.')
					        cursor.index--;
				    }
				}
			    break;
			case KEY_SR: // >
			    if (location != 1 && location != 4)
				{
			        if (cursor.index < cursor.length)
				    {
				        highLight((void *)cursor.buf,&font2,cursor.x, cursor.y,RED,RED,&B0,NONE_HIGH_LIGHT);
				        cursor.index++;
					    if (dispbuf[cursor.index] == '.')
					        cursor.index++;
				    }
				}
			    break;
			case KEY_DEC:  // DEC
 			        if (cursor.index == cursor.length)
					{
						if(dispbuf[cursor.length] == ' ')
						    dispbuf[cursor.length] = 'K';
						else if(dispbuf[cursor.length] == 'K')
							dispbuf[cursor.length] = 'M';
						else if(dispbuf[cursor.length] == 'M')
							dispbuf[cursor.length] = 'G';
						else if(dispbuf[cursor.length] == 'G')
							dispbuf[cursor.length] = 'T';
					}
					else
					{
					    backupValue = atof((void *)dispbuf);  // ƥ O0  ܦ 0
                        for(dispbuf[cursor.index]--,i = 0;dispbuf[cursor.index-i] == ('0'- 1)  ;i++)
					    {
					        dispbuf[cursor.index-i] = '9';
					        if (dispbuf[cursor.index-i-1] == '.')
						        i++;
						    dispbuf[cursor.index-i-1]--;
				        }
					}
			    break;
			case KEY_INC:  // INC
			        if (cursor.index == cursor.length)
					{
						 tempBuffer.element *= 1000;
					}
					else
					{
                        for(dispbuf[cursor.index]++,i = 0;dispbuf[cursor.index-i] == ('9'+1)  ;i++)
					    {
					        dispbuf[cursor.index-i] = '0';
					        if (dispbuf[cursor.index-i-1] == '.')
						        i++;
						    if (dispbuf[cursor.index-i-1] == ' ')
						   	    dispbuf[cursor.index-i-1] = '0';
						    dispbuf[cursor.index-i-1]++;
					    }
					} 
			    break;
		}
	}
	else if(keyParameter.keyFunction == KEY_NUMERICAL)  // 0 ~ 9 Ʀr
	{

        if (IS_NUMBER)
		{
		    if (event == KEY_INC || event == KEY_DEC || event == KEY_SR || event == KEY_SL )
			{
			    switch(location)
				{
				    case 0:
					    switch(event)
						{
						    case KEY_INC:  //Hz
							    SET_FINISH_EDIT;
								freq.element = atof((void *)dispbuf);
							    break;
							case KEY_DEC:  //KHz
							    SET_FINISH_EDIT;
								freq.element = atof((void *)dispbuf);
								freq.element *= 1000;
							    break;
							case KEY_SR:  //MHz
							    SET_FINISH_EDIT;
								freq.element = atof((void *)dispbuf);
								freq.element *= 1000000;
							    break;
						}
						editValue(FONT2_CHAR10,FONT2_LINE10,6,&freq);
					    break;
					case 2:
					    switch(event)
						{
						    case KEY_INC:  // mV
							    SET_FINISH_EDIT;
								vac.element = atof((void *)dispbuf);
								vac.element *= 0.001;
							    break;
							case KEY_DEC:  // V
								vac.element = atof((void *)dispbuf);
								SET_FINISH_EDIT;
							    break;
						}
						editValue(FONT2_CHAR10,FONT2_LINE12,6,&vac);
					    break;
					case 3:
					    switch(event)
						{
						    case KEY_INC:  // mV
							    SET_FINISH_EDIT;
								level.element = atof((void *)dispbuf);
								level.element *= 0.001;
							    break;
							case KEY_DEC:  // V
								level.element = atof((void *)dispbuf);
								SET_FINISH_EDIT;
							    break;
						}
						editValue(FONT2_CHAR33,FONT2_LINE10,6,&level);
					    break;
					case 5:
					    switch(event)
						{
						    case KEY_INC:  // uA
							    SET_FINISH_EDIT;
								iac.element = atof((void *)dispbuf);
								iac.element *= 0.000001;
							    break;
							case KEY_DEC:  // mA
							    SET_FINISH_EDIT;
								iac.element = atof((void *)dispbuf);
								iac.element *= 0.001;
							    break;
						}
						editValue(FONT2_CHAR33,FONT2_LINE12,6,&iac);
					    break;
				}
				if (IS_FINISH_EDIT)
				{
				    CLR_FINISH_EDIT;
					CLR_NUMBER;
					CLR_DP;
				}
			}
			else
			{
		        if (cursor.index < cursor.length)
			    {
		            
				    if (event == KEY_DP)
				    {
				        if (IS_DP == 0)
				        {
						    if (cursor.index < (cursor.length - 1))
							{
							    cursor.index++;
				                SET_DP;
						        dispbuf[cursor.index] = '.';
							}
				        }
				    }
				    else if(event == KEY_SIGN)
				    {
				    }
				
				    else
				    {
					    cursor.index++;
				        dispbuf[cursor.index] = event+0x30; // Ʀrܦm
				        printLcdString((void *)dispbuf,cursor.xStart,cursor.y,&font2,B0.backcolor,RED,NONE_TRANSPARENT);
			        }
				}
			}
		}
		else
		{
		    if (IS_EDIT)
			{
		        uint8_t i;
		        SET_NUMBER;
	            DRAW_KEY_R4;
	            DRAW_KEY_R3;
	            DRAW_KEY_R2;
	            DRAW_KEY_R1;
		        switch(location)
		        {
		        case 0:
			        editValue(FONT2_CHAR10,FONT2_LINE10,6,&freq);
					for (i = 0 ; i < (cursor.length+3) ;i++)  // M buffer
	                    dispbuf[i] = ' ';
					dispbuf[cursor.index] = event+0x30; // Ʀrܦm
	                printLcdString((void *)dispbuf,cursor.x,cursor.y,&font2,B0.backcolor,RED,NONE_TRANSPARENT);	// تܪť
	                for (i = cursor.index + 1 ; i < (cursor.length+3) ;i++)  // s
	                    dispbuf[i] = 0;
			        printLcdString("    Hz   ",392,20,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("   KHz   ",392,20+56,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("   MHz   ",392,20+112,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
			        break;
			    case 2:
			        editValue(FONT2_CHAR10,FONT2_LINE12,6,&vac);
					for (i = 0 ; i < (cursor.length+3) ;i++)  // M buffer
	                    dispbuf[i] = ' ';
	                dispbuf[cursor.index] = event+0x30; // Ʀrܦm
	                printLcdString((void *)dispbuf,cursor.x,cursor.y,&font2,B0.backcolor,RED,NONE_TRANSPARENT);	// تܪť
	                for (i = cursor.index + 1 ; i < (cursor.length+3) ;i++)  // s
	                    dispbuf[i] = 0;
			        printLcdString("   mV    ",392,20,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("    V    ",392,20+56,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					
			        break;
			    case 3:
			        editValue(FONT2_CHAR33,FONT2_LINE10,6,&level);
					for (i = 0 ; i < (cursor.length+3) ;i++)  // M buffer
	                    dispbuf[i] = ' ';
	                dispbuf[cursor.index] = event+0x30; // Ʀrܦm
	                printLcdString((void *)dispbuf,cursor.x,cursor.y,&font2,B0.backcolor,RED,NONE_TRANSPARENT);	// تܪť
	                for (i = cursor.index + 1 ; i < (cursor.length+3) ;i++)  // s
	                    dispbuf[i] = 0;
			        printLcdString("   mV    ",392,20,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("    V    ",392,20+56,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					
			        break;
			    case 5:
			        editValue(FONT2_CHAR33,FONT2_LINE12,6,&iac);
					for (i = 0 ; i < (cursor.length+3) ;i++)  // M buffer
	                    dispbuf[i] = ' ';
	                dispbuf[cursor.index] = event+0x30; // Ʀrܦm
	                printLcdString((void *)dispbuf,cursor.x,cursor.y,&font2,B0.backcolor,RED,NONE_TRANSPARENT);	// تܪť
	                for (i = cursor.index + 1 ; i < (cursor.length+3) ;i++)  // s
	                    dispbuf[i] = 0;
			        printLcdString("   \\A   ",392,20,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					printLcdString("   mA   ",392,20+56,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
					
			        break;
			    }
			}
		}	    
	} 
}

void initializeLcrState(void)
{
    if (!IS_CHANGE) 
	{

	}
	else
	{
    switch (actualState)
    {
        case MEASFUNCCS:
		    SET_S;
			if (QDRG == CG)
			   	QDRG = CQ;
//			if (lastState == DISPCSLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
            showMEASFUNCR1ToR4();
		    clzrdcr = MEAS_C;
			highLightCLZRDCR();
            break;
        case MEASFUNCCP:
		    CLR_S;
//			if (lastState == DISPCPLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//              drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
            showMEASFUNCR1ToR4();
		    clzrdcr = MEAS_C;
			highLightCLZRDCR();
            break;
        case MEASFUNCLS:
		    SET_S;
			if (QDRG == CG)
			   	QDRG = CQ;
//			if (lastState == DISPLSLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
		    showMEASFUNCR1ToR4();
		    clzrdcr = MEAS_L;
			highLightCLZRDCR();
            break;
        case MEASFUNCLP:
		    CLR_S;
//			if (lastState == DISPLPLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
		    showMEASFUNCR1ToR4();
		    clzrdcr = MEAS_L;
			highLightCLZRDCR();
            break;
        case MEASFUNCZTH:
		    SET_S;
//			if (lastState == DISPZTHLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
            showMEASFUNCR1ToR4();
  		    clzrdcr = MEAS_Z;
			highLightCLZRDCR();
            break;
        case MEASFUNCYTH:
		    CLR_S;
//			if (lastState == DISPYTHLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
            showMEASFUNCR1ToR4();
			clzrdcr = MEAS_Z;
			highLightCLZRDCR();
            break;
        case MEASFUNCRX:
		    SET_S;
//			if (lastState == DISPRXLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
		    showMEASFUNCR1ToR4();
		    clzrdcr = MEAS_R;
			highLightCLZRDCR();
            break;
        case MEASFUNCGB:
		    CLR_S;
//			if (lastState == DISPGBLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
		    showMEASFUNCR1ToR4();
		    clzrdcr = MEAS_R;
			highLightCLZRDCR();
            break;
        case MEASFUNCDCR:
//			if (lastState == DISPDCRLARGE)
//			{
//			    set_s_TextColor(GRAY2); 
//                drawLcdRect(0,0, 227, 480 ,FILL); //  e
//			}
		    showMEASFUNCR1ToR4();
		    clzrdcr = MEAS_DCR;
			highLightCLZRDCR();
            break;
        case BINCSTOLBIN:
			showBIN();
            break;
        case BINCSTOLTBL:
            break;
        case BINCSTOLHIST:
            break;
        case BINCSABSBIN:
            break;
        case BINCSABSTBL:
            break;
        case BINCSABSHIST:
            break;
        case BINCPTOLBIN:
		    showBIN();
            break;
        case BINCPTOLTBL:
            break;
        case BINCPTOLHIST:
            break;
        case BINCPABSBIN:
            break;
        case BINCPABSTBL:
            break;
        case BINCPABSHIST:
            break;
        case BINLSTOLBIN:
			showBIN();
            break;
        case BINLSTOLTBL:
            break;
        case BINLSTOLHIST:
            break;
        case BINLSABSBIN:
            break;
        case BINLSABSTBL:
            break;
        case BINLSABSHIST:
            break;
        case BINLPTOLBIN:
		    showBIN();
            break;
        case BINLPTOLTBL:
            break;
        case BINLPTOLHIST:
            break;
        case BINLPABSBIN:
            break;
        case BINLPABSTBL:
            break;
        case BINLPABSHIST:
            break;
        case BINZTHTOLBIN:
		    showBIN();
            break;
        case BINZTHTOLTBL:
            break;
        case BINZTHTOLHIST:
            break;
        case BINZTHABSBIN:
            break;
        case BINZTHABSTBL:
            break;
        case BINZTHABSHIST:
            break;
        case BINYTHTOLBIN:
		    showBIN();
            break;
        case BINYTHTOLTBL:
            break;
        case BINYTHTOLHIST:
            break;
        case BINYTHABSBIN:
            break;
        case BINYTHABSTBL:
            break;
        case BINYTHABSHIST:
            break;
        case BINRXTOLBIN:
		    showBIN();
            break;
        case BINRXTOLTBL:
            break;
        case BINRXTOLHIST:
            break;
        case BINRXABSBIN:
            break;
        case BINRXABSTBL:
            break;
        case BINRXABSHIST:
            break;
        case BINGBTOLBIN:
		    showBIN();
            break;
        case BINGBTOLTBL:
            break;
        case BINGBTOLHIST:
            break;
        case BINGBABSBIN:
            break;
        case BINGBABSTBL:
            break;
        case BINGBABSHIST:
            break;
        case BINDCRTOLBIN:
		    showBIN();
            break;
        case BINDCRTOLTBL:
            break;
        case BINDCRTOLHIST:
            break;
        case BINDCRABSBIN:
            break;
        case BINDCRABSTBL:
            break;
        case BINDCRABSHIST:
            break;
        case SWEEPCSLIN:
            break;
        case SWEEPCSLOG:
            break;
        case SWEEPCPLIN:
            break;
        case SWEEPCPLOG:
            break;
        case SWEEPLSLIN:
            break;
        case SWEEPLSLOG:
            break;
        case SWEEPLPLIN:
            break;
        case SWEEPLPLOG:
            break;
        case SWEEPZTHLIN:
            break;
        case SWEEPZTHLOG:
            break;
        case SWEEPYTHLIN:
            break;
        case SWEEPYTHLOG:
            break;
        case SWEEPRXLIN:
            break;
        case SWEEPRXLOG:
            break;
        case SWEEPGBLIN:
            break;
        case SWEEPGBLOG:
            break;

        case DISPCSLARGE:
		case DISPCPLARGE:
		case DISPLSLARGE:
		case DISPLPLARGE:
		case DISPZTHLARGE:
		case DISPYTHLARGE:
		case DISPRXLARGE:
		case DISPGBLARGE:
		case DISPDCRLARGE:
        case DISPCSNORM:
		case DISPCPNORM:
		case DISPLSNORM:
		case DISPLPNORM:
	    case DISPZTHNORM:
		case DISPYTHNORM:
		case DISPRXNORM:
		case DISPGBNORM:
		case DISPDCRNORM:
		    if ((lastState != MEASFUNCCS) &&
		    (lastState != MEASFUNCCP) &&
			(lastState != MEASFUNCLS) &&
			(lastState != MEASFUNCLP) &&
			(lastState != MEASFUNCZTH) &&
			(lastState != MEASFUNCYTH) &&
			(lastState != MEASFUNCRX) &&
			(lastState != MEASFUNCGB) &&
			(lastState != MEASFUNCDCR) &&
			(lastState != SPECRETURN ))
			{
		        displayState ^= 0x01;	 //iJn
				set_s_TextColor(GRAY2); 
                drawLcdRect(0,0, 227, 480 ,FILL); //  e

			    
			}

 	        if (displayState == NORM)
		    {

				DRAW_KEY_R4;
				DRAW_KEY_R3;
				DRAW_KEY_R2;
				DRAW_KEY_R1;
                highLight("NORM",&font1,295, 256,BLACK,WHITE,&B4,HIGH_LIGHT);
			    highLight("LARGE",&font1,295+7*7, 256,BLACK,WHITE,&B4,NONE_HIGH_LIGHT);
		    }
	        else
		    {
	            highLight("LARGE",&font1,295+7*7, 256,BLACK,WHITE,&B4,HIGH_LIGHT);
		        highLight("NORM",&font1,295, 256,BLACK,WHITE,&B4,NONE_HIGH_LIGHT);
		    }
			showDISPR1ToR4();
            break;
 
        case SYSTEMINFO:
			systemInfoState = SYSTEM_INFO;
			showSystemInfo();

            break;
        case SYSSPECSTATEB1:
		    systemInfoState = SYSTEM_INFO;
            actualState = lastState;
			lastState = lastLastState; 

			showSystemInfo();
            break;
        case SYSSPECSTATEB2:
		    systemInfoState = SYSTEM_CONFIG;
            actualState = lastState;
			lastState = lastLastState; 

			showSystemInfo();
            break;
        case SYSSPECSTATEB3:
		    systemInfoState = SYSTEM_CAL;
            actualState = lastState;
			lastState = lastLastState; 

		    showSystemInfo();
            break;
		case MEASSPECSTATER1:
		    SET_S;
		    QDRG++;
			if (QDRG == (numberOfQDRG - 1))
			    QDRG = CQ;

            actualState = lastState;
			lastState = lastLastState; 
			initializeLcrState();
			break;
		case MEASSPECSTATER2:
		    CLR_S;
		    QDRG++;
			if (QDRG == numberOfQDRG)
			    QDRG = CQ;

            actualState = lastState;
			lastState = lastLastState; 
			initializeLcrState();
			break;
		case DISPSPECSTATER1:
		    displayNotation ^= 0x01;

            actualState = lastState;
			lastState = lastLastState; 
			showDISPR1ToR4();
			
		    break;
		case DISPSPECSTATER2:
		    priminaryDigit++;
			if (priminaryDigit == 7)
			    priminaryDigit = 2;

            actualState = lastState;
			lastState = lastLastState; 
			showDISPR1ToR4();

		    break;
		case DISPSPECSTATER3:
		    if (clzrdcr != 4)  //DCR  secondaryDigit iվ
		        secondaryDigit++;
			if (secondaryDigit == 7)
			    secondaryDigit = 2;

            actualState = lastState;
			lastState = lastLastState; 
			showDISPR1ToR4();

		    break;
        case SPECSTATER1:
            break;
        case SPECSTATER2:
            break;
        case SPECSTATER3:
            break;
        case SPECSTATER4:
            break;
        case SPECRETURN:

			if (lastState == SYSTEMINFO 
			    
			)
			{
	            pasteB0ToB9(); //  sI
                showMEASFUNCB1ToB5();
			    showMEASFUNCR1ToR4();
				highLightNORMLARGE();
				highLightCLZRDCR();
			}
            swapState = actualState;  // lastLastState to move in circles 	then call  initializeLcrState(); again
            actualState = lastLastState;
			lastLastState = lastState;
			lastState = swapState;
			initializeLcrState();
            break;
    }
	}

}

void measure(void)
{
    switch (actualState)
    {
        case MEASFUNCCS:
            break;
        case MEASFUNCCP:
            break;
        case MEASFUNCLS:
            break;
        case MEASFUNCLP:
            break;
        case MEASFUNCZTH:
            break;
        case MEASFUNCYTH:
            break;
        case MEASFUNCRX:
            break;
        case MEASFUNCGB:
            break;
        case MEASFUNCDCR:
            break;
        case BINCSTOLBIN:
            break;
        case BINCSTOLTBL:
            break;
        case BINCSTOLHIST:
            break;
        case BINCSABSBIN:
            break;
        case BINCSABSTBL:
            break;
        case BINCSABSHIST:
            break;
        case BINCPTOLBIN:
            break;
        case BINCPTOLTBL:
            break;
        case BINCPTOLHIST:
            break;
        case BINCPABSBIN:
            break;
        case BINCPABSTBL:
            break;
        case BINCPABSHIST:
            break;
        case BINLSTOLBIN:
            break;
        case BINLSTOLTBL:
            break;
        case BINLSTOLHIST:
            break;
        case BINLSABSBIN:
            break;
        case BINLSABSTBL:
            break;
        case BINLSABSHIST:
            break;
        case BINLPTOLBIN:
            break;
        case BINLPTOLTBL:
            break;
        case BINLPTOLHIST:
            break;
        case BINLPABSBIN:
            break;
        case BINLPABSTBL:
            break;
        case BINLPABSHIST:
            break;
        case BINZTHTOLBIN:
            break;
        case BINZTHTOLTBL:
            break;
        case BINZTHTOLHIST:
            break;
        case BINZTHABSBIN:
            break;
        case BINZTHABSTBL:
            break;
        case BINZTHABSHIST:
            break;
        case BINYTHTOLBIN:
            break;
        case BINYTHTOLTBL:
            break;
        case BINYTHTOLHIST:
            break;
        case BINYTHABSBIN:
            break;
        case BINYTHABSTBL:
            break;
        case BINYTHABSHIST:
            break;
        case BINRXTOLBIN:
            break;
        case BINRXTOLTBL:
            break;
        case BINRXTOLHIST:
            break;
        case BINRXABSBIN:
            break;
        case BINRXABSTBL:
            break;
        case BINRXABSHIST:
            break;
        case BINGBTOLBIN:
            break;
        case BINGBTOLTBL:
            break;
        case BINGBTOLHIST:
            break;
        case BINGBABSBIN:
            break;
        case BINGBABSTBL:
            break;
        case BINGBABSHIST:
            break;
        case BINDCRTOLBIN:
            break;
        case BINDCRTOLTBL:
            break;
        case BINDCRTOLHIST:
            break;
        case BINDCRABSBIN:
            break;
        case BINDCRABSTBL:
            break;
        case BINDCRABSHIST:
            break;
        case SWEEPCSLIN:
            break;
        case SWEEPCSLOG:
            break;
        case SWEEPCPLIN:
            break;
        case SWEEPCPLOG:
            break;
        case SWEEPLSLIN:
            break;
        case SWEEPLSLOG:
            break;
        case SWEEPLPLIN:
            break;
        case SWEEPLPLOG:
            break;
        case SWEEPZTHLIN:
            break;
        case SWEEPZTHLOG:
            break;
        case SWEEPYTHLIN:
            break;
        case SWEEPYTHLOG:
            break;
        case SWEEPRXLIN:
            break;
        case SWEEPRXLOG:
            break;
        case SWEEPGBLIN:
            break;
        case SWEEPGBLOG:
            break;
        case DISPCSNORM:
            break;
        case DISPCSLARGE:
            break;
        case DISPCPNORM:
            break;
        case DISPCPLARGE:
            break;
        case DISPLSNORM:
            break;
        case DISPLSLARGE:
            break;
        case DISPLPNORM:
            break;
        case DISPLPLARGE:
            break;
        case DISPZTHNORM:
            break;
        case DISPZTHLARGE:
            break;
        case DISPYTHNORM:
            break;
        case DISPYTHLARGE:
            break;
        case DISPRXNORM:
            break;
        case DISPRXLARGE:
            break;
        case DISPGBNORM:
            break;
        case DISPGBLARGE:
            break;
        case DISPDCRNORM:
            break;
        case DISPDCRLARGE:
            break;
        case SYSTEMINFO:
            break;
 
        case SPECSTATER1:
            break;
        case SPECSTATER2:
            break;
        case SPECSTATER3:
            break;
        case SPECSTATER4:
            break;
        case SPECRETURN:
            break;
    }
}

/*

Cs,Cp,Ls,Lp Ѽ FDEC SCI  Pri.Digit  Sec.Digit 覡


*/

void numericalParser(uint8_t *Deststr,NUMERICAL *a,uint8_t Digit)
{
    uint8_t i,disp[20];

	uint8_t unit[6] ={0,0,0,0,0,0};
	float element = fabs(a->element);
	for (i = 0 ;i < 20; i++)
	{
	    Deststr[i] = 0;
		disp[i] = 0;
	}

	if (actualState != DISPCSLARGE &&
		actualState != DISPCPLARGE &&
		actualState != DISPLSLARGE &&
		actualState != DISPLPLARGE &&
		actualState != DISPZTHLARGE &&
		actualState != DISPYTHLARGE &&
		actualState != DISPRXLARGE &&
		actualState != DISPGBLARGE &&
		actualState != DISPDCRLARGE 
		)
	    strcpy((void *)Deststr,(void *)a->name);
    if (displayNotation == DEC)
	{
        if (Digit == 6)
	    {
		    if (element < 10)
                sprintf((void *)disp,"% .5f",a->element);
		    else if (element < 100)
		        sprintf((void *)disp,"% .4f",a->element);
		    else if (element < 1000)
		        sprintf((void *)disp,"% .3f",a->element);
		    else if (element < 10000)
			    sprintf((void *)disp,"% .2f",a->element);
			else if (element < 100000)
			    sprintf((void *)disp,"% .1f",a->element);
			else if (element < 1000000)
			    sprintf((void *)disp,"% .0f ",a->element);

		}
		else if (Digit == 5)
		{
		    if (element < 10)
                sprintf((void *)disp,"% .4f ",a->element);
		    else if (element < 100)
		        sprintf((void *)disp,"% .3f ",a->element);
		    else if (element < 1000)
		        sprintf((void *)disp,"% .2f ",a->element);
		    else if (element < 10000)
		        sprintf((void *)disp,"% .1f ",a->element);
		    else if (element < 100000)
		        sprintf((void *)disp,"% .0f  ",a->element);
		    else if (element < 1000000)
		        sprintf((void *)disp,"% .0f ",a->element);								

		}								
		else if (Digit == 4)
		{
		    if (element < 10)
                sprintf((void *)disp,"% .3f  ",a->element);
		    else if (element < 100)
		        sprintf((void *)disp,"% .2f  ",a->element);
		    else if (element < 1000)
		        sprintf((void *)disp,"% .1f  ",a->element);
		    else if (element < 10000)
		        sprintf((void *)disp,"% .0f   ",a->element);
		    else if (element < 100000)
		        sprintf((void *)disp,"% .0f  ",a->element);
		    else if (element < 1000000)
		        sprintf((void *)disp,"% .0f ",a->element);								

		}								
		else if (Digit == 3)
		{
		    if (element < 10)
                sprintf((void *)disp,"% .2f   ",a->element);
		    else if (element < 100)
		        sprintf((void *)disp,"% .1f   ",a->element);
		    else if (element < 1000)
		        sprintf((void *)disp,"% .0f    ",a->element);
		    else if (element < 10000)
		        sprintf((void *)disp,"% .0f   ",a->element);
		    else if (element < 100000)
		        sprintf((void *)disp,"% .0f  ",a->element);
		    else if (element < 1000000)
		        sprintf((void *)disp,"% .0f ",a->element);								
							
		}
		else if (Digit == 2)
		{
		    if (element < 10)
                sprintf((void *)disp,"% .1f    ",a->element);
		    else if (element < 100)
		        sprintf((void *)disp,"% .0f     ",a->element);
		    else if (element < 1000)
		        sprintf((void *)disp,"% .0f    ",a->element);
		    else if (element < 10000)
		        sprintf((void *)disp,"% .0f   ",a->element);
		    else if (element < 100000)
		        sprintf((void *)disp,"% .0f  ",a->element);
		    else if (element < 1000000)
		        sprintf((void *)disp,"% .0f ",a->element);	
	    }
/*
#define EMPTY    0
#define FARAD    1   // qe uF,F
#define OHM      2   // کi
#define HENRY    3   // Q mH,H
#define DEGREE	 4   // 
#define CONDUCTTANCE  5 //q mS ,S
*/
		switch(a->unit)
		{
		    case EMPTY:
                strcpy((void *)unit,"     ");
				break;
		    case FARAD:
                strcpy((void *)unit,"\\F   "); // uF
				break;
			case OHM:
                strcpy((void *)unit,"K_   ");  //K ohm
				break;
			case HENRY:
                strcpy((void *)unit,"mH   ");
				break;
			case DEGREE:
                strcpy((void *)unit," {   ");  //
			    break;
			case CONDUCTTANCE:
                strcpy((void *)unit,"mS   ");
				break;
		}
	}
	else
	{

		if(Digit == 6)
		    sprintf((void *)disp,"% .5e",a->element);
		else if(Digit == 5)
		    sprintf((void *)disp," % .4e",a->element);
		else if(Digit == 4) 
		    sprintf((void *)disp,"  % .3e",a->element);
		else if(Digit == 3)
		    sprintf((void *)disp,"   % .2e",a->element);
		else if(Digit == 2)
		    sprintf((void *)disp,"    % .1e",a->element);
		switch(a->unit)
		{
		    case EMPTY:
			    strcpy((void *)unit," ");
				break;
		    case FARAD:
		    	strcpy((void *)unit,"F");
				break;
			case OHM:
				strcpy((void *)unit,"_");
				break;
			case HENRY:
			    strcpy((void *)unit,"H");
				break;
			case DEGREE:
				strcpy((void *)unit,"{");
			    break;
			case CONDUCTTANCE:
    		    strcpy((void *)unit,"S");
				break;
		}
	}
	strcat((void *)Deststr,(void*)disp);
	strcat((void *)Deststr,(void*)unit);
}

void displayQDRGValue(void)
{
	switch (QDRG)
	{
	     case CQ:
             numericalParser(displayBuffer,&Q,secondaryDigit);
			 break;
		 case CD:
             numericalParser(displayBuffer,&D,secondaryDigit);
			 break;				     
		 case CR:
		     if (IS_S)
			     numericalParser(displayBuffer,&Rs,secondaryDigit);
			 else
                 numericalParser(displayBuffer,&Rp,secondaryDigit);
			 break;	
		 case CG:
             numericalParser(displayBuffer,&G,secondaryDigit);
			 break;						 			 	
	}
    printLcdString(displayBuffer,8,8+56,&font4,blockColor,WHITE,NONE_TRANSPARENT);
}
void displayQDRGLargeValue(void)
{
	switch (QDRG)
	{
	     case CQ:
		     printLcdString("Q",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
             numericalParser(displayBuffer,&Q,secondaryDigit);
			 break;
		 case CD:
		     printLcdString("D",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
             numericalParser(displayBuffer,&D,secondaryDigit);
			 break;				     
		 case CR:
		     printLcdString("R",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
		     if (IS_S)
			     
			     numericalParser(displayBuffer,&Rs,secondaryDigit);
			 else
                 numericalParser(displayBuffer,&Rp,secondaryDigit);
			 break;	
		 case CG:
		     printLcdString("G",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
             numericalParser(displayBuffer,&G,secondaryDigit);
			 break;						 			 	
	}
    printLcdString(displayBuffer,0,154,&font5,blockColor,WHITE,NONE_TRANSPARENT);
}



void displayScreen(void)
{
    if (disptp == 1)
	{
	}
	else
	{
    switch (actualState)
    {
        case MEASFUNCCS:
		case DISPCSNORM:
		    
			numericalParser(displayBuffer,&Cs,priminaryDigit);
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            displayQDRGValue();
			displayFreqLevelRangeSpeedVacIac();
            break;
		
        case MEASFUNCCP:
		case DISPCPNORM:
            numericalParser(displayBuffer,&Cp,priminaryDigit);
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            displayQDRGValue();
		    displayFreqLevelRangeSpeedVacIac();
            break;
	    
        case MEASFUNCLS:
	    case DISPLSNORM:
		    numericalParser(displayBuffer,&Ls,priminaryDigit);
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            displayQDRGValue();
		    displayFreqLevelRangeSpeedVacIac();
            break;
        case MEASFUNCLP:
		case DISPLPNORM:
            numericalParser(displayBuffer,&Lp,priminaryDigit);
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            displayQDRGValue();
		    displayFreqLevelRangeSpeedVacIac();
            break;
        case MEASFUNCZTH:
		case DISPZTHNORM:
            numericalParser(displayBuffer,&Z,priminaryDigit);//ohm
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&TH,secondaryDigit); // theta & degree
            printLcdString(displayBuffer,8,8+56,&font4,blockColor,WHITE,NONE_TRANSPARENT);
		    displayFreqLevelRangeSpeedVacIac();
            break;
        case MEASFUNCYTH:
		case DISPYTHNORM:
            numericalParser(displayBuffer,&Y,priminaryDigit);//
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&TH,secondaryDigit); // theta & degree
            printLcdString(displayBuffer,8,8+56,&font4,blockColor,WHITE,NONE_TRANSPARENT);
		    displayFreqLevelRangeSpeedVacIac();
            break;
        case MEASFUNCRX:
		case DISPRXNORM:
		    numericalParser(displayBuffer,&Rs,priminaryDigit);//ohm
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&X,secondaryDigit);//K ohm	
            printLcdString(displayBuffer,8,8+56,&font4,blockColor,WHITE,NONE_TRANSPARENT);
		    displayFreqLevelRangeSpeedVacIac();
            break;
        case MEASFUNCGB:
	    case DISPGBNORM:
			numericalParser(displayBuffer,&G,priminaryDigit);//
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&B,secondaryDigit);//	
            printLcdString(displayBuffer,8,8+56,&font4,blockColor,WHITE,NONE_TRANSPARENT);
		    displayFreqLevelRangeSpeedVacIac();
            break;
        case MEASFUNCDCR:
		case DISPDCRNORM:
            sprintf((char *)displayBuffer,"                ");//ohm
            printLcdString(displayBuffer,8,8,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&DCR,priminaryDigit);	
            printLcdString(displayBuffer,8,8+56,&font4,blockColor,WHITE,NONE_TRANSPARENT);
		    displayFreqLevelRangeSpeedVacIac();
            break;
        case BINCSTOLBIN:
            break;
        case BINCSTOLTBL:
            break;
        case BINCSTOLHIST:
            break;
        case BINCSABSBIN:
            break;
        case BINCSABSTBL:
            break;
        case BINCSABSHIST:
            break;
        case BINCPTOLBIN:
            break;
        case BINCPTOLTBL:
            break;
        case BINCPTOLHIST:
            break;
        case BINCPABSBIN:
            break;
        case BINCPABSTBL:
            break;
        case BINCPABSHIST:
            break;
        case BINLSTOLBIN:
            break;
        case BINLSTOLTBL:
            break;
        case BINLSTOLHIST:
            break;
        case BINLSABSBIN:
            break;
        case BINLSABSTBL:
            break;
        case BINLSABSHIST:
            break;
        case BINLPTOLBIN:
            break;
        case BINLPTOLTBL:
            break;
        case BINLPTOLHIST:
            break;
        case BINLPABSBIN:
            break;
        case BINLPABSTBL:
            break;
        case BINLPABSHIST:
            break;
        case BINZTHTOLBIN:
            break;
        case BINZTHTOLTBL:
            break;
        case BINZTHTOLHIST:
            break;
        case BINZTHABSBIN:
            break;
        case BINZTHABSTBL:
            break;
        case BINZTHABSHIST:
            break;
        case BINYTHTOLBIN:
            break;
        case BINYTHTOLTBL:
            break;
        case BINYTHTOLHIST:
            break;
        case BINYTHABSBIN:
            break;
        case BINYTHABSTBL:
            break;
        case BINYTHABSHIST:
            break;
        case BINRXTOLBIN:
            break;
        case BINRXTOLTBL:
            break;
        case BINRXTOLHIST:
            break;
        case BINRXABSBIN:
            break;
        case BINRXABSTBL:
            break;
        case BINRXABSHIST:
            break;
        case BINGBTOLBIN:
            break;
        case BINGBTOLTBL:
            break;
        case BINGBTOLHIST:
            break;
        case BINGBABSBIN:
            break;
        case BINGBABSTBL:
            break;
        case BINGBABSHIST:
            break;
        case BINDCRTOLBIN:
            break;
        case BINDCRTOLTBL:
            break;
        case BINDCRTOLHIST:
            break;
        case BINDCRABSBIN:
            break;
        case BINDCRABSTBL:
            break;
        case BINDCRABSHIST:
            break;
        case SWEEPCSLIN:
            break;
        case SWEEPCSLOG:
            break;
        case SWEEPCPLIN:
            break;
        case SWEEPCPLOG:
            break;
        case SWEEPLSLIN:
            break;
        case SWEEPLSLOG:
            break;
        case SWEEPLPLIN:
            break;
        case SWEEPLPLOG:
            break;
        case SWEEPZTHLIN:
            break;
        case SWEEPZTHLOG:
            break;
        case SWEEPYTHLIN:
            break;
        case SWEEPYTHLOG:
            break;
        case SWEEPRXLIN:
            break;
        case SWEEPRXLOG:
            break;
        case SWEEPGBLIN:
            break;
        case SWEEPGBLOG:
            break;

        case DISPCSLARGE:
		    printLcdString("Cs",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&Cs,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
			displayQDRGLargeValue();
            break;

        case DISPCPLARGE:
		    printLcdString("Cp",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&Cp,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
			displayQDRGLargeValue();
            break;

        case DISPLSLARGE:
		    printLcdString("Ls",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&Ls,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
			displayQDRGLargeValue();
            break;

        case DISPLPLARGE:
		    printLcdString("Lp",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&Lp,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
			displayQDRGLargeValue();
            break;

        case DISPZTHLARGE:
		    printLcdString("Z",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&Z,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
		    printLcdString("|",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&TH,secondaryDigit);	
            printLcdString(displayBuffer,0,154,&font5,blockColor,WHITE,NONE_TRANSPARENT);
            break;

        case DISPYTHLARGE:
		    printLcdString("Y",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&Y,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
		    printLcdString("|",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&TH,secondaryDigit);	
            printLcdString(displayBuffer,0,154,&font5,blockColor,WHITE,NONE_TRANSPARENT);
            break;

        case DISPRXLARGE:
		    printLcdString("R",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&Rs,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
		    printLcdString("X",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&X,secondaryDigit);	
            printLcdString(displayBuffer,0,154,&font5,blockColor,WHITE,NONE_TRANSPARENT);
            break;

        case DISPGBLARGE:
		    printLcdString("G",0,0,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&G,priminaryDigit);	
            printLcdString(displayBuffer,0,41,&font5,blockColor,WHITE,NONE_TRANSPARENT);
		    printLcdString("B",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&B,secondaryDigit);	
            printLcdString(displayBuffer,0,154,&font5,blockColor,WHITE,NONE_TRANSPARENT);
            break;

        case DISPDCRLARGE:
		    printLcdString("DCR",0,113,&font4,blockColor,WHITE,NONE_TRANSPARENT);
            numericalParser(displayBuffer,&DCR,priminaryDigit);	
            printLcdString(displayBuffer,0,154,&font5,blockColor,WHITE,NONE_TRANSPARENT);
            break;
        case SYSTEMINFO:
            break;

        case SPECSTATER1:

            break;
        case SPECSTATER2:

            break;
        case SPECSTATER3:
            break;
        case SPECSTATER4:
            break;
        case SPECRETURN:
            break;
    }
	}

}



void highLightCLZRDCR(void)
{
    switch(clzrdcr)
	{
	    case 0:
	        highLight("DCR",&font1,10+56, 256,BLACK,WHITE,&B1,NONE_HIGH_LIGHT);
	        highLight("C",&font1,10, 256,BLACK,WHITE,&B1,HIGH_LIGHT);
		    break;
		case 1:
            highLight("C",&font1,10, 256,BLACK,WHITE,&B1,NONE_HIGH_LIGHT);
	        highLight("L",&font1,10+14, 256,BLACK,WHITE,&B1,HIGH_LIGHT);
		    break;
		case 2:
            highLight("L",&font1,10+14, 256,BLACK,WHITE,&B1,NONE_HIGH_LIGHT);
	        highLight("Z",&font1,10+28, 256,BLACK,WHITE,&B1,HIGH_LIGHT);
		    break;
		case 3:
            highLight("Z",&font1,10+28, 256,BLACK,WHITE,&B1,NONE_HIGH_LIGHT);
	        highLight("R",&font1,10+42, 256,BLACK,WHITE,&B1,HIGH_LIGHT);
		    break;
		case 4:
            highLight("R",&font1,10+42, 256,BLACK,WHITE,&B1,NONE_HIGH_LIGHT);
	        highLight("DCR",&font1,10+56, 256,BLACK,WHITE,&B1,HIGH_LIGHT);
		    break;

	}
}
void highLightCsCpQDRG(void)
{

    if (IS_S)  // Cs Ѽ
	{
		switch(QDRG)
		{
		    case CQ:
			    highLight("Q",&font2,410, 30,BLACK,WHITE,&R1,HIGH_LIGHT);
			    break;
			case CD:
			    highLight("D",&font2,410+18, 30,BLACK,WHITE,&R1,HIGH_LIGHT);
			    break;
			case CR:
			    highLight("R",&font2,410+36, 30,BLACK,WHITE,&R1,HIGH_LIGHT);
			    break;
		}
	}
	else
	{
		switch(QDRG)
		{
		    case CQ:
			    highLight("Q",&font2,401, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
			    break;
			case CD:
			    highLight("D",&font2,401+18, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
			    break;
			case CR:
			    highLight("R",&font2,401+36, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
			    break;
			case CG:
			    highLight("G",&font2,401+54, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
			    break;
		}
	}
}


void showMEASFUNCR1ToR4(void)
{
	if (lastState == DISPCSNORM ||
	    lastState == DISPCPNORM ||
		lastState == DISPLPNORM ||
		lastState == DISPLSNORM ||
		lastState == DISPZTHNORM ||
		lastState == DISPYTHNORM ||
		lastState == DISPRXNORM ||
		lastState == DISPGBNORM ||
		lastState == DISPDCRNORM ||
        lastState == DISPCSLARGE ||
	    lastState == DISPCPLARGE ||
		lastState == DISPLPLARGE ||
		lastState == DISPLSLARGE ||
		lastState == DISPZTHLARGE ||
		lastState == DISPYTHLARGE ||
		lastState == DISPRXLARGE ||
		lastState == DISPGBLARGE ||
		lastState == DISPDCRLARGE ||
		lastState == BINCSTOLBIN ||
		lastState == BINCPTOLBIN ||
		lastState == BINLSTOLBIN ||
		lastState == BINLPTOLBIN ||
		lastState == BINZTHTOLBIN ||
		lastState == BINYTHTOLBIN ||
		lastState == BINRXTOLBIN ||
		lastState == BINGBTOLBIN ||
		lastState == BINDCRTOLBIN 

		)
	{ 
		set_s_TextColor(GRAY2); 
        drawLcdRect(0,0, 227, 480 ,FILL); //  e
	    DRAW_KEY_R1;
        DRAW_KEY_R2;
        DRAW_KEY_R3;
        DRAW_KEY_R4;
		displayState = NORM;
		printLcdString("NORM  LARGE",295,256,&font1,B4.backcolor,WHITE,NONE_TRANSPARENT);
		highLight("NORM",&font1,295, 256,BLACK,WHITE,&B4,HIGH_LIGHT);
		highLight("LARGE",&font1,295+7*7, 256,BLACK,WHITE,&B4,NONE_HIGH_LIGHT);
		printLcdString("TOL    ABS",106,256,&font1,B2.backcolor,WHITE,NONE_TRANSPARENT);
	}




    if (actualState == MEASFUNCCS || actualState == MEASFUNCCP)
	{
	    
	    printLcdString("    Cs    ",387,6,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("  Q D R  ",392,30,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("    Cp    ",387,62,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString(" Q D R G ",392,86,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		highLightCsCpQDRG();
	}
	else if  (actualState == MEASFUNCLS || actualState == MEASFUNCLP)
	{
		printLcdString("    Ls   ",387,6,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("  Q D R  ",392,30,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("    Lp    ",387,62,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString(" Q D R G ",392,86,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		highLightCsCpQDRG();
	}
	else if (actualState == MEASFUNCZTH || actualState == MEASFUNCYTH)
	{
	    printLcdString("   Z-|  ",391,6,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("         ",387,30,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("   Y-|  ",391,62,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("         ",387,86,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
	}
	else if (actualState == MEASFUNCRX || actualState == MEASFUNCGB)
	{
	    printLcdString("   R-X  ",391,6,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("          ",387,30,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("   G-B  ",391,62,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("          ",387,86,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
	}
	else if (actualState == MEASFUNCDCR)
	{
	    printLcdString("         ",387,6,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
	    printLcdString("         ",387,62,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
	}	
}

void highLightDISPParameter(void)
{
    if (displayNotation == DEC)
	{
	    highLight("DEC",&font2,401, 30,BLACK,WHITE,&R1,HIGH_LIGHT);
		highLight("SCI",&font2,401+9*4, 30,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
	}
	else
	{
	    highLight("DEC",&font2,401, 30,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("SCI",&font2,401+9*4, 30,BLACK,WHITE,&R1,HIGH_LIGHT);
	}
	switch(priminaryDigit)
	{
	    case 2:
		    highLight("2",&font2,392, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
		case 3:
		    highLight("3",&font2,392+18, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
		case 4:
		    highLight("4",&font2,392+36, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
		case 5:
		    highLight("5",&font2,392+54, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
		case 6:
		    highLight("6",&font2,392+72, 86,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
	}
   	if (clzrdcr != 4)
	{
	switch(secondaryDigit)
	{
	    case 2:
		    highLight("2",&font2,392,142,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
		case 3:
		    highLight("3",&font2,392+18,142,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
		case 4:
		    highLight("4",&font2,392+36,142,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
		case 5:
		    highLight("5",&font2,392+54,142,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;	   
		case 6:
		    highLight("6",&font2,392+72,142,BLACK,WHITE,&R1,HIGH_LIGHT);
		    break;
	}
	}
}



void showDISPR1ToR4(void)
{

    if (actualState == DISPCSNORM || actualState == DISPCPNORM || actualState == DISPLSNORM || actualState == DISPLPNORM ||
	    actualState == DISPZTHNORM || actualState == DISPYTHNORM || actualState == DISPRXNORM || actualState == DISPGBNORM || 
		actualState == DISPDCRNORM)
	{
	    printLcdString("NOTATION",396,6,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("DEC SCI",401,30,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("PRI. DISP",392,62,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		printLcdString("2 3 4 5 6",392,86,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
		        // Iu@	
 	    set_s_TextColor(R2.backcolor);
		drawLcdLine(391, 86, 15, VERTICAL);

		if (clzrdcr != 4)
		{
		    printLcdString("SEC. DISP",392,118,&font2,R3.backcolor,WHITE,NONE_TRANSPARENT);
		    printLcdString("2 3 4 5 6",392,142,&font2,R3.backcolor,WHITE,NONE_TRANSPARENT);
	
		        // Iu@	
 	        set_s_TextColor(R3.backcolor);


		    drawLcdLine(391, 142, 15, VERTICAL);
		    
		}
	    highLightDISPParameter();
	}
	else if(actualState == DISPCSLARGE || actualState == DISPCPLARGE || actualState == DISPLSLARGE || actualState == DISPLPLARGE ||
	    actualState == DISPZTHLARGE || actualState == DISPYTHLARGE || actualState == DISPRXLARGE || actualState == DISPGBLARGE || 
		actualState == DISPDCRLARGE)
	{
	     set_s_TextColor(GRAY2); 
         drawLcdRect(0,0, 227, 480 ,FILL); //  e
	}
}




void showMEASFUNCB1ToB5(void)
{
    printLcdString("MEAS FUNC",4,233,&font3,B1.backcolor,WHITE,NONE_TRANSPARENT);
    printLcdString("C L Z R DCR",10,256,&font1,B1.backcolor,WHITE,NONE_TRANSPARENT);

    printLcdString("BIN",130,233,&font3,B2.backcolor,WHITE,NONE_TRANSPARENT);
    printLcdString("TOL    ABS",106,256,&font1,B2.backcolor,WHITE,NONE_TRANSPARENT);

    printLcdString("SWEEP",216,233,&font3,B3.backcolor,WHITE,NONE_TRANSPARENT);
    printLcdString("FREQ",227,256,&font1,B3.backcolor,WHITE,NONE_TRANSPARENT);

    printLcdString("DISP",317,233,&font3,B4.backcolor,WHITE,NONE_TRANSPARENT);
    printLcdString("NORM   LARGE",295,256,&font1,B4.backcolor,WHITE,NONE_TRANSPARENT);
    printLcdString("SYSTEM",403,233,&font3,B5.backcolor,WHITE,NONE_TRANSPARENT);
}
 
void showSystemInfo(void)
{
	if (systemInfoState == SYSTEM_INFO)
	{
	    pasteB0ToB9();

	    printLcdString("SYSTEM",18,233,&font3,B1.backcolor,WHITE,NONE_TRANSPARENT);
 	    printLcdString("INFO",28,253,&font3,B1.backcolor,WHITE,NONE_TRANSPARENT);
	
	    printLcdString("SYSTEM",114,233,&font3,B2.backcolor,WHITE,NONE_TRANSPARENT);
	    printLcdString("CONFIG",114,253,&font3,B2.backcolor,WHITE,NONE_TRANSPARENT);

	    printLcdString("CAL",225,233,&font3,B3.backcolor,WHITE,NONE_TRANSPARENT);
	
	    printLcdString("EXIT",412,233,&font3,B5.backcolor,WHITE,NONE_TRANSPARENT);

        printLcdString("  SYSTEM INFO",1,FONT2_LINE2,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	    strcpy((void *)displayBuffer,"  Model              \0");
	    strcat((void *)displayBuffer,(void *)Model);
	    printLcdString((void *)displayBuffer,1,FONT2_LINE3,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	    strcpy((void *)displayBuffer,"  Serial Number      \0");
	    strcat((void *)displayBuffer,(void *)SerialNumber);
	    printLcdString((void *)displayBuffer,1,FONT2_LINE4,&font2,blockColor,WHITE,NONE_TRANSPARENT);
 	    strcpy((void *)displayBuffer,"  Version            \0");
	    strcat((void *)displayBuffer,(void *)Version);
	    printLcdString((void *)displayBuffer,1,FONT2_LINE5,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	   
	    sprintf((void *)displayBuffer,"  Front USB ID       VID:%04Xh PID:%04Xh",
	                                                  (uint32_t)USB_Host.device_prop.Dev_Desc.idVendor,
													  (uint32_t)USB_Host.device_prop.Dev_Desc.idProduct);
													  
													 // (void *)USB_Host.device_prop.Dev_Desc.iProduct);
													 
	    printLcdString((void *)displayBuffer,1,FONT2_LINE7,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	    sprintf((void *)displayBuffer,"  MAC Address        %d",MAC_address);
	    printLcdString((void *)displayBuffer,1,FONT2_LINE8,&font2,blockColor,WHITE,NONE_TRANSPARENT);
        sprintf((void *)displayBuffer,"  GPIB Address       %d",GPIB_address);
	    printLcdString((void *)displayBuffer,1,FONT2_LINE9,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	}
	else if (systemInfoState == SYSTEM_CONFIG)
	{
	     showSystemConfig();
	}
	else //SYSTEM_CAL
	{
		 showSystemCal();
	}


}

void showSystemConfig(void)
{

	set_s_TextColor(GRAY2);
	drawLcdRect(0,0, 229, 386 ,FILL);
	DRAW_KEY_R4;
	DRAW_KEY_R3;
	DRAW_KEY_R2;
	DRAW_KEY_R1;
	printLcdString("  SYSTEM CONFIG",1,FONT2_LINE2,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	RTC_TimeShow();// FONT2_LINE3
    RTC_DateShow();// FONT2_LINE4
    sprintf((void *)displayBuffer,"  GPIB Address         %d",GPIB_address);
	printLcdString((void *)displayBuffer,1,FONT2_LINE5,&font2,blockColor,WHITE,NONE_TRANSPARENT);
    sprintf((void *)displayBuffer,"  IP Mode              DHCP");
	printLcdString((void *)displayBuffer,1,FONT2_LINE6,&font2,blockColor,WHITE,NONE_TRANSPARENT);
    sprintf((void *)displayBuffer,"  IP Address           \0");
	strcat((void *)displayBuffer,(void *)IP_Address);
	printLcdString((void *)displayBuffer,1,FONT2_LINE7,&font2,blockColor,WHITE,NONE_TRANSPARENT);
    sprintf((void *)displayBuffer,"  Subnet Mask          \0");
	strcat((void *)displayBuffer,(void *)Subnet_Mask);
	printLcdString((void *)displayBuffer,1,FONT2_LINE8,&font2,blockColor,WHITE,NONE_TRANSPARENT);
    sprintf((void *)displayBuffer,"  Geteway              \0");
	strcat((void *)displayBuffer,(void *)Geteway);
	printLcdString((void *)displayBuffer,1,FONT2_LINE9,&font2,blockColor,WHITE,NONE_TRANSPARENT);


    sprintf((void *)displayBuffer,"  Current IP Address   \0");
	strcat((void *)displayBuffer,(void *)Current_IP_Address);
	printLcdString((void *)displayBuffer,1,FONT2_LINE11,&font2,blockColor,WHITE,NONE_TRANSPARENT);
    sprintf((void *)displayBuffer,"  Current Subnet Mask  \0");
	strcat((void *)displayBuffer,(void *)Current_Subnet_Mask);
	printLcdString((void *)displayBuffer,1,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);
    sprintf((void *)displayBuffer,"  Current Geteway      \0");
	strcat((void *)displayBuffer,(void *)Current_Geteway);
	printLcdString((void *)displayBuffer,1,FONT2_LINE13,&font2,blockColor,WHITE,NONE_TRANSPARENT);


}
void showSystemCal(void)
{

	set_s_TextColor(GRAY2);
	drawLcdRect(0,0, 229, 386 ,FILL);
	DRAW_KEY_R4;
	DRAW_KEY_R3;
	DRAW_KEY_R2;
	DRAW_KEY_R1;	
    printLcdString("For open calibration,",55,FONT2_LINE4,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	printLcdString("open the test leads and press  ---->",55,FONT2_LINE5,&font2,blockColor,WHITE,NONE_TRANSPARENT);
    printLcdString("Last Cal. 2012/07/30 13:40:20",60,FONT2_LINE6,&font2,blockColor,WHITE,NONE_TRANSPARENT);

    printLcdString("For short calibration,",55,FONT2_LINE11,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	printLcdString("short the test leads and press ---->",55,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	printLcdString("Last Cal. 2012/07/30 13:40:20",55,FONT2_LINE13,&font2,blockColor,WHITE,NONE_TRANSPARENT);

	printLcdString("  OPEN  ",396,62,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);
	printLcdString("   CAL   ",392,86,&font2,R2.backcolor,WHITE,NONE_TRANSPARENT);

	printLcdString("  SHORT  ",392,174,&font2,R4.backcolor,WHITE,NONE_TRANSPARENT);
	printLcdString("   CAL   ",392,198,&font2,R4.backcolor,WHITE,NONE_TRANSPARENT);



}



void displayFreqLevelRangeSpeedVacIac(void)
{
    if (cursor.used == 0)
	{

		printLcdString("FREQ",FONT2_CHAR2,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT); 
	    optimizeValue((void *)displayBuffer,&freq );
	    printLcdString(displayBuffer,FONT2_CHAR10,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT);  // (10,10)

	    printLcdString("LEVEL",FONT2_CHAR25,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT);	
	    optimizeValue((void *)displayBuffer,&level );
	    printLcdString(displayBuffer,FONT2_CHAR33,FONT2_LINE10,&font2,blockColor,WHITE,NONE_TRANSPARENT); // (33,10)

	    sprintf((char*)displayBuffer," RANGE    AUTO          SPEED    SLOW    ");
	    printLcdString(displayBuffer,FONT2_CHAR1,FONT2_LINE11,&font2,blockColor,WHITE,NONE_TRANSPARENT);

	    printLcdString("VAC",FONT2_CHAR2,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	    optimizeValue((void *)displayBuffer,&vac );
	    printLcdString(displayBuffer,FONT2_CHAR10,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT); // (10,12)
	
	    printLcdString("IAC",FONT2_CHAR25,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	    optimizeValue((void *)displayBuffer,&iac );
	    printLcdString(displayBuffer,FONT2_CHAR33,FONT2_LINE12,&font2,blockColor,WHITE,NONE_TRANSPARENT); // (33,12)

	}
	else
	{
	    if (location == 1 || location == 4)
		{
	        if(IS_SEC1_0)
	            highLight((void *)dispbuf,&font2,cursor.x, cursor.y,RED,RED,&B0,HIGH_LIGHT);
	        else
	            highLight((void *)dispbuf,&font2,cursor.x, cursor.y,RED,RED,&B0,NONE_HIGH_LIGHT);
		}
		else
		{
		    
		    if (IS_NUMBER == 0 )

			{
			float temp;
			tempBuffer.element = atof((void *)dispbuf);
    		if (tempBuffer.element == 0) // Xk ,nקK
			{
			    tempBuffer.element = backupValue * 0.9;	//W@kȭH0.9 
			}
			switch(dispbuf[6])
			{
			    case ' ':
				   	temp = 1;
					break;
				case 'm':
				    temp = 0.001;
					break;
				case '\\':
				    temp = 0.000001;
					break;
				case 'n':
				    temp = 0.000000001;
					break;
				case 'p':
				    temp = 0.000000000001;
					break;
				case 'f':
				    temp = 0.000000000000001;
					break;
				case 'K':
				    temp = 1000;
					break;
				case 'M':
				    temp = 1000000;
					break;
				case 'G': 
				    temp = 1000000000;
					break;
				case 'T':
				    temp = 1000000000000;
					break;
				case 'P':
				    temp = 1000000000000000;
					break;
			}
			tempBuffer.element *= temp;
			switch(location)   // s^Ӫ
			{
			    case 0:
				    freq = tempBuffer;
				    break;
				case 2:
				    vac = tempBuffer;
				    break;
				case 3:
				    level = tempBuffer;
				    break;
				case 5:
				    iac = tempBuffer;
				    break;
			}
			optimizeValue((void *)dispbuf,&tempBuffer);// ̨ΤƼƭȪ{ùW
			}
		    if (IS_SEC1_0)
			{
				set_s_TextColor(B0.backcolor);
	            drawLcdLine(cursor.xStart - 1, cursor.y, font2.high, VERTICAL);	 // ̥@ݽu 
			    printLcdString((void *)dispbuf,cursor.xStart,cursor.y,&font2,B0.backcolor,RED,NONE_TRANSPARENT);
			}
            else 
			{	 // Bzа{{
			    cursor.buf[0] =	dispbuf[cursor.index]; 
	            cursor.buf[1] = 0;
	            cursor.x = cursor.xStart + (cursor.index*font2.width);   
		        highLight((void *)cursor.buf,&font2,cursor.x, cursor.y,RED,RED,&B0,HIGH_LIGHT);
			}
		}
	}
}

void highLightTOLABS(void)
{
    if (tolabs == TOL)
	{
	    highLight("TOL",&font1,106,256,BLACK,WHITE,&R1,HIGH_LIGHT);
		highLight("ABS",&font1,106+7*7,256,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
	}
	else
	{
	    highLight("TOL",&font1,106,256,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("ABS",&font1,106+7*7,256,BLACK,WHITE,&R1,HIGH_LIGHT);
	}
}

void highLightBINTBLHIST(void)
{
    if (bintblhist == BIN)
	{
	    highLight("BIN",&font1,295,256,BLACK,WHITE,&R1,HIGH_LIGHT);
		highLight("TBL",&font1,295+4*7,BLACK,WHITE,256,&R1,NONE_HIGH_LIGHT);
		highLight("HIST",&font1,295+8*7,256,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
	}
	else if(bintblhist == TBL)
	{
	    highLight("BIN",&font1,295,256,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("TBL",&font1,295+4*7,256,BLACK,WHITE,&R1,HIGH_LIGHT);
		highLight("HIST",&font1,295+8*7,256,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
	}
	else   //HIST
	{
	    highLight("BIN",&font1,295,256,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("TBL",&font1,295+4*7,256,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("HIST",&font1,295+8*7,256,BLACK,WHITE,&R1,HIGH_LIGHT);
	}
}
void highLigthOFFONSMART(void)
{
    if (offonsmart == OFF)
	{
	    highLight("OFF",&font1,392,86,BLACK,WHITE,&R1,HIGH_LIGHT);
		highLight("ON",&font1,392+4*7,86,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("SMART",&font1,392+7*7,86,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
	}
	else if(offonsmart == ON)
	{
	    highLight("OFF",&font1,392,86,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("ON",&font1,392+4*7,86,BLACK,WHITE,&R1,HIGH_LIGHT);
		highLight("SMART",&font1,392+7*7,86,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
	}
	else  //SMART
	{
	    highLight("OFF",&font1,392,86,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("ON",&font1,392+4*7,86,BLACK,WHITE,&R1,NONE_HIGH_LIGHT);
		highLight("SMART",&font1,392+7*7,86,BLACK,WHITE,&R1,HIGH_LIGHT);
	}

}


void showBIN(void)
{
    uint8_t disp[32];
	set_s_TextColor(GRAY2);
	drawLcdRect(0,0, 229, 386 ,FILL);
	DRAW_KEY_R4;
	DRAW_KEY_R3;
	DRAW_KEY_R2;
	DRAW_KEY_R1;
    printLcdString(" C L Z R DCR",3,256,&font1,B1.backcolor,WHITE,NONE_TRANSPARENT);
	printLcdString("BIN TBL HIST",295,256,&font1,B4.backcolor,WHITE,NONE_TRANSPARENT);
	highLightTOLABS();
	highLightBINTBLHIST();
    printLcdString("  START  ",392,6,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
	printLcdString("  BEEP  ",396,6+56,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
	printLcdString("OFF ON SMART",392,86,&font1,R2.backcolor,WHITE,NONE_TRANSPARENT);
    highLigthOFFONSMART();
	printLcdString("  SWAP  ",396,6+56*2,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);
	printLcdString("  CLEAR  ",392,6+56*3,&font2,R1.backcolor,WHITE,NONE_TRANSPARENT);


    strcpy((void *)displayBuffer,"FUNC \0");
    if (IS_S)
	{
	    switch(clzrdcr)
		{
		    case MEAS_C:
			    strcat((void *)displayBuffer,"Cs-\0");
		        switch(QDRG)
		        {
		            case CQ:
			            strcat((void *)displayBuffer,"Q \0");
			            break;
                    case CD:
			            strcat((void *)displayBuffer,"D \0");
			            break;
			        case CR:
			            strcat((void *)displayBuffer,"R \0");
			            break;
			        case CG:
			            strcat((void *)displayBuffer,"G \0");
			            break;
		        }
                break;
			case MEAS_L:
			    strcat((void *)displayBuffer,"Ls-\0");
		        switch(QDRG)
		        {
		            case CQ:
			            strcat((void *)displayBuffer,"Q \0");
			            break;
                    case CD:
			            strcat((void *)displayBuffer,"D \0");
			            break;
			        case CR:
			            strcat((void *)displayBuffer,"R \0");
			            break;
			        case CG:
			            strcat((void *)displayBuffer,"G \0");
			            break;
		        }
                break;
            case MEAS_Z:
			    strcat((void *)displayBuffer,"Z-|  \0");
                break;
            case MEAS_R:
			    strcat((void *)displayBuffer,"R-X  \0");
                break;
            case MEAS_DCR:
			    strcat((void *)displayBuffer,"DCR  \0");
                break;							   
		}
	}
	else
	{
	    switch(clzrdcr)
		{
		    case MEAS_C:
			    strcat((void *)displayBuffer,"Cp-\0");
		        switch(QDRG)
		        {
		            case CQ:
			            strcat((void *)displayBuffer,"Q \0");
			            break;
                    case CD:
			            strcat((void *)displayBuffer,"D \0");
			            break;
			        case CR:
			            strcat((void *)displayBuffer,"R \0");
			            break;
			        case CG:
			            strcat((void *)displayBuffer,"G \0");
			            break;
		        }
                break;
			case MEAS_L:
			    strcat((void *)displayBuffer,"Lp-\0");
		        switch(QDRG)
		        {
		            case CQ:
			            strcat((void *)displayBuffer,"Q \0");
			            break;
                    case CD:
			            strcat((void *)displayBuffer,"D \0");
			            break;
			        case CR:
			            strcat((void *)displayBuffer,"R \0");
			            break;
			        case CG:
			            strcat((void *)displayBuffer,"G \0");
			            break;
		        }
                break;
            case MEAS_Z:
			    strcat((void *)displayBuffer,"Y-|  \0");
                break;
            case MEAS_R:
			    strcat((void *)displayBuffer,"G-B  \0");
                break;
            case MEAS_DCR:
			    strcat((void *)displayBuffer,"DCR  \0");
                break;							   
		}
	}
	strcat((void *)displayBuffer,"     \0");
	sprintf((void *)disp,"FREQ %6.3fKHz  \0",freq.element);
	strcat((void *)displayBuffer,(void *)disp);
	strcat((void *)displayBuffer,"RANGE AUTO \0");
	printLcdString(displayBuffer,1,FONT2_LINE1,&font2,blockColor,WHITE,NONE_TRANSPARENT);
	
	if (tolabs == TOL)
	{
	    sprintf((void *)displayBuffer,"NOW  50.000pF  ");
	}
	else // ABS
	{
	    sprintf((void *)displayBuffer,"               ");
	}

	sprintf((void *)disp,"LEVEL%6.3f V   \0",level.element);
	strcat((void *)displayBuffer,(void *)disp);
	strcat((void *)displayBuffer,"SPEED SLOW \0");
	printLcdString(displayBuffer,1,FONT2_LINE2,&font2,blockColor,WHITE,NONE_TRANSPARENT);

	if (bintblhist == BIN)
	{

	}
	else if(bintblhist == TBL)
	{
	}
	else
	{
	}

}



