#ifndef _PVSSTATE_H
#define _PVSSTATE_H


typedef enum {
    KEY_NOTHING,		/* S	 */
	KEY_FUNCTION,
	KEY_NUMERICAL,
	KEY_FLAG,
	KEY_DIRECTION
	

}key_utility;


typedef enum {
    KEY_OVP = 0,
    KEY_OPP,
    KEY_OCP,
    KEY_VSET,
    KEY_RECALL,
    KEY_ESC,
    KEY_ISET,
    KEY_MENU,
	KEY_OK,
	KEY_METER,
	KEY_ONOFF,
	KEY_SHIFT,
	
    numberOfTriggers,
    KEY_UP = 0,
    KEY_DN = 1,
    KEY_LT = 2,
    KEY_RT = 3,
	numberOfDirection = 4,
    KEY_N0 = 0,
    KEY_N1 = 1,
    KEY_N2 = 2,
    KEY_N3 = 3,
    KEY_N4 = 4,
    KEY_N5 = 5,
    KEY_N6 = 6,
    KEY_N7 = 7,
    KEY_N8 = 8,
    KEY_N9 = 9,
    KEY_DP = 10,
	KEY_SELFTEST = 13,
	KEY_NORMAL = 14,
	KEY_DEBUG = 15,
	NULL_KEY = 30

}trigger_id;

typedef enum {
   D_NORMAL,
   D_PARALLELSLAVE,
   D_PARALLELMASTER,
   D_SHIFT,
   D_OK,
   D_VSET,
   D_ISET,
   D_OVP,
   D_OCP,
   D_OPP,
   D_ESC,
   RECALL,
   STORE,
   PROGRAMMODE,
   PROGRAMEDIT,
   PROGRAMREADY,
   PROGRAMRUNNING,
   TIMEREDIT,
   TIMERRUNNING,
   TIMERONOFF,
   PASSWORD,
   PROGRAMONOFF,
   PROGRAMEDITACT,
   PROGRAMREPEAT,

   D_MENU,
   SLEW,
   CAL,
   MENUSYS1,
   MENUSYSCOMM,
   MENUCONF1,
   MENUPVS, // ON OFF
   MENUPVSCURVE,
   MENUPVSEDIT,
   MENUPVSEDITRECORD1,
   MENUPVSEDITRECORD2,
   MENUPVSEDITRECORD3,
   MENUPVSEDITRECORD4,

   MENUPVSCTRLMOD,

   MENUCONFLIMIT,
   MENUCONFPROT,
   MENUCONFEXT,
   MENUCONFPARALLEL,
   MENUCONFCHAIN,
   MENUSYSCOMLAN,
   MEMUSYSCOMRS485,
   MEMUSYSCOMRS232,
   SELFTEST3,

   MENUSYSPON,
   SLEWVOLTAGE,
   SLEWCURRENT,
   TESTEEPROM,
   TESTEXTCTRL,
   TESTEXTVOLT,
   TESTEXTCURR,
   TESTUART1,
   TESTUART2,
   TESTEXTVCC,
   TESTEXTICC,
   CALVOLTAGE,
   CALCURRENT,
   CALOVP,
   CALOCP,
   EXTCALVOLTAGE,
   EXTCALCURRENT,
   EXTCALRESVOLTAGE,
   EXTCALRESCURRENT,
   RFACTORY,


   MENUSYSCOMMGPIBADDR,
   MENUSYSCOMMLANIPMODE,
   MENUSYSCOMM485BAUD,
   MENUSYSCOMM485PDATA,
   MENUSYSCOMM485STOP,

   MENUSYSCOMM232BAUD,
   MENUSYSCOMM232PDATA,
   MENUSYSCOMM232STOP,

   MENUSYSMEMG,
   MENUSYSBEEP,
   MENUSYSDEFAULT,
   MENUSYSPONMODE,


   MENUINFOMODEL,
   MENUINFOFWVER,
   MENUINFOOPT,
   MENUINFOIPMODE,
   MENUINFOIPADDR,
   MENUINFOMASK,
   MENUINFOGWAY,
   MENUINFOBAUD,

   MENUCONFLIMITVMIN,
   MENUCONFLIMITVMAX,
   MENUCONFLIMITIMIN,
   MENUCONFLIMITIMAX,
   MENUCONFLIMITPMIN,
   MENUCONFLIMITPMAX,
   MENUSYSPONUDEFV,
   MENUSYSPONUDEFI,
   MENUSYSPONUDEFONOFF,



   MENUCONFPROTOVP,
   MENUCONFPROTOCP,
   MENUCONFPROTOPP,
   MENUCONFPROTCVCC,
   MENUCONFPROTCCCV,

   MENUCONFEXTCV,
   MENUCONFEXTCI,
   MENUCONFEXTCPRANGE,
   MENUCONFEXTCMONRNG,
   MENUCONFEXTCSHUT,
   MENUCONFEXTCENABLE,

   MENUSYSCOMMLANIPADDR,
   MENUSYSCOMMLANMASK,
   MENUSYSCOMMLANGWAY,

   MENUCONFPARAMODE,
   MENUCONFPARAROLE,
   MENUCONFCHAINMODE,
   MENUCONFCHAINADDR,
   SELFTEST1,
   SELFTEST2,
   STARTDLE7,
   STARTDLE1,   
   STARTDLEG,
/*  
   */
   SET_METER_FLAG,
   SET_ONOFF_FLAG,
   CLR_LOCAL,
   SET_OFF_FLAG,
   numberOfStates

} state_id;

typedef struct _keytype
{    
    key_utility    keyFunction;
    trigger_id     keyEvent;
  
}KEY_TYPE;


extern KEY_TYPE  					keyParameter;
extern uint8_t keyCode;




static const state_id next_state23[numberOfStates * numberOfTriggers] = {

// KEY_OVP                  KEY_OPP               KEY_OCP                 KEY_VSET                  KEY_RECALL			    	KEY_ESC				   KEY_ISET			    		KEY_MENU                    KEY_OK           	        KEY_METER                   KEY_ONOFF			    KEY_SHIFT
 
   MENUCONFPROTOVP,         PROGRAMMODE,          MENUCONFPROTOCP,	      D_VSET,                    RECALL,                   D_ESC,                   D_ISET,                    D_MENU,                      D_OK,                   SET_METER_FLAG,                SET_ONOFF_FLAG,       	D_SHIFT,		    // D_NORMAL
   D_PARALLELSLAVE,         D_PARALLELSLAVE,      D_PARALLELSLAVE,	      D_PARALLELSLAVE,           D_PARALLELSLAVE,          D_PARALLELSLAVE,         D_PARALLELSLAVE,           D_MENU,          			D_PARALLELSLAVE,        D_PARALLELSLAVE,               D_PARALLELSLAVE,       	D_PARALLELSLAVE,    // D_PARALLELSLAVE
   MENUCONFPROTOVP,         PROGRAMMODE,          MENUCONFPROTOCP,        D_VSET,                    D_PARALLELMASTER,         D_ESC,                   D_ISET,                    D_MENU,			            D_OK,                   SET_METER_FLAG,                SET_ONOFF_FLAG,       	D_SHIFT,            // D_PARALLELMASTER

   D_SHIFT,					D_SHIFT,	          D_SHIFT,                SLEW,						 STORE,					   D_ESC,					TIMEREDIT,				   D_SHIFT,			            D_SHIFT,		        D_SHIFT,  	                   SET_ONOFF_FLAG,			D_NORMAL,		    // D_SHIFT
   D_OK,                    D_OK,                 D_OK,                   D_OK,                      D_OK,                     D_OK,                    D_OK,                      D_OK,                        D_OK,      	            D_OK,                          D_OK,                 	D_OK,				// D_OK
   D_VSET,				    D_VSET,               D_VSET,                 D_VSET,                    D_VSET,                   D_ESC,                   D_VSET,                    D_VSET,                      D_OK,		            SET_METER_FLAG,                SET_OFF_FLAG,	       	D_VSET,				// D_VSET
   D_ISET,                  D_ISET,               D_ISET,                 D_ISET,                    D_ISET,                   D_ESC,                   D_ISET,                    D_ISET,                      D_OK,                   SET_METER_FLAG,                SET_OFF_FLAG,	       	D_ISET,				// D_ISET 
   D_OVP,                   D_OVP,                D_OVP,                  D_OVP,                     D_OVP,                    D_ESC,                   D_OVP,                     D_OVP,                       D_OK,                   SET_METER_FLAG,			  	   D_OVP,			        D_OVP,				// D_OVP                                                        
   D_OCP,					D_OCP,                D_OCP,                  D_OCP,                     D_OCP,                    D_ESC,                   D_OCP,                     D_OCP,                       D_OK,                   SET_METER_FLAG,                D_OCP,			       	D_OCP,				// D_OCP                    
   D_OPP,					D_OPP,                D_OPP,                  D_OPP,                     D_OPP,                    D_ESC,                   D_OPP,                     D_OPP,                       D_OK,                   SET_METER_FLAG,			       D_OPP,			       	D_OPP,				// D_OPP
   D_ESC,					D_ESC,				  D_ESC,                  D_ESC,                     D_ESC,                    D_ESC,                   D_ESC,                     D_ESC,                       D_ESC,		            D_ESC,                         D_ESC,                	D_ESC,				// D_ESC
   RECALL,				    RECALL,				  RECALL,				  RECALL,					 RECALL,				   D_ESC,					RECALL,					   RECALL,						D_OK,		            RECALL,                        RECALL,           		RECALL,				// RECALL
   STORE,					STORE,				  STORE,				  STORE,					 STORE,				       D_ESC,					STORE,					   STORE,						D_OK,		            STORE,                         STORE,		           	STORE,				// STORE
   PROGRAMMODE,				PROGRAMMODE,		  PROGRAMMODE,			  PROGRAMMODE,				 PROGRAMMODE,			   D_ESC,					D_ISET,					   PROGRAMMODE,					D_OK,		            PROGRAMMODE,                   PROGRAMMODE,          	PROGRAMMODE,		// PROGRAMMODE,
   PROGRAMEDIT,				PROGRAMEDIT,		  PROGRAMEDIT,			  PROGRAMEDIT,				 PROGRAMEDIT,			   D_ESC,					PROGRAMEDIT,			   PROGRAMEDIT,					D_OK,					PROGRAMEDIT,				   PROGRAMEDIT,				PROGRAMEDIT,		// PROGRAMEDIT,
   PROGRAMREADY,			PROGRAMMODE,		  PROGRAMREADY,			  PROGRAMREADY,				 PROGRAMREADY,			   D_ESC,					PROGRAMREADY,			   PROGRAMREADY,				PROGRAMREADY,			SET_METER_FLAG,				   SET_ONOFF_FLAG,			D_SHIFT,			// PROGRAMREADY,
   PROGRAMRUNNING,			PROGRAMRUNNING,		  PROGRAMRUNNING,		  PROGRAMRUNNING,			 PROGRAMRUNNING,		   D_ESC,					PROGRAMRUNNING,			   PROGRAMRUNNING,				PROGRAMRUNNING,			SET_METER_FLAG,				   SET_ONOFF_FLAG,			PROGRAMRUNNING,		// PROGRAMRUNNING,
   TIMEREDIT,				TIMEREDIT,			  TIMEREDIT,			  TIMEREDIT,				 TIMEREDIT,				   D_ESC,					TIMEREDIT,				   TIMEREDIT,					D_OK,					TIMEREDIT,					   TIMEREDIT,				TIMEREDIT,			// TIMEREDIT,
   MENUCONFPROTOVP,			TIMERRUNNING,		  MENUCONFPROTOCP,		  TIMERRUNNING,				 TIMERRUNNING,			   D_ESC,					TIMERRUNNING,			   TIMERRUNNING,				TIMERRUNNING,			SET_METER_FLAG,				   SET_ONOFF_FLAG,			D_SHIFT,			// TIMERRUNNING,
   TIMERONOFF,				TIMERONOFF,			  TIMERONOFF,			  TIMERONOFF,				 TIMERONOFF,			   D_ESC,					TIMERONOFF,				   TIMERONOFF,					D_OK,					TIMERONOFF,					   TIMERONOFF,				TIMERONOFF,			// TIMERONOFF,
   PASSWORD,				PASSWORD,			  PASSWORD,				  PASSWORD,					 PASSWORD,				   D_ESC,					PASSWORD,				   PASSWORD,					D_OK,					PASSWORD,					   PASSWORD,				PASSWORD,			// PASSWORD,
   PROGRAMONOFF,			PROGRAMONOFF,		  PROGRAMONOFF,			  PROGRAMONOFF,				 PROGRAMONOFF,			   D_ESC,					PROGRAMONOFF,			   PROGRAMONOFF,				D_OK,					PROGRAMONOFF,				   PROGRAMONOFF,			PROGRAMONOFF,		// PROGRAMONOFF,
   PROGRAMEDITACT,			PROGRAMEDITACT,		  PROGRAMEDITACT,		  PROGRAMEDITACT,			 PROGRAMEDITACT,		   D_ESC,					PROGRAMEDITACT,			   PROGRAMEDITACT,				D_OK,					PROGRAMEDITACT,				   PROGRAMEDITACT,			PROGRAMEDITACT,		// PROGRAMEDITACT,
   PROGRAMREPEAT,			PROGRAMREPEAT,		  PROGRAMREPEAT,		  PROGRAMREPEAT,			 PROGRAMREPEAT,			   D_ESC,					PROGRAMREPEAT,			   PROGRAMREPEAT,				D_OK,					PROGRAMREPEAT,				   PROGRAMREPEAT,			PROGRAMREPEAT,		// PROGRAMREPEAT,

   D_MENU,                  D_MENU,               D_MENU,                 D_MENU,                    D_MENU,                   D_ESC,                   D_MENU,                    D_MENU,                      D_OK,                   D_MENU,                        D_MENU,               	D_MENU,				// D_MENU
   SLEW,					SLEW,				  SLEW,					  SLEW,						 SLEW,					   D_ESC,					SLEW,					   SLEW,						D_OK,		            SLEW,                          SET_OFF_FLAG,           	SLEW,				// SLEW
   CAL,					    CAL,				  CAL,				      CAL,					     CAL,					   D_ESC,					CAL,					   CAL,						    D_OK,					CAL,						   CAL,					    CAL,				// CAL
   MENUSYS1,                MENUSYS1,             MENUSYS1,               MENUSYS1,                  MENUSYS1,                 D_ESC,                   MENUSYS1,                  MENUSYS1,                    D_OK,                   MENUSYS1,                      MENUSYS1,             	MENUSYS1,			// MENUSYS1                                          
   MENUSYSCOMM,			    MENUSYSCOMM,		  MENUSYSCOMM,			  MENUSYSCOMM,				 MENUSYSCOMM,			   D_ESC,					MENUSYSCOMM,			   MENUSYSCOMM,					D_OK,		            MENUSYSCOMM,                   MENUSYSCOMM,          	MENUSYSCOMM,		// MENUSYSCOMM,
   MENUCONF1,				MENUCONF1,			  MENUCONF1,			  MENUCONF1,				 MENUCONF1,				   D_ESC,					MENUCONF1,				   MENUCONF1,					D_OK,		            MENUCONF1,                     MENUCONF1,            	MENUCONF1,			// MENUCONF1,
   MENUPVS,					MENUPVS,			  MENUPVS,				  MENUPVS,				     MENUPVS,				   D_ESC,					MENUPVS,				   MENUPVS,						D_OK,					MENUPVS,					   MENUPVS,					MENUPVS,			// MENUPVS,
   MENUPVSCURVE,			MENUPVSCURVE,		  MENUPVSCURVE,			  MENUPVSCURVE,				 MENUPVSCURVE,			   D_ESC,					MENUPVSCURVE,			   MENUPVSCURVE,				D_OK,					MENUPVSCURVE,				   MENUPVSCURVE,			MENUPVSCURVE,		// MENUPVSCURVE,
   MENUPVSEDIT,				MENUPVSEDIT,		  MENUPVSEDIT,			  MENUPVSEDIT,				 MENUPVSEDIT,			   D_ESC,					MENUPVSEDIT,			   MENUPVSEDIT,					D_OK,					MENUPVSEDIT,				   MENUPVSEDIT,				MENUPVSEDIT,		// MENUPVSEDIT,
   MENUPVSEDITRECORD1,		MENUPVSEDITRECORD1,	  MENUPVSEDITRECORD1,	  MENUPVSEDITRECORD1,		 MENUPVSEDITRECORD1,	   D_ESC,					MENUPVSEDITRECORD1,		   MENUPVSEDITRECORD1,			D_OK,					MENUPVSEDITRECORD1,			   MENUPVSEDITRECORD1,		MENUPVSEDITRECORD1, // MENUPVSEDITRECORD1,
   MENUPVSEDITRECORD2,		MENUPVSEDITRECORD2,	  MENUPVSEDITRECORD2,	  MENUPVSEDITRECORD2,		 MENUPVSEDITRECORD2,	   D_ESC,					MENUPVSEDITRECORD2,		   MENUPVSEDITRECORD2,			D_OK,					MENUPVSEDITRECORD2,			   MENUPVSEDITRECORD2,		MENUPVSEDITRECORD2, // MENUPVSEDITRECORD2,
   MENUPVSEDITRECORD3,		MENUPVSEDITRECORD3,	  MENUPVSEDITRECORD3,	  MENUPVSEDITRECORD3,		 MENUPVSEDITRECORD3,	   D_ESC,					MENUPVSEDITRECORD3,		   MENUPVSEDITRECORD3,			D_OK,					MENUPVSEDITRECORD3,			   MENUPVSEDITRECORD3,		MENUPVSEDITRECORD3, // MENUPVSEDITRECORD3,
   MENUPVSEDITRECORD4,		MENUPVSEDITRECORD4,	  MENUPVSEDITRECORD4,	  MENUPVSEDITRECORD4,		 MENUPVSEDITRECORD4,	   D_ESC,					MENUPVSEDITRECORD4,		   MENUPVSEDITRECORD4,			D_OK,					MENUPVSEDITRECORD4,			   MENUPVSEDITRECORD4,		MENUPVSEDITRECORD4, // MENUPVSEDITRECORD4,
  
   MENUPVSCTRLMOD,			MENUPVSCTRLMOD,		  MENUPVSCTRLMOD,		  MENUPVSCTRLMOD,		     MENUPVSCTRLMOD,		   D_ESC,					MENUPVSCTRLMOD,			   MENUPVSCTRLMOD,				D_OK,					MENUPVSCTRLMOD,				   MENUPVSCTRLMOD,			MENUPVSCTRLMOD,		// MENUPVSCTRLMOD,
   
   MENUCONFLIMIT,			MENUCONFLIMIT,		  MENUCONFLIMIT,		  MENUCONFLIMIT,			 MENUCONFLIMIT,			   D_ESC,					MENUCONFLIMIT,			   MENUCONFLIMIT,				D_OK,					MENUCONFLIMIT,				   MENUCONFLIMIT,		 	MENUCONFLIMIT,		// MENUCONFLIMIT,
   MENUCONFPROT,			MENUCONFPROT,		  MENUCONFPROT,			  MENUCONFPROT,				 MENUCONFPROT,			   D_ESC,					MENUCONFPROT,			   MENUCONFPROT,				D_OK,					MENUCONFPROT,				   MENUCONFPROT,		 	MENUCONFPROT,		// MENUCONFPROT,
   MENUCONFEXT,				MENUCONFEXT,		  MENUCONFEXT,			  MENUCONFEXT,				 MENUCONFEXT,			   D_ESC,					MENUCONFEXT,			   MENUCONFEXT,					D_OK,					MENUCONFEXT,				   MENUCONFEXT,			 	MENUCONFEXT,		// MENUCONFEXT,
   MENUCONFPARALLEL,		MENUCONFPARALLEL,	  MENUCONFPARALLEL,		  MENUCONFPARALLEL,			 MENUCONFPARALLEL,		   D_ESC,					MENUCONFPARALLEL,		   MENUCONFPARALLEL,			D_OK,					MENUCONFPARALLEL,			   MENUCONFPARALLEL,	 	MENUCONFPARALLEL,	// MENUCONFPARALLEL,
   MENUCONFCHAIN,			MENUCONFCHAIN,		  MENUCONFCHAIN,		  MENUCONFCHAIN,			 MENUCONFCHAIN,			   D_ESC,					MENUCONFCHAIN,			   MENUCONFCHAIN,				D_OK,					MENUCONFCHAIN,				   MENUCONFCHAIN,		 	MENUCONFCHAIN,		// MENUCONFCHAIN,
   MENUSYSCOMLAN,			MENUSYSCOMLAN,		  MENUSYSCOMLAN,		  MENUSYSCOMLAN,			 MENUSYSCOMLAN,			   D_ESC,					MENUSYSCOMLAN,			   MENUSYSCOMLAN,				D_OK,					MENUSYSCOMLAN,				   MENUSYSCOMLAN,		 	MENUSYSCOMLAN,		// MENUSYSCOMLAN,
   MEMUSYSCOMRS485,			MEMUSYSCOMRS485,	  MEMUSYSCOMRS485,		  MEMUSYSCOMRS485,			 MEMUSYSCOMRS485,		   D_ESC,					MEMUSYSCOMRS485,		   MEMUSYSCOMRS485,				D_OK,					MEMUSYSCOMRS485,			   MEMUSYSCOMRS485,			MEMUSYSCOMRS485,	// MEMUSYSCOMRS485,
   MEMUSYSCOMRS232,			MEMUSYSCOMRS232,	  MEMUSYSCOMRS232,		  MEMUSYSCOMRS232,			 MEMUSYSCOMRS232,		   D_ESC,					MEMUSYSCOMRS232,		   MEMUSYSCOMRS232,				D_OK,					MEMUSYSCOMRS232,			   MEMUSYSCOMRS232,			MEMUSYSCOMRS232,	// MEMUSYSCOMRS232,
   SELFTEST3,				SELFTEST3,			  SELFTEST3,			  SELFTEST3,				 SELFTEST3,				   SELFTEST3,				SELFTEST3,				   SELFTEST3,					D_OK,					SELFTEST3,					   SELFTEST3,				SELFTEST3,			// SELFTEST3



   MENUSYSPON,				MENUSYSPON,			  MENUSYSPON,			  MENUSYSPON,				 MENUSYSPON,			   D_ESC,					MENUSYSPON,				   MENUSYSPON,					D_OK,					MENUSYSPON,					   MENUSYSPON,			 	MENUSYSPON,			// MENUSYSPON,
   SLEWVOLTAGE,				SLEWVOLTAGE,		  SLEWVOLTAGE,			  SLEWVOLTAGE,				 SLEWVOLTAGE,			   D_ESC,					SLEWVOLTAGE,			   SLEWVOLTAGE,					D_OK,					SLEWVOLTAGE,				   SLEWVOLTAGE, 			SLEWVOLTAGE,		// SLEWVOLTAGE,
   SLEWCURRENT,				SLEWCURRENT,		  SLEWCURRENT,			  SLEWCURRENT,				 SLEWCURRENT,			   D_ESC,					SLEWCURRENT,			   SLEWCURRENT,					D_OK,					SLEWCURRENT,				   SLEWCURRENT,				SLEWCURRENT,		// SLEWCURRENT,
   TESTEEPROM,				TESTEEPROM,			  TESTEEPROM,			  TESTEEPROM,				 TESTEEPROM,			   D_ESC,					TESTEEPROM,				   TESTEEPROM,					TESTEEPROM,				TESTEEPROM,					   TESTEEPROM,				TESTEEPROM,			// TESTEEPROM,
   TESTEXTCTRL,				TESTEXTCTRL,		  TESTEXTCTRL,			  TESTEXTCTRL,				 TESTEXTCTRL,			   D_ESC,					TESTEXTCTRL,			   TESTEXTCTRL,					TESTEXTCTRL,			TESTEXTCTRL,				   TESTEXTCTRL,				TESTEXTCTRL,		// TESTEXTCTRL,
   TESTEXTVOLT,				TESTEXTVOLT,		  TESTEXTVOLT,			  TESTEXTVOLT,				 TESTEXTVOLT,			   D_ESC,					TESTEXTVOLT,			   TESTEXTVOLT,					D_OK,					TESTEXTVOLT,				   TESTEXTVOLT,				TESTEXTVOLT,		// TESTEXTVOLT,
   TESTEXTCURR,				TESTEXTCURR,		  TESTEXTCURR,			  TESTEXTCURR,				 TESTEXTCURR,			   D_ESC,					TESTEXTCURR,			   TESTEXTCURR,					D_OK,					TESTEXTCURR,				   TESTEXTCURR,				TESTEXTCURR,		// TESTEXTCURR,
   TESTUART1,				TESTUART1,			  TESTUART1,			  TESTUART1,				 TESTUART1,				   D_ESC,					TESTUART1,				   TESTUART1,					TESTUART1,				TESTUART1,					   TESTUART1,			    TESTUART1,			// TESTUART1,
   TESTUART2,				TESTUART2,			  TESTUART2,			  TESTUART2,				 TESTUART2,				   D_ESC,					TESTUART2,				   TESTUART2,					TESTUART2,				TESTUART2,					   TESTUART2,			    TESTUART2,			// TESTUART2,
   TESTEXTVCC,				TESTEXTVCC,			  TESTEXTVCC,			  TESTEXTVCC,				 TESTEXTVCC,			   D_ESC,					TESTEXTVCC,				   TESTEXTVCC,					D_OK,					TESTEXTVCC,					   TESTEXTVCC,				TESTEXTVCC,			// TESTEXTVCC,
   TESTEXTICC,				TESTEXTICC,			  TESTEXTICC,			  TESTEXTICC,				 TESTEXTICC,			   D_ESC,					TESTEXTICC,				   TESTEXTICC,					D_OK,					TESTEXTICC,					   TESTEXTICC,				TESTEXTICC,			// TESTEXTICC,
  
  
   CALVOLTAGE,				CALVOLTAGE,			  CALVOLTAGE,			  CALVOLTAGE,				 CALVOLTAGE,			   D_ESC,					CALVOLTAGE,				   CALVOLTAGE,					D_OK,					CALVOLTAGE,					   CALVOLTAGE,				CALVOLTAGE,			// CALVOLTAGE,
   CALCURRENT,				CALCURRENT,			  CALCURRENT,			  CALCURRENT,				 CALCURRENT,			   D_ESC,					CALCURRENT,				   CALCURRENT,					D_OK,					CALCURRENT,					   CALCURRENT,				CALCURRENT,			// CALCURRENT,
   CALOVP,					CALOVP,	    		  CALOVP,	   			  CALOVP,	   				 CALOVP,	   			   D_ESC,					CALOVP,	   				   CALOVP,	   					D_OK,					CALOVP,	   					   CALOVP,	   				CALOVP,	   			// CALOVP,	   
   CALOCP,	   				CALOCP,	  			  CALOCP,	  			  CALOCP,	  				 CALOCP,	  			   D_ESC,					CALOCP,	  				   CALOCP,	  					D_OK,					CALOCP,	  					   CALOCP,	  				CALOCP,	  			// CALOCP,	  
   EXTCALVOLTAGE,			EXTCALVOLTAGE,		  EXTCALVOLTAGE,		  EXTCALVOLTAGE,			 EXTCALVOLTAGE,			   D_ESC,					EXTCALVOLTAGE,			   EXTCALVOLTAGE,				D_OK,					EXTCALVOLTAGE,				   EXTCALVOLTAGE,			EXTCALVOLTAGE,		// EXTCALVOLTAGE,
   EXTCALCURRENT,			EXTCALCURRENT,		  EXTCALCURRENT,		  EXTCALCURRENT,			 EXTCALCURRENT,			   D_ESC,					EXTCALCURRENT,			   EXTCALCURRENT,				D_OK,					EXTCALCURRENT,				   EXTCALCURRENT,			EXTCALCURRENT,		// EXTCALCURRENT,
   EXTCALRESVOLTAGE,		EXTCALRESVOLTAGE,	  EXTCALRESVOLTAGE,		  EXTCALRESVOLTAGE,			 EXTCALRESVOLTAGE,		   D_ESC,					EXTCALRESVOLTAGE,		   EXTCALRESVOLTAGE,			D_OK,					EXTCALRESVOLTAGE,			   EXTCALRESVOLTAGE,		EXTCALRESVOLTAGE,	// EXTCALRESVOLTAGE,
   EXTCALRESCURRENT,		EXTCALRESCURRENT,	  EXTCALRESCURRENT,		  EXTCALRESCURRENT,			 EXTCALRESCURRENT,		   D_ESC,					EXTCALRESCURRENT,		   EXTCALRESCURRENT,			D_OK,					EXTCALRESCURRENT,			   EXTCALRESCURRENT,		EXTCALRESCURRENT,	// EXTCALRESCURRENT,
   RFACTORY,				RFACTORY,			  RFACTORY,				  RFACTORY,					 RFACTORY,				   D_ESC,					RFACTORY,				   RFACTORY,					D_OK,					RFACTORY,					   RFACTORY,				RFACTORY,			// RFACTORY,


   MENUSYSCOMMGPIBADDR,		MENUSYSCOMMGPIBADDR,  MENUSYSCOMMGPIBADDR,	  MENUSYSCOMMGPIBADDR,		 MENUSYSCOMMGPIBADDR,	   D_ESC,					MENUSYSCOMMGPIBADDR,	   MENUSYSCOMMGPIBADDR,			D_OK,		            MENUSYSCOMMGPIBADDR,           MENUSYSCOMMGPIBADDR,  	MENUSYSCOMMGPIBADDR,// MENUSYSCOMMGPIBADDR,
   MENUSYSCOMMLANIPMODE,	MENUSYSCOMMLANIPMODE, MENUSYSCOMMLANIPMODE,	  MENUSYSCOMMLANIPMODE,		 MENUSYSCOMMLANIPMODE,	   D_ESC,					MENUSYSCOMMLANIPMODE,	   MENUSYSCOMMLANIPMODE,		D_OK,		            MENUSYSCOMMLANIPMODE,          MENUSYSCOMMLANIPMODE, 	MENUSYSCOMMLANIPMODE,// MENUSYSCOMMLANIPMODE,
   MENUSYSCOMM485BAUD,		MENUSYSCOMM485BAUD,	  MENUSYSCOMM485BAUD,	  MENUSYSCOMM485BAUD,		 MENUSYSCOMM485BAUD,	   D_ESC,					MENUSYSCOMM485BAUD,		   MENUSYSCOMM485BAUD,			D_OK,		            MENUSYSCOMM485BAUD,            MENUSYSCOMM485BAUD,   	MENUSYSCOMM485BAUD,	// MENUSYSCOMM485BAUD,
   MENUSYSCOMM485PDATA,		MENUSYSCOMM485PDATA,  MENUSYSCOMM485PDATA,	  MENUSYSCOMM485PDATA,		 MENUSYSCOMM485PDATA,	   D_ESC,					MENUSYSCOMM485PDATA,	   MENUSYSCOMM485PDATA,			D_OK,					MENUSYSCOMM485PDATA,		   MENUSYSCOMM485PDATA,		MENUSYSCOMM485PDATA,// MENUSYSCOMM485PDATA
   MENUSYSCOMM485STOP,		MENUSYSCOMM485STOP,	  MENUSYSCOMM485STOP,	  MENUSYSCOMM485STOP,		 MENUSYSCOMM485STOP,	   D_ESC,					MENUSYSCOMM485STOP,		   MENUSYSCOMM485STOP,			D_OK,					MENUSYSCOMM485STOP,			   MENUSYSCOMM485STOP,		MENUSYSCOMM485STOP, // MENUSYSCOMM485STOP,
   
   MENUSYSCOMM232BAUD,		MENUSYSCOMM232BAUD,	  MENUSYSCOMM232BAUD,	  MENUSYSCOMM232BAUD,		 MENUSYSCOMM232BAUD,	   D_ESC,					MENUSYSCOMM232BAUD,		   MENUSYSCOMM232BAUD,			D_OK,		            MENUSYSCOMM232BAUD,            MENUSYSCOMM232BAUD,   	MENUSYSCOMM232BAUD,	// MENUSYSCOMM232BAUD,
   MENUSYSCOMM232PDATA,		MENUSYSCOMM232PDATA,  MENUSYSCOMM232PDATA,	  MENUSYSCOMM232PDATA,		 MENUSYSCOMM232PDATA,	   D_ESC,					MENUSYSCOMM232PDATA,	   MENUSYSCOMM232PDATA,			D_OK,					MENUSYSCOMM232PDATA,		   MENUSYSCOMM232PDATA,		MENUSYSCOMM232PDATA,// MENUSYSCOMM232PDATA
   MENUSYSCOMM232STOP,		MENUSYSCOMM232STOP,	  MENUSYSCOMM232STOP,	  MENUSYSCOMM232STOP,		 MENUSYSCOMM232STOP,	   D_ESC,					MENUSYSCOMM232STOP,		   MENUSYSCOMM232STOP,			D_OK,					MENUSYSCOMM232STOP,			   MENUSYSCOMM232STOP,		MENUSYSCOMM232STOP, // MENUSYSCOMM232STOP,
   
   MENUSYSMEMG,				MENUSYSMEMG,		  MENUSYSMEMG,			  MENUSYSMEMG,				 MENUSYSMEMG,			   D_ESC,					MENUSYSMEMG,			   MENUSYSMEMG,					D_OK,		            MENUSYSMEMG,                   MENUSYSMEMG,          	MENUSYSMEMG,		// MENUSYSMEMG,
   MENUSYSBEEP,				MENUSYSBEEP,		  MENUSYSBEEP,			  MENUSYSBEEP,				 MENUSYSBEEP,			   D_ESC,					MENUSYSBEEP,			   MENUSYSBEEP,				    D_OK,		            MENUSYSBEEP,                   MENUSYSBEEP,          	MENUSYSBEEP,		// MENUSYSBEEP,
   MENUSYSDEFAULT,			MENUSYSDEFAULT,		  MENUSYSDEFAULT,		  MENUSYSDEFAULT,			 MENUSYSDEFAULT,		   D_ESC,					MENUSYSDEFAULT,			   MENUSYSDEFAULT,				D_OK,		            MENUSYSDEFAULT,                MENUSYSDEFAULT,       	MENUSYSDEFAULT,		// MENUSYSDEFAULT,
   MENUSYSPONMODE,			MENUSYSPONMODE,		  MENUSYSPONMODE,		  MENUSYSPONMODE,			 MENUSYSPONMODE,		   D_ESC,					MENUSYSPONMODE,			   MENUSYSPONMODE,				D_OK,		            MENUSYSPONMODE,                MENUSYSPONMODE,       	MENUSYSPONMODE,		// MENUSYSPONMODE,

   
   MENUINFOMODEL,			MENUINFOMODEL,		  MENUINFOMODEL,		  MENUINFOMODEL,			 MENUINFOMODEL,			   D_ESC,					MENUINFOMODEL,			   MENUINFOMODEL,				MENUINFOMODEL,          MENUINFOMODEL,                 MENUINFOMODEL,        	MENUINFOMODEL,		// MENUINFOMODEL,
   MENUINFOFWVER,			MENUINFOFWVER,		  MENUINFOFWVER,		  MENUINFOFWVER,			 MENUINFOFWVER,            D_ESC,					MENUINFOFWVER,			   MENUINFOFWVER,				MENUINFOFWVER,			MENUINFOFWVER,				   MENUINFOFWVER,		 	MENUINFOFWVER,		// MENUINFOFWVER,
   MENUINFOOPT,				MENUINFOOPT,		  MENUINFOOPT,			  MENUINFOOPT,				 MENUINFOOPT,			   D_ESC,					MENUINFOOPT,			   MENUINFOOPT,					MENUINFOOPT,			MENUINFOOPT,				   MENUINFOOPT,			 	MENUINFOOPT,		// MENUINFOOPT,
   MENUINFOIPMODE,			MENUINFOIPMODE,		  MENUINFOIPMODE,		  MENUINFOIPMODE,			 MENUINFOIPMODE,		   D_ESC,					MENUINFOIPMODE,			   MENUINFOIPMODE,				MENUINFOIPMODE,			MENUINFOIPMODE,				   MENUINFOIPMODE,		 	MENUINFOIPMODE,		// MENUINFOIPMODE,
   MENUINFOIPADDR,			MENUINFOIPADDR,		  MENUINFOIPADDR,		  MENUINFOIPADDR,			 MENUINFOIPADDR,		   D_ESC,					MENUINFOIPADDR,			   MENUINFOIPADDR,				MENUINFOIPADDR,			MENUINFOIPADDR,				   MENUINFOIPADDR,		 	MENUINFOIPADDR,		// MENUINFOIPADDR,
   MENUINFOMASK,			MENUINFOMASK,		  MENUINFOMASK,			  MENUINFOMASK,				 MENUINFOMASK,			   D_ESC,					MENUINFOMASK,			   MENUINFOMASK,				MENUINFOMASK,			MENUINFOMASK,				   MENUINFOMASK,		 	MENUINFOMASK,		// MENUINFOMASK,
   MENUINFOGWAY,			MENUINFOGWAY,		  MENUINFOGWAY,			  MENUINFOGWAY,				 MENUINFOGWAY,			   D_ESC,					MENUINFOGWAY,			   MENUINFOGWAY,				MENUINFOGWAY,			MENUINFOGWAY,				   MENUINFOGWAY,		 	MENUINFOGWAY,		// MENUINFOGWAY,
   MENUINFOBAUD,			MENUINFOBAUD,		  MENUINFOBAUD,			  MENUINFOBAUD,				 MENUINFOBAUD,			   D_ESC,					MENUINFOBAUD,			   MENUINFOBAUD,				MENUINFOBAUD,			MENUINFOBAUD,				   MENUINFOBAUD,		 	MENUINFOBAUD,		// MENUINFOBAUD,



   MENUCONFLIMITVMIN,		MENUCONFLIMITVMIN,	  MENUCONFLIMITVMIN,	  MENUCONFLIMITVMIN,		 MENUCONFLIMITVMIN,		   D_ESC,					MENUCONFLIMITVMIN,		   MENUCONFLIMITVMIN,			D_OK,					MENUCONFLIMITVMIN,			   MENUCONFLIMITVMIN,	 	MENUCONFLIMITVMIN,	// MENUCONFLIMITVMIN,
   MENUCONFLIMITVMAX,	    MENUCONFLIMITVMAX,	  MENUCONFLIMITVMAX,	  MENUCONFLIMITVMAX,		 MENUCONFLIMITVMAX,        D_ESC,					MENUCONFLIMITVMAX,		   MENUCONFLIMITVMAX,		    D_OK,					MENUCONFLIMITVMAX,			   MENUCONFLIMITVMAX,    	MENUCONFLIMITVMAX,	// MENUCONFLIMITVMAX,
   MENUCONFLIMITIMIN,		MENUCONFLIMITIMIN,	  MENUCONFLIMITIMIN,	  MENUCONFLIMITIMIN,		 MENUCONFLIMITIMIN,		   D_ESC,					MENUCONFLIMITIMIN,		   MENUCONFLIMITIMIN,			D_OK,					MENUCONFLIMITIMIN,			   MENUCONFLIMITIMIN,    	MENUCONFLIMITIMIN,	// MENUCONFLIMITIMIN,
   MENUCONFLIMITIMAX,		MENUCONFLIMITIMAX,	  MENUCONFLIMITIMAX,	  MENUCONFLIMITIMAX,		 MENUCONFLIMITIMAX,		   D_ESC,					MENUCONFLIMITIMAX,		   MENUCONFLIMITIMAX,			D_OK,					MENUCONFLIMITIMAX,			   MENUCONFLIMITIMAX,    	MENUCONFLIMITIMAX,	// MENUCONFLIMITIMAX,
   MENUCONFLIMITPMIN,		MENUCONFLIMITPMIN,	  MENUCONFLIMITPMIN,	  MENUCONFLIMITPMIN,		 MENUCONFLIMITPMIN,		   D_ESC,					MENUCONFLIMITPMIN,		   MENUCONFLIMITPMIN,			D_OK,					MENUCONFLIMITPMIN,			   MENUCONFLIMITPMIN,    	MENUCONFLIMITPMIN,	// MENUCONFLIMITPMIN,
   MENUCONFLIMITPMAX,		MENUCONFLIMITPMAX,	  MENUCONFLIMITPMAX,	  MENUCONFLIMITPMAX,		 MENUCONFLIMITPMAX,		   D_ESC,					MENUCONFLIMITPMAX,		   MENUCONFLIMITPMAX,			D_OK,					MENUCONFLIMITPMAX,			   MENUCONFLIMITPMAX,    	MENUCONFLIMITPMAX,	// MENUCONFLIMITPMAX,
   MENUSYSPONUDEFV,			MENUSYSPONUDEFV,	  MENUSYSPONUDEFV,		  MENUSYSPONUDEFV,			 MENUSYSPONUDEFV,		   D_ESC,					MENUSYSPONUDEFV,		   MENUSYSPONUDEFV,				D_OK,					MENUSYSPONUDEFV,			   MENUSYSPONUDEFV,		 	MENUSYSPONUDEFV,	// MENUSYSPONUDEFV,
   MENUSYSPONUDEFI,			MENUSYSPONUDEFI,	  MENUSYSPONUDEFI,		  MENUSYSPONUDEFI,			 MENUSYSPONUDEFI,		   D_ESC,					MENUSYSPONUDEFI,		   MENUSYSPONUDEFI,				D_OK,					MENUSYSPONUDEFI,			   MENUSYSPONUDEFI,		 	MENUSYSPONUDEFI,	// MENUSYSPONUDEFI,
   MENUSYSPONUDEFONOFF,		MENUSYSPONUDEFONOFF,  MENUSYSPONUDEFONOFF,	  MENUSYSPONUDEFONOFF,		 MENUSYSPONUDEFONOFF,	   D_ESC,					MENUSYSPONUDEFONOFF,	   MENUSYSPONUDEFONOFF,			D_OK,					MENUSYSPONUDEFONOFF,		   MENUSYSPONUDEFONOFF,		MENUSYSPONUDEFONOFF,// MENUSYSPONUDEFONOFF,

   MENUCONFPROTOVP,			MENUCONFPROTOVP,	  MENUCONFPROTOVP,		  MENUCONFPROTOVP,			 MENUCONFPROTOVP,		   D_ESC,					MENUCONFPROTOVP,		   MENUCONFPROTOVP,				D_OK,					SET_METER_FLAG,				   MENUCONFPROTOVP,      	MENUCONFPROTOVP,	// MENUCONFPROTOVP,
   MENUCONFPROTOCP,			MENUCONFPROTOCP,	  MENUCONFPROTOCP,		  MENUCONFPROTOCP,			 MENUCONFPROTOCP,		   D_ESC,					MENUCONFPROTOCP,		   MENUCONFPROTOCP,				D_OK,					SET_METER_FLAG,				   MENUCONFPROTOCP,      	MENUCONFPROTOCP,	// MENUCONFPROTOCP,
   MENUCONFPROTOPP,			MENUCONFPROTOPP,	  MENUCONFPROTOPP,		  MENUCONFPROTOPP,			 MENUCONFPROTOPP,		   D_ESC,					MENUCONFPROTOPP,		   MENUCONFPROTOPP,				D_OK,					SET_METER_FLAG,	 			   MENUCONFPROTOPP,      	MENUCONFPROTOPP,	// MENUCONFPROTOPP,
   MENUCONFPROTCVCC,		MENUCONFPROTCVCC,	  MENUCONFPROTCVCC,		  MENUCONFPROTCVCC,			 MENUCONFPROTCVCC,		   D_ESC,					MENUCONFPROTCVCC,		   MENUCONFPROTCVCC,			D_OK,					MENUCONFPROTCVCC,			   MENUCONFPROTCVCC,     	MENUCONFPROTCVCC,	// MENUCONFPROTCVCC,
   MENUCONFPROTCCCV,		MENUCONFPROTCCCV,	  MENUCONFPROTCCCV,		  MENUCONFPROTCCCV,			 MENUCONFPROTCCCV,		   D_ESC,					MENUCONFPROTCCCV,		   MENUCONFPROTCCCV,			D_OK,					MENUCONFPROTCCCV,			   MENUCONFPROTCCCV,     	MENUCONFPROTCCCV,	// MENUCONFPROTCCCV,

   MENUCONFEXTCV,			MENUCONFEXTCV,   	  MENUCONFEXTCV,		  MENUCONFEXTCV,			 MENUCONFEXTCV, 		   D_ESC,					MENUCONFEXTCV,  		   MENUCONFEXTCV,				D_OK,					MENUCONFEXTCV,  			   MENUCONFEXTCV,        	MENUCONFEXTCV,		// MENUCONFEXTCV,
   MENUCONFEXTCI,			MENUCONFEXTCI,		  MENUCONFEXTCI,		  MENUCONFEXTCI,			 MENUCONFEXTCI,			   D_ESC,					MENUCONFEXTCI,			   MENUCONFEXTCI,				D_OK,					MENUCONFEXTCI,				   MENUCONFEXTCI,        	MENUCONFEXTCI,		// MENUCONFEXTCI,
   MENUCONFEXTCPRANGE,		MENUCONFEXTCPRANGE,	  MENUCONFEXTCPRANGE,	  MENUCONFEXTCPRANGE,		 MENUCONFEXTCPRANGE,	   D_ESC,					MENUCONFEXTCPRANGE,		   MENUCONFEXTCPRANGE,			D_OK,					MENUCONFEXTCPRANGE,			   MENUCONFEXTCPRANGE,   	MENUCONFEXTCPRANGE,	// MENUCONFEXTCPRANGE,
   MENUCONFEXTCMONRNG,		MENUCONFEXTCMONRNG,	  MENUCONFEXTCMONRNG,	  MENUCONFEXTCMONRNG,		 MENUCONFEXTCMONRNG,	   D_ESC,					MENUCONFEXTCMONRNG,		   MENUCONFEXTCMONRNG,			D_OK,					MENUCONFEXTCMONRNG,			   MENUCONFEXTCMONRNG,   	MENUCONFEXTCMONRNG, // MENUCONFEXTCMONRNG,
   MENUCONFEXTCSHUT,		MENUCONFEXTCSHUT,	  MENUCONFEXTCSHUT,		  MENUCONFEXTCSHUT,			 MENUCONFEXTCSHUT,		   D_ESC,					MENUCONFEXTCSHUT,		   MENUCONFEXTCSHUT,			D_OK,					MENUCONFEXTCSHUT,			   MENUCONFEXTCSHUT,      	MENUCONFEXTCSHUT,   // MENUCONFEXTCSHUT,
   MENUCONFEXTCENABLE,		MENUCONFEXTCENABLE,	  MENUCONFEXTCENABLE,	  MENUCONFEXTCENABLE,		 MENUCONFEXTCENABLE,	   D_ESC,					MENUCONFEXTCENABLE,		   MENUCONFEXTCENABLE,			D_OK,					MENUCONFEXTCENABLE,			   MENUCONFEXTCENABLE,   	MENUCONFEXTCENABLE,	// MENUCONFEXTCENABLE,

   MENUSYSCOMMLANIPADDR,	MENUSYSCOMMLANIPADDR, MENUSYSCOMMLANIPADDR,	  MENUSYSCOMMLANIPADDR,		 MENUSYSCOMMLANIPADDR,	   D_ESC,					MENUSYSCOMMLANIPADDR,	   MENUSYSCOMMLANIPADDR,		D_OK,					MENUSYSCOMMLANIPADDR,		   MENUSYSCOMMLANIPADDR, 	MENUSYSCOMMLANIPADDR,// MENUSYSCOMMLANIPADDR,
   MENUSYSCOMMLANMASK,		MENUSYSCOMMLANMASK,	  MENUSYSCOMMLANMASK,	  MENUSYSCOMMLANMASK,		 MENUSYSCOMMLANMASK,	   D_ESC,					MENUSYSCOMMLANMASK,		   MENUSYSCOMMLANMASK,			D_OK,					MENUSYSCOMMLANMASK,			   MENUSYSCOMMLANMASK,	 	MENUSYSCOMMLANMASK,	// MENUSYSCOMMLANMASK,
   MENUSYSCOMMLANGWAY,		MENUSYSCOMMLANGWAY,	  MENUSYSCOMMLANGWAY,	  MENUSYSCOMMLANGWAY,		 MENUSYSCOMMLANGWAY,	   D_ESC,					MENUSYSCOMMLANGWAY,		   MENUSYSCOMMLANGWAY,			D_OK,					MENUSYSCOMMLANGWAY,			   MENUSYSCOMMLANGWAY,	 	MENUSYSCOMMLANGWAY,	// MENUSYSCOMMLANGWAY,

   MENUCONFPARAMODE,		MENUCONFPARAMODE,	  MENUCONFPARAMODE,		  MENUCONFPARAMODE,			 MENUCONFPARAMODE,		   D_ESC,					MENUCONFPARAMODE,		   MENUCONFPARAMODE,			D_OK,					MENUCONFPARAMODE,			   MENUCONFPARAMODE,     	MENUCONFPARAMODE,	// MENUCONFPARAMODE,
   MENUCONFPARAROLE,		MENUCONFPARAROLE,	  MENUCONFPARAROLE,		  MENUCONFPARAROLE,			 MENUCONFPARAROLE,		   D_ESC,					MENUCONFPARAROLE,		   MENUCONFPARAROLE,			D_OK,					MENUCONFPARAROLE,			   MENUCONFPARAROLE,	 	MENUCONFPARAROLE,	// MENUCONFPARAROLE,

   MENUCONFCHAINMODE,		MENUCONFCHAINMODE,	  MENUCONFCHAINMODE,	  MENUCONFCHAINMODE,		 MENUCONFCHAINMODE,		   D_ESC,					MENUCONFCHAINMODE,		   MENUCONFCHAINMODE,			D_OK,					MENUCONFCHAINMODE,			   MENUCONFCHAINMODE,	 	MENUCONFCHAINMODE,	// MENUCONFCHAIN,
   MENUCONFCHAINADDR,		MENUCONFCHAINADDR,	  MENUCONFCHAINADDR,	  MENUCONFCHAINADDR,		 MENUCONFCHAINADDR,		   D_ESC,					MENUCONFCHAINADDR,		   MENUCONFCHAINADDR,           D_OK,					MENUCONFCHAINADDR,			   MENUCONFCHAINADDR,    	MENUCONFCHAINADDR,	// MENUCONFCHAINADDR,

   SELFTEST1,				SELFTEST1,			  SELFTEST1,			  SELFTEST1,				 SELFTEST1,				   SELFTEST1,				SELFTEST1,				   SELFTEST1,					SELFTEST2,				SELFTEST1,					   SELFTEST1,				SELFTEST1,			// SELFTEST1
   SELFTEST2,				SELFTEST2,			  SELFTEST2,			  SELFTEST2,				 SELFTEST2,				   SELFTEST2,				SELFTEST2,				   SELFTEST2,					SELFTEST2,				SELFTEST2,					   SELFTEST2,				SELFTEST2,			// SELFTEST2
   STARTDLE7,				STARTDLE7,			  STARTDLE7,			  STARTDLE7,				 STARTDLE7,				   STARTDLE7,				STARTDLE7,				   STARTDLE7,					STARTDLE7,				STARTDLE7,					   STARTDLE7,				STARTDLE7,			// STARTDLE7,
   STARTDLE1,   			STARTDLE1,			  STARTDLE1,			  STARTDLE1,				 STARTDLE1,				   STARTDLE1,				STARTDLE1,				   STARTDLE1,					STARTDLE1,				STARTDLE1,					   STARTDLE1,				STARTDLE1,			// STARTDLE1,
   STARTDLEG,   			STARTDLEG,			  STARTDLEG,			  STARTDLEG,				 STARTDLEG,				   STARTDLEG,				STARTDLEG,				   STARTDLEG,					STARTDLEG,				STARTDLEG,					   STARTDLEG,				STARTDLEG,			// STARTDLEG,

   SET_METER_FLAG,		    SET_METER_FLAG,       SET_METER_FLAG,         SET_METER_FLAG,			 SET_METER_FLAG,		   SET_METER_FLAG,          SET_METER_FLAG,			   SET_METER_FLAG,				SET_METER_FLAG,			SET_METER_FLAG,				   SET_METER_FLAG,		 	SET_METER_FLAG,		// SET_METER_FLAG
   SET_ONOFF_FLAG,		    SET_ONOFF_FLAG,		  SET_ONOFF_FLAG,		  SET_ONOFF_FLAG,			 SET_ONOFF_FLAG,		   SET_ONOFF_FLAG,			SET_ONOFF_FLAG,			   SET_ONOFF_FLAG,				SET_ONOFF_FLAG,			SET_ONOFF_FLAG,				   SET_ONOFF_FLAG,       	SET_ONOFF_FLAG,		// SET_ONOFF_FLAG
   CLR_LOCAL,				CLR_LOCAL,			  CLR_LOCAL,			  CLR_LOCAL,				 CLR_LOCAL,				   CLR_LOCAL,				CLR_LOCAL,				   CLR_LOCAL,					CLR_LOCAL,				CLR_LOCAL,					   CLR_LOCAL,				CLR_LOCAL,			// CLR_LOCAL,
   SET_OFF_FLAG,		    SET_OFF_FLAG,		  SET_OFF_FLAG,			  SET_OFF_FLAG,				 SET_OFF_FLAG,		 	   SET_OFF_FLAG,			SET_OFF_FLAG,			   SET_OFF_FLAG,				SET_OFF_FLAG,			SET_OFF_FLAG,				   SET_OFF_FLAG, 	      	SET_OFF_FLAG,		// SET_OFF_FLAG





};

static const state_id next_state29[numberOfStates * numberOfTriggers] = {

// KEY_OVP                  KEY_OPP               KEY_OCP                 KEY_VSET                  KEY_RECALL			    	KEY_ESC				   KEY_ISET			    		KEY_MENU                    KEY_OK           	        KEY_METER                   KEY_ONOFF			    KEY_SHIFT
 
   MENUCONFPROTOVP,         MENUCONFPROTOPP,      MENUCONFPROTOCP,        D_VSET,                    RECALL,                   D_ESC,                   D_ISET,                    D_MENU,                      D_OK,                   SET_METER_FLAG,                SET_ONOFF_FLAG,       	D_SHIFT,		    // D_NORMAL
   D_PARALLELSLAVE,         D_PARALLELSLAVE,      D_PARALLELSLAVE,	      D_PARALLELSLAVE,           D_PARALLELSLAVE,          D_PARALLELSLAVE,         D_PARALLELSLAVE,           D_MENU,          			D_PARALLELSLAVE,        SET_METER_FLAG,                D_PARALLELSLAVE,       	D_PARALLELSLAVE,    // D_PARALLELSLAVE
   MENUCONFPROTOVP,         PROGRAMMODE,          MENUCONFPROTOCP,        D_VSET,                    D_PARALLELMASTER,         D_ESC,                   D_ISET,                    D_MENU,			            D_OK,                   SET_METER_FLAG,                SET_ONOFF_FLAG,       	D_SHIFT,            // D_PARALLELMASTER

   D_SHIFT,					D_SHIFT,			  D_SHIFT,				  SLEW,						 STORE,					   D_ESC,					PROGRAMMODE,			   TIMEREDIT,					D_SHIFT,				CLR_LOCAL,					   SET_ONOFF_FLAG,			D_NORMAL,		    // D_SHIFT
   D_OK,                    D_OK,                 D_OK,                   D_OK,                      D_OK,                     D_OK,                    D_OK,                      D_OK,                        D_OK,      	            D_OK,                          D_OK,                 	D_OK,				// D_OK
   D_VSET,				    D_VSET,               D_VSET,                 D_VSET,                    D_VSET,                   D_ESC,                   D_VSET,                    D_VSET,                      D_OK,		            SET_METER_FLAG,                SET_OFF_FLAG,	       	D_VSET,				// D_VSET
   D_ISET,                  D_ISET,               D_ISET,                 D_ISET,                    D_ISET,                   D_ESC,                   D_ISET,                    D_ISET,                      D_OK,                   SET_METER_FLAG,                SET_OFF_FLAG,	       	D_ISET,				// D_ISET 
   D_OVP,                   D_OVP,                D_OVP,                  D_OVP,                     D_OVP,                    D_ESC,                   D_OVP,                     D_OVP,                       D_OK,                   SET_METER_FLAG,			  	   D_OVP,	  			    D_OVP,				// D_OVP                                                        
   D_OCP,					D_OCP,                D_OCP,                  D_OCP,                     D_OCP,                    D_ESC,                   D_OCP,                     D_OCP,                       D_OK,                   SET_METER_FLAG,                D_OCP,	 		      	D_OCP,				// D_OCP                    
   D_OPP,					D_OPP,                D_OPP,                  D_OPP,                     D_OPP,                    D_ESC,                   D_OPP,                     D_OPP,                       D_OK,                   SET_METER_FLAG,			       D_OPP,	   		    	D_OPP,				// D_OPP
   D_ESC,					D_ESC,				  D_ESC,                  D_ESC,                     D_ESC,                    D_ESC,                   D_ESC,                     D_ESC,                       D_ESC,		            D_ESC,                         D_ESC,                	D_ESC,				// D_ESC
   RECALL,				    RECALL,				  RECALL,				  RECALL,					 RECALL,				   D_ESC,					RECALL,					   RECALL,						D_OK,		            RECALL,                        RECALL,           		RECALL,				// RECALL
   STORE,					STORE,				  STORE,				  STORE,					 STORE,				       D_ESC,					STORE,					   STORE,						D_OK,		            STORE,                         STORE,		           	STORE,				// STORE
   PROGRAMMODE,				PROGRAMMODE,		  PROGRAMMODE,			  PROGRAMMODE,				 PROGRAMMODE,			   D_ESC,					D_ISET,					   PROGRAMMODE,					D_OK,		            PROGRAMMODE,                   PROGRAMMODE,          	PROGRAMMODE,		// PROGRAMMODE,
   PROGRAMEDIT,				PROGRAMEDIT,		  PROGRAMEDIT,			  PROGRAMEDIT,				 PROGRAMEDIT,			   D_ESC,					PROGRAMEDIT,			   PROGRAMEDIT,					D_OK,					PROGRAMEDIT,				   PROGRAMEDIT,				PROGRAMEDIT,		// PROGRAMEDIT,
   PROGRAMREADY,			PROGRAMREADY,		  PROGRAMREADY,			  PROGRAMREADY,				 PROGRAMREADY,			   D_ESC,					PROGRAMREADY,			   PROGRAMREADY,				PROGRAMREADY,			SET_METER_FLAG,				   SET_ONOFF_FLAG,			D_SHIFT,			// PROGRAMREADY,
   PROGRAMRUNNING,			PROGRAMRUNNING,		  PROGRAMRUNNING,		  PROGRAMRUNNING,			 PROGRAMRUNNING,		   D_ESC,					PROGRAMRUNNING,			   PROGRAMRUNNING,				PROGRAMRUNNING,			SET_METER_FLAG,				   SET_ONOFF_FLAG,			PROGRAMRUNNING,		// PROGRAMRUNNING,
   TIMEREDIT,				TIMEREDIT,			  TIMEREDIT,			  TIMEREDIT,				 TIMEREDIT,				   D_ESC,					TIMEREDIT,				   TIMEREDIT,					D_OK,					TIMEREDIT,					   TIMEREDIT,				TIMEREDIT,			// TIMEREDIT,
   MENUCONFPROTOVP,			MENUCONFPROTOPP,	  MENUCONFPROTOCP,		  TIMERRUNNING,				 TIMERRUNNING,			   D_ESC,					TIMERRUNNING,			   TIMERRUNNING,				TIMERRUNNING,			SET_METER_FLAG,				   SET_ONOFF_FLAG,			D_SHIFT,			// TIMERRUNNING,
   TIMERONOFF,				TIMERONOFF,			  TIMERONOFF,			  TIMERONOFF,				 TIMERONOFF,			   D_ESC,					TIMERONOFF,				   TIMERONOFF,					D_OK,					TIMERONOFF,					   TIMERONOFF,				TIMERONOFF,			// TIMERONOFF,
   PASSWORD,				PASSWORD,			  PASSWORD,				  PASSWORD,					 PASSWORD,				   D_ESC,					PASSWORD,				   PASSWORD,					D_OK,					PASSWORD,					   PASSWORD,				PASSWORD,			// PASSWORD,
   PROGRAMONOFF,			PROGRAMONOFF,		  PROGRAMONOFF,			  PROGRAMONOFF,				 PROGRAMONOFF,			   D_ESC,					PROGRAMONOFF,			   PROGRAMONOFF,				D_OK,					PROGRAMONOFF,				   PROGRAMONOFF,			PROGRAMONOFF,		// PROGRAMONOFF,
   PROGRAMEDITACT,			PROGRAMEDITACT,		  PROGRAMEDITACT,		  PROGRAMEDITACT,			 PROGRAMEDITACT,		   D_ESC,					PROGRAMEDITACT,			   PROGRAMEDITACT,				D_OK,					PROGRAMEDITACT,				   PROGRAMEDITACT,			PROGRAMEDITACT,		// PROGRAMEDITACT,
   PROGRAMREPEAT,			PROGRAMREPEAT,		  PROGRAMREPEAT,		  PROGRAMREPEAT,			 PROGRAMREPEAT,			   D_ESC,					PROGRAMREPEAT,			   PROGRAMREPEAT,				D_OK,					PROGRAMREPEAT,				   PROGRAMREPEAT,			PROGRAMREPEAT,		// PROGRAMREPEAT,


   D_MENU,                  D_MENU,               D_MENU,                 D_MENU,                    D_MENU,                   D_ESC,                   D_MENU,                    D_MENU,                      D_OK,                   D_MENU,                        D_MENU,               	D_MENU,				// D_MENU
   SLEW,					SLEW,				  SLEW,					  SLEW,						 SLEW,					   D_ESC,					SLEW,					   SLEW,						D_OK,		            SLEW,                          SET_OFF_FLAG,           	SLEW,				// SLEW
   CAL,					    CAL,				  CAL,				      CAL,					     CAL,					   D_ESC,					CAL,					   CAL,						    D_OK,					CAL,						   CAL,					    CAL,				// CAL
   MENUSYS1,                MENUSYS1,             MENUSYS1,               MENUSYS1,                  MENUSYS1,                 D_ESC,                   MENUSYS1,                  MENUSYS1,                    D_OK,                   MENUSYS1,                      MENUSYS1,             	MENUSYS1,			// MENUSYS1                                          
   MENUSYSCOMM,			    MENUSYSCOMM,		  MENUSYSCOMM,			  MENUSYSCOMM,				 MENUSYSCOMM,			   D_ESC,					MENUSYSCOMM,			   MENUSYSCOMM,					D_OK,		            MENUSYSCOMM,                   MENUSYSCOMM,          	MENUSYSCOMM,		// MENUSYSCOMM,

   
   MENUCONF1,				MENUCONF1,			  MENUCONF1,			  MENUCONF1,				 MENUCONF1,				   D_ESC,					MENUCONF1,				   MENUCONF1,					D_OK,		            MENUCONF1,                     MENUCONF1,            	MENUCONF1,			// MENUCONF1,
   MENUPVS,					MENUPVS,			  MENUPVS,				  MENUPVS,				     MENUPVS,				   D_ESC,					MENUPVS,				   MENUPVS,						D_OK,					MENUPVS,					   MENUPVS,					MENUPVS,			// MENUPVS,
   MENUPVSCURVE,			MENUPVSCURVE,		  MENUPVSCURVE,			  MENUPVSCURVE,				 MENUPVSCURVE,			   D_ESC,					MENUPVSCURVE,			   MENUPVSCURVE,				D_OK,					MENUPVSCURVE,				   MENUPVSCURVE,			MENUPVSCURVE,		// MENUPVSCURVE,
   MENUPVSEDIT,				MENUPVSEDIT,		  MENUPVSEDIT,			  MENUPVSEDIT,				 MENUPVSEDIT,			   D_ESC,					MENUPVSEDIT,			   MENUPVSEDIT,					D_OK,					MENUPVSEDIT,				   MENUPVSEDIT,				MENUPVSEDIT,		// MENUPVSEDIT,
   MENUPVSEDITRECORD1,		MENUPVSEDITRECORD1,	  MENUPVSEDITRECORD1,	  MENUPVSEDITRECORD1,		 MENUPVSEDITRECORD1,	   D_ESC,					MENUPVSEDITRECORD1,		   MENUPVSEDITRECORD1,			D_OK,					MENUPVSEDITRECORD1,			   MENUPVSEDITRECORD1,		MENUPVSEDITRECORD1, // MENUPVSEDITRECORD1,
   MENUPVSEDITRECORD2,		MENUPVSEDITRECORD2,	  MENUPVSEDITRECORD2,	  MENUPVSEDITRECORD2,		 MENUPVSEDITRECORD2,	   D_ESC,					MENUPVSEDITRECORD2,		   MENUPVSEDITRECORD2,			D_OK,					MENUPVSEDITRECORD2,			   MENUPVSEDITRECORD2,		MENUPVSEDITRECORD2, // MENUPVSEDITRECORD2,
   MENUPVSEDITRECORD3,		MENUPVSEDITRECORD3,	  MENUPVSEDITRECORD3,	  MENUPVSEDITRECORD3,		 MENUPVSEDITRECORD3,	   D_ESC,					MENUPVSEDITRECORD3,		   MENUPVSEDITRECORD3,			D_OK,					MENUPVSEDITRECORD3,			   MENUPVSEDITRECORD3,		MENUPVSEDITRECORD3, // MENUPVSEDITRECORD3,
   MENUPVSEDITRECORD4,		MENUPVSEDITRECORD4,	  MENUPVSEDITRECORD4,	  MENUPVSEDITRECORD4,		 MENUPVSEDITRECORD4,	   D_ESC,					MENUPVSEDITRECORD4,		   MENUPVSEDITRECORD4,			D_OK,					MENUPVSEDITRECORD4,			   MENUPVSEDITRECORD4,		MENUPVSEDITRECORD4, // MENUPVSEDITRECORD4,
   
   MENUPVSCTRLMOD,			MENUPVSCTRLMOD,		  MENUPVSCTRLMOD,		  MENUPVSCTRLMOD,		     MENUPVSCTRLMOD,		   D_ESC,					MENUPVSCTRLMOD,			   MENUPVSCTRLMOD,				D_OK,					MENUPVSCTRLMOD,				   MENUPVSCTRLMOD,			MENUPVSCTRLMOD,		// MENUPVSCTRLMOD,

   MENUCONFLIMIT,			MENUCONFLIMIT,		  MENUCONFLIMIT,		  MENUCONFLIMIT,			 MENUCONFLIMIT,			   D_ESC,					MENUCONFLIMIT,			   MENUCONFLIMIT,				D_OK,					MENUCONFLIMIT,				   MENUCONFLIMIT,		 	MENUCONFLIMIT,		// MENUCONFLIMIT,
   MENUCONFPROT,			MENUCONFPROT,		  MENUCONFPROT,			  MENUCONFPROT,				 MENUCONFPROT,			   D_ESC,					MENUCONFPROT,			   MENUCONFPROT,				D_OK,					MENUCONFPROT,				   MENUCONFPROT,		 	MENUCONFPROT,		// MENUCONFPROT,
   MENUCONFEXT,				MENUCONFEXT,		  MENUCONFEXT,			  MENUCONFEXT,				 MENUCONFEXT,			   D_ESC,					MENUCONFEXT,			   MENUCONFEXT,					D_OK,					MENUCONFEXT,				   MENUCONFEXT,			 	MENUCONFEXT,		// MENUCONFEXT,
   MENUCONFPARALLEL,		MENUCONFPARALLEL,	  MENUCONFPARALLEL,		  MENUCONFPARALLEL,			 MENUCONFPARALLEL,		   D_ESC,					MENUCONFPARALLEL,		   MENUCONFPARALLEL,			D_OK,					MENUCONFPARALLEL,			   MENUCONFPARALLEL,	 	MENUCONFPARALLEL,	// MENUCONFPARALLEL,
   MENUCONFCHAIN,			MENUCONFCHAIN,		  MENUCONFCHAIN,		  MENUCONFCHAIN,			 MENUCONFCHAIN,			   D_ESC,					MENUCONFCHAIN,			   MENUCONFCHAIN,				D_OK,					MENUCONFCHAIN,				   MENUCONFCHAIN,		 	MENUCONFCHAIN,		// MENUCONFCHAIN,
   MENUSYSCOMLAN,			MENUSYSCOMLAN,		  MENUSYSCOMLAN,		  MENUSYSCOMLAN,			 MENUSYSCOMLAN,			   D_ESC,					MENUSYSCOMLAN,			   MENUSYSCOMLAN,				D_OK,					MENUSYSCOMLAN,				   MENUSYSCOMLAN,		 	MENUSYSCOMLAN,		// MENUSYSCOMLAN,
   MEMUSYSCOMRS485,			MEMUSYSCOMRS485,	  MEMUSYSCOMRS485,		  MEMUSYSCOMRS485,			 MEMUSYSCOMRS485,		   D_ESC,					MEMUSYSCOMRS485,		   MEMUSYSCOMRS485,				D_OK,					MEMUSYSCOMRS485,			   MEMUSYSCOMRS485,			MEMUSYSCOMRS485,	// MEMUSYSCOMRS485,
   MEMUSYSCOMRS232,			MEMUSYSCOMRS232,	  MEMUSYSCOMRS232,		  MEMUSYSCOMRS232,			 MEMUSYSCOMRS232,		   D_ESC,					MEMUSYSCOMRS232,		   MEMUSYSCOMRS232,				D_OK,					MEMUSYSCOMRS232,			   MEMUSYSCOMRS232,			MEMUSYSCOMRS232,	// MEMUSYSCOMRS232,
   SELFTEST3,				SELFTEST3,			  SELFTEST3,			  SELFTEST3,				 SELFTEST3,				   SELFTEST3,				SELFTEST3,				   SELFTEST3,					D_OK,				SELFTEST3,					   SELFTEST3,				SELFTEST3,			// SELFTEST3



   MENUSYSPON,				MENUSYSPON,			  MENUSYSPON,			  MENUSYSPON,				 MENUSYSPON,			   D_ESC,					MENUSYSPON,				   MENUSYSPON,					D_OK,					MENUSYSPON,					   MENUSYSPON,			 	MENUSYSPON,			// MENUSYSPON,
   SLEWVOLTAGE,				SLEWVOLTAGE,		  SLEWVOLTAGE,			  SLEWVOLTAGE,				 SLEWVOLTAGE,			   D_ESC,					SLEWVOLTAGE,			   SLEWVOLTAGE,					D_OK,					SLEWVOLTAGE,				   SLEWVOLTAGE, 			SLEWVOLTAGE,		// SLEWVOLTAGE,
   SLEWCURRENT,				SLEWCURRENT,		  SLEWCURRENT,			  SLEWCURRENT,				 SLEWCURRENT,			   D_ESC,					SLEWCURRENT,			   SLEWCURRENT,					D_OK,					SLEWCURRENT,				   SLEWCURRENT,				SLEWCURRENT,		// SLEWCURRENT,
   TESTEEPROM,				TESTEEPROM,			  TESTEEPROM,			  TESTEEPROM,				 TESTEEPROM,			   D_ESC,					TESTEEPROM,				   TESTEEPROM,					TESTEEPROM,				TESTEEPROM,					   TESTEEPROM,				TESTEEPROM,			// TESTEEPROM,
   TESTEXTCTRL,				TESTEXTCTRL,		  TESTEXTCTRL,			  TESTEXTCTRL,				 TESTEXTCTRL,			   D_ESC,					TESTEXTCTRL,			   TESTEXTCTRL,					TESTEXTCTRL,			TESTEXTCTRL,				   TESTEXTCTRL,				TESTEXTCTRL,		// TESTEXTCTRL,
   TESTEXTVOLT,				TESTEXTVOLT,		  TESTEXTVOLT,			  TESTEXTVOLT,				 TESTEXTVOLT,			   D_ESC,					TESTEXTVOLT,			   TESTEXTVOLT,					D_OK,					TESTEXTVOLT,				   TESTEXTVOLT,				TESTEXTVOLT,		// TESTEXTVOLT,
   TESTEXTCURR,				TESTEXTCURR,		  TESTEXTCURR,			  TESTEXTCURR,				 TESTEXTCURR,			   D_ESC,					TESTEXTCURR,			   TESTEXTCURR,					D_OK,					TESTEXTCURR,				   TESTEXTCURR,				TESTEXTCURR,		// TESTEXTCURR,
   TESTUART1,				TESTUART1,			  TESTUART1,			  TESTUART1,				 TESTUART1,				   D_ESC,					TESTUART1,				   TESTUART1,					TESTUART1,				TESTUART1,					   TESTUART1,			    TESTUART1,			// TESTUART1,
   TESTUART2,				TESTUART2,			  TESTUART2,			  TESTUART2,				 TESTUART2,				   D_ESC,					TESTUART2,				   TESTUART2,					TESTUART2,				TESTUART2,					   TESTUART2,			    TESTUART2,			// TESTUART2,
   TESTEXTVCC,				TESTEXTVCC,			  TESTEXTVCC,			  TESTEXTVCC,				 TESTEXTVCC,			   D_ESC,					TESTEXTVCC,				   TESTEXTVCC,					D_OK,					TESTEXTVCC,					   TESTEXTVCC,				TESTEXTVCC,			// TESTEXTVCC,
   TESTEXTICC,				TESTEXTICC,			  TESTEXTICC,			  TESTEXTICC,				 TESTEXTICC,			   D_ESC,					TESTEXTICC,				   TESTEXTICC,					D_OK,					TESTEXTICC,					   TESTEXTICC,				TESTEXTICC,			// TESTEXTICC,
   
   CALVOLTAGE,				CALVOLTAGE,			  CALVOLTAGE,			  CALVOLTAGE,				 CALVOLTAGE,			   D_ESC,					CALVOLTAGE,				   CALVOLTAGE,					D_OK,					CALVOLTAGE,					   CALVOLTAGE,				CALVOLTAGE,			// CALVOLTAGE,
   CALCURRENT,				CALCURRENT,			  CALCURRENT,			  CALCURRENT,				 CALCURRENT,			   D_ESC,					CALCURRENT,				   CALCURRENT,					D_OK,					CALCURRENT,					   CALCURRENT,				CALCURRENT,			// CALCURRENT,
   CALOVP,					CALOVP,	    		  CALOVP,	   			  CALOVP,	   				 CALOVP,	   			   D_ESC,					CALOVP,	   				   CALOVP,	   					D_OK,					CALOVP,	   					   CALOVP,	   				CALOVP,	   			// CALOVP,	   
   CALOCP,	   				CALOCP,	  			  CALOCP,	  			  CALOCP,	  				 CALOCP,	  			   D_ESC,					CALOCP,	  				   CALOCP,	  					D_OK,					CALOCP,	  					   CALOCP,	  				CALOCP,	  			// CALOCP,	  
   EXTCALVOLTAGE,			EXTCALVOLTAGE,		  EXTCALVOLTAGE,		  EXTCALVOLTAGE,			 EXTCALVOLTAGE,			   D_ESC,					EXTCALVOLTAGE,			   EXTCALVOLTAGE,				D_OK,					EXTCALVOLTAGE,				   EXTCALVOLTAGE,			EXTCALVOLTAGE,		// EXTCALVOLTAGE,
   EXTCALCURRENT,			EXTCALCURRENT,		  EXTCALCURRENT,		  EXTCALCURRENT,			 EXTCALCURRENT,			   D_ESC,					EXTCALCURRENT,			   EXTCALCURRENT,				D_OK,					EXTCALCURRENT,				   EXTCALCURRENT,			EXTCALCURRENT,		// EXTCALCURRENT,
   EXTCALRESVOLTAGE,		EXTCALRESVOLTAGE,	  EXTCALRESVOLTAGE,		  EXTCALRESVOLTAGE,			 EXTCALRESVOLTAGE,		   D_ESC,					EXTCALRESVOLTAGE,		   EXTCALRESVOLTAGE,			D_OK,					EXTCALRESVOLTAGE,			   EXTCALRESVOLTAGE,		EXTCALRESVOLTAGE,	// EXTCALRESVOLTAGE,
   EXTCALRESCURRENT,		EXTCALRESCURRENT,	  EXTCALRESCURRENT,		  EXTCALRESCURRENT,			 EXTCALRESCURRENT,		   D_ESC,					EXTCALRESCURRENT,		   EXTCALRESCURRENT,			D_OK,					EXTCALRESCURRENT,			   EXTCALRESCURRENT,		EXTCALRESCURRENT,	// EXTCALRESCURRENT,
   
   RFACTORY,				RFACTORY,			  RFACTORY,				  RFACTORY,					 RFACTORY,				   D_ESC,					RFACTORY,				   RFACTORY,					D_OK,					RFACTORY,					   RFACTORY,				RFACTORY,			// RFACTORY,


   MENUSYSCOMMGPIBADDR,		MENUSYSCOMMGPIBADDR,  MENUSYSCOMMGPIBADDR,	  MENUSYSCOMMGPIBADDR,		 MENUSYSCOMMGPIBADDR,	   D_ESC,					MENUSYSCOMMGPIBADDR,	   MENUSYSCOMMGPIBADDR,			D_OK,		            MENUSYSCOMMGPIBADDR,           MENUSYSCOMMGPIBADDR,  	MENUSYSCOMMGPIBADDR,// MENUSYSCOMMGPIBADDR,
   MENUSYSCOMMLANIPMODE,	MENUSYSCOMMLANIPMODE, MENUSYSCOMMLANIPMODE,	  MENUSYSCOMMLANIPMODE,		 MENUSYSCOMMLANIPMODE,	   D_ESC,					MENUSYSCOMMLANIPMODE,	   MENUSYSCOMMLANIPMODE,		D_OK,		            MENUSYSCOMMLANIPMODE,          MENUSYSCOMMLANIPMODE, 	MENUSYSCOMMLANIPMODE,// MENUSYSCOMMLANIPMODE,
   MENUSYSCOMM485BAUD,		MENUSYSCOMM485BAUD,	  MENUSYSCOMM485BAUD,	  MENUSYSCOMM485BAUD,		 MENUSYSCOMM485BAUD,	   D_ESC,					MENUSYSCOMM485BAUD,		   MENUSYSCOMM485BAUD,			D_OK,		            MENUSYSCOMM485BAUD,            MENUSYSCOMM485BAUD,   	MENUSYSCOMM485BAUD,	// MENUSYSCOMM485BAUD,
   MENUSYSCOMM485PDATA,		MENUSYSCOMM485PDATA,  MENUSYSCOMM485PDATA,	  MENUSYSCOMM485PDATA,		 MENUSYSCOMM485PDATA,	   D_ESC,					MENUSYSCOMM485PDATA,	   MENUSYSCOMM485PDATA,			D_OK,					MENUSYSCOMM485PDATA,		   MENUSYSCOMM485PDATA,		MENUSYSCOMM485PDATA,// MENUSYSCOMM485PDATA
   MENUSYSCOMM485STOP,		MENUSYSCOMM485STOP,	  MENUSYSCOMM485STOP,	  MENUSYSCOMM485STOP,		 MENUSYSCOMM485STOP,	   D_ESC,					MENUSYSCOMM485STOP,		   MENUSYSCOMM485STOP,			D_OK,					MENUSYSCOMM485STOP,			   MENUSYSCOMM485STOP,		MENUSYSCOMM485STOP, // MENUSYSCOMM485STOP,
   
   MENUSYSCOMM232BAUD,		MENUSYSCOMM232BAUD,	  MENUSYSCOMM232BAUD,	  MENUSYSCOMM232BAUD,		 MENUSYSCOMM232BAUD,	   D_ESC,					MENUSYSCOMM232BAUD,		   MENUSYSCOMM232BAUD,			D_OK,		            MENUSYSCOMM232BAUD,            MENUSYSCOMM232BAUD,   	MENUSYSCOMM232BAUD,	// MENUSYSCOMM232BAUD,
   MENUSYSCOMM232PDATA,		MENUSYSCOMM232PDATA,  MENUSYSCOMM232PDATA,	  MENUSYSCOMM232PDATA,		 MENUSYSCOMM232PDATA,	   D_ESC,					MENUSYSCOMM232PDATA,	   MENUSYSCOMM232PDATA,			D_OK,					MENUSYSCOMM232PDATA,		   MENUSYSCOMM232PDATA,		MENUSYSCOMM232PDATA,// MENUSYSCOMM232PDATA
   MENUSYSCOMM232STOP,		MENUSYSCOMM232STOP,	  MENUSYSCOMM232STOP,	  MENUSYSCOMM232STOP,		 MENUSYSCOMM232STOP,	   D_ESC,					MENUSYSCOMM232STOP,		   MENUSYSCOMM232STOP,			D_OK,					MENUSYSCOMM232STOP,			   MENUSYSCOMM232STOP,		MENUSYSCOMM232STOP, // MENUSYSCOMM232STOP,
   
   MENUSYSMEMG,				MENUSYSMEMG,		  MENUSYSMEMG,			  MENUSYSMEMG,				 MENUSYSMEMG,			   D_ESC,					MENUSYSMEMG,			   MENUSYSMEMG,					D_OK,		            MENUSYSMEMG,                   MENUSYSMEMG,          	MENUSYSMEMG,		// MENUSYSMEMG,
   MENUSYSBEEP,				MENUSYSBEEP,		  MENUSYSBEEP,			  MENUSYSBEEP,				 MENUSYSBEEP,			   D_ESC,					MENUSYSBEEP,			   MENUSYSBEEP,				    D_OK,		            MENUSYSBEEP,                   MENUSYSBEEP,          	MENUSYSBEEP,		// MENUSYSBEEP,
   MENUSYSDEFAULT,			MENUSYSDEFAULT,		  MENUSYSDEFAULT,		  MENUSYSDEFAULT,			 MENUSYSDEFAULT,		   D_ESC,					MENUSYSDEFAULT,			   MENUSYSDEFAULT,				D_OK,		            MENUSYSDEFAULT,                MENUSYSDEFAULT,       	MENUSYSDEFAULT,		// MENUSYSDEFAULT,
   MENUSYSPONMODE,			MENUSYSPONMODE,		  MENUSYSPONMODE,		  MENUSYSPONMODE,			 MENUSYSPONMODE,		   D_ESC,					MENUSYSPONMODE,			   MENUSYSPONMODE,				D_OK,		            MENUSYSPONMODE,                MENUSYSPONMODE,       	MENUSYSPONMODE,		// MENUSYSPONMODE,

   
   MENUINFOMODEL,			MENUINFOMODEL,		  MENUINFOMODEL,		  MENUINFOMODEL,			 MENUINFOMODEL,			   D_ESC,					MENUINFOMODEL,			   MENUINFOMODEL,				MENUINFOMODEL,          MENUINFOMODEL,                 MENUINFOMODEL,        	MENUINFOMODEL,		// MENUINFOMODEL,
   MENUINFOFWVER,			MENUINFOFWVER,		  MENUINFOFWVER,		  MENUINFOFWVER,			 MENUINFOFWVER,            D_ESC,					MENUINFOFWVER,			   MENUINFOFWVER,				MENUINFOFWVER,			MENUINFOFWVER,				   MENUINFOFWVER,		 	MENUINFOFWVER,		// MENUINFOFWVER,
   MENUINFOOPT,				MENUINFOOPT,		  MENUINFOOPT,			  MENUINFOOPT,				 MENUINFOOPT,			   D_ESC,					MENUINFOOPT,			   MENUINFOOPT,					MENUINFOOPT,			MENUINFOOPT,				   MENUINFOOPT,			 	MENUINFOOPT,		// MENUINFOOPT,
   MENUINFOIPMODE,			MENUINFOIPMODE,		  MENUINFOIPMODE,		  MENUINFOIPMODE,			 MENUINFOIPMODE,		   D_ESC,					MENUINFOIPMODE,			   MENUINFOIPMODE,				MENUINFOIPMODE,			MENUINFOIPMODE,				   MENUINFOIPMODE,		 	MENUINFOIPMODE,		// MENUINFOIPMODE,
   MENUINFOIPADDR,			MENUINFOIPADDR,		  MENUINFOIPADDR,		  MENUINFOIPADDR,			 MENUINFOIPADDR,		   D_ESC,					MENUINFOIPADDR,			   MENUINFOIPADDR,				MENUINFOIPADDR,			MENUINFOIPADDR,				   MENUINFOIPADDR,		 	MENUINFOIPADDR,		// MENUINFOIPADDR,
   MENUINFOMASK,			MENUINFOMASK,		  MENUINFOMASK,			  MENUINFOMASK,				 MENUINFOMASK,			   D_ESC,					MENUINFOMASK,			   MENUINFOMASK,				MENUINFOMASK,			MENUINFOMASK,				   MENUINFOMASK,		 	MENUINFOMASK,		// MENUINFOMASK,
   MENUINFOGWAY,			MENUINFOGWAY,		  MENUINFOGWAY,			  MENUINFOGWAY,				 MENUINFOGWAY,			   D_ESC,					MENUINFOGWAY,			   MENUINFOGWAY,				MENUINFOGWAY,			MENUINFOGWAY,				   MENUINFOGWAY,		 	MENUINFOGWAY,		// MENUINFOGWAY,
   MENUINFOBAUD,			MENUINFOBAUD,		  MENUINFOBAUD,			  MENUINFOBAUD,				 MENUINFOBAUD,			   D_ESC,					MENUINFOBAUD,			   MENUINFOBAUD,				MENUINFOBAUD,			MENUINFOBAUD,				   MENUINFOBAUD,		 	MENUINFOBAUD,		// MENUINFOBAUD,



   MENUCONFLIMITVMIN,		MENUCONFLIMITVMIN,	  MENUCONFLIMITVMIN,	  MENUCONFLIMITVMIN,		 MENUCONFLIMITVMIN,		   D_ESC,					MENUCONFLIMITVMIN,		   MENUCONFLIMITVMIN,			D_OK,					MENUCONFLIMITVMIN,			   MENUCONFLIMITVMIN,	 	MENUCONFLIMITVMIN,	// MENUCONFLIMITVMIN,
   MENUCONFLIMITVMAX,	    MENUCONFLIMITVMAX,	  MENUCONFLIMITVMAX,	  MENUCONFLIMITVMAX,		 MENUCONFLIMITVMAX,        D_ESC,					MENUCONFLIMITVMAX,		   MENUCONFLIMITVMAX,		    D_OK,					MENUCONFLIMITVMAX,			   MENUCONFLIMITVMAX,    	MENUCONFLIMITVMAX,	// MENUCONFLIMITVMAX,
   MENUCONFLIMITIMIN,		MENUCONFLIMITIMIN,	  MENUCONFLIMITIMIN,	  MENUCONFLIMITIMIN,		 MENUCONFLIMITIMIN,		   D_ESC,					MENUCONFLIMITIMIN,		   MENUCONFLIMITIMIN,			D_OK,					MENUCONFLIMITIMIN,			   MENUCONFLIMITIMIN,    	MENUCONFLIMITIMIN,	// MENUCONFLIMITIMIN,
   MENUCONFLIMITIMAX,		MENUCONFLIMITIMAX,	  MENUCONFLIMITIMAX,	  MENUCONFLIMITIMAX,		 MENUCONFLIMITIMAX,		   D_ESC,					MENUCONFLIMITIMAX,		   MENUCONFLIMITIMAX,			D_OK,					MENUCONFLIMITIMAX,			   MENUCONFLIMITIMAX,    	MENUCONFLIMITIMAX,	// MENUCONFLIMITIMAX,
   MENUCONFLIMITPMIN,		MENUCONFLIMITPMIN,	  MENUCONFLIMITPMIN,	  MENUCONFLIMITPMIN,		 MENUCONFLIMITPMIN,		   D_ESC,					MENUCONFLIMITPMIN,		   MENUCONFLIMITPMIN,			D_OK,					MENUCONFLIMITPMIN,			   MENUCONFLIMITPMIN,    	MENUCONFLIMITPMIN,	// MENUCONFLIMITPMIN,
   MENUCONFLIMITPMAX,		MENUCONFLIMITPMAX,	  MENUCONFLIMITPMAX,	  MENUCONFLIMITPMAX,		 MENUCONFLIMITPMAX,		   D_ESC,					MENUCONFLIMITPMAX,		   MENUCONFLIMITPMAX,			D_OK,					MENUCONFLIMITPMAX,			   MENUCONFLIMITPMAX,    	MENUCONFLIMITPMAX,	// MENUCONFLIMITPMAX,
   MENUSYSPONUDEFV,			MENUSYSPONUDEFV,	  MENUSYSPONUDEFV,		  MENUSYSPONUDEFV,			 MENUSYSPONUDEFV,		   D_ESC,					MENUSYSPONUDEFV,		   MENUSYSPONUDEFV,				D_OK,					MENUSYSPONUDEFV,			   MENUSYSPONUDEFV,		 	MENUSYSPONUDEFV,	// MENUSYSPONUDEFV,
   MENUSYSPONUDEFI,			MENUSYSPONUDEFI,	  MENUSYSPONUDEFI,		  MENUSYSPONUDEFI,			 MENUSYSPONUDEFI,		   D_ESC,					MENUSYSPONUDEFI,		   MENUSYSPONUDEFI,				D_OK,					MENUSYSPONUDEFI,			   MENUSYSPONUDEFI,		 	MENUSYSPONUDEFI,	// MENUSYSPONUDEFI,
   MENUSYSPONUDEFONOFF,		MENUSYSPONUDEFONOFF,  MENUSYSPONUDEFONOFF,	  MENUSYSPONUDEFONOFF,		 MENUSYSPONUDEFONOFF,	   D_ESC,					MENUSYSPONUDEFONOFF,	   MENUSYSPONUDEFONOFF,			D_OK,					MENUSYSPONUDEFONOFF,		   MENUSYSPONUDEFONOFF,		MENUSYSPONUDEFONOFF,// MENUSYSPONUDEFONOFF,

   MENUCONFPROTOVP,			MENUCONFPROTOVP,	  MENUCONFPROTOVP,		  MENUCONFPROTOVP,			 MENUCONFPROTOVP,		   D_ESC,					MENUCONFPROTOVP,		   MENUCONFPROTOVP,				D_OK,					SET_METER_FLAG,				   MENUCONFPROTOVP,      	MENUCONFPROTOVP,	// MENUCONFPROTOVP,
   MENUCONFPROTOCP,			MENUCONFPROTOCP,	  MENUCONFPROTOCP,		  MENUCONFPROTOCP,			 MENUCONFPROTOCP,		   D_ESC,					MENUCONFPROTOCP,		   MENUCONFPROTOCP,				D_OK,					SET_METER_FLAG,				   MENUCONFPROTOCP,      	MENUCONFPROTOCP,	// MENUCONFPROTOCP,
   MENUCONFPROTOPP,			MENUCONFPROTOPP,	  MENUCONFPROTOPP,		  MENUCONFPROTOPP,			 MENUCONFPROTOPP,		   D_ESC,					MENUCONFPROTOPP,		   MENUCONFPROTOPP,				D_OK,					SET_METER_FLAG,	 			   MENUCONFPROTOPP,      	MENUCONFPROTOPP,	// MENUCONFPROTOPP,
   MENUCONFPROTCVCC,		MENUCONFPROTCVCC,	  MENUCONFPROTCVCC,		  MENUCONFPROTCVCC,			 MENUCONFPROTCVCC,		   D_ESC,					MENUCONFPROTCVCC,		   MENUCONFPROTCVCC,			D_OK,					MENUCONFPROTCVCC,			   MENUCONFPROTCVCC,     	MENUCONFPROTCVCC,	// MENUCONFPROTCVCC,
   MENUCONFPROTCCCV,		MENUCONFPROTCCCV,	  MENUCONFPROTCCCV,		  MENUCONFPROTCCCV,			 MENUCONFPROTCCCV,		   D_ESC,					MENUCONFPROTCCCV,		   MENUCONFPROTCCCV,			D_OK,					MENUCONFPROTCCCV,			   MENUCONFPROTCCCV,     	MENUCONFPROTCCCV,	// MENUCONFPROTCCCV,

   MENUCONFEXTCV,			MENUCONFEXTCV,   	  MENUCONFEXTCV,		  MENUCONFEXTCV,			 MENUCONFEXTCV, 		   D_ESC,					MENUCONFEXTCV,  		   MENUCONFEXTCV,				D_OK,					MENUCONFEXTCV,  			   MENUCONFEXTCV,        	MENUCONFEXTCV,		// MENUCONFEXTCV,
   MENUCONFEXTCI,			MENUCONFEXTCI,		  MENUCONFEXTCI,		  MENUCONFEXTCI,			 MENUCONFEXTCI,			   D_ESC,					MENUCONFEXTCI,			   MENUCONFEXTCI,				D_OK,					MENUCONFEXTCI,				   MENUCONFEXTCI,        	MENUCONFEXTCI,		// MENUCONFEXTCI,
   MENUCONFEXTCPRANGE,		MENUCONFEXTCPRANGE,	  MENUCONFEXTCPRANGE,	  MENUCONFEXTCPRANGE,		 MENUCONFEXTCPRANGE,	   D_ESC,					MENUCONFEXTCPRANGE,		   MENUCONFEXTCPRANGE,			D_OK,					MENUCONFEXTCPRANGE,			   MENUCONFEXTCPRANGE,   	MENUCONFEXTCPRANGE,	// MENUCONFEXTCPRANGE,
   MENUCONFEXTCMONRNG,		MENUCONFEXTCMONRNG,	  MENUCONFEXTCMONRNG,	  MENUCONFEXTCMONRNG,		 MENUCONFEXTCMONRNG,	   D_ESC,					MENUCONFEXTCMONRNG,		   MENUCONFEXTCMONRNG,			D_OK,					MENUCONFEXTCMONRNG,			   MENUCONFEXTCMONRNG,   	MENUCONFEXTCMONRNG, // MENUCONFEXTCMONRNG,
   MENUCONFEXTCSHUT,		MENUCONFEXTCSHUT,	  MENUCONFEXTCSHUT,		  MENUCONFEXTCSHUT,			 MENUCONFEXTCSHUT,		   D_ESC,					MENUCONFEXTCSHUT,		   MENUCONFEXTCSHUT,			D_OK,					MENUCONFEXTCSHUT,			   MENUCONFEXTCSHUT,      	MENUCONFEXTCSHUT,   // MENUCONFEXTCSHUT,
   MENUCONFEXTCENABLE,		MENUCONFEXTCENABLE,	  MENUCONFEXTCENABLE,	  MENUCONFEXTCENABLE,		 MENUCONFEXTCENABLE,	   D_ESC,					MENUCONFEXTCENABLE,		   MENUCONFEXTCENABLE,			D_OK,					MENUCONFEXTCENABLE,			   MENUCONFEXTCENABLE,   	MENUCONFEXTCENABLE,	// MENUCONFEXTCENABLE,

   MENUSYSCOMMLANIPADDR,	MENUSYSCOMMLANIPADDR, MENUSYSCOMMLANIPADDR,	  MENUSYSCOMMLANIPADDR,		 MENUSYSCOMMLANIPADDR,	   D_ESC,					MENUSYSCOMMLANIPADDR,	   MENUSYSCOMMLANIPADDR,		D_OK,					MENUSYSCOMMLANIPADDR,		   MENUSYSCOMMLANIPADDR, 	MENUSYSCOMMLANIPADDR,// MENUSYSCOMMLANIPADDR,
   MENUSYSCOMMLANMASK,		MENUSYSCOMMLANMASK,	  MENUSYSCOMMLANMASK,	  MENUSYSCOMMLANMASK,		 MENUSYSCOMMLANMASK,	   D_ESC,					MENUSYSCOMMLANMASK,		   MENUSYSCOMMLANMASK,			D_OK,					MENUSYSCOMMLANMASK,			   MENUSYSCOMMLANMASK,	 	MENUSYSCOMMLANMASK,	// MENUSYSCOMMLANMASK,
   MENUSYSCOMMLANGWAY,		MENUSYSCOMMLANGWAY,	  MENUSYSCOMMLANGWAY,	  MENUSYSCOMMLANGWAY,		 MENUSYSCOMMLANGWAY,	   D_ESC,					MENUSYSCOMMLANGWAY,		   MENUSYSCOMMLANGWAY,			D_OK,					MENUSYSCOMMLANGWAY,			   MENUSYSCOMMLANGWAY,	 	MENUSYSCOMMLANGWAY,	// MENUSYSCOMMLANGWAY,

   MENUCONFPARAMODE,		MENUCONFPARAMODE,	  MENUCONFPARAMODE,		  MENUCONFPARAMODE,			 MENUCONFPARAMODE,		   D_ESC,					MENUCONFPARAMODE,		   MENUCONFPARAMODE,			D_OK,					MENUCONFPARAMODE,			   MENUCONFPARAMODE,     	MENUCONFPARAMODE,	// MENUCONFPARAMODE,
   MENUCONFPARAROLE,		MENUCONFPARAROLE,	  MENUCONFPARAROLE,		  MENUCONFPARAROLE,			 MENUCONFPARAROLE,		   D_ESC,					MENUCONFPARAROLE,		   MENUCONFPARAROLE,			D_OK,					MENUCONFPARAROLE,			   MENUCONFPARAROLE,	 	MENUCONFPARAROLE,	// MENUCONFPARAROLE,

   MENUCONFCHAINMODE,		MENUCONFCHAINMODE,	  MENUCONFCHAINMODE,	  MENUCONFCHAINMODE,		 MENUCONFCHAINMODE,		   D_ESC,					MENUCONFCHAINMODE,		   MENUCONFCHAINMODE,			D_OK,					MENUCONFCHAINMODE,			   MENUCONFCHAINMODE,	 	MENUCONFCHAINMODE,	// MENUCONFCHAIN,
   MENUCONFCHAINADDR,		MENUCONFCHAINADDR,	  MENUCONFCHAINADDR,	  MENUCONFCHAINADDR,		 MENUCONFCHAINADDR,		   D_ESC,					MENUCONFCHAINADDR,		   MENUCONFCHAINADDR,           D_OK,					MENUCONFCHAINADDR,			   MENUCONFCHAINADDR,    	MENUCONFCHAINADDR,	// MENUCONFCHAINADDR,

   SELFTEST1,				SELFTEST1,			  SELFTEST1,			  SELFTEST1,				 SELFTEST1,				   SELFTEST1,				SELFTEST1,				   SELFTEST1,					SELFTEST2,				SELFTEST1,					   SELFTEST1,				SELFTEST1,			// SELFTEST1
   SELFTEST2,				SELFTEST2,			  SELFTEST2,			  SELFTEST2,				 SELFTEST2,				   SELFTEST2,				SELFTEST2,				   SELFTEST2,					SELFTEST2,				SELFTEST2,					   SELFTEST2,				SELFTEST2,			// SELFTEST2
   STARTDLE7,				STARTDLE7,			  STARTDLE7,			  STARTDLE7,				 STARTDLE7,				   STARTDLE7,				STARTDLE7,				   STARTDLE7,					STARTDLE7,				STARTDLE7,					   STARTDLE7,				STARTDLE7,			// STARTDLE7,
   STARTDLE1,   			STARTDLE1,			  STARTDLE1,			  STARTDLE1,				 STARTDLE1,				   STARTDLE1,				STARTDLE1,				   STARTDLE1,					STARTDLE1,				STARTDLE1,					   STARTDLE1,				STARTDLE1,			// STARTDLE1,
   STARTDLEG,   			STARTDLEG,			  STARTDLEG,			  STARTDLEG,				 STARTDLEG,				   STARTDLEG,				STARTDLEG,				   STARTDLEG,					STARTDLEG,				STARTDLEG,					   STARTDLEG,				STARTDLEG,			// STARTDLEG,

   SET_METER_FLAG,		    SET_METER_FLAG,       SET_METER_FLAG,         SET_METER_FLAG,			 SET_METER_FLAG,		   SET_METER_FLAG,          SET_METER_FLAG,			   SET_METER_FLAG,				SET_METER_FLAG,			SET_METER_FLAG,				   SET_METER_FLAG,		 	SET_METER_FLAG,		// SET_METER_FLAG
   SET_ONOFF_FLAG,		    SET_ONOFF_FLAG,		  SET_ONOFF_FLAG,		  SET_ONOFF_FLAG,			 SET_ONOFF_FLAG,		   SET_ONOFF_FLAG,			SET_ONOFF_FLAG,			   SET_ONOFF_FLAG,				SET_ONOFF_FLAG,			SET_ONOFF_FLAG,				   SET_ONOFF_FLAG,       	SET_ONOFF_FLAG,		// SET_ONOFF_FLAG
   CLR_LOCAL,				CLR_LOCAL,			  CLR_LOCAL,			  CLR_LOCAL,				 CLR_LOCAL,				   CLR_LOCAL,				CLR_LOCAL,				   CLR_LOCAL,					CLR_LOCAL,				CLR_LOCAL,					   CLR_LOCAL,				CLR_LOCAL,			// CLR_LOCAL,
   SET_OFF_FLAG,		    SET_OFF_FLAG,		  SET_OFF_FLAG,			  SET_OFF_FLAG,				 SET_OFF_FLAG,		 	   SET_OFF_FLAG,			SET_OFF_FLAG,			   SET_OFF_FLAG,				SET_OFF_FLAG,			SET_OFF_FLAG,				   SET_OFF_FLAG, 	      	SET_OFF_FLAG,		// SET_OFF_FLAG



};




extern uint8_t	controlState ;
#define LOCAL_CTRL		0
#define ANALOG_CTRL		1













#endif



