#ifndef	_DISPLAY_H
#define _DISPLAY_H



#define    BLUE0    0x0088      //Lx
#define    BLACK    0x0000     	//¦
#define    BLUE     0x000F     	//Ŧ
#define    RED      0x0800     	//
#define    GRAY0    0x0877   	//Ǧ0  3165 00110 001011 00101
#define    GRAY1    0x0088     	//Ǧ1      00000 000000 00000
#define    GRAY2    0x0070     	//Ǧ2  1111111111011111
#define    WHITE    0xFFFF		//զ   110010 110100 110100
#define    GREEN    0x0080		//զ   110010 110100 110100
#define    YELLOW   0x0880     	//

extern uint8_t   disptp;




#define DRAW_KEY_B1    drawLcdBlockBackGround(&B1,96,45)
#define DRAW_KEY_B2    drawLcdBlockBackGround(&B2,96,45)
#define DRAW_KEY_B3    drawLcdBlockBackGround(&B3,96,45)
#define DRAW_KEY_B4    drawLcdBlockBackGround(&B4,96,45)
#define DRAW_KEY_B5    drawLcdBlockBackGround(&B5,96,45)
#define DRAW_KEY_R4    drawLcdBlockBackGround(&R4,96,56)
#define DRAW_KEY_R3    drawLcdBlockBackGround(&R3,96,56)
#define DRAW_KEY_R2    drawLcdBlockBackGround(&R2,96,56)
#define DRAW_KEY_R1    drawLcdBlockBackGround(&R1,96,56)


//#define DRAW_BLOCK10    drawlcdBlockBackGround(30, 30,120,60,5)


typedef struct _block
{
    uint16_t    leftUpX;     // W X
	uint16_t	leftUpY;     // W Y
    uint16_t    leftDownX;   // U X
	uint16_t	leftDownY;   // U Y
    uint16_t    rightUpX;    // kW X
	uint16_t	rightUpY;    // kW Y
    uint16_t    rightDownX;  // kU X
	uint16_t	rightDownY;  // kU Y
	uint16_t    backcolor;   //	I
} sBLOCK;

extern sBLOCK  B0;
extern sBLOCK  B1;
extern sBLOCK  B2;
extern sBLOCK  B3;
extern sBLOCK  B4;
extern sBLOCK  B5;
extern sBLOCK  R1;
extern sBLOCK  R2;
extern sBLOCK  R3;
extern sBLOCK  R4;
//extern sBLOCK  block2;
extern const uint16_t blockColor;
extern 	uint8_t   displayBuffer[128];
extern  uint8_t  displayLength;

#define TRANSPARENT          0	  		    //z
#define NONE_TRANSPARENT     !TRANSPARENT	//z

#define HORIZONTAL				0	//	
#define VERTICAL				1	//

#define FILL					1   // 
#define NONE_FILL               0  // 

#define HIGH_LIGHT              0  //  ϥ թ¦r
#define NONE_HIGH_LIGHT			1  //  `

typedef struct _tFont
{    
  const uint8_t *table;
  uint8_t width;
  uint8_t high;
  
} sFONT;

extern sFONT font1;
extern sFONT font2;
extern sFONT font3;
extern sFONT font4;
extern sFONT font5;





void printLcdString(uint8_t *str,uint16_t x,uint16_t y,sFONT *font,uint16_t bcolor,uint16_t color,uint8_t mode);
void drawLcdLine(uint16_t Xpos, uint16_t Ypos, uint16_t Length, uint8_t Direction);
void drawLcdRect(uint16_t Xpos, uint16_t Ypos, uint8_t Height, uint16_t Width ,uint8_t fill);
void printLcd16BitBmp(uint16_t* image,uint16_t x,uint16_t y,uint16_t width,uint16_t height);
void drawLcdChar(uint16_t Xpos, uint16_t Ypos, sFONT *font ,const uint8_t *c);
void drawLcdBlockBackGround(sBLOCK *block,uint16_t length,uint16_t width);
void printBKLogo(void);
void highLight(uint8_t *str,sFONT *font,uint16_t Xpos, uint16_t Ypos,uint16_t color,uint16_t color1,sBLOCK *block,uint8_t highLight);
void set_s_TextColor(uint16_t color);
void displayFreqLevelRangeSpeedVacIac(void);
void pasteB0ToB9(void);
#endif




