
#include "includes.h"



void initializeVFD(void)
{
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x06);				// cursor ON
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1

	clearVFD();
	delay5us(2);
	setVFDFlashOff(0x40, 0x30);
	delay5us(2);
	setVFDCursorOff();
}

void clearVFD(void)
{
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x01);				// clear screen
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}

void printVFDString(uint8_t pos, char* string)
{
	uint8_t stringLength, i;

	stringLength = strlen(string);

	setVFDCursorOff();
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(pos);					// character position
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1

  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x84);
	for (i = 0; i < stringLength; i++) sVFD_SendByte(string[i]);
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}
/*
void dispVFD48(uint8_t* string)
{
    uint8_t i;
	setVFDCursorOff();
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x40);				// character position
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x84);
	for (i = 0; i < 48 ; i++) 
	{
	    if (string[i] == 0)
		    string[i] = ' ';
		if (string[i] == '<')
		    string[i] = 0xD3;
		if (string[i] == '>')
		    string[i] = 0xD4;
	    sVFD_SendByte(string[i]);
	}
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}
  */
void dispVFD48(uint8_t* string)
{
    uint8_t i;
	setVFDCursorOff();
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	delay5us(1);
	sVFD_SendByte(0x40);				// character position
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
	delay5us(1);
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x84);
	for (i = 0; i < 48 ; i++) 
	{
	    if (string[i] == 0 || string[i] == 0xFF)
		    string[i] = ' ';
		if (string[i] == '<')
		    string[i] = 0xD3;
		if (string[i] == '>')
		    string[i] = 0xD4;
	    sVFD_SendByte(string[i]);
	}
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}


extern uint8_t		programStart;
extern uint8_t		ProtOVActivation;
extern uint8_t		ProtOCActivation;
extern uint8_t		ProtOPActivation;
extern uint8_t		CVtoCCActivation;
extern uint8_t		CCtoCVActivation;
extern uint8_t		extVMode;
extern uint8_t		extIMode;
extern uint8_t		extEnable;
extern uint32_t     VFDsign;
extern uint8_t      onoffStatus;
extern uint8_t 		protsw;
extern uint16_t     outputStatus;
extern uint32_t		runningTimer;
extern uint8_t 		displayBuffer[49];
extern uint8_t 		remote;
void checkTimerCount(uint32_t time);
void display(void);

extern uint8_t		OVPOccurred;
extern uint8_t		OCPOccurred;
extern uint8_t		OPPOccurred;
extern uint8_t		VCPOccurred;
extern uint8_t		CVPOccurred;

uint8_t	cc_cv_ctrl_beep = 0;
uint8_t otwOccurred,otpOccurred;

uint8_t cccvcount = 0;
uint8_t cvcccount = 0;
void printVFDsign(void)
{
    uint32_t sign;
	if (actualState != SELFTEST1)
	{
		if (outputStatus & OTW_STATE) // OTW
		{
			if (otwOccurred == 0)
			{
				otwOccurred = 1;
				clearOnTheFlyCursor();
				cursorPosition = 0;
				if (softTimer[TEMP_BEEP_COUNT].flag == DISABLE)
				{
				    softTimer[TEMP_BEEP_COUNT].flag = ENABLE;
				    softTimer[TEMP_BEEP_COUNT].count = softTimer[MAIN_COUNT].count;
				}
			}
			setVFDFlashOff(0x40, 48);
		}
		else
		{
			otwOccurred = 0;
			softTimer[TEMP_BEEP_COUNT].flag = DISABLE;
		}

		if (IS_NTC_TOO_HIGH)
		{
			if (otpOccurred == 0)
			{
				otpOccurred = 1;
				SET_ERROR_BEEP;	   // OTP  Beep
				cursorPosition = 0;
			}
			setVFDFlashOff(0x40, 48);
		}
		else
			otpOccurred = 0;

/* OVP */
	    if (ProtOVActivation)
		{
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				static uint16_t ovpCount = 0;
				if (master.vOut > (master.OVPSet + 4))
				{
					ovpCount++;
					if (ovpCount > 2 && OVPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						OVPOccurred = 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						SET_PARALLEL_PROTECT;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}
					}
				}
				else
				{
				 	VFDsign &= ~(sign_PROT);//prot r
					ovpCount = 0; 
				}
			}
			else
			{
				if(outputStatus & OVP_STATE) // dc/dc board  OVP Occurred
				{
					if (OVPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						OVPOccurred = 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}
					}
				}
				else 
				{
				 	VFDsign &= ~(sign_PROT);//prot r
					OVPOccurred = 0; 
				}
			}
	   	 	VFDsign |= sign_OVP;   // O
		}
		else
		{
			VFDsign &= ~(sign_PROT);
		    VFDsign &= ~(sign_OVP);
			OVPOccurred = 0;
   		}
/* OCP */
 	   if (ProtOCActivation)
		{
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				static uint16_t ocpCount = 0;
				if(sumiOut() > (master.OCPSet * (slaveNumber + 1))) // dc/dc board  OCP Occurred
				{
					ocpCount++;
					if (ocpCount > 0 && OCPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						OCPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						SET_PARALLEL_PROTECT;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}				
					}
				}
				else 
				{
				 	VFDsign &= ~(sign_PROT);//prot r 
					ocpCount = 0;
				}				 
			}
			else
			{
				if(outputStatus & OCP_STATE) // dc/dc board  OCP Occurred
				{
					if (OCPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						OCPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}				
					}
				} 
				else 
				{
				 	VFDsign &= ~(sign_PROT);//prot r 
					OCPOccurred= 0;
				}
			}
	   	 	VFDsign |= sign_OCP;   // O
		}
		else
		{
		    if ( ProtOVActivation == 0)
				VFDsign &= ~(sign_PROT);
		    VFDsign &= ~(sign_OCP);
			OCPOccurred= 0;
   	 	}
/* OPP */
 	   if (ProtOPActivation)
		{
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				static uint16_t oppCount = 0;
				if(master.vOut * sumiOut() > (master.OPPSet * (slaveNumber + 1))) // dc/dc board  OPP Occurred
				{
					oppCount++;
					if (oppCount > 0 && OPPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						OPPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						SET_PARALLEL_PROTECT;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}				
					}
				}
				else 
				{
			 		VFDsign &= ~(sign_PROT);//prot r 
   					oppCount = 0;
				}
			}
			else
			{
				if(outputStatus & OPP_STATE) // dc/dc board  OPP Occurred
				{
					if (OPPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						OPPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}				
					}
				}
				else 
				{
			 		VFDsign &= ~(sign_PROT);//prot r 
	 				OPPOccurred= 0;
				}
			}
			VFDsign |= sign_OPP;   // O
		}
		else
		{
			if (ProtOVActivation == 0 && ProtOCActivation == 0)
				VFDsign &= ~(sign_PROT);
		    VFDsign &= ~(sign_OPP);
			OPPOccurred= 0;
	   	 }
		if ( CVtoCCActivation)
		{
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
/*				static uint16_t CvCcCount = 0;
				if( sumiOut() > (master.iSet * (slaveNumber + 1))) // 
				{
					CvCcCount++;
					if (CvCcCount > 5 && VCPOccurred == 0 && (VFDsign & (sign_CV)))
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						VCPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						SET_PARALLEL_PROTECT;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}				
					}
				}
				else 
				{
			 		VFDsign &= ~(sign_PROT);//prot r 
   					CvCcCount = 0;
				}*/	 
			}
			else
			{
				if(outputStatus & CV_CC_STATE) // dc/dc board CV-CC Occurred
				{
					if (VCPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						VCPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}				
					}
				}
				else
				{ 
			 		VFDsign &= ~(sign_PROT);//prot r
					VCPOccurred= 0;
				}
			}		 
		}
		else
			VCPOccurred= 0;
		if ( CCtoCVActivation)
		{
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
			/*	static uint16_t CcCvCount = 0;
				if( sumiOut() < ((master.iSet * (slaveNumber + 1)) - (0.002 * (slaveNumber + 1)))) // 
				{
					CcCvCount++;
					if (CcCvCount > 5 && CVPOccurred == 0 && (VFDsign & (sign_CC)))
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						CVPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						SET_PARALLEL_PROTECT;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}				
					}
				}
				else 
				{
			 		VFDsign &= ~(sign_PROT);//prot r 
   					CcCvCount = 0;
				}*/	
			}
			else   
			{
				if(outputStatus & CC_CV_STATE) // dc/dc board   CC-CV Occurred
				{
					if (CVPOccurred == 0)
					{
						setVFDFlashOff(0x40, 48);
						VFDsign |= sign_PROT;//prot r
						CVPOccurred= 1;
						clearOnTheFlyCursor();
						SET_ERROR_BEEP;
						if (onoffStatus == ON)
						{
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
						}
					}
				}
				else 
				{
				 	VFDsign &= ~(sign_PROT);//prot r 
					CVPOccurred= 0;
				}
			}
		}
		else
			CVPOccurred= 0;



		if ((extEnable > OFF) && (controlState == ANALOG_CTRL) && (extVMode >= 1 || extIMode >= 1))  // ùr
			VFDsign |= sign_REAR;
		else 
			VFDsign &= ~(sign_REAR);
		if ((outputStatus & ON_STATE ))	// Ū^AUO ON
		{
			VFDsign = (VFDsign & ~sign_OFF) | sign_ONOFF;  // ùrΫO
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				if (sumiOut() < ((master.iSet * (slaveNumber + 1)) - (0.0007 * (slaveNumber + 1)))) // -0.0007A تOnp master iJ CC (Cx~t0.0006A)
				{
					cvcccount = 0;
					cccvcount++;
					if (cccvcount > 15)
					{
						cccvcount = 15;
						VFDsign |= sign_CV;	  // ùr
						VFDsign &= ~(sign_CC);
						if (cc_cv_ctrl_beep == 2)
						{
							slaveErrorState = CV_CC_ERROR;
							if(cursoronoff == 0)
								clearOnTheFlyCursor();
							if (CCtoCVActivation == 1 && CVPOccurred == 0 )	// CCCV protect
							{
								setVFDFlashOff(0x40, 48);
								VFDsign |= sign_PROT;//prot r
								CVPOccurred= 1;
								clearOnTheFlyCursor();
								SET_ERROR_BEEP;
								SET_PARALLEL_PROTECT;
								if (onoffStatus == ON)
								{
									onoffStatus = 0;
									verifyInput(OUTPUT_CMD,(float)onoffStatus );
								}				
							}
							else 
							{
								if (pvsONOFF == OFF)
									beep(1);		 //  CC  CV beep
							}

						}
						cc_cv_ctrl_beep = 1; // CV state
					}
				}
				else 
				{
					cccvcount = 0;
					cvcccount++;
					if (cvcccount > 15)
					{
					    cvcccount = 15;
						VFDsign |= sign_CC;	  // ùr
						VFDsign &= ~(sign_CV);
						if (cc_cv_ctrl_beep == 1)
						{
							slaveErrorState = CC_CV_ERROR;
							if(cursoronoff == 0)
								clearOnTheFlyCursor();
							if (CVtoCCActivation == 1 && VCPOccurred == 0 )	// CVCC protect
							{
								setVFDFlashOff(0x40, 48);
								VFDsign |= sign_PROT;//prot r
								VCPOccurred = 1;
								clearOnTheFlyCursor();
								SET_ERROR_BEEP;
								SET_PARALLEL_PROTECT;
								if (onoffStatus == ON)
								{
									onoffStatus = 0;
									verifyInput(OUTPUT_CMD,(float)onoffStatus );
								}				
							}
							else 
							{
								if (pvsONOFF == OFF)
									beep(1);  //  CV  CC  beep
							}
						}
						cc_cv_ctrl_beep = 2; // CC state
					}
				} 
			}	
			else 
			{
				if ((outputStatus & CV_STATE    ))
				{
			    	VFDsign |= sign_CV;	  // ùr
					if (cc_cv_ctrl_beep == 2)
					{
						slaveErrorState = CV_CC_ERROR;
						if(cursoronoff == 0)
							clearOnTheFlyCursor();
						if (pvsONOFF == OFF)
						{
							if (parallelMode == ON && parallelRole != MASTER && slaveState == 4)
								;				 // slave s
							else
								beep(1);		 //  CC  CV beep
						}
					}
					cc_cv_ctrl_beep = 1; // CV state
				}
				else
					VFDsign &= ~(sign_CV);
				if ((outputStatus & CC_STATE    ))
				{
			    	VFDsign |= sign_CC;	 // ùr
					if (cc_cv_ctrl_beep == 1)
					{
						slaveErrorState = CC_CV_ERROR;
						if (pvsONOFF == OFF)
						{
							if (parallelMode == ON && parallelRole != MASTER && slaveState == 4)
								;				 // slave s
							else
								beep(1);  //  CV  CC  beep
						}
						if(cursoronoff == 0)
							clearOnTheFlyCursor();
					}
					cc_cv_ctrl_beep = 2; // CC state
				}
				else
					VFDsign &= ~(sign_CC);
				if ((outputStatus & CP_STATE    ))
			    	VFDsign |= sign_CW;	 // ùr
				else
					VFDsign &= ~(sign_CW);
			}
		}
		else
		{
			clearFilterData();
			VFDsign = (VFDsign & ~sign_ONOFF) | sign_OFF;
			cc_cv_ctrl_beep = 0; //normal
			VFDsign &= ~(sign_CV);	 // ùr
			VFDsign &= ~(sign_CC);
			VFDsign &= ~(sign_CW);			
		}
	}

	sign = VFDsign;   	
	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x85);
	sVFD_SendByte((uint8_t)(sign >> 24));
	sVFD_SendByte((uint8_t)(sign >> 16));
	sVFD_SendByte((uint8_t)(sign >> 8));
	sVFD_SendByte((uint8_t)(sign));
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}

uint8_t bkpos,bklen;  //  {{}Ϊ

void setVFDFlashOn(uint8_t pos, uint8_t len)
{
	if (bkpos != pos && bklen != len)
	{
		bkpos = pos;
		bklen = len;
  		VFD_SPI_CS_LOW;  					// SPI_CS = 0
		sVFD_SendByte(0x86);
		sVFD_SendByte(pos-0x40);			// position = real position - 0x30
		sVFD_SendByte(len);
   		VFD_SPI_CS_HIGH;    				// SPI_CS = 1
	}
}

void setVFDFlashOff(uint8_t pos, uint8_t len)
{
	bkpos = 0;
	bklen = 0;
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x87);
	sVFD_SendByte(pos-0x40);			// position = real position - 0x30
	sVFD_SendByte(len);
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}

void setVFDCursorOn(uint8_t pos)
{
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(pos);					// cursor position
    GPIO_SetBits(GPIOC, GPIO_Pin_8);    // SPI_CS = 1
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x0A);				// cursor on
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}

void setVFDCursorOff(void)
{
  	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x08);				// cursor off
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}

void showCursor(void)
{
/* `N   cursoroffROiHKU uݭnɤ~U 
   ҥHoΤ@flagӱ 
*/ 
	if (!cursorPosition)
	{ 
		if (IS_CURSOR_FLAG)
		{
	    	setVFDCursorOff();
			CLR_CURSOR_FLAG;
		}
	}
	else
	{ 
	    SET_CURSOR_FLAG;
	    setVFDCursorOn(cursorPosition);
	}
}


void clearScreen(void)
{
	memset((void *)displayBuffer,0x20,49);
	dispVFD48(DISPBUF);
	VFD_SPI_CS_LOW;  					// SPI_CS = 0
	sVFD_SendByte(0x85);
	sVFD_SendByte((uint8_t)(0));
	sVFD_SendByte((uint8_t)(0));
	sVFD_SendByte((uint8_t)(0));
	sVFD_SendByte((uint8_t)(0));
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
}


