#ifndef __DISPLAYVFD_H
#define __DISPLAYVFD_H


#define sign_SRQ		0x80000000
#define sign_ADDR		0x40000000
#define sign_RMT		0x20000000
#define sign_CW			0x10000000
#define sign_CR			0x08000000
#define sign_CV			0x04000000
#define sign_CC			0x02000000
#define sign_OFF		0x01000000
#define sign_SHIFT		0x00800000
#define sign_STAR		0x00400000
#define sign_AUTO		0x00200000
#define sign_REAR		0x00100000
#define sign_PROT		0x00080000
#define sign_SENSE		0x00040000
#define sign_TRIG		0x00020000
#define sign_ERROR		0x00010000
#define sign_OPP		0x00008000
#define sign_OVP		0x00004000
#define sign_METER		0x00002000
#define sign_LOCK		0x00001000
#define sign_SHIFTBL	0x00000800
#define sign_ESC		0x00000400
#define sign_OCP		0x00000200
#define sign_VSET		0x00000100
#define sign_MENU		0x00000008
#define sign_ONOFF		0x00000004
#define sign_ISET		0x00000002
#define sign_RECALL		0x00000001


extern uint8_t bkpos,bklen;  //  {{}Ϊ

void initializeVFD(void);
void clearVFD(void);
void printVFDString(uint8_t pos, char* string);
void dispVFD48(uint8_t* string);
void printVFDsign(void );
void setVFDFlashOn(uint8_t pos, uint8_t len);
void setVFDFlashOff(uint8_t pos, uint8_t len);
void setVFDCursorOn(uint8_t pos);
void setVFDCursorOff(void);
void showCursor(void);

//#define 	SPI_GPIO_FUNC


#define VFD_SPI_CS_LOW			GPIO_ResetBits(GPIOC, GPIO_Pin_8);delay5us(1)
#define VFD_SPI_CS_HIGH			delay5us(2);GPIO_SetBits(GPIOC, GPIO_Pin_8)

#ifdef SPI_GPIO_FUNC

#define VFD_SPI_SCLK_LOW		GPIO_ResetBits(GPIOC, GPIO_Pin_10);delay5us(1)
#define VFD_SPI_SCLK_HIGH		GPIO_SetBits(GPIOC, GPIO_Pin_10);delay5us(1)

#define VFD_SPI_MOSI_LOW		GPIO_ResetBits(GPIOC, GPIO_Pin_12)
#define VFD_SPI_MOSI_HIGH		GPIO_SetBits(GPIOC, GPIO_Pin_12)

#define VFD_SPI_MISO_STATUS		GPIO_ReadInputDataBit(GPIOC,GPIO_Pin_11)

#endif

#endif
