#ifndef _EEPROM_H
#define _EEPROM_H


/* MAC ADDRESS: MAC_ADDR0:MAC_ADDR1:MAC_ADDR2:MAC_ADDR3:MAC_ADDR4:MAC_ADDR5 */
#define MAC_ADDR0   0x00
#define MAC_ADDR1   0x17
#define MAC_ADDR2   0xF8
#define MAC_ADDR3   0xFF
#define MAC_ADDR4   0xFF
#define MAC_ADDR5   0x00



// EEPROM  2464	   64Kbits  = 8192 Bytes

// e 700 BytesOŪ iHϥ											// eeprom address
#define EE_BEEPACTIVATION				0									// 0
#define EE_GROUPNUMBER					EE_BEEPACTIVATION + sizeof(uint8_t)	// 1
#define EE_POWERONMODE					EE_GROUPNUMBER + sizeof(uint8_t)	// 2
#define EE_POWERON_ONOFF				EE_POWERONMODE + sizeof(uint8_t)	// 3
#define EE_POWERONVOLT					EE_POWERON_ONOFF + sizeof(uint8_t)	// 4
#define EE_POWERONCURRENT				EE_POWERONVOLT + sizeof(float)		// 8
#define EE_LASTVSET						EE_POWERONCURRENT + sizeof(float)	// 12 W@ϥ VSET
#define EE_LASTISET						EE_LASTVSET + sizeof(float)			// 16 W@ϥ ISET
#define EE_EXTVMODE						EE_LASTISET + sizeof(float)	 		// 20 FRONT  EXT-V EXT-R
#define EE_EXTIMODE						EE_EXTVMODE + sizeof(uint8_t)		// 21 FRONT  EXT-V EXT-R
#define EE_EXTPROGRANGE					EE_EXTIMODE + sizeof(uint8_t)		// 22 5V/5K   10V/10K
#define EE_EXTMONRANGE					EE_EXTPROGRANGE + sizeof(uint8_t)	// 23 5V  10V
#define EE_EXTSHUTOFFLOGIC				EE_EXTMONRANGE + sizeof(uint8_t)	// 24 OFF/Low  ON/Low
#define	EE_EXTENABLE					EE_EXTSHUTOFFLOGIC + sizeof(uint8_t)// 25 NON ACTIVE    ACTIVE
#define EE_ONOFFSTATUS					EE_EXTENABLE + sizeof(uint8_t)		// 26 Last power on 
#define EE_LIMITVMIN					EE_ONOFFSTATUS + sizeof(uint8_t)	// 27
#define EE_LIMITVMAX					EE_LIMITVMIN + sizeof(float)		// 31
#define EE_LIMITIMIN					EE_LIMITVMAX + sizeof(float)		// 35
#define EE_LIMITIMAX					EE_LIMITIMIN + sizeof(float)		// 39
#define EE_LIMITPMIN					EE_LIMITIMAX + sizeof(float)		// 43
#define EE_LIMITPMAX					EE_LIMITPMIN + sizeof(float)		// 47
#define EE_REALOVPSET					EE_LIMITPMAX + sizeof(float)		// 51
#define EE_REALOCPSET					EE_REALOVPSET + sizeof(float)		// 55
#define EE_REALOPPSET					EE_REALOCPSET + sizeof(float)		// 59
#define EE_R485BAUD						EE_REALOPPSET + sizeof(float)		// 63
#define EE_RS485PARITYDATABITS			EE_R485BAUD + sizeof(uint8_t)		// 64
#define EE_RS485STOPBITS				EE_RS485PARITYDATABITS + sizeof(uint8_t) // 65
#define EE_R232BAUD						EE_RS485STOPBITS + sizeof(uint8_t)		 // 66
#define EE_RS232PARITYDATABITS			EE_R232BAUD + sizeof(uint8_t)			 // 67
#define EE_RS232STOPBITS				EE_RS232PARITYDATABITS + sizeof(uint8_t) // 68
#define EE_PROTSW						EE_RS232STOPBITS + sizeof(uint8_t)		 // 69

#define EE_USER_EXTCALV_0				(EE_PROTSW + sizeof(uint8_t))			 // 70
#define EE_USER_EXTCALV_1				(EE_USER_EXTCALV_0 + sizeof(float))		 // 74
#define EE_USER_EXTCALVAD_0				(EE_USER_EXTCALV_1 + sizeof(float))		 // 78
#define EE_USER_EXTCALVAD_1				(EE_USER_EXTCALVAD_0 + sizeof(uint16_t)) // 80
#define EE_USER_EXTCALI_0				(EE_USER_EXTCALVAD_1 + sizeof(uint16_t)) // 82
#define EE_USER_EXTCALI_1				(EE_USER_EXTCALI_0 + sizeof(float))		 // 86
#define EE_USER_EXTCALIAD_0				(EE_USER_EXTCALI_1 + sizeof(float))		 // 90
#define EE_USER_EXTCALIAD_1				(EE_USER_EXTCALIAD_0 + sizeof(uint16_t)) // 92
#define EE_USER_CHECKSUM				(EE_USER_EXTCALIAD_1 + sizeof(uint16_t)) // 94

#define EE_FAT_EXTCALV_0				(EE_USER_CHECKSUM + sizeof(uint8_t))	 // 95
#define EE_FAT_EXTCALV_1				(EE_FAT_EXTCALV_0 + sizeof(float))		 // 99
#define EE_FAT_EXTCALVAD_0				(EE_FAT_EXTCALV_1 + sizeof(float))		 // 103
#define EE_FAT_EXTCALVAD_1				(EE_FAT_EXTCALVAD_0 + sizeof(uint16_t))	 // 105
#define EE_FAT_EXTCALI_0				(EE_FAT_EXTCALVAD_1 + sizeof(uint16_t))	 // 107
#define EE_FAT_EXTCALI_1				(EE_FAT_EXTCALI_0 + sizeof(float))		 // 111
#define EE_FAT_EXTCALIAD_0				(EE_FAT_EXTCALI_1 + sizeof(float))		 // 115
#define EE_FAT_EXTCALIAD_1				(EE_FAT_EXTCALIAD_0 + sizeof(uint16_t))	 // 117
#define EE_FAT_CHECKSUM					(EE_FAT_EXTCALIAD_1 + sizeof(uint16_t))  // 119

#define EE_PARALLELMODE					EE_FAT_CHECKSUM + sizeof(uint8_t)		 // 120
#define EE_PARALLELROLE					EE_PARALLELMODE + sizeof(uint8_t)		 // 121
#define EE_CHAINMODE					EE_PARALLELROLE + sizeof(uint8_t)		 // 122
#define EE_CHAINADDR					EE_CHAINMODE + sizeof(uint8_t) 			 // 123
#define EE_GPIBADDR						EE_CHAINADDR + sizeof(uint8_t)			 // 124
#define EE_LANIPMODE					EE_GPIBADDR	+ sizeof(uint8_t)  			 // 125 AUTO or MENUAL
#define EE_LANIPADDR					EE_LANIPMODE + sizeof(uint8_t)			 // 126
#define EE_LANMASK						EE_LANIPADDR + 4						 // 130
#define EE_LANGATEWAY					EE_LANMASK + 4							 // 134
#define EE_SERIALNUMBER					EE_LANGATEWAY + 4					     // 138 20 characters
#define EE_SRVSET						EE_SERIALNUMBER + 20					 // 158
#define EE_SRISET						EE_SRVSET + sizeof(float)				 // 162
#define EE_MACADDRESS					(EE_SRISET + sizeof(float))				 // 166
#define EE_MANUFACTURE					(EE_MACADDRESS + 6)						 // 172
#define EE_MODEL						(EE_MANUFACTURE + 20)						 // 192
#define EE_KEYTYPE						(EE_MODEL + 20)							 // 202
#define EE_TIMERHR						EE_KEYTYPE + sizeof(uint8_t)			 // 203
#define EE_TIMERMN						EE_TIMERHR + sizeof(uint16_t)			 // 205
#define EE_TIMERSE						EE_TIMERMN + sizeof(uint8_t)			 // 206

#define EE_USER_VOLTAGERESCURR			(EE_TIMERSE + sizeof(uint8_t)) 			 // 207
#define EE_USER_CURRENTRESCURR			(EE_USER_VOLTAGERESCURR + sizeof(float)) // 211

#define EE_FAT_VOLTAGERESCURR			(EE_USER_CURRENTRESCURR + sizeof(float)) // 215
#define EE_FAT_CURRENTRESCURR			(EE_FAT_VOLTAGERESCURR + sizeof(float))	 // 219
#define EE_PATTERNCHECKSUM				EE_FAT_CURRENTRESCURR + sizeof(float)

#define EE_CURSORONOFF					EE_PATTERNCHECKSUM + 10



#define STEPMAX  						100
#define PROGRAMGROUP					10

#define EE_PROGRAM_ACT					0														// 0	(O_ϥ)
#define EE_PROGRAM_VOLTAGE				(EE_PROGRAM_ACT + sizeof(uint8_t))						// 1
#define EE_PROGRAM_CURRENT				(EE_PROGRAM_VOLTAGE + sizeof(uint16_t))					// 3
#define EE_PROGRAM_TIMER     			(EE_PROGRAM_CURRENT + sizeof(uint16_t))					// 5
#define SIZEOF_STEP_PACKET				(EE_PROGRAM_TIMER + sizeof(uint16_t))					// 7
#define EE_PROGRAMGROUP_REPEAT			((SIZEOF_STEP_PACKET * STEPMAX) * PROGRAMGROUP)			// 7 * 100 * 10 = 7000
#define EE_LINKNUMBERGROUP				(EE_PROGRAMGROUP_REPEAT + (PROGRAMGROUP * sizeof(uint16_t)))	// 7000 + (10 *2) = 7020 
#define EE_PROGRAMGROUP  				( EE_LINKNUMBERGROUP + (PROGRAMGROUP * sizeof(uint8_t)))  // 7020 + ( 10 * 1 ) = 7030

/* memory Group start from 	EE_PROGRAMGROUP + (PROGRAMGROUP * sizeof(uint8_t)) = 7030 + (10 * 1) = 7040 */

#define TOTALNUMBER						10
//#define MEMGROUP						10

#define EE_VSET							0														// 0
#define EE_ISET							(EE_VSET + sizeof(uint16_t))							// 2
#define EE_OVPSET						(EE_ISET + sizeof(uint16_t))							// 4
#define EE_OCPSET						(EE_OVPSET + sizeof(uint16_t))							// 6
#define EE_OPPSET						(EE_OCPSET + sizeof(uint16_t))							// 8
#define EE_PROTECTSW					(EE_OPPSET + sizeof(uint16_t))						   	// 10
#define SIZEOF_MEM_PACKET				(EE_PROTECTSW + sizeof(uint8_t))					// 11
 


#define EE_MEMORY_GROUP					(EE_PROGRAMGROUP + (PROGRAMGROUP * sizeof(uint8_t)))   // 7030 + (10 *1) = 7040
#define END_OF_MEMORY_GROUP				(EE_MEMORY_GROUP + (SIZEOF_MEM_PACKET * TOTALNUMBER) * 10)	// 7040 + (11 * 10) * 10 = 8140



#define EE_SPEC							0x1FFB
#define EE_CHKPAD						0x1FFD		// EEPROM O_եL

#define CHKPAD1							(0x2A+1)
#define CHKPAD2							(0x74+1)
#define CHKPAD3							(0x5E+1)

#define SWAPCHKPAD1						0xA2
#define SWAPCHKPAD2						0x47
#define SWAPCHKPAD3						0xE5


//#if    END_OF_MEMORY_GROUP > EE_CHKPAD
//#error "EEPROM OUT OF RANGE!!!!!!!!!!!!!!!"
//#endif












extern uint32_t stateChangeFlag; 
extern uint32_t stateChangeFlag1;
extern uint32_t stateChangeFlag2;



#define IS_CHANGE    	            (stateChangeFlag & (BIT0))	  /* AO_nܧ */
#define SET_CHANGE		            (stateChangeFlag |= (BIT0))
#define CLR_CHANGE                  (stateChangeFlag &= ~(BIT0))

#define IS_SETTING    	            (stateChangeFlag & (BIT1))	  /* O_iHJƦr */
#define SET_SETTING		            (stateChangeFlag |= (BIT1))	  // iHJ
#define CLR_SETTING                  (stateChangeFlag &= ~(BIT1))

#define IS_NUMBER    	            (stateChangeFlag & (BIT2))	  /* }ls */
#define SET_NUMBER		            (stateChangeFlag |= (BIT2))	  // Ĥ@J
#define CLR_NUMBER                  (stateChangeFlag &= ~(BIT2))

#define IS_STRING    	            (stateChangeFlag & (BIT3))	  /* O_rק   IS_SETTIN ft */
#define SET_STRING		            (stateChangeFlag |= (BIT3))	  // iHJ
#define CLR_STRING                  (stateChangeFlag &= ~(BIT3))

#define IS_CAL_NOW			        (stateChangeFlag & (BIT4))	  /* }lե*/
#define SET_CAL_NOW					(stateChangeFlag |= (BIT4))	  // 
#define CLR_CAL_NOW        			(stateChangeFlag &= ~(BIT4))

#define IS_EXT_V_LOW		        (stateChangeFlag & (BIT5))	  /*  */
#define SET_EXT_V_LOW				(stateChangeFlag |= (BIT5))	  // 
#define CLR_EXT_V_LOW		        (stateChangeFlag &= ~(BIT5))

#define IS_FAT_CAL			        (stateChangeFlag & (BIT6))	  /* t iJA ٥ */
#define SET_FAT_CAL					(stateChangeFlag |= (BIT6))	  // 
#define CLR_FAT_CAL			        (stateChangeFlag &= ~(BIT6))

#define IS_TIMER_COUNT_IS_READY     (stateChangeFlag & (BIT7))	  /*  */
#define SET_TIMER_COUNT_IS_READY	(stateChangeFlag |= (BIT7))	  // 
#define CLR_TIMER_COUNT_IS_READY    (stateChangeFlag &= ~(BIT7))

#define IS_ENTRY_PROGRAMEDIT     	(stateChangeFlag & (BIT8))	  /*  */
#define SET_ENTRY_PROGRAMEDIT		(stateChangeFlag |= (BIT8))	  // 
#define CLR_ENTRY_PROGRAMEDIT    	(stateChangeFlag &= ~(BIT8))

#define IS_VOLTAGE_FINISH	     	(stateChangeFlag & (BIT9))	  /*  */
#define SET_VOLTAGE_FINISH			(stateChangeFlag |= (BIT9))	  // 
#define CLR_VOLTAGE_FINISH    		(stateChangeFlag &= ~(BIT9))

#define IS_CURRENT_FINISH	     	(stateChangeFlag & (BIT10))	  /*  */
#define SET_CURRENT_FINISH			(stateChangeFlag |= (BIT10))	  // 
#define CLR_CURRENT_FINISH    		(stateChangeFlag &= ~(BIT10))

#define IS_TIMER_COUNT_IS_READY2     (stateChangeFlag & (BIT11))	  /*  */
#define SET_TIMER_COUNT_IS_READY2	(stateChangeFlag |= (BIT11))	  // 
#define CLR_TIMER_COUNT_IS_READY2    (stateChangeFlag &= ~(BIT11))

#define IS_CURSOR_FLAG			     (stateChangeFlag & (BIT12))	  /*  cursor u@ */
#define SET_CURSOR_FLAG				(stateChangeFlag |= (BIT12))	  // 
#define CLR_CURSOR_FLAG    			(stateChangeFlag &= ~(BIT12))

#define IS_EXT_I_LOW			     (stateChangeFlag & (BIT13))	  /* PMBq error */
#define SET_EXT_I_LOW				(stateChangeFlag |= (BIT13))	  // 
#define CLR_EXT_I_LOW   			(stateChangeFlag &= ~(BIT13))

#define IS_DEBUG			    	 (stateChangeFlag & (BIT14))	  /* PMBq debuf */
#define SET_DEBUG					(stateChangeFlag |= (BIT14))	  // 
#define CLR_DEBUG		   			(stateChangeFlag &= ~(BIT14))

#define IS_MB_ERROR				    (stateChangeFlag & (BIT15))		  /* PFC ERROR */
#define SET_MB_ERROR				(stateChangeFlag |= (BIT15))	  // 
#define CLR_MB_ERROR		   		(stateChangeFlag &= ~(BIT15))

#define IS_FROM_MENU		    	(stateChangeFlag & (BIT16))		  /*  OVP OCP OPP Oq menu key ٬O ~ i */
#define SET_FROM_MENU				(stateChangeFlag |= (BIT16))	  // 
#define CLR_FROM_MENU		   		(stateChangeFlag &= ~(BIT16))

#define IS_FAT_FINAL_CAL	        (stateChangeFlag & (BIT17))	  /* t uǵU*/
#define SET_FAT_FINAL_CAL			(stateChangeFlag |= (BIT17))	  // 
#define CLR_FAT_FINAL_CAL	        (stateChangeFlag &= ~(BIT17))

#define IS_BACKUP_SCREEN	        (stateChangeFlag & (BIT18))	  /* E7 ~T */
#define SET_BACKUP_SCREEN			(stateChangeFlag |= (BIT18))	  // 
#define CLR_BACKUP_SCREEN	        (stateChangeFlag &= ~(BIT18))

#define IS_SCPIEXTCAL_VOLT	        (stateChangeFlag & (BIT19))	  /* SCPI EXT VOLT CAL use*/
#define SET_SCPIEXTCAL_VOLT			(stateChangeFlag |= (BIT19))	  // 
#define CLR_SCPIEXTCAL_VOLT	        (stateChangeFlag &= ~(BIT19))

#define IS_SCPIEXTCAL_CURR	        (stateChangeFlag & (BIT20))	  /* SCPI EXT CURRENT CAL use*/
#define SET_SCPIEXTCAL_CURR			(stateChangeFlag |= (BIT20))	  // 
#define CLR_SCPIEXTCAL_CURR	        (stateChangeFlag &= ~(BIT20))

#define IS_SHOW_ENA			        (stateChangeFlag & (BIT21))	  /* indecate enable+  enable- short*/
#define SET_SHOW_ENA				(stateChangeFlag |= (BIT21))	  // 
#define CLR_SHOW_ENA		        (stateChangeFlag &= ~(BIT21))

#define IS_SHOW_SO			        (stateChangeFlag & (BIT22))	  /* indecate SO */
#define SET_SHOW_SO					(stateChangeFlag |= (BIT22))	  // 
#define CLR_SHOW_SO		        	(stateChangeFlag &= ~(BIT22))

#define IS_MODEL_CONFLICT    	     (stateChangeFlag & (BIT23))	  /*  */
#define SET_MODEL_CONFLICT  		(stateChangeFlag |= (BIT23))	  // 
#define CLR_MODEL_CONFLICT 	        (stateChangeFlag &= ~(BIT23))

#define IS_PARALLELMODE_SLAVE_ERROR_CONNECT      (stateChangeFlag & (BIT24))	  /*  */
#define SET_PARALLELMODE_SLAVE_ERROR_CONNECT		(stateChangeFlag |= (BIT24))	  // 
#define CLR_PARALLELMODE_SLAVE_ERROR_CONNECT    	(stateChangeFlag &= ~(BIT24))


#define IS_HTTP_DATA_COUNT    	     (stateChangeFlag & (BIT25))	  /* gpib set data */
#define SET_HTTP_DATA_COUNT			 (stateChangeFlag |= (BIT25))	  // 
#define CLR_HTTP_DATA_COUNT 	     (stateChangeFlag &= ~(BIT25))

#define IS_GPIB_HTTP_SCPI_PACKET   	    (stateChangeFlag & (BIT26))	  
#define SET_GPIB_HTTP_SCPI_PACKET		(stateChangeFlag |= (BIT26))	  // 
#define CLR_GPIB_HTTP_SCPI_PACKET       (stateChangeFlag &= ~(BIT26))

#define IS_GPIB_VSET_PACKET   	    (stateChangeFlag & (BIT27))	  
#define SET_GPIB_VSET_PACKET		(stateChangeFlag |= (BIT27))	  // 
#define CLR_GPIB_VSET_PACKET       	(stateChangeFlag &= ~(BIT27))

#define IS_GPIB_ISET_PACKET   	    (stateChangeFlag & (BIT28))	  
#define SET_GPIB_ISET_PACKET		(stateChangeFlag |= (BIT28))	  // 
#define CLR_GPIB_ISET_PACKET       	(stateChangeFlag &= ~(BIT28))

#define IS_GPIB_OUTPUTSTATUS_PACKET   	(stateChangeFlag & (BIT29))	  
#define SET_GPIB_OUTPUTSTATUS_PACKET	(stateChangeFlag |= (BIT29))	  // 
#define CLR_GPIB_OUTPUTSTATUS_PACKET    (stateChangeFlag &= ~(BIT29))

#define IS_GPIB_OVPSET_PACKET   	    (stateChangeFlag & (BIT30))	  
#define SET_GPIB_OVPSET_PACKET			(stateChangeFlag |= (BIT30))	  // 
#define CLR_GPIB_OVPSET_PACKET       	(stateChangeFlag &= ~(BIT30))

#define IS_GPIB_OCPSET_PACKET   	    (stateChangeFlag & (BIT31))	  
#define SET_GPIB_OCPSET_PACKET			(stateChangeFlag |= (BIT31))	  // 
#define CLR_GPIB_OCPSET_PACKET       	(stateChangeFlag &= ~(BIT31))

#define IS_GPIB_SRVSET_PACKET   	    (stateChangeFlag1 & (BIT0))	  
#define SET_GPIB_SRVSET_PACKET			(stateChangeFlag1 |= (BIT0))	  // 
#define CLR_GPIB_SRVSET_PACKET       	(stateChangeFlag1 &= ~(BIT0))

#define IS_GPIB_SRISET_PACKET   	    (stateChangeFlag1 & (BIT1))	  
#define SET_GPIB_SRISET_PACKET			(stateChangeFlag1 |= (BIT1))	  // 
#define CLR_GPIB_SRISET_PACKET       	(stateChangeFlag1 &= ~(BIT1))

#define IS_GPIB_PROTSW_PACKET   	    (stateChangeFlag1 & (BIT2))	  
#define SET_GPIB_PROTSW_PACKET			(stateChangeFlag1 |= (BIT2))	  // 
#define CLR_GPIB_PROTSW_PACKET       	(stateChangeFlag1 &= ~(BIT2))

#define IS_GPIB_OPPSET_PACKET   	    (stateChangeFlag1 & (BIT3))	  
#define SET_GPIB_OPPSET_PACKET			(stateChangeFlag1 |= (BIT3))	  // 
#define CLR_GPIB_OPPSET_PACKET       	(stateChangeFlag1 &= ~(BIT3))

#define IS_GPIB_VMAX_PACKET 	  	    (stateChangeFlag1 & (BIT4))	  
#define SET_GPIB_VMAX_PACKET			(stateChangeFlag1 |= (BIT4))	  // 
#define CLR_GPIB_VMAX_PACKET    	   	(stateChangeFlag1 &= ~(BIT4))

#define IS_GPIB_VMIN_PACKET   	 	   (stateChangeFlag1 & (BIT5))	  
#define SET_GPIB_VMIN_PACKET			(stateChangeFlag1 |= (BIT5))	  // 
#define CLR_GPIB_VMIN_PACKET    	   	(stateChangeFlag1 &= ~(BIT5))

#define IS_GPIB_IMAX_PACKET 	  	    (stateChangeFlag1 & (BIT6))	  
#define SET_GPIB_IMAX_PACKET			(stateChangeFlag1 |= (BIT6))	  // 
#define CLR_GPIB_IMAX_PACKET    	   	(stateChangeFlag1 &= ~(BIT6))

#define IS_GPIB_IMIN_PACKET   	    	(stateChangeFlag1 & (BIT7))	  
#define SET_GPIB_IMIN_PACKET			(stateChangeFlag1 |= (BIT7))	  // 
#define CLR_GPIB_IMIN_PACKET       		(stateChangeFlag1 &= ~(BIT7))

#define IS_RESTART_GPIB  		    	(stateChangeFlag1 & (BIT8))	  
#define SET_RESTART_GPIB  				(stateChangeFlag1 |= (BIT8))	  // 
#define CLR_RESTART_GPIB  	       		(stateChangeFlag1 &= ~(BIT8))

#define IS_POWEROFF_MESSAGE   		    (stateChangeFlag1 & (BIT9))	  
#define SET_POWEROFF_MESSAGE			(stateChangeFlag1 |= (BIT9))	  // 
#define CLR_POWEROFF_MESSAGE      		(stateChangeFlag1 &= ~(BIT9))


#define IS_SCPI_CAL				   	    (stateChangeFlag1 & (BIT10))	  
#define SET_SCPI_CAL					(stateChangeFlag1 |= (BIT10))	  // 
#define CLR_SCPI_CAL		      		(stateChangeFlag1 &= ~(BIT10))

#define IS_FIX_CURSOR				   	(stateChangeFlag1 & (BIT11))	  
#define SET_FIX_CURSOR					(stateChangeFlag1 |= (BIT11))	  // 
#define CLR_FIX_CURSOR   				(stateChangeFlag1 &= ~(BIT11))

#define IS_START_SCPIOVPOCP_CAL		   	(stateChangeFlag1 & (BIT12))	  
#define SET_START_SCPIOVPOCP_CAL		(stateChangeFlag1 |= (BIT12))	  // 
#define CLR_START_SCPIOVPOCP_CAL		(stateChangeFlag1 &= ~(BIT12))

#define IS_GPIB_ADDR				   	(stateChangeFlag1 & (BIT13))	  
#define SET_GPIB_ADDR					(stateChangeFlag1 |= (BIT13))	  // 
#define CLR_GPIB_ADDR					(stateChangeFlag1 &= ~(BIT13))

#define IS_TRANSPARENT_GPIBL_DOWNLOAD  	(stateChangeFlag1 & (BIT14))	  
#define SET_TRANSPARENT_GPIBL_DOWNLOAD	(stateChangeFlag1 |= (BIT14))	  // 
#define CLR_TRANSPARENT_GPIBL_DOWNLOAD	(stateChangeFlag1 &= ~(BIT14))

#define IS_GPIB_BLOCK				   	(stateChangeFlag1 & (BIT15))	  
#define SET_GPIB_BLOCK					(stateChangeFlag1 |= (BIT15))	  // 
#define CLR_GPIB_BLOCK					(stateChangeFlag1 &= ~(BIT15))

#define IS_SHOW_VERSION				   	(stateChangeFlag1 & (BIT16))	  
#define SET_SHOW_VERSION				(stateChangeFlag1 |= (BIT16))	  // 
#define CLR_SHOW_VERSION				(stateChangeFlag1 &= ~(BIT16))


#define IS_SLAVE_CONFIGURED			   	(stateChangeFlag1 & (BIT17))	  
#define SET_SLAVE_CONFIGURED				(stateChangeFlag1 |= (BIT17))	  // 
#define CLR_SLAVE_CONFIGURED				(stateChangeFlag1 &= ~(BIT17))

#define IS_ACK						   	(stateChangeFlag1 & (BIT17))	  
#define SET_ACK							(stateChangeFlag1 |= (BIT17))	  // 
#define CLR_ACK							(stateChangeFlag1 &= ~(BIT17))

#define IS_UPDATE_SLAVE_VSET		   	(stateChangeFlag1 & (BIT18))	  
#define SET_UPDATE_SLAVE_VSET			(stateChangeFlag1 |= (BIT18))	  // 
#define CLR_UPDATE_SLAVE_VSET			(stateChangeFlag1 &= ~(BIT18))

#define IS_UPDATE_SLAVE_ISET		   	(stateChangeFlag1 & (BIT19))	  
#define SET_UPDATE_SLAVE_ISET			(stateChangeFlag1 |= (BIT19))	  // 
#define CLR_UPDATE_SLAVE_ISET			(stateChangeFlag1 &= ~(BIT19))

#define IS_USB_RESTART				   	(stateChangeFlag1 & (BIT20))	  
#define SET_USB_RESTART					(stateChangeFlag1 |= (BIT20))	  // 
#define CLR_USB_RESTART					(stateChangeFlag1 &= ~(BIT20))

#define IS_MEASURE_FAULT			   	(stateChangeFlag1 & (BIT21))	  
#define SET_MEASURE_FAULT				(stateChangeFlag1 |= (BIT21))	  // 
#define CLR_MEASURE_FAULT				(stateChangeFlag1 &= ~(BIT21))


#define IS_RECALL_PARAM				   	(stateChangeFlag1 & (BIT22))	  
#define SET_RECALL_PARAM				(stateChangeFlag1 |= (BIT22))	  // 
#define CLR_RECALL_PARAM				(stateChangeFlag1 &= ~(BIT22))

#define IS_MULTI_MASTER					   	(stateChangeFlag1 & (BIT23))	  
#define SET_MULTI_MASTER					(stateChangeFlag1 |= (BIT23))	  // 
#define CLR_MULTI_MASTER					(stateChangeFlag1 &= ~(BIT23))

#define IS_PREVENT_TO_JAM					   	(stateChangeFlag2 & (BIT0))	  
#define SET_PREVENT_TO_JAM						(stateChangeFlag2 |= (BIT0))	  // 
#define CLR_PREVENT_TO_JAM						(stateChangeFlag2 &= ~(BIT0))

#define IS_receivedRS485Packet			   	(stateChangeFlag2 & (BIT1))	  
#define SET_receivedRS485Packet				(stateChangeFlag2 |= (BIT1))	  // 
#define CLR_receivedRS485Packet				(stateChangeFlag2 &= ~(BIT1))


#define IS_RS485_CHAIN_MASTER			   	(stateChangeFlag2 & (BIT2))	  
#define SET_RS485_CHAIN_MASTER				(stateChangeFlag2 |= (BIT2))	  // 
#define CLR_RS485_CHAIN_MASTER				(stateChangeFlag2 &= ~(BIT2))

#define IS_RS485_DETECT_HOLD_BUS		   	(stateChangeFlag2 & (BIT3))	  
#define SET_RS485_DETECT_HOLD_BUS			(stateChangeFlag2 |= (BIT3))	  // 
#define CLR_RS485_DETECT_HOLD_BUS			(stateChangeFlag2 &= ~(BIT3))

#define IS_RS485_BROADCAST_ECHO			   	(stateChangeFlag2 & (BIT4))	  	  // 
#define SET_RS485_BROADCAST_ECHO			(stateChangeFlag2 |= (BIT4))	  // 
#define CLR_RS485_BROADCAST_ECHO			(stateChangeFlag2 &= ~(BIT4))


#define IS_RS485_QUERY_VI_BUSY			   	(stateChangeFlag2 & (BIT5))	  	  // 
#define SET_RS485_QUERY_VI_BUSY				(stateChangeFlag2 |= (BIT5))	  // 
#define CLR_RS485_QUERY_VI_BUSY				(stateChangeFlag2 &= ~(BIT5))

#define IS_PARALLEL_OVPSWITCH			   	(stateChangeFlag2 & (BIT6))	  	  // 
#define SET_PARALLEL_OVPSWITCH				(stateChangeFlag2 |= (BIT6))	  // 
#define CLR_PARALLEL_OVPSWITCH				(stateChangeFlag2 &= ~(BIT6))

#define IS_PARALLEL_OCPSWITCH			   	(stateChangeFlag2 & (BIT7))	  	  // 
#define SET_PARALLEL_OCPSWITCH				(stateChangeFlag2 |= (BIT7))	  // 
#define CLR_PARALLEL_OCPSWITCH				(stateChangeFlag2 &= ~(BIT7))

#define IS_PARALLEL_OPPSWITCH			   	(stateChangeFlag2 & (BIT8))	  	  // 
#define SET_PARALLEL_OPPSWITCH				(stateChangeFlag2 |= (BIT8))	  // 
#define CLR_PARALLEL_OPPSWITCH				(stateChangeFlag2 &= ~(BIT8))

#define IS_PARALLEL_GPVPARM				   	(stateChangeFlag2 & (BIT9))	  	  // 
#define SET_PARALLEL_GPVPARM				(stateChangeFlag2 |= (BIT9))	  // 
#define CLR_PARALLEL_GPVPARM				(stateChangeFlag2 &= ~(BIT9))

#define IS_PARALLEL_GPVSTATE			   	(stateChangeFlag2 & (BIT10))	  	  // 
#define SET_PARALLEL_GPVSTATE				(stateChangeFlag2 |= (BIT10))	  // 
#define CLR_PARALLEL_GPVSTATE				(stateChangeFlag2 &= ~(BIT10))

#define IS_PARALLELMODE_SLAVE_NOT_FOUND     (stateChangeFlag2 & (BIT11))	  /*  */
#define SET_PARALLELMODE_SLAVE_NOT_FOUND	(stateChangeFlag2 |= (BIT11))	  // 
#define CLR_PARALLELMODE_SLAVE_NOT_FOUND    (stateChangeFlag2 &= ~(BIT11))

#define IS_ONOFF_CMD_AGAIN				    (stateChangeFlag2 & (BIT12))	  /*  */
#define SET_ONOFF_CMD_AGAIN					(stateChangeFlag2 |= (BIT12))	  // 
#define CLR_ONOFF_CMD_AGAIN    				(stateChangeFlag2 &= ~(BIT12))

#define IS_DYNAMIC_ADJUST				    (stateChangeFlag2 & (BIT13))	  /*  */
#define SET_DYNAMIC_ADJUST					(stateChangeFlag2 |= (BIT13))	  // 
#define CLR_DYNAMIC_ADJUST    				(stateChangeFlag2 &= ~(BIT13))

#define IS_VSET_CMD_AGAIN				    (stateChangeFlag2 & (BIT14))	  /*  */
#define SET_VSET_CMD_AGAIN					(stateChangeFlag2 |= (BIT14))	  // 
#define CLR_VSET_CMD_AGAIN    				(stateChangeFlag2 &= ~(BIT14))

#define IS_PARALLEL_PROTECT		    		(stateChangeFlag2 & (BIT15))		  /* parallel mode protect ERROR */
#define SET_PARALLEL_PROTECT				(stateChangeFlag2 |= (BIT15))	  // 
#define CLR_PARALLEL_PROTECT		   		(stateChangeFlag2 &= ~(BIT15))

#define IS_PVSSHDSIMMOD_ON	    		(stateChangeFlag2 & (BIT16))		  /* pvs shadow modw on/off */
#define SET_PVSSHDSIMMOD_ON				(stateChangeFlag2 |= (BIT16))	  // 
#define CLR_PVSSHDSIMMOD_ON		   		(stateChangeFlag2 &= ~(BIT16))

#define IS_VFD_TOO_HIGH		    		(stateChangeFlag2 & (BIT17))		  /* pvs shadow modw on/off */
#define SET_VFD_TOO_HIGH				(stateChangeFlag2 |= (BIT17))	  // 
#define CLR_VFD_TOO_HIGH		   		(stateChangeFlag2 &= ~(BIT17))

#define IS_SCPI_RESET		    		(stateChangeFlag2 & (BIT18))		  /*  */
#define SET_SCPI_RESET				  (stateChangeFlag2 |= (BIT18))	  // 
#define CLR_SCPI_RESET		   		(stateChangeFlag2 &= ~(BIT18))


void readParameter(void);
void recall(uint8_t num);
void save(uint8_t num);
void clearProgram(uint8_t num);



#endif



