#ifndef _HARDWARE_H
#define _HARDWARE_H
#
#include <stdint.h>
#include "stm32f2xx.h"


#define VFD_FREQI	14000		 // 32K
#define VFD_FREQ	14000		 // 24K

extern uint8_t VFDflag;

typedef enum 
{
  COM1 = 0, COM2 ,COM3,COM4,COM5,COM6,INITCOM
} COM_TypeDef;   

  /** @addtogroup STM322xG_EVAL_LOW_LEVEL_COM
  * @{
  */
#define COMn                             6

/**
 * @brief Definition for COM port1, connected to USART1
 */ 
#define EVAL_COM1                        USART1
#define EVAL_COM1_CLK                    RCC_APB2Periph_USART1
#define EVAL_COM1_TX_PIN                 GPIO_Pin_6
#define EVAL_COM1_TX_GPIO_PORT           GPIOB
#define EVAL_COM1_TX_GPIO_CLK            RCC_AHB1Periph_GPIOB
#define EVAL_COM1_TX_SOURCE              GPIO_PinSource6
#define EVAL_COM1_TX_AF                  GPIO_AF_USART1
#define EVAL_COM1_RX_PIN                 GPIO_Pin_7
#define EVAL_COM1_RX_GPIO_PORT           GPIOB
#define EVAL_COM1_RX_GPIO_CLK            RCC_AHB1Periph_GPIOB
#define EVAL_COM1_RX_SOURCE              GPIO_PinSource7
#define EVAL_COM1_RX_AF                  GPIO_AF_USART1
#define EVAL_COM1_IRQn                   USART1_IRQn


 /**
  * @brief Definition for COM2, connector to USART2}
  */ 
#define EVAL_COM2                        USART2
#define EVAL_COM2_CLK                    RCC_APB1Periph_USART2
#define EVAL_COM2_TX_PIN                 GPIO_Pin_5
#define EVAL_COM2_TX_GPIO_PORT           GPIOD
#define EVAL_COM2_TX_GPIO_CLK            RCC_AHB1Periph_GPIOD
#define EVAL_COM2_TX_SOURCE              GPIO_PinSource5
#define EVAL_COM2_TX_AF                  GPIO_AF_USART2
#define EVAL_COM2_RX_PIN                 GPIO_Pin_6
#define EVAL_COM2_RX_GPIO_PORT           GPIOD
#define EVAL_COM2_RX_GPIO_CLK            RCC_AHB1Periph_GPIOD
#define EVAL_COM2_RX_SOURCE              GPIO_PinSource6
#define EVAL_COM2_RX_AF                  GPIO_AF_USART2
#define EVAL_COM2_IRQn                   USART2_IRQn

/**
  * @brief Definition for COM3, connector to USART3}
  */ 
#if (HARDWARE_VERSION >= VERSION_C)

#define EVAL_COM3                        USART3
#define EVAL_COM3_CLK                    RCC_APB1Periph_USART3
#define EVAL_COM3_TX_PIN                 GPIO_Pin_10
#define EVAL_COM3_TX_GPIO_PORT           GPIOB
#define EVAL_COM3_TX_GPIO_CLK            RCC_AHB1Periph_GPIOB
#define EVAL_COM3_TX_SOURCE              GPIO_PinSource10
#define EVAL_COM3_TX_AF                  GPIO_AF_USART3
#define EVAL_COM3_RX_PIN                 GPIO_Pin_11
#define EVAL_COM3_RX_GPIO_PORT           GPIOB
#define EVAL_COM3_RX_GPIO_CLK            RCC_AHB1Periph_GPIOB
#define EVAL_COM3_RX_SOURCE              GPIO_PinSource11
#define EVAL_COM3_RX_AF                  GPIO_AF_USART3
#define EVAL_COM3_IRQn                   USART3_IRQn


#else

#define EVAL_COM3                        USART3
#define EVAL_COM3_CLK                    RCC_APB1Periph_USART3
#define EVAL_COM3_TX_PIN                 GPIO_Pin_8
#define EVAL_COM3_TX_GPIO_PORT           GPIOD
#define EVAL_COM3_TX_GPIO_CLK            RCC_AHB1Periph_GPIOD
#define EVAL_COM3_TX_SOURCE              GPIO_PinSource8
#define EVAL_COM3_TX_AF                  GPIO_AF_USART3
#define EVAL_COM3_RX_PIN                 GPIO_Pin_9
#define EVAL_COM3_RX_GPIO_PORT           GPIOD
#define EVAL_COM3_RX_GPIO_CLK            RCC_AHB1Periph_GPIOD
#define EVAL_COM3_RX_SOURCE              GPIO_PinSource9
#define EVAL_COM3_RX_AF                  GPIO_AF_USART3
#define EVAL_COM3_IRQn                   USART3_IRQn

#endif
/**
  * @brief Definition for COM4, connector to USART4}
  */ 

#define EVAL_COM4                        UART4
#define EVAL_COM4_CLK                    RCC_APB1Periph_UART4
#define EVAL_COM4_TX_PIN                 GPIO_Pin_0
#define EVAL_COM4_TX_GPIO_PORT           GPIOA
#define EVAL_COM4_TX_GPIO_CLK            RCC_AHB1Periph_GPIOA
#define EVAL_COM4_TX_SOURCE              GPIO_PinSource0
#define EVAL_COM4_TX_AF                  GPIO_AF_UART4
#define EVAL_COM4_RX_PIN                 GPIO_Pin_1
#define EVAL_COM4_RX_GPIO_PORT           GPIOA
#define EVAL_COM4_RX_GPIO_CLK            RCC_AHB1Periph_GPIOA
#define EVAL_COM4_RX_SOURCE              GPIO_PinSource1
#define EVAL_COM4_RX_AF                  GPIO_AF_UART4
#define EVAL_COM4_IRQn                   UART4_IRQn
	 

/**
  * @brief Definition for COM5, connector to USART5}
  */

#define EVAL_COM5                        UART5
#define EVAL_COM5_CLK                    RCC_APB1Periph_UART5
#define EVAL_COM5_TX_PIN                 GPIO_Pin_12
#define EVAL_COM5_TX_GPIO_PORT           GPIOC
#define EVAL_COM5_TX_GPIO_CLK            RCC_AHB1Periph_GPIOC
#define EVAL_COM5_TX_SOURCE              GPIO_PinSource12
#define EVAL_COM5_TX_AF                  GPIO_AF_UART5
#define EVAL_COM5_RX_PIN                 GPIO_Pin_2
#define EVAL_COM5_RX_GPIO_PORT           GPIOD
#define EVAL_COM5_RX_GPIO_CLK            RCC_AHB1Periph_GPIOD
#define EVAL_COM5_RX_SOURCE              GPIO_PinSource2
#define EVAL_COM5_RX_AF                  GPIO_AF_UART5
#define EVAL_COM5_IRQn                   UART5_IRQn


/**
  * @brief Definition for COM6, connector to USART6}
  */ 

#define EVAL_COM6                        USART6
#define EVAL_COM6_CLK                    RCC_APB2Periph_USART6
#define EVAL_COM6_TX_PIN                 GPIO_Pin_6
#define EVAL_COM6_TX_GPIO_PORT           GPIOC
#define EVAL_COM6_TX_GPIO_CLK            RCC_AHB1Periph_GPIOC
#define EVAL_COM6_TX_SOURCE              GPIO_PinSource6
#define EVAL_COM6_TX_AF                  GPIO_AF_USART6
#define EVAL_COM6_RX_PIN                 GPIO_Pin_7
#define EVAL_COM6_RX_GPIO_PORT           GPIOC
#define EVAL_COM6_RX_GPIO_CLK            RCC_AHB1Periph_GPIOC
#define EVAL_COM6_RX_SOURCE              GPIO_PinSource7
#define EVAL_COM6_RX_AF                  GPIO_AF_USART6
#define EVAL_COM6_IRQn                   USART6_IRQn







extern DMA_Stream_TypeDef *USARTx_TX_DMAx_Streamx[COMn];
extern USART_TypeDef* COM_USART[COMn];
extern const uint8_t  COM_USART_IRQ[COMn];
extern const uint32_t USARTx_TX_DMA_CLK[COMn];
extern const uint32_t USARTx_TX_DMA_FLAG_FEIF[COMn];
extern const uint32_t USARTx_TX_DMA_FLAG_DMEIF[COMn];
extern const uint32_t USARTx_TX_DMA_FLAG_TEIF[COMn];
extern const uint32_t USARTx_TX_DMA_FLAG_HTIF[COMn];
extern const uint32_t USARTx_TX_DMA_FLAG_TCIF[COMn];

extern const uint32_t USARTx_TX_DMA_IT_FEIF[COMn];
extern const uint32_t USARTx_TX_DMA_IT_DMEIF[COMn];
extern const uint32_t USARTx_TX_DMA_IT_TEIF[COMn];
extern const uint32_t USARTx_TX_DMA_IT_HTIF[COMn];
extern const uint32_t USARTx_TX_DMA_IT_TCIF[COMn];

extern const uint32_t USARTx_TX_DMA_CHANNEL[COMn];
extern const uint32_t USARTx_TX_DR_ADDRESS[COMn];

extern const uint8_t  DMAx_Streamx_IRQn[COMn];





/** @addtogroup STM322xG_EVAL_LOW_LEVEL_I2C_EE
  * @{
  */
/**
  * @brief  I2C EEPROM Interface pins
  */  
#define sEE_I2C                          I2C1
#define sEE_I2C_CLK                      RCC_APB1Periph_I2C1
#define sEE_I2C_SCL_PIN                  GPIO_Pin_8                  /* PB.06 */
#define sEE_I2C_SCL_GPIO_PORT            GPIOB                       /* GPIOB */
#define sEE_I2C_SCL_GPIO_CLK             RCC_AHB1Periph_GPIOB
#define sEE_I2C_SCL_SOURCE               GPIO_PinSource8
#define sEE_I2C_SCL_AF                   GPIO_AF_I2C1
#define sEE_I2C_SDA_PIN                  GPIO_Pin_9                  /* PB.09 */
#define sEE_I2C_SDA_GPIO_PORT            GPIOB                       /* GPIOB */
#define sEE_I2C_SDA_GPIO_CLK             RCC_AHB1Periph_GPIOB
#define sEE_I2C_SDA_SOURCE               GPIO_PinSource9
#define sEE_I2C_SDA_AF                   GPIO_AF_I2C1
//#define sEE_M24C64_32


#define sEE_I2C_DMA                      DMA1   
#define sEE_I2C_DMA_CHANNEL              DMA_Channel_1
#define sEE_I2C_DMA_STREAM_TX            DMA1_Stream6
#define sEE_I2C_DMA_STREAM_RX            DMA1_Stream0   
#define sEE_I2C_DMA_CLK                  RCC_AHB1Periph_DMA1
#define sEE_I2C_DR_Address               ((uint32_t)0x40005410)	  	/* I2C1   0x4000 5400 - 0x4000 57FF  DR ofset 0x10 
																			  ҥHO 0x40005410 	*/
#define sEE_USE_DMA
   
#define sEE_I2C_DMA_TX_IRQn              DMA1_Stream6_IRQn
#define sEE_I2C_DMA_RX_IRQn              DMA1_Stream0_IRQn
#define sEE_I2C_DMA_TX_IRQHandler        DMA1_Stream6_IRQHandler
#define sEE_I2C_DMA_RX_IRQHandler        DMA1_Stream0_IRQHandler   
#define sEE_I2C_DMA_PREPRIO              1
#define sEE_I2C_DMA_SUBPRIO              1   
   
#define sEE_TX_DMA_FLAG_FEIF             DMA_FLAG_FEIF6
#define sEE_TX_DMA_FLAG_DMEIF            DMA_FLAG_DMEIF6
#define sEE_TX_DMA_FLAG_TEIF             DMA_FLAG_TEIF6
#define sEE_TX_DMA_FLAG_HTIF             DMA_FLAG_HTIF6
#define sEE_TX_DMA_FLAG_TCIF             DMA_FLAG_TCIF6
#define sEE_RX_DMA_FLAG_FEIF             DMA_FLAG_FEIF0
#define sEE_RX_DMA_FLAG_DMEIF            DMA_FLAG_DMEIF0
#define sEE_RX_DMA_FLAG_TEIF             DMA_FLAG_TEIF0
#define sEE_RX_DMA_FLAG_HTIF             DMA_FLAG_HTIF0
#define sEE_RX_DMA_FLAG_TCIF             DMA_FLAG_TCIF0
   
#define sEE_DIRECTION_TX                 0
#define sEE_DIRECTION_RX                 1  



  // DIO hardware define
#define EN485_LOW				GPIO_ResetBits(GPIOD, GPIO_Pin_4)
#define EN485_HIGH				GPIO_SetBits(GPIOD, GPIO_Pin_4)
#define SYNC485_LOW				GPIO_ResetBits(GPIOE, GPIO_Pin_2)
#define SYNC485_HIGH			GPIO_SetBits(GPIOE, GPIO_Pin_2)

#define IS_SYNC485				GPIO_ReadInputDataBit(GPIOE, GPIO_Pin_2)


//#define USB_485_PARA_LOW		GPIO_ResetBits(GPIOD, GPIO_Pin_3)
//#define USB_485_PARA_HIGH		GPIO_SetBits(GPIOD, GPIO_Pin_3)

#define HARDFAULT_TEST_LOW		GPIO_ResetBits(GPIOD, GPIO_Pin_2)
#define HARDFAULT_TEST_HIGH		GPIO_SetBits(GPIOD, GPIO_Pin_2)


#define VOL_RES_SEL_LOW			GPIO_ResetBits(GPIOE, GPIO_Pin_11)
#define VOL_RES_SEL_HIGH		GPIO_SetBits(GPIOE, GPIO_Pin_11)
#define IS_VOL_RES				GPIO_ReadOutputDataBit(GPIOE, GPIO_Pin_11)
#define CURR_RES_SEL_LOW		GPIO_ResetBits(GPIOE, GPIO_Pin_15)
#define CURR_RES_SEL_HIGH		GPIO_SetBits(GPIOE, GPIO_Pin_15)
#define IS_CURR_RES				GPIO_ReadOutputDataBit(GPIOE, GPIO_Pin_15)

#define POWER_OK_LOW			GPIO_ResetBits(GPIOE, GPIO_Pin_12)
#define POWER_OK_HIGH			GPIO_SetBits(GPIOE, GPIO_Pin_12)
#define LOCAL_ANALOG_STATE_LOW	GPIO_ResetBits(GPIOE, GPIO_Pin_13)
#define LOCAL_ANALOG_STATE_HIGH	GPIO_SetBits(GPIOE, GPIO_Pin_13)
#define CV_CC_STATE_LOW			GPIO_ResetBits(GPIOE, GPIO_Pin_14)
#define CV_CC_STATE_HIGH		GPIO_SetBits(GPIOE, GPIO_Pin_14)

#define ENABLE_CPU_PIN			GPIO_ReadInputDataBit(GPIOE, GPIO_Pin_8)
#define SHUTOFF_CPU_PIN			GPIO_ReadInputDataBit(GPIOE, GPIO_Pin_9)
#define LOCANA_CPU_PIN			GPIO_ReadInputDataBit(GPIOE, GPIO_Pin_10)



extern uint32_t   usbflags;

#define IS_USB_CONNECTBEEP           usbflags & BIT0
#define SET_USB_CONNECTBEEP          usbflags |= BIT0
#define CLR_USB_CONNECTBEEP          usbflags &= ~(BIT0)

#define IS_USB_DISCONNECTBEEP        usbflags & BIT1
#define SET_USB_DISCONNECTBEEP       usbflags |= BIT1
#define CLR_USB_DISCONNECTBEEP       usbflags &= ~(BIT1)

#define IS_VCP_CONNECT		         usbflags & BIT2
#define SET_VCP_CONNECT       		 usbflags |= BIT2
#define CLR_VCP_CONNECT       		 usbflags &= ~(BIT2)

#define IS_REINIT_VCP		         usbflags & BIT3
#define SET_REINIT_VCP       		 usbflags |= BIT3
#define CLR_REINIT_VCP       		 usbflags &= ~(BIT3)




extern __IO uint16_t ADCDualConvertedValue[4];
extern float YnADCDualConvertedValue[3];
extern float XnADCDualConvertedValue[3];
extern uint8_t PVDState;


void usbMessageBeep(void);

void beep(uint32_t time);
void stopBeep(void);
void flashBlock(uint8_t n);
void HVVoltage(void);
void TIM7_interruptInit(void);


void USARTx_Configuration(COM_TypeDef COM,USART_InitTypeDef* USART_InitStructure);
void initializeBoard(void);
/**
  * @brief  Configures COM port.
  * @param  COM: Specifies the COM port to be configured.
  *   This parameter can be one of following parameters:    
  *     @arg COM1
  *     @arg COM2  
  * @param  USART_InitStruct: pointer to a USART_InitTypeDef structure that
  *   contains the configuration information for the specified USART peripheral.
  * @retval None
  */
void STM_EVAL_COMInit(COM_TypeDef COM, USART_InitTypeDef* USART_InitStruct); 
void sEE_LowLevel_Init(void);
void sEE_LowLevel_DeInit(void);
void sEE_LowLevel_DMAConfig(uint32_t pBuffer, uint32_t BufferSize, uint32_t Direction);
void dacControl(uint8_t ch,uint16_t value,uint8_t onoff);
#define DAC_VOLTAGE	0
#define DAC_CURRENT	1

void initializeRs485(void); // RS485_CHANNEL
void initializeRs232(void); // 
void getAdCh(uint8_t ch);
void dispVFD48(uint8_t* string);
void initializePVS(void ); 											// RAM initialize


/* keyboard debounce */

#define FULL_COUNT	15//6
#define H_COUNT		10//4
#define L_COUNT		5//2
#define NO_COUNT	0//0

#define HIT			1
#define NO_HIT		0


/* outputStatus BIT define */

#define ON_STATE			BIT15
#define CV_STATE			BIT14
#define CC_STATE			BIT13
#define CP_STATE			BIT12
#define OVP_STATE			BIT11
#define OCP_STATE			BIT10
#define OPP_STATE			BIT9
#define CV_CC_STATE			BIT8
#define CC_CV_STATE			BIT7
#define CAL_BUSY_STATE		BIT6
#define HALF_POWER_STATE	BIT5   // 110V
#define THREEKW_POWER_STATE		BIT4	// 3KW
#define OTW_STATE			BIT3	// over temp warring



#define PROGRAM_REPEAT_MAX	99
#define PROGRAM_REPEAT_MIN	0

#define PROGRAM_STEP_MAX	100
#define PROGRAM_STEP_MIN	1






#define IS_EXCPOWER						(faultStatus & BIT0 )	 // 0:OK   1:FAIL
#define CLR_EXCPOWER					(faultStatus &= (~BIT0) )// 0:OK
#define IS_PFC_VIN_TOO_LOW	    		(faultStatus & BIT1 )	 // 0:OK   1:FAIL
#define CLR_PFC_VIN_TOO_LOW	    		(faultStatus &= (~BIT1) )// 0:OK
#define IS_PFC_VBUS_TOO_HIGH    		(faultStatus & BIT2 )	 // 0:OK   1:FAIL
#define CLR_PFC_VBUS_TOO_HIGH     		(faultStatus &= (~BIT2) )// 0:OK
#define IS_PFC_VBUS_NO_CHARGE    		(faultStatus & BIT3 )	 // 0:OK   1:FAIL
#define CLR_PFC_VBUS_NO_CHARGE    		(faultStatus &= (~BIT3) )// 0:OK
#define IS_PFC_MEMORY_FAIL	    		(faultStatus & BIT4 )	 // 0:OK   1:FAIL
#define CLR_PFC_MEMORY_FAIL	    		(faultStatus &= (~BIT4) )// 0:OK
#define IS_NTC_TOO_HIGH	    			(faultStatus & BIT5 )	 // 0:OK   1:FAIL
#define CLR_NTC_TOO_HIGH	    		(faultStatus &= (~BIT5) )// 0:OK
#define IS_FAN_ERROR		    		(faultStatus & BIT6 )	 // 0:OK   1:FAIL
#define CLR_FAN_ERROR		    		(faultStatus &= (~BIT6) )// 0:OK
#define IS_EXCOVP_ERROR		    		(faultStatus & BIT7 )	 // 0:OK   1:FAIL
#define CLR_EXCOVP_ERROR	    		(faultStatus &= (~BIT7) )// 0:OK
#define IS_EXCOCP_ERROR		    		(faultStatus & BIT8 )	 // 0:OK   1:FAIL
#define CLR_EXCOCP_ERROR	    		(faultStatus &= (~BIT8) )// 0:OK
#define IS_CAL_ERROR		    		(faultStatus & BIT9 )	 // 0:OK   1:FAIL
#define CLR_CAL_ERROR	    			(faultStatus &= (~BIT9) )// 0:OK
#define IS_AC_FREQ_ERROR		    	(faultStatus & BIT10 )	 // 0:OK   1:FAIL
#define CLR_AC_FREQ_ERROR	    		(faultStatus &= (~BIT10) )// 0:OK
#define IS_PFC_ERROR			    	(faultStatus & BIT11 )	 // 0:OK   1:FAIL
//#define CLR_PFC_ERROR	    			(faultStatus &= (~BIT11) )// 0:OK
#define IS_POWER_OFF			    	(faultStatus & BIT12 )	 // 0:OK   1:POWER OFF

//#define IS_OTP_PROTECT			    	(faultStatus & BIT13 )	 // 0:OK   1:OTP PROTECT



#define IS_ERROR_BEEP					GPIO_ReadOutputDataBit(GPIOA, GPIO_Pin_10)
#define SET_ERROR_BEEP					GPIO_SetBits(GPIOA, GPIO_Pin_10);	// BEEP = 1
#define CLR_ERROR_BEEP					GPIO_ResetBits(GPIOA, GPIO_Pin_10);	// BEEP = 0

extern uint8_t extCalTotalPoint;

extern float mADc_v;
extern float bADc_v;
extern float mDAc_v;
extern float bDAc_v;


extern float mADc_i;
extern float bADc_i;
extern float mDAc_i;
extern float bDAc_i;

extern uint16_t extCalVAd[2];
extern uint16_t extCalIAd[2];
extern float extCalV[2];
extern float extCalI[2];
#if (HARDWARE_VERSION >= VERSION_C)
#define DAC1V	0x172
#define DAC9V	0xD02
#else
#define DAC1V	0x136
#define DAC9V	0xAE6
#endif

void queryCurveparrmeter(void);
void queryTableparrmeter(void);

ErrorStatus verifyGPIBLANInput(uint8_t cmd,uint8_t temp1,uint8_t temp2,uint8_t temp3,uint8_t temp4,uint8_t temp5,uint8_t temp6 );
void usbFSInterrupt(FunctionalState state);
extern uint8_t manufacture[20];
extern uint8_t model[20];
void disableUsart(COM_TypeDef COM,USART_InitTypeDef* USART_InitStructure);
void disableGPIBLAN(void);
void disableMeasure(void);
void EXTILine2_Config(uint8_t type);		// For rs485 slave SYNC
void EXTILine9_Config(uint8_t type);				// For rs485 SHUTOFF Emergency Switch
void SYNCPinConfig(uint8_t type);
void RS485EmergencySwitchConfig(uint8_t type);
#define GPIO_OUTPUT	 	0
#define GPIO_INPUT	 	1
#define INTERRUPT		2


#endif

