/**
  ******************************************************************************
  * @file    keyboard.c 
  * @author  B&K precision Corp.
  * @version V1.1.0
  * @date    25-May-2012
  * @brief   keyboard body
  ******************************************************************************
  * @attention
  *
  * 
  *
  ******************************************************************************
  */ 


/* Includes ------------------------------------------------------------------*/
#include	"includes.h"
#include    "PVSState.h"

uint8_t keyType;

/* BIT macro */
#define ZeroOrOneBitSet(i)		(((i) & ((i)-1)) == 0)				/* 0ө1bit  1  TRUE */
#define OneBitSet(i)			((i) && (((i) & ((i)-1)) == 0))		/* u@bit  1  TRUE */
#define MultipleBitsSet(i)		(((i) & ((i)-1)) != 0)				/* bit HW 1  TRUE */


/* Private--------------------------------------------------------------*/
uint8_t	keyState;
uint8_t keyHold, leftRotary, rightRotary,byte7;
uint8_t rxVFDBuffer[10];
//#if (HARDWARE_VERSION >= VERSION_C && MANUFACTURE == ITECH)	  //] 25 pcs iteck vfd keyboard "." & "0" 
                                // 	0	 1	         2	      3	        4	    5	   6	  7	   8	 9       10     11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31  32 //
const uint8_t keyConvertion29[33] = { 0, key_DOWN, key_ONOFF, key_MENU,  key_0,key_DP, key_OK,key_9,  0,key_LEFT, key_OK, 15, 25, 26,  8,  9,  0, 23, 24,  5,  6,  7,  4,  3,  0, 18, 19, 20, 12, 21, 22,  2, 17};
//#else
                                // 	0	 1	         2	      3	        4	    5	   6	  7	   8	 9       10     11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31  32 //
const uint8_t keyConvertion23[33] = { 0, key_DOWN, key_ONOFF, key_MENU,  key_DP,key_0, key_OK,key_9,  0,key_LEFT, key_OK, 15, 25, 26,  8,  9,  0, 23, 24,  5,  6,  7,  4,  3,  0, 18, 19, 20, 12, 21, 22,  2, 17};

//#endif
//const uint8_t keyConvertion[33] = { 0, 13,       27,        28,      11,     1,     16,    10,    0,   14,     16,    15, 25, 26,  8,  9,  0, 23, 24,  5,  6,  7,  4,  3,  0, 18, 19, 20, 12, 21, 22,  2, 17};


extern state_id actualState;                    /* 檺A  */



/* BIT macro */
#define ZeroOrOneBitSet(i)		(((i) & ((i)-1)) == 0)				/* 0ө1bit  1  TRUE */
#define OneBitSet(i)			((i) && (((i) & ((i)-1)) == 0))		/* u@bit  1  TRUE */
#define MultipleBitsSet(i)		(((i) & ((i)-1)) != 0)				/* bit HW 1  TRUE */


#define KEY_OUT_PORT	GPIOC
#define KEY_IN_PORT		GPIOB

/* Global--------------------------------------------*/

//uint32_t vfdadjcount;
//uint32_t vfdcount = 0;

void TIM8_CH1_CH1N_PWM_Config(void);
void checkVFDFreq(void)
{
	if (VFDflag == 1)
	{
		uint8_t change = 0;
		if (YnADCDualConvertedValue[2]	> 2150)		//ئa P_ VFD 54VӰ {wVFDt PWM
		{
		  	TIM_CCPreloadControl(TIM8, DISABLE);
		  	TIM_ITConfig(TIM8, TIM_IT_COM, DISABLE);
		  /* TIM8 counter enable */
  			TIM_Cmd(TIM8, DISABLE);
		  /* Main Output Enable */
  			TIM_CtrlPWMOutputs(TIM8, DISABLE);
			TIM_DeInit(TIM8);
			SET_VFD_TOO_HIGH;
			return;
		}
			if (YnADCDualConvertedValue[2]	> 2050)	// 2100  = 1.7V
			{
				VFDfreq -= 14;
				change = 1;
			}
			else if (YnADCDualConvertedValue[2]	< 1950)
			{
				VFDfreq += 14;
				change = 1;
			}
			if (VFDfreq >= 45000 )	  // too high must be protected
			{
				VFDfreq = 45000;
				change = 1;
			}
			else if (VFDfreq <= 7000)
			{
				VFDfreq = 7000;
				change = 1;
			}
			if (change == 1)
				TIM8_CH1_CH1N_PWM_Config();
	}
}



/* _I{ 1ms */
void timeTickIsr(void)
{	
  	if(TIM_GetITStatus(TIM4, TIM_IT_Update) != RESET)
	{
	    softTimer[MAIN_COUNT].count++;
#if (HARDWARE_VERSION >= VERSION_C)
		if (softTimer[MAIN_COUNT].count > 300 && softTimer[MAIN_COUNT].count < 30000)
#endif
		{
			HVVoltage();
			if (softTimer[MAIN_COUNT].count % 10 == 0)
			{
				if (!(IS_VFD_TOO_HIGH))
					checkVFDFreq();
			}
		}
		beepTimeOut();
		checkOnTheFlyCursor();
	 	TIM_ClearITPendingBit(TIM4, TIM_IT_Update);
	}
}
uint32_t rawKeyCode	;
uint8_t getKey(void)
{
	uint8_t ki;
	uint32_t keyMask = 0x00000001;

    VFD_SPI_CS_LOW;    					// SPI_CS = 0
	sVFD_SendByte(0x81);
	for (ki = 0; ki < 9; ki++)
	{
		delay5us(1);
		rxVFDBuffer[ki] = sVFD_ReadByte();
	}
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
			rawKeyCode = (((uint32_t)rxVFDBuffer[0]) << 24) | (((uint32_t)rxVFDBuffer[1]) << 16) | (((uint32_t)rxVFDBuffer[2]) << 8) | ((uint32_t)rxVFDBuffer[3]);
			leftRotary = rxVFDBuffer[4];
			rightRotary = rxVFDBuffer[5];
		if (rawKeyCode)
		{
			if (!keyHold)
			{
	    		keyHold = 1;
 					if (rawKeyCode == 0x40000028) // "1"+"."+"ok"  selftest mode
						return key_SelfTest;


				for (ki = 1; ki < 33; ki++, keyMask = keyMask << 1)
				{
					if (rawKeyCode & keyMask) break; 	
				}
				beep(20);
				if (keyType == KEY23)
					return(keyConvertion23[ki]);
				else
					return(keyConvertion29[ki]);
			}
		}
		else 
			keyHold = 0;
	return(0);
}

uint8_t key_count = NO_COUNT;

 uint8_t getKey1(void)
{
	uint8_t ki,check;
	static uint32_t showcount = 0;
	static uint8_t  keySignal = NO_HIT;
	static uint32_t firstKey = 0;
	uint32_t keyMask = 0x00000001;

    VFD_SPI_CS_LOW;    					// SPI_CS = 0
	delay5us(1);
	sVFD_SendByte(0x81);
	check = 0;
	for (ki = 0; ki < 6; ki++)
	{
		delay5us(1);
		rxVFDBuffer[ki] = sVFD_ReadByte();
		check += rxVFDBuffer[ki];
	}
	delay5us(1);
	rxVFDBuffer[ki] = sVFD_ReadByte();
	check = ~check;
	delay5us(1);
    VFD_SPI_CS_HIGH;    				// SPI_CS = 1
	if (check == rxVFDBuffer[ki])
		ki++;
	rawKeyCode = (((uint32_t)rxVFDBuffer[0]) << 24) | (((uint32_t)rxVFDBuffer[1]) << 16) | (((uint32_t)rxVFDBuffer[2]) << 8) | ((uint32_t)rxVFDBuffer[3]);
	leftRotary = rxVFDBuffer[4];
	if (leftRotary == 0x01)
		upCount++;
	else if(leftRotary == 0xFF)
		downCount++;
	else if(leftRotary == 0)
		;
	else
		noiseCount++;
	totalCount++;		

	rightRotary = rxVFDBuffer[5];
    if (actualState == SELFTEST2)
	{
//#if (MANUFACTURE == BK_PRECISION)
	if (keyType == KEY23)
	{
		if (leftRotary == 1)
		{
			displayBuffer[36] = displayBuffer[37] = ' ';  // R+
			displayFresh = 1;beep(0);
		}
		else if(leftRotary == 0xFF)
		{
			displayBuffer[39] = displayBuffer[40] = ' ';  // R-
	    	displayFresh = 1; beep(0);
		}
	}
	else
	{
//#else
		if (leftRotary == 1)
		{
  			displayBuffer[32] = displayBuffer[33] = ' ';  // L+
			displayFresh = 1;beep(0);
		}
		else if(leftRotary == 0xFF)
		{
			displayBuffer[35] = displayBuffer[36] = ' ';  // L-
			displayFresh = 1;beep(0);
		}
	 }
//#endif

//#if (MANUFACTURE == BK_PRECISION)
	if (keyType == KEY23)
		;
	else
	{
//#else
		if (rightRotary == 1)
		{
			displayBuffer[38] = displayBuffer[39] = ' ';  // R+
			displayFresh = 1;beep(0);
		}
		else if(rightRotary == 0xFF)
		{
			displayBuffer[41] = displayBuffer[42] = ' ';  // R-
	    	displayFresh = 1; beep(0);
		}
	}
//#endif
	}

	byte7 = rxVFDBuffer[6];
	showcount++;
	if (showcount % 50 == 0)
	{
		if (actualState == D_NORMAL && rawKeyCode == 0x00000020) // 'ok' key pressed exceed 5 second
		{
			displayFresh = 1;
			if (softTimer[KEY_HOLD_COUNT].flag == DISABLE)
			{
				softTimer[KEY_HOLD_COUNT].count = softTimer[MAIN_COUNT].count;	// VERSION HOLD KEY TIME SETTING
			 	softTimer[KEY_HOLD_COUNT].flag = ENABLE;
			}
			else
			{
				if (softTimer[MAIN_COUNT].count - softTimer[KEY_HOLD_COUNT].count > 5000)
				{
					softTimer[KEY_HOLD_COUNT].flag = DISABLE;
					softTimer[SHOW_VERSION_COUNT].flag = ENABLE; 
					softTimer[SHOW_VERSION_COUNT].count = softTimer[MAIN_COUNT].count;
				}
			}			
		}
		else
			softTimer[KEY_HOLD_COUNT].count = softTimer[MAIN_COUNT].count;
	}
		if (rawKeyCode)
		{
		    if (firstKey != rawKeyCode)
			{
			    if (keySignal == NO_HIT)
				{
					firstKey = rawKeyCode;	//Ĥ@Tkey
				
				}
				if (key_count > NO_COUNT)
				    key_count--;		   // L{QzZ
				if (keySignal == HIT)
				{
					if (key_count < H_COUNT)
					{
				    	key_count = NO_COUNT;		//L{YzZ 
						keySignal = NO_HIT;
						firstKey = 0;
					}
				}
			}
            else
			{
			    key_count++; // TU
				if (key_count > L_COUNT) // L level
				    key_count = FULL_COUNT;

			}
		    if (keySignal == NO_HIT)
			{
	            if (key_count == FULL_COUNT)
				{					 // u
				 	keySignal = HIT;
					if (keyType == KEY23 && rawKeyCode == 0x40000030) // "1"+"0"+"ok"  selftest mode
					    return key_SelfTest;
					if (keyType == KEY29 && rawKeyCode == 0x40000028) // "1"+"0"+"ok"  selftest mode
						return key_SelfTest;
					else if(rawKeyCode == 0x00140020) // "4"+"6"+"ok" esc form selftest2 to d_normal
					{
						if (actualState == SELFTEST2)
							return key_Normal;
					}
//					else if(rawKeyCode == 0x10080000) // shift + 5 debug screen
//					{
//						return key_Debug;
//					}
					if (actualState == SELFTEST2)
					{
						if (keyType == KEY23)
						{

						switch(rawKeyCode)
						{
							case 0x40000000:   // 1
								displayBuffer[1] = ' ';
								break;
							case 0x00400000:   // 2
								displayBuffer[2] = ' ';
								break;
							case 0x00200000:   // 3
								displayBuffer[3] = ' ';
								break;
							case 0x00040000:   // 4
								displayBuffer[4] = ' ';
								break;
							case 0x00080000:   // 5
								displayBuffer[5] = ' ';
								break;
							case 0x00100000:   // 6
								displayBuffer[6] = ' ';
								break;
							case 0x00002000:   // 7
								displayBuffer[7] = ' ';
								break;
							case 0x00004000:   // 8
								displayBuffer[8] = ' ';
								break;
							case 0x00000040:   // 9
								displayBuffer[9] = ' ';
								break;
							case 0x00000010:   // 0
								displayBuffer[0] = ' ';
								break;
							case 0x00000008:   // .
								displayBuffer[10] = ' ';
								break;
							case 0x00000200:   // ok1
								displayBuffer[12] = displayBuffer[13] = displayBuffer[14] = ' ';
								break;
							case 0x00000020:   // ok2
								displayBuffer[16] = displayBuffer[17] = displayBuffer[18] = ' ';
								break;
							case 0x08000000:   // UP
								displayBuffer[23] = ' ';
								break;
							case 0x00000001:   // DOWM
								displayBuffer[25] = ' ';
								break;
							case 0x00000100:   // LEFT
								displayBuffer[32] = ' ';
								break;
							case 0x00000400:   // RIGHT
								displayBuffer[34] = ' ';
								break;
							case 0x80000000:   // OVP
								VFDsign &= ~sign_OVP;
								break;
							case 0x01000000:   // OPP
								displayBuffer[42] = displayBuffer[43] = displayBuffer[44] = ' ';
								break;
							case 0x02000000:   // OCP
								VFDsign &= ~sign_OCP;
								break;

							case 0x04000000:   // LOCK
								VFDsign &= ~sign_LOCK;
								break;

							case 0x10000000:   // SHIFT
								VFDsign &= ~sign_SHIFTBL;
								break;
							case 0x00010000:   // VSET
								displayBuffer[19] = displayBuffer[20] = ' ';
								VFDsign &= ~sign_OVP;
								break;
							case 0x00000800:   // RECALL
								displayBuffer[25] = displayBuffer[26] = ' ';
								VFDsign &= ~sign_OPP;
								break;
							case 0x00000002:   // ONOFF
								VFDsign &= ~sign_ONOFF;
								break;
							case 0x20000000:   // ESC
								displayBuffer[28] = displayBuffer[29] = displayBuffer[30] = ' ';
								VFDsign &= ~sign_LOCK;
								break;
							case 0x00020000:   // ISET
								displayBuffer[22] = displayBuffer[23] = ' ';
								VFDsign &= ~sign_OCP;
								break;
							case 0x00001000:   // METER
								VFDsign &= ~sign_METER;
								break;
							case 0x00000004:   // MENU
								displayBuffer[12] = ' '; displayBuffer[13] = ' ';displayBuffer[14] = ' ';
								break;
						}
						}
						else
						{
						switch(rawKeyCode)
						{
							case 0x40000000:   // 1
								displayBuffer[1] = ' ';
								break;
							case 0x00400000:   // 2
								displayBuffer[2] = ' ';
								break;
							case 0x00200000:   // 3
								displayBuffer[3] = ' ';
								break;
							case 0x00040000:   // 4
								displayBuffer[4] = ' ';
								break;
							case 0x00080000:   // 5
								displayBuffer[5] = ' ';
								break;
							case 0x00100000:   // 6
								displayBuffer[6] = ' ';
								break;
							case 0x00002000:   // 7
								displayBuffer[7] = ' ';
								break;
							case 0x00004000:   // 8
								displayBuffer[8] = ' ';
								break;
							case 0x00000040:   // 9
								displayBuffer[9] = ' ';
								break;
							case 0x00000008:   // 0
								displayBuffer[0] = ' ';
								break;
							case 0x00000010:   // .
								displayBuffer[10] = ' ';
								break;
							case 0x00000200:   // ok1
								displayBuffer[12] = displayBuffer[13] = displayBuffer[14] = ' ';
								break;
							case 0x00000020:   // ok2
								displayBuffer[16] = displayBuffer[17] = displayBuffer[18] = ' ';
								break;
							case 0x08000000:   // UP
								displayBuffer[23] = ' ';
								break;
							case 0x00000001:   // DOWM
								displayBuffer[25] = ' ';
								break;
							case 0x00000100:   // LEFT
								displayBuffer[27] = ' ';
								break;
							case 0x00000400:   // RIGHT
								displayBuffer[29] = ' ';
								break;
							case 0x80000000:   // OVP
								VFDsign &= ~sign_OVP;
								break;
							case 0x01000000:   // OPP
								VFDsign &= ~sign_OPP;
								break;
							case 0x02000000:   // OCP
								VFDsign &= ~sign_OCP;
								break;

							case 0x04000000:   // LOCK
								VFDsign &= ~sign_LOCK;
								break;

							case 0x10000000:   // SHIFT
								VFDsign &= ~sign_SHIFTBL;
								break;
							case 0x00010000:   // VSET
								VFDsign &= ~sign_VSET;
								break;
							case 0x00000800:   // RECALL
								VFDsign &= ~sign_RECALL;
								break;
							case 0x00000002:   // ONOFF
								VFDsign &= ~sign_ONOFF;
								break;

							case 0x20000000:   // ESC
								VFDsign &= ~sign_ESC;
								break;
							case 0x00020000:   // ISET
								VFDsign &= ~sign_ISET;
								break;
							case 0x00001000:   // METER
								VFDsign &= ~sign_METER;
								break;
							case 0x00000004:   // MENU
								VFDsign &= ~sign_MENU;
								break;
						}
						}
						displayFresh = 1;
						beep(0);
						return (0);
					}
					if (OneBitSet(firstKey))	/* u@ bit high */
					{
						for (ki = 1; ki < 33; ki++, keyMask = keyMask << 1)
						{
							if (firstKey & keyMask) 
								break; 	
						}
						beep(20);
						if (keyType == KEY23)
							return(keyConvertion23[ki]);
						else
							return(keyConvertion29[ki]);
					}
					else
					{
				    	key_count = NO_COUNT;		//L{YzZ 
						keySignal = NO_HIT;
						firstKey = 0;
						return (0);
					}
				}
			}
		}
		else
		{
			if (key_count > NO_COUNT)
			    key_count--;
			if (keySignal == HIT)
			{
				if (key_count < H_COUNT)
				{
			    	key_count = NO_COUNT;
					keySignal = NO_HIT;
					firstKey = 0;
				}
			}
		}
		return (0);
 
}






