
#include	"includes.h"










__INLINE uint16_t readData(void)
{   
	return LCD_DATA_ADD;
}
__INLINE uint16_t readCOMM(void)
{
	return LCD_COMM_ADD;
}



uint16_t readBackColor(void)
{
    uint16_t Data;
	Data= readData();
	return Data;
}
void Memory_Clear(void)
{
	uint8_t temp;
	writeCommand(0x8e);//MCLR
	temp = readData();
	temp |= BIT7;
	writeData(temp);
}






/*
  RA8870 
*/
void RA8870_WAITSTATUS(void)
{
	while(!(GPIOD->IDR & GPIO_Pin_6 ));
}
uint8_t LCD_StatusRead(void)
{
	uint16_t Data;
	Data = readCOMM();
	return Data;
}


/*
rICM
*/

void Memory_Clear_with_Font_BgColor(void)
{
	uint8_t temp;
	writeCommand(0x8e);//MCLR
	temp = readData();
	temp |= BIT0;
	writeData(temp);
}


void Text_Foreground_Color(uint8_t color)
{
	writeCommand(0x42);//TFCR
	writeData(color);
}
void Text_Background_Color(uint8_t color)
{
	writeCommand(0x43);//TBCR
	writeData(color);
}




/* rC]w */

void Text_color(uint16_t color)//0xF800 == RED
{
	writeCommand(0x63);//R
	writeData((color&0xf800)>>11);//5  R
	
	
	writeCommand(0x64);
	writeData((color&0x07e0)>>5);//6  G
	
	writeCommand(0x65);
	writeData((color&0x001f));//5    B
	
//	RA8870_WAITSTATUS();
}

/*
   \:O X Yϰ]w REG[46h]~/EG[49h]
   XL :X_l    XR :X
   YT :Y_l	YB :Y
REG[46h]~REG[49h]
*/
void XY_Coordinate(uint16_t X,uint16_t Y)
{
	  // ] V H ۤϳ]w ҥH X,Y ]wۤ
	writeCommand(0x46);
	writeData(Y);
	writeCommand(0x47);
	writeData(Y>>8);
	writeCommand(0x48);
	writeData(X);
	writeCommand(0x49);
	writeData(X>>8);

}

/*
   \:ø X Yϰ]w REG[90h]~/EG[9Dh]
   XL :X_l    XR :X
   YT :Y_l	YB :Y
    
*/  									
void Geometric_Coordinate(uint16_t XL,uint16_t XR ,uint16_t YT ,uint16_t YB)
{	  
	writeCommand(0x91);//Hs
	writeData(XL);   
	writeCommand(0x92);	   
	writeData(XL>>8);
	
	writeCommand(0x95);//Vs
	writeData(XR);  
	writeCommand(0x96);	   
	writeData(XR>>8);
	
	writeCommand(0x93);	
	writeData(YT);  
	writeCommand(0x94);	   
	writeData(YT>>8);
	
	writeCommand(0x97);
	writeData(YB);   
	writeCommand(0x98);	   
	writeData(YB>>8);
//	RA8870_WAITSTATUS();
}


/**************************************************************************************
\GMLCD̹
JG    ؼC
XG	  L	  en40ms M
**************************************************************************************/
void lcdClear(uint16_t color)
{
//	Memory_Clear();				 		/* OвM */
//	Chk_Busy();
    uint32_t i;
    XY_Coordinate(0, 0); // X,Y w /
	writeCommand(0x02);
	for(i = 0 ; i < (130560) ; i++)
	{
		writeData(color); //IC
	}

	 
}
	 


/*
	256 ϧδC0 ]w
*/

//---------------------------------//
//REG[84h]

void Graphic_Cursor_Color_0(uint8_t setx)
{	  
	writeCommand(0x84);//GCC0
	writeData(setx); 
}  									  


/*
   256 ϧδC1 ]w
*/
void Graphic_Cursor_Color_1(uint8_t setx)
{	 
	writeCommand(0x85);//GCC1
	writeData(setx); 
}  	
 	 				

//--------------------------------------------//
//REG[40h]
void Graphic_Mode(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT7) ;
	writeData(temp);
}

void Text_Mode(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp |= BIT7;
	writeData(temp);	 
} 


 //------------------------//
//STATUS 
void Chk_Busy(void)
{
	uint8_t temp;
	do
	{
		temp=LCD_StatusRead();
	}while((temp&0x80)==0x80);
}
void Chk_Busy_BTE(void)
{
	uint8_t temp;
   	
	do
	{
		temp=LCD_StatusRead();
	}while((temp&0x40)==0x40);
}

void Chk_Busy_DIR_Access(void)
{
	uint8_t  temp;
   	
	do
	{
		temp=LCD_StatusRead();
	}while((temp&0x01)==0x01);
}


void Display_ON(void)
{	
	writeCommand(0x01);//PWRR
	writeData(0x80);
//	RA8870_WAITSTATUS();
}

void Display_OFF(void)
{
	writeCommand(0x01);//PWRR
	writeData(0x00);
}



void HDIR_SEG0_SEGn(void)
{
	uint8_t temp;
	writeCommand(0x20);//DPCR
	temp = readData();
	temp &= ~BIT3 ;
	writeData(temp);
}
void HDIR_SEGn_SEG0(void)
{
	uint8_t temp;
	writeCommand(0x20);//DPCR
	temp = readData();
	temp |= BIT3 ;
	writeData(temp);
//	RA8870_WAITSTATUS();
}
void VDIR_COM0_COMn(void)
{
	uint8_t temp;
	writeCommand(0x20);//DPCR
	temp = readData();
	temp &= ~BIT2 ;
	writeData(temp);
}
void VDIR_COMn_COM0(void)
{
	uint8_t temp;
	writeCommand(0x20);//DPCR
	temp = readData();
	temp |= BIT2 ;
	writeData(temp);
}


// REG[40h]	============================================
void Text_Cursor_Disable(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	
	temp &= ~(BIT6+BIT5+BIT4);
	writeData(temp);
}

void Text_Cursor_Enable(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp |= (BIT6+BIT5);
	writeData(temp);
} 

void Text_Cursor_Blink_Disable(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT5);
	writeData(temp);
}

void Text_Cursor_Blink_Enable(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp |= BIT5 ;//0x20
	writeData(temp);
}

void Memory_Write_LeftRight_TopDown(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT3|BIT2);
	writeData(temp);
}

void Memory_Write_RightLeft_TopDown(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT3+BIT2) ;
	temp |= BIT2 ;
	writeData(temp);
}

void Memory_Write_DownTop_LeftRight(void)
{
	uint8_t temp;	
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT3+BIT2) ;
	temp |= (BIT3+BIT2) ;
	writeData(temp);
}

void Memory_Write_TopDown_LeftRight(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT3+BIT2) ;
	temp |= BIT3 ;
	writeData(temp);
} 

void MemoryWrite_Cursor_autoIncrease(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT1) ;
	writeData(temp);
}

void MemoryWrite_Cursor_NoautoIncrease(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp |= BIT1 ;
	writeData(temp);
}

void MemoryRead_Cursor_autoIncrease(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp &= ~(BIT0) ;
	writeData(temp);
}

void MemoryRead_Cursor_NoautoIncrease(void)
{
	uint8_t temp;
	writeCommand(0x40);//MWCR0
	temp = readData();
	temp |= BIT0 ;
	writeData(temp);
}  										 

//=======END oF REG[40h] ===================================================












/*

TFT_LCDİϰ]w

(XL,YT)	W
(XR,YB)	kW



     (0,0) ------------------------------|
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |-----------------------------|
										  (479,271)



*/
void Active_Window(uint16_t XL,uint16_t XR ,uint16_t YT ,uint16_t YB)
{

 	//Active window  set 
	//setting active window X   480 * 272
	writeCommand(0x30); //Horizontal Start Point 0 of Active Window (HSAW0)
	writeData(XL); //Horizontal Start Point of Active Window [7:0]

	writeCommand(0x31); //Horizontal Start Point 1 of Active Window (HSAW1)	   
	writeData(XL >> 8); //Horizontal Start Point of Active Window [9:8]

	writeCommand(0x34); //Horizontal End Point 0 of Active Window (HEAW0)
	writeData(XR); //Horizontal End Point of Active Window [7:0]

	writeCommand(0x35); //Horizontal End Point 1 of Active Window (HEAW1)	   
	writeData(XR >> 8); //Horizontal End Point of Active Window [9:8]

//	RA8870_WAITSTATUS();       //0x1DF = 479
	
	//setting active window Y
	writeCommand(0x32); //Vertical Start Point 0 of Active Window (VSAW0)
	writeData(YT); //Vertical Start Point of Active Window [7:0]

	writeCommand(0x33); //Vertical Start Point 1 of Active Window (VSAW1)	   
	writeData(YT >> 8); //Vertical Start Point of Active Window [8]

	writeCommand(0x36); //Vertical End Point of Active Window 0 (VEAW0)
	writeData(YB); //Vertical End Point of Active Window [7:0]

	writeCommand(0x37); //Vertical End Point of Active Window 1 (VEAW1)	   
	writeData(YB >> 8); //Vertical End Point of Active Window [8]

//	RA8870_WAITSTATUS();     //0x10f = 271

}


/**************************************************************************************
ƥ\Gex
JG    xΪWMkUСAMؼC
		  x1,y1  W
		  x2,y2  kW
		  fill	 0  exή
		  		 1  xζR
XG	  L
**************************************************************************************/
void LcdFillRec(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint8_t fill, uint16_t color)
{
	Text_color(color); // ]wC
	Geometric_Coordinate(x1,x2,y1,y2); // ]wxΧ
	writeCommand(0x90);
	if (fill)
	{
		writeData(0xB0);
	}
	else
	{
		writeData(0x90);
	}
//	RA8870_WAITSTATUS();
	delayMs(100);
}

void software_reset(void)
{
/* **** SOFTWARE RESET ***** */
    writeCommand(0x01);
	writeData(0x01);
	delayMs(1);
	writeData(0x00);
	delayMs(100);
/*****************************/
}


/*
   RA8870 ]pb SYS_CLK 42MHz
          XTFT LCD PLL CLOCK b10.5Mhz 
*/

void initializeRa8870Pll(void)
{
	writeCommand(0x88);	//SYS_CLK = FIN*(PLLDIVN[4:0] +1)/((PLLDIVM+1)*(2^PLLDIVK[2:0]))   = 8Mhz *(20+1)/16 = 168M/4 = 42Mhz
						//	6-7 : Clock ]wPOѪRתY   480*272 1 8/12 NA NA 10.4MHz	]SYS_CLK /2^*1
	writeData(0x014);	//PLLDIVN[4:0] = 20; FIN = 8MHz  PLLDIVM =0   
		
	writeCommand(0x89);
	writeData(0x02);	//PLLDIVK[2:0] = 2 (2^2 =4)
	
	delayMs(100);
	software_reset();
}


void InitializeRa8870(void)
{
	
	initializeRa8870Pll(); // PLL initial

	writeCommand(0x10);    // ƦTFT LCD O, æƿX,O
	writeData(0x06);       // 12-bpp Generic TFT OApϥ4K ,	16-bit MCU ɭ	
	
	writeCommand(0x04);    // PCLK inverse
	writeData(0x81);       // PCLK = SYS_CLK/((2^(Layer Setting Control + 1)) * (2^PPWS))
					       // PPWS = 0,SYS_CLK = 42Mhz ,Layer Setting Control = 0
					       //PCLK = 42Mhz/((2^0+1)) * (2^0)) = 42Mhz/(2*2) = 10.5Mhz.
	delayMs(1);

	//Horizontal set  RA8870 480*272 S ,nq˳]w ==> M90ױy HugV]n
	writeCommand(0x14); //HDWR//Horizontal Display Width Setting Bit[6:0]                      
	writeData(0x21);//Horizontal display width(pixels) = (HDWR + 1)*8      = (33+1)*8 = 272               
//	writeCommand(0x15);//Horizontal Non-Display Period Fine Tuning Option Register (HNDFTR)   
//	writeData(0x03);//Horizontal Non-Display Period Fine Tuning(HNDFT) [3:0]               
	writeCommand(0x16); //HNDR//Horizontal Non-Display Period Bit[4:0]                         
	writeData(0x01);//Horizontal Non-Display Period (pixels) = (HNDR + 1)*8    Dܼeס]pixel^=]HNDR + 1^*8 + HNDFTR+2  = (0+1)*8+ 3+2  = 13               
	writeCommand(0x17); //HSTR//HSYNC Start Position[4:0]                                      
	writeData(0x01);//HSYNC Start Position(PCLK) = (HSTR + 1)*8 = 8                           
	writeCommand(0x18); //HPWR//HSYNC Polarity ,The period width of HSYNC.                     
	writeData(0x09);//HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8 = 24    			;13+8+24 = 45 
	delayMs(1);
	//Vertical set                             
	writeCommand(0x19); //VDHR0 //Vertical Display Height Bit [7:0]                            
	writeData(0xdf);//Vertical pixels = VDHR + 1 = 479+1 = 480                                          
	writeCommand(0x1a); //VDHR1 //Vertical Display Height Bit [8]                              
	writeData(0x01);//Vertical pixels = VDHR + 1 = 1+1 = 2                                           
	writeCommand(0x1b); //VNDR0 //Vertical Non-Display Period Bit [7:0]                        
	writeData(0x01);//Vertical Non-Display area = (VNDR0 ) = (1+1) = 2                               
	writeCommand(0x1c); //VNDR1 //Vertical Non-Display Period Bit [8]                          
	writeData(0x00);//Vertical Non-Display area = (VNDR1 ) = 0                              
	writeCommand(0x1d); //VSTR0 //VSYNC Start Position[7:0]                                    
	writeData(0x01);//VSYNC Start Position(PCLK) = (VSTR0 + 1) = 1 +1 = 2                             
	writeCommand(0x1e); //VSTR1 //VSYNC Start Position[8]                                      
	writeData(0x00);//VSYNC Start Position(PCLK) = (VSTR1 ) = 0                            
	writeCommand(0x1f); //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]                        
	writeData(0x28);//VSYNC Pulse Width(PCLK) = (VPWR + 1) = 9+1 = 10                                 
	delayMs(1);

	writeCommand(0x20); //]w90 oO4.3T TFT LCD Ww
	writeData(0x01);


/*	
	//Horizontal set 쥻]w |y I 0 ,0 uX{  Pıu 479,255
	writeCommand(0x14); //HDWR//Horizontal Display Width Setting Bit[6:0]                      
	writeData(0x3B);//Horizontal display width(pixels) = (HDWR + 1)*8      = (59+1)*8 = 480               
	writeCommand(0x15);//Horizontal Non-Display Period Fine Tuning Option Register (HNDFTR)   
	writeData(0x03);//Horizontal Non-Display Period Fine Tuning(HNDFT) [3:0]               
	writeCommand(0x16); //HNDR//Horizontal Non-Display Period Bit[4:0]                         
	writeData(0x00);//Horizontal Non-Display Period (pixels) = (HNDR + 1)*8    Dܼeס]pixel^=]HNDR + 1^*8 + HNDFTR+2  = (0+1)*8+ 3+2  = 13               
	writeCommand(0x17); //HSTR//HSYNC Start Position[4:0]                                      
	writeData(0x00);//HSYNC Start Position(PCLK) = (HSTR + 1)*8 = 8                           
	writeCommand(0x18); //HPWR//HSYNC Polarity ,The period width of HSYNC.                     
	writeData(0x02);//HSYNC Width [4:0]   HSYNC Pulse width(PCLK) = (HPWR + 1)*8 // 24    			;13+8+24 = 45 
	delayMs(1);
	//Vertical set                             
	writeCommand(0x19); //VDHR0 //Vertical Display Height Bit [7:0]                            
	writeData(0x0f);//Vertical pixels = VDHR + 1 = 271+1 = 272                                          
	writeCommand(0x1a); //VDHR1 //Vertical Display Height Bit [8]                              
	writeData(0x01);//Vertical pixels = VDHR + 1 = 1+1 = 2                                           
	writeCommand(0x1b); //VNDR0 //Vertical Non-Display Period Bit [7:0]                        
	writeData(0x01);//Vertical Non-Display area = (VNDR0 ) = (1+1) = 2                               
	writeCommand(0x1c); //VNDR1 //Vertical Non-Display Period Bit [8]                          
	writeData(0x00);//Vertical Non-Display area = (VNDR1 ) = 0                              
	writeCommand(0x1d); //VSTR0 //VSYNC Start Position[7:0]                                    
	writeData(0x01);//VSYNC Start Position(PCLK) = (VSTR0 + 1) = 1 +1 = 2                             
	writeCommand(0x1e); //VSTR1 //VSYNC Start Position[8]                                      
	writeData(0x00);//VSYNC Start Position(PCLK) = (VSTR1 ) = 0                            
	writeCommand(0x1f); //VPWR //VSYNC Polarity ,VSYNC Pulse Width[6:0]                        
	writeData(0x09);//VSYNC Pulse Width(PCLK) = (VPWR + 1) = 9+1 = 10                                 
	delayMs(1);
*/	
	
	Active_Window(0 ,271 ,0 ,479);		/* ĵ]w 4.3" TFT  쥻O(0,479,0,271) ] 90 ҥHx,ybnۤ*/

/********************************************************
     (0,0) ------------------------------|
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |							 |
		   |-----------------------------|
										  (479,271)		   */

	HDIR_SEGn_SEG0();// ۤ
	VDIR_COMn_COM0();// ۤ

    Memory_Write_TopDown_LeftRight();	 //ѤWӤU  ѥӥk

	writeCommand(0x4E); //OŪV ѤWUѥk
	writeData(0x02);


/*********************************************************/

	Memory_Clear_with_Font_BgColor();	/* clear rIC */
	Memory_Clear();				 		/* OвM */
	Chk_Busy();
	GPIO_SetBits(GPIOA,	  GPIO_Pin_4); // RA8870 DISP PIN HI
	Display_ON();						/* ù */
	lcdClear(blockColor);

}



