
#ifndef _UART_H
#define _UART_H

#define BAUD_9600    0
#define BAUD_19200   1
#define BAUD_38400   2
#define BAUD_57600   3


#define PARALLEL_SAMPLE_WEIGHT	1
//#define VCP_TO_COM	 // ]wizLVCPgUSART UO N{,UOݥNUSART IAP bootloader

#if (HARDWARE_VERSION >= VERSION_C)

#define RS485_CHANNEL		COM1
#define RS232_CHANNEL		COM3
#define MEASURE_CHANNEL		COM4
#define GPIB_LAN_CHANNEL	COM2
#define USB_VCP_CHANNEL		COM5   // virtual com port	  => usbd_cdc_vcp.h    UART5_IRQHandler _]n


#else

#define RS485_CHANNEL		COM1
#define RS232_CHANNEL		COM2
#define MEASURE_CHANNEL		COM3
#define GPIB_LAN_CHANNEL	COM4
#define USB_VCP_CHANNEL		COM5   // virtual com port	  => usbd_cdc_vcp.h    UART5_IRQHandler _]n

#endif
extern COM_TypeDef transparentDEVICE;
extern COM_TypeDef transparentHOST;
extern uint8_t usb_channel_count;

#define RS485_TO_COMport	RS485_CHANNEL
#define RS232_TO_COMport	RS232_CHANNEL
#define VCP_TO_COMport		USB_VCP_CHANNEL
#define	NOT_PROGRAMMING		INITCOM


#define RS485_HEAD					0xAB
#define RS485_TAIL					0x0A
#define RS485_CHAINBROADCAST		0x90
#define RS485_PARALLELBROADCAST		0x80

#define EXTEND	1000 //Xi



#define COMPLEX				0xD0
#define SIMPLE 				0xE7


#define ERR			0xE2
#define NOPACKET	0x32
#define NOCOMMAND	0xA7

extern uint8_t gpibLanModle[20];
extern uint8_t gpibLanSerial[20];

// GPIB LAN command

#define STATUS_CMD				0x06

#define	MODLEQ_CMD				0x10
#define MODLER_CMD				0x11 
#define SERIALQ_CMD				0x12
#define SERIALR_CMD				0x13
#define FWVERQ_CMD				0x14
#define FWVERR_CMD				0x15
#define MANUQ_CMD				0x16
#define MANUR_CMD				0x17
#define RS232CQ_CMD				0x18
#define RS232CR_CMD				0x19
#define RS485CQ_CMD				0x1A
#define RS485CR_CMD				0x1B

#define GPIBADDR_CMD			0x20
#define GPIBADDRQ_CMD			0x21
#define GPIBADDRR_CMD			0x22
#define IPMODE_CMD				0x23
#define IPMODEQ_CMD				0x24
#define IPMODER_CMD				0x25
#define IPADDR_CMD				0x26
#define IPADDRQ_CMD				0x27
#define IPADDRR_CMD				0x28
#define GWADDR_CMD				0x29
#define GWADDRQ_CMD				0x2A
#define GWADDRR_CMD				0x2B
#define MASKADDR_CMD			0x2C
#define MASKADDRQ_CMD			0x2D
#define MASKADDRR_CMD			0x2E

#define CURRIPADDRQ_CMD			0x30
#define CURRIPADDRR_CMD			0x31
#define CURRGWQ_CMD				0x32
#define CURRGWR_CMD				0x33
#define CURRMASKQ_CMD			0x34
#define CURRMASKR_CMD			0x35
#define MACADDR_CMD				0x36
#define MACADDRQ_CMD			0x37
#define MACADDRR_CMD			0x38

#define GPIBSCPISEND_CMD		0x40
#define GPIBSCPIRECEIVE_CMD		0x41
#define GPIBSTATUS_CMD			0x42

#define HTTPSCPISEND_CMD		0x50
#define HTTPSCPIRECEIVE_CMD		0x51
#define PORT23SCPISEND_CMD		0x52
#define PORT23SCPIRECEIVE_CMD	0x53
#define PORT5024SCPISEND_CMD	0x54
#define PORT5024SCPIRECEIVE_CMD	0x55
#define PORT5025SCPISEND_CMD	0x56
#define PORT5025SCPIRECEIVE_CMD	0x57



#define WEBVSET_CMD				0x60
#define WEBVSETQ_CMD			0x61
#define WEBVSETR_CMD			0x62
#define WEBISET_CMD				0x63
#define WEBISETQ_CMD			0x64
#define WEBISETR_CMD			0x65
#define WEBPROTSW_CMD			0x66
#define WEBPROTSWQ_CMD			0x67
#define WEBPROTSWR_CMD			0x68

#define WEBOVP_CMD				0x69
#define WEBOVPQ_CMD				0x6A
#define WEBOVPR_CMD				0x6B

#define WEBOCP_CMD				0x6C
#define WEBOCPQ_CMD				0x6D
#define WEBOCPR_CMD				0x6E

#define WEBOPP_CMD				0x6F
#define WEBOPPQ_CMD				0x70
#define WEBOPPR_CMD				0x71

#define WEBVSR_CMD				0x72
#define WEBVSRQ_CMD				0x73
#define WEBVSRR_CMD				0x74
#define WEBISR_CMD				0x75
#define WEBISRQ_CMD				0x76
#define WEBISRR_CMD				0x77

#define WEBOUTPUTSW_CMD			0x78
#define WEBOUTPUTQ_CMD			0x79
#define WEBOUTPUTR_CMD			0x7A

#define GPIBVREADQ_CMD			0x7B
#define GPIBVREADR_CMD			0x7C
#define GPIBIREADQ_CMD			0x7D
#define GPIBIREADR_CMD			0x7E

#define WEBVMAX_CMD				0x7F
#define WEBVMAXQ_CMD			0x80
#define WEBVMAXR_CMD			0x81
#define WEBVMIN_CMD				0x82
#define WEBVMINQ_CMD			0x83
#define WEBVMINR_CMD			0x84
#define WEBIMAX_CMD				0x85
#define WEBIMAXQ_CMD			0x86
#define WEBIMAXR_CMD			0x87
#define WEBIMIN_CMD				0x88
#define WEBIMINQ_CMD			0x89
#define WEBIMINR_CMD			0x8A




#define RST_REQ_CMD				0xA0	// й譫}
#define BOOT_CMD				0xA1	// 0 normal  1 bootloader
#define BOOTSTATEQ_CMD			0xA2
#define BOOTSTATER_CMD			0xA3



//define the communication command list

// MEASUREMENT Command
#define IDNQ_CMD		0x01
#define IDNR_CMD		0x02
#define ERRQ_CMD		0x03
#define ERRR_CMD		0x04


#define RST_CMD			0x07
#define END_CMD			0x0A
#define ACK_CMD			0x08 // pvsTableNumState
#define NAK_CMD			0x09



#define FULLSCALEQ_CMD	0x20
#define FULLSCALER_CMD	0x21
#define VMAXQ_CMD		0x22
#define VMAXR_CMD		0x23
#define VMINQ_CMD		0x24
#define VMINR_CMD		0x25
#define IMAXQ_CMD		0x26
#define IMAXR_CMD		0x27
#define IMINQ_CMD		0x28
#define IMINR_CMD		0x29
#define PMAXQ_CMD		0x2A
#define PMAXR_CMD		0x2B
#define OVPMAXQ_CMD		0x2C
#define OVPMAXR_CMD		0x2D
#define OVPMINQ_CMD		0x2E
#define OVPMINR_CMD		0x2F
#define OCPMAXQ_CMD		0x30
#define OCPMAXR_CMD		0x31
#define OCPMINQ_CMD		0x32
#define OCPMINR_CMD		0x33
#define OPPMAXQ_CMD		0x34
#define OPPMAXR_CMD		0x35
#define OPPMINQ_CMD		0x36
#define OPPMINR_CMD		0x37
#define VSRMAXQ_CMD		0x38
#define VSRMAXR_CMD		0x39
#define ISRMAXQ_CMD		0x3A
#define ISRMAXR_CMD		0x3B

#define VSET_CMD		0x60
#define ISET_CMD		0x61
#define PSET_CMD		0x62
#define OVPSET_CMD		0x63
#define OCPSET_CMD		0x64
#define OPPSET_CMD		0x65
#define OUTPUT_CMD		0x66
#define OVPCLEAR_CMD	0x67
#define OCPCLEAR_CMD	0x68
#define OPPCLEAR_CMD	0x69
#define VSRSET_CMD		0x6A
#define ISRSET_CMD		0x6B

#define CVCCCLEAR_CMD	0x6C
#define CCCVCLEAR_CMD	0x6D
#define PORTSW_CMD		0x6E
#define OTPCLEAR_CMD	0x6F


#define VSETQ_CMD		0x80
#define VSETR_CMD		0x81
#define ISETQ_CMD		0x82
#define ISETR_CMD		0x83
#define PSETQ_CMD		0x84
#define PSETR_CMD		0x85
#define OVPSETQ_CMD		0x86
#define OVPSETR_CMD		0x87
#define OCPSETQ_CMD		0x88
#define OCPSETR_CMD		0x89
#define OPPSETQ_CMD		0x8A
#define OPPSETR_CMD		0x8B
#define VREADQ_CMD		0x8C
#define VREADR_CMD		0x8D
#define IREADQ_CMD		0x8E
#define IREADR_CMD		0x8F
#define OUTPUTQ_CMD		0x90
#define OUTPUTR_CMD		0x91
#define VSRQ_CMD		0x92
#define VSRR_CMD		0x93
#define ISRQ_CMD		0x94
#define ISRR_CMD		0x95
#define PROTSWQ_CMD		0x96
#define PROTSWR_CMD		0x97


#define CALPVQ_CMD		0xA0
#define CALPVR_CMD		0xA1
#define CALPIQ_CMD		0xA2
#define CALPIR_CMD		0xA3
#define CALVN_CMD		0xA4
#define CALVNQ_CMD		0xA5
#define CALVNR_CMD		0xA6
#define CALVNS_CMD		0xA7
#define CALIN_CMD		0xA8
#define CALINQ_CMD		0xA9
#define CALINR_CMD		0xAA
#define CALINS_CMD		0xAB
#define VADCQ_CMD       0xAC
#define VADCR_CMD       0xAD
#define IADCQ_CMD       0xAE
#define IADCR_CMD       0xAF

#define STARTOVPCALQ_CMD  0xB0
#define OVPCALSTATER_CMD  0xB1
#define STARTOCPCALQ_CMD  0xB2
#define OCPCALSTATER_CMD  0xB3

#define FATSTARTOVPCALQ_CMD  0xB4
#define FATOVPCALSTATER_CMD  0xB5
#define FATSTARTOCPCALQ_CMD  0xB6
#define FATOCPCALSTATER_CMD  0xB7
#define RESTOREFACTORYQ_CMD	 0xB8
#define RESTOREFACTORYR_CMD	 0xB9
#define DUMPQ_CMD			 0xBA
#define DUMPR_CMD			 0xBB


#define FAULTSTATUS2_CMD  0xC0
#define FAULTSTATUSQ_CMD  0xC1
#define FAULTSTATUSR_CMD  0xC2

#define PVSMODE_CMD			0xD0
#define PVSCURVEPARAM_CMD	0xD1
#define PVSCURVESELECT_CMD	0xD2
#define PVSSTARTLOAD_CMD	0xD3
#define PVSDEFNVI_CMD		0xD4
#define PVSSTOPLOAD_CMD		0xD5
#define PVSCURVEQ_CMD		0xD6
#define PVSCURVER_CMD		0xD7
#define PVSSIMPOWER_CMD		0xD8
#define PVSSIMGT_CMD		0xD8
#define PVSSTATEQ_CMD		0xD9
#define PVSSTATER_CMD		0xDA
#define PVSDEFNVIQ_CMD		0xDB
#define PVSDEFNVIR_CMD		0xDC
#define OTWNTCQ_CMD			0xDD
#define OTWNTCR_CMD			0xDE

#define PVSFM_CMD			0xDF // formual ,material
#define PVSVMPPMP_CMD		0xE0
#define PVSTABARRAY_CMD		0xE1
#define PVCTRLMOD_CMD		0xE2 // set pv sim control mode cc or cv
#define PVCTRLMODQ_CMD		0xE3 //	query pv sim status?
#define PVCTRLMODR_CMD		0xE4 // return pv sim control status
#define PVSHDPARME5_CMD						0xE5
//															0xE6
//															0xE7
//															0xE8
#define PVSHDBUILDBASICOK_CMD		0xE9
#define PVSSHDSIMMODE_CMD				0xEA
#define PVTABCRC_CMD						0xEB
#define PVTABCRCQ_CMD						0xEC
#define PVRABCRCR_CMD						0xED

uint8_t receiveMBResponse(COM_TypeDef COM);
extern  uint8_t measureFaultStatus[32];



// byte conversion related
// The output sequence of the int16, int32 and float is reversed. i.e. seq = byte_loc[3] byte_loc[2] byte_loc[1] byte_loc[0]
typedef union _unionbyte_TypeDef
{
    uint8_t byte_loc[4];
    uint16_t itob[2];
    uint32_t ltob;
    float ftob;
} unionbyte_TypeDef;

extern unionbyte_TypeDef unionbyte;





#define TX_LEN 			256
#define RX_LEN			256
typedef struct  {
	uint8_t head;
	uint8_t sourceAddr;
	uint8_t destinationAddr;
	uint8_t	length;
	uint8_t payload[256];
} complexPacketFormat;
typedef struct  {
	uint8_t head;
	uint8_t	length;
	uint8_t payload[256];
} simplePacketFormat;

typedef struct  {
	uint8_t Head;
	uint8_t	DA;
	uint8_t SA;
	uint8_t Len;
	uint8_t Cmd;
	uint8_t Data[256];
	uint8_t Serial;
	uint8_t CRC8;
	uint8_t dataIndex;
} rs485PacketFormat;


typedef struct {
 	uint8_t Head;
	uint8_t Tail;
	uint8_t Data[256];
	uint8_t Count;
} rs485AntiCollisionBuffer_TypDef;


typedef struct {
	float vSet;
	float iSet;
	uint8_t iOutIndex;
	float iOutData[PARALLEL_SAMPLE_WEIGHT];
	float iOut;
	float vOut;
	float deltaVSet;
	float iOutTarget;
	float dynamiciOutTarget;
	float vMax;
	float vMin;
	float iMax;
	float iMin;
	float SRvSet;
	float SRiSet;
	float pMax;
    float OVPMax;
    float OVPMin;
    float OCPMax;
    float OCPMin;
    float OPPMax;
    float OPPMin;
	float limitIMax;
	float limitIMin;
	float limitVMax;
	float limitVMin;

	float OCPSet;
	float OVPSet;
	float OPPSet;
	float ratioiMax;
	float limitdelta;	// ̤pLխ
	float erroriOutTarget; // վqy~t
	uint8_t	address;
	uint8_t name[2];
	uint8_t exist;
	uint8_t outputStatus;
	uint8_t status;
	
} rs485IDFormat;


typedef struct {
	uint8_t len;
	uint8_t	cmd;
	uint8_t add;

	unionbyte_TypeDef unionbyte;
//	uint8_t temp8;
//	uint16_t temp16;
//	uint32_t temp32;  
//	float tempfloat; 
} rs485Buffer;

//#define LOOP			0
//#define SETONOFF		1
//#define BROADCAST		2


extern rs485Buffer rs485Temp;
extern uint8_t slaveIndex;
extern uint8_t cmdexenum;
#define MASTERQUERYCMD	1
#define MASTERSETINT8	2
#define MASTERSETINT16	3
#define MASTERSETFLOAT	4
#define MASTERSETINT32	5
#define MASTERSET4FLOAT	6


extern uint8_t slaveNumber;
 void processCmd(uint8_t n);

// 485RO

#define CMD_QID			0x01	//(]wΩRO)
#define CMD_CONTROL		0x02	//(]wΩRO)
#define CMD_SETV		0x03	//]wq
#define CMD_SETI		0x04	//]wqy
#define CMD_SETOVP		0x05	//]wOVPq
#define CMD_SETOCP		0x06	//]wOCPqy
#define CMD_SETOPP		0x07	//]wOPP\v
#define CMD_SETOUTPUT	0x08	//]wXA
#define CMD_QCURR		0x09	//߰ݿXqy
#define CMD_RCURR		0x0A	//^Xqy
#define CMD_QVOLT		0x0B	//߰ݿXq
#define CMD_RVOLT		0x0C	//^Xq
#define CMD_SETVSLEW	0x0D	//]wqSlew Rate
#define CMD_SETISLEW	0x0E	//]wqySlew Rate
#define CMD_SETOVPONOFF 0x0F	//]wOVP\O_Ұ
#define CMD_SETOCPONOFF	0x10	//]wOCP\O_Ұ
#define CMD_SETOPPONOFF 0x11	//]wOPP\O_Ұ
#define CMD_ADR			0x12	//]wADDRESS
#define CMD_CLS			0x13	//MERRORA
#define CMD_CLR			0x14	//MOA
#define CMD_RST			0x15	//sҰʾ
#define CMD_QSTB		0x16	//߰ݾA
#define CMD_RSTB		0x17	//^A
#define CMD_QIDN		0x18	//߰ݾ
#define CMD_RIDN		0x19	//^
#define CMD_QREV		0x1A	//߰ݾ骩
#define CMD_RREV		0x1B	//^骩
#define CMD_QSN			0x1C	//߰ݾǸ
#define CMD_RSN			0x1D	//^Ǹ
#define CMD_QVI			0x1E	//Pɸ߰ݿXqqy
#define CMD_RVI			0x1F	//^߰ݿXqqy
#define CMD_QOUT		0x20	//߰ݿXA
#define CMD_ROUT		0x21	//^XA
#define CMD_QOVP		0x22	//߰OVP]w
#define CMD_ROVP		0x23	//^OVP]w
#define CMD_QOVPONOFF	0x24	//߰OVPA
#define CMD_ROVPONOFF	0x25	//^OVPA
#define CMD_QOCP		0x26	//߰OCP]w
#define CMD_ROCP		0x27	//^OCP]w
#define CMD_QOCPONOFF	0x28	//߰OCPA
#define CMD_ROCPONOFF	0x29	//^OCPA
#define CMD_QOPP		0x2A	//߰OPP]w
#define CMD_ROPP		0x2B	//^OPP]w
#define CMD_QOPPONOFF	0x2C	//߰OPPA
#define CMD_ROPPONOFF	0x2D	//^OPPA
#define CMD_QMODE		0x2E	//߰ݾ
#define CMD_RMODE		0x2F	//^
#define CMD_QSETV		0x30	//߰ݳ]wq
#define CMD_RSETV		0x31	//^]wq
#define CMD_QSETI		0x32	//߰ݳ]wqy
#define CMD_RSETI		0x33	//^]wqy
#define CMD_OK			0x40	//^OK
#define	CMD_FAIL		0x41	//^FAIL
#define CMD_OVER		0x42	//^_ Range error
#define CMD_QOUTONOFF	0x43	//߰ ON or OFF
#define CMD_ROUTONOFF	0x44	//^_ ON or OFF
#define CMD_QMAXPOW 	0x45	//߰ Machine Max Power
#define CMD_RMAXPOW 	0x46	//^ Machine Max Power

#define CMD_SETPVCURV	0x50	//]wPVSIM curve
#define CMD_QPVCURV		0x51	//߰ݥثePVSIM curve
#define CMD_RPVCURV		0x52	//^ثePVSIM curve
#define CMD_SETPVPARAM	0x53	//]wPVSIM  isc ,voc,imp,vmp
#define CMD_QPVPARAM	0x54	//߰ PVSIM isc,voc,imp,vmp
#define CMD_RPVPARAM	0x55	//^ PVSIM isc,voc,imp,vmp
#define CMD_SETPVSTATE	0x56	//]wPVSIM (pvsONOFF) A ON/OFF
#define CMD_QPVSTATE	0x57	//߰PVSIM (pvsONOFF) A ON/OFF
#define CMD_RPVSTATE	0x58	//^PVSIM (pvsONOFF) A ON/OFF
#define CMD_SETPVPOW          0x59   // Set the simulated output power from 0 ~ 100%
#define CMD_QPVPOW            0x5A   // Query  the simulated output power from 0 ~ 100%
#define CMD_RPVPOW            0x5B   // Return  the simulated output power from 0 ~ 100%
#define CMD_SETPVTABLEPOINT   0x5C   // Set the point number n of the user defined V/I table
#define CMD_SETPVTABPARM      0x5D   // Set the parameters (voltage and current) of the table point number n
#define CMD_QPVTABPARM        0x5E   // Query the parameters (voltage and current) of the table point number n
#define CMD_RPVTABPARM        0x5F   // Return the parameters (voltage and current) of the table point number n
#define CMD_SETPVTABSTART     0x60   // Start the user defined V/I tableloading
#define CMD_SETPVTABSTOP      0x61   // Stop the user defined V/I table loading
#define CMD_QPVTABSTATE       0x62   // Query the previous write status of table point, 0=not OK, 1=OK
#define CMD_RPVTABSTATE       0x63   // Return the previous write status of table point, 0=not OK, 1=OK
#define CMD_SETPVGT			  0x64	 // Set irra(ӫ) ,temperature(ū) 10000 = 100?
#define CMD_SETPVFM			  0x65	 //	Set formula() ,material( )
#define	CMD_SETVMPPMP		  0x66	 //	zL vmp pmpѼƭpⲣ voc ,isc,imp
#define CMD_SETTABARRAY		  0x67	 //	Set the V/I table number array

#define CMD_SETPARALLELROLE	  0x68	 // ]w parallel mode MASTER ,SLAVE1 ,SLAVE2,SLAVE3~ SLAVE50
#define CMD_QPARALLELROLE	  0x69	 // parallel mode MASTER ,SLAVE1 ,SLAVE2,SLAVE3~ SLAVE50
#define CMD_SETCHAINADDRESS	  0x6A	 // ]w Chain mode 1, 2 , 3  ~ 50
#define CMD_QCHAINADDRESS	  0x6B	 //    Chain mode Address
#define CMD_SETPARALLELSTATE  0x6C	 // }/ PARALLEL MODE
#define CMD_SETCHAINSTATE	  0x6D	 //	}/ CHAIN MODE
#define CMD_SETPARALLELDEBUG  0x6E	 // }/ parallelMode Debug

#define CMD_SETCVCCONOFF	  0x70	// CVCC protect switch
#define CMD_SETCCCVONOFF	  0x71	// CCCV protect switch

#define CMD_SETLIMITVMAX	  0x72	// set limitVMax
#define CMD_SETLIMITVMIN	  0x73	// set limitVMin

#define CMD_SETLIMITIMAX	  0x74	// limitIMax
#define CMD_SETLIMITIMIN	  0x75	// limitIMin
#define CMD_SETPVCTRLMOD	  0x76	// pvCtrlMode


#define CMD_SETECHO			  0x80		// ]ws^
#define CMD_SETPVSHDE5   	0x81		// shadow parameter
#define CMD_SETPVSHDE6   	0x82		// shadow  num G T
#define CMD_SETPVSHDE7   	0x83		// shadow  parallel number
#define CMD_SETPVSHDE8   	0x84		// shadow  parallel type

#define CMD_PVSHDE9Q			0x85		// query E9 state
#define CMD_PVSHDE9R			0x86		// respones E9 state

#define CMD_SETPVSHDEA   	0x87		// shadow  sim mode

#define CMD_SETPVTABCRC		0x88		// set PV Table crc checksum
#define CMD_PVTABCRCQ			0x89		// query PV Table crc check
#define CMD_PVTABCRCR			0x8A		// respones PV Tbale crc checksum


extern rs485IDFormat master;
extern rs485IDFormat slave1; 
extern rs485IDFormat slave2;
extern rs485IDFormat slave3;
extern rs485IDFormat slave4; 
extern rs485IDFormat slave5;
extern rs485IDFormat slave6;
extern rs485IDFormat slave7; 
extern rs485IDFormat slave8;
extern rs485IDFormat slave9;
extern rs485IDFormat slave10; 
extern rs485IDFormat slave11;
extern rs485IDFormat slave12;
extern rs485IDFormat slave13;
extern rs485IDFormat slave14; 
extern rs485IDFormat slave15;
extern rs485IDFormat slave16;
extern rs485IDFormat slave17; 
extern rs485IDFormat slave18;
extern rs485IDFormat slave19;
extern rs485IDFormat slave20; 
extern rs485IDFormat slave21; 
extern rs485IDFormat slave22;
extern rs485IDFormat slave23;
extern rs485IDFormat slave24; 
extern rs485IDFormat slave25;
extern rs485IDFormat slave26;
extern rs485IDFormat slave27; 
extern rs485IDFormat slave28;
extern rs485IDFormat slave29;
extern rs485IDFormat slave30; 
extern rs485IDFormat slave31;
extern rs485IDFormat slave32;
extern rs485IDFormat slave33;
extern rs485IDFormat slave34; 
extern rs485IDFormat slave35;
extern rs485IDFormat slave36;
extern rs485IDFormat slave37; 
extern rs485IDFormat slave38;
extern rs485IDFormat slave39;
extern rs485IDFormat slave40; 
extern rs485IDFormat slave41;
extern rs485IDFormat slave42;
extern rs485IDFormat slave43;
extern rs485IDFormat slave44; 
extern rs485IDFormat slave45;
extern rs485IDFormat slave46;
extern rs485IDFormat slave47; 
extern rs485IDFormat slave48;
extern rs485IDFormat slave49;



extern rs485IDFormat* slaveDUT[50]; 
extern rs485PacketFormat rs485Packet ,rs485Packet1 ;
extern rs485AntiCollisionBuffer_TypDef rs485AnitCollisionBuffer;

//extern rs485IDFormat slave;
typedef struct
{
	volatile uint8_t txBuffer[TX_LEN];		// ǰe 			
	volatile uint8_t txHead;				// ǰeY 	 		
	volatile uint8_t txTail;				// ǰe  			
	volatile uint8_t rxState;									
	volatile uint8_t rxBuffer[RX_LEN]; 		//  			
	volatile uint8_t rxHead;				// Y	  		
	volatile uint8_t rxTail;				// 
	volatile uint8_t packetCount;			// packet count, how many packets in the rxBuffer
	volatile uint8_t prev;		  	
	volatile uint8_t packetHead;			// head			
	volatile uint8_t sourceAddr;	 		// source address
	volatile uint8_t destinationAddr;		// destination address
	volatile uint8_t packetLen;				// length
	volatile uint8_t cmd;
	volatile uint8_t lengthReceived;		// received length
	volatile uint8_t packetCRC;				// packet CRC byte
	simplePacketFormat simplePacket;
}UARTx_BUFFER;





#define COM_MAX			6


extern 	uint16_t USART3_TX_CurrDataCounter;

/* USART1 TX DMA function */
#define USART1_TX_DMA_CHANNEL		   	DMA_Channel_4
#define USART1_TX_DMA_STREAM			DMA2_Stream7
#define USART1_TX_DR_ADDRESS            ((uint32_t)(USART1_BASE+4))	
//#define USART1_TX_BUFFER_ADDRESS		(uint32_t)uartBuffer[2].UartTx_Buffer
#define USART1_TX_DMA_CLK				RCC_AHB1Periph_DMA2
#define USART1_TX_DMAx_Streamx_IRQn		DMA2_Stream7_IRQn
#define	USART1_TX_DMA_FLAG_FEIF			DMA_FLAG_FEIF7
#define	USART1_TX_DMA_FLAG_DMEIF		DMA_FLAG_DMEIF7	
#define	USART1_TX_DMA_FLAG_TEIF			DMA_FLAG_TEIF7
#define	USART1_TX_DMA_FLAG_HTIF			DMA_FLAG_HTIF7
#define	USART1_TX_DMA_FLAG_TCIF			DMA_FLAG_TCIF7

#define	USART1_TX_DMA_IT_FEIF			DMA_IT_FEIF7
#define	USART1_TX_DMA_IT_DMEIF			DMA_IT_DMEIF7	
#define	USART1_TX_DMA_IT_TEIF			DMA_IT_TEIF7
#define	USART1_TX_DMA_IT_HTIF			DMA_IT_HTIF7
#define	USART1_TX_DMA_IT_TCIF			DMA_IT_TCIF7



/* USART2 TX DMA function */
#define USART2_TX_DMA_CHANNEL		   	DMA_Channel_4
#define USART2_TX_DMA_STREAM			DMA1_Stream6
#define USART2_TX_DR_ADDRESS            ((uint32_t)(USART2_BASE+4))	
//#define USART2_TX_BUFFER_ADDRESS		(uint32_t)uartBuffer[2].UartTx_Buffer
#define USART2_TX_DMA_CLK				RCC_AHB1Periph_DMA1
#define USART2_TX_DMAx_Streamx_IRQn		DMA1_Stream6_IRQn
#define	USART2_TX_DMA_FLAG_FEIF			DMA_FLAG_FEIF6
#define	USART2_TX_DMA_FLAG_DMEIF		DMA_FLAG_DMEIF6	
#define	USART2_TX_DMA_FLAG_TEIF			DMA_FLAG_TEIF6
#define	USART2_TX_DMA_FLAG_HTIF			DMA_FLAG_HTIF6
#define	USART2_TX_DMA_FLAG_TCIF			DMA_FLAG_TCIF6

#define	USART2_TX_DMA_IT_FEIF			DMA_IT_FEIF6
#define	USART2_TX_DMA_IT_DMEIF			DMA_IT_DMEIF6	
#define	USART2_TX_DMA_IT_TEIF			DMA_IT_TEIF6
#define	USART2_TX_DMA_IT_HTIF			DMA_IT_HTIF6
#define	USART2_TX_DMA_IT_TCIF			DMA_IT_TCIF6

/* USART3 TX DMA function */

#define USART3_TX_DMA_CHANNEL		   	DMA_Channel_4
#define USART3_TX_DMA_STREAM			DMA1_Stream3
#define USART3_TX_DR_ADDRESS            ((uint32_t)(USART3_BASE+4))	//USART3   0x4000 4800 - 0x4000 4BFF  (USART3)  DR offset 0x04
//#define USART3_TX_BUFFER_ADDRESS		(uint32_t)uartBuffer[2].UartTx_Buffer
#define USART3_TX_DMA_CLK				RCC_AHB1Periph_DMA1
#define USART3_TX_DMAx_Streamx_IRQn		DMA1_Stream3_IRQn

#define	USART3_TX_DMA_FLAG_FEIF			DMA_FLAG_FEIF3
#define	USART3_TX_DMA_FLAG_DMEIF		DMA_FLAG_DMEIF3	
#define	USART3_TX_DMA_FLAG_TEIF			DMA_FLAG_TEIF3
#define	USART3_TX_DMA_FLAG_HTIF			DMA_FLAG_HTIF3
#define	USART3_TX_DMA_FLAG_TCIF			DMA_FLAG_TCIF3

#define	USART3_TX_DMA_IT_FEIF			DMA_IT_FEIF3
#define	USART3_TX_DMA_IT_DMEIF			DMA_IT_DMEIF3	
#define	USART3_TX_DMA_IT_TEIF			DMA_IT_TEIF3
#define	USART3_TX_DMA_IT_HTIF			DMA_IT_HTIF3
#define	USART3_TX_DMA_IT_TCIF			DMA_IT_TCIF3

/* UART4 TX DMA function */
#define UART4_TX_DMA_CHANNEL		   	DMA_Channel_4
#define UART4_TX_DMA_STREAM				DMA1_Stream4
#define UART4_TX_DR_ADDRESS            ((uint32_t)(UART4_BASE+4))	
//#define UART4_TX_BUFFER_ADDRESS		(uint32_t)uartBuffer[2].UartTx_Buffer
#define UART4_TX_DMA_CLK				RCC_AHB1Periph_DMA1
#define UART4_TX_DMAx_Streamx_IRQn		DMA1_Stream4_IRQn
#define	UART4_TX_DMA_FLAG_FEIF			DMA_FLAG_FEIF4
#define	UART4_TX_DMA_FLAG_DMEIF			DMA_FLAG_DMEIF4	
#define	UART4_TX_DMA_FLAG_TEIF			DMA_FLAG_TEIF4
#define	UART4_TX_DMA_FLAG_HTIF			DMA_FLAG_HTIF4
#define	UART4_TX_DMA_FLAG_TCIF			DMA_FLAG_TCIF4

#define	UART4_TX_DMA_IT_FEIF			DMA_IT_FEIF4
#define	UART4_TX_DMA_IT_DMEIF			DMA_IT_DMEIF4	
#define	UART4_TX_DMA_IT_TEIF			DMA_IT_TEIF4
#define	UART4_TX_DMA_IT_HTIF			DMA_IT_HTIF4
#define	UART4_TX_DMA_IT_TCIF			DMA_IT_TCIF4

/* UART5 TX DMA function */
#define UART5_TX_DMA_CHANNEL		   	DMA_Channel_4
#define UART5_TX_DMA_STREAM				DMA1_Stream7
#define UART5_TX_DR_ADDRESS            ((uint32_t)(UART5_BASE+4))	//UART5->DR 
//#define UART5_TX_BUFFER_ADDRESS		(uint32_t)uartBuffer[2].UartTx_Buffer
#define UART5_TX_DMA_CLK				RCC_AHB1Periph_DMA1
#define UART5_TX_DMAx_Streamx_IRQn		DMA1_Stream7_IRQn
#define	UART5_TX_DMA_FLAG_FEIF			DMA_FLAG_FEIF7
#define	UART5_TX_DMA_FLAG_DMEIF			DMA_FLAG_DMEIF7	
#define	UART5_TX_DMA_FLAG_TEIF			DMA_FLAG_TEIF7
#define	UART5_TX_DMA_FLAG_HTIF			DMA_FLAG_HTIF7
#define	UART5_TX_DMA_FLAG_TCIF			DMA_FLAG_TCIF7

#define	UART5_TX_DMA_IT_FEIF			DMA_IT_FEIF7
#define	UART5_TX_DMA_IT_DMEIF			DMA_IT_DMEIF7	
#define	UART5_TX_DMA_IT_TEIF			DMA_IT_TEIF7
#define	UART5_TX_DMA_IT_HTIF			DMA_IT_HTIF7
#define	UART5_TX_DMA_IT_TCIF			DMA_IT_TCIF7

/* USART6 TX DMA function */
#define USART6_TX_DMA_CHANNEL		   	DMA_Channel_5
#define USART6_TX_DMA_STREAM			DMA2_Stream6
#define USART6_TX_DR_ADDRESS            ((uint32_t)(USART6_BASE+4))	//USART6->DR 
//#define USART6_TX_BUFFER_ADDRESS		(uint32_t)uartBuffer[2].UartTx_Buffer
#define USART6_TX_DMA_CLK				RCC_AHB1Periph_DMA2
#define USART6_TX_DMAx_Streamx_IRQn		DMA2_Stream6_IRQn
#define	USART6_TX_DMA_FLAG_FEIF			DMA_FLAG_FEIF6
#define	USART6_TX_DMA_FLAG_DMEIF		DMA_FLAG_DMEIF6	
#define	USART6_TX_DMA_FLAG_TEIF			DMA_FLAG_TEIF6
#define	USART6_TX_DMA_FLAG_HTIF			DMA_FLAG_HTIF6
#define	USART6_TX_DMA_FLAG_TCIF			DMA_FLAG_TCIF6

#define	USART6_TX_DMA_IT_FEIF			DMA_IT_FEIF6
#define	USART6_TX_DMA_IT_DMEIF			DMA_IT_DMEIF6	
#define	USART6_TX_DMA_IT_TEIF			DMA_IT_TEIF6
#define	USART6_TX_DMA_IT_HTIF			DMA_IT_HTIF6
#define	USART6_TX_DMA_IT_TCIF			DMA_IT_TCIF6


extern	UARTx_BUFFER	uartBuffer[COM_MAX];


extern uint32_t usartflags;

#define IS_TRIGGER		            (usartflags & (BIT0))
#define SET_TRIGGER		            (usartflags |= (BIT0))
#define CLR_TRIGGER		            (usartflags &= ~(BIT0))

#define IS_SENT	    	            (usartflags & (BIT1))
#define SET_SENT		            (usartflags |= (BIT1))
#define CLR_SENT		            (usartflags &= ~(BIT1))

#define IS_MEAS_HAS_VALID_DATA      (usartflags & (BIT2))
#define SET_MEAS_HAS_VALID_DATA     (usartflags |= (BIT2))
#define CLR_MEAS_HAS_VALID_DATA     (usartflags &= ~(BIT2))

#define IS_SET_VALUE                (usartflags & (BIT3))   // ǰeset value command flag
#define SET_SET_VALUE               (usartflags |= (BIT3))
#define CLR_SET_VALUE               (usartflags &= ~(BIT3))




#define QUEUE_LENGTH             10

extern uint8_t 	  triggerBufferindex;
extern uint8_t*   triggerBuffer[QUEUE_LENGTH];
extern uint8_t*   measureBuffer[QUEUE_LENGTH];
extern uint8_t 	  measureBufferindex;

/* ǰeƵ{
   com  	iHO COM1,COM2,COM3,COM4,COM5,COM6
   *str  	Orꤺe
   length 	Oǰe
*/
void uartTransmit(COM_TypeDef COM,uint8_t *str,uint8_t length);
/*
   DMA USART TX ǰeƵ{
   DMAy_Streamx   :DMA stream channel
   *str  	Orꤺe
   length 	Oǰe   

 */
void scpiuartTransmit(COM_TypeDef COM,uint8_t *str,uint8_t length);
void dmaTransmit(uint8_t com,uint8_t *str,uint8_t length);
void getMeasurementData(void);
void triggerMeasurement(void);
void measureParser(void);
void clearMeasureCommand(void);
uint8_t rs485PacketParser(void);
void masterSlaveControl(void);
void checkLANGPIB(void);
void GPIBLANRestart(void);



#define VMAX10005	1010
#define VMIN10005	5
#define IMAX10005	5.05
#define IMIN10005	0.02


#define VMAX60085	606
#define VMIN60085	5//3
#define IMAX60085	8.585
#define IMIN60085	0.034



#define PMIN	(master.vMin*master.iMin)

#define VSRMAX	4 //9999	//4
#define VSRMIN	0.1 //0		//0.1
#define ISRMAX	20//9999 //20
#define ISRMIN	0.3 //0    //0.3


extern uint8_t masterState,slaveState;

#define QUERYSLAVEA		1
#define SLAVEAACK		2
#define QUERYSLAVEB		3
#define SLAVEBACK		4
#define QUERYSLAVEC		5
#define	SLAVECACK		6

#define SHOWFOUNDSLAVE	110

#define BROADCAST		111	//BROADCAST
#define SETONOFF		112
#define SETVSETI		113
#define SYNC			114

#define QUERYCURR		115


#define LASTCMD			120



void translate485Cmd(uint8_t cmd,uint8_t des,uint8_t sur);
void bkiMax(uint8_t para);
void masterParallelSetCmdFloat(float value,uint8_t cmd);
float sumiOutTarget(void); 
float sumiSet(void);
float sumiOut(void);
uint8_t sumSlaves(void);
float sumiMax(void);
float sumiMin(void);
float sumiOutData(void);
float sumRatioiMax(void);
float sumOCPSet(void);
float sumOCPMax(void);
float sumOCPMin(void);
float sumlimitIMax(void);
float sumlimitIMin(void);
float sumpMax(void)	;

void rs485QueryIDN(void);
void delayNop(uint32_t count);

void calCurrRatio(float value);
void pushError(uint8_t state);
uint8_t popError(void);
void clearErorrQueue(void );
void clearFilterData(void);
extern uint8_t errorIndex;
extern uint8_t errorQueue[256];

#define OVER_RANGE				1
#define LIMIT_RANGE 			2
#define AD_OVER					3
#define SLAVE_TIME_OUT			4
#define MEASURE_VERIFY_ERROR	5
#define GPIB_VERIFY_ERROR		6

#define SLAVEA_ERROR			7 
#define SLAVEB_ERROR			8
#define SLAVEC_ERROR			9

#define PV_SIM_DATA_ERROR		10

#define SLAVE_ERROR				11
#define SLAVE_HW_ERROR			12
#define IMP_OVER_RANGE			13

#define HOLD_RS485_BUS			CV_CC_STATE_LOW
#define RELEASE_RS485_BUS		CV_CC_STATE_HIGH

#define RS485_BUS_STATUS		ADCDualConvertedValue[1]
#define RS485_BUS_FREE			(2800 ) 		  // 2947  8 V *1/3.37 = 2.37V	  (1k .2.37k)
#define RS485_TWO_SLAVE			(1900 )		  // 1841      5 V *1/3.37 = 1.48V

//   10V 3821
//    9V 3300
// 6.15V 2280
//  3.2V 1197

extern float rs485SlavevSet[MAX_CHAINADDR];
extern float rs485SlaveiSet[MAX_CHAINADDR];
extern float rs485SlavevOut[MAX_CHAINADDR];
extern float rs485SlaveiOut[MAX_CHAINADDR];

extern uint8_t broadcastEcho;
extern uint8_t broadcastOKCount[32];
extern uint32_t broadcastOKTimer[32];
extern uint8_t broadcastVICount;
typedef struct  {
	uint8_t id;
	uint8_t exist;		 //sb
	uint8_t disconnect;	 //_u
	uint32_t timer[3];	 //p pɶ
}rs485Id_TypDef;

#define CMD_QVI_COUNT	0
#define CMD_OK_COUNT	1


extern rs485Id_TypDef rs485Id[MAX_CHAINADDR];
extern uint8_t showMeter;	 			// METER key use 
extern uint8_t	totalSlave;
void rs485AntiCollision(void);

extern uint32_t rs485PacketSerialNumberFlag;
extern uint32_t rs485ErrorConnect[2];

uint8_t specifyNumber(void);
void receivedRS485Packet(void);
#define DELAY_ADDTIME 	6
void rs485TransmitRetroactive(void);
extern uint8_t broadcastOKBuffer[32][20];

typedef struct {
	float voltage;
	float current;
} GpvTabParm_TypDef;


//typedef struct VERIFY{
//  uint8_t cmd;
//	uint8_t queryCounter;
//	uint32_t timer;
//	float value;
//} VERIFY_Def;
//typedef struct VERIFT_QUEUE{
//  VERIFY_Def item[256];
//	uint8_t head;
//	uint8_t tail;
//}	VERIFYQUEUE_Def;

//extern VERIFYQUEUE_Def verifyQueue;
//void checkSetValue(void);


extern GpvTabParm_TypDef GpvTabParm[4096];
extern uint8_t parallelDebug;

extern uint8_t currentSourceState;
#define CURRENT_SOURCE_NOT_EXIST		0	 // u DB25 Pin Lqy
#define MULTI_SOURCE					2
#define ONE_SOURCE						1
#define DB25_NOT_INSTALL				3	 // DB25 pin Hardware S


void initchainMode(void);
void initparallelMode(void);
void checkCurrentSource(void);
uint32_t shiftLeftWordBlock(void *a,uint8_t len);
#endif






