

/* Includes ------------------------------------------------------------------*/
#include <ctype.h>
#include <math.h>
#include "includes.h"
#include "variable.h"
#include "PVSState.h"
uint8_t programStart = 0;
float tempiSet;
float around;
float extvMax,extiMax;

uint8_t specif;
void parallelInitRun(void);

uint8_t currentSourceState;
__IO uint32_t LsiFreq = 0;



#define VADHIGH1	60000 	//2000
#define VADHIGH2	60000	//10500
#define VADHIGH3	60000	//20000						  
#define VADHIGH4	60000	//27000

#define VADLOW1		0		//900
#define VADLOW2		0		//7000
#define VADLOW3		0		//14000
#define VADLOW4		0		//21000



#define IADHIGH1	60000	//1500
#define IADHIGH2	60000	//10300
#define IADHIGH3	60000	//20500
#define IADHIGH4	60000	//30000

#define IADLOW1		0		//900
#define IADLOW2		0		//8300
#define IADLOW3		0		//17500
#define IADLOW4		0		//25000

uint16_t	d = 0;
uint16_t	Databuf[1000];

uint8_t	otwdisplayBuffer[49];


uint8_t slaveErrorState;

uint16_t	iTemp;
uint8_t voltPoint = 0;	 // voltage point
uint8_t currPoint = 0;	 // current point
uint8_t powPoint = 0;	 // power point

typedef struct _incType
{
	uint8_t digit;
	float delta;
}
INC_TYPE;
INC_TYPE  point0[6] = {
   {1,  	1		},
   {2,      10		},
   {3,      100		},
   {4,		1000	},
   {5,		10000	},
   {6,		100000	} 
};

INC_TYPE  point1[6] = {
   {1,  	0.1		},
   {3,      1		},
   {4,      10		},
   {5,		100		},
   {6,		1000	},
   {7,		10000	} 
};

INC_TYPE  point2[6] = {
   {1,  	0.01	},
   {2,      0.1		},
   {4,      1		},
   {5,		10		},
   {6,		100		},
   {7,		1000	} 
};

INC_TYPE  point3[6] = {
   {1,  	0.001	},
   {2,      0.01	},
   {3,      0.1		},
   {5,		1		},
   {6,		10		},
   {7,		100		} 
};

INC_TYPE  point4[6] = {
   {1,  	0.0001	},
   {2,      0.001	},
   {3,      0.01	},
   {4,		0.1		},
   {6,		1		},
   {7,		10		}, 
};

INC_TYPE * numerical[5][6] = {
&point0[0],&point0[1],&point0[2],&point0[3],&point0[4],&point0[5],
&point1[0],&point1[1],&point1[2],&point1[3],&point1[4],&point1[5],
&point2[0],&point2[1],&point2[2],&point2[3],&point2[4],&point2[5],
&point3[0],&point3[1],&point3[2],&point3[3],&point3[4],&point3[5],
&point4[0],&point4[1],&point4[2],&point4[3],&point4[4],&point4[5]
};




uint8_t *voltDisp[4]  = {
  "%6.0f",
  "%6.1f",
  "%6.2f",
  "%6.3f"
};

uint8_t *voltDispUnit[4]  = {
  "%6.0fV",
  "%6.1fV",
  "%6.2fV",
  "%6.3fV"
};


uint8_t *currDisp[5]  = {
  "%7.0f",
  "%7.1f",
  "%7.2f",
  "%7.3f",
  "%7.4f"
};
uint8_t *currDispUnit[5]  = {
  "%7.0fA",
  "%7.1fA",
  "%7.2fA",
  "%7.3fA",
  "%7.4fA"
};




uint8_t *powDisp[4]  = {
  "%6.0f",
  "%6.1f",
  "%6.2f",
  "%6.3f"
};

uint8_t *powDispUnit[4]  = {
  "%6.0fW",
  "%6.1fW",
  "%6.2fW",
  "%6.3fW"
};



uint8_t *pvSim[3] = {
"  Reg:%6d    Vmp:%6.0f V>< Pmp:%6.0f W  Mtl:%6d   ",
"  Reg:%6d    Vmp:%6.1f V>< Pmp:%6.1f W  Mtl:%6d   ",
"  Reg:%6d    Vmp:%6.2f V>< Pmp:%6.1f W  Mtl:%6d   "
};


#define PVS_CURVE_USER	255	// PV SIM  16 curve

#define GPIB9914MAX		192	 // GPIB packet 
#define GPIB9914MIN		16

uint32_t CRC8ErrorCount;
uint16_t iOutADCount,vOutADCount;	// ADC count
uint8_t patternChecksum;			// some checksum
uint8_t cpuEnablePinCount;			// ENABLE PIN count

uint8_t E7Board = 0;				// E7 board exist or not
uint8_t measurementInf[64];			// E7 board information
uint8_t pfcInf[64];					// E1 board information
uint8_t gpibInf[64];				// GPIB board information


#if (_DEBUG_CHANNEL != 0)	   // 
#define POS		9
static uint8_t usbDebugOutBuffer[64];
static uint8_t usbDebugInBuffer[64]; 
#endif

state_id swapState;	                     /* just buffer   */
state_id lastLastLastState = D_NORMAL;     /*WWWA     */
state_id lastLastState = D_NORMAL;    	 /* WWA      */
state_id lastState = D_NORMAL;    	     /* W@A      */
state_id actualState;                    /* 檺A  */

uint32_t stateChangeFlag = 0; 			 // some flags
uint32_t stateChangeFlag1 = 0;
uint32_t stateChangeFlag2 = 0;
KEY_TYPE  keyParameter;					 // key information


__ALIGN_BEGIN USB_OTG_CORE_HANDLE      USB_OTG_dev __ALIGN_END ;

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

#define UI_TEST_EXT232		"Hello! I am Rs232 Port\r"
#define UI_TEST_EXT485		"Hello! I am Rs485 Port\r"
#define UI_TEST_INTMEASURE	"Hello! I am Measurement Port\r\n"
#define UI_TEST_INTGPIBLAN	"Hello! I am GPIB Port\r\n"
  

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
uint8_t temps[256];
uint8_t tempstring[32];
float tempf;
uint32_t VFDsign;
uint8_t keyCode;
uint8_t showMeter;	 			// METER key use
uint8_t displayFresh;
uint8_t dpFlag;				 	// Point flag
uint8_t keyInBuffer[8];
uint8_t displayBuffer[49] = {0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,
 0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,	0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20, 0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
} ;						
uint8_t displayBufferTemp[30]; // backup befor error message from displayBuffer[19] ~ displayBuffer[47]  
uint8_t measurementState;	   // query E7 state
uint32_t measureTick;



unionbyte_TypeDef unionbyte;


/* Private functions ---------------------------------------------------------*/

/**
  * @brief  Main program
  * @param  None
  * @retval None
  */

uint8_t cursorPosition;		// cursor position = 0x40 to 0x6F, corsor off = 0x00
uint8_t cursorPositionTemp ; // backup before error message cursorPosition;
uint8_t cursorPatternPosition;   //Item select pos
uint8_t cursorItemNumber;        // total Item
uint8_t flashPosition[6] ;//= {0x58,0x58,0x58,0x5D,0x5D,0x00};
uint8_t flashLength[6];
uint8_t memSysCommIpPosition = 0;
uint8_t menuItemBuffer[29*11+1];
uint8_t menuLevelPosition;
uint8_t menuLevel1; 
#define SYSTEM           0  
#define CONFIG    	     1
#define PVS				 2
#define INFO		     3
#define CALIBRATION		 4

uint8_t menuLevel2;
#define COMM             0
#define MEMORY_GROUP     1
#define BEEP             2
#define FACTORY_DEFAULT  3
#define POWER_ON_STATE   4

#define LIMIT            0
#define PROTECT          1
#define EXTCTRL          2
#define PARALLEL         3
#define CHAIN            4

uint8_t menuLevel3;											    
uint8_t menuLevel4;
uint8_t parameterTemp;
uint8_t programONOFFTemp;
uint8_t passwordLength;
uint8_t programCount = 0,timerCount = 0;

void setProtectSwitch(void);
ErrorStatus verifyInput(uint8_t cmd,float temp );
void initializePVS(void);
void showTempValue(uint8_t addr);
void shiftBufferLeft(uint8_t val ,uint8_t len);
void shiftBufferRight(uint8_t val ,uint8_t len);
uint8_t convertSettingValue(void);
void spaceToZero(uint8_t addr);
void initializeMB(void);
void initializeGPIBLAN(void);
void measureMB(void);
uint16_t convertFloatToInt(float value, float maxValue, uint16_t maxCount);
void sendMBIntSetting(uint8_t cmd, uint16_t value);
void sendMBFloatSetting(uint8_t cmd, float value);

void sendMBCalSetting(uint8_t cmd ,uint8_t value1,uint16_t value2);
void sendMBTwoIntSetting(uint8_t cmd, uint16_t value1, uint16_t value2);
void sendMBStateSetting(COM_TypeDef COM,uint8_t cmd, uint8_t state);
void sendMBQuery(COM_TypeDef COM,uint8_t cmd);
void sendRs485(void);
void sendRs232(void);


void processEvent(trigger_id event);
void keyParser(void);
//void initializePVSState(void);
void externalControlHandler(void);
void setTimerCount(void);
void checkTimerCount(uint32_t time);
void setTimerCount2(void);
void checkTimerCount2(uint32_t time);
void readProgramParameter(void);

void calibrationHandler(void);
ErrorStatus queryStepByStep(COM_TypeDef COM ,uint8_t cmd ,uint8_t reply ,uint32_t waitTime);
void inputNumerical(void);
void setInputParameter(uint8_t addr,uint8_t len , uint8_t point ,uint8_t fg ,float max , float min);
void getFirstStepProgram(void);
void programHandler(void);
void display(void);
void extfilterV(void);
void extfilterI(void);

void mul_word_blk(void *a ,void *b ,void *c,uint8_t a_len,uint8_t b_len);
uint32_t shr_word_blk(void *a,uint8_t len);
uint32_t add_word_blk(void *x, void *y,uint8_t len);
void clear_word_blk(void *a,int8_t len);
void selftestDisplay(void);

uint8_t readUserChecksum(void);
void writeUserChecksum(void);
void selftestNestHandler(void);
void gotoUpLayer(void);	// ^W@h
void eepromDefaultSet(void);
void softwareReset(void);
void restoreFactoryCal(void);
float buf;
extern uint32_t rawKeyCode;
void calVoltageInit(void);
void calCurrentInit(void);

void readKey		(void);
void processEvent(trigger_id event);
void initializePVSState(void);
void uartChannels(COM_TypeDef COM);

void sendGBStateSetting(COM_TypeDef COM,uint8_t cmd, uint8_t state1,uint8_t state2,uint8_t state3 ,uint8_t state4);



void reverseState(void)
{
	actualState = lastState;
	lastState = lastLastState;
	lastLastState = lastLastLastState;
}

uint8_t cnt = 0;

void readKey(void)
{
//	if (++cnt >= 1)
//	{
		keyCode = getKey1();
		if ((softTimer[SHOW_VERSION_COUNT].flag == DISABLE) && (IS_MODEL_CONFLICT == 0)) // Ver 1.A0
			keyParser();
//		cnt = 0;
//	}
//	else
//	{
//		keyParameter.keyFunction = KEY_NOTHING;
//		keyParameter.keyEvent = NULL_KEY;   
//	}
}

extern 	USART_InitTypeDef 			USART_InitStructure;

void selfTestCheck(void)
{
	keyCode = getKey();
	if (rawKeyCode == 0x40000008)// "1" + "."  }
	{
		int8_t i = 0;
//		vfdadjcount = UI_TEST_COUNT;
	  	USART_InitStructure.USART_BaudRate = 9600;
	  	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	  	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	  	USART_InitStructure.USART_Parity = USART_Parity_No;
	  	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	  	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
		USARTx_Configuration(MEASURE_CHANNEL,&USART_InitStructure); //E7 PWR
		USARTx_Configuration(GPIB_LAN_CHANNEL,&USART_InitStructure); //GPIB/LAN
		USARTx_Configuration(RS232_CHANNEL,&USART_InitStructure); //232
		USARTx_Configuration(RS485_CHANNEL,&USART_InitStructure); //485
		sprintf((void *)displayBuffer,"UI TEST           ");
		for (i = 6; i >= 0 ;i--)
		{
			sprintf((void *)(displayBuffer+19),"VFD Test Plaease Wait ... %d  ",i);
			dispVFD48(DISPBUF);
			delayMs(1000); // F vfdվ
		}
		strcpy((void *)menuItemBuffer," EEPROM  |EXT_CTRL |EXT_VOLT><EXT_CURR|INT_UART |EXT_UART><EXT_V_CC| EXT_I_CC|  EXIT   ");
		cursorItemNumber = 9;  
		flashBlock(0);
		actualState = SELFTEST3;
		SET_FAT_CAL; // tե
		displayFresh = 1;
		while(1)
		{
			readKey();
			processEvent(keyParameter.keyEvent);
	        initializePVSState();
			selftestDisplay();
//			HVVoltage();
		}
	}
}

void checkPowerOnState(void)
{
	switch(powerOnMode)											// check power on state
	{
		case 0: // OFF
			eepRead((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));		// 1.37  
			eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
			onoffStatus = 0;
			break;
		case 1:	// LAST
			eepRead((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
			eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
			eepRead((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
			break;
		case 2:	  // USER
		    master.vSet = powerOnVolt;
			master.iSet = powerOnCurrent;
			onoffStatus = powerOn_OnOff;
			break;
	}
	if (master.limitVMin > master.vSet)
		master.vSet = master.limitVMin;
	if (master.vSet > master.limitVMax)
		master.vSet = master.limitVMax;
	if (master.limitIMin > master.iSet)
		master.iSet = master.limitIMin;
	if (master.iSet > master.limitIMax)
		master.iSet = master.limitIMax;
	if (master.iSet * master.vSet > master.pMax)
		master.vSet = master.pMax/master.iSet;
	// send vset						
	if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
		eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
	// send iset
	if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
//		eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
	eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
	// send output off
	verifyInput(OUTPUT_CMD,(float)onoffStatus );
	master.exist = 1;
	CLR_MULTI_MASTER;
	chainAddrSlave = 0;
	delayMs(50);
	while(uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL) ;
	}


}


void TIM5_interruptInit(void); //10 m
void programmingE7E1(void);
uint8_t PVDState = 0; 		// power voltage detect State
uint8_t serialNumber[20];
uint8_t rs232p[32];
uint8_t rs485p[32];
uint8_t manufacture[20];
uint8_t model[20];
uint8_t GPIBStatus = 0;



/* 	
	machine1000 = 0; // means 1000V
	machine1000 = 1; // means 600V

	machine3KW = 1;	 // means 3KW
	machine3KW = 0;	 // measn 5KW

*/

void showManufactureInfo(void)
{
	memset((void *)displayBuffer ,0x20,48);
	sprintf((void *)(displayBuffer), (void *)manufacture);
	sprintf((void *)(displayBuffer+19), (void *)model);
	machine1000 = 0;
	if ((memcmp((void *)model ,"IT6625S",7) == 0) || (memcmp((void *)model ,"IT6624S",7) == 0))
	{
		if ( memcmp((void *)model ,"IT6624S",7) == 0)
			machine1000 = 1;//600V
		machine3KW = 1; // 3KW
		keyType = KEY29;
	}
	else if(memcmp((void *)model ,"PVS10005A-TC",12) == 0) 
	{
		memset((void *)model ,0, 20);
		strcpy((void *)model,"PVS10005MR");
		eepWrite((uint8_t *)&model, EE_MODEL ,20);
	}
	else if (memcmp((void *)model ,"PVS60085A-TC",12) == 0)
	{
		memset((void *)model ,0, 20);
		strcpy((void *)model,"PVS60085MR");
		eepWrite((uint8_t *)&model, EE_MODEL ,20);
	}	
	if((memcmp((void *)model ,"PVS10005MR",10) == 0) || (memcmp((void *)model ,"PVS60085MR",10) == 0))
	{
		if ( memcmp((void *)model ,"PVS60085MR",10) == 0)
			machine1000 = 1;//600V
		machine3KW = 1; //3KW B&K  Taiwan
		keyType = KEY23;
	}
	else if((memcmp((void *)model ,"IT6635S",7) == 0) || (memcmp((void *)model ,"IT6634S",7) == 0))
	{
		if ( memcmp((void *)model ,"IT6634S",7) == 0)
			machine1000 = 1;//600V
		machine3KW = 0; // 5KW
	 	keyType = KEY29;
	}
	else if((memcmp((void *)model ,"PVS10005",8) == 0) || (memcmp((void *)model ,"PVS60085",8) == 0))
	{
		if ( memcmp((void *)model ,"PVS60085",8) == 0)
			machine1000 = 1;//600V
		machine3KW = 0; // 5KW
	 	keyType = KEY23;
	}
	eepWrite((uint8_t *)&keyType, EE_KEYTYPE ,sizeof(uint8_t));
	writePatternChecksum();

	dispVFD48((void *)displayBuffer);
	eepRead((uint8_t *)&MACaddress, EE_MACADDRESS ,6);
	delayMs(200);
	selfTestCheck();   											// self TEST section...
	delayMs(2000);												// FVER:....
}

void checkifGPIBDownload(void)
{
	if (IS_TRANSPARENT_GPIBL_DOWNLOAD)
	{
		CLR_TRANSPARENT_GPIBL_DOWNLOAD;
		sprintf((void *)(displayBuffer), "RUN PC TERM. PROG.");
    	sprintf((void *)(displayBuffer + 19), "Press 1=USB , 2=RS232        ");
		dispVFD48((void *)displayBuffer);
		keyCode = getKey1();
		while (keyCode != key_1 && keyCode != key_2)
		    keyCode = getKey1();
		if (keyCode == key_1)
			witchCOM = USB_VCP_CHANNEL;
		else if(keyCode == key_2)
		    witchCOM = RS232_CHANNEL;
		SCPI_DownLoadEG(&scpi_context);
	}
	displayFresh = 1;
}
uint16_t board;	// query E7 or E1 board
void checkPWRModule(void)
{
//    HVVoltage();
	memcpy((void *)(displayBuffer), "Checking PWR Module",19);
	dispVFD48((void *)displayBuffer);
	board = 0x0100;				 								// E7 IDN code
	if (queryStepByStep(MEASURE_CHANNEL,IDNQ_CMD,IDNR_CMD ,50) == SUCCESS){ // varify	// get measurement board old IDN?
	}
	sendMBIntSetting(IDNQ_CMD, board); 							// query E7 IDN? new
	delayMs(100);
//	HVVoltage();
	if ( uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}
	board = 0x0101;												// E1 IDN code
	sendMBIntSetting(IDNQ_CMD, board); 							// query E1	IDN? new
	delayMs(100);
//	HVVoltage();
	if ( uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}
	board = 0x0100;												// E7 IDN code(_)
	
}

void initGPIBLAN9600(void);

void initializePVS(void)
{
 	// 1010V W
	
	voltPoint = 1; //qpI1
	powPoint = 1;  //\vpI1
	currPoint = 4; //qypI4
	fullScale = 60600;
	master.vMax = VMAX10005;
	master.vMin = VMIN10005;
	master.ratioiMax = master.iMax = IMAX10005;
	master.iMin = IMIN10005;
	master.pMax = 5100.5;
	master.OVPMax = 1100;
	master.OVPMin = 10;
	master.OCPMax = 5.1;
	master.OCPMin = 0.05;
	master.OPPMax = 5200;
	master.OPPMin = 100;
	VSRMax = 4;
	ISRMax = 20;
	master.SRvSet = VSRMax;
	master.SRiSet = ISRMax;
		extvMax = 1000;
		extiMax = 5;
	memcpy((void *)(gpibInf+22)," NONE ",6);

}

void clearSlaveDUT(void)
{
	uint8_t i;
	for (i = 1 ; i <= SLAVEMAXNUM ; i++)
	{
		slaveDUT[i]->iSet = 0;
		slaveDUT[i]->iOut = 0;
		slaveDUT[i]->iMax = 0;
		slaveDUT[i]->ratioiMax =  0;
		slaveDUT[i]->iMin = 0;
		slaveDUT[i]->vMax = 0;
		slaveDUT[i]->vMin = 0;
		slaveDUT[i]->exist = 0;
		slaveDUT[i]->pMax = 0;
	}
	slaveDUT[0]->ratioiMax = slaveDUT[0]->iMax;
}

void checkCurrentSource(void)
{

	HOLD_RS485_BUS;
	delayMs(10);
	getAdCh(1);	getAdCh(1);	getAdCh(1);
	if (RS485_BUS_STATUS >= 4000) // 4095 1.BC
		currentSourceState = DB25_NOT_INSTALL;
	else if (RS485_BUS_STATUS > 3000)
		currentSourceState = MULTI_SOURCE;
	else if (RS485_BUS_STATUS > RS485_TWO_SLAVE && RS485_BUS_STATUS < RS485_BUS_FREE)
		currentSourceState = ONE_SOURCE;
	else
		currentSourceState = CURRENT_SOURCE_NOT_EXIST;
	RELEASE_RS485_BUS;
}
void parallelInitRun(void);

uint32_t GetLSIFrequency(void);


int main(void)	 //y{ P90 P91
{
	initializePVS();
	initializeBoard();									// Hardware initialize
	showManufactureInfo();
	USBD_Init(&USB_OTG_dev, USB_OTG_FS_CORE_ID, &USR_desc, &USBD_CDC_cb, &USR_cb); // initialize USB VCP
	checkPWRModule();									// check PWR Module
	SCPI_Init(&scpi_context);							// SCPI RAM initialize
	initializeMB();	 									// initial measurement board
	readParameter(); 									// read eeprom parameter
	checkLANGPIB();	        							// check LAN/GPIB//
	checkPowerOnState();								// check power on state	
	checkifGPIBDownload();
	checkCurrentSource();
	parallelInitRun();

#ifdef I_WATCH_DOG
  /* Check if the system has resumed from IWDG reset */
  if (RCC_GetFlagStatus(RCC_FLAG_IWDGRST) != RESET)
  {
    /* IWDGRST flag set */

    /* Clear reset flags */
    RCC_ClearFlag();
  }
  else
  {
    /* IWDGRST flag is not set */
  }
 
  /* Get the LSI frequency:  TIM5 is used to measure the LSI frequency */
  LsiFreq = GetLSIFrequency();
   
  /* IWDG timeout equal to 250 ms (the timeout may varies due to LSI frequency
     dispersion) */
  /* Enable write access to IWDG_PR and IWDG_RLR registers */
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);

  /* IWDG counter clock: LSI/32 */
  IWDG_SetPrescaler(IWDG_Prescaler_32);

  /* Set counter reload value to obtain 250ms IWDG TimeOut.
     Counter Reload Value = 250ms/IWDG counter clock period
                          = 250ms / (LSI/32)
                          = 0.25s / (LsiFreq/32)
                          = LsiFreq/(32 * 4)
                          = LsiFreq/128
   */
  IWDG_SetReload(LsiFreq/128);

  /* Reload IWDG counter */
  IWDG_ReloadCounter();

  /* Enable IWDG (the LSI oscillator will be enabled by hardware) */
  IWDG_Enable();
#endif





#ifdef W_WATCH_DOG
    /* WWDG configuration */
    /* Enable WWDG clock */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_WWDG, ENABLE);

    /* WWDG clock counter = (PCLK1 (30MHz)/4096)/8 = 915 Hz (~1092 us)  */
    WWDG_SetPrescaler(WWDG_Prescaler_8);

    /* Set Window value to 80; WWDG counter should be refreshed only when the counter
      is below 80 (and greater than 64) otherwise a reset will be generated */
    WWDG_SetWindowValue(127);

    /* Enable WWDG and set counter value to 127, WWDG timeout = ~1092 us * 64 = 69.9 ms 
      In this case the refresh window is: ~1092 * (127-80) = 51.3 ms < refresh window < ~1092 * 64 = 69.9ms
    */
    WWDG_Enable(127);  // 127-127 * 1092us =  0 ms < refresh window  < ~1092 * 64 = 69.9ms
#endif   
	while (1)	{
		readKey();
		processEvent(keyParameter.keyEvent);		// main_fops.processevent(keyParameter.keyEvent);	
		initializePVSState();							      // main_fops.machineinit();
		uartChannels(USB_VCP_CHANNEL);					// main_fops.iouart(MEASURE_CHANNEL);
		uartChannels(MEASURE_CHANNEL);
		uartChannels(RS232_CHANNEL);
		uartChannels(RS485_CHANNEL);
		uartChannels(GPIB_LAN_CHANNEL);
		calibrationHandler();			   				    // ե{  y{ P29~P33
		programHandler();				   				      // running program {
		externalControlHandler();						    // external control 
		errorMessageTimeOut();			   				  // over range ... ~Tܮɶ
		display();						   				        // if displayFresh = 1  than show displayBuffer on VFD
		programmingE7E1();								      // N E7 or E1
		if (IS_START_SCPIOVPOCP_CAL )	{  				// OVP OCPե
			if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	{
				uartBuffer[MEASURE_CHANNEL].packetCount--;
				receiveMBResponse(MEASURE_CHANNEL);
				CLR_SCPI_CAL;
				CLR_FAT_CAL;
				CLR_START_SCPIOVPOCP_CAL;
				scpiFinishCal();						        // SCPI cal finish use	// us@
			}
		}
		if (IS_SCPI_RESET)
		{
			softwareReset();
			actualState = D_NORMAL;
			CLR_SCPI_RESET;
		}
		if (softTimer[SCPI_RESET_COUNT].flag == ENABLE)
		{ // scpi gU *RST O b 500ms HWɶ@
			if (softTimer[MAIN_COUNT].count - softTimer[SCPI_RESET_COUNT].count > 500)
			{
			  softTimer[SCPI_RESET_COUNT].flag = DISABLE;
			}
		}

#ifdef	W_WATCH_DOG
	  WWDG_SetCounter(127);
#endif
#ifdef 	I_WATCH_DOG
/* Reload IWDG counter */
    IWDG_ReloadCounter();  
#endif
		if (rs485PacketSerialNumberFlag == 0xFFFFFFFF)
			rs485PacketSerialNumberFlag = 0;
	}
}


void parallelInitRun(void)
{

	if (parallelMode == ON)
	{
		clearSlaveDUT();
		CLR_MULTI_MASTER;
		R485Baud = BAUD_57600;// 57600
		rs485parityDataBits = 0; //N,8
		rs485stopBits = 0; // 1
		chainMode = OFF;
		VFDsign &=  ~(sign_ADDR);
		eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
		CLR_SLAVE_CONFIGURED;
		eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));		
//		master.iSet = sumiSet();
		slaveErrorState = NONE;
		memset((void *)&(uartBuffer[RS485_CHANNEL]) ,0, sizeof(UARTx_BUFFER));
		if (parallelRole == MASTER)
		{
			slaveIndex = 1;
			masterState = 1;
			if (slaveNumber != 0)
			{
				eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
				verifyInput(ISET_CMD,master.iSet);	//
				eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
			}
			slaveNumber = 0;
			cmdexenum = MASTERQUERYCMD;
			rs485Temp.cmd = CMD_QID;
			master.address = MASTER; // 0
			SYNCPinConfig(GPIO_OUTPUT);
			sendMBStateSetting(MEASURE_CHANNEL,PORTSW_CMD, 0x00  ); // close all protect
		}
		else
		{
			slaveIndex = 0;
			slaveNumber = 0;
			protsw = 0;	  // iJslaveMode  protect switch
			verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
			slaveState = 1;
			CLR_SLAVE_CONFIGURED;
			showMeter = 0;
			VFDsign = VFDsign & (~sign_METER);
			master.address = slaveDUT[parallelRole]->address;
			SYNCPinConfig(INTERRUPT); // interrupt
		}
		initializeRs485();
		setVFDFlashOff(0x40,48);
		softTimer[SLAVE_COUNT].flag = DISABLE;
		if (parallelRole == MASTER)
		{
			actualState = D_NORMAL;
			sprintf((void *)(displayBuffer), "PARALLEL MODE      ");
			sprintf((void *)(displayBuffer+19), "     CHECKING FOR SLAVE      ");
			dispVFD48((void *)displayBuffer);
			delayMs(1000);
			displayBuffer[42] ='.';
			dispVFD48((void *)displayBuffer);
			delayMs(1000);
			displayBuffer[43] ='.';
			dispVFD48((void *)displayBuffer);
			delayMs(1000);
			displayBuffer[44] ='.';
			dispVFD48((void *)displayBuffer);
			delayMs(1000);
			displayBuffer[45] ='.';
			dispVFD48((void *)displayBuffer);

			delayMs(1000);
		}
		else
			actualState = D_PARALLELSLAVE;
	   	VFDsign &= ~(sign_MENU);
		memset((void *)displayBuffer,' ',48);
		menuLevel1 = 0;
		menuLevel2 = 0;
		menuLevel3 = 0;
		menuLevel4 = 0;
		cursorPatternPosition = 0;
	}
}


uint8_t GPIBerrorStatus = 3;
#define GPIB_LAN_NORMAL		0
#define DHCP_NOT_WORK		1
#define DHCP_WORK			2

// ˬdGPIB/LANO_sb
void checkLANGPIB(void)
{
	if (GPIBStatus != 2)  // GPIB code O` ~check
	{
		uint8_t queryCount,received = 0;
		optCard = 0;
 		sprintf((void *)(displayBuffer), "Checking GPIB/LAN  ");
		sprintf((void *)(displayBuffer+19), "                             ");
		dispVFD48((void *)displayBuffer);
		memset((void *)&(uartBuffer[GPIB_LAN_CHANNEL] ) ,0,sizeof(UARTx_BUFFER));
//		HVVoltage();
		for (queryCount = 0 ;queryCount < 6 ;queryCount++)
		{
			received = 0;
			while (uartBuffer[GPIB_LAN_CHANNEL].packetCount != 0)
			{
				uartBuffer[GPIB_LAN_CHANNEL].packetCount--;
				receiveMBResponse(GPIB_LAN_CHANNEL);
				received = 1;
			}
			sendMBQuery(GPIB_LAN_CHANNEL,IDNQ_CMD);
			delayMs(100);
			received = 0;
			while (uartBuffer[GPIB_LAN_CHANNEL].packetCount != 0)
			{
				uartBuffer[GPIB_LAN_CHANNEL].packetCount--;
				receiveMBResponse(GPIB_LAN_CHANNEL);
				received = 1;
			}
		}
		verifyGPIBLANInput(MACADDR_CMD,MACaddress[0],MACaddress[1],MACaddress[2],MACaddress[3],MACaddress[4],MACaddress[5]);
//		 HVVoltage();
		initializeGPIBLAN();
//		HVVoltage();
		verifyGPIBLANInput(GPIBADDR_CMD,GPIBAddr,NULL,NULL,NULL,NULL,NULL);
		while (uartBuffer[GPIB_LAN_CHANNEL].packetCount != 0)
		{
			receiveMBResponse(GPIB_LAN_CHANNEL);
			uartBuffer[GPIB_LAN_CHANNEL].packetCount--;
			received = 1;
		}
//		HVVoltage();
		if (received == 1)
		{
			uartBuffer[GPIB_LAN_CHANNEL].packetCount = 0;
			sprintf((void *)(displayBuffer+19), "GPIB/LAN CARD OK          ");
			dispVFD48((void *)displayBuffer);
			delayMs(1000);
			memset((void *)&(uartBuffer[GPIB_LAN_CHANNEL] ) ,0,sizeof(UARTx_BUFFER));
			if (queryStepByStep(GPIB_LAN_CHANNEL, ERRQ_CMD,ERRR_CMD ,50) == SUCCESS) // check GPIB cnoonect status
				;	
			else // ѦA@
			{
				if (queryStepByStep(GPIB_LAN_CHANNEL, ERRQ_CMD,ERRR_CMD ,50) == SUCCESS) // check GPIB cnoonect status
					;
			}
			while (uartBuffer[GPIB_LAN_CHANNEL].packetCount != 0)
			{
				receiveMBResponse(GPIB_LAN_CHANNEL);
				uartBuffer[GPIB_LAN_CHANNEL].packetCount--;
			}
			optCard = 1; // responce with interrupt
		}
		else
		{
			sprintf((void *)(displayBuffer+19), "GPIB/LAN not exist           ");
			clearErorrQueue(); // clear GPIB error
		}
		dispVFD48((void *)displayBuffer);
		delayMs(1000);
		displayFresh = 1;
	}
//	HVVoltage();
}

uint8_t shutoffState = 0;
#define LOWLEVEL	0
#define HIGHLEVEL	1
uint8_t	controlState = LOCAL_CTRL;
float vADbuffer,iADbuffer;

uint16_t	xVindex,xIindex;
uint16_t	xVdata[SAMPLE_WEIGHT];
uint16_t	xIdata[SAMPLE_WEIGHT];

float tempvoltage,tempcurrent;
/* external Control A */
/*

(1)	ѥ~ޱ নVEST ,ISET C50 ms e@command to E7 measure(); case 6
		ɶ̤֥[WqTɶ̤65ms
(2)	LOC/ANA_CPU   (Loacl   Analog ) 
		controlState = ANALOG_CTRL VFD ~| EXT-V or EXT-R r _hOť

*/
void externalControlHandler(void)
{	
	static float vADCvSet = 0,iADCiSet = 0;
	
    if ((actualState == D_NORMAL || actualState == D_VSET || actualState == D_ISET || actualState == D_SHIFT || actualState == PROGRAMRUNNING 
	   || actualState == TIMERRUNNING || actualState == PROGRAMREADY || actualState == TIMEREDIT | actualState == D_OVP || actualState == D_OCP || actualState == D_OPP 
	   || actualState == MENUCONFPROTOVP || actualState == MENUCONFPROTOCP || actualState == MENUCONFPROTOPP) && (IS_SCPIEXTCAL_VOLT == 0 && IS_SCPIEXTCAL_CURR == 0) // O SCPI command U
	   
	  && (extEnable > OFF))	// active
	{
		static uint8_t shutoffCount = 0;
		static uint8_t locanaCount = 0;
		uint8_t error = 0;
		if(extVMode >= 1 || extIMode >= 1)
		{
	     	if (LOCANA_CPU_PIN == SET) 	//	LOC/ANA_CPU   (Loacl   Analog ) 
																		//	controlState = ANALOG_CTRL VFD ~| EXT-V or EXT-R r _hOť
			{	 // analog control
				locanaCount++;
				if (locanaCount >= L_COUNT)
					locanaCount = FULL_COUNT;
				if (locanaCount == FULL_COUNT)
				{
					LOCAL_ANALOG_STATE_HIGH;	// 25DB pin21 L/A STATE	5V output
					controlState = ANALOG_CTRL;
				}				
			}
			else   // local control
			{
				locanaCount--;
				if (locanaCount <= H_COUNT)
					locanaCount = NO_COUNT;
				if (locanaCount == NO_COUNT)
				{
					LOCAL_ANALOG_STATE_LOW; // 25DB pin21 L/A STATE	0V output
					controlState = LOCAL_CTRL;
				}
			}
		}
		else
		{	   // local	control
			LOCAL_ANALOG_STATE_LOW; // 25DB pin21 L/A STATE	0V output
			controlState = LOCAL_CTRL;
		}
		if (extEnable == BMODE)	 // pin 1 & pin14 will control on/off button
		{
	     	if ( ENABLE_CPU_PIN == SET && IS_SHOW_SO == 0) // pin 1 & pin14 short (output ON)
			{	 // analog control
				cpuEnablePinCount++;
				if (cpuEnablePinCount >= L_COUNT)
					cpuEnablePinCount = FULL_COUNT;
				if (cpuEnablePinCount == FULL_COUNT)
				{
					if (onoffStatus == OFF)
					{
						onoffStatus = ON;
						clearMeasureCommand();//Nbuffer Bzʥ] M
						if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
							displayFresh = 1;
						if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
							displayFresh = 1;
					}			
				}				
			}
			else   // output OFF
			{
				cpuEnablePinCount--;
				if (cpuEnablePinCount <= H_COUNT)
					cpuEnablePinCount = NO_COUNT;
				if (cpuEnablePinCount == NO_COUNT)
				{
					if (onoffStatus == ON)
					{
						onoffStatus = OFF;
						clearMeasureCommand();//Nbuffer Bzʥ] M
						if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
							displayFresh = 1;
						if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
							displayFresh = 1;
					}			
				}
			}
		} 
		if(controlState == ANALOG_CTRL && extVMode >= 1 ) // 1:EXT-V  2:EXTV-R
		{	
			// AUTO RANGE y{ P81
			float temp5;
			if (extVMode == 2)	// EXT-R
				VOL_RES_SEL_HIGH;
			else
				VOL_RES_SEL_LOW; 
			extfilterV();
			if (extProgRange == 0) // 5V/5K
				temp5 = 5;
			else				   // 10V/10K
				temp5 = 10;
			vADCvSet = (float)((vADbuffer * mADc_v + bADc_v)* extvMax/temp5); //  1000V/5V = 200
			if (extVMode == 2)// EXT-R  1.03mA
				vADCvSet /= voltagerescurr;
			if (master.vMax < 610)
				vADCvSet = round(vADCvSet , 0.5);	 // 0.5 @
			else
				vADCvSet = round(vADCvSet , 1.0);  // 1.0 @

			if (vADCvSet > master.limitVMax)
				vADCvSet = master.limitVMax;
			if (vADCvSet < master.limitVMin )
				vADCvSet = master.limitVMin;
 			if (IS_EXT_V_LOW)
			{
				if (vADCvSet < master.vSet)
					CLR_EXT_V_LOW;
				else
					goto next1;
			}
			master.vSet = vADCvSet;
			if (master.vSet * master.iSet > master.pMax)	  // EXT autorange adjust
			{
				master.iSet = master.pMax/master.vSet;
				master.iSet = round(master.iSet , 0.005);// 0.005 @
  			SET_EXT_I_LOW;
//ѥ~ޱ নVEST ,ISET C50 ms e@command to E7 measure(); case 6
//		ɶ̤֥[WqTɶ̤65ms				
			}
		}
		else
		{
			VOL_RES_SEL_LOW;
		}
next1:
		if(controlState == ANALOG_CTRL && extIMode >= 1) // 1:EXT-V  2:EXTV-R
		{
			float temp5;
			if (extIMode == 2)
				CURR_RES_SEL_HIGH;	// EXT-R
			else
				CURR_RES_SEL_LOW; 	// EXT-V
			extfilterI();
			if (extProgRange == 0) // 5V/5K
				temp5 = 5;  
			else				   // 10V/10K
				temp5 = 10;
			iADCiSet = (float)((iADbuffer *  mADc_i + bADc_i) * extiMax/temp5);
			if (extIMode == 2)// EXT-R  1.03mA
				iADCiSet /= currentrescurr;
			iADCiSet = round(iADCiSet , 0.005);// 0.005 @
			if (iADCiSet > master.limitIMax)
				iADCiSet = master.limitIMax;
			if (iADCiSet < master.limitIMin)
				iADCiSet = master.limitIMin;
 			if (IS_EXT_I_LOW)
			{
				if (iADCiSet < master.iSet)
					CLR_EXT_I_LOW;
				else
					goto next2;
			}
			master.iSet = iADCiSet;
			if (master.vSet * master.iSet > master.pMax)	  // EXT autorange adjust
			{
				master.vSet = master.pMax/master.iSet;
				if (master.vMax < 610)
					master.vSet = round(master.vSet , 0.5);	 // 0.5 @
				else
					master.vSet = round(master.vSet , 1.0);  // 1.0 @
  				SET_EXT_V_LOW;
//ѥ~ޱ নVEST ,ISET C50 ms e@command to E7 measure(); case 6
//		ɶ̤֥[WqTɶ̤65ms				
				
			}
		}
		else
		{
			CURR_RES_SEL_LOW;
		}
next2:
		if (extMonRange == 0) // 5V max DAC out
		{
			
			if (specif == V_1000)
			{
				tempvoltage = master.vOut/200;
				tempcurrent = master.iOut;
			}
			else
			{
				tempvoltage = master.vOut/120;
				tempcurrent = master.iOut/1.7;
				
			}
		}
		else				  // 10V max DAC out
		{
			if (specif == V_1000)
			{
				tempvoltage = master.vOut/100;
				tempcurrent = master.iOut/0.5;
			}
			else
			{
				tempvoltage = master.vOut/60;
				tempcurrent = master.iOut/0.85;
				
			}
		}
		dacControl(DAC_VOLTAGE,(uint16_t)(tempvoltage * mDAc_v + bDAc_v),ON);
		dacControl(DAC_CURRENT,(uint16_t)(tempcurrent * mDAc_i + bDAc_i),ON);

		if (extShutOffLogic == FALLING_EDGE)// off/Low Logic
		{
			if (SHUTOFF_CPU_PIN == SET) 
			{
				shutoffCount++;
				if (shutoffCount >= L_COUNT)
					shutoffCount = FULL_COUNT;
				if (shutoffCount == FULL_COUNT)
				{
					if (shutoffState != LOWLEVEL && IS_SHOW_SO == 0)	// ttĲoedge trigger
					{												
						if (onoffStatus == ON)
						{
						    shutoffCount = 0;
							shutoffState = LOWLEVEL;
							SET_SHOW_SO;
							onoffStatus = OFF;
						   	if (onoffStatus & BIT0)
							{ 
//						   		VFDsign = (VFDsign & ~sign_OFF) | sign_ONOFF; // ON
							}
							else 
							{
//				   	    		VFDsign = (VFDsign & ~sign_ONOFF) | sign_OFF; // OFF
								cursorPosition = 0;
								CLR_SETTING;
								CLR_NUMBER;
							}
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
							onoffStatus = OFF;
							if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
							{
								if (powerOnMode == 1) // LAST
									eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
							}
						}
						else
						{
							if ( shutoffState != LOWLEVEL && IS_SHOW_SO == 0)
								shutoffState = LOWLEVEL;
						}
					}				
				}
			}
			else
			{
				if ( shutoffState != HIGHLEVEL && IS_SHOW_SO == 0)
					shutoffState = HIGHLEVEL;
			}
		}
		else // high Logic
		{
    		if (SHUTOFF_CPU_PIN != SET)  // SHUTOFF_CPU
			{
				shutoffCount++;
				if (shutoffCount >= L_COUNT)
					shutoffCount = FULL_COUNT;
				if (shutoffCount == FULL_COUNT)
				{
					if (shutoffState != HIGHLEVEL && IS_SHOW_SO == 0)	//tĲo
					{
						if (onoffStatus == ON)
						{
						    shutoffCount = 0;
							shutoffState = HIGHLEVEL;
							SET_SHOW_SO;
							onoffStatus = OFF;
					   		if (onoffStatus & BIT0)
							{ 
//					   			VFDsign = (VFDsign & ~sign_OFF) | sign_ONOFF; // ON
							}
							else 
							{
//			   	    			VFDsign = (VFDsign & ~sign_ONOFF) | sign_OFF; // OFF
								cursorPosition = 0;
								CLR_SETTING;
								CLR_NUMBER;
							}
							verifyInput(OUTPUT_CMD,(float)onoffStatus );
							onoffStatus = OFF;
							if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
							{
								if (powerOnMode == 1) // LAST
									eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
							}
						}
						else
						{
							if ( shutoffState != HIGHLEVEL && IS_SHOW_SO == 0)
								shutoffState = HIGHLEVEL;
						}

					}
				}				
			}
			else
			{
				if ( shutoffState != LOWLEVEL && IS_SHOW_SO == 0)
					shutoffState = LOWLEVEL;
			}
		}		   
		if (extEnable == AMODE && ENABLE_CPU_PIN != SET && onoffStatus == ON)   // level trigger
		{
			SET_SHOW_ENA;
			onoffStatus = OFF;
		   	if (onoffStatus & BIT0)
			{ 
//		   		VFDsign = (VFDsign & ~sign_OFF) | sign_ONOFF; // ON
			}
			else 
			{
//	       		VFDsign = (VFDsign & ~sign_ONOFF) | sign_OFF; // OFF
				cursorPosition = 0;
				CLR_SETTING;
				CLR_NUMBER;
			}
			verifyInput(OUTPUT_CMD,(float)onoffStatus );
			onoffStatus = OFF;
			if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
			{
				if (powerOnMode == 1) // LAST
					eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
			}
		}
// POWER OK indecate
		if (outputStatus & OVP_STATE )
			error = 1;
		if (outputStatus & OCP_STATE )
			error = 1;
		if (outputStatus & OPP_STATE )
			error = 1;	
		if (IS_NTC_TOO_HIGH)
			error = 1;
		if (IS_PFC_VIN_TOO_LOW)
			error = 1;
		if (IS_PFC_VBUS_TOO_HIGH)
		    error = 1;
		if (IS_SHOW_SO)
			error = 1;
		if (IS_SHOW_ENA)
			error = 1;
		if (onoffStatus == OFF)
			error = 1;
		if (error == 1)
		    POWER_OK_HIGH; // something error P610 Pin16 Low
		else
			POWER_OK_LOW; // power on turn on  everything ok

		if (outputStatus & CV_STATE)
			CV_CC_STATE_LOW; // 25DB 
		else if(outputStatus & CC_STATE)
			CV_CC_STATE_HIGH;// 25DB 
		setTimerCount();
	    checkTimerCount(200);//C100 ms  ]w displayFresh = 1
	}
	else
	{
		if (IS_SCPIEXTCAL_VOLT == 0 && IS_SCPIEXTCAL_CURR == 0 && actualState != EXTCALVOLTAGE && actualState != EXTCALCURRENT && actualState != EXTCALRESVOLTAGE && actualState != EXTCALRESCURRENT)
		{
			CURR_RES_SEL_LOW;
			VOL_RES_SEL_LOW;
			POWER_OK_HIGH;	  			// 25DB pin16 POWEROK	0V output
			LOCAL_ANALOG_STATE_HIGH;  	// 25DB pin21 L/A STATE	0V output
			if (chainMode == ON)
			{ 
//				if (broadcastEcho == OFF)
//					RELEASE_RS485_BUS;
			}
			else	
				CV_CC_STATE_HIGH;	  		// 25DB pin13 CV/CC		0V output
			dacControl(DAC_VOLTAGE,0,ON);
			dacControl(DAC_CURRENT,0,ON);
		}
	}
}
 /*
// shift + 5  debug ѼƵ{
void debugError(void)
{
		switch(checkItem)
		{
			case 0:
				sprintf((void *)(displayBuffer),"CRC8ErrorCount     ");
				sprintf((void *)(displayBuffer+19),"%11d                  ",CRC8ErrorCount);
				break;
			case 1:
				sprintf((void *)(displayBuffer),"vRead Tx:%10d",vreadCount.count);
				sprintf((void *)(displayBuffer+19),"vRead Rx:VAD:%5d %10d",vOutADCount,vreadCount.rcount);  
				break;
			case 2:
				sprintf((void *)(displayBuffer),"iRead Tx:%10d",ireadCount.count);
				sprintf((void *)(displayBuffer+19),"iRead Rx:IAD:%5d %10d",iOutADCount,ireadCount.rcount);  
				break;	 
			case 3:
				sprintf((void *)(displayBuffer),"outSt Tx:%10d",ireadCount.count);
				sprintf((void *)(displayBuffer+19),"outSt Rx:          %10d",ireadCount.rcount);
				displayBuffer[19 + 9] = '0';
				displayBuffer[19 + 10] = 'x';
				displayBuffer[19 + 11] = (outputStatus >> 12) + 0x30;
				if (displayBuffer[19 + 11] > '9')
				{
					displayBuffer[19 + 11] = displayBuffer[19 + 11] - '9' + 0x40;
				}
				displayBuffer[19 + 12] = ((outputStatus & 0x0FFF) >> 8) + 0x30;
				if (displayBuffer[19 + 12] > '9')
				{
					displayBuffer[19 + 12] = displayBuffer[19 + 12] - '9' + 0x40;
				}
				displayBuffer[19 + 13] = ((outputStatus & 0x00FF) >> 4) + 0x30;
				if (displayBuffer[19 + 13] > '9')
				{
					displayBuffer[19 + 13] = displayBuffer[19 + 13] - '9' + 0x40;
				}
				displayBuffer[19 + 14] = ((outputStatus & 0x000F) ) + 0x30;
				if (displayBuffer[19 + 14] > '9')
				{
					displayBuffer[19 + 14] = displayBuffer[19 + 14] - '9' + 0x40;
				}
				break;
			case 4:
				sprintf((void *)(displayBuffer),"SRv   Tx:%10d",SRvSetCount.count);
				sprintf((void *)(displayBuffer+19),"SRv   Rx:%20d",SRvSetCount.rcount);
				break;	 
			case 5:
				sprintf((void *)(displayBuffer),"SRi   Tx:%10d",SRiSetCount.count);
				sprintf((void *)(displayBuffer+19),"SRi   Rx:%20d",SRiSetCount.rcount);
				break;
			case 6:
				sprintf((void *)(displayBuffer),"vSet  Tx:%10d",vSetCount.count);
				sprintf((void *)(displayBuffer+19),"vSet  Rx:%20d",vSetCount.rcount);
				break;	 
			case 7:
				sprintf((void *)(displayBuffer),"iSet  Tx:%10d",iSetCount.count);
				sprintf((void *)(displayBuffer+19),"iSet  Rx:%20d",iSetCount.rcount);
				break;
			case 8:
				sprintf((void *)(displayBuffer),"OVPST Tx:%10d",OVPSetCount.count);
				sprintf((void *)(displayBuffer+19),"OVPST Rx:%20d",OVPSetCount.rcount);
				break;	 
			case 9:
				sprintf((void *)(displayBuffer),"OCPST Tx:%10d",OCPSetCount.count);
				sprintf((void *)(displayBuffer+19),"OCPST Rx:%20d",OCPSetCount.rcount);
				break;
			case 10:
				sprintf((void *)(displayBuffer),"T:%7dU:%7d",totalCount,upCount);
				sprintf((void *)(displayBuffer+19),"D:%11d  N:%11d",downCount,noiseCount);
				break;
				
		}
		dispVFD48(DISPBUF);
		printVFDsign();
}		 */

/*
// debug Ѽƿ򥢪A
void missingParameter(void)
{
	switch(waitMBStatus)
	{
		case BIT0:
			waitMBStatus &= ~BIT0;
			break;
		case BIT1:
			waitMBStatus &= ~BIT1;
			break;
		case BIT14:
			waitMBStatus &= ~BIT14;



			break;
	}



}
  */
//  覡
void showExternalMessage(void)
{
	if ( extEnable > OFF)
	{
		if (controlState == ANALOG_CTRL && (extVMode != 0 || extIMode != 0))
		{
		    switch(extVMode)
			{
				case 0:	
					sprintf((void *)(displayBuffer + 19 ), "V:FRONT");
					break;
				case 1:
					sprintf((void *)(displayBuffer + 19 ), "V:EXT-V");
					break;
				case 2:
					sprintf((void *)(displayBuffer + 19 ), "V:EXT-R");
					break;
			}
		    switch(extIMode)
			{
				case 0:
					sprintf((void *)(displayBuffer + 19 + 8), "I:FRONT");
					break;
				case 1:
					sprintf((void *)(displayBuffer + 19 + 8), "I:EXT-V");
					break;
				case 2:
					sprintf((void *)(displayBuffer + 19 + 8), "I:EXT-R");
					break;
			}
		}
		if (IS_SHOW_SO)
		{
			memcpy((void *)(displayBuffer + 19 + 16), "SO ",3);
		}
		else
		{
			if (IS_SHOW_ENA )
			{
				memcpy((void *)(displayBuffer + 19 + 16), "ENA",3);
			}
			else
			{
				setVFDFlashOff(0x40, 48);
				memcpy((void *)(displayBuffer + 19 + 16), "   ",3);
			}
		}
	}
	else
	{
		if (parallelMode == ON)
		{
			if (parallelRole == MASTER)
			{
						switch(masterState)
						{
							case 1:
							case 2:
							case 3:
							case 4:
							case 5:
								  
							case 6:
							case 7:
							case 8:
							case 9:
							case 10:
							case 11:
							case 12:
							case 13:
							case 14:
							case 15:
							case 16:
							case 17:
							case 18:
							case 19:
							case 20:
							case 21:
							case 22:
							case 23:
							case 24:
							case 25:
//								 sprintf((void *)(displayBuffer+19+23), ".     ");
							case 26:
							case 27:
							case 28:
							case 29:
							case 30:
							case 31:
							case 32:
							case 33:
							case 34:
							case 35:
							case 36:
							case 37:
							case 38:
							case 39:
							case 40:
							case 41:
							case 42:
							case 43:
							case 44:
							case 45:
//								 sprintf((void *)(displayBuffer+19+23), "..    ");
							case 46:
							case 47:
							case 48:
							case 49:
							case 50:
							case 51:
							case 52:
							case 53:
							case 54:
							case 55:
							case 56:
							case 57:
							case 58:
							case 59:
							case 60:
							case 61:
							case 62:
							case 63:
							case 64:
							case 65:
//								 sprintf((void *)(displayBuffer+19+23), "...   ");
							case 66:
							case 67:
							case 68:
							case 69:
							case 70:
							case 71:
							case 72:
							case 73:
							case 74:
							case 75:
							case 76:
							case 77:
							case 78:
							case 79:
							case 80:
							case 81:
							case 82:
							case 83:
							case 84:
							case 85:
//								 sprintf((void *)(displayBuffer+19+23), "....  ");
							case 86:
							case 87:
							case 88:
							case 89:
							case 90:
							case 91:
							case 92:
							case 93:
							case 94:
							case 95:
//								sprintf((void *)(displayBuffer+19+23), "..... ");
							case 96:
							case 97:
							case 98:
							case 99:
							case 100:
							case 101:
							case 102:
								sprintf((void *)(displayBuffer), "PARALLEL MODE      ");
								sprintf((void *)(displayBuffer+19), "     CHECKING FOR SLAVE");
								if (masterState > 80)
								    strcat((void *)(displayBuffer+19+23), "....  ");
								else if (masterState > 60)
									strcat((void *)(displayBuffer+19+23), "...   ");
								else if(masterState > 40)
									strcat((void *)(displayBuffer+19+23), "..    ");
								else if(masterState > 20)
									strcat((void *)(displayBuffer+19+23), ".     ");
								else 
									strcat((void *)(displayBuffer+19+23), "      ");
								

								break;
							case SHOWFOUNDSLAVE:
								if ( sumSlaves() == 1)
									sprintf((void *)(displayBuffer+19), "FOUND %2d SLAVE DEVICE       ",sumSlaves());
								else
									sprintf((void *)(displayBuffer+19), "FOUND %2d SLAVE DEVICES      ",sumSlaves());
								break;
							case BROADCAST:
							case SETONOFF:
							case SETVSETI:
							case SYNC:
							case QUERYCURR:
								memset((void *)displayBuffer,' ',19);
								if (showMeter)
								{

									sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vOut);  
									sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint],round(/* showsumofiOut */  sumiOut(),around) );
									if (parallelDebug == ON)
									{
										sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vOut);  
										sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint],master.iOut);//sumiOut());
									}					
									sprintf((void *)(displayBuffer+19), "PARALLEL:MASTER    P=%7.1fW", master.vOut * /* showsumofiOut */  sumiOut());
								}
								else
								{
							    	sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vSet);
									sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiSet());
							    	sprintf((void *)(displayBuffer+19), "PARALLEL:MASTER    P=%7.1fW", master.vSet*sumiSet());
								}
								if (parallelDebug == ON)
									sprintf((void *)(displayBuffer+19), "Total I=%7.4fA   P=%7.1fW", sumiOut() ,master.vOut * /* showsumofiOut */  sumiOut() );
								if (pvsONOFF == ON)
								{
									sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint],sumiOut());
									sprintf((void *)(displayBuffer + 19 ), "MASTER   PV SIM    P=%7.1fW", master.vSet*sumiOut());
								}
								break;
						}			
			}
		} 
		else
		{
			if (pvsONOFF == ON)
			{
//				percent = percentage/100;
				sprintf((void *)(displayBuffer + 19 ), "PV SIM          ");
				if(curve == PVS_CURVE_USER)
					memcpy((void *)(displayBuffer + 19 + 10),"TAB",3);
			}
			else
			{
				if (actualState != D_SHIFT)
					memset((void *)(displayBuffer + 19 + 16), ' ',3);
			}
		}
	}
}

// VFD 
// displayFresh = 1ܤ@
void display(void)
{
// display to VFD
//	if (IS_DEBUG)
//		debugError();
//	else
//	{	
		uint8_t i;			   
		if (displayFresh && (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE))
		{
			displayFresh = 0;
			if (!(outputStatus & ON_STATE))
				clearFilterData();
			if (errorIndex != 0)
			{
				
				cursorPositionTemp = cursorPosition;
				cursorPosition = 0;
				setVFDFlashOff(0x40, 48);
				memcpy((void *)(displayBufferTemp),(void *)(displayBuffer + 19),29); // backup 
				softTimer[ERROR_MESSAGE_COUNT].count = softTimer[MAIN_COUNT].count;
				softTimer[ERROR_MESSAGE_COUNT].flag = ENABLE;
				dpFlag = 0;				
				switch(popError())
				{
					case OVER_RANGE:	//1
//						if (IS_LIMIT_COMPARE )
//							memcpy((void *)(displayBuffer + 19),"    INPUT LIMIT RANGE!       ",29);
//						else
							memcpy((void *)(displayBuffer + 19),"     INPUT OVER RANGE!       ",29);
						break;
					case LIMIT_RANGE:
						memcpy((void *)(displayBuffer + 19),"    INPUT LIMIT RANGE!       ",29);
						break;
					case AD_OVER:
						memcpy((void *)(displayBuffer + 19),"      AD VALUE ERROR !       ",29);
						break;
					case SLAVE_TIME_OUT:
						memcpy((void *)(displayBuffer + 19),"      SLAVE TIME OUT !       ",29);
						break;
					case MEASURE_VERIFY_ERROR:
						if (E7Board == 1)
							memcpy((void *)(displayBuffer + 19),"PWR communication ERROR !    ",29);
						break;
					case PV_SIM_DATA_ERROR:
							memcpy((void *)(displayBuffer + 19),"PV SIM DATA(ZERO) ERROR !    ",29);
						break;
					case GPIB_VERIFY_ERROR:
					    if (optCard == 1)
							memcpy((void *)(displayBuffer + 19),"GPIB/LANcommunication ERROR !",29);
						break;
					case SLAVEA_ERROR:
						memcpy((void *)(displayBuffer + 19),"       SLAVE 1 ERROR         ",29);
						break;
					case SLAVEB_ERROR:
						memcpy((void *)(displayBuffer + 19),"       SLAVE 2 ERROR         ",29);
						break;
					case SLAVEC_ERROR:
						memcpy((void *)(displayBuffer + 19),"       SLAVE 3 ERROR         ",29);
						break;
					case SLAVE_ERROR:
						for (i = 0; i < MAX_CHAINADDR  && rs485Id[i].disconnect == 0;i++)
							;
						if (i < MAX_CHAINADDR)
						{
							memcpy((void *)(displayBuffer + 19)," ADD    SLAVE ERROR          ",29);
							sprintf((void *)(displayBuffer + 19 + 5) ,"%d" , i );
						}
						break;
					case SLAVE_HW_ERROR:
						memcpy((void *)(displayBuffer + 19),"SLAVE HW ERROR Current Source",29);
						break;
					case IMP_OVER_RANGE:
						memcpy((void *)(displayBuffer + 19),"       Imp TOO HIGH!         ",29);
						break;
					default:
						clearErorrQueue();
						break;
				}
			}
			else if(IS_MB_ERROR)
			{
					setTimerCount();
				    checkTimerCount(100);//C100 ms  ]w displayFresh = 1
					if (IS_BACKUP_SCREEN == 0) // s`e
					{
						SET_BACKUP_SCREEN;	   // sL
						cursorPositionTemp = cursorPosition;
						cursorPosition = 0;
						setVFDFlashOff(0x40, 48);
					   	memcpy((void *)(displayBufferTemp),(void *)(displayBuffer + 19),29); // backup 
					}
					if ((actualState == D_NORMAL || actualState == PROGRAMRUNNING || actualState == PROGRAMREADY || actualState == D_SHIFT
					     || actualState == D_ISET || actualState == D_VSET || actualState ==  TIMERRUNNING))
					{
						memset((void *)displayBuffer,' ',19);
						if (showMeter)
						{
							sprintf((void *)(displayBuffer+1),  (void *)voltDispUnit[voltPoint], master.vOut);
							if (parallelMode == ON && parallelRole == MASTER)
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiOut() );
							else
								sprintf((void *)(displayBuffer+10),(void *)currDispUnit[currPoint], master.iOut);
						}
						else
						{
			 				sprintf((void *)(displayBuffer+1),  (void *)voltDispUnit[voltPoint], master.vSet);
							sprintf((void *)(displayBuffer+10),(void *)currDispUnit[currPoint], master.iSet);
					    }
					}
					if (IS_EXCPOWER)							 // 0:OK   1:FAIL
						memcpy((void *)(displayBuffer + 19),"        EXCEED POWER!        ",29);
					if (IS_PFC_VBUS_NO_CHARGE)    			 	// 0:OK   1:FAIL
						memcpy((void *)(displayBuffer + 19),"       VBUS NO CHARGE!       ",29);
					if (IS_PFC_VIN_TOO_LOW)	    			 	// 0:OK   1:FAIL
 						memcpy((void *)(displayBuffer + 19),"        VAC TOO LOW!         ",29);
					if (IS_PFC_VBUS_TOO_HIGH)    			 	// 0:OK   1:FAIL
						memcpy((void *)(displayBuffer + 19),"        VAC TOO HIGH!        ",29);
					if (IS_PFC_MEMORY_FAIL)	    			 	// 0:OK   1:FAIL
						memcpy((void *)(displayBuffer + 19),"     MEMORY CHECK ERROR!     ",29);
					if (IS_NTC_TOO_HIGH)	   				 // 0:OK   1:FAIL
					{
						if ((softTimer[MAIN_COUNT].count - softTimer[OTW_NTC_STATUS_COUNT].count) > 200 )
						{
							softTimer[OTW_NTC_STATUS_COUNT].count = softTimer[MAIN_COUNT].count;
							sendMBQuery(MEASURE_CHANNEL,OTWNTCQ_CMD);
							displayFresh = 1;
						}
						memcpy((void *)(displayBuffer + 19),"   OTP                       ",29);
						if (NTCStatus & BIT8)
							memcpy((void *)(displayBuffer + 19+7),"ADTC1",5);
						if (NTCStatus & BIT9)
							memcpy((void *)(displayBuffer + 19+7+6),"ADTC2",5);
						if (NTCStatus & BIT10)
							memcpy((void *)(displayBuffer + 19+7+6+6),"ADCT",4);
						if (NTCStatus & BIT11)
							memcpy((void *)(displayBuffer + 19+7+6+6+5),"PFC",3);
					}
					if (IS_FAN_ERROR)		    				 // 0:OK   1:FAIL
						memcpy((void *)(displayBuffer + 19),"         FAN ERROR!          ",29);
					if (IS_EXCOVP_ERROR)		    			 // 0:OK   1:FAIL
						memcpy((void *)(displayBuffer + 19),"         EXCEED OVP!         ",29);
					if (IS_EXCOCP_ERROR)		    			 // 0:OK   1:FAIL	
						memcpy((void *)(displayBuffer + 19),"         EXCEED OCP!         ",29);
					if (IS_CAL_ERROR)		    				 // 0:OK   1:FAIL
						memcpy((void *)(displayBuffer + 19),"     CALIBRATION ERROR!      ",29);
					if (IS_AC_FREQ_ERROR)
						memcpy((void *)(displayBuffer + 19),"    AC FREQUENCY ERROR!      ",29);
					if (IS_PFC_ERROR)
					    memcpy((void *)(displayBuffer + 19),"         PFC ERROR!          ",29);   // PFC Lost
					if (IS_POWER_OFF)
					    memcpy((void *)(displayBuffer + 19),"          POWER OFF          ",29);   // PFC Lost
					dpFlag = 0;
			}
			else if (IS_PARALLELMODE_SLAVE_ERROR_CONNECT)
			{	
				for (i = 0; i < MAX_CHAINADDR  && rs485Id[i].disconnect == 0;i++)
					;
				if (i < MAX_CHAINADDR)
				{
					memcpy((void *)(displayBuffer + 19)," SLAVE    ERROR CONNECT     ",29);
					sprintf((void *)(displayBuffer + 19 + 7) ,"%d" , i );
				}
				else
					CLR_PARALLELMODE_SLAVE_ERROR_CONNECT;
			}
			else
			{
				switch(actualState)
				{
					case D_PARALLELSLAVE:
						switch(slaveState)
						{
							case 0:
							case 1:
							case 2:
							case 3:
								sprintf((void *)(displayBuffer), "PARALLEL MODE      ");
								sprintf((void *)(displayBuffer+19), "     WAITING FOR MASTER      ");
								break;
							case 4:
								memset((void *)displayBuffer,' ',19);
								if (parallelDebug == ON)
								{
									if (onoffStatus)
									{
										sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vOut);
										sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], master.iOut);
									}
									else
									{
										sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vSet);
										sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], master.iSet);
									}
								}
								else
									sprintf((void *)(displayBuffer), "PARALLEL MODE      ");
								sprintf((void *)(displayBuffer+19), "SLAVE            ERR:NONE    ");
								if (pvsONOFF == ON)
									sprintf((void *)(displayBuffer+19), "SLAVE    PV SIM");
								sprintf((void *)(displayBuffer + 25),"%d",parallelRole);
								if (VFDsign & sign_ERROR)
									slaveErrorState = CRASH_ERROR;
								else
									slaveErrorState = NONE;
								switch(slaveErrorState)
								{
//									case CC_CV_ERROR:
//										strcpy((void *)(displayBuffer + 19 + 21),"CC-CV   ");
//										break;
//									case CV_CC_ERROR:
//										strcpy((void *)(displayBuffer + 19 + 21),"CV-CC   ");
//										break;
									case CRASH_ERROR:
										strcpy((void *)(displayBuffer + 19 + 21),"ERROR   ");
										break;
								}
								break;
						}
						break;
					case D_SHIFT:
						if (showMeter)
						{
							memset((void *)displayBuffer,' ',19);
			 				sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vOut);
							sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiOut());
							sprintf((void *)(displayBuffer + 19 + 19), "P=%7.1fW", master.vOut*sumiOut());
						}
						if ((int32_t)runningTimer > 0)
						    sprintf((void *)(displayBuffer + 19),"TIMER:%.3d:%.2d:%.2d",runningTimer/(60*60),(runningTimer/60)%60,runningTimer%60 );
						showExternalMessage();
						break;
					case D_NORMAL:	 
						memset((void *)displayBuffer,' ',19);	
						if (showMeter)
						{
							sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vOut);
							sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiOut());
							sprintf((void *)(displayBuffer+19),"                   P=%7.1fW", master.vOut*sumiOut());
						}
						else
						{
							sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vSet);
							sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiSet());
					    	sprintf((void *)(displayBuffer+19),"                   P=%7.1fW", master.vSet* sumiSet());
							
						}
						showExternalMessage();
						if (timerONOFF > OFF && masterState != SHOWFOUNDSLAVE)
							sprintf((void *)(displayBuffer + 19),"TIMER:%.3d:%.2d:%.2d",timerHR,timerMN,timerSE );
				        break;
					case D_ISET:
					case D_VSET:
						memset((void *)(displayBuffer),' ',19);
						if (showMeter)
						{
			 				sprintf((void *)(displayBuffer+0x01), (void *)voltDispUnit[voltPoint], master.vOut);
							if (parallelMode == ON && parallelRole == MASTER)
							{
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiOut());
								sprintf((void *)(displayBuffer+19+15),"    P=%7.1fW", master.vOut*sumiOut());
							}
							else
							{
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], master.iOut);
								sprintf((void *)(displayBuffer+19+15),"    P=%7.1fW", master.vOut*master.iOut);
							}
						}
						else
						{
					    	sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vSet);
							sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint],  sumiSet());
					    	sprintf((void *)(displayBuffer+19+15), "    P=%7.1fW", master.vSet* sumiSet());	
						}
						break;
					case PROGRAMRUNNING:
					case PROGRAMREADY:
						memset((void *)(displayBuffer),' ',19);
						if (showMeter)
						{
			 				sprintf((void *)(displayBuffer+0x01), (void *)voltDispUnit[voltPoint], master.vOut);
							if (parallelMode == ON && parallelRole == MASTER)
							{
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiOut());
								sprintf((void *)(displayBuffer+19+19),"P=%7.1fW", master.vOut*sumiOut());
							}
							else
							{
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], master.iOut);
								sprintf((void *)(displayBuffer+19+19),"P=%7.1fW", master.vOut*master.iOut);
							}
						}
						else
						{
					    	sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vSet);
							sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint],  sumiSet());
					    	sprintf((void *)(displayBuffer+19+19), "P=%7.1fW", master.vSet* sumiSet());	
						}
						break;
					case D_OVP:
					case D_OPP:
					case D_OCP:	
					case MENUCONFPROTOVP:
					case MENUCONFPROTOCP:
					case MENUCONFPROTOPP:
						if (IS_FROM_MENU)
							sprintf((void *)(displayBuffer + 19 + 15), "              ");
						else
						{
							memset((void *)displayBuffer,' ',19);
							if (showMeter)
							{
			 					sprintf((void *)(displayBuffer+0x01), (void *)voltDispUnit[voltPoint], master.vOut);
								if (parallelMode == ON && parallelRole == MASTER)
								{
									sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiOut() );
									sprintf((void *)(displayBuffer+19+15),"     P=%7.1fW", master.vOut*sumiOut());
								}
								else
								{
									sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], master.iOut);
									sprintf((void *)(displayBuffer+19+15), "    P=%7.1fW", master.vOut*master.iOut);
								}
							}
							else
							{
					    		sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vSet);
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint],  sumiSet());
					    		sprintf((void *)(displayBuffer+19+15), "    P=%7.1fW", master.vSet* sumiSet());
							}
						}
						break;
					case TIMERRUNNING:
						memset((void *)displayBuffer,' ',19);
					    if (showMeter)
						{
			 				sprintf((void *)(displayBuffer+1), (void *)voltDispUnit[voltPoint], master.vOut);
							if (parallelMode == ON && parallelRole == MASTER)
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], sumiOut() );
							else
								sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint], master.iOut);
						}
						else
						{
					    	sprintf((void *)(displayBuffer+1),(void *)voltDispUnit[voltPoint], master.vSet);
							sprintf((void *)(displayBuffer+0x0A), (void *)currDispUnit[currPoint],  sumiSet());
						}
						if (runningTimer == 0)
						{
							sprintf((void *)(displayBuffer + 19),"TIMER:%.3d:%.2d:%.2d",runningTimer/(60*60),(runningTimer/60)%60,runningTimer%60 );
			    			onoffStatus &= ~(BIT0); // OFF
							if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
							{
								if (powerOnMode == 1) // LAST
									eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
							}
						}
						else if((int32_t)runningTimer == -1)
						{
							sprintf((void *)(displayBuffer + 19),"TIMER:%.3d:%.2d:%.2d",timerHR,timerMN,timerSE );
							actualState = D_NORMAL;
						}
						else
				            sprintf((void *)(displayBuffer + 19),"TIMER:%.3d:%.2d:%.2d",runningTimer/(60*60),(runningTimer/60)%60,runningTimer%60 );
						sprintf((void *)(displayBuffer+19+15), "    P=%7.1fW", master.vSet*master.iSet);
						break;
					case CALVOLTAGE:
					    if (calState < 5 )
						{
							if (presentPoint == 1)
							{
								if (voltPoint == 1)
								{
									if (vMeter > 100)
										sprintf((void *)(displayBuffer + 19 ) ,"METER:  %5.1fV AD:%.5d P:%d/%d",vMeter,vAdc,presentPoint,calPV); // 1.32
									else	
										sprintf((void *)(displayBuffer + 19 ) ,"METER:  %5.2fV AD:%.5d P:%d/%d",vMeter,vAdc,presentPoint,calPV); // 1.30
								}
								else if(voltPoint == 2) // 600V
								{
									if (vMeter > 100)
										sprintf((void *)(displayBuffer + 19 ) ,"METER: %5.1fV AD:%.5d P:%d/%d",vMeter,vAdc,presentPoint,calPV); // 1.32
									else	
										sprintf((void *)(displayBuffer + 19 ) ,"METER: %5.2fV AD:%.5d P:%d/%d",vMeter,vAdc,presentPoint,calPV); // 1.30
								}
							}
							else
							{
								if (voltPoint == 1)
								{
									if (vMeter > 1000)
										sprintf((void *)(displayBuffer + 19 ) ,"METER: %6.1fV AD:%.5d P:%d/%d",vMeter,vAdc,presentPoint,calPV);	 // 1.30
									else	
										sprintf((void *)(displayBuffer + 19 ) ,"METER: %6.2fV AD:%.5d P:%d/%d",vMeter,vAdc,presentPoint,calPV);	 // 1.30
								}
								else if(voltPoint == 2)
									sprintf((void *)(displayBuffer + 19 ) ,"METER:%6.2fV AD:%.5d P:%d/%d",vMeter,vAdc,presentPoint,calPV);	 // 1.30
							}
							memcpy((void *)(displayBuffer + numericalInput.startAddress - 0x40),KEYINBUF,numericalInput.length);
   			            }
					    break;
					case CALCURRENT:
					    if (calState < 5 )
						{
							sprintf((void *)(displayBuffer + 19 ) ,"METER:%7.4fA AD:%.5d P:%d/%d",iMeter,iAdc,presentPoint,calPI);
							memcpy((void *)(displayBuffer + 19 +	6),KEYINBUF,7);
						}
					    break;
				}// end of switch	
				if (OVPOccurred == 1)
					sprintf((void *)(displayBuffer+19),"   OV Protect!    ");
				else if (OCPOccurred == 1)
					sprintf((void *)(displayBuffer+19),"   OC Protect!    ");
				else if (OPPOccurred == 1)
					sprintf((void *)(displayBuffer+19),"   OP Protect!    ");
				else if (VCPOccurred == 1)
					sprintf((void *)(displayBuffer+19),"  CV-CC protect!  ");
				else if (CVPOccurred	== 1)
					sprintf((void *)(displayBuffer+19),"  CC-CV protect!  ");
				
				if (IS_MODEL_CONFLICT)
					sprintf((void *)(displayBuffer+19),"      MODEL CONFLICT!        ");
			
			}
			if (actualState == SELFTEST2)
			{
				uint32_t sign;
				sign = VFDsign;
  				VFD_SPI_CS_LOW;  					// SPI_CS = 0
				sVFD_SendByte(0x85);
				sVFD_SendByte((uint8_t)(sign >> 24));
				sVFD_SendByte((uint8_t)(sign >> 16));
				sVFD_SendByte((uint8_t)(sign >> 8));
				sVFD_SendByte((uint8_t)(sign));
    			VFD_SPI_CS_HIGH;    				// SPI_CS = 1			
			}						 
			else
				printVFDsign();
			if (softTimer[SHOW_VERSION_COUNT].flag == DISABLE)
			{
				if ((outputStatus & OTW_STATE) && !(IS_NTC_TOO_HIGH))
				{
					if (softTimer[OTW_NTC_STATUS_COUNT].flag == DISABLE)
					{
						softTimer[OTW_NTC_STATUS_COUNT].count = softTimer[MAIN_COUNT].count;
						softTimer[OTW_NTC_STATUS_COUNT].flag = ENABLE;
						memcpy((void *)otwdisplayBuffer ,(void *)displayBuffer,19);
						sprintf((void *)(otwdisplayBuffer+19),"   OTW                       ");
						sendMBQuery(MEASURE_CHANNEL,OTWNTCQ_CMD);
					}
					else
					{
						if (softTimer[TEMP_BEEP_COUNT].flag == ENABLE)
						{
							if (softTimer[MAIN_COUNT].count - softTimer[TEMP_BEEP_COUNT].count > 1000)	// OTW beep 1 `
							{
								softTimer[TEMP_BEEP_COUNT].count = softTimer[MAIN_COUNT].count;
								beep(2);
							}
						}
						memcpy((void *)otwdisplayBuffer ,(void *)displayBuffer,19);
						if ( softTimer[MAIN_COUNT].count - softTimer[OTW_NTC_STATUS_COUNT].count > 1000)
						{
							softTimer[OTW_NTC_STATUS_COUNT].count = softTimer[MAIN_COUNT].count;
							sendMBQuery(MEASURE_CHANNEL,OTWNTCQ_CMD);
						}
						else if ((softTimer[MAIN_COUNT].count - softTimer[OTW_NTC_STATUS_COUNT].count) % 200 == 0)
						{
							sendMBQuery(MEASURE_CHANNEL,OTWNTCQ_CMD);
						} 
						memcpy((void *)(otwdisplayBuffer + 19),"   OTW                       ",29);
						if (NTCStatus & BIT0)
							memcpy((void *)(otwdisplayBuffer + 19+7),"ADTC1",5);
						if (NTCStatus & BIT1)
							memcpy((void *)(otwdisplayBuffer + 19+7+6),"ADTC2",5);
						if (NTCStatus & BIT2)
							memcpy((void *)(otwdisplayBuffer + 19+7+6+6),"ADCT",4);
						if (NTCStatus & BIT3)
							memcpy((void *)(otwdisplayBuffer + 19+7+6+6+5),"PFC",3);
					}
					dispVFD48((void *)otwdisplayBuffer);
				}
				else
				{
					softTimer[OTW_NTC_STATUS_COUNT].flag = DISABLE;
					dispVFD48(DISPBUF);
					if (bkpos != 0 && bklen != 0)
						setVFDFlashOn(bkpos ,bklen);
				}
			}
			showCursor();
		}
		showVer(7000);
//	}
}

void programmingE7E1(void)
{
	uint8_t count = 0;
	while(actualState == STARTDLE7 || actualState == STARTDLE1 || actualState == STARTDLEG)
	{
		setTimerCount();
	    checkTimerCount(500);//C500 ms  ]w displayFresh = 1
		if (displayFresh == 1)
		{
		 	displayFresh = 0;
			sprintf((void *)(displayBuffer  ) ," Programming Mode ");
			if (actualState == STARTDLE7)
				sprintf((void *)(displayBuffer + 19 ) ,"     PWR Module Download     ");
			else if(actualState == STARTDLE1)
				sprintf((void *)(displayBuffer + 19 ) ,"     PFC Module Download     ");
			else if(actualState == STARTDLEG)
				sprintf((void *)(displayBuffer + 19 ) ,"GPIB/LAN Module Download     ");
			switch(count%4)
			{
				case  0:
					memcpy((void *)(displayBuffer + 19 + 25) ,"   ",3);
					break;
				case  1:
					memcpy((void *)(displayBuffer + 19 + 25) ,".  ",3);
					break;
				case  2:
					memcpy((void *)(displayBuffer + 19 + 25) ,".. ",3);
					break;
				case  3:
					memcpy((void *)(displayBuffer + 19 + 25) ,"...",3);
					break;
			}
			count++;
			dispVFD48(DISPBUF);
			VFD_SPI_CS_LOW;  					// SPI_CS = 0
			sVFD_SendByte(0x85);
			sVFD_SendByte((uint8_t)(0));
			sVFD_SendByte((uint8_t)(0));
			sVFD_SendByte((uint8_t)(0));
			sVFD_SendByte((uint8_t)(0));
    		VFD_SPI_CS_HIGH;    				// SPI_CS = 1		
		}
		if (IS_USB_RESTART)
		{
			softTimer[USB_RESTART_COUNT].count = softTimer[MAIN_COUNT].count;
			softTimer[USB_RESTART_COUNT].flag = ENABLE;
			CLR_USB_RESTART;
		}
		if (softTimer[USB_RESTART_COUNT].flag == ENABLE)
		{
			if (softTimer[MAIN_COUNT].count - softTimer[USB_RESTART_COUNT].count > 500)
				NVIC_SystemReset(); // software reset  UN񧹦 }
		}
#ifdef 	I_WATCH_DOG
/* Reload IWDG counter */
    	IWDG_ReloadCounter();  
#endif
	}
}

void selftestDisplay(void)
{

	if (actualState == TESTEXTVOLT)
	{
		VOL_RES_SEL_LOW;
		extfilterV();
		if (softTimer[MAIN_COUNT].count - softTimer[TEMP_COUNT].count > (500 )) // 300 ms
		{
			softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ;
			sprintf((void *)(displayBuffer + 19 + 14) ,"AD:%.4d  P:%d/%d",(uint16_t)vADbuffer ,presentPoint,extCalTotalPoint);
			displayFresh = 1;
		}			
	}
	else if(actualState == TESTEXTCURR)
	{
		CURR_RES_SEL_LOW;
		extfilterI();
		if (softTimer[MAIN_COUNT].count - softTimer[TEMP_COUNT].count > (500 )) // 300 ms
		{
			softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ;
			sprintf((void *)(displayBuffer + 19 + 14) ,"AD:%.4d  P:%d/%d",(uint16_t)iADbuffer ,presentPoint,extCalTotalPoint);
			displayFresh = 1;
		}			

	}
	if (displayFresh == 1)
	{
		displayFresh = 0;
		dispVFD48(DISPBUF);
		showCursor();
	}
}



void showTempValue(uint8_t addr)
{
    uint8_t i;
	for (i = 0 ; i < numericalInput.length ; i++)
	    displayBuffer[(addr - 0x40) + i] = keyInBuffer[i];
}

void shiftBufferLeft(uint8_t val ,uint8_t len)
{
	uint8_t tempi;
	if (len == 1)
	{
		keyInBuffer[0] = val;
	}
	else
	{
		if (keyInBuffer[0] == ' ' || keyInBuffer[0] == '0')
		{
			for (tempi = 0; tempi < (len - 1); tempi++)
			{	
				keyInBuffer[tempi] = keyInBuffer[tempi+1];
			}
			keyInBuffer[tempi] = val;
		}
	}
	keyInBuffer[len] = 0; // string type
}

void shiftBufferRight(uint8_t val ,uint8_t len)
{
	uint8_t tempi;
	
	for (tempi = len; tempi > 0; tempi--)
	{
		keyInBuffer[tempi] = keyInBuffer[tempi-1];
	}
	keyInBuffer[tempi] = val;
	keyInBuffer[len] = 0;//  String type
}

void clearFilterData(void)
{
	uint8_t i,j;
	for (j = 0; j < SLAVEMAXNUM ;j++)
	{
		slaveDUT[j]->iOut = 0;
		slaveDUT[j]->deltaVSet = 0;
		slaveDUT[j]->dynamiciOutTarget = 0;
		slaveDUT[j]->iOutIndex = 0;
		for (i = 0 ; i < (PARALLEL_SAMPLE_WEIGHT) ; i++)
			slaveDUT[j]->iOutData[i] = 0;
	}
	showsumofiOut = sumofiOut = 0;

}

void sendRS232SettingFloat(uint8_t cmd,float value)	  //q
{
	unionbyte.ftob= value;
	uartBuffer[RS232_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[RS232_CHANNEL].simplePacket.length = 2 + sizeof(float) ;
	uartBuffer[RS232_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[RS232_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[3];	// MSB first
	uartBuffer[RS232_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[2];
	uartBuffer[RS232_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[1];	
	uartBuffer[RS232_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[0];
	uartBuffer[RS232_CHANNEL].simplePacket.payload[uartBuffer[RS232_CHANNEL].simplePacket.length - 1] = calculateCrc8(&uartBuffer[RS232_CHANNEL].simplePacket.head, uartBuffer[RS232_CHANNEL].simplePacket.length + 1);
	uartTransmit(RS232_CHANNEL, &uartBuffer[RS232_CHANNEL].simplePacket.head, uartBuffer[RS232_CHANNEL].simplePacket.length + 2);
}


void sendRS232Settingint8(uint8_t cmd,uint8_t value)  //q
{
	unionbyte.ftob= value;
	uartBuffer[RS232_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[RS232_CHANNEL].simplePacket.length = 2 + sizeof(uint8_t) ;
	uartBuffer[RS232_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[RS232_CHANNEL].simplePacket.payload[1] = value;	
	uartBuffer[RS232_CHANNEL].simplePacket.payload[uartBuffer[RS232_CHANNEL].simplePacket.length - 1] = calculateCrc8(&uartBuffer[RS232_CHANNEL].simplePacket.head, uartBuffer[RS232_CHANNEL].simplePacket.length + 1);
	uartTransmit(RS232_CHANNEL, &uartBuffer[RS232_CHANNEL].simplePacket.head, uartBuffer[RS232_CHANNEL].simplePacket.length + 2);
}



// POqT @骺qT 
ErrorStatus verifyInput(uint8_t cmd,float temp )
{
	ErrorStatus result = SUCCESS;
	float backup;
	uint8_t backup1,i,j;
	float minvSet;
	uint8_t flag = 0;
	uint32_t time  = softTimer[MAIN_COUNT].count;
	if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}
	unionbyte.ftob = -1;
	switch(cmd)
	{
		case VSET_CMD:
			backup = master.vSet;
			temp = roundDigit(temp ,voltPoint);
			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
			{
				// RS485 s			hW u VSET,ISET,VSRSET,ISRSET ,ONOFFSTATUS nSLAVE ,L p OVP,OCPw masterD ǵSLAVE 
				master.vSet = temp;
				masterState = BROADCAST;
				masterParallelSetCmdFloat(master.vSet,CMD_SETV);
				SET_VSET_CMD_AGAIN;
				sendRS232SettingFloat(VSET_CMD,master.vSet); //q
			}
			else
			{
 				do
				{
					if (softTimer[MAIN_COUNT].count - time < 100 )
					{
						iTemp = convertFloatToInt(temp, master.vMax, fullScale);
						sendMBIntSetting(VSET_CMD, iTemp);
						
						sendMBQuery(MEASURE_CHANNEL,VSETQ_CMD);
						
//						verifyQueue.item[verifyQueue.head].cmd = VSETQ_CMD;
//						verifyQueue.item[verifyQueue.head].queryCounter = 1;
//						verifyQueue.item[verifyQueue.head].timer = softTimer[MAIN_COUNT].count;
//						verifyQueue.item[verifyQueue.head++].value = temp;
						master.vSet = temp; //  This assumption is to replace the following annotation, 
						                    // in order to allow faster orders GPIB
//			    	delayMs(10);
//						master.vSet = -1;
//						if (queryStepByStep(MEASURE_CHANNEL,VSETQ_CMD,VSETR_CMD ,20) == SUCCESS) // varify
//						{	
//							if (iTemp == (uint16_t)unionbyte.itob[0]) // compare with count equal
//							{
//								master.vSet = temp;
//							    break;
//							}
//						}
					}
					else
					{
						master.vSet = backup;
						pushError(MEASURE_VERIFY_ERROR);
						displayFresh = 1;
						waitMBStatus |= BIT31;
						result = ERROR;
						break;
					}
				}while (temp != master.vSet);
			}
			if (result == SUCCESS)
			{
				minvSet = master.vSet;
				temp = sumiSet();
				temp = roundDigit(temp ,currPoint);
				for (i = 0 ; i <= SLAVEMAXNUM ;i++)
				{
					if (slaveDUT[i]->exist == 1)
					{
						if (slaveDUT[i]->vMax < minvSet)
						{
							minvSet = slaveDUT[i]->vMax; 
							for (j = 0 ; j <= SLAVEMAXNUM  ;j++)
								slaveDUT[j]->vSet = minvSet;
							masterState = BROADCAST;
							masterParallelSetCmdFloat(master.vSet,CMD_SETV); // MIN(vMax) KiJ̤jq
						}
						if (slaveDUT[i]->iSet * slaveDUT[i]->vSet > slaveDUT[i]->pMax)
						{
							flag = 1;
							slaveDUT[i]->ratioiMax = slaveDUT[i]->pMax/slaveDUT[i]->vSet;
							if (slaveDUT[i]->ratioiMax > slaveDUT[i]->iMax)	 // 3KW machine
							{
								slaveDUT[i]->ratioiMax = slaveDUT[i]->iMax;
							}
						}
					}
				}
				if (flag == 1)
				{
					uint32_t tempvalue4;
					if (extVMode == 0 ) // FRONT
						SET_EXT_I_LOW;
					if (temp > sumRatioiMax())
						temp = sumRatioiMax();
					temp = round(temp,around);
					for (i = 0; i <= SLAVEMAXNUM ;i++)
						slaveDUT[i]->iSet = temp * slaveDUT[i]->ratioiMax/sumRatioiMax();
					// 600V |I iSetLվ
					for (i = 1; i <=SLAVEMAXNUM ;i++)
					{
						tempvalue4 = slaveDUT[i]->iSet/0.001;
						slaveDUT[i]->iSet = tempvalue4 * 0.001;
					} 
					for (i = 1 , slaveDUT[0]->iSet = temp; i <= SLAVEMAXNUM ;i++)
					    slaveDUT[0]->iSet -= slaveDUT[i]->iSet;
					sendMBIntSetting(ISET_CMD, convertFloatToInt(slaveDUT[0]->iSet, master.iMax, fullScale));
					eepWrite((uint8_t *)&slaveDUT[0]->iSet, EE_LASTISET ,sizeof(float));
					if (slaveNumber > 0)
						SET_UPDATE_SLAVE_ISET;
				}
				else // _
				{
					for (i = 0; i <= SLAVEMAXNUM ;i++)
						slaveDUT[i]->ratioiMax = slaveDUT[i]->iMax;
				}
			}
			break;
		case ISET_CMD:
			backup = master.iSet;
			
			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
			{
				// RS485 qyCxɬۦP ҥHn@x@x
				master.iSet = temp;
				masterState = BROADCAST; // SETVSETI;
				masterParallelSetCmdFloat(master.iSet,CMD_SETI);
				SET_UPDATE_SLAVE_ISET; // ISET set twice
			}
			else
			{
				temp = roundDigit(temp ,currPoint);
				if (parallelMode != ON)
					temp = round(temp,around);
 				do
				{	
					if (softTimer[MAIN_COUNT].count - time < 100 )
					{
						iTemp = convertFloatToInt(temp, master.iMax, fullScale);
						sendMBIntSetting(ISET_CMD, iTemp);

						sendMBQuery(MEASURE_CHANNEL,ISETQ_CMD);
  					    master.iSet = temp; // This assumption is to replace the following annotation, 
						                    // in order to allow faster orders GPIB
//          						    
//						iSetCount.count++;
//			    	delayMs(10);
//						master.iSet = -1;
//						if (queryStepByStep( MEASURE_CHANNEL,ISETQ_CMD,ISETR_CMD ,20) == SUCCESS) // varify
//						{
//							if (iTemp == (uint16_t)unionbyte.itob[0]) // compare with count equal
//							{
//								master.iSet = temp;
//							    iSetCount.rcount++;
//							    break;
//							}
//						}
					}
					else
					{
						master.iSet = backup;
						pushError(MEASURE_VERIFY_ERROR);
						displayFresh = 1;
						waitMBStatus |= BIT30;
						result = ERROR;
						break;
					}
				}while (temp != master.iSet);
			}	

			break;
		case OVPSET_CMD:
			backup = master.OVPSet;
 			temp = roundDigit(temp ,voltPoint);
//			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
//			{
//				masterState = BROADCAST;
//				masterParallelSetCmdFloat(temp,CMD_SETOVP);
//				SET_PARALLEL_OVPSWITCH;
//			}
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 100 )
				{
					if (temp > (master.OVPMax - 40)) //1060)   // j 1060V H 1060 E7
					{
						master.OVPSet = temp;
						temp = (master.OVPMax - 40);
						sendMBIntSetting(OVPSET_CMD, convertFloatToInt(temp, master.vMax, fullScale));
						break;
					}
					iTemp = convertFloatToInt(temp, master.vMax, fullScale);
					sendMBIntSetting(OVPSET_CMD, iTemp);
					
					sendMBQuery(MEASURE_CHANNEL,OVPSETQ_CMD);
					master.OVPSet = temp;  //  This assumption is to replace the following annotation, 
						                    // in order to allow faster orders GPIB
//		    	delayMs(10);
//					master.OVPSet = -1;
//					if (queryStepByStep(MEASURE_CHANNEL, OVPSETQ_CMD,OVPSETR_CMD ,20) == SUCCESS) // varify
//					{
//					   OVPSetCount.rcount++;
//						if (master.OVPSet >= (master.OVPMax - 40))	 // Ū^ YO 1070 ,^_]w HsJ eeprom
//						{
//							master.OVPSet = backup	;
//							return result;
//						}
//						else
//						{
//							if (iTemp == (uint16_t)unionbyte.itob[0]) // compare with count equal
//							{
//								master.OVPSet = temp;
//							    iSetCount.rcount++;
//							    break;
//							}
//						}
//					}
				}
				else
				{
					master.OVPSet = backup;
					pushError(MEASURE_VERIFY_ERROR);
					displayFresh = 1;
					waitMBStatus |= BIT29;
					result = ERROR;
					break;
				}
			}while (temp != master.OVPSet);
			break;
		case OCPSET_CMD:
			backup = master.OCPSet;
 			temp = roundDigit(temp ,currPoint);
			temp = round(temp,around);
//			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
//			{
//				temp = temp/(slaveNumber + 1);
//				masterState = BROADCAST;
//				masterParallelSetCmdFloat(temp,CMD_SETOCP);
//				SET_PARALLEL_OCPSWITCH;
//			}
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 100 )
				{
					iTemp = convertFloatToInt(temp, master.iMax, fullScale);
					sendMBIntSetting(OCPSET_CMD, iTemp);
					
					sendMBQuery(MEASURE_CHANNEL,OCPSETQ_CMD);
					master.OCPSet = temp; //  This assumption is to replace the following annotation, 
						                    // in order to allow faster orders GPIB
//					OCPSetCount.count++;
//		    	delayMs(10);
//					master.OCPSet = -1;
//					if (queryStepByStep(MEASURE_CHANNEL, OCPSETQ_CMD,OCPSETR_CMD ,20) == SUCCESS) // varify
//					{
//						if (iTemp == (uint16_t)unionbyte.itob[0]) // compare with count equal
//						{
//							master.OCPSet = temp;	 
//							OCPSetCount.rcount++;
//							break;
//						}
//					}
				}
				else
				{
					master.OCPSet = backup;
					pushError(MEASURE_VERIFY_ERROR);
					displayFresh = 1;
					waitMBStatus |= BIT28;
					result = ERROR;
					break;
				}
			}while (temp != master.OCPSet);
			break;
		case OPPSET_CMD:
			backup = master.OPPSet;
 			temp = roundDigit(temp ,powPoint);
//			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
//			{
//				// RS485s
//				masterState = BROADCAST;
//				masterParallelSetCmdFloat(temp,CMD_SETOPP);
//				SET_PARALLEL_OPPSWITCH;
//			}
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 100 )
				{
					sendMBFloatSetting(OPPSET_CMD, temp);
					
					sendMBQuery(MEASURE_CHANNEL,OPPSETQ_CMD);
					master.OPPSet = temp; //  This assumption is to replace the following annotation, 
						                    // in order to allow faster orders GPIB
//					OPPSetCount.count++;
//		    	delayMs(15);
//					master.OPPSet = -1;
//					if (queryStepByStep(MEASURE_CHANNEL, OPPSETQ_CMD,OPPSETR_CMD ,20) == SUCCESS) // varify
//					{
//						OPPSetCount.rcount++;
//					}
				}
				else
				{
					master.OPPSet = backup;
					displayFresh = 1;
					result = ERROR;
					break;
				}
			}while (temp != master.OPPSet);
			break;
		case VSRSET_CMD:
			backup = master.SRvSet;
			temp = roundDigit(temp ,1);
			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
			{
				// RS485s
				slaveIndex = 0;
				master.SRvSet = temp;
				masterState = BROADCAST;
				masterParallelSetCmdFloat(master.SRvSet,CMD_SETVSLEW);
			}
			else
			{
				do
				{
					if (softTimer[MAIN_COUNT].count - time < 100)
					{
						sendMBFloatSetting(VSRSET_CMD ,temp);
						
					  sendMBQuery(MEASURE_CHANNEL,VSRQ_CMD);
						master.SRvSet = temp; //  This assumption is to replace the following annotation, 
						                      // in order to allow faster orders GPIB
//						SRvSetCount.count++;
//			    	delayMs(10);
//						master.SRvSet = -1;
//						if (queryStepByStep(MEASURE_CHANNEL, VSRQ_CMD,VSRR_CMD ,20) == SUCCESS) // varify
//						{
//							SRvSetCount.rcount++;
//						}
					}
					else
					{
						master.SRvSet = backup;
						pushError(MEASURE_VERIFY_ERROR);
						displayFresh = 1;
						waitMBStatus |= BIT26;
						result = ERROR;
						break;
					}
				}while (temp != master.SRvSet);
			}
			break;
		case ISRSET_CMD:
			backup = master.SRiSet;
			temp = roundDigit(temp ,1);
			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
			{
				// RS485s
				slaveIndex = 0;
				master.SRiSet = temp;
				masterState = BROADCAST;
				masterParallelSetCmdFloat(master.SRiSet,CMD_SETISLEW);
			}
			else
			{
	 			do
				{
					if (softTimer[MAIN_COUNT].count - time < 100)
					{
						sendMBFloatSetting(ISRSET_CMD ,temp);
						
					  sendMBQuery(MEASURE_CHANNEL,ISRQ_CMD);
						master.SRiSet = temp;//  This assumption is to replace the following annotation, 
						                     // in order to allow faster orders GPIB
//						SRiSetCount.count++;
//			    	delayMs(10);
//						master.SRiSet = -1;
//						if (queryStepByStep(MEASURE_CHANNEL, ISRQ_CMD,ISRR_CMD ,20) == SUCCESS) // varify
//						{
//							SRiSetCount.rcount++;
//						}
					}
					else
					{
						master.SRiSet = backup;
						pushError(MEASURE_VERIFY_ERROR);
						displayFresh = 1;
						waitMBStatus |= BIT25;
						result = ERROR;
						break;
					}
				}while (temp != master.SRiSet);
			}
			break;
		case OUTPUT_CMD:
			if (parallelMode == ON && parallelRole == MASTER && masterState == QUERYCURR && slaveNumber > 0)
			{
 				rs485Temp.cmd = CMD_SETOUTPUT;
				rs485Temp.unionbyte.byte_loc[0] /*temp8*/ = onoffStatus;
				masterState = BROADCAST;
//				SET_ACK; //dummy ACK
				slaveIndex = 0;
				cmdexenum = MASTERSETINT8;
				SET_ONOFF_CMD_AGAIN;
				sendRS232Settingint8(OUTPUT_CMD,onoffStatus); //q
			}
			else 
			{
				backup1 = onoffStatus;
 				do
				{
					if (softTimer[MAIN_COUNT].count - time < 100 )
					{
						sendMBStateSetting(MEASURE_CHANNEL,OUTPUT_CMD, (uint8_t)temp); // OFF
						
					  sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
						onoffStatus = (uint8_t)temp; //  This assumption is to replace the following annotation, 
						                             // in order to allow faster orders GPIB
//						outputStatusCount.count++;
//			    	delayMs(10);
//						onoffStatus = 0xff;
//						if (queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,20) == SUCCESS) // varify
//						{
//							outputStatusCount.rcount++;
//							if (outputStatus & ON_STATE)
//								onoffStatus = 1;
//							else
//							  onoffStatus = 0;
//						}
					}
					else
					{
						onoffStatus = backup1;
						pushError(MEASURE_VERIFY_ERROR);
						displayFresh = 1;
						waitMBStatus |= BIT24;
						result = ERROR;
						break;
					}
				}while ((uint8_t)temp != onoffStatus);
			}
			break;
		case PORTSW_CMD:
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0 )  // 
				;
			else
			{
				backup1 = protsw;
 				do
				{
					if (softTimer[MAIN_COUNT].count - time < 100)
					{
						sendMBStateSetting(MEASURE_CHANNEL,PORTSW_CMD, (uint8_t)temp); //
						
						
					  sendMBQuery(MEASURE_CHANNEL,PROTSWQ_CMD);
						protsw = (uint8_t)temp; //  This assumption is to replace the following annotation, 
						                        // in order to allow faster orders GPIB
//			    	delayMs(10);
//						protsw = 0xff;
//						if (queryStepByStep(MEASURE_CHANNEL, PROTSWQ_CMD,PROTSWR_CMD ,20) == SUCCESS) // varify
//						{
//						}
					}
					else
					{
						protsw = backup1;
						pushError(MEASURE_VERIFY_ERROR);
						displayFresh = 1;
						waitMBStatus |= BIT25;
						result = ERROR;
						break;
					}
				}while ((uint8_t)temp != protsw);
			}
			break;
			
	}
	return result;
}

// POqT @骺qT 
ErrorStatus verifyGPIBLANInput(uint8_t cmd,uint8_t temp1,uint8_t temp2,uint8_t temp3,uint8_t temp4,uint8_t temp5,uint8_t temp6 )
{
	ErrorStatus result = SUCCESS;
	uint8_t backup1;
	uint8_t backup2[6];
	uint32_t time  = softTimer[MAIN_COUNT].count;
	backup1 = temp1;
	backup2[0] = temp1;backup2[1] = temp2;backup2[2] = temp3;backup2[3] = temp4;backup2[4] = temp5;backup2[5] = temp6;
	while (uartBuffer[GPIB_LAN_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[GPIB_LAN_CHANNEL].packetCount--;
		receiveMBResponse(GPIB_LAN_CHANNEL);
	}
	time  = softTimer[MAIN_COUNT].count;
	switch(cmd)
	{
		case GPIBADDR_CMD:
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 200)
				{
					sendMBStateSetting(GPIB_LAN_CHANNEL,GPIBADDR_CMD, (uint8_t)temp1); //
		    		delayMs(10);
					GPIBAddr = 0xff;
					if (queryStepByStep(GPIB_LAN_CHANNEL, GPIBADDRQ_CMD,GPIBADDRR_CMD ,50) == SUCCESS) // varify
					{
					}	
				}
				else
				{
					GPIBAddr = backup1;
					waitGBStatus |= BIT0;
					pushError(GPIB_VERIFY_ERROR);
					break;
				}
			}while (temp1 != GPIBAddr);
			break;
		case IPMODE_CMD:
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 200)
				{
					sendMBStateSetting(GPIB_LAN_CHANNEL,IPMODE_CMD, (uint8_t)temp1); //
		    		delayMs(10);
					LANIPMode = 0xff;
					if (queryStepByStep(GPIB_LAN_CHANNEL, IPMODEQ_CMD,IPMODER_CMD ,50) == SUCCESS) // varify
					{
					}
				}
				else
				{
					LANIPMode = backup1;
					waitGBStatus |= BIT1;
					pushError(GPIB_VERIFY_ERROR);
					break;
				}
			}while (temp1 != LANIPMode);			
			break;
		case IPADDR_CMD:
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 200)
				{
					sendGBStateSetting(GPIB_LAN_CHANNEL,IPADDR_CMD, temp1 ,temp2 ,temp3,temp4); //
		    		delayMs(15);
					memset((void *)LANIPAddr , 0xff ,4);
					if (queryStepByStep(GPIB_LAN_CHANNEL, IPADDRQ_CMD,IPADDRR_CMD ,50) == SUCCESS) // varify
					{
					}
				}
				else
				{
					memcpy((void *)LANIPAddr ,(void *)backup2 ,4);
					pushError(GPIB_VERIFY_ERROR);
					waitGBStatus |= BIT2;
					break;
				}
			}while (memcmp((void *)backup2 ,(void *)LANIPAddr,4) != 0);			
			break;		
		case GWADDR_CMD:
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 200)
				{
					sendGBStateSetting(GPIB_LAN_CHANNEL,GWADDR_CMD, temp1 ,temp2 ,temp3,temp4); //
		    		delayMs(15);
					memset((void *)LANGateway , 0xff ,4);
					if (queryStepByStep(GPIB_LAN_CHANNEL, GWADDRQ_CMD,GWADDRR_CMD ,50) == SUCCESS) // varify
					{
					}
				}
				else
				{
					memcpy((void *)LANGateway ,(void *)backup2 ,4);
					waitGBStatus |= BIT3;
					pushError(GPIB_VERIFY_ERROR);
					break;
				}
			}while (memcmp((void *)backup2 ,(void *)LANGateway,4) != 0);			
			break;		
		case MASKADDR_CMD:
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 200)
				{
					sendGBStateSetting(GPIB_LAN_CHANNEL,MASKADDR_CMD, temp1 ,temp2 ,temp3,temp4); //
		    		delayMs(15);
					memset((void *)LANMask , 0xff ,4);
					if (queryStepByStep(GPIB_LAN_CHANNEL, MASKADDRQ_CMD,MASKADDRR_CMD ,50) == SUCCESS) // varify
					{
					}
				}
				else
				{
					memcpy((void *)LANMask ,(void *)backup2 ,4);
					waitGBStatus |= BIT4;
					pushError(GPIB_VERIFY_ERROR);
					break;
				}
			}while (memcmp((void *)backup2 ,(void *)LANMask,4) != 0);			
			break;
		case MACADDR_CMD:
 			do
			{
				if (softTimer[MAIN_COUNT].count - time < 200)
				{
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head = SIMPLE;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length = 0x08;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[0] = MACADDR_CMD;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[1] = temp1;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[2] = temp2;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[3] = temp3;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[4] = temp4;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[5] = temp5;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[6] = temp6;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[7] = calculateCrc8(&uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head, uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 1);
					uartTransmit(GPIB_LAN_CHANNEL, &uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head, uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 2);
		    		delayMs(20);
					memset((void *)MACaddress, 0xff ,6);
					if (queryStepByStep(GPIB_LAN_CHANNEL, MACADDRQ_CMD,MACADDRR_CMD ,50) == SUCCESS) // varify
					{
					}
				}
				else
				{
					memcpy((void *)MACaddress ,(void *)backup2 ,6);
					waitGBStatus |= BIT5;
					pushError(GPIB_VERIFY_ERROR);
					break;
				}
			}while (memcmp((void *)backup2 ,(void *)MACaddress,6) != 0);			
			break;			


	}
	return result;
}


static transRuleMaterialPattern(void)
{
	switch((uint8_t)Rule)
	{
		case 1:
			memcpy((void *)(pvsBuffer + 6), "EN50530 ",8);
//			memcpy((void *)(pvsBuffer + 6), (void *)(displayBuffer + 19 + 6),8);
			break;
		case 2:
			memcpy((void *)(pvsBuffer + 6), "SANDIA  ",8);
//			memcpy((void *)(pvsBuffer + 6), (void *)(displayBuffer + 19 + 6),8);
			break;
		case 3:
			memcpy((void *)(pvsBuffer + 6), "NBT32004",8);
//			memcpy((void *)(pvsBuffer + 6), (void *)(displayBuffer + 19 + 6),8);
			break;
		default:
			memcpy((void *)(pvsBuffer + 6), "EN50530 ",8);
			Rule = 1;
			break;		
	}
	switch((uint8_t)Rule)
	{
		case 1:
		case 3:
			switch((uint8_t)Material)
			{
				case 1:
					memcpy((void *)(pvsBuffer + 29 + 21), "cSi     ",8);
//					memcpy((void *)(pvsBuffer + 29 + 21), (void *)(displayBuffer + 19 + 21),8);
					break;
				case 2:
					memcpy((void *)(pvsBuffer + 29 + 21), "TF      ",8);
//					memcpy((void *)(pvsBuffer + 29 + 21), (void *)(displayBuffer + 19 + 21),8);
					break;
				default:
					memcpy((void *)(pvsBuffer + 29 + 21), "cSi     ",8);
					Material = 1;
					break;
			}
			break;
		case 2:
			switch((uint8_t)Material)
			{
				case 1:
					memcpy((void *)(pvsBuffer + 29 + 21), "TF      ",8);
//					memcpy((void *)(pvsBuffer + 29 + 21), (void *)(displayBuffer + 19 + 21),8);
					break;
				case 2:
					memcpy((void *)(pvsBuffer + 29 + 21), "SCMC    ",8);
//					memcpy((void *)(pvsBuffer + 29 + 21), (void *)(displayBuffer + 19 + 21),8);
					break;
				case 3:
					memcpy((void *)(pvsBuffer + 29 + 21), "HEC     ",8);
//					memcpy((void *)(pvsBuffer + 29 + 21), (void *)(displayBuffer + 19 + 21),8);
					break;
				default:
					memcpy((void *)(pvsBuffer + 29 + 21), "TH      ",8);
					Material = 1;
					break;
			}
			break;
	}
}




// return 1   error message
// return 0	  normal
uint8_t convertSettingValue(void)
{
	uint8_t disp[20];
	float tempf1;
	tempf = atof(KEYINBUF);
	if (tempf > numericalInput.floatMax)
		pushError(OVER_RANGE);
	else if (tempf < numericalInput.floatMin)
		pushError(OVER_RANGE);
	if (errorQueue[errorIndex - 1] == OVER_RANGE )
	    return 1; //ERROR
	switch(lastState)
	{
		case D_VSET:
			// send vset						
			if (verifyInput(VSET_CMD,tempf ) == SUCCESS)
				eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
			break;
		case D_ISET:
			// send iset
			tempf = round(tempf,around);
			calCurrRatio(tempf);
			if (verifyInput(ISET_CMD,slaveDUT[0]->iSet ) == SUCCESS)
				eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
			break;
		case D_OVP:
			if (verifyInput(OVPSET_CMD,tempf ) == SUCCESS)
				eepWrite((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
			if (parameterTemp == 1)
				protsw |= BIT7;
			else
				protsw &= ~(BIT7);
			ProtOVActivation = parameterTemp;
			if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
				eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));

			break;
		case D_OCP:
			tempf = round(tempf,around);
			ProtOCActivation = parameterTemp;
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				uint8_t i;
				tempf = tempf/(slaveNumber + 1);
				eepWrite((uint8_t *)&tempf, EE_REALOCPSET ,sizeof(float));
				if (parameterTemp == 1)
					protsw |= BIT6;
				else
					protsw &= ~(BIT6);
				eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
				for (i = 0 ;slaveDUT[i]->exist == 1 && i <= SLAVEMAXNUM ; i++)
					slaveDUT[i]->OCPSet = tempf;
			} 
			else
			{
				if (verifyInput(OCPSET_CMD,tempf ) == SUCCESS)
					eepWrite((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
				if (parameterTemp == 1)
					protsw |= BIT6;
				else
					protsw &= ~(BIT6);
				if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
					eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			}
			break;
		case D_OPP:
			ProtOPActivation = parameterTemp;
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				master.OPPSet =	tempf;
				master.OPPSet = master.OPPSet/(slaveNumber + 1);
				eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
				if (parameterTemp == 1)
					protsw |= BIT5;
				else
					protsw &= ~(BIT5);
				eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			} 
			else
			{
				if (parameterTemp == 1)
					protsw |= BIT5;
				else
					protsw &= ~(BIT5);
				if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
					eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
				if (verifyInput(OPPSET_CMD,tempf ) == SUCCESS)
					eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
			}
			break;
		case MENUCONFLIMITVMIN:
			if ( tempf >= master.limitVMax)
			{
				pushError(OVER_RANGE);
				return 1;
			}
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
 				masterState = BROADCAST;
				masterParallelSetCmdFloat(tempf,CMD_SETLIMITVMIN);
 			}
			master.limitVMin = tempf;
			master.limitVMin = roundDigit(master.limitVMin ,voltPoint);
			if (master.limitVMin > master.vSet)
				master.vSet = master.limitVMin;
			eepWrite((uint8_t *)&master.limitVMin, EE_LIMITVMIN ,sizeof(float));
		    break;
		case MENUCONFLIMITVMAX:
			if ( tempf <= master.limitVMin)
			{
				pushError(OVER_RANGE);
				return 1;
			}
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
 				masterState = BROADCAST;
				masterParallelSetCmdFloat(tempf,CMD_SETLIMITVMAX);
 			}
 			master.limitVMax = tempf;
			master.limitVMax = roundDigit(master.limitVMax ,voltPoint);
			if (master.vSet > master.limitVMax )
				master.vSet = master.limitVMax;
			eepWrite((uint8_t *)&master.limitVMax, EE_LIMITVMAX ,sizeof(float));
		    break;
		case MENUCONFLIMITIMIN:
			sprintf((void *)disp,"%8.4f",(master.limitIMax * (slaveNumber + 1)));
			tempf1 = atof((void *)disp);
			if (tempf >= tempf1)
			//if ( tempf >= (master.limitIMax * (slaveNumber + 1) /*sumlimitIMax()*/))
			{
				pushError(OVER_RANGE);
				return 1;
			}
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				uint8_t i;
				tempf = tempf/(slaveNumber+1);
 				masterState = BROADCAST;
				masterParallelSetCmdFloat(tempf,CMD_SETLIMITIMIN);
				for (i = 0 ;slaveDUT[i]->exist == 1 && i <= SLAVEMAXNUM ; i++)
					slaveDUT[i]->limitIMin = tempf;
			}
//			else
//			{
		    master.limitIMin = tempf;
				master.limitIMin = roundDigit(master.limitIMin ,currPoint);
//			}
			if (master.limitIMin > master.iSet)
			{
				master.iSet = master.limitIMin;
				masterParallelSetCmdFloat(master.iSet,CMD_SETI);
			}
			eepWrite((uint8_t *)&master.limitIMin , EE_LIMITIMIN ,sizeof(float));
		    break;
		case MENUCONFLIMITIMAX:
			sprintf((void *)disp,"%8.4f",(master.limitIMin * (slaveNumber + 1)));
			tempf1 = atof((void *)disp);
			if ( tempf <= tempf1)
//			if ( tempf <= (master.limitIMin * (slaveNumber + 1) /*sumlimitIMin()*/))
			{
				pushError(OVER_RANGE);
				return 1;
			}
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				uint8_t i;
				tempf = tempf/(slaveNumber+1);
 				masterState = BROADCAST;
				masterParallelSetCmdFloat(tempf,CMD_SETLIMITIMAX);
				for (i = 0 ;slaveDUT[i]->exist == 1 && i <= SLAVEMAXNUM ; i++)
					slaveDUT[i]->limitIMax = tempf;
			}					    
//			else
//			{
				master.limitIMax = tempf;
				master.limitIMax = roundDigit(master.limitIMax ,currPoint);
//			}
			if (master.iSet > master.limitIMax )
			{
				master.iSet = master.limitIMax;
				masterParallelSetCmdFloat(master.iSet,CMD_SETI);
			}
			eepWrite((uint8_t *)&master.limitIMax , EE_LIMITIMAX ,sizeof(float));
		    break;

		case MENUSYSPONUDEFV:
			powerOnVolt = tempf;
			powerOnVolt = roundDigit(powerOnVolt ,voltPoint);
			eepWrite((uint8_t *)&powerOnVolt, EE_POWERONVOLT ,sizeof(float));
		    break;
		case MENUSYSPONUDEFI:
			tempf = round(tempf,around);
		    powerOnCurrent = tempf;
			powerOnCurrent = roundDigit(powerOnCurrent,currPoint);
			eepWrite((uint8_t *)&powerOnCurrent, EE_POWERONCURRENT ,sizeof(float));
			break;
	}
	if (errorQueue[errorIndex - 1] == MEASURE_VERIFY_ERROR)
	    return 1; //ERROR
	else
	    return 0; // NORMAL
}




void spaceToZero(uint8_t addr)
{
	uint8_t tempii;
	if (numericalInput.ft == FLOAT)
	{
		for (tempii = cursorPosition; tempii < (addr + numericalInput.length); tempii++)
		{
			if (keyInBuffer[tempii-addr] == ' ') keyInBuffer[tempii-addr] = '0';
		}
		for (tempii = addr; tempii < cursorPosition; tempii++)
		{
			if (keyInBuffer[tempii-addr] == '0' || keyInBuffer[tempii-addr] == ' ')
			{
				if (keyInBuffer[tempii-addr-1] == '.') 
				    break;
				else 
				    keyInBuffer[tempii-addr] = ' ';
			}
			else 
			    break;
		}
	}
    for (tempii = 0 ; tempii < numericalInput.length ; tempii++)
	   displayBuffer[(addr - 0x40) + tempii] = keyInBuffer[tempii];
}



//} PO qTˬd 
void initializeMB(void)
{
	uint32_t time;
	// get *IDN?
//	HVVoltage();
//	delayMs(3000);
	clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
	clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
	clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
	clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
	time = softTimer[MAIN_COUNT].count;
	do
	{
		clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
		delayMs(100);
		if ((softTimer[MAIN_COUNT].count - time) < (3000 )) // 
		{
			while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
			{
				uartBuffer[MEASURE_CHANNEL].packetCount--;
				receiveMBResponse(MEASURE_CHANNEL);
			}
			 waitMBStatus = 0;
		// get fullscale
	    	if (queryStepByStep(MEASURE_CHANNEL, FULLSCALEQ_CMD,FULLSCALER_CMD ,30) == ERROR)  //0x20 ->
				waitMBStatus |= BIT0;
			delayMs(50);
		// get vmax
			if (queryStepByStep( MEASURE_CHANNEL,VMAXQ_CMD,VMAXR_CMD ,30) == ERROR)			  //0x22 ->	 vMax
	 	   		waitMBStatus |= BIT1;
			delayMs(50);
		// get vmin													  //0x23 <-
			if (queryStepByStep( MEASURE_CHANNEL,VMINQ_CMD,VMINR_CMD ,30) == ERROR)			  //0x24 ->
		    	waitMBStatus |= BIT2;
		// get imax	
			delayMs(50);											  //0x25 <-
			if (queryStepByStep(MEASURE_CHANNEL, IMAXQ_CMD,IMAXR_CMD ,30) == ERROR)			  //0x26 ->
	    		waitMBStatus |= BIT3;
			delayMs(50);
		// get imin													  //0x27 <-
			if (queryStepByStep(MEASURE_CHANNEL, IMINQ_CMD,IMINR_CMD ,30) == ERROR)			  //0x28 ->
		    	waitMBStatus |= BIT4;									  //0x29 <-
			delayMs(50);
			if (queryStepByStep(MEASURE_CHANNEL, PMAXQ_CMD,PMAXR_CMD ,30) == ERROR)		      //0x2A ->
			    waitMBStatus |= BIT5;									  //0x2B
			delayMs(50);
			if (queryStepByStep(MEASURE_CHANNEL, OVPMAXQ_CMD,OVPMAXR_CMD,30) == ERROR)		  //0x2C ->
			   	waitMBStatus |= BIT6;									  //0x2D <-
			delayMs(50);
			if (queryStepByStep(MEASURE_CHANNEL, OVPMINQ_CMD,OVPMINR_CMD ,30) == ERROR)		  //0x2E ->
			    waitMBStatus |= BIT7;									  //0x2F <-
			delayMs(50);
			if (queryStepByStep( MEASURE_CHANNEL,OCPMAXQ_CMD,OCPMAXR_CMD ,30) == ERROR)		  //0x30 ->
			    waitMBStatus |= BIT8;									  //0x31 <-
			delayMs(50);
			if (queryStepByStep( MEASURE_CHANNEL,OCPMINQ_CMD,OCPMINR_CMD ,30) == ERROR)		  //0x32 ->
			    waitMBStatus |= BIT9;									  //0x33 <-
			delayMs(50);
			if (queryStepByStep( MEASURE_CHANNEL,OPPMAXQ_CMD,OPPMAXR_CMD ,30) == ERROR)		  //0x34 ->
		    	waitMBStatus |= BIT10;									  //0x35 <-
			delayMs(50);
			if (queryStepByStep( MEASURE_CHANNEL,OPPMINQ_CMD,OPPMINR_CMD ,30) == ERROR)		  //0x36 ->
		    	waitMBStatus |= BIT11;									  //0x37 <-
			delayMs(50);
			if (queryStepByStep(MEASURE_CHANNEL, VSRMAXQ_CMD,VSRMAXR_CMD ,30) == ERROR)		  //0x38 ->
			    waitMBStatus |= BIT12;									  //0x39 <-
			delayMs(50);
			if (queryStepByStep( MEASURE_CHANNEL,ISRMAXQ_CMD,ISRMAXR_CMD ,30) == ERROR)		  //0x3A ->
		    	waitMBStatus |= BIT13;									  //0x3B <-
			delayMs(50);
			if (queryStepByStep(MEASURE_CHANNEL, VSRQ_CMD,VSRR_CMD ,30) == ERROR)  //SRvSet
				waitMBStatus |= BIT14;
			 delayMs(50);
			if (queryStepByStep(MEASURE_CHANNEL, ISRQ_CMD,ISRR_CMD ,30) == ERROR)  //SRiSet
				waitMBStatus |= BIT15;
			if (waitMBStatus != 0)
				pushError(MEASURE_VERIFY_ERROR);
			delayMs(50);
			// send vset						
			if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
				;//eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));			
			// send iset						
			if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
				;//eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
			verifyInput(VSRSET_CMD,master.SRvSet );// send SRvSet
			verifyInput(ISRSET_CMD,master.SRiSet ); // send SRiSet
			verifyInput(OUTPUT_CMD,(float)onoffStatus );  // send output off
			externalControlHandler();
		}
		else
			break;
	}while(waitMBStatus != 0);
	delayMs(200);
	while(uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL) ;
	}


/* 600V 8.5A

	master.vMax = 606;
	master.vMin = 5;
	master.iMax = 8.585;
	master.iMin = 0.02;
	master.pMax = 5202;
	master.OVPMax = 660;
	master.OVPMin = 6;
	master.OCPMax = 8.67;
	master.OCPMin = 0.08;
	master.OPPMax = 5408;
	OPPMin = 102;
	VSRMax = 40;
	ISRMax = 0.2;
	master.SRvSet = 4;
	master.SRiSet = 20;
  */
  /*
	master.vMax = 1010;
	master.vMin = 5;
	master.iMax = 5.05;
	master.iMin = 0.02;
	master.pMax = 5100;
	master.OVPMax = 1100;//1020;
	master.OVPMin = 10;
	master.OCPMax = 5.1;
	master.OCPMin = 0.05
	master.OPPMax = 5200;
	OPPMin = 100;
	VSRMax = 40;
	ISRMax = 0.2;
	master.SRvSet = 4;
	master.SRiSet = 20;


  */
	
	if(master.vMax == 606)
	{
		if (machine1000 == 0)	// model = 1000V
			SET_MODEL_CONFLICT;	
		specif = V_600;
		powPoint = 1;
		voltPoint = 2;
		currPoint = 4;
		extvMax = 600;
		extiMax = 8.5;
		around = 0.0002; //
	}
	else
	{
		if (machine1000 == 1)	// model = 600V
			SET_MODEL_CONFLICT;	
		specif = V_1000;
		extvMax = 1000;
		extiMax = 5;
		around = 0.0001;
	}
	master.pMax = master.iMax * master.vMax;
	master.pMax = roundDigit(master.pMax ,1);
//#if	LOCK_POWER == 1
	if (outputStatus & HALF_POWER_STATE)  // AC 110V
	{
		master.pMax = master.pMax * 0.5;
	}
	else								// AC 110V
	{
		if (machine3KW == 1)
		{
			master.pMax = master.pMax * 0.6; // 5200 * 0.6 = 3120 ,5100 * 0.6 =3060
		}
	}
 
	if (outputStatus & THREEKW_POWER_STATE)  // 3kw
	{
		if (machine3KW == 0)
		  	SET_MODEL_CONFLICT;
	}
	else								// 5kw
	{
		if (machine3KW == 1)
		   SET_MODEL_CONFLICT;
	}

//#endif
	slaveDUT[0]->ratioiMax = slaveDUT[0]->iMax;
	sendMBQuery(MEASURE_CHANNEL,PVCTRLMODQ_CMD);	 //E3
}

//} PGPIB/LAN qTˬd 
void initializeGPIBLAN(void)
{
	eepRead((void *)&LANIPMode,EE_LANIPMODE,sizeof(LANIPMode));
	if (LANIPMode > 1)
	{
		LANIPMode = 0;
		eepWrite((void *)&LANIPMode,EE_LANIPMODE,sizeof(LANIPMode));
	}
	waitGBStatus = 0;
	verifyGPIBLANInput(IPMODE_CMD,LANIPMode,NULL,NULL,NULL,NULL,NULL);
	if (LANIPMode > 0) // MANUEL
	{
		verifyGPIBLANInput(IPADDR_CMD,LANIPAddr[0],LANIPAddr[1],LANIPAddr[2],LANIPAddr[3],NULL,NULL);
		verifyGPIBLANInput(GWADDR_CMD,LANGateway[0],LANGateway[1],LANGateway[2],LANGateway[3],NULL,NULL);
		verifyGPIBLANInput(MASKADDR_CMD,LANMask[0],LANMask[1],LANMask[2],LANMask[3],NULL,NULL);
	}
}













 /*
uint16_t bufferLength = 0;
uint8_t *bufferAddress;
uint8_t buffer[10];
static uint8_t  *GetBuffer (uint8_t* address, uint16_t *length)
{
  *length = sizeof (buffer);
  return address;
}
 
//	buffer[10] = bufferAddress[bufferLength] ;

    bufferAddress = GetBuffer(buffer, &bufferLength);
	bufferAddress[5] = 2;
*/



void measure(void)	// y{ P 25
{
	uint32_t time;
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
		time = 50 ;
	else
		time = 50;
	if (softTimer[MAIN_COUNT].count - softTimer[TIME_ALARM_COUNT1].count > (time) && (IS_SCPI_CAL == 0)) // 50 ms
	{
		softTimer[TIME_ALARM_COUNT1].count = softTimer[MAIN_COUNT].count ;
		
		switch (measurementState)
		{
			case 0:		//send vread
				sendMBQuery(MEASURE_CHANNEL,VREADQ_CMD);
				measurementState++;	
				vreadCount.count++;
				displayFresh = 1;
				break;
			case 2:		//send iread
				if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0 && masterState >= BROADCAST  )
					;
				else
					sendMBQuery(MEASURE_CHANNEL,IREADQ_CMD);
				measurementState++;
				ireadCount.count++;
				break;
			case 4:		//send output state
				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
				measurementState++;
				outputStatusCount.count++;
				break;
			case 6: // extVMode >= 1  ,VSET
				if (extVMode >= 1)
					verifyInput(VSET_CMD,master.vSet ); // not neet to save value
				if (extIMode >= 1)
					verifyInput(ISET_CMD,master.iSet );
				measurementState = 0;
				displayFresh = 1;
				break;
			case 1:	  	//receive vread
			case 3:		//receive iread
			case 5:		//receive outputStatus
				if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)
				{
					uartBuffer[MEASURE_CHANNEL].packetCount--;
					if (receiveMBResponse(MEASURE_CHANNEL) == ERR) 
						measurementState--;	// CRC error
					else
					{
					    measurementState++;
						if (controlState == LOCAL_CTRL)
						{
							if (measurementState == 6) 
					    		measurementState = 0;	
						}
						else
						{
							if ( extVMode == 0 && extIMode == 0)
							{
								if (measurementState == 6) 
						    		measurementState = 0;	
							}

						}
						if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)// && showMeter)
							displayFresh = 1;//readbackReady = 1;	// enable to show the reading on the VFD
					}
				}
				else
				{
//					if (softTimer[MAIN_COUNT].count > measureTick + (500 )) 		// if not received after 500ms, timeout
					{
						measurementState++;
						if (controlState == LOCAL_CTRL)
						{
							if (measurementState == 6) 
					    		measurementState = 0;	
						}
						else
						{
							if ( extVMode == 0 && extIMode == 0)
							{
								if (measurementState == 6) 
						    		measurementState = 0;	
							}
							else
							{
								if (measurementState == 7) 
						    		measurementState = 0;
							}
						}
						measureTick = softTimer[MAIN_COUNT].count;	
					}
				}	  
				break;
		}
	}
}

uint8_t gpibPacketChannel  ,firstGpibPacketChannel = INITPACKET;


void gpibPacketProcess(GPIB_PACKET * Packet,uint8_t channel)
{
  uint8_t i;
  if (Packet->count != 0) // http packet proccess
  {
    for (i = 0 ; Packet->tail != Packet->head;i++)
    {
      smbuffer[i] = Packet->smbuffer[Packet->tail++];
      if ((smbuffer[i] == '\r'))
      {
        Packet->count--;
        i++;
        break;
      }
    }
		smbuffer[i] = 0;
    if (Packet->head >= Packet->tail)	// valid data in buffer size 
      Packet->size = (Packet->head - Packet->tail);
    else
      Packet->size =  256 - Packet->tail + Packet->head;
    if ( (firstWitchCOM == INITCOM && firstGpibPacketChannel == INITPACKET)
         || (firstWitchCOM == GPIB_LAN_CHANNEL && firstGpibPacketChannel == channel))
    {
      firstWitchCOM = witchCOM = GPIB_LAN_CHANNEL;		//q @Uart Xh
      firstGpibPacketChannel = gpibPacketChannel = channel; 		// @ packet
      remote = SCPI_Input(&scpi_context, smbuffer, strlen(smbuffer));
    }
////////////////// Inform GPIB card UI busy or not//////////////////////////		
/*
	Generaly the SCPI command subrouting do not include any delay function such as delayMs();.
  If SCPI command	subrouting include delay function ,it will be out of control.
  When out of control the UI will inform GPIB card holdoff data do not transmit data in.
*/		
    if (channel == GPIB)
    {
      if (Packet->status == 0)
      {
				if (Packet->count > 10)
				{
					Packet->status = 1;
					SET_GPIB_BLOCK;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head = SIMPLE;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length = 1 + 2;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[0] = GPIBSTATUS_CMD;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[1] = 1; // hold 
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length - 1] = calculateCrc8(&uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head, uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 1);
					uartTransmit(GPIB_LAN_CHANNEL, &uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head, uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 2);
				}
			}
			else // Packet->status == 1;
			{
				if (Packet->count < 2)
				{
				  Packet->status = 0;
				  CLR_GPIB_BLOCK;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head = SIMPLE;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length = 1 + 2;
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[0] = GPIBSTATUS_CMD;
				  uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[1] = 0; // release
					uartBuffer[GPIB_LAN_CHANNEL].simplePacket.payload[uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length - 1] = calculateCrc8(&uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head, uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 1);
					uartTransmit(GPIB_LAN_CHANNEL, &uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head, uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 2);
				}
			}
    }
/////////////////////////////////////////////////////////////////////////////		
    if (remote == 1)
    {
      displayFresh = 1;
      if (channel == GPIB)
        SET_GPIB_ADDR;
      else
        CLR_GPIB_ADDR;
      VFDsign |= (sign_RMT);
      if (IS_GPIB_ADDR)
        VFDsign |=  sign_ADDR;
      else
        VFDsign &=  ~sign_ADDR;
    }
  }
}
extern float httpData;


void gpibLan(void)
{
	gpibPacketProcess(&httpPacket,HTTP);
	gpibPacketProcess(&gpibPacket,GPIB);
	gpibPacketProcess(&port23Packet,PORT23);	 	// telnet
	gpibPacketProcess(&port5024Packet,PORT5024);	// telnet
	gpibPacketProcess(&port5025Packet,PORT5025);	// telnet
	if ((firstWitchCOM == GPIB_LAN_CHANNEL || firstWitchCOM == INITCOM) 
	&& (firstGpibPacketChannel == INITPACKET || firstGpibPacketChannel == HTTP))
	{
		if ((stateChangeFlag & ~(0x07ffffff)) || (stateChangeFlag1 & ~(0xffffff00)))// some valid packet IN
		{
			firstWitchCOM = witchCOM = GPIB_LAN_CHANNEL;
			firstGpibPacketChannel = gpibPacketChannel = HTTP;
		}
		if (IS_GPIB_VSET_PACKET)
		{
			CLR_GPIB_VSET_PACKET;
			verifyInput(VSET_CMD,httpData );  // no neet to save value
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_ISET_PACKET)
		{
			CLR_GPIB_ISET_PACKET;
			calCurrRatio(httpData);
			verifyInput(ISET_CMD,slaveDUT[0]->iSet );
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_OUTPUTSTATUS_PACKET)
		{
			CLR_GPIB_OUTPUTSTATUS_PACKET;
			if (OVPOccurred == 0 && OCPOccurred == 0 && OPPOccurred == 0 && VCPOccurred == 0 && CVPOccurred	== 0 && !(IS_MODEL_CONFLICT) )
			{
				onoffStatus = httpData;
				if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
				{
				}
			}
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_SRVSET_PACKET)
		{
			CLR_GPIB_SRVSET_PACKET;
			if (verifyInput(VSRSET_CMD,httpData ) == SUCCESS)
				eepWrite((uint8_t *)&master.SRvSet, EE_SRVSET ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_SRISET_PACKET)
		{
			CLR_GPIB_SRISET_PACKET;
			if (verifyInput(ISRSET_CMD,httpData ) == SUCCESS)
				eepWrite((uint8_t *)&master.SRiSet, EE_SRISET ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_OVPSET_PACKET)
		{
			CLR_GPIB_OVPSET_PACKET;
			if (verifyInput(OVPSET_CMD,httpData ) == SUCCESS)
				eepWrite((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_OCPSET_PACKET)
		{
			CLR_GPIB_OCPSET_PACKET;
			if (verifyInput(OCPSET_CMD,httpData ) == SUCCESS)
				eepWrite((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_OPPSET_PACKET)
		{
			CLR_GPIB_OPPSET_PACKET;
			if (verifyInput(OPPSET_CMD,httpData ) == SUCCESS)
				eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_VMAX_PACKET)
		{
			CLR_GPIB_VMAX_PACKET;
			master.limitVMax = httpData;
			eepWrite((uint8_t *)&master.limitVMax, EE_LIMITVMAX ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_VMIN_PACKET)
		{
			CLR_GPIB_VMIN_PACKET;
			master.limitVMin = httpData;
			eepWrite((uint8_t *)&master.limitVMin, EE_LIMITVMIN ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_IMAX_PACKET)
		{
			CLR_GPIB_IMAX_PACKET;
			master.limitIMax = httpData;
			eepWrite((uint8_t *)&master.limitIMax, EE_LIMITIMAX ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_IMIN_PACKET)
		{
			CLR_GPIB_IMIN_PACKET;
			master.limitIMin = httpData;
			eepWrite((uint8_t *)&master.limitIMin, EE_LIMITIMIN ,sizeof(float));
			VFDsign |= (sign_RMT);
		}
		if (IS_GPIB_PROTSW_PACKET)
		{
			CLR_GPIB_PROTSW_PACKET;
			protsw = httpData;
			if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
				eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			setProtectSwitch();
			VFDsign |= (sign_RMT);
		}
	}
	else  // other channel occupy ,clear ALL packet flag
	{
		stateChangeFlag &= 	0x07ffffff;
		stateChangeFlag1 &= 0xffffff00;
	}
}

void rs232_or_usb(COM_TypeDef COM)
{
	if (COM == USB_VCP_CHANNEL)
	{	
		if (usb_channel_count != 0)
		{
			uint8_t i;
			//usbFSInterrupt(DISABLE);
			usb_channel_count--;
			//usbFSInterrupt(ENABLE);
			for(i = 0;(uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail] != '\r' && 
			uartBuffer[COM].rxTail != uartBuffer[COM].rxHead) ;i++)
				smbuffer[i] = uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail++];  
			smbuffer[i++] = uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail++];	   // must be '\r'
			smbuffer[i++] = '\n';
			smbuffer[i] = 0x00;  // make string
			if (firstWitchCOM == INITCOM || firstWitchCOM == COM )
			{
				firstWitchCOM = witchCOM = COM;		//q @Uart Xh
				remote = SCPI_Input(&scpi_context, smbuffer, strlen(smbuffer));
				memset((void *)smbuffer,0,256);
			}
			if (remote == 1)
			{
				displayFresh = 1;
				CLR_GPIB_ADDR;
				VFDsign |= (sign_RMT);
				if (IS_GPIB_ADDR)
					VFDsign |=  sign_ADDR;
				else
					VFDsign &=  ~sign_ADDR;
			}
		}

	}
	else
	{
		if (uartBuffer[COM].packetCount != 0)
		{
			uint8_t i;
			uartBuffer[COM].packetCount--;
			for(i = 0;(uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail] != '\r' && 
			uartBuffer[COM].rxTail != uartBuffer[COM].rxHead) ;i++)
				smbuffer[i] = uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail++];  
			smbuffer[i] = uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail++];	   // must be '\r'
			smbuffer[++i] = 0x00;  // make string
			if (firstWitchCOM == INITCOM || firstWitchCOM == COM)
			{
				
				firstWitchCOM = witchCOM = COM;		//q @Uart Xh
				remote = SCPI_Input(&scpi_context, smbuffer, strlen(smbuffer));
			}
			if (remote == 1)
			{
				displayFresh = 1;
				CLR_GPIB_ADDR;
				VFDsign |= (sign_RMT);
				if (IS_GPIB_ADDR)
					VFDsign |=  sign_ADDR;
				else
					VFDsign &=  ~sign_ADDR;
			}
		}
	}
}
void returnToNormal(COM_TypeDef COM)
{
	onoffStatus = 0;
	verifyInput(OUTPUT_CMD,(float)onoffStatus );
	setVFDFlashOff(0x40,48);
   	VFDsign &= ~(sign_MENU);
	memset((void *)displayBuffer,' ',48);
	menuLevel1 = 0;
	menuLevel2 = 0;
	menuLevel3 = 0;
	menuLevel4 = 0;
	cursorPatternPosition = 0;
	menuLevelPosition = 0;
    shiftStatus = 0;
	VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
	CLR_FROM_MENU;
	actualState = D_NORMAL;
	uartChannels(COM);
	cursorPosition = 0;
}


void uartTransmit485(uint8_t *str,uint8_t length)
{
	uint8_t tempi;
	CLR_RS485_DETECT_HOLD_BUS;
 	for (tempi = 0; tempi < length; tempi++)
	{
		uartBuffer[RS485_CHANNEL].txBuffer[uartBuffer[RS485_CHANNEL].txHead++] = str[tempi];
	}
	delayMs(DELAY_ADDTIME - 5);
	getAdCh(1);
	getAdCh(1);
	getAdCh(1);
	if (RS485_BUS_STATUS > RS485_TWO_SLAVE && RS485_BUS_STATUS < RS485_BUS_FREE) // if only one slave on bus
	{
		SET_RS485_QUERY_VI_BUSY;
		USART_ITConfig(COM_USART[RS485_CHANNEL], USART_IT_TXE, ENABLE); //}϶ǰe
	}
	else
	{
		RELEASE_RS485_BUS;
		uartBuffer[RS485_CHANNEL].txHead -= length;
	}
}





extern uint8_t slavetest[256];
extern uint8_t slavetestindex;


uint8_t lostSlaveCount;

void pollingNext(void)
{
	slaveIndex++;  // ߰ݤU@x
	for ( ; slaveIndex < MAX_CHAINADDR && rs485Id[slaveIndex].exist == 0 ;slaveIndex++);
	if (slaveIndex >= MAX_CHAINADDR)
		slaveIndex = 1;

//	rs485PacketParser();
	if (rs485Id[slaveIndex].exist == 1)
	{
    slavetest[slavetestindex++] = slaveIndex;		
    if (slaveIndex == chainAddr)
		{
			rs485SlavevOut[chainAddr] = master.vOut;
			rs485SlaveiOut[chainAddr] = master.iOut;
			rs485Id[chainAddr].exist = 1;
			rs485Id[chainAddr].timer[CMD_QVI_COUNT]  = softTimer[MAIN_COUNT].count;
		}
		else
		{
			rs485Packet.Head = RS485_HEAD;
			rs485Packet.DA = slaveIndex;	
			rs485Packet.SA = chainAddr; //
			rs485Packet.Len = 1;
			rs485Packet.Cmd = CMD_QVI;
			rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
			rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
			if (rs485Packet.DA == 2)
				__nop();
			else if(rs485Packet.DA == 1)
				__nop();
			uartTransmit(RS485_CHANNEL, &rs485Packet.Head, rs485Packet.Len + 6);	// 6 = Head + DA + SA + Len + Sn + CRC8
		}
	}


/*
	for (i = 0 ; i < MAX_CHAINADDR && rs485Id[i].exist == 0 ; i++);
	if (i >= MAX_CHAINADDR)
		return; // S slave su ,קK stack overflow
	if (++slaveIndex >= MAX_CHAINADDR)
		slaveIndex = 1;


	
	
	rs485PacketParser();
	if (rs485Id[slaveIndex].exist == 1)
	{

	    if (slaveIndex == chainAddr)
		{
			rs485SlavevOut[chainAddr] = master.vOut;
			rs485SlaveiOut[chainAddr] = master.iOut;
			rs485Id[chainAddr].exist = 1;
			rs485Id[chainAddr].timer[CMD_QVI_COUNT]  = softTimer[MAIN_COUNT].count;
		}
		else
		{
			rs485Packet.Head = RS485_HEAD;
			rs485Packet.DA = slaveIndex;	
			rs485Packet.SA = chainAddr; //
			rs485Packet.Len = 1;
			rs485Packet.Cmd = CMD_QVI;
			rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
			rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
			if (slaveIndex == 37)
				__nop();
			uartTransmit(RS485_CHANNEL, &rs485Packet.Head, rs485Packet.Len + 6);	// 6 = Head + DA + SA + Len + Sn + CRC8
		}
		return;								
	}
	else
		pollingNext();	*/				
}
void TransmitRetroactive(void);
void SCPI_485SlaveInt8(uint8_t cmd ,uint8_t des ,uint8_t temp);
uint32_t temp32[2];
void broadcastQueryVI(void)
{
	uint8_t i;
	uint8_t number;
	uint32_t temp;
	if (softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].flag == ENABLE)
	{
		if (softTimer[MAIN_COUNT].count - softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].count > 100)
		{
			CLR_PREVENT_TO_JAM;
			softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].flag = DISABLE;
		}
	}
	if (chainMode == ON && IS_RS485_CHAIN_MASTER)
	{
		if (broadcastEcho == ON )
		{
			if (currentSourceState == ONE_SOURCE)
			{

//				if (softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].flag == ENABLE)
//				{
//					if (softTimer[MAIN_COUNT].count - softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].count > 100)
//					{
//						CLR_PREVENT_TO_JAM;
//						softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].flag = DISABLE;
//					}
//				}
				if (softTimer[MAIN_COUNT].count - softTimer[RS485_QVI_BROADCAST_COUNT].count > (150 + (totalSlave * DELAY_ADDTIME)))
				{
					softTimer[RS485_QVI_BROADCAST_COUNT].count = softTimer[MAIN_COUNT].count;
					SET_RS485_BROADCAST_ECHO;
					SET_PREVENT_TO_JAM;	 //  I@CMD_QVI
					broadcastVICount = 1;
					rs485SlavevOut[chainAddr] = master.vOut;
					rs485SlaveiOut[chainAddr] = master.iOut;
					rs485Id[chainAddr].exist = 1;
					rs485Id[chainAddr].timer[CMD_QVI_COUNT]  = softTimer[MAIN_COUNT].count;
					if (totalSlave > 1)
					{
						rs485Packet.Head = RS485_HEAD;
						rs485Packet.DA = RS485_CHAINBROADCAST;	
						rs485Packet.SA = chainAddr; //
						rs485Packet.Len = 1;
						rs485Packet.Cmd = CMD_QVI;
						rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
						rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
						CLR_MULTI_MASTER;
						getAdCh(1);
						getAdCh(1);	
						getAdCh(1);
						if (RS485_BUS_STATUS > RS485_BUS_FREE)
						{
							HOLD_RS485_BUS;
							SET_RS485_DETECT_HOLD_BUS;
							uartTransmit485(&rs485Packet.Head, rs485Packet.Len + 6);	// 6 = Head + DA + SA + Len + Sn + CRC8 
						}		
						else
							RELEASE_RS485_BUS;
						SET_RS485_CHAIN_MASTER;
					}
				}
				else
					rs485TransmitRetroactive();	// rs485 after collision ,retroactive
				for (number = 0 , temp = 1; number < 32  ; number++ ,temp >>= 1) // check witch bit of serialNumber feedback time
				{
					if (rs485PacketSerialNumberFlag	& temp)	// check witch bit of serialNumber beedback time
					{
						if (softTimer[MAIN_COUNT].count - broadcastOKTimer[number] > (400 + (totalSlave * DELAY_ADDTIME)))	// out of time ,recall from memory
						{
							lostSlaveCount++;
							memcpy((void *)&rs485Packet.Head,(void *)(broadcastOKBuffer + number * 20) ,20);
							broadcastOKCount[number] = 1;	// master received
							broadcastOKTimer[number] = softTimer[MAIN_COUNT].count;	// set max time for feedback again
							rs485AntiCollision(); // transmit again
						}
					}
				}
				for (i = 1 ; i < MAX_CHAINADDR ;i++ )	// check slave suA
				{
					if (rs485Id[i].exist == 1)
					{
						if ( softTimer[MAIN_COUNT].count - rs485Id[i].timer[CMD_QVI_COUNT] > 4000)
						{
							rs485Id[i].exist = 0;   // sb
							onoffStatus = 0;		 // 
							verifyInput(OUTPUT_CMD,(float)onoffStatus ) ;
							if (rs485Id[i].disconnect == 0)
								SCPI_485SlaveInt8(CMD_SETOUTPUT ,RS485_CHAINBROADCAST ,onoffStatus);//s
							rs485Id[i].disconnect = 1; // _u
						}
					}
				}
			}
			else if(currentSourceState == CURRENT_SOURCE_NOT_EXIST || currentSourceState == DB25_NOT_INSTALL)	// master side
			{

				if (softTimer[MAIN_COUNT].count - softTimer[RS485_QVI_BROADCAST_COUNT].count > (30))
				{
					SET_PREVENT_TO_JAM;	 //  I@CMD_QVI
					softTimer[RS485_QVI_BROADCAST_COUNT].count = softTimer[MAIN_COUNT].count;
//					rs485PacketParser();

					switch(masterState)
					{
						case QUERYCURR:	 // 12	query current slave 
							if (rs485AnitCollisionBuffer.Count != 0)  // ~өRO
							{
								TransmitRetroactive();
								rs485AnitCollisionBuffer.Count--;
							}
							else // h V & I
								pollingNext();
							break;
						case BROADCAST:
							if(rs485AnitCollisionBuffer.Count != 0)
							{
								TransmitRetroactive();
								rs485AnitCollisionBuffer.Count--;
							}
							masterState = QUERYCURR;
							break;	

					}
					for (i = 1 ; i < MAX_CHAINADDR ;i++ )	// Master check slave suA
					{
						if (rs485Id[i].exist == 1)
						{
							if ( softTimer[MAIN_COUNT].count - rs485Id[i].timer[CMD_QVI_COUNT] > 10000) /* 5000 */
							{
								pushError(SLAVE_ERROR); // show which slave is disconnect 
								onoffStatus = 0;		 // 
								verifyInput(OUTPUT_CMD,(float)onoffStatus ) ;
								if (rs485Id[i].disconnect == 0)
									SCPI_485SlaveInt8(CMD_SETOUTPUT ,RS485_CHAINBROADCAST ,onoffStatus);//s
								rs485Id[i].disconnect = 1; // _u
							}
						}
					}
					for (temp32[1] = 0,temp32[0] = 1,i = 0 ; i < MAX_CHAINADDR ;i++ , shiftLeftWordBlock((void *)&temp32 ,2))
					{
						if (rs485Id[i].disconnect == 1)
						{
							if(totalSlave > 1)
							{
								rs485ErrorConnect[1] |= temp32[1];
								rs485ErrorConnect[0] |= temp32[0];
							}
						}
						else
						{
							rs485ErrorConnect[1] &= ~(temp32[1]);
							rs485ErrorConnect[0] &= ~(temp32[0]);
						}
					}
				}
			}	  	
		} 
	}
	if (!(IS_RS485_CHAIN_MASTER))
	{
		rs485TransmitRetroactive();	// chain mode slave side
		if (softTimer[CHAIN_SLAVE_CONNECT_STATUS_COUNT].flag == ENABLE)
		{
			if (softTimer[MAIN_COUNT].count - softTimer[CHAIN_SLAVE_CONNECT_STATUS_COUNT].count > 10000)
			{
				softTimer[CHAIN_SLAVE_CONNECT_STATUS_COUNT].count = softTimer[MAIN_COUNT].count;
//				beep(1);
				onoffStatus = 0;	  // disconnect protect
				verifyInput(OUTPUT_CMD,(float)onoffStatus );
			}
		}
	}
	rs485PacketParser();	 
}


void TransmitRetroactive(void)
{
	uint8_t i,j;
	rs485Packet1.Head = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	rs485Packet1.DA = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	rs485Packet1.SA = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	rs485Packet1.Len = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	rs485Packet1.Cmd = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	for (j = 0,i = 0 ; i < (rs485Packet1.Len - 1 )	; i++)
		rs485Packet1.Data[j++] = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	rs485Packet1.Data[j++] = rs485Packet1.Serial = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	rs485Packet1.Data[j++] = rs485Packet1.CRC8 = rs485AnitCollisionBuffer.Data[rs485AnitCollisionBuffer.Tail++];
	uartTransmit(RS485_CHANNEL, &rs485Packet1.Head, rs485Packet1.Len + 6);	// 6 = Head + DA + SA + Len + Check + End
}

/*
  4 byte word block LŸ  (2)
  len O word 
*/
uint32_t shiftLeftWordBlock(void *a,uint8_t len)
{
   signed char i;
   uint32_t *za,carry = 0;
   za = (uint32_t *)a;
   len--;
   if(*(za+len) >= 0x80000000)
      carry = 1;
   for(i = len;i >= 0;i--)
   {
     *(za+i) <<= 1;
     if ((i != 0) && (*(za+i-1) >= 0x80000000))
       *(za+i) |= 0x00000001;
   }
   return carry;
}

void rs485TransmitRetroactive(void)
{
		if (chainMode == ON && broadcastEcho == ON && (currentSourceState == ONE_SOURCE))
		{ 
			uint8_t i;
			if (rs485AnitCollisionBuffer.Count ) //I ɰe
			{
				if (rs485AnitCollisionBuffer.Count > 5)
				{
					pushError(SLAVE_HW_ERROR);	
				}
				getAdCh(1);	
				getAdCh(1);
				getAdCh(1);
				if (RS485_BUS_STATUS > RS485_BUS_FREE )	 // if RS485 bus free ,transmit again
				{
					HOLD_RS485_BUS;
					SET_RS485_DETECT_HOLD_BUS;
					rs485AnitCollisionBuffer.Count--;
					TransmitRetroactive();
				}
				else
				{
					RELEASE_RS485_BUS;
				}
			}
			for (temp32[1] = 0,temp32[0] = 1,i = 0 ; i < MAX_CHAINADDR ;i++ , shiftLeftWordBlock((void *)&temp32 ,2))
			{
				if (rs485Id[i].disconnect == 1)
				{
					rs485Id[i].exist = 0;//sbF
					if(totalSlave > 1)
					{
						pushError(SLAVE_ERROR);
						rs485ErrorConnect[1] |= temp32[1];
						rs485ErrorConnect[0] |= temp32[0];
					}
				}
				else
				{
					rs485ErrorConnect[1] &= ~(temp32[1]);
					rs485ErrorConnect[0] &= ~(temp32[0]);
				}
			}
		}
}
void SCPI_485SlaveFloatInt16(uint8_t cmd ,uint8_t des ,float temp ,int16_t temp1);

// POXBz
void uartChannels(COM_TypeDef COM)
{
	switch(COM)
	{
		case MEASURE_CHANNEL:
		case RS485_CHANNEL:
			if ((actualState == D_NORMAL || actualState == D_VSET || actualState == D_ISET || actualState == D_SHIFT || actualState == PROGRAMRUNNING 
	   		|| actualState == TIMERRUNNING || actualState == PROGRAMREADY || actualState == TIMEREDIT | actualState == D_OVP || actualState == D_OCP || actualState == D_OPP 
			|| actualState == MENUCONFPROTOVP || actualState == MENUCONFPROTOCP || actualState == MENUCONFPROTOPP || actualState == SLEWVOLTAGE || actualState == SLEWCURRENT
			|| actualState == PROGRAMONOFF || actualState == PROGRAMEDIT || actualState == SLEW || actualState == D_PARALLELMASTER || actualState == D_PARALLELSLAVE
			|| actualState == TIMERONOFF  || actualState == STORE || actualState == RECALL || actualState == D_MENU || actualState == MENUCONF1 
			|| actualState == MENUCONFLIMIT || actualState == MENUCONFLIMITVMIN || actualState == MENUCONFLIMITVMAX 
			|| actualState == MENUCONFLIMITIMIN || actualState == MENUCONFLIMITIMAX || actualState == MENUCONFPROT
			|| actualState == MENUCONFPROTOVP || actualState == MENUCONFPROTOCP || actualState == MENUCONFPROTOPP
			|| actualState == MENUCONFPROTCVCC || actualState == MENUCONFPROTCCCV || actualState == MENUINFOMODEL 
			|| actualState == MENUINFOFWVER || actualState == MENUINFOOPT || actualState == MENUINFOIPMODE || actualState == MENUINFOIPADDR
			|| actualState == MENUINFOMASK || actualState == MENUINFOGWAY || actualState == MENUINFOBAUD || actualState == MENUPVS
			|| actualState == MENUPVSCURVE || actualState == MENUPVSEDIT || actualState == MENUPVSEDITRECORD1 || actualState == MENUPVSEDITRECORD2
			|| actualState == MENUPVSEDITRECORD3 || actualState == MENUPVSEDITRECORD4 || actualState == MENUPVSCTRLMOD  
			))	
			{
				if (COM == MEASURE_CHANNEL)
					measure();
				else
				{
					masterSlaveControl();	// rs485 parallel mode
					broadcastQueryVI();		// chain mode master query all slave voltage and current
				}
			}
			if (IS_MEASURE_FAULT)
			{
				CLR_MEASURE_FAULT;
				faultStatus = measureFaultStatus[3];	// MSB first
				faultStatus <<= 8;
				faultStatus |= measureFaultStatus[4]; // LSB
// /* TEST */ 				if (softTimer[MAIN_COUNT].count > 35000 && softTimer[MAIN_COUNT].count < 40000)
//					faultStatus |= BIT5; 
				if (faultStatus != 0)
				{
					displayFresh = 1;
					SET_MB_ERROR; // PFC something error
					if (IS_POWER_OFF)
					{
						SET_POWEROFF_MESSAGE;
					}
					else
					{
						// close any process
						if (IS_NTC_TOO_HIGH)  // temperture too high protect
						{
							programStart = 0;
							programState = 4;	//stop
							if (onoffStatus == ON)
							{
								onoffStatus = OFF;
								verifyInput(OUTPUT_CMD,(float)onoffStatus );
							}
							TIM_Cmd(TIM2, DISABLE);
							if (pvsONOFF == ON)
							{
								pvsONOFF = OFF;
								sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
							}
					        // release remote [local]
							VFDsign &= ~(sign_RMT | sign_ADDR);
							firstWitchCOM = INITCOM;
							firstGpibPacketChannel = INITPACKET;
							if (parallelMode == ON && parallelRole != MASTER && !(outputStatus & ON_STATE))	 // SLAVE
							{
								masterState = 0;slaveState = 0;CLR_SLAVE_CONFIGURED;
								slaveNumber = 0;
								memset((void *)&(uartBuffer[RS485_CHANNEL]) ,0, sizeof(UARTx_BUFFER));
								clearSlaveDUT();
								softTimer[SLAVE_COUNT].flag = DISABLE;
							}							
						}
					}
				}
				else
				{
					if (IS_POWEROFF_MESSAGE)
					{
						displayFresh = 1;
						CLR_POWEROFF_MESSAGE;
						if (IS_BACKUP_SCREEN)
						{
							CLR_MB_ERROR;
						 	CLR_BACKUP_SCREEN;
					     	memcpy((void *)(displayBuffer + 19),(void *)displayBufferTemp,29);
						 	cursorPosition = cursorPositionTemp;
						 	CLR_NUMBER;
						 	softTimer[ERROR_MESSAGE_COUNT].flag = DISABLE;
						}
					}
				}
			}
			break;
		case USB_VCP_CHANNEL:
		case RS232_CHANNEL:
		case GPIB_LAN_CHANNEL:
  			if ((actualState == D_NORMAL || actualState == PROGRAMRUNNING 
	   		|| actualState == TIMERRUNNING || actualState == PROGRAMREADY   
			|| actualState == D_PARALLELMASTER || actualState == D_PARALLELSLAVE))	
			{
				if (parallelMode == ON && parallelRole != MASTER && slaveState == 4) // parallelMode ON and Slave ,interface can't work
				{
					if (uartBuffer[COM].packetCount != 0)  // clear received buffer
					{
						uartBuffer[COM].rxTail = uartBuffer[COM].rxHead;
						uartBuffer[COM].packetCount--;
					}
				}
				else
				{
					if (COM == GPIB_LAN_CHANNEL)
						gpibLan();
					else
						rs232_or_usb(COM);
				}
				CLR_HTTP_DATA_COUNT;
			}
			else
			{
				if (COM == GPIB_LAN_CHANNEL)
				{
					if ( IS_HTTP_DATA_COUNT || httpPacket.count != 0 || httpPacket.count != 0 || port23Packet.count != 0 || port5025Packet.count != 0 || port5024Packet.count != 0)
					{
						CLR_HTTP_DATA_COUNT;	
						returnToNormal(COM);
					}
				}
				else
				{
					if (COM == USB_VCP_CHANNEL)
					{
						if (usb_channel_count != 0)
							returnToNormal(COM);
					}
					else
					{
						if ( uartBuffer[COM].packetCount != 0)	 // تO^ NORMALA
							returnToNormal(COM);
					}
				}
			}
			break;
	}
	
}
	 		


#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
void debugMeasurementIn(void)
{
	uint8_t i ,*Str;
	Str =  &uartBuffer[MEASURE_CHANNEL].simplePacket.head;
	strcpy((void *)usbDebugInBuffer,"UI IN <--");
	for (i = 0 ; i < (uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2)*3 ;i += 3 )
	{
		usbDebugInBuffer[POS + i] = *Str;
		usbDebugInBuffer[POS + i] >>= 4;
		if (usbDebugInBuffer[POS + i] > 9)
			usbDebugInBuffer[POS + i] += 55;
		else
			usbDebugInBuffer[POS + i] += 48;
		usbDebugInBuffer[POS + i + 1] = *Str++;
		usbDebugInBuffer[POS + i + 1] &= 0x0f;
		if (usbDebugInBuffer[POS + i + 1] > 9)
			usbDebugInBuffer[POS + i + 1] += 55;
		else
			usbDebugInBuffer[POS + i + 1] += 48;
		usbDebugInBuffer[POS + i + 2] = ' ';
	}
	usbDebugInBuffer[POS + i] = 0; 
	strcat((void *)usbDebugInBuffer,"\r\n");
	usbCdcTx((void *)usbDebugInBuffer,strlen((void *)usbDebugInBuffer));
}

#endif

#if (_DEBUG_CHANNEL == _DEBUG_GPIB )
void debugGPIBIn(void)
{
	uint8_t i ,*Str;
	Str =  &uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head;
	strcpy((void *)usbDebugInBuffer,"UI IN <--");
	for (i = 0 ; i < (uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 2)*3 ;i += 3 )
	{
		usbDebugInBuffer[POS + i] = *Str;
		usbDebugInBuffer[POS + i] >>= 4;
		if (usbDebugInBuffer[POS + i] > 9)
			usbDebugInBuffer[POS + i] += 55;
		else
			usbDebugInBuffer[POS + i] += 48;
		usbDebugInBuffer[POS + i + 1] = *Str++;
		usbDebugInBuffer[POS + i + 1] &= 0x0f;
		if (usbDebugInBuffer[POS + i + 1] > 9)
			usbDebugInBuffer[POS + i + 1] += 55;
		else
			usbDebugInBuffer[POS + i + 1] += 48;
		usbDebugInBuffer[POS + i + 2] = ' ';
	}
	usbDebugInBuffer[POS + i] = 0; 
	strcat((void *)usbDebugInBuffer,"\r\n");
	usbCdcTx((void *)usbDebugInBuffer,strlen((void *)usbDebugInBuffer));
}

#endif

//uint8_t testtempi;
float	httpData;

// OŪ^ROBz
uint8_t receiveMBResponse(COM_TypeDef COM)
{
	uint8_t testtempj,testtempi;
	if (uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail] == SIMPLE)
	{
		uartBuffer[COM].simplePacket.head = uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail++];
		uartBuffer[COM].simplePacket.length =uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail++];
		for (testtempj = 0; testtempj < uartBuffer[COM].simplePacket.length; testtempj++)
		{
			uartBuffer[COM].simplePacket.payload[testtempj] = uartBuffer[COM].rxBuffer[uartBuffer[COM].rxTail++];
		}
		if (uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] != calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1))
		{	// CRC error
			CRC8ErrorCount++;
			memcpy((void *)(measureFaultStatus + 15) ,(void *)&uartBuffer[COM].simplePacket.head ,uartBuffer[COM].simplePacket.length + 2);
			return(ERR);
		}
		else
		{	// parser command
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
		    debugMeasurementIn();
#elif (_DEBUG_CHANNEL == _DEBUG_GPIB )
			debugGPIBIn();
#endif
	 		for (testtempi = 0; testtempi < uartBuffer[COM].simplePacket.length - 2; testtempi++)
			{
				temps[testtempi] = uartBuffer[COM].simplePacket.payload[testtempi+1];
			}
			temps[testtempi] = 0x00;
			if (COM == MEASURE_CHANNEL)
			{
			
				switch (uartBuffer[COM].simplePacket.payload[0])
				{
					case ACK_CMD:
						pvsTableNumState = 1; // OK
						break;
					case NAK_CMD:
						pvsTableNumState = 0;// not OK
						break;
					case IDNQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen(BOARD_NUMBER) 
																		+ strlen(PRODUCT_CATEGORY_NUMBER) 
																		+ strlen(PRODUCT_SERIES_NUMBER)
																		+ strlen(MAIN_SPEC)
																		+ strlen(CUSTOMER_MODEL_NUMBER)
																		+ strlen(PCB_VERSION)
																		+ strlen(HARDWARE_VER)
																		+ strlen(MAIN_FIRMWARE_VERSION)
																		+ strlen(SECONDARY_FIRMWARE_VERSION)
																		+ 2;
						uartBuffer[COM].simplePacket.payload[0] = IDNR_CMD;
						strcpy((void *)(uartBuffer[COM].simplePacket.payload+1),BOARD_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,PRODUCT_CATEGORY_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,PRODUCT_SERIES_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,MAIN_SPEC);
						strcat((void *)uartBuffer[COM].simplePacket.payload,CUSTOMER_MODEL_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,PCB_VERSION);
						strcat((void *)uartBuffer[COM].simplePacket.payload,HARDWARE_VER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,MAIN_FIRMWARE_VERSION);
						strcat((void *)uartBuffer[COM].simplePacket.payload,SECONDARY_FIRMWARE_VERSION);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case IDNR_CMD:
						if (board == 0x0100)
							memcpy((void *)measurementInf,(void *)(uartBuffer[COM].simplePacket.payload + 1),uartBuffer[COM].simplePacket.length - 2);
						else if (board == 0x0101)
							memcpy((void *)pfcInf,(void *)(uartBuffer[COM].simplePacket.payload + 1),uartBuffer[COM].simplePacket.length - 2);
						break;
					case FULLSCALER_CMD:
						fullScale = atol((void *)temps);
						break;
					case VMAXR_CMD:
						master.vMax = atof((void *)temps);
						break;
					case VMINR_CMD:
						master.vMin = atof((void *)temps);
						break;
					case IMAXR_CMD:	
						master.ratioiMax = master.iMax = atof((void *)temps);
						break;
					case IMINR_CMD:
						master.iMin = atof((void *)temps);
						break;
					case PMAXR_CMD:
						master.pMax = atof((void *)temps);
						break;
					case OVPMAXR_CMD:
						master.OVPMax = atof((void *)temps);
						break;
					case OVPMINR_CMD:
						master.OVPMin = atof((void *)temps);
						break;
					case OCPMAXR_CMD:
						master.OCPMax = atof((void *)temps);
						break;
					case OCPMINR_CMD:
						master.OCPMin = atof((void *)temps);
						break;
					case OPPMAXR_CMD:
						master.OPPMax = atof((void *)temps);
						break;
					case OPPMINR_CMD:
						master.OPPMin = atof((void *)temps);
						break;
					case VSRMAXR_CMD:
						VSRMax = atof((void *)temps);
						break;
					case ISRMAXR_CMD:
						ISRMax = atof((void *)temps);
					    break;
					case VSETR_CMD: // 0x80
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						master.vSet = ((uint16_t)unionbyte.itob[0] * master.vMax) / fullScale;
						master.vSet = roundDigit(master.vSet,voltPoint);
//						sprintf((void *)tempstring,(void *)voltDisp[voltPoint],master.vSet);
//						master.vSet = atof((void *)tempstring);
						break;
					case ISETR_CMD: // 0x83
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						if (specif == V_600)
						{
							if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
							{
								master.iSet = ((uint16_t)unionbyte.itob[0] * master.iMax / fullScale) ;
								master.iSet = roundDigit(master.iSet,currPoint);							
							}
							else
							{
								float buffer , buffer1;
								buffer1 = (uint16_t)unionbyte.itob[0]; 
								buffer = roundDigit(buffer1* 42925 /fullScale ,0);
							 	master.iSet = buffer * around ;
							}
						}
						else
						{
							master.iSet = ((uint16_t)unionbyte.itob[0] * master.iMax / fullScale) ;
							master.iSet = roundDigit(master.iSet,currPoint);
						}
						break;
					case OVPSETR_CMD: // 0x87
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						master.OVPSet = ((uint16_t)unionbyte.itob[0] * master.vMax) / fullScale;
						master.OVPSet = roundDigit(master.OVPSet,voltPoint);
//						sprintf((void *)tempstring,(void *)voltDisp[voltPoint],master.OVPSet);
//						master.OVPSet = atof((void *)tempstring);
						break;
					case OCPSETR_CMD: // 0x89
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						if (specif == V_600)
						{
							float buffer , buffer1;
							buffer1 = (uint16_t)unionbyte.itob[0]; 
							buffer = roundDigit(buffer1 * 42925 /fullScale,0);
						 	master.OCPSet = buffer * around ;
						}
						else
						{
							master.OCPSet = ((uint16_t)unionbyte.itob[0] * master.iMax) / fullScale;
							master.OCPSet = roundDigit(master.OCPSet,currPoint);
						}
//						sprintf((void *)tempstring,(void *)currDisp[currPoint],master.OCPSet);
//						master.OCPSet = atof((void *)tempstring);
						break;
					case OPPSETR_CMD: // 0x8B
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4];
						master.OPPSet = unionbyte.ftob;
						break;
					case VREADR_CMD:
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						vOutADCount = (uint16_t)unionbyte.itob[0];
						oldvOut = master.vOut;
						master.vOut = ((float)unionbyte.itob[0] * master.vMax) / fullScale;
						master.vOut = roundDigit(master.vOut,voltPoint);
						if ((pvsONOFF == ON || IS_PVSSHDSIMMOD_ON ) && outputStatus & ON_STATE)
						{
							master.vSet = master.vOut;
							if (master.vSet < master.limitVMin)
								master.vSet = master.limitVMin;
						}
						break;
					case IREADR_CMD:
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						iOutADCount = (uint16_t)unionbyte.itob[0];
						master.iOut = ((float)unionbyte.itob[0] * master.iMax) / fullScale; 
						if (master.iOut < 0.005) //Fq nø
							master.iOut = 0;
						master.iOut = roundDigit(master.iOut,currPoint);
						master.iOut = round(master.iOut ,around);
						if ((pvsONOFF == ON || IS_PVSSHDSIMMOD_ON ) && outputStatus & ON_STATE)
						{
							master.iSet = master.iOut;
							if (master.iSet < master.limitIMin)
								master.iSet = master.limitIMin;
						}
						break;
					case OUTPUTR_CMD:
					    lastoutputStatus = outputStatus;
					    outputStatus = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
						outputStatus <<= 8;
						outputStatus |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
//	/* TEST */					if (softTimer[MAIN_COUNT].count > 15000 && softTimer[MAIN_COUNT].count < 35000)
//							outputStatus |= OTW_STATE;
						if (lastoutputStatus != outputStatus)
						    displayFresh = 1; // Ÿs
					    break;
					case VSRR_CMD:
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4];
						master.SRvSet = unionbyte.ftob;
						break;
					case ISRR_CMD:
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4];
						master.SRiSet = unionbyte.ftob;
						break;
					case CALPVR_CMD:	// 0xA1
					    calPV =	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
						break;
					case CALPIR_CMD:   // 0xA3
					    calPI =	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
						break;
					case CALVNR_CMD://	0xA6
						if (IS_FAT_CAL)
						{
		                    /* VDAC */
						    vDac[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f)- 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // MSB
							vDac[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] <<= 8;
							vDac[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3]; // LSB
							/* VCAL */
						    vCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4]; // MSB
							vCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] <<= 8;
							vCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5]; // LSB
					    	vMeter = (vCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] * master.vMax)/fullScale;
						}
						else
						{
		                    /* VDAC */
						    vDac[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // MSB
							vDac[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] <<= 8;
							vDac[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3]; // LSB
							/* VCAL */
						    vCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4]; // MSB
							vCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] <<= 8;
							vCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5]; // LSB
					    	vMeter = (vCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] * master.vMax)/fullScale;
						}
						if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
							displayFresh = 1;
					    break;
					case CALINR_CMD: // 0xAA
						if (IS_FAT_CAL)
						{
		                    /* IDAC */
						    iDac[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // MSB
							iDac[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] <<= 8;
							iDac[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3]; // LSB
							/* ICAL */
						    iCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4]; // MSB
							iCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] <<= 8;
							iCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5]; // LSB
					    	iMeter = (iCal[(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] & 0x7f) - 1] * master.iMax)/fullScale;
						}
						else
						{
		                    /* IDAC */
						    iDac[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // MSB
							iDac[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] <<= 8;
							iDac[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3]; // LSB
							/* ICAL */
						    iCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4]; // MSB
							iCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] <<= 8;
							iCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5]; // LSB
					    	iMeter = (iCal[uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] - 1] * master.iMax)/fullScale;
						}
					    if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
							displayFresh = 1;
					    break;
					case VADCR_CMD: // 0xAD
						vAdc = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						vAdc <<= 8;
						vAdc |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // LSB
						if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
							displayFresh = 1;
					    break;
					case IADCR_CMD: // 0xAF
						iAdc = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						iAdc <<= 8;
						iAdc |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // LSB
						if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
							displayFresh = 1;
					    break;
				    case OVPCALSTATER_CMD: // 0xB1
					case FATOVPCALSTATER_CMD:// 0xB5
						ovpCalState = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
						break;					
					case OCPCALSTATER_CMD: // 0xB3
					case FATOCPCALSTATER_CMD: // 0xB7
						ocpCalState = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
						break;
					case DUMPR_CMD:	//0xBB
						switch(uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1])
						{
							case 12:
							case 13:
							case 14:
							case 15:
							case 16:
							case 17:
							case 18:
							case 19:
							case 34:
							case 35:
							case 36:
							case 37:
							case 38:
							case 39:
							case 40:
							case 41:
								unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];	// MSB first
								unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3];
								sprintf((void *)transBuffer	,"%lx\r\n",unionbyte.itob[0]);
								break;
							default:
								unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];	// MSB first
								unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3];
								unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4];	
								unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5];
								sprintf((void *)transBuffer	,"%lx\r\n",unionbyte.ltob);
								break;
						}
						break;

					case FAULTSTATUS2_CMD: // 0xC0  set falutStatus
						faultStatus = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						faultStatus <<= 8;
						faultStatus |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // LSB
						if (faultStatus != 0)
						{
							displayFresh = 1;
							SET_MB_ERROR; // PFC something error
							if (IS_POWER_OFF)
							{
								SET_POWEROFF_MESSAGE;
							}
						}
						else
						{
							if (IS_POWEROFF_MESSAGE)  // when power in again POWER OFF message auto clear
							{
					 			displayFresh = 1;
								CLR_POWEROFF_MESSAGE;
								if (IS_BACKUP_SCREEN)
								{
									CLR_MB_ERROR;
								 	CLR_BACKUP_SCREEN;
							     	memcpy((void *)(displayBuffer + 19),(void *)displayBufferTemp,29);
								 	cursorPosition = cursorPositionTemp;
								 	CLR_NUMBER;
								 	softTimer[ERROR_MESSAGE_COUNT].flag = DISABLE;
								}
							}
						}
						break;
					case FAULTSTATUSQ_CMD: // 0xC1	query faultStatus
						sendMBIntSetting(FAULTSTATUSR_CMD, faultStatus);  // 0xC2
						break;
					case PROTSWR_CMD:
						protsw =	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
						break;
					case RESTOREFACTORYR_CMD:
						restoreFactoryParameter = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
					case RST_CMD:
						initializeMB();
						break;
					case PVSCURVER_CMD: // 0xD7
						curve = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] ;
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5];
						Rule = unionbyte.ftob;
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[9];
						Vmp = unionbyte.ftob;
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[10];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[11];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[12];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[13];
						Pmp = unionbyte.ftob;
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[14];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[15];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[16];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[17];
						Material = unionbyte.ftob;
						break;			
					case PVSSTATER_CMD:	//DA
						pvsONOFF = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];
						curve = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						break;
					case PVSDEFNVIR_CMD: //DC
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2];
						pvsPoint = unionbyte.itob[0];
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6];
						pvsVoltage = unionbyte.ftob;
						unionbyte.byte_loc[3] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7];	// MSB first
						unionbyte.byte_loc[2] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8];
						unionbyte.byte_loc[1] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[9];	
						unionbyte.byte_loc[0] = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[10];
						pvsCurrent = unionbyte.ftob;
						break;						
					case OTWNTCR_CMD:
						NTCStatus = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	// MSB first
						NTCStatus <<= 8;
						NTCStatus |= uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2]; // LSB
						break;
					case PVCTRLMODR_CMD:
						pvCtrlMode = uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1];	  // pv sim control in cc or cv mode
						break;	
					case PVRABCRCR_CMD:
						memcpy( (void *)pvTabCRC ,(void *)(uartBuffer[MEASURE_CHANNEL].simplePacket.payload + 1) ,uartBuffer[MEASURE_CHANNEL].simplePacket.length - 2);
						pvTabCRC[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 2] = 0; // make string
						break;
					case PVSHDBUILDBASICOK_CMD: // E9
						buildBasicCurveOK = 1;
						break;
				}
			}
			else if(COM == GPIB_LAN_CHANNEL)
			{
				float tempGPIB;
				switch (uartBuffer[COM].simplePacket.payload[0])
				{
					case BOOTSTATER_CMD:
						GPIBStatus = uartBuffer[COM].simplePacket.payload[1];
						break;
					case IDNQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen(BOARD_NUMBER) 
																	+ strlen(PRODUCT_CATEGORY_NUMBER) 
																	+ strlen(PRODUCT_SERIES_NUMBER)
																	+ strlen(MAIN_SPEC)
																	+ strlen(CUSTOMER_MODEL_NUMBER)
																	+ strlen(PCB_VERSION)
																	+ strlen(HARDWARE_VER)
																	+ strlen(MAIN_FIRMWARE_VERSION)
																	+ strlen(SECONDARY_FIRMWARE_VERSION)
																	+ 2;
						uartBuffer[COM].simplePacket.payload[0] = IDNR_CMD;
						strcpy((void *)(uartBuffer[COM].simplePacket.payload+1),BOARD_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,PRODUCT_CATEGORY_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,PRODUCT_SERIES_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,MAIN_SPEC);
						strcat((void *)uartBuffer[COM].simplePacket.payload,CUSTOMER_MODEL_NUMBER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,PCB_VERSION);
						strcat((void *)uartBuffer[COM].simplePacket.payload,HARDWARE_VER);
						strcat((void *)uartBuffer[COM].simplePacket.payload,MAIN_FIRMWARE_VERSION);
						strcat((void *)uartBuffer[COM].simplePacket.payload,SECONDARY_FIRMWARE_VERSION);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case IDNR_CMD:
						memcpy((void *)gpibInf,(void *)(uartBuffer[COM].simplePacket.payload + 1),uartBuffer[COM].simplePacket.length - 2);
						break;
					case MODLEQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen((void *)model) + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] = MODLEQ_CMD; //block gpib transmit
						else 
							uartBuffer[COM].simplePacket.payload[0] = MODLER_CMD;
						strcpy((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)model);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case SERIALQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen((void *)serialNumber) + 2;
						if ( IS_GPIB_BLOCK)
							uartBuffer[COM].simplePacket.payload[0] = SERIALQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] = SERIALR_CMD;
						strcpy((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)serialNumber);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case FWVERQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen(MAIN_FIRMWARE_VERSION) + 2;
						if ( IS_GPIB_BLOCK)
							uartBuffer[COM].simplePacket.payload[0] = FWVERQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] = FWVERR_CMD;
						strcpy((void *)(uartBuffer[COM].simplePacket.payload + 1),MAIN_FIRMWARE_VERSION);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case RS232CQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen((void *)rs232p) + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] = RS232CQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] = RS232CR_CMD;
						strcpy((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)rs232p);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case RS485CQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen((void *)rs485p) + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] = RS485CQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] = RS485CR_CMD;						
						strcpy((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)rs485p);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;








					case MANUQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = strlen((void *)manufacture) + 2;
						if ( IS_GPIB_BLOCK)
							uartBuffer[COM].simplePacket.payload[0] = MANUQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] = MANUR_CMD;						
						strcpy((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)manufacture);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case GPIBADDRR_CMD:	  
						GPIBAddr = uartBuffer[COM].simplePacket.payload[1];	  // respones GPIBAddr
						break;
					case IPMODER_CMD:
						LANIPMode = uartBuffer[COM].simplePacket.payload[1];
						break;
					case IPADDRR_CMD:
						LANIPAddr[0] = uartBuffer[COM].simplePacket.payload[1];
						LANIPAddr[1] = uartBuffer[COM].simplePacket.payload[2];
						LANIPAddr[2] = uartBuffer[COM].simplePacket.payload[3];
						LANIPAddr[3] = uartBuffer[COM].simplePacket.payload[4];
						break;
					case MASKADDRR_CMD:
						LANMask[0] = uartBuffer[COM].simplePacket.payload[1];
						LANMask[1] = uartBuffer[COM].simplePacket.payload[2];
						LANMask[2] = uartBuffer[COM].simplePacket.payload[3];
						LANMask[3] = uartBuffer[COM].simplePacket.payload[4];
						break;	
					case GWADDRR_CMD:		
						LANGateway[0] =	uartBuffer[COM].simplePacket.payload[1];
						LANGateway[1] =	uartBuffer[COM].simplePacket.payload[2];
						LANGateway[2] =	uartBuffer[COM].simplePacket.payload[3];
						LANGateway[3] =	uartBuffer[COM].simplePacket.payload[4];
						break;	
					case CURRIPADDRR_CMD:
						currentLANIPAddr[0] = uartBuffer[COM].simplePacket.payload[1];
						currentLANIPAddr[1] = uartBuffer[COM].simplePacket.payload[2];
						currentLANIPAddr[2] = uartBuffer[COM].simplePacket.payload[3];
						currentLANIPAddr[3] = uartBuffer[COM].simplePacket.payload[4];
						break;
					case CURRMASKR_CMD:
						currentLANMask[0] = uartBuffer[COM].simplePacket.payload[1];
						currentLANMask[1] = uartBuffer[COM].simplePacket.payload[2];
						currentLANMask[2] = uartBuffer[COM].simplePacket.payload[3];
						currentLANMask[3] = uartBuffer[COM].simplePacket.payload[4];
						break;	
					case CURRGWR_CMD:		
						currentLANGateway[0] =	uartBuffer[COM].simplePacket.payload[1];
						currentLANGateway[1] =	uartBuffer[COM].simplePacket.payload[2];
						currentLANGateway[2] =	uartBuffer[COM].simplePacket.payload[3];
						currentLANGateway[3] =	uartBuffer[COM].simplePacket.payload[4];
						break;	
					case MACADDRR_CMD:
						MACaddress[0] =	uartBuffer[COM].simplePacket.payload[1];
						MACaddress[1] =	uartBuffer[COM].simplePacket.payload[2];
						MACaddress[2] =	uartBuffer[COM].simplePacket.payload[3];
						MACaddress[3] =	uartBuffer[COM].simplePacket.payload[4];
						MACaddress[4] =	uartBuffer[COM].simplePacket.payload[5];
						MACaddress[5] =	uartBuffer[COM].simplePacket.payload[6];
						break;
					case GPIBVREADQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] = GPIBVREADQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] = GPIBVREADR_CMD;						
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)voltDisp[voltPoint],master.vOut);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;		
					case GPIBIREADQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 7 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  GPIBIREADQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  GPIBIREADR_CMD;						
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)currDisp[currPoint],sumiOut());
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBOVPQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if ( IS_GPIB_BLOCK)
							uartBuffer[COM].simplePacket.payload[0] =  WEBOVPQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBOVPR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)voltDisp[voltPoint],master.OVPSet);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;	
					case WEBOCPQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBOCPQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBOCPR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)currDisp[currPoint],master.OCPSet);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;	
					case WEBOPPQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 7 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBOPPQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBOPPR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),"%7.1f",master.OPPSet);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;	
					case WEBPROTSWQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 1 + 2;
						if ( IS_GPIB_BLOCK)
							uartBuffer[COM].simplePacket.payload[0] =  WEBPROTSWQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBPROTSWR_CMD;	
						uartBuffer[COM].simplePacket.payload[1] = protsw;
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
				    case WEBVSRQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 4 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBVSRQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBVSRR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),"%4.1f",master.SRvSet);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBISRQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBISRQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBISRR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),"%6.2f",master.SRiSet);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBVSETQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBVSETQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBVSETR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)voltDisp[voltPoint],master.vSet);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBISETQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 7 + 2;
						if (IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBISETQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBISETR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)currDisp[currPoint],sumiSet());
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBVMAXQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBVMAXQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBVMAXR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)voltDisp[voltPoint],master.limitVMax);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBVMINQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBVMINQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBVMINR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)voltDisp[voltPoint],master.limitVMin);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBIMAXQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if (IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBIMAXQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBIMAXR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)currDisp[currPoint],master.limitIMax);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBIMINQ_CMD:
						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = 6 + 2;
						if (IS_GPIB_BLOCK)
							uartBuffer[COM].simplePacket.payload[0] =  WEBIMINQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBIMINR_CMD;	
						sprintf((void *)(uartBuffer[COM].simplePacket.payload + 1),(void *)currDisp[currPoint],master.limitIMin);
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
				    case WEBOUTPUTQ_CMD:
 						uartBuffer[COM].simplePacket.head = SIMPLE;
						uartBuffer[COM].simplePacket.length = sizeof(uint16_t) + 2;
						if ( IS_GPIB_BLOCK )
							uartBuffer[COM].simplePacket.payload[0] =  WEBOUTPUTQ_CMD;
						else 
							uartBuffer[COM].simplePacket.payload[0] =  WEBOUTPUTR_CMD;	
						uartBuffer[COM].simplePacket.payload[1]	= (outputStatus >> 8);
						uartBuffer[COM].simplePacket.payload[2]	= outputStatus & 0x00ff;
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
						uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
						break;
					case WEBVSR_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= VSRMIN && tempGPIB <= VSRMax)
						{
							httpData = tempGPIB;
							SET_GPIB_SRVSET_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBISR_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= ISRMIN && tempGPIB <= ISRMax)
						{
							httpData = tempGPIB;
							SET_GPIB_SRISET_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBOVP_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.OVPMin  && tempGPIB <= master.OVPMax)
						{
							httpData = tempGPIB;
							SET_GPIB_OVPSET_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBOCP_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= sumOCPMin() && tempGPIB <= sumOCPMax())
						{
							httpData = tempGPIB;
							SET_GPIB_OCPSET_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBPROTSW_CMD:
						httpData = uartBuffer[COM].simplePacket.payload[1];
						SET_GPIB_PROTSW_PACKET;
						break;
					case WEBOPP_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.OPPMin && tempGPIB <= master.OPPMax)
						{
							httpData = tempGPIB;
							SET_GPIB_OPPSET_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;

					case WEBVMAX_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.vMin && tempGPIB <= master.vMax)
						{
							httpData = tempGPIB;
							SET_GPIB_VMAX_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBVMIN_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.vMin && tempGPIB <= master.limitVMax)
						{
							httpData = tempGPIB;
							SET_GPIB_VMIN_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBIMAX_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.iMin && tempGPIB <= master.iMax)
						{
							httpData = tempGPIB;
							SET_GPIB_IMAX_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBIMIN_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.iMin && tempGPIB <= master.limitIMax)
						{
							httpData = tempGPIB;
							SET_GPIB_IMIN_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;

					case WEBVSET_CMD:
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.limitVMin && tempGPIB <= master.limitVMax)
						{
							httpData = tempGPIB;
							SET_GPIB_VSET_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBISET_CMD:
 						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0; // make string
						tempGPIB = atof((void *)(uartBuffer[COM].simplePacket.payload + 1));
						if (tempGPIB >= master.limitIMin && tempGPIB <= master.limitIMax)
						{
							httpData = tempGPIB;
							SET_GPIB_ISET_PACKET;
							SET_HTTP_DATA_COUNT;
						}
						break;
					case WEBOUTPUTSW_CMD:
						if (uartBuffer[COM].simplePacket.payload[1]	== 1)
							httpData = 1;							
						else
							httpData = 0;
						SET_GPIB_OUTPUTSTATUS_PACKET;
						SET_HTTP_DATA_COUNT;
						break;
					case HTTPSCPIRECEIVE_CMD:	  // http packet received
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0;//'\r';
						for (testtempi = 1 ;uartBuffer[COM].simplePacket.payload[testtempi] != 0 ;testtempi++)
						{			 
							if (uartBuffer[COM].simplePacket.payload[testtempi] == '\r' || uartBuffer[COM].simplePacket.payload[testtempi] == '\n')
							{ 
								if (httpPacket.eof == 0)
								{
									httpPacket.eof = 1;
								  httpPacket.smbuffer[httpPacket.head++] = '\r';
									httpPacket.count++;
								}
							}
							else
							{
								httpPacket.eof = 0;
								httpPacket.smbuffer[httpPacket.head++] = uartBuffer[COM].simplePacket.payload[testtempi];
							}
						}						break;	
					case GPIBSCPIRECEIVE_CMD: // GPIB packet received
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0;//'\r';
						for (testtempi = 1 ;uartBuffer[COM].simplePacket.payload[testtempi] != 0 ;testtempi++)
						{			 
							if (uartBuffer[COM].simplePacket.payload[testtempi] == '\r' || uartBuffer[COM].simplePacket.payload[testtempi] == '\n')
							{ 
								if (gpibPacket.eof == 0)
								{
									gpibPacket.eof = 1;
								  gpibPacket.smbuffer[gpibPacket.head++] = '\r';
									gpibPacket.count++;
								}
							}
							else
							{
								gpibPacket.eof = 0;
								gpibPacket.smbuffer[gpibPacket.head++] = uartBuffer[COM].simplePacket.payload[testtempi];
							}
						}
	
						break;	
					case PORT23SCPIRECEIVE_CMD: // telnet Port23 packet received
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0;//'\r';
						for (testtempi = 1 ;uartBuffer[COM].simplePacket.payload[testtempi] != 0 ;testtempi++)
						{			 
							if (uartBuffer[COM].simplePacket.payload[testtempi] == '\r' || uartBuffer[COM].simplePacket.payload[testtempi] == '\n')
							{ 
								if (port23Packet.eof == 0)
								{
									port23Packet.eof = 1;
								  port23Packet.smbuffer[port23Packet.head++] = '\r';
									port23Packet.count++;
								}
							}
							else
							{
								port23Packet.eof = 0;
								port23Packet.smbuffer[port23Packet.head++] = uartBuffer[COM].simplePacket.payload[testtempi];
							}
						}
						break;
					case PORT5024SCPIRECEIVE_CMD: // telnet Port5024 packet received
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0;//'\r';
						for (testtempi = 1 ;uartBuffer[COM].simplePacket.payload[testtempi] != 0 ;testtempi++)
						{			 
							if (uartBuffer[COM].simplePacket.payload[testtempi] == '\r' || uartBuffer[COM].simplePacket.payload[testtempi] == '\n')
							{ 
								if (port5024Packet.eof == 0)
								{
									port5024Packet.eof = 1;
								  port5024Packet.smbuffer[port5024Packet.head++] = '\r';
									port5024Packet.count++;
								}
							}
							else
							{
								port5024Packet.eof = 0;
								port5024Packet.smbuffer[port5024Packet.head++] = uartBuffer[COM].simplePacket.payload[testtempi];
							}
						}
						break;
					case PORT5025SCPIRECEIVE_CMD: // telnet Port5025 packet received
						uartBuffer[COM].simplePacket.payload[uartBuffer[COM].simplePacket.length - 1] = 0;//'\r';
						for (testtempi = 1 ;uartBuffer[COM].simplePacket.payload[testtempi] != 0 ;testtempi++)
						{			 
							if (uartBuffer[COM].simplePacket.payload[testtempi] == '\r' || uartBuffer[COM].simplePacket.payload[testtempi] == '\n')
							{ 
								if (port5025Packet.eof == 0)
								{
									port5025Packet.eof = 1;
								  port5025Packet.smbuffer[port5025Packet.head++] = '\r';
									port5025Packet.count++;
								}
							}
							else
							{
								port5025Packet.eof = 0;
								port5025Packet.smbuffer[port5025Packet.head++] = uartBuffer[COM].simplePacket.payload[testtempi];
							}
						}
						break;




					case ERRR_CMD:
						GPIBerrorStatus = uartBuffer[COM].simplePacket.payload[1];
						break;
					default:
//						uartBuffer[witchCOM].rxTail = uartBuffer[witchCOM].rxHead; // clear buffer
						break;
							
				}
			}
		}	
	}
	return(0);	// received okay
}
uint8_t temp2[10];
uint16_t convertFloatToInt(float value, float maxValue, uint16_t maxCount)
{	// value = the value to be converted, maxValue = full scale value, maxCount = maximum full scale count in int16
	float temp;
	uint16_t temp1;
	temp = value * maxCount;
	temp /= maxValue;
	temp1 = roundDigit(temp,0);
//	sprintf((void *)temp2,"%6.0f",temp);
//	temp1 = atoi((void *)temp2);
	return temp1;
}
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
void debugMeasurementOut(void)
{
	uint8_t i ,*Str;
	Str =  &uartBuffer[MEASURE_CHANNEL].simplePacket.head;
	strcpy((void *)usbDebugOutBuffer,"UI OUT-->");
	for (i = 0 ; i < (uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2)*3 ;i += 3 )
	{
		usbDebugOutBuffer[POS + i] = *Str;
		usbDebugOutBuffer[POS + i] >>= 4;
		if (usbDebugOutBuffer[POS + i] > 9)
			usbDebugOutBuffer[POS + i] += 55;
		else
			usbDebugOutBuffer[POS + i] += 48;
		usbDebugOutBuffer[POS + i + 1] = *Str++;
		usbDebugOutBuffer[POS + i + 1] &= 0x0f;
		if (usbDebugOutBuffer[POS + i + 1] > 9)
			usbDebugOutBuffer[POS + i + 1] += 55;
		else
			usbDebugOutBuffer[POS + i + 1] += 48;
		usbDebugOutBuffer[POS + i + 2] = ' ';
	}
	usbDebugOutBuffer[POS + i] = 0; 
	strcat((void *)usbDebugOutBuffer,"\r\n");

	usbCdcTx((void *)usbDebugOutBuffer,strlen((void *)usbDebugOutBuffer));
}

#endif

#if (_DEBUG_CHANNEL == _DEBUG_GPIB )
void debugGPIBOut(void)
{
	uint8_t i ,*Str;
	Str =  &uartBuffer[GPIB_LAN_CHANNEL].simplePacket.head;
	strcpy((void *)usbDebugOutBuffer,"UI OUT-->");
	for (i = 0 ; i < (uartBuffer[GPIB_LAN_CHANNEL].simplePacket.length + 2)*3 ;i += 3 )
	{
		usbDebugOutBuffer[POS + i] = *Str;
		usbDebugOutBuffer[POS + i] >>= 4;
		if (usbDebugOutBuffer[POS + i] > 9)
			usbDebugOutBuffer[POS + i] += 55;
		else
			usbDebugOutBuffer[POS + i] += 48;
		usbDebugOutBuffer[POS + i + 1] = *Str++;
		usbDebugOutBuffer[POS + i + 1] &= 0x0f;
		if (usbDebugOutBuffer[POS + i + 1] > 9)
			usbDebugOutBuffer[POS + i + 1] += 55;
		else
			usbDebugOutBuffer[POS + i + 1] += 48;
		usbDebugOutBuffer[POS + i + 2] = ' ';
	}
	usbDebugOutBuffer[POS + i] = 0; 
	strcat((void *)usbDebugOutBuffer,"\r\n");

	usbCdcTx((void *)usbDebugOutBuffer,strlen((void *)usbDebugOutBuffer));
}

#endif



void sendMBCalSetting(uint8_t cmd ,uint8_t value1,uint16_t value2)
{
	unionbyte.itob[0] = value2;
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x05;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1]	= value1;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[1];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
	debugMeasurementOut();
#endif     

}

void sendMBIntSetting(uint8_t cmd, uint16_t value)
{
	unionbyte.itob[0] = value;
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x04;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[1];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
	debugMeasurementOut();
#endif
}

void sendMBIntSettingFloatInt16(uint8_t cmd, float value ,uint16_t value1)
{
	unionbyte.ftob= value;
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(float) + sizeof(int16_t);
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[3];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[1];	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[0];
	unionbyte.itob[0] = value1;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = unionbyte.byte_loc[1];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
}

void sendMBIntSettingFloatFloat(uint8_t cmd, float value ,float value1)
{
	unionbyte.ftob= value;
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(float) + sizeof(float);
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[3];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[1];	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[0];
	unionbyte.ftob = value1;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = unionbyte.byte_loc[3];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7] = unionbyte.byte_loc[1];	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8] = unionbyte.byte_loc[0];

	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
}

void sendMBIntSettingInt8Int8(uint8_t cmd, int8_t value ,int8_t value1)
{
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(int8_t) + sizeof(int8_t);
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = value;	// 
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = value1;	// 
 	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
}



void sendMBIntSettingQuater(uint8_t cmd, uint32_t value)	 // 1/4 count to E7 board
{
	uint8_t temp = 0;
	uint32_t temp1 = 0;
	temp1 = value;
	temp1 &= 0x00000003;
	temp = temp1;
	temp <<= 5; 
	unionbyte.itob[0] = value >> 2;
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x04 | 0x80 | temp;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[1];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, 4 + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, 4 + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
	debugMeasurementOut();
#endif
}

void sendMBFloatSetting(uint8_t cmd, float value)
{
	unionbyte.ftob = value;
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x06;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[3];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[1];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
	debugMeasurementOut();
#endif
}

void sendMBTwoIntSetting(uint8_t cmd, uint16_t value1, uint16_t value2)
{
	unionbyte.itob[0] = value1;
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x06;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = cmd;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[1];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[0];
	unionbyte.itob[0] = value2;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[1];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
	debugMeasurementOut();
#endif
}

void sendMBStateSetting(COM_TypeDef COM,uint8_t cmd, uint8_t state)
{
	uartBuffer[COM].simplePacket.head = SIMPLE;
	uartBuffer[COM].simplePacket.length = 0x03;
	uartBuffer[COM].simplePacket.payload[0] = cmd;
	uartBuffer[COM].simplePacket.payload[1] = state;
	uartBuffer[COM].simplePacket.payload[2] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
	uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
		    debugMeasurementOut();
#elif (_DEBUG_CHANNEL == _DEBUG_GPIB )
			debugGPIBOut();
#endif
}


void sendGBStateSetting(COM_TypeDef COM,uint8_t cmd, uint8_t state1,uint8_t state2,uint8_t state3 ,uint8_t state4)
{
	uartBuffer[COM].simplePacket.head = SIMPLE;
	uartBuffer[COM].simplePacket.length = 0x06;
	uartBuffer[COM].simplePacket.payload[0] = cmd;
	uartBuffer[COM].simplePacket.payload[1] = state1;
	uartBuffer[COM].simplePacket.payload[2] = state2;
	uartBuffer[COM].simplePacket.payload[3] = state3;
	uartBuffer[COM].simplePacket.payload[4] = state4;
	uartBuffer[COM].simplePacket.payload[5] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
	uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
		    debugMeasurementOut();
#elif (_DEBUG_CHANNEL == _DEBUG_GPIB )
			debugGPIBOut();
#endif
}


void sendMBQuery(COM_TypeDef COM,uint8_t cmd)
{
	uartBuffer[COM].simplePacket.head = SIMPLE;
	uartBuffer[COM].simplePacket.length = 0x02;
	uartBuffer[COM].simplePacket.payload[0] = cmd;
	uartBuffer[COM].simplePacket.payload[1] = calculateCrc8(&uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 1);
	uartTransmit(COM, &uartBuffer[COM].simplePacket.head, uartBuffer[COM].simplePacket.length + 2);
#if (_DEBUG_CHANNEL == _DEBUG_MEASUREMENT )
		    debugMeasurementOut();
#elif (_DEBUG_CHANNEL == _DEBUG_GPIB )
			debugGPIBOut();
#endif
}


void intoFlyCursor(void)
{
							if (onoffStatus)
							{
//								if (outputStatus & CV_STATE)
								if (VFDsign & sign_CV)
								{
									cursorPosition = 0x46;
									setInputParameter(0x41,6,FLOAT,LIMIT_COMPARE ,master.limitVMax ,master.limitVMin); 
									sprintf((void *)keyInBuffer,(void *)voltDisp[voltPoint],master.vSet);
									setOnTheFly();
									if (actualState == D_SHIFT)
										SET_FIX_CURSOR;
								}
								else if(VFDsign & sign_CC)
//								else if(outputStatus & CC_STATE)
								{
									cursorPosition = 0x50;
									setInputParameter(0x4A,7,FLOAT,LIMIT_COMPARE ,sumlimitIMax() ,sumlimitIMin());
									sprintf((void *)keyInBuffer,(void *)currDisp[currPoint],sumiSet());
									setOnTheFly();
									if (actualState == D_SHIFT)
										SET_FIX_CURSOR;
								}
								shiftStatus = 0;
								VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
								actualState = D_NORMAL;
							}
}


float     tempff;
uint32_t  tempint;
state_id nextState;
// AŪ^
void processEvent(trigger_id event)
{
	uint8_t i,flagtemp = 0;
    CLR_CHANGE;
    switch (keyParameter.keyFunction)
	{
		case KEY_FUNCTION:
	        if (event < numberOfTriggers)
	        {
				if (keyType == KEY23)
	    	        nextState = next_state23[actualState * numberOfTriggers + event];
				else
					nextState = next_state29[actualState * numberOfTriggers + event];
                if (nextState == actualState)
                {  //state not change
                }
                else
                {  //state changed
				    lastLastLastState = lastLastState;
				    lastLastState = lastState;
                    lastState = actualState;
                    actualState = nextState;
                    SET_CHANGE; 

#ifndef		MB_NOT_IN 
					if (lastState == D_SHIFT)
						clearMeasureCommand();//Nbuffer Bzʥ] M
#endif				
					if (parallelMode == ON && parallelRole == MASTER && (masterState > 0 && masterState <= SHOWFOUNDSLAVE) )
					{
						if (masterState == 1 && (event == KEY_ESC || event == KEY_MENU))
							CLR_PARALLELMODE_SLAVE_NOT_FOUND;  // bMASTER U䤣slave (SLAVE NOT FOUND \ ESC ,MENUާ@)
						else
						{
							reverseState();		 //p ܪAU  קKn~
							CLR_CHANGE;
						}
					}
                }
		    }
			else
			{
				if (keyParameter.keyEvent == KEY_SELFTEST)
				{
				    lastLastLastState = lastLastState;
				    lastLastState = lastState;
                    lastState = actualState;
                    actualState = SELFTEST1;
					setVFDFlashOff(0x40, 48);
					SET_CHANGE;

				}
				else if	(keyParameter.keyEvent == KEY_NORMAL) // ^
				{
				    lastLastLastState = lastLastState;
				    lastLastState = lastState;
                    lastState = actualState;
				    cursorPosition = 0;
					VFDsign &= 0xFFFF0000;
                    actualState = D_NORMAL;
					SET_CHANGE;
				}
				else if(keyParameter.keyEvent == KEY_DEBUG)
				{
					SET_DEBUG;
					shiftStatus = 0;
					VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
					reverseState();
				}
			}
			break;
		case KEY_NUMERICAL:
		    if (IS_STRING == 0) //Drק
			{
		        switch(actualState)
			    {
				    case PASSWORD:
					    if (keyParameter.keyEvent != KEY_DP) //LpI\
						{
							if (passwordLength == 5)
							{
							    passwordLength = 0;
								cursorPosition = 0x6A;
								memcpy((void *)(displayBuffer + 19 + 23),"     ",5);
							}
							displayBuffer[19 + 23 + passwordLength] = '*';
							keyInBuffer[passwordLength] = keyParameter.keyEvent + 0x30;
							passwordLength++;
							cursorPosition++;
						}
					    break;
				    case PROGRAMREPEAT:
					    if (cursorPatternPosition == 1)	 // linkNumberGroup
						{
						    inputNumerical();
							if (keyInBuffer[0] == '0')	  //o  0  NONE ,lƦr`
							{
							    memcpy((void *)(displayBuffer + numericalInput.startAddress	- 0x40) ,"NONE",4);
								setVFDFlashOn(numericalInput.startAddress, 4);
								cursorPosition = 0;
							}
							else
							{
							    memcpy((void *)(displayBuffer + numericalInput.startAddress	- 0x40 + 1) ,"   ",3);
								setVFDFlashOn(numericalInput.startAddress, 4);
							}
						}
						else
					        inputNumerical();
					    break;
//					case MENUPVSEDITRECORD1:
					case MENUPVSEDITRECORD2:
					case MENUPVSEDITRECORD3:
//					case MENUPVSEDITRECORD4:
				    case PROGRAMEDIT:
					case TIMEREDIT:
					case MENUSYSMEMG:
				    case MENUSYSCOMMGPIBADDR:
					case MENUPVSCURVE:
					case MENUCONFCHAINADDR:
				    case MENUSYSCOMMLANIPADDR:	   // LAN IP ADDR setting
					case MENUSYSCOMMLANMASK:
					case MENUSYSCOMMLANGWAY:
					case MENUSYSPONUDEFV:
					case MENUSYSPONUDEFI: 
                    case MENUCONFLIMITVMIN:
                    case MENUCONFLIMITVMAX:
                    case MENUCONFLIMITIMIN:
				    case MENUCONFLIMITIMAX:
                    case MENUCONFLIMITPMIN:
                    case MENUCONFLIMITPMAX:
					case SLEWVOLTAGE:
					case SLEWCURRENT:
					case CALVOLTAGE:
					case CALCURRENT:
					case EXTCALVOLTAGE:
					case EXTCALCURRENT:
					case EXTCALRESVOLTAGE:
					case EXTCALRESCURRENT:
					case TESTEXTVOLT:
					case TESTEXTCURR:
					case TESTEXTVCC:
					case TESTEXTICC:
					case STORE:
					case D_VSET:
					case D_ISET:
					case D_OVP:
					case D_OCP:
					case D_OPP:
					    inputNumerical();
					    break;
					case RECALL:
						if (IS_NUMBER == 0)
						{
	  						bkvSet = master.vSet;
							bkiSet = master.iSet;
							bkOVPSet = master.OVPSet;
							bkOCPSet = master.OCPSet;
							bkOPPSet = master.OPPSet;
						}
					    inputNumerical();
						recall(keyInBuffer[0] - 48);
						break;
				    case PROGRAMMODE:
					    if (cursorPatternPosition == 1)
						{
						    if (keyParameter.keyEvent != KEY_N0)  // PROGRAM FUNC  PROGRAMѼ(programGroup) OOq 1 ~ 9 
							{									  // ] 0䤣 ҥH 0}|OŪ 
						        menuLevel1 = 0;
							    inputNumerical();
							}
						}
					    break;
				}
			}
			break;
		case KEY_DIRECTION:
		    switch(keyParameter.keyEvent)	 // KEY_LT ,KEY_RT,KEY_RT,KEY_DN
			{
			    case KEY_LT:
				   	if (IS_SETTING)
					{
			    		if (IS_STRING == 0)
						{
				    		switch(actualState)
							{
							    case PROGRAMREPEAT:
								    if (IS_NUMBER == 0)
									{
								    	cursorPatternPosition = 0;
										setInputParameter(0x5A,2,INTEGER,NULL , PROGRAM_REPEAT_MAX , PROGRAM_REPEAT_MIN);
										sprintf(KEYINBUF,"%.2d",repeatGroup[programGroup]);
										sprintf((void *)(displayBuffer + 19 + 7),"%.2d",repeatGroup[programGroup]);								    
									}
									break;
								case MENUPVSEDITRECORD2:
								case MENUPVSEDITRECORD1:
									if (IS_NUMBER == 0)
									{
										actualState = MENUPVSEDITRECORD1;
										setInputParameter(0x53 + 6,1,INTEGER,NULL ,9 , 0);
										sprintf(KEYINBUF,"%1d",(uint8_t)Rule);
									}
									break;
								case MENUPVSEDITRECORD3:
									if (IS_NUMBER == 0)
									{
										actualState = MENUPVSEDITRECORD2;
										setInputParameter(0x53 + 20,6, FLOAT ,LIMIT_COMPARE ,master.limitVMax * 0.95,master.limitVMin);
										memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer) ,29) ;
										sprintf(KEYINBUF,(void *)voltDisp[voltPoint],Vmp);
									}
									break;
								case MENUPVSEDITRECORD4:
									if (IS_NUMBER == 0)
									{
										actualState = MENUPVSEDITRECORD3;
										setInputParameter(0x53 + 6,6, FLOAT ,LIMIT_COMPARE , /* master.pMax */sumpMax()  * 0.9,/*master.limitIMin*/ sumlimitIMin() * master.limitVMin );
										sprintf(KEYINBUF,(void *)powDisp[powPoint],Pmp * (slaveNumber + 1));
									}
									break;
							    case PROGRAMEDIT:
								    if (IS_NUMBER == 0)
									{
										setVFDFlashOff(0x40,48);
								    	cursorPatternPosition--;
										if  ((int8_t)cursorPatternPosition < 0)
									    	cursorPatternPosition = 0;
										switch(cursorPatternPosition)
										{
									    	case 0:
												setInputParameter(0x4C,3, INTEGER ,NULL ,PROGRAM_STEP_MAX , PROGRAM_STEP_MIN);
											    sprintf(KEYINBUF,"%.3d",step + 1);
									 			break;
									    	case 1:
												actualState = PROGRAMEDITACT;
												parameterTemp = *(uint8_t *)(programParameter + PROG_ACT);
												setVFDFlashOn(0x50,3);
										    	cursorPosition = 0;
												CLR_NUMBER;
												SET_STRING;
										    	break;
											case 2:
												setInputParameter(0x55,6, FLOAT ,LIMIT_COMPARE ,master.limitVMax ,master.limitVMin);	 // voltage parameter
											    sprintf(KEYINBUF,(void *)voltDisp[voltPoint],master.vSet);
										    	break;	  
									    	case 3:
												setInputParameter(0x5F,7, FLOAT ,LIMIT_COMPARE ,master.limitIMax ,master.limitIMin);	 // current parameter
											    sprintf(KEYINBUF,(void *)currDisp[currPoint],master.iSet);
										    	break;
										}
									}
								    break;
								case PROGRAMEDITACT:
									cursorPatternPosition = 0;
									sprintf(KEYINBUF,"%.3d",step + 1);
									setVFDFlashOff(0x40,48);
									setInputParameter(0x4C,3,INTEGER,NULL ,STEPMAX , 1);
									actualState = PROGRAMEDIT;
									CLR_STRING;
								  	break;
							    case PASSWORD:
								case PROGRAMREADY:
								    break;
							    case TIMEREDIT:
								    if (IS_NUMBER == 0)
									{
										setVFDFlashOff(0x40,48);
								    	switch(cursorPatternPosition)
										{
									    	case 0:
										    	setInputParameter(0x59,3,INTEGER,NULL ,999 , 0); // HR parameter
												setVFDFlashOn(0x59,3);
										    	break;
											case 1:
										    	if (atoi(KEYINBUF) > numericalInput.intMax)
												{
											    	memcpy((void *)(displayBuffer + 19 +9),"59",2);
													strcpy(KEYINBUF,"59");
												}
												setInputParameter(0x59,3,INTEGER,NULL ,59 , 0); // HR parameter	
												setVFDFlashOn(0x59,3);
										    	break;
											case 2:
										    	if (atoi(KEYINBUF) > numericalInput.intMax)
												{
											    	memcpy((void *)(displayBuffer + 19 + 16),"59",2);
													strcpy(KEYINBUF,"59");
												}
												setInputParameter(0x60,2,INTEGER,NULL , 59 , 0); // min parameter
												setVFDFlashOn(0x60,2);	
										    	break;
										}

								    	cursorPatternPosition--;
										if ((int8_t)cursorPatternPosition < 0)
											cursorPatternPosition = 0;
										cursorPosition = 0x5B + cursorPatternPosition * 6;
//										setVFDFlashOff(0x40,48);
										CLR_NUMBER;
										CLR_STRING;
									}
									break;	 
							    case MENUSYSMEMG:
								    break; // nothing
					    		case MENUSYSCOMMLANIPADDR:
								case MENUSYSCOMMLANMASK:
								case MENUSYSCOMMLANGWAY:
								    if (atoi(KEYINBUF) < 256)
									{
									    switch(actualState)
										{
								            case MENUSYSCOMMLANIPADDR:
											    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition > 0)
								                    memSysCommIpPosition--; //shift right
												sprintf(KEYINBUF ,"%.3d",LANIPAddrTemp[memSysCommIpPosition ]);
												break;
								            case MENUSYSCOMMLANMASK:
											    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition > 0)
								                    memSysCommIpPosition--; //shift right
												sprintf(KEYINBUF ,"%.3d",LANMaskTemp[memSysCommIpPosition ]);
												break;
								            case MENUSYSCOMMLANGWAY:
											    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition > 0)
								                    memSysCommIpPosition--; //shift right
												sprintf(KEYINBUF ,"%.3d",LANGatewayTemp[memSysCommIpPosition ]);
												break;
								        }
									}
									else
									{
									    strcpy(KEYINBUF,"255");
									    switch(actualState)
										{
								            case MENUSYSCOMMLANIPADDR:
											    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								            case MENUSYSCOMMLANMASK:
											    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								            case MENUSYSCOMMLANGWAY:
											    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								        }										
										memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3);
									}
									setVFDFlashOff(0x40,48);
       								setInputParameter(0x60 + (memSysCommIpPosition * 4),3,INTEGER,PT_SHIFT_RIGHT ,255, 0);
									break;
                                case MENUCONFLIMITVMIN:
                                case MENUCONFLIMITVMAX:
                                case MENUCONFLIMITIMIN:
                                case MENUCONFLIMITIMAX:
                                case MENUCONFLIMITPMIN:
                                case MENUCONFLIMITPMAX:
								case SLEWCURRENT:
								case SLEWVOLTAGE:
								    if (IS_NUMBER == 0)
								    {
					            	    cursorPosition--;
					            	    if (keyInBuffer[cursorPosition - numericalInput.startAddress] == '.') 
					                	    cursorPosition--;
					            	    if(cursorPosition < numericalInput.startAddress)
					                	    cursorPosition = numericalInput.startAddress + numericalInput.length - 1;
									    spaceToZero(numericalInput.startAddress);
								    }
								break;
								case MENUCONFCHAINADDR:
								case MENUSYSCOMMGPIBADDR:
 								    if (IS_NUMBER == 0)
								    {
					            	    cursorPosition--;
					            	    if(cursorPosition < 0x5F) 
					                	    cursorPosition = 0x60;
								    }
								    break;
								case MENUPVSCURVE:
 								    if (IS_NUMBER == 0)
								    {
					            	    cursorPosition--;
					            	    if(cursorPosition < (0x53 + 17)) 
					                	    cursorPosition = 0x53 + 19;
								    }
									break;
								case RECALL:
								case STORE:
								    break;
								case PROGRAMMODE:
									setVFDFlashOff(0x40,48);
								    cursorPatternPosition--;
									if ((int8_t)cursorPatternPosition < 0)
									    cursorPatternPosition = 0;
									switch(cursorPatternPosition)
									{
										case 0:
											actualState = PROGRAMONOFF;
											setVFDFlashOn(0x56  ,3);
											SET_STRING;
											cursorPosition = 0;
											break;
										case 1:
									    	sprintf(KEYINBUF,"%.1d",programGroup);
											setInputParameter(0x65,1,INTEGER,NULL , 9 , 1);	 // programGroup parameter
											CLR_STRING;
											break;
									}
								    break;
								case D_NORMAL:
									//if (outputStatus & CV_STATE || outputStatus & CC_STATE)
									if (VFDsign & sign_CV || VFDsign & sign_CC)
										setOnTheFly();
					    		default:
								    if (IS_NUMBER == 0)
								    {
					            	    cursorPosition--;
					            	    if (keyInBuffer[cursorPosition-numericalInput.startAddress] == '.') 
					                	    cursorPosition--;
					            	    if(cursorPosition < numericalInput.startAddress) 
					                	    cursorPosition = numericalInput.startAddress + numericalInput.length - 1;
					            	    spaceToZero(numericalInput.startAddress);
								    }
								    break;
					 		}
						}
						else //  IS_STRING = 1
						{
						    switch(actualState)
							{
							    case TIMERONOFF:
								    cursorPatternPosition = 2;
									sprintf(KEYINBUF,"%.2d",timerSE);
									setVFDFlashOff(0x40,48);
									actualState = TIMEREDIT; setVFDFlashOn(0x66,2);
									setInputParameter(0x66,2,INTEGER,NULL , 59 , 0);	 // second parameter
								    break;
								case MENUPVSEDIT:
									setVFDFlashOff(0x40,48);
									setVFDFlashOn(0x53+16,5);
									cursorPatternPosition = 1;
									parameterTemp = curve;
									SET_STRING;
									actualState = MENUPVSCURVE;
									break;
								case MENUPVSCURVE:
									setVFDFlashOff(0x40,48);
									parameterTemp = pvsONOFF;
									setVFDFlashOn(0x53+3,3);
									cursorPatternPosition = 0;
									SET_STRING;
									actualState = MENUPVS;
									break;
							    case PROGRAMMODE:
								case PROGRAMONOFF:
									setVFDFlashOff(0x40,48);
								    cursorPatternPosition--;
									if ((int8_t)cursorPatternPosition < 0)
									    cursorPatternPosition = 0;
									switch(cursorPatternPosition)
									{
										case 0:
											actualState = PROGRAMONOFF;
											setVFDFlashOn(0x56  ,3);
											SET_STRING;
											break;
										case 1:
									    	sprintf(KEYINBUF,"%.1d",programGroupTemp);
											setInputParameter(0x65,1,INTEGER,NULL , 9 , 1);	 // programGroup parameter
											CLR_STRING;
											break;
									}
								    break;
								case PROGRAMEDITACT:
									cursorPatternPosition = 0;
									setVFDFlashOff(0x40,48);
									setInputParameter(0x4C,3,INTEGER,NULL ,STEPMAX , 1);	 // step parameter
								    sprintf(KEYINBUF,"%.3d",step + 1);
									actualState = PROGRAMEDIT;
									CLR_STRING;
								  	break;
							}
						}
					} 
					else  //IS_SETTING == 0
					{	

			    		if (actualState >= D_MENU && actualState <= MENUSYSPON )
						{
    			    		setVFDFlashOff(0x40, 0x30);
				    		if (cursorPatternPosition > 0)
					    		cursorPatternPosition--;
							flashBlock(0);
							if (actualState == D_MENU)	 // MENU
							{
					    		menuLevel1 = 0;menuLevel2 = 0;menuLevel3 = 0;menuLevel4 = 0;
							}
							else if(actualState == MENUCONF1 || actualState == MENUSYS1)
							{
								menuLevel3 = 0;menuLevel4 = 0;
							}
							else if(actualState == MENUSYSCOMM)
								menuLevel4 = 0;
						}
						else if(actualState >=  MENUINFOMODEL && actualState <= MENUCONFCHAINADDR) // ﶵ½
						{
							setVFDFlashOff(0x40, 0x30);
				    		if (cursorPatternPosition > 0)
							{
					    		cursorPatternPosition--;
								lastLastLastState = lastLastState;
								lastLastState = lastState;
								lastState = actualState;
								actualState--;
							}
							for ( i = 0 ; i < 29 ; i++)
					    		displayBuffer[19+i] = menuItemBuffer[cursorPatternPosition*29+i];
							setVFDFlashOn(flashPosition[cursorPatternPosition], flashLength[cursorPatternPosition]);
						}
						else if (actualState == D_NORMAL || actualState == D_SHIFT )
						{
							intoFlyCursor();
						} 
					}
					break;
				case KEY_RT:
				   	if (IS_SETTING)
					{
			    		if (IS_STRING == 0)
						{
				    		switch(actualState)
							{
							    case PROGRAMREPEAT:
								    if (IS_NUMBER == 0)
									{
								    	cursorPatternPosition = 1;
										setInputParameter(0x6A,1,INTEGER,NULL , 9 , 0); // linkNumberGroup parameter
										sprintf(KEYINBUF,"%.1d",linkNumberGroup[programGroup]);
										if ( linkNumberGroup[programGroup] == 0)
											sprintf((void *)(displayBuffer + 19 + 23),"NONE");
										else
											sprintf((void *)(displayBuffer + 19 + 23),"%.1d",linkNumberGroup[programGroup]);
								    }
									break;
								case MENUPVSEDITRECORD1:
									if (IS_NUMBER == 0)
									{
										actualState = MENUPVSEDITRECORD2;
										setInputParameter(0x53 + 20,6, FLOAT ,LIMIT_COMPARE ,master.limitVMax * 0.95 ,master.limitVMin);
										sprintf(KEYINBUF,(void *)voltDisp[voltPoint],Vmp);
									}
									break;
								case MENUPVSEDITRECORD2:
									if (IS_NUMBER == 0)
									{
										actualState = MENUPVSEDITRECORD3;
										setInputParameter(0x53 + 6,6, FLOAT ,LIMIT_COMPARE ,/* master.pMax */sumpMax() * 0.9,master.limitVMin * sumlimitIMin()/* master.limitIMin */);
										memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer + 29) ,29) ;
										sprintf(KEYINBUF,(void *)powDisp[powPoint],Pmp * (slaveNumber + 1));
									}
									break;
								case MENUPVSEDITRECORD3:
								case MENUPVSEDITRECORD4:
									if (IS_NUMBER == 0)
									{
										actualState = MENUPVSEDITRECORD4;
										setInputParameter(0x53 + 21,1,INTEGER  ,LIMIT_COMPARE , 9, 0);
										sprintf(KEYINBUF,"%1d",(uint8_t)Material);
									}
									break;
								case PROGRAMONOFF:
							    case PROGRAMREADY:
									break;
							    case PROGRAMEDIT:
								    
								    if (IS_NUMBER == 0)
									{
										setVFDFlashOff(0x40,48);
									    cursorPatternPosition++;
										if ( cursorPatternPosition > 4)
										    cursorPatternPosition = 4;
										switch(cursorPatternPosition)
										{
										    case 1:
												actualState = PROGRAMEDITACT;
												parameterTemp = *(uint8_t *)(programParameter + PROG_ACT);
												setVFDFlashOn(0x50,3);
										    	cursorPosition = 0;
												CLR_NUMBER;
												SET_STRING;
											    break;
										    case 3:
												setInputParameter(0x5F,7, FLOAT ,LIMIT_COMPARE ,master.limitIMax , master.limitIMin); // current parameter
											    sprintf(KEYINBUF,(void *)currDisp[currPoint],current);
											    break;
											case 4:
												setInputParameter(0x69,6, FLOAT ,NULL ,6000 , 0);	 // timer parameter
												sprintf(KEYINBUF,"%5.1f",timer);
											    break;	  
										}
									}
								    break;
							    case PROGRAMMODE:
								    if (IS_NUMBER == 0)
									{
								        setVFDFlashOff(0x40,48);
								        cursorPatternPosition++;
									    if (cursorPatternPosition > 2)
									        cursorPatternPosition = 2;
									    setVFDFlashOn(0x6B ,4);
									    cursorPosition = 0;
									    SET_STRING;
									}
								    break;
							    case PASSWORD:
								    break;
							    case TIMEREDIT:
								    if (IS_NUMBER == 0)
									{
										setVFDFlashOff(0x40,48);
								    	switch(cursorPatternPosition)
										{
									    	case 0:
											    setInputParameter(0x60,2,INTEGER,NULL ,59 , 0); // min parameter
												setVFDFlashOn(0x60 , 2);
										    	break;
											case 1:
												sprintf(KEYINBUF,"%2d",timerMN);
										    	if (atoi(KEYINBUF) > numericalInput.intMax)
												{
											    	memcpy((void *)(displayBuffer + 19 +9),"59",2);
													strcpy(KEYINBUF,"59");
												}
												setInputParameter(0x66,2,INTEGER,NULL ,59 , 0); // sec parameter
												setVFDFlashOn(0x66 , 2);	
										    	break;
											case 2:
												sprintf(KEYINBUF,"%2d",timerSE);
										    	if (atoi(KEYINBUF) > numericalInput.intMax)
												{
											    	memcpy((void *)(displayBuffer + 19 + 16),"59",2);
													strcpy(KEYINBUF,"59");
												}
//												setVFDFlashOn(0x6D , 3);	
										    	break;
										}
								    	cursorPatternPosition++;
										if (cursorPatternPosition > 3)
											cursorPatternPosition = 3;
//										setVFDFlashOff(0x40,48);
										if (cursorPatternPosition == 3)
										{
											setVFDFlashOn(0x5B + (cursorPatternPosition * 6),3);
									    	cursorPosition = 0;
											actualState = TIMERONOFF;
											SET_STRING;
										}
										else
									    	cursorPosition = 0x5B + cursorPatternPosition * 6;
										CLR_NUMBER;
									}
									break;	 
							    case MENUSYSMEMG:
								    break; // nothing
					    		case MENUSYSCOMMLANIPADDR:
								case MENUSYSCOMMLANMASK:
								case MENUSYSCOMMLANGWAY:
								    if (atoi(KEYINBUF) < 256)
									{
									    switch(actualState)
										{
								            case MENUSYSCOMMLANIPADDR:
											    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition < (4 - 1))
								                    memSysCommIpPosition++; //shift right
												sprintf(KEYINBUF ,"%.3d",LANIPAddrTemp[memSysCommIpPosition ]);
												break;
								            case MENUSYSCOMMLANMASK:
											    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition < (4 - 1))
								                    memSysCommIpPosition++; //shift right
												sprintf(KEYINBUF ,"%.3d",LANMaskTemp[memSysCommIpPosition ]);
												break;
								            case MENUSYSCOMMLANGWAY:
											    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition < (4 - 1))
								                    memSysCommIpPosition++; //shift right
												sprintf(KEYINBUF ,"%.3d",LANGatewayTemp[memSysCommIpPosition ]);
												break;
								        }
									}
									else
									{
									    strcpy(KEYINBUF,"255");
									    switch(actualState)
										{
								            case MENUSYSCOMMLANIPADDR:
											    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								            case MENUSYSCOMMLANMASK:
											    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								            case MENUSYSCOMMLANGWAY:
											    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								        }										
										memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3);
									}
									setVFDFlashOff(0x40,48);
								    setInputParameter(0x60 + (memSysCommIpPosition * 4),3,INTEGER,PT_SHIFT_RIGHT ,255 , 0);
						    		break;
                                case MENUCONFLIMITVMIN:
                                case MENUCONFLIMITVMAX:
                                case MENUCONFLIMITIMIN:
                                case MENUCONFLIMITIMAX:
                                case MENUCONFLIMITPMIN:
                                case MENUCONFLIMITPMAX:
								case SLEWCURRENT:
								case SLEWVOLTAGE:
									if (IS_NUMBER == 0)
									{
					            		cursorPosition++;
					            		if (keyInBuffer[cursorPosition - numericalInput.startAddress] == '.') 
					                		cursorPosition++;
					            		if(cursorPosition > (numericalInput.startAddress + numericalInput.length - 1)) 
					                		cursorPosition = numericalInput.startAddress;
					            		spaceToZero(numericalInput.startAddress);
									}
								break;
								case MENUCONFCHAINADDR:
								case MENUSYSCOMMGPIBADDR:
 								    if (IS_NUMBER == 0)
								    {
					            	    cursorPosition++;
					            	    if(cursorPosition > 0x60) 
					                	    cursorPosition = 0x5F;
								    }
								    break;
//								case MENUPVSCURVE:
//								    if (IS_NUMBER == 0)
//								    {
//					            	    cursorPosition++;
//					            	    if(cursorPosition > 0x53 + 19) 
//					                	    cursorPosition = 0x53 + 17;
//								    }
//								    break;									
								case RECALL:
								case STORE:
								    break;
								case D_NORMAL:
									if (IS_DEBUG)
									{
										if(++checkItem == MAXITEM)
											checkItem = 0;
										break;
									}
									else
									{
										 if (VFDsign & sign_CV || VFDsign & sign_CC)
										//if (outputStatus & CC_STATE || outputStatus & CV_STATE)
											setOnTheFly();
									}
									
					    		default:
						    		if (IS_NUMBER == 0)
									{
										cursorPosition++;
										if (keyInBuffer[cursorPosition-numericalInput.startAddress] == '.') 
					    					cursorPosition++;
										if(cursorPosition > (numericalInput.startAddress + numericalInput.length - 1)) 
					    					cursorPosition = numericalInput.startAddress;
										spaceToZero(numericalInput.startAddress);
									}
									break;
				    		}	
						}
						else  // IS_STRING == 1
						{
				    		switch(actualState)
							{
								case PROGRAMEDITACT:
									cursorPatternPosition = 2;
									setVFDFlashOff(0x40,48);
									setInputParameter(0x55,6, FLOAT ,LIMIT_COMPARE , master.limitVMax , master.limitVMin);	 // voltage parameter
									actualState = PROGRAMEDIT;
									sprintf(KEYINBUF,(void *)voltDisp[voltPoint],voltage);
								  	break;
								case MENUPVS:
									setVFDFlashOff(0x40,48);
									setVFDFlashOn(0x53+16,5);
								    cursorPatternPosition = 1;
									pvsONOFF = parameterTemp;
									SET_STRING;
							    	parameterTemp = curve;
									actualState = MENUPVSCURVE;
									break;
								case MENUPVSCURVE:
									if (parameterTemp <= 100 || parameterTemp == 255  )	 // curve != USER
									{
								        setVFDFlashOff(0x40,48);
										curve = parameterTemp;
								        cursorPatternPosition = 2;
									    setVFDFlashOn(0x53+24 ,4);
									    cursorPosition = 0;
										actualState = MENUPVSEDIT;
									    SET_STRING;
									}
									break;
								case PROGRAMONOFF:
								    setVFDFlashOff(0x40,48);
								    cursorPatternPosition++;
									if (cursorPatternPosition > 2)
									    cursorPatternPosition = 2;
									switch(cursorPatternPosition)
									{
										case 1:
											CLR_STRING;
											sprintf(KEYINBUF,"%.1d",programGroupTemp);
											setInputParameter(0x65,1, INTEGER ,NULL , 9 , 1);	 // programGroup
											actualState = PROGRAMMODE;
											break;
										case 2:
											break;
									}
									break;
							    case PROGRAMMODE:
								    setVFDFlashOff(0x40,48);
								    cursorPatternPosition++;
									if (cursorPatternPosition > 2)
									    cursorPatternPosition = 2;
									setVFDFlashOn(0x6B ,4);
								    break;
						    }
						}
					}
					else // IS_SETTING = 1
					{					   
					    if (actualState >= D_MENU && actualState <= MENUSYSPON ) // ذ{{в
						{
							setVFDFlashOff(0x40, 0x30);
				    		if (cursorPatternPosition < (cursorItemNumber - 1))
					    		cursorPatternPosition++;
							flashBlock(0);
							if (actualState == D_MENU || actualState == SLEW)
							{
					    		menuLevel1 = 0;menuLevel2 = 0;menuLevel3 = 0;menuLevel4 = 0;
							}
							else if(actualState == MENUCONF1 || actualState == MENUSYS1)
							{
								menuLevel3 = 0;menuLevel4 = 0;
							}
						}
						else if(actualState >= MENUINFOMODEL && actualState <= MENUCONFCHAINADDR)  // {{ buffer 
						{
							setVFDFlashOff(0x40, 0x30);
				    		if (cursorPatternPosition < (cursorItemNumber - 1))
							{
					    		cursorPatternPosition++;
								lastLastLastState = lastLastState;
								lastLastState = lastState;
								lastState = actualState;
								actualState++;
							}
							for ( i = 0 ; i < 29 ; i++)
					    		displayBuffer[19+i] = menuItemBuffer[cursorPatternPosition*29+i];
							setVFDFlashOn(flashPosition[cursorPatternPosition], flashLength[cursorPatternPosition]);   
						}
						else if (actualState == D_NORMAL || actualState == D_SHIFT )
						{
							intoFlyCursor();
							if (IS_DEBUG)
							{
								if(++checkItem == MAXITEM)
									checkItem = 0;
							}
						} 
					}
					break;
				case KEY_UP:
					switch(actualState)
					{	
						case MENUPVSCTRLMOD:
							parameterTemp ^= 0x01;
//							pvCtrlMode = parameterTemp;
							sprintf((void *)(displayBuffer + 19 + 14),"%s",parameterTemp > 0? "CV":"CC");
							break;
						case MENUPVS:
							parameterTemp ^= 0x01;
							pvsONOFF = parameterTemp;
							sprintf((void *)(displayBuffer + 19 + 3),"%s",parameterTemp > 0? " ON":"OFF");

							break;
						case MENUPVSCURVE:
							if (++parameterTemp == 101)
								parameterTemp = 0xFF; // 0xFF =>Table
							sprintf(KEYINBUF,"%3d",parameterTemp);
							if (parameterTemp == 0xFF)
								sprintf((void *)(displayBuffer + 19 + 16),"%s","TAB");
							else	
								sprintf((void *)(displayBuffer + 19 + 16),"%3d",parameterTemp + 1);
							curve = parameterTemp;
							break; 
						case RFACTORY:
							parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 21),"%s",parameterTemp > 0? "YES":" NO");
						    break;
					    case PROGRAMMODE:
						    if (cursorPatternPosition == 1)
							{
							    keyInBuffer[0]++;
								if (keyInBuffer[0] > '9' )
								    keyInBuffer[0] = '1';
                                displayBuffer[19 + 18] = keyInBuffer[0];
								programGroupTemp = keyInBuffer[0] - 0x30;                                
							}
						    break;
						case MENUSYSCOMMLANIPMODE: // AUTO or MANUAL
							parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 14),"%s         ",parameterTemp > 0 ? "MANUAL":"  AUTO");
						    break; 

					    case PROGRAMEDITACT:
						    parameterTemp++;
							if (parameterTemp > 3)
							    parameterTemp = 0;
							switch(parameterTemp)
							{
							    case 0:
								    memcpy((void *)(displayBuffer + 16),"OFF",3); 
								    break;
								case 1:
									memcpy((void *)(displayBuffer + 16)," ON",3);
								    break;
								case 2:
									memcpy((void *)(displayBuffer + 16),"NAC",3);
								    break;
								case 3:
									memcpy((void *)(displayBuffer + 16),"END",3);
								    break;
							}
						    break;
					    case MENUSYSCOMM485PDATA:
						case MENUSYSCOMM232PDATA:
						    if (++parameterTemp == 5)
							    parameterTemp = 0;
	                        switch(parameterTemp)
	                        {
	                            case 0:
	                                sprintf((void *)(displayBuffer+19+18) ,"NONE/8 BITS");
			                        break;
	                            case 1:
	                                sprintf((void *)(displayBuffer+19+18) ,"EVEN/8 BITS");
			                        break;
	                            case 2:
	                                sprintf((void *)(displayBuffer+19+18) ," ODD/8 BITS");
			                        break;
	                            case 3:
	                                sprintf((void *)(displayBuffer+19+18) ,"EVEN/7 BITS");
			                        break;
	                            case 4:
	                                sprintf((void *)(displayBuffer+19+18) ," ODD/7 BITS");
			                        break;
	                        }
						    break;
						case MENUSYSCOMM485STOP:
						case MENUSYSCOMM232STOP:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer+19)," STOP BITS: %s                ",parameterTemp > 0 ? "2":"1");
 						    break;
					    case MENUSYSDEFAULT:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 17),"%s",parameterTemp > 0? "YES":" NO");
						    break;
						case TIMERONOFF:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 26),"%s",parameterTemp > OFF ? " ON":"OFF");
                            break; 
						case PROGRAMONOFF:
						    programONOFFTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 3),"%s",programONOFFTemp > OFF ? " ON":"OFF");
                            break; 							  					
   						case MENUCONFPARAMODE:
   						case MENUCONFCHAINMODE:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 6),"%s",parameterTemp > OFF ? " ON":"OFF");
                            break;   					
						case MENUCONFPARAROLE:
						    if (++parameterTemp > SLAVEMAXNUM)
								parameterTemp = MASTER;	//0
							if (parameterTemp == MASTER)
							    sprintf((void *)(displayBuffer + 19 + 6),"%s","MASTER ");
							else
							    sprintf((void *)(displayBuffer + 19 + 6),"%s%d","SLAVE ",parameterTemp);
/*							switch(parameterTemp)
							{
								case MASTER:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","MASTER ");
						    		break;
								case SLAVE1:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 1");
						    		break;
								case SLAVE2:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 2");
						    		break;
								case SLAVE3:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 3");
						    		break;
								case SLAVE4:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 4");
						    		break;
								case SLAVE5:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 5");
						    		break;
								case SLAVE6:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 6");
						    		break;
								case SLAVE7:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 7");
						    		break;
								case SLAVE8:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 8");
						    		break;
								case SLAVE9:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 9");
						    		break;
								case SLAVE10:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 10");
						    		break;
								case SLAVE11:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 11");
						    		break;
							}  */
							break;
   						case MENUCONFCHAINADDR:
						    parameterTemp = atoi(KEYINBUF);
							if (cursorPosition == 0x60)
							{
							    if (++parameterTemp >= MAX_CHAINADDR)
							        parameterTemp = 1;
							}
							else if(cursorPosition == 0x5F)
							{
 							    parameterTemp += 10;
								if (parameterTemp >= MAX_CHAINADDR)
							        parameterTemp -= (MAX_CHAINADDR - 1);
							}
							sprintf(KEYINBUF,"%.2d",parameterTemp);
							memcpy((void *)(displayBuffer + 19 + 12 ),KEYINBUF,2);
						    break;
					    case MENUSYSCOMMGPIBADDR:

						    parameterTemp = atoi(KEYINBUF);
							if (cursorPosition == 0x60)
							{
							    if (++parameterTemp > 30)
							        parameterTemp = 1;
							}
							else if(cursorPosition == 0x5F)
							{
 							    parameterTemp += 10;
								if (parameterTemp > 30)
							        parameterTemp -= 30;
								else if (parameterTemp > 30)
								    parameterTemp -= 10;
							}
							sprintf(KEYINBUF,"%.2d",parameterTemp);
							memcpy((void *)(displayBuffer + 19 + 12 ),KEYINBUF,2);
						    break;
   						case MENUCONFEXTCV:
                        case MENUCONFEXTCI:
						    if (++parameterTemp == 3)
							    parameterTemp = 0;
						    switch(parameterTemp)
							{
							    case 0:
									memcpy((void *)(displayBuffer + 19 + 9) ,"FRONT",5);
								    break;
								case 1:
									memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-V",5);
								    break;
								case 2:
									memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-R",5);
								    break;
							}
						    break;
   						case MENUCONFEXTCPRANGE:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 15),"%s",parameterTemp > 0? "10V/10K ":" 5V/5K ");
							break;
   						case MENUCONFEXTCMONRNG:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 15),"%s",parameterTemp > 0? "10V":" 5V");
							break;

   						case MENUCONFEXTCSHUT:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 21),"%s",parameterTemp > 0? " ON/Low":"OFF/Low");
							break;
   						case MENUCONFEXTCENABLE:
 						    if (++parameterTemp > BMODE)
							   parameterTemp = OFF;
						  	switch(parameterTemp)
							{
								case OFF:
									sprintf((void *)(displayBuffer + 19 + 8),"NOT ACTIVE            ");
									break;
								case AMODE:
									sprintf((void *)(displayBuffer + 19 + 8),"ACTIVE-AMODE          ");
									break;
								case BMODE:
									sprintf((void *)(displayBuffer + 19 + 8),"ACTIVE-BMODE          ");
									break;
							}
							break;
					    case MENUCONFPROTOVP:
                        case MENUCONFPROTOCP:
                        case MENUCONFPROTOPP:
                        case MENUCONFPROTCVCC:
                        case MENUCONFPROTCCCV:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 8),"%s",parameterTemp > OFF ? " ON":"OFF");
							break;
						case D_NORMAL:
							if (onoffStatus == 0)
								break;
							else
							{
								if (IS_SETTING)		// on the fly
								{
							    	//if (outputStatus & CV_STATE)  // CV
									if (VFDsign & sign_CV)
									{
										flagtemp = 1;
										if (cursoronoff == 1) // TECO(F)
										{
											if (cursorPosition > 0x4A && cursorPosition < 0x52)
												goto modifycurrent;
											else	
												goto modifyvoltage;
									  }
										else
								    	goto modifyvoltage;
									}
									//if (outputStatus & CC_STATE)  // CC
									if (VFDsign & sign_CC)
									{
									  flagtemp = 1;
										if (cursoronoff == 1) // TECO(F)
										{
											if (cursorPosition > 0x40 && cursorPosition < 0x47)
												goto modifyvoltage;
											else	
												goto modifycurrent;
									  }
										else
											goto modifycurrent;
									}
								}
								break;
							}
modifyvoltage:
						case PROGRAMREPEAT:
						case PROGRAMEDIT:
							if (cursorPatternPosition > 1)
								break;
						case D_VSET:
						case MENUSYSPONUDEFV:
						case CALVOLTAGE:
						
						case SLEWVOLTAGE:
						case SLEWCURRENT:
						case D_OVP:
						case D_OPP:
					    case MENUCONFLIMITVMIN:
						case MENUCONFLIMITVMAX:
						case MENUCONFLIMITPMIN:
					    case MENUCONFLIMITPMAX:

							if (IS_NUMBER == 0)
							{
							    if (numericalInput.ft == INTEGER) // for step parameter input
								{
									tempint = atoi(KEYINBUF);
									if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1)) 
									{
										if (numericalInput.length == 1 && actualState == PROGRAMREPEAT)
										{
											if (tempint < numericalInput.intMax) 
												tempint += 1;
											else
												tempint = numericalInput.intMin;
										}
										else
											tempint += 1;
									}
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempint += 10;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempint += 100;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 4)) tempint += 1000;
									if (tempint > numericalInput.intMax) tempint = numericalInput.intMax;
									switch(numericalInput.length)
									{
										case 3:
											sprintf(KEYINBUF, "%.3d", tempint);
											break;
									    case 2:
   		 								    sprintf(KEYINBUF, "%.2d", tempint);
											break;
										case 1:
										    sprintf(KEYINBUF, "%.1d", tempint);
									        break;
									}
									spaceToZero(numericalInput.startAddress);
									if (numericalInput.length == 1 && actualState == PROGRAMREPEAT)
									{
									    if (keyInBuffer[0] == '0')
											strcpy((void *)(displayBuffer+19+23),"NONE");
										else
											strcpy((void *)(displayBuffer+19+24),"   ");
									}
									if(actualState == PROGRAMEDIT && cursorPatternPosition == 0) // stepŪprogram data
									{
										step = atoi(KEYINBUF) - 1;
										readProgramParameter();
									}																//	  numerical[5][6]
								}
								else
								{
									uint8_t tempPoint;
									if(actualState == D_OPP)
										tempPoint = powPoint;
									else
										tempPoint = voltPoint;
									tempff = atof(KEYINBUF);
									     if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][0]->digit)) tempff = tempff + numerical[tempPoint][0]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][1]->digit)) tempff = tempff + numerical[tempPoint][1]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][2]->digit)) tempff = tempff + numerical[tempPoint][2]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][3]->digit)) tempff = tempff + numerical[tempPoint][3]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][4]->digit)) tempff = tempff + numerical[tempPoint][4]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][5]->digit)) tempff = tempff + numerical[tempPoint][5]->delta;
									if (tempff > numericalInput.floatMax) tempff = numericalInput.floatMax;
									if (numericalInput.length >= 6)
									    sprintf(KEYINBUF, (void *)voltDisp[tempPoint], tempff);
									else if	 (numericalInput.length == 5)
									{
										if (tempPoint == 1)
											sprintf(KEYINBUF, "%5.1f", tempff);
										else if (tempPoint == 2)
											sprintf(KEYINBUF, "%5.2f", tempff);
									}
									else if  (numericalInput.length == 4)
										sprintf(KEYINBUF, "%4.1f", tempff);
									else if (numericalInput.length == 3)
										sprintf(KEYINBUF, "%3.1f", tempff);
									spaceToZero(numericalInput.startAddress);
								}
								if (flagtemp == 1)
								{
									// on the fly
//									if (VFDsign & sign_CV) // mark for TECO
									{
										setOnTheFly();
								    	master.vSet = atof(KEYINBUF);
										// send vset						
										if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
											eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
									}
								}
							}
						    break;
						case EXTCALRESVOLTAGE:
						case EXTCALRESCURRENT:
						case TESTEXTVCC:
						case TESTEXTICC:
							if (IS_NUMBER == 0)
								{
									tempff = atof(KEYINBUF);
									if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1)) tempff = tempff + 0.00001;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempff = tempff + 0.0001;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempff = tempff + 0.001;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 4)) tempff = tempff + 0.01;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 5)) tempff = tempff + 0.1;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 7)) tempff = tempff + 1;
									if (tempff > numericalInput.floatMax) tempff = numericalInput.floatMax;
										sprintf(KEYINBUF, "%6.5f", tempff);
									spaceToZero(numericalInput.startAddress);
								}
							 break;
						case EXTCALCURRENT:
						case EXTCALVOLTAGE:
						case TESTEXTVOLT:
						case TESTEXTCURR:
							if (IS_NUMBER == 0)
								{
								tempff = atof(KEYINBUF);
								if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1)) tempff = tempff + 0.001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempff = tempff + 0.01;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempff = tempff + 0.1;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 5)) tempff = tempff + 1.0;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 6)) tempff = tempff + 10.0;
								if (tempff > numericalInput.floatMax) tempff = numericalInput.floatMax;
								sprintf(KEYINBUF, "%6.3f", tempff);
								spaceToZero(numericalInput.startAddress);
								}
							break;

modifycurrent:
						case D_ISET:
						case MENUSYSPONUDEFI:
						case CALCURRENT: 
						case D_OCP:
						case MENUCONFLIMITIMIN:
						case MENUCONFLIMITIMAX:
							if (IS_NUMBER == 0)
							{
								tempff = atof(KEYINBUF);
								if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1)) tempff = tempff + 0.0001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempff = tempff + 0.001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempff = tempff + 0.01;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 4)) tempff = tempff + 0.1;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 6)) tempff = tempff + 1.0;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 7)) tempff = tempff + 10.0;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 8)) tempff = tempff + 100.0;

//								tempff = round(tempff,around);
								if (tempff > numericalInput.floatMax) tempff = numericalInput.floatMax;
									sprintf(KEYINBUF, (void *)currDisp[currPoint], tempff);
								if (keyInBuffer[cursorPosition - numericalInput.startAddress] == '.')
									cursorPosition--; // 99.9i 100 pIh קK cursor b '.'W
								spaceToZero(numericalInput.startAddress);
								if (flagtemp == 1)
								{
//									if (VFDsign & sign_CC)//if (outputStatus & CC_STATE)  // on the fly mark for TECO
									{
										setOnTheFly();
										if (atof(KEYINBUF) > sumRatioiMax())  //s
										{
											for (i = 0 ; i <= SLAVEMAXNUM ;i++)
											slaveDUT[i]->ratioiMax = slaveDUT[i]->iMax;
										}
										for (i = 0 ;i <= SLAVEMAXNUM ;i++)
										{
											if (atof(KEYINBUF) > sumRatioiMax())
												slaveDUT[i]->iSet = (atof(KEYINBUF) * slaveDUT[i]->iMax)/sumiMax();
											else
												slaveDUT[i]->iSet = (atof(KEYINBUF) * slaveDUT[i]->ratioiMax)/sumRatioiMax();
										}
										// send iset
										if (verifyInput(ISET_CMD,slaveDUT[0]->iSet ) == SUCCESS)
											eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
									}							
								}
							}
						    break;
						case MENUPVSEDITRECORD1:
							Rule += 1;
							if (Rule == 4)
								Rule = 1;
							transRuleMaterialPattern();
							memcpy((void *)(displayBuffer+19),(void *)pvsBuffer,29);
							sprintf(KEYINBUF,"%1d",(uint8_t)Rule);
							break;
						case MENUPVSEDITRECORD4:
							switch((uint8_t)Rule)
							{
								case 1:
								case 3:
									Material += 1;
									if (Material >= 3)
										Material = 1;
									break;
								case 2:
									Material += 1;
									if (Material >= 4)
										Material = 1;
									break;	
 							}
							transRuleMaterialPattern();
							memcpy((void *)(displayBuffer+19),(void *)(pvsBuffer+29),29);
							sprintf(KEYINBUF,"%1d",(uint8_t)Material);
							break;
						case MENUSYSCOMM485BAUD:
						case MENUSYSCOMM232BAUD:
						    if (++parameterTemp == 4)
							    parameterTemp = 0;
							switch(parameterTemp)
							{
							    case 3:
								    memcpy((void *)(displayBuffer + 19 + 13), "57600",5);
								    break;
								case 2:
								    memcpy((void *)(displayBuffer + 19 + 13), "38400",5);
								    break;
								case 1:
								    memcpy((void *)(displayBuffer + 19 + 13), "19200",5);
								    break;
								case 0:
								    memcpy((void *)(displayBuffer + 19 + 13), " 9600",5);
								    break;
							}
						    break;
						case MENUSYSMEMG:
						    if (++parameterTemp	== 10)
							    parameterTemp = 0;
							displayBuffer[19 + 15] = parameterTemp + 0x30;
							keyInBuffer[0] = displayBuffer[19 + 15];
							break;
						case MENUSYSBEEP:
						    parameterTemp &= 0x01;
						    parameterTemp ^= 0x01;

							sprintf((void *)(displayBuffer + 19 + 6),"%s",parameterTemp > OFF ? " ON":"OFF");
						    break;
						case MENUSYSPONMODE:
						    if (++parameterTemp == 3)
							    parameterTemp = 0;
							switch(parameterTemp)
							{
							    case 0:
								    memcpy((void *)(displayBuffer + 19 + 16),"OFF ",4);
									break;
								case 1:
								    memcpy((void *)(displayBuffer + 19 + 16),"LAST",4);
								    break;
								case 2:
								    memcpy((void *)(displayBuffer + 19 + 16),"USER",4);
						    	    break;
							}
						    break;
						case MENUSYSPONUDEFONOFF:
						    if (++parameterTemp == 2)
							    parameterTemp = 0;
							switch(parameterTemp)
							{
							    case 0:
								    memcpy((void *)(displayBuffer + 19 + 19),"OFF ",4);
									break;
								case 1:
								    memcpy((void *)(displayBuffer + 19 + 19)," ON ",4);
								    break;
							}
						    break;							
					}	
				    break;
				case KEY_DN:
		            switch(actualState)
					{
						case MENUPVSCTRLMOD:
							parameterTemp ^= 0x01;
//							pvCtrlMode = parameterTemp;
							sprintf((void *)(displayBuffer + 19 + 14),"%s",parameterTemp > 0? "CV":"CC");
							break;
						case MENUPVS:
							parameterTemp ^= 0x01;
							pvsONOFF = parameterTemp;
							sprintf((void *)(displayBuffer + 19 + 3),"%s",parameterTemp > 0? " ON":"OFF");
							break;
						case MENUPVSCURVE:
							if (--parameterTemp == 0xFE)	// curve 255 = Table
								parameterTemp = 100;
							sprintf(KEYINBUF,"%3d",parameterTemp);
							if (parameterTemp == 0xFF)
							  sprintf((void *)(displayBuffer + 19 + 16),"%s","TAB");
							else	
								sprintf((void *)(displayBuffer + 19 + 16),"%3d",parameterTemp + 1);
							curve = parameterTemp;
							break; 
						case RFACTORY:
							parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 21),"%s",parameterTemp > 0? "YES":" NO");
						    break;
					    case PROGRAMMODE:
						    if (cursorPatternPosition == 1)
							{
							    keyInBuffer[0]--;
								if (keyInBuffer[0] < '1' )
								    keyInBuffer[0] = '9';
                                displayBuffer[19 + 18] = keyInBuffer[0];  
								programGroupTemp = keyInBuffer[0] - 0x30;                               
							}
						    break;

					    case PROGRAMEDITACT:
						    parameterTemp--;
							if ((int8_t)parameterTemp < 0)
							    parameterTemp = 3;
							switch(parameterTemp)
							{
							    case 0:
								    memcpy((void *)(displayBuffer + 16),"OFF",3); 
								    break;
								case 1:
									memcpy((void *)(displayBuffer + 16)," ON",3);
								    break;
								case 2:
									memcpy((void *)(displayBuffer + 16),"NAC",3);
								    break;
								case 3:
									memcpy((void *)(displayBuffer + 16),"END",3);
								    break;
							}
						    break;
					    case MENUSYSCOMM485PDATA:
						case MENUSYSCOMM232PDATA:
						    if (--parameterTemp == 0xFF)
							    parameterTemp = 4;
	                        switch(parameterTemp)
	                        {
	                            case 0:
	                                sprintf((void *)(displayBuffer+19+18) ,"NONE/8 BITS");
			                        break;
	                            case 1:
	                                sprintf((void *)(displayBuffer+19+18) ,"EVEN/8 BITS");
			                        break;
	                            case 2:
	                                sprintf((void *)(displayBuffer+19+18) ," ODD/8 BITS");
			                        break;
	                            case 3:
	                                sprintf((void *)(displayBuffer+19+18) ,"EVEN/7 BITS");
			                        break;
	                            case 4:
	                                sprintf((void *)(displayBuffer+19+18) ," ODD/7 BITS");
			                        break;
	                        }
						    break;
						case MENUSYSCOMM485STOP:
						case MENUSYSCOMM232STOP:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer+19)," STOP BITS: %s                ",parameterTemp > 0 ? "2":"1");
 						    break;
					    case MENUSYSDEFAULT:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 17),"%s",parameterTemp > 0? "YES":" NO");
						    break;
						case TIMERONOFF:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 26),"%s",parameterTemp > OFF ? " ON":"OFF");
                            break ;
						case PROGRAMONOFF:
						    programONOFFTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 3),"%s",programONOFFTemp > OFF ? " ON":"OFF");
                            break; 								  					
   						case MENUCONFPARAMODE:
   						case MENUCONFCHAINMODE:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 6),"%s",parameterTemp > OFF ? " ON":"OFF");
                            break ;  					
						case MENUCONFPARAROLE:
						    if (--parameterTemp == 0xFF)
								parameterTemp = SLAVEMAXNUM;
							if (parameterTemp == MASTER)
							    sprintf((void *)(displayBuffer + 19 + 6),"%s","MASTER ");
							else
							    sprintf((void *)(displayBuffer + 19 + 6),"%s%d","SLAVE ",parameterTemp);
/*							switch(parameterTemp)
							{
								case MASTER:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","MASTER ");
						    		break;
								case SLAVE1:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 1");
						    		break;
								case SLAVE2:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 2");
						    		break;
								case SLAVE3:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 3");
						    		break;
								case SLAVE4:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 4");
						    		break;
								case SLAVE5:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 5");
						    		break;
								case SLAVE6:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 6");
						    		break;
								case SLAVE7:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 7");
						    		break;
								case SLAVE8:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 8");
						    		break;
								case SLAVE9:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 9");
						    		break;
								case SLAVE10:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 10");
						    		break;
								case SLAVE11:
									sprintf((void *)(displayBuffer + 19 + 6),"%s","SLAVE 11");
						    		break;
							}  */
						    break;
   						case MENUCONFCHAINADDR:
						    parameterTemp = atoi(KEYINBUF);
							if (cursorPosition == 0x60)
							{
							    if (--parameterTemp == 0)
							        parameterTemp = (MAX_CHAINADDR - 1);
							}
							else if(cursorPosition == 0x5F)
							{
 							    parameterTemp -= 10;
								if ((int8_t)parameterTemp < 1)
							        parameterTemp += (MAX_CHAINADDR - 1);
							}
							sprintf(KEYINBUF,"%.2d",parameterTemp);
							memcpy((void *)(displayBuffer + 19 + 12 ),KEYINBUF,2);
						    break;

					    case MENUSYSCOMMGPIBADDR:
						    parameterTemp = atoi(KEYINBUF);
							if (cursorPosition == 0x60)
							{
							    if (--parameterTemp == 0)
							        parameterTemp = 30;
							}
							else if(cursorPosition == 0x5F)
							{
 							    parameterTemp -= 10;
								if ((int8_t)parameterTemp < 1)
								{
//								    if ((int8_t)parameterTemp <= -5)
							            parameterTemp += 30;
//									else
//									    parameterTemp += 20;
								}
							}
							sprintf(KEYINBUF,"%.2d",parameterTemp);
							memcpy((void *)(displayBuffer + 19 + 12 ),KEYINBUF,2);
						    break;

   						case MENUCONFEXTCV:
                        case MENUCONFEXTCI:
						    if (--parameterTemp == 0xff)
							    parameterTemp = 2;
						    switch(parameterTemp)
							{
							    case 0:
									memcpy((void *)(displayBuffer + 19 + 9) ,"FRONT",5);
								    break;
								case 1:
									memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-V",5);
								    break;
								case 2:
									memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-R",5);
								    break;
							}
						    break;
   						case MENUCONFEXTCPRANGE:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 15),"%s",parameterTemp > 0? "10V/10K ":" 5V/5K ");
							break;
   						case MENUCONFEXTCMONRNG:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 15),"%s",parameterTemp > 0? "10V":" 5V");
							break;

   						case MENUCONFEXTCSHUT:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 21),"%s",parameterTemp > 0? " ON/Low":"OFF/Low");
							break;
   						case MENUCONFEXTCENABLE:
 						    if (--parameterTemp == 0xFF)
							   parameterTemp = BMODE;
						  	switch(parameterTemp)
							{
								case OFF:
									sprintf((void *)(displayBuffer + 19 + 8),"NOT ACTIVE            ");
									break;
								case AMODE:
									sprintf((void *)(displayBuffer + 19 + 8),"ACTIVE-AMODE          ");
									break;
								case BMODE:
									sprintf((void *)(displayBuffer + 19 + 8),"ACTIVE-BMODE          ");
									break;
							}
							break;
					    case MENUCONFPROTOVP:
                        case MENUCONFPROTOCP:
                        case MENUCONFPROTOPP:
                        case MENUCONFPROTCVCC:
                        case MENUCONFPROTCCCV:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 8),"%s",parameterTemp > OFF ? " ON":"OFF");
							break;
						case D_NORMAL:
							if (onoffStatus == 0)
								break;
							else
							{
								if (IS_SETTING)		// on the fly
								{
							    	//if (outputStatus & CV_STATE)  // CV
									if (VFDsign & sign_CV)
									{
										flagtemp = 1;
										
										if (cursoronoff == 1) // TECO(F)
										{
											if (cursorPosition > 0x4A && cursorPosition < 0x52)
												goto modifycurrent1;
											else	
												goto modifyvoltage1;
									  }
										else
								    	goto modifyvoltage1;
									}
									//if (outputStatus & CC_STATE)  // CC
									if (VFDsign & sign_CC)
									{
									    flagtemp = 1;
										if (cursoronoff == 1) // TECO(F)
										{
											if (cursorPosition > 0x40 && cursorPosition < 0x47)
												goto modifyvoltage1;
											else	
												goto modifycurrent1;
									  }
										else
									   	goto modifycurrent1;
									}
								}
								break;
							}
modifyvoltage1:
						case PROGRAMREPEAT:
						case PROGRAMEDIT:
							if (cursorPatternPosition > 1)
								break;
						case D_VSET:
						case MENUSYSPONUDEFV:
						case CALVOLTAGE:
						case SLEWCURRENT:
						case SLEWVOLTAGE:
						case D_OVP:
						case D_OPP:
					    case MENUCONFLIMITVMIN:
						case MENUCONFLIMITVMAX:
						case MENUCONFLIMITPMIN:
					    case MENUCONFLIMITPMAX:
							if (IS_NUMBER == 0)
							{
							    if (numericalInput.ft == INTEGER)
								{
									tempint = atoi(KEYINBUF);
									if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1))
									{
										if (numericalInput.length == 1 && actualState == PROGRAMREPEAT)
										{
											if (tempint > numericalInput.intMin) 
												tempint -= 1;
											else
												tempint = numericalInput.intMax;
										}
										else
											tempint -= 1;
									}
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempint -= 10;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempint -= 100;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 4)) tempint -= 1000;
									if ((int32_t)tempint < (int32_t)numericalInput.intMin) 
									    tempint = numericalInput.intMin;
									switch(numericalInput.length)
									{
										case 3:
   		 								    sprintf(KEYINBUF, "%.3d", tempint);
											break;
									    case 2:
    									    sprintf(KEYINBUF, "%.2d", tempint);
											break;
										case 1:
											sprintf(KEYINBUF, "%.1d", tempint);
									        break;
									}
									spaceToZero(numericalInput.startAddress);
									if (numericalInput.length == 1 && actualState == PROGRAMREPEAT)
									{
									    if (keyInBuffer[0] == '0')
											strcpy((void *)(displayBuffer+19+23),"NONE");
										else
											strcpy((void *)(displayBuffer+19+24),"   ");
									}
									if(actualState == PROGRAMEDIT && cursorPatternPosition == 0) // stepŪprogram data
									{
										step = atoi(KEYINBUF) - 1;
										readProgramParameter();
									}
								}
								else
								{
									uint8_t tempPoint;
									if(actualState == D_OPP)
										tempPoint = powPoint;
									else
										tempPoint = voltPoint;
									tempff = atof(KEYINBUF);
									     if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][0]->digit)) tempff = tempff - numerical[tempPoint][0]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][1]->digit)) tempff = tempff - numerical[tempPoint][1]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][2]->digit)) tempff = tempff - numerical[tempPoint][2]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][3]->digit)) tempff = tempff - numerical[tempPoint][3]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][4]->digit)) tempff = tempff - numerical[tempPoint][4]->delta;
									else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - numerical[tempPoint][5]->digit)) tempff = tempff - numerical[tempPoint][5]->delta;
									if (tempff < numericalInput.floatMin) tempff = numericalInput.floatMin;
									if  (numericalInput.length >= 6)
										sprintf(KEYINBUF, (void *)voltDisp[tempPoint], tempff);
									else if (numericalInput.length == 5)
									{
										if (tempPoint == 1)
											sprintf(KEYINBUF, "%5.1f", tempff);
										else if (tempPoint == 2)
											sprintf(KEYINBUF, "%5.2f", tempff);
									}
									else if  (numericalInput.length == 4)
										sprintf(KEYINBUF, "%4.1f", tempff);
									else if (numericalInput.length == 3)
										sprintf(KEYINBUF, "%3.1f", tempff);
									spaceToZero(numericalInput.startAddress);
								}
								if (flagtemp == 1)
								{
									//if (outputStatus & CV_STATE)  // on the fly
//									if (VFDsign & sign_CV) //mark for TECO
									{
										setOnTheFly();
								    	master.vSet = atof(KEYINBUF);
										// send vset						
										if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
											eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
									}
								}
							}
							break;
						case MENUPVSEDITRECORD1:
							Rule -= 1;
							if ( Rule == 0)
								Rule = 3;
							transRuleMaterialPattern();
							memcpy((void *)(displayBuffer+19),(void *)(pvsBuffer),29);
							sprintf(KEYINBUF,"%1d",(uint8_t)Rule);
							break;
						case MENUPVSEDITRECORD4:
							switch((uint8_t)Rule)
							{
								case 1:
								case 3:
									Material -= 1;
									if (Material == 0)
										Material = 2;
									break;
								case 2:
									Material -= 1;
									if (Material == 0)
										Material = 3;
									break;
 							}
							transRuleMaterialPattern();
							memcpy((void *)(displayBuffer+19),(void *)(pvsBuffer+29),29);
							sprintf(KEYINBUF,"%1d",(uint8_t)Material);
							break;
						case EXTCALRESVOLTAGE:
						case EXTCALRESCURRENT:
						case TESTEXTVCC:
						case TESTEXTICC:
							if (IS_NUMBER == 0)
							{
	 							tempff = atof(KEYINBUF);
								if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1)) tempff = tempff - 0.00001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempff = tempff - 0.0001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempff = tempff - 0.001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 4)) tempff = tempff - 0.01;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 5)) tempff = tempff - 0.1;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 5)) tempff = tempff - 1;
								if (tempff < numericalInput.floatMin) tempff = numericalInput.floatMin;
									sprintf(KEYINBUF, "%6.5f", tempff);
								spaceToZero(numericalInput.startAddress);
							}
							break;
						case EXTCALCURRENT:
						case EXTCALVOLTAGE:
						case TESTEXTVOLT:
						case TESTEXTCURR:
							if (IS_NUMBER == 0)
							{
 								tempff = atof(KEYINBUF);
								if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1)) tempff = tempff - 0.001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempff = tempff - 0.01;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempff = tempff - 0.1;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 5)) tempff = tempff - 1.0;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 6)) tempff = tempff - 10.0;
								if (tempff < numericalInput.floatMin) tempff = numericalInput.floatMin;
									sprintf(KEYINBUF, "%6.3f", tempff);
								spaceToZero(numericalInput.startAddress);
							}
						break;
modifycurrent1:
						case D_ISET:
						case MENUSYSPONUDEFI:
						case CALCURRENT:
						case D_OCP:
						case MENUCONFLIMITIMIN:
						case MENUCONFLIMITIMAX:
							if (IS_NUMBER == 0)
							{
								tempff = atof(KEYINBUF);
								if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 1)) tempff = tempff - 0.0001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 2)) tempff = tempff - 0.001;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 3)) tempff = tempff - 0.01;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 4)) tempff = tempff - 0.1;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 6)) tempff = tempff - 1.0;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 7)) tempff = tempff - 10.0;
								else if (cursorPosition == (numericalInput.startAddress + numericalInput.length - 8)) tempff = tempff - 100.0;
//								tempff = round(tempff,around);
								if (tempff < numericalInput.floatMin) tempff = numericalInput.floatMin;
									sprintf(KEYINBUF, (void *)currDisp[currPoint], tempff);
	  							if (keyInBuffer[cursorPosition - numericalInput.startAddress] == '.')
									cursorPosition--; // 99.9i 100 pIh קK cursor b '.'W
								spaceToZero(numericalInput.startAddress);
								if (flagtemp == 1)
								{
	//								if (VFDsign & sign_CC)//if (outputStatus & CC_STATE)  // on the fly  //mark for TECO
									{
										setOnTheFly();
 										if (atof(KEYINBUF) > sumRatioiMax())  //s
										{
											for (i = 0 ; i <= SLAVEMAXNUM ;i++)
											slaveDUT[i]->ratioiMax = slaveDUT[i]->iMax;
										}
										for (i = 0 ;i <= SLAVEMAXNUM ;i++)
										{
											if (atof(KEYINBUF) > sumRatioiMax())
												slaveDUT[i]->iSet = (atof(KEYINBUF) * slaveDUT[i]->iMax)/sumiMax();
											else
												slaveDUT[i]->iSet = (atof(KEYINBUF) * slaveDUT[i]->ratioiMax)/sumRatioiMax();
										}
										// send iset
										if (verifyInput(ISET_CMD,slaveDUT[0]->iSet ) == SUCCESS)
											eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
 									}							
								}
							}
						    break;
						case MENUSYSCOMMLANIPMODE: // AUTO or MANUAL
							parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 14),"%s         ",parameterTemp > 0 ? "MANUAL":"  AUTO");
						    break; 
						case MENUSYSCOMM485BAUD:
						case MENUSYSCOMM232BAUD:
						    if (--parameterTemp == 0xFF)
							    parameterTemp = 3;
							switch(parameterTemp)
							{
							    case 3:
								    memcpy((void *)(displayBuffer + 19 + 13), "57600",5);
								    break;
								case 2:
								    memcpy((void *)(displayBuffer + 19 + 13), "38400",5);
								    break;
								case 1:
								    memcpy((void *)(displayBuffer + 19 + 13), "19200",5);
								    break;
								case 0:
								    memcpy((void *)(displayBuffer + 19 + 13), " 9600",5);
								    break;
							}
						    break;
						case MENUSYSMEMG:
						    if (--parameterTemp	== 0xff)
							    parameterTemp = 9;
							displayBuffer[19 + 15] = parameterTemp + 0x30;
							keyInBuffer[0] = displayBuffer[19 + 15];
							break;
						case MENUSYSBEEP:
						    parameterTemp ^= 0x01;
							sprintf((void *)(displayBuffer + 19 + 6),"%s",parameterTemp > OFF ? " ON":"OFF");
						    break;
						case MENUSYSPONMODE:
						    if (--parameterTemp == 0xff)
							    parameterTemp = 2;
							switch(parameterTemp)
							{
							    case 0:
								    memcpy((void *)(displayBuffer + 19 + 16),"OFF ",4);
									break;
								case 1:
								    memcpy((void *)(displayBuffer + 19 + 16),"LAST",4);
								    break;
								case 2:
								    memcpy((void *)(displayBuffer + 19 + 16),"USER",4);
						    	    break;
							}
							break;
 						case MENUSYSPONUDEFONOFF:
						    if (--parameterTemp == 0xff)
							    parameterTemp = 1;
							switch(parameterTemp)
							{
							    case 0:
								    memcpy((void *)(displayBuffer + 19 + 19),"OFF ",4);
									break;
								case 1:
								    memcpy((void *)(displayBuffer + 19 + 19)," ON ",4);
								    break;
							}
						    break;		
					}	
				    break;
			}
		    break;
		default:
		    break;
	}
}
extern uint8_t otwOccurred;

// OVP OCP OPP O@ MRO
void clearOVPOCPOPPCVCCCCCV(void)
{
	uint32_t time,clearflag ;
	clearflag = 0;
	clearMeasureCommand();
	if (IS_NTC_TOO_HIGH) // OTP
	{
		softTimer[OTW_NTC_STATUS_COUNT].flag = DISABLE;
		onoffStatus = OFF;
		verifyInput(OUTPUT_CMD,(uint8_t)onoffStatus ); 
	}
	softTimer[TEMP_BEEP_COUNT].flag = DISABLE;
	time = softTimer[MAIN_COUNT].count;
  if (outputStatus & OVP_STATE ) // OVP
	{
		while(outputStatus & OVP_STATE)
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
		    sendMBQuery(MEASURE_CHANNEL,OVPCLEAR_CMD);	 // Clear OVP
//				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
		 		delayMs(10);
				queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,20);
			}
			else
				break;
		}
		clearflag = 1;
		verifyInput(OVPSET_CMD,master.OVPSet );
	}
  if (outputStatus & OCP_STATE ) // OCP
	{
		while(outputStatus & OCP_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
				sendMBQuery(MEASURE_CHANNEL,OCPCLEAR_CMD);	  // Clear OCP
//				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
				delayMs(10);
			 	queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,20);
			}
			else
				break;
		}
		clearflag = 1;
		verifyInput(OCPSET_CMD,master.OCPSet );
	}
  if (outputStatus & OPP_STATE ) // OPP
	{
		while(outputStatus & OPP_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
			  sendMBQuery(MEASURE_CHANNEL,OPPCLEAR_CMD);	 // Clear OPP
//				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
				delayMs(10);
			 	queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,20);
			}
			else
				break;
		}
		clearflag = 1;
		 verifyInput(OPPSET_CMD,master.OPPSet );
	}
  if (outputStatus & CV_CC_STATE ) // OCP
	{
		while(outputStatus & CV_CC_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
			  sendMBQuery(MEASURE_CHANNEL,CVCCCLEAR_CMD);	 // Clear CV-CC
//				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
				delayMs(10);
			 	queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,20);
			}
			else
				break;
		}
		clearflag = 1;
	}
  if (outputStatus & CC_CV_STATE ) // OPP
	{
		while(outputStatus & CC_CV_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
			  sendMBQuery(MEASURE_CHANNEL,CCCVCLEAR_CMD);	 // Clear CV-CC
//				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
				delayMs(10);
			 	queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,20);				  
			}
			else
				break;
		} 	
		clearflag = 1;
	}
	if (clearflag == 1)
	{
		CLR_ERROR_BEEP;	 
		if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
		if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));	
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		if (actualState == PROGRAMRUNNING)
			 actualState	= PROGRAMREADY;
		programStart = 0; 
  	programState = 4;	//stop
		TIM_Cmd(TIM2, DISABLE);
		VFDsign &= ~(sign_STAR);
		totalRepeat = repeat = OVPOccurred = OCPOccurred = OPPOccurred = VCPOccurred = CVPOccurred = 0;
		runningTimer = 0xFFFFFFFF;
	}
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber	> 0)
	{
		OVPOccurred = OCPOccurred = OPPOccurred = VCPOccurred = CVPOccurred = 0;
	}
}

// OVP OCP OPP O@ MRO
void clearOVPOCPOPPCVCCCCCV1(void)
{
	uint32_t time,clearflag ;
	clearflag = 0;
	if (IS_NTC_TOO_HIGH) // OTP
	{
		softTimer[OTW_NTC_STATUS_COUNT].flag = DISABLE;
		onoffStatus = OFF;
		verifyInput(OUTPUT_CMD,(uint8_t)onoffStatus ); 
	}
	softTimer[TEMP_BEEP_COUNT].flag = DISABLE;
	time = softTimer[MAIN_COUNT].count;
  if (outputStatus & OVP_STATE ) // OVP
	{
		while(outputStatus & OVP_STATE)
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
		    sendMBQuery(MEASURE_CHANNEL,OVPCLEAR_CMD);	 // Clear OVP
				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
			}
			else
				break;
		}
		clearflag = 1;
		verifyInput(OVPSET_CMD,master.OVPSet );
	}
  if (outputStatus & OCP_STATE ) // OCP
	{
		while(outputStatus & OCP_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
				sendMBQuery(MEASURE_CHANNEL,OCPCLEAR_CMD);	  // Clear OCP
				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
			}
			else
				break;
		}
		clearflag = 1;
		verifyInput(OCPSET_CMD,master.OCPSet );
	}
  if (outputStatus & OPP_STATE ) // OPP
	{
		while(outputStatus & OPP_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
			  sendMBQuery(MEASURE_CHANNEL,OPPCLEAR_CMD);	 // Clear OPP
				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
			}
			else
				break;
		}
		clearflag = 1;
		 verifyInput(OPPSET_CMD,master.OPPSet );
	}
  if (outputStatus & CV_CC_STATE ) // OCP
	{
		while(outputStatus & CV_CC_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
			  sendMBQuery(MEASURE_CHANNEL,CVCCCLEAR_CMD);	 // Clear CV-CC
				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
			}
			else
				break;
		}
		clearflag = 1;
	}
  if (outputStatus & CC_CV_STATE ) // OPP
	{
		while(outputStatus & CC_CV_STATE ) 
		{
			if ( softTimer[MAIN_COUNT].count - time < (300))
			{
			  sendMBQuery(MEASURE_CHANNEL,CCCVCLEAR_CMD);	 // Clear CV-CC
				sendMBQuery(MEASURE_CHANNEL,OUTPUTQ_CMD);
			}
			else
				break;
		} 	
		clearflag = 1;
	}
	if (clearflag == 1)
	{
		CLR_ERROR_BEEP;	 
		verifyInput(VSET_CMD,master.vSet );
		verifyInput(ISET_CMD,master.iSet );
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		if (actualState == PROGRAMRUNNING)
			 actualState	= PROGRAMREADY;
		programStart = 0; 
  	programState = 4;	//stop
		TIM_Cmd(TIM2, DISABLE);
		VFDsign &= ~(sign_STAR);
		totalRepeat = repeat = OVPOccurred = OCPOccurred = OPPOccurred = VCPOccurred = CVPOccurred = 0;
		runningTimer = 0xFFFFFFFF;
	}
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber	> 0)
	{
		OVPOccurred = OCPOccurred = OPPOccurred = VCPOccurred = CVPOccurred = 0;
	}
}


// ѪR
void keyParser(void)
{
	uint8_t errorBeepFlag = 0;
    keyParameter.keyFunction = KEY_NOTHING;
	keyParameter.keyEvent = NULL_KEY; 
	if ((outputStatus & (OVP_STATE|OCP_STATE|OPP_STATE|CV_CC_STATE|CC_CV_STATE) || IS_MB_ERROR || IS_PARALLEL_PROTECT))	// 
		errorBeepFlag = 1;  	 // something error in protect
	switch(keyCode)
	{
		case key_SelfTest:
			if (errorBeepFlag == 0)
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_SELFTEST;
			}
			break;
		case key_Normal:
		    if (errorBeepFlag == 0)
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_NORMAL;
			}
			break;
		case key_Debug:
		    if (errorBeepFlag == 0)
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_DEBUG;
			}
			break;
		case key_OVP:
			if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_OVP;

			}
			break;
		case key_OPP:
			if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_OPP;
			}
			break;
		case key_OCP:
			if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_OCP;
			}
			break;
		case key_VSET:
		    if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
		        keyParameter.keyFunction = KEY_FUNCTION;
			    keyParameter.keyEvent = KEY_VSET;
			}
			break;
		case key_RECALL:
		    if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
			    keyParameter.keyFunction = KEY_FUNCTION;
			    keyParameter.keyEvent = KEY_RECALL;
			}
		    break;
		case key_ESC:
			if (lockStatus == 0 && !(VFDsign & sign_RMT))
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_ESC;
		    }
			break;
		case key_ISET:
		    if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
			    keyParameter.keyFunction = KEY_FUNCTION;
			    keyParameter.keyEvent = KEY_ISET;
			}
			break;
		case key_MENU:
		    if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
			    keyParameter.keyFunction = KEY_FUNCTION;
			    keyParameter.keyEvent = KEY_MENU;
			}
		    break;
		case key_OK:
			if(actualState == SELFTEST1)
			{
				if (lockStatus == 0 && errorBeepFlag == 0 )
				{
					keyParameter.keyFunction = KEY_FUNCTION;
					keyParameter.keyEvent = KEY_OK;
			    }
			}
			else
			{
				if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
				{
					keyParameter.keyFunction = KEY_FUNCTION;
					keyParameter.keyEvent = KEY_OK;
			    }
			}
			break;
		case key_LOCK: // errorBeepFlag
			if (otwOccurred == 0 && errorBeepFlag == 0)
			{
				if ((actualState != SELFTEST1 && actualState != D_PARALLELSLAVE) && !(VFDsign & sign_RMT))
				{	
					if (lockStatus == 0)
					{
			   	 		lockStatus = 0x01;
						VFDsign |= sign_LOCK;
					}
					else
					{
						lockStatus = 0;
						VFDsign &= ~(sign_LOCK);
					}
					printVFDsign();
				}
			}
		    break;
		case key_SHIFT: // errorBeepFlag
			if (keyType == KEY23)
			{
			    if (otwOccurred == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT) )
				{
				    keyParameter.keyFunction = KEY_FUNCTION;
				    keyParameter.keyEvent = KEY_SHIFT;
/*					if (shiftStatus == 1)
					{
						shiftStatus = 0;
						VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
					}
					else
					{
						shiftStatus = 1;
						VFDsign |= (sign_SHIFT + sign_SHIFTBL);

					}		*/
				}			
			}
			else
			{
			    if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT) )
				{
				    keyParameter.keyFunction = KEY_FUNCTION;
				    keyParameter.keyEvent = KEY_SHIFT;
				}
			}
		    break;
		case key_METER:	// errorBeepFlag
			if (keyType == KEY23) // BK
			{
				if (errorBeepFlag == 0 && lockStatus == 0 && !(VFDsign & sign_RMT))
				{	
						keyParameter.keyFunction = KEY_FUNCTION;
						keyParameter.keyEvent = KEY_METER;
				}
			}
			else
			{		// ITECH
				if (VFDsign & sign_RMT )
				{
					if (lockStatus == 0 )
					{	
					              // release key [local]
						VFDsign &= ~(sign_RMT | sign_ADDR);
						firstWitchCOM = INITCOM;
						firstGpibPacketChannel = INITPACKET;
						if (parallelMode == ON && parallelRole != MASTER && !(outputStatus & ON_STATE) && slaveState == 1)	 // SLAVE
						{
							VFDsign = VFDsign & (~sign_METER);
							masterState = 0;slaveState = 1;CLR_SLAVE_CONFIGURED;
							slaveNumber = 0;
							memset((void *)&(uartBuffer[RS485_CHANNEL]) ,0, sizeof(UARTx_BUFFER));
							clearSlaveDUT();
							softTimer[SLAVE_COUNT].flag = DISABLE;
						}
					}
					else
					{
						  // release key [local]
						VFDsign &= ~(sign_RMT | sign_ADDR);
				    	lockStatus = 0;
						VFDsign = VFDsign & ~sign_LOCK;
						printVFDsign();
					}
				}
				else
				{
					if (errorBeepFlag == 0)
					{
						if (lockStatus == 0 )
						{	
							keyParameter.keyFunction = KEY_FUNCTION;
							keyParameter.keyEvent = KEY_METER;
						}
					}
				}
			}
			break;
		case key_ONOFF:	// errorBeepFlag
			if (lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
				keyParameter.keyFunction = KEY_FUNCTION;
				keyParameter.keyEvent = KEY_ONOFF;
			}
			break;
        case key_0:	
			if (keyType == KEY23)
			{
		  		if (otwOccurred == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
				{
					if (shiftStatus == 1)
					{
						if (actualState != SELFTEST1 && !(VFDsign & sign_RMT))
						{	
							if (lockStatus == 0)
							{
					   	 		lockStatus = 0x01;
								VFDsign |= sign_LOCK;
							}
							else
							{
								lockStatus = 0;
								VFDsign &= ~(sign_LOCK);
							}
							shiftStatus = 0;
							VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
							reverseState();
							printVFDsign();
							break;
						}
					}
				}
			}	
        case key_1:			 
        case key_2:			 
        case key_3:			 
        case key_4:			 
        case key_5:			  
        case key_6:			 
        case key_7:			 
        case key_8:			 
        case key_9:
			if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
		    	if (IS_SETTING)
				{
			    	keyParameter.keyFunction = KEY_NUMERICAL;
			    	keyParameter.keyEvent = (trigger_id)(keyCode - 1);
				}
			}
		    break;		  
        case key_DP:
  			if (otwOccurred == 0 && keyType == KEY23)
			{
				if (VFDsign & sign_RMT )
				{
					if (lockStatus == 0 )
					{	
								  // release key [local]
						VFDsign &= ~(sign_RMT | sign_ADDR);
						firstWitchCOM = INITCOM;
						firstGpibPacketChannel = INITPACKET;
						if (parallelMode == ON && parallelRole != MASTER && !(outputStatus & ON_STATE) && slaveState == 1)	// SLAVE
						{
	    					VFDsign = VFDsign & (~sign_METER);

							masterState = 0;slaveState = 1;CLR_SLAVE_CONFIGURED;
							slaveNumber = 0;
							memset((void *)&(uartBuffer[RS485_CHANNEL]) ,0, sizeof(UARTx_BUFFER));
							clearSlaveDUT();
							softTimer[SLAVE_COUNT].flag = DISABLE;
						}
					}
					else
					{
						  // release key [local]
						VFDsign &= ~(sign_RMT | sign_ADDR);
			    		lockStatus = 0;
						VFDsign = VFDsign & ~sign_LOCK;
						printVFDsign();
					}
				}
				else
				{
					if (errorBeepFlag == 0)
					{
						if (lockStatus == 0 )
						{	
					    	if (IS_SETTING)
							{
						    	keyParameter.keyFunction = KEY_NUMERICAL;
						   		keyParameter.keyEvent = KEY_DP;
							}
						}
					}
				}
			}
			else
			{
				if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
				{
			    	if (IS_SETTING)
					{
				    	keyParameter.keyFunction = KEY_NUMERICAL;
				   		keyParameter.keyEvent = KEY_DP;
					}
				}
			}
			break;
		case key_UP:
			if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
		   		if (IS_SETTING)
				{
			    	keyParameter.keyFunction = KEY_DIRECTION;
			    	keyParameter.keyEvent = KEY_UP;
				}
			}
			break;
		case key_DOWN:
			if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
		   		if (IS_SETTING)
				{
			    	keyParameter.keyFunction = KEY_DIRECTION;
			    	keyParameter.keyEvent = KEY_DN;
				}
			}
			break;
		case key_LEFT:
			if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
				keyParameter.keyFunction = KEY_DIRECTION;
				keyParameter.keyEvent = KEY_LT;
			}

			break;
		case key_RIGHT:
            if (otwOccurred == 0 && lockStatus == 0 && errorBeepFlag == 0 && !(VFDsign & sign_RMT))
			{
				keyParameter.keyFunction = KEY_DIRECTION;
            	keyParameter.keyEvent = KEY_RT;
			}

			break;
		default:
			   break;	
	}
	if (otwOccurred == 0 && errorBeepFlag == 0 && lockStatus == 0 && !(VFDsign & sign_RMT))
	{
		if (keyType == KEY23)
		{
			if (leftRotary != 0 && IS_SETTING)
			{
			    if (actualState == D_VSET || actualState == D_OVP || actualState == D_OPP || actualState == MENUSYSCOMMLANIPMODE
				|| actualState == MENUSYSCOMMGPIBADDR || actualState == MENUSYSCOMM485BAUD || actualState == MENUSYSCOMM232BAUD || actualState == MENUSYSMEMG || actualState == MENUPVSCURVE
				|| actualState == MENUSYSBEEP || actualState == MENUSYSPONMODE || actualState == MENUSYSPONUDEFONOFF || actualState == MENUCONFLIMITVMIN || actualState == MENUCONFLIMITVMAX
				|| actualState == MENUCONFLIMITPMIN || actualState == MENUCONFLIMITPMAX 
				|| actualState == MENUSYSPONUDEFV || actualState == TIMERONOFF
				|| actualState == MENUCONFPROTOVP || actualState == MENUCONFPROTOCP || actualState == MENUCONFPROTOPP
				|| actualState == MENUCONFPROTCVCC || actualState == MENUCONFPROTCCCV 
				|| actualState == MENUCONFEXTCV || actualState == MENUCONFEXTCI || actualState == MENUCONFEXTCPRANGE 
				|| actualState == MENUCONFEXTCMONRNG || actualState == MENUCONFEXTCSHUT || actualState == MENUCONFEXTCENABLE
				|| actualState == MENUCONFPARAMODE || actualState == MENUCONFPARAROLE || actualState == MENUCONFCHAINMODE || actualState == MENUCONFCHAINADDR
				|| actualState == MENUSYSDEFAULT || actualState == MENUSYSCOMM485PDATA	|| actualState == MENUSYSCOMM232PDATA	|| actualState == MENUSYSCOMM485STOP || actualState == MENUSYSCOMM232STOP
				|| actualState == CALVOLTAGE || actualState == CALCURRENT || actualState == TIMERONOFF || actualState == PROGRAMONOFF || actualState == PROGRAMMODE 
				|| actualState == PROGRAMEDITACT || actualState == PROGRAMREPEAT || actualState == SLEWVOLTAGE || actualState == D_NORMAL || actualState == PROGRAMEDIT
				|| actualState == EXTCALVOLTAGE	|| actualState == EXTCALCURRENT || actualState == TESTEXTVOLT	|| actualState == TESTEXTCURR || actualState == RFACTORY
			  	|| actualState == EXTCALRESVOLTAGE	|| actualState == EXTCALRESCURRENT || actualState == TESTEXTVCC || actualState == TESTEXTICC
				|| actualState == D_ISET || actualState == D_OCP 
				|| actualState == MENUCONFLIMITIMIN || actualState == MENUCONFLIMITIMAX 
				|| actualState == MENUSYSPONUDEFI || actualState == MENUPVS	 || actualState == MENUPVSCURVE
				|| actualState ==SLEWCURRENT || actualState == MENUPVSEDITRECORD1 || actualState == MENUPVSEDITRECORD4 || actualState == MENUPVSCTRLMOD
				) 
				{
				    if (IS_NUMBER == 0)
					{
						if (actualState == D_NORMAL)
						{
							//if (outputStatus & CV_STATE	|| outputStatus & CC_STATE	)   // on the fly
							if ((VFDsign & sign_CV)	|| (VFDsign & sign_CC))
							{
			        			if(leftRotary == 0xFF)
					      		  	keyParameter.keyEvent = KEY_UP;
								else if(leftRotary == 1)
						       		keyParameter.keyEvent = KEY_DN;
								else
									return;
							    setOnTheFly();
								keyParameter.keyFunction = KEY_DIRECTION;
								displayFresh = 1;				
							}	
						}
						else
						{
				        	if(actualState == PROGRAMEDIT && cursorPatternPosition != 0) // stepŪprogram dat
							{
							}
							else
							{
				        		if(leftRotary == 0xFF)
					        		keyParameter.keyEvent = KEY_UP;
								else if(leftRotary == 1)
					       			keyParameter.keyEvent = KEY_DN;
								else
									return;
								keyParameter.keyFunction = KEY_DIRECTION;
								displayFresh = 1;
							}
						}
					}       
				}
			}
		}
		else
		{
			if (leftRotary != 0 && IS_SETTING)
			{
			    if (actualState == D_VSET || actualState == D_OVP || actualState == D_OPP || actualState == MENUSYSCOMMLANIPMODE
				|| actualState == MENUSYSCOMMGPIBADDR || actualState == MENUSYSCOMM485BAUD || actualState == MENUSYSCOMM232BAUD || actualState == MENUSYSMEMG  || actualState == MENUPVSCURVE
				|| actualState == MENUSYSBEEP || actualState == MENUSYSPONMODE || actualState == MENUSYSPONUDEFONOFF || actualState == MENUCONFLIMITVMIN || actualState == MENUCONFLIMITVMAX
				|| actualState == MENUCONFLIMITPMIN || actualState == MENUCONFLIMITPMAX 
				|| actualState == MENUSYSPONUDEFV || actualState == TIMERONOFF
				|| actualState == MENUCONFPROTOVP || actualState == MENUCONFPROTOCP || actualState == MENUCONFPROTOPP
				|| actualState == MENUCONFPROTCVCC || actualState == MENUCONFPROTCCCV 
				|| actualState == MENUCONFEXTCV || actualState == MENUCONFEXTCI || actualState == MENUCONFEXTCPRANGE 
				|| actualState == MENUCONFEXTCMONRNG || actualState == MENUCONFEXTCSHUT || actualState == MENUCONFEXTCENABLE
				|| actualState == MENUCONFPARAMODE || actualState == MENUCONFPARAROLE || actualState == MENUCONFCHAINMODE || actualState == MENUCONFCHAINADDR
				|| actualState == MENUSYSDEFAULT || actualState == MENUSYSCOMM485PDATA	|| actualState == MENUSYSCOMM232PDATA	|| actualState == MENUSYSCOMM485STOP || actualState == MENUSYSCOMM232STOP
				|| actualState == CALVOLTAGE || actualState == CALCURRENT || actualState == TIMERONOFF || actualState == PROGRAMONOFF || actualState == PROGRAMMODE 
				|| actualState == PROGRAMEDITACT || actualState == PROGRAMREPEAT || actualState == SLEWVOLTAGE || actualState == D_NORMAL || actualState == PROGRAMEDIT
				|| actualState == EXTCALVOLTAGE	|| actualState == EXTCALCURRENT || actualState == TESTEXTVOLT	|| actualState == TESTEXTCURR || actualState == RFACTORY || actualState == TESTEXTVCC || actualState == TESTEXTICC
				|| actualState == EXTCALRESVOLTAGE	|| actualState == EXTCALRESCURRENT || actualState == MENUPVS || actualState == MENUPVSCURVE	|| actualState == MENUPVSEDITRECORD1 || actualState == MENUPVSEDITRECORD4 || actualState == MENUPVSCTRLMOD
				) 
				{
				    if (IS_NUMBER == 0)
					{
						if (actualState == D_NORMAL)
						{
							//if (outputStatus & CV_STATE	)   // on the fly
							if (VFDsign & sign_CV)
							{
								if(leftRotary == 1)
					      		  	keyParameter.keyEvent = KEY_UP;
						    	else if(leftRotary == 0xFF)
						       		keyParameter.keyEvent = KEY_DN;
								else
									return;
							    setOnTheFly();
								keyParameter.keyFunction = KEY_DIRECTION;
								displayFresh = 1;				
							}	
						}
						else
						{
				        	if(actualState == PROGRAMEDIT && cursorPatternPosition != 0) // stepŪprogram dat
							{
							}
							else
							{
				        		if(leftRotary == 1)
					        		keyParameter.keyEvent = KEY_UP;
					    		else if(leftRotary == 0xFF)
					       			keyParameter.keyEvent = KEY_DN;
								else
									return;
								keyParameter.keyFunction = KEY_DIRECTION;
								displayFresh = 1;
							}
						}
					}       
				}
			}
			if (rightRotary != 0 && IS_SETTING)
			{
				if(actualState == D_ISET || actualState == D_OCP || actualState == D_OPP || actualState == MENUSYSCOMMLANIPMODE
			   || actualState == MENUSYSCOMMGPIBADDR || actualState == MENUSYSCOMM485BAUD || actualState == MENUSYSCOMM232BAUD || actualState == MENUSYSMEMG || actualState == MENUPVSCURVE
			   || actualState == MENUSYSBEEP || actualState == MENUSYSPONMODE || actualState == MENUSYSPONUDEFONOFF 
			   || actualState == MENUCONFLIMITIMIN || actualState == MENUCONFLIMITIMAX 
			   || actualState == MENUCONFLIMITPMIN || actualState == TIMERONOFF
			   || actualState == MENUCONFLIMITPMAX || actualState == MENUSYSPONUDEFI
			   || actualState == MENUCONFPROTOVP || actualState == MENUCONFPROTOCP || actualState == MENUCONFPROTOPP
			   || actualState == MENUCONFPROTCVCC || actualState == MENUCONFPROTCCCV
			   || actualState == MENUCONFEXTCV || actualState == MENUCONFEXTCI || actualState == MENUCONFEXTCPRANGE 
			   || actualState == MENUCONFEXTCMONRNG || actualState == MENUCONFEXTCSHUT || actualState == MENUCONFEXTCENABLE
			   || actualState == MENUCONFPARAMODE || actualState == MENUCONFPARAROLE || actualState == MENUCONFCHAINMODE || actualState == MENUCONFCHAINADDR
			   || actualState == MENUSYSDEFAULT || actualState == MENUSYSCOMM485PDATA || actualState == MENUSYSCOMM232PDATA	|| actualState == MENUSYSCOMM485STOP  || actualState == MENUSYSCOMM232STOP
			   || actualState == CALVOLTAGE || actualState == CALCURRENT || actualState == TIMERONOFF || actualState == PROGRAMONOFF || actualState == PROGRAMMODE 
			   || actualState == PROGRAMEDITACT || actualState == PROGRAMREPEAT	|| actualState ==SLEWCURRENT || actualState == D_NORMAL	|| actualState == PROGRAMEDIT
			   || actualState == EXTCALVOLTAGE || actualState == EXTCALCURRENT || actualState == TESTEXTVOLT	|| actualState == TESTEXTCURR  || actualState == RFACTORY  || actualState == TESTEXTVCC || actualState == TESTEXTICC
			   || actualState == EXTCALRESVOLTAGE	|| actualState == EXTCALRESCURRENT || actualState == MENUPVS || actualState == MENUPVSCURVE || actualState == MENUPVSEDITRECORD1 || actualState == MENUPVSEDITRECORD4
				)
				{
				    if (IS_NUMBER == 0)
					{
						if (actualState == D_NORMAL)
						{
							//if (outputStatus & CC_STATE)
							if (VFDsign & sign_CC)
							{
				        		if(rightRotary == 1)
					      		  	keyParameter.keyEvent = KEY_UP;
					    		else if(rightRotary == 0xFF)
					       			keyParameter.keyEvent = KEY_DN;
								else
									return;
								setOnTheFly();
				        		keyParameter.keyFunction = KEY_DIRECTION;
								displayFresh = 1;					
							}	
						}
						else
						{
				        	if(actualState == PROGRAMEDIT && cursorPatternPosition != 0) // stepŪprogram dat
							{
							}
							else
							{
				        		if(rightRotary == 1)
					        		keyParameter.keyEvent = KEY_UP;
					    		else if(rightRotary == 0xFF)
					       			keyParameter.keyEvent = KEY_DN;
								else
									return;
				        		keyParameter.keyFunction = KEY_DIRECTION;
								displayFresh = 1;
							}
						}
					}
				}
			}
		}
		if (keyCode) 
		{	 // some key pressed ,
			displayFresh = 1;
			if (softTimer[ERROR_MESSAGE_COUNT].flag == ENABLE)
			{
			    memcpy((void *)(displayBuffer + 19),(void *)displayBufferTemp,29);
			    softTimer[ERROR_MESSAGE_COUNT].flag = DISABLE;
				cursorPosition = cursorPositionTemp;
			}
		}
	}
}
// ѪR@϶ ݰ{{
void flashBlock(uint8_t n)
{
// n == 0 aibuffer
// n == 1 Ȱ{
	switch(cursorPatternPosition)
    {
        case 0:
			if (n == 0)
				memcpy((void *)(displayBuffer + 19),(void *)menuItemBuffer,29);
			setVFDFlashOn(0x54,8);
			 break;
		case 3:
			if (n == 0)
			    memcpy((void *)(displayBuffer + 19),(void *)(menuItemBuffer + 29),29);
		    setVFDFlashOn(0x54,8);
		    break;
		case 6:
			if (n == 0)
			    memcpy((void *)(displayBuffer + 19),(void *)(menuItemBuffer + 58),29);
		    setVFDFlashOn(0x54,8);
		    break;
		case 7:
			if (n == 0)
			    memcpy((void *)(displayBuffer + 19),(void *)(menuItemBuffer + 58),29);
		    setVFDFlashOn(0x5D,9);
			break;
		case 8:
			if (n == 0)
			    memcpy((void *)(displayBuffer + 19),(void *)(menuItemBuffer + 58),29);
		    setVFDFlashOn(0x67,9);
			break;
		case 1:
			if (n == 0)
				memcpy((void *)(displayBuffer + 19),(void *)menuItemBuffer,29);
			setVFDFlashOn(0x5D,9);
			break;
		case 4:
			if (n == 0)
			    memcpy((void *)(displayBuffer + 19),(void *)(menuItemBuffer + 29),29);
		    setVFDFlashOn(0x5D,9);
		    break;
		case 2:
			if (n == 0)
			    memcpy((void *)(displayBuffer + 19),(void *)menuItemBuffer,29);
			setVFDFlashOn(0x67,8);
		    break;
	    case 5:
			if (n == 0)
		        memcpy((void *)(displayBuffer + 19),(void *)(menuItemBuffer + 29),29);
		    setVFDFlashOn(0x67,8);
		break;
	}																						  
}
#define	TESTBYTE	0x1FFC
	uint8_t backup,data = 0 ,data1 = 0x55;
uint32_t eepStatus;
void selftestNestHandler(void)
{
	setVFDFlashOff(0x40, 48);
	switch(menuLevelPosition )
	{
	    case 0:	// in th first layer
			menuLevel1 = cursorPatternPosition;
			cursorPatternPosition = menuLevel2;
			menuLevelPosition++; // entry second layer
			switch(menuLevel1)
			{
			    case 0:	// EEPROM
				    sprintf((void *)(displayBuffer + 8), "EEPROM  ");
					eepStatus = eepRead((uint8_t *)&backup , TESTBYTE , sizeof(uint8_t));
					if ( eepStatus == sEE_OK)
					{
						eepWrite((uint8_t *)&data1 , TESTBYTE , sizeof(uint8_t));	
						eepRead((uint8_t *)&data , TESTBYTE , sizeof(uint8_t));
						eepWrite((uint8_t *)&backup , TESTBYTE , sizeof(uint8_t));
						if (data == data1)
							sprintf((void *)(displayBuffer + 19), " EEPROM  OK                  ");
					}
					else
						sprintf((void *)(displayBuffer + 19), " EEPROM  FAIL                ");
					actualState = TESTEEPROM;
				    break;
				case 1:	// 
				    sprintf((void *)(displayBuffer + 8), "EX_CTRL ");
					POWER_OK_HIGH;
					delayMs(10);
					if (ENABLE_CPU_PIN == SET)
					{
						POWER_OK_LOW;
						delayMs(10);
						if (ENABLE_CPU_PIN == RESET)
							sprintf((void *)(displayBuffer + 19), "16-1 OK   ");
						else
							sprintf((void *)(displayBuffer + 19), "16-1 FAIL ");
					}
					else
						sprintf((void *)(displayBuffer + 19), "16-1 FAIL ");

					LOCAL_ANALOG_STATE_HIGH;
					delayMs(10);
					if (SHUTOFF_CPU_PIN == SET)
					{
						LOCAL_ANALOG_STATE_LOW;
						delayMs(10);
						if (SHUTOFF_CPU_PIN == RESET)
							sprintf((void *)(displayBuffer + 19+10), "21-15 OK  ");
						else
							sprintf((void *)(displayBuffer + 19+10), "21-15 FAIL");
					}
					else
						sprintf((void *)(displayBuffer + 19+10), "21-15 FAIL");

					CV_CC_STATE_HIGH;
					delayMs(10);
					if (LOCANA_CPU_PIN == SET)
					{
						CV_CC_STATE_LOW;
						delayMs(10);
						if (LOCANA_CPU_PIN == RESET)
							sprintf((void *)(displayBuffer + 19+20), "13-8 OK  ");
						else
							sprintf((void *)(displayBuffer + 19+20), "13-8 FAIL");
					}
					else
						sprintf((void *)(displayBuffer + 19+20), "13-8 FAIL");
					actualState = TESTEXTCTRL;
				    break;
				case 2:	// EXT_VOLT
					sprintf((void *)(displayBuffer + 8), "EX_VOLT ");
					VOL_RES_SEL_LOW;
					dacControl(DAC_VOLTAGE,(uint16_t)(DAC1V),ON); // eX1V	 AD
					if (IS_FAT_CAL)
						eepRead((uint8_t *)&extCalV[0] , EE_FAT_EXTCALV_0 , sizeof(float) * 2);
					else
						eepRead((uint8_t *)&extCalV[0] , EE_USER_EXTCALV_0 , sizeof(float) * 2);
					presentPoint = 1; 
					sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalV[presentPoint - 1]); // ഫ 1.xx Vk
					sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalV[presentPoint - 1]);
					actualState = TESTEXTVOLT;
					setInputParameter(0x59,6,FLOAT,NULL ,(1+0.1) , 1-0.1);	//Jd 0.9 ~1.1V
					softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ; // ȥ
					break;
				case 3:	// EXT_CURR
					sprintf((void *)(displayBuffer + 8), "EXT_CURR");
					CURR_RES_SEL_LOW;
					dacControl(DAC_CURRENT,(uint16_t)(DAC1V),ON); // 1V
					if (IS_FAT_CAL)
						eepRead((uint8_t *)&extCalI[0] , EE_FAT_EXTCALI_0 , sizeof(float) * 2);
					else
						eepRead((uint8_t *)&extCalI[0] , EE_USER_EXTCALI_0 , sizeof(float) * 2);
					presentPoint = 1;
					sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalI[presentPoint - 1]); // ഫ 1.xx Vk
					sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalI[presentPoint - 1]);
					setInputParameter(0x59,6,FLOAT,NULL ,(1+0.1) , 1-0.1);	//Jd 0.9 ~1.1V
					softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ; // ȥ
					actualState = TESTEXTCURR;
					break;
				case 4:	// UART1				P 606 measurement   P609 GPIB/LAN
					 
					sprintf((void *)(displayBuffer + 8), "P606  P609 ");
					uartTransmit(MEASURE_CHANNEL,UI_TEST_INTMEASURE,strlen(UI_TEST_INTMEASURE));
					delayMs(100);
					if (strcmp((void *)uartBuffer[GPIB_LAN_CHANNEL].rxBuffer	,UI_TEST_INTMEASURE) == 0)
						sprintf((void *)(displayBuffer + 19), "606-->609 OK   ");
					else
						sprintf((void *)(displayBuffer + 19), "606-->609 FAIL ");

					uartTransmit(GPIB_LAN_CHANNEL,UI_TEST_INTGPIBLAN,strlen(UI_TEST_INTGPIBLAN));
					delayMs(100);
					if (strcmp((void *)uartBuffer[MEASURE_CHANNEL].rxBuffer	,UI_TEST_INTGPIBLAN) == 0)
						sprintf((void *)(displayBuffer + 34), "606<--609 OK  ");
					else
						sprintf((void *)(displayBuffer + 34), "606<--609 FAIL");
					memset(uartBuffer, 0, sizeof(UARTx_BUFFER)*COM_MAX);		// Clear uartBuffer[COM1] to uartBuffer[COM6]
					actualState = TESTUART1;
					break;
				case 5:	// UART2	  P612  RS232   P602 RS485
 					sprintf((void *)(displayBuffer + 8), "P612  P602 ");
					uartTransmit(RS232_CHANNEL,UI_TEST_EXT232,strlen(UI_TEST_EXT232));
					delayMs(50);
					if (strcmp((void *)uartBuffer[RS485_CHANNEL].rxBuffer	,(void *)(UI_TEST_EXT232)) == 0)
						sprintf((void *)(displayBuffer + 19), "612-->602 OK   ");
					else
						sprintf((void *)(displayBuffer + 19), "612-->602 FAIL ");
					uartTransmit(RS485_CHANNEL,UI_TEST_EXT485,strlen(UI_TEST_EXT485));
					delayMs(50);
					if (strcmp((void *)uartBuffer[RS232_CHANNEL].rxBuffer	,(void *)(UI_TEST_EXT485)) == 0)
						sprintf((void *)(displayBuffer + 34), "612<--602 OK  ");
					else
						sprintf((void *)(displayBuffer + 34), "612<--602 FAIL");
					memset(uartBuffer, 0, sizeof(UARTx_BUFFER)*COM_MAX);		// Clear uartBuffer[COM1] to uartBuffer[COM6]
					actualState = TESTUART2;
					break;
				case 6:
					sprintf((void *)(displayBuffer + 8),"VOLTAGE CC ");
					VOL_RES_SEL_HIGH;
					CURR_RES_SEL_LOW;
					if (IS_FAT_CAL)
						eepRead((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
					else
						eepRead((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
					sprintf((void *)(displayBuffer + 19),"  Meter:%6.5f mA          ",voltagerescurr); 
					sprintf(KEYINBUF,"%6.5f",voltagerescurr);
					actualState = TESTEXTVCC;
					setInputParameter(0x5B,7,FLOAT,NULL ,1.05 , 1.01);	//Jd 0.9 ~1.1V
					break;
				case 7:
				    sprintf((void *)(displayBuffer + 8),"CURRENT CC  ");
					VOL_RES_SEL_LOW;
					CURR_RES_SEL_HIGH;
					if (IS_FAT_CAL)
						eepRead((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
					else
						eepRead((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
					sprintf((void *)(displayBuffer + 19),"  Meter:%6.5f mA          ",currentrescurr); 
					sprintf(KEYINBUF,"%6.5f",currentrescurr);
					actualState = TESTEXTICC;
					setInputParameter(0x5B,7,FLOAT,NULL ,1.05 , 1.01);	//Jd 0.9 ~1.1V
					break;
				case 8:	  //EXIT
					NVIC_SystemReset(); // software reset
					break;
			}
			break;
	}
}

// slew _Bz
void slewNestHandler(void)
{
	setVFDFlashOff(0x40, 48);
	switch(menuLevelPosition )
	{
	    case 0:	// in th first layer
			menuLevel1 = cursorPatternPosition;
			cursorPatternPosition = menuLevel2;
			menuLevelPosition++; // entry second layer
			switch(menuLevel1)
			{
			    case 0:	// SLEWVOLTAGE
				    sprintf((void *)(displayBuffer + 19), " VOLTAGE:%4.1fV/mS              ",master.SRvSet  );
					setInputParameter(0x5C,4,FLOAT,NULL,VSRMax,VSRMIN); // 4V/ms
					sprintf(KEYINBUF,"%4.1f",master.SRvSet);
					actualState = SLEWVOLTAGE;
				    break;
				case 1:	// SLEWCURRENT
				    sprintf((void *)(displayBuffer + 19), " CURRENT:%4.1fmA/mS             ",master.SRiSet  );
					setInputParameter(0x5C,4,FLOAT,NULL,ISRMax,ISRMIN); //20mA.mS  ~ 0.3mA
					sprintf(KEYINBUF,"%4.1f",master.SRiSet);
					actualState = SLEWCURRENT;
				    break;
			}
			break;
	}
}


// menu _Bz
void menuNestHandler(void)
{
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
	{
		if (lastState == D_MENU)
		{
			if (cursorPatternPosition == SYSTEM	 || cursorPatternPosition == CALIBRATION) // SYSTEM P CAL iiJ
			{
				reverseState();
				return ;
			}
		}
		else if (lastState == MENUCONF1)
		{
			if (cursorPatternPosition == EXTCTRL) // EXTCTRL ~դi]w
			{
				reverseState();
				return;
			}
		}		
//		if (menuLevel1 == 0 && menuLevel2 == 0 && (cursorPatternPosition == 0 || cursorPatternPosition == 4))	// SYSTEM P CAL iiJ
//		{
//			reverseState();
//			return;
//		}
//		else if(menuLevel1 == 1 && menuLevel1 == 0 &&cursorPatternPosition == 2) // EXTCTRL ~դi]w
//		{
//			reverseState();
//			return;
//		} 
	}	
	setVFDFlashOff(0x40, 48);
	switch(menuLevelPosition )
	{
	    case 0:	// in th first layer
			menuLevel1 = cursorPatternPosition;
			cursorPatternPosition = menuLevel2;
			menuLevelPosition++; // entry second layer
			switch(menuLevel1)
			{
				case SYSTEM:
					sprintf((void *)displayBuffer,"MENU SYS           ");
					strcpy((void *)menuItemBuffer,"   COMM  |  MEMORY |  BEEP  ><DEFAULT | PON STAT|         ");
					cursorItemNumber = 5;  // 5   (COMM)  (MEMORY GROUP)  (BEEP)   (FACTORY DEFAULT)  (POWER ON STATE)
   					flashBlock(0);
		    	    actualState = MENUSYS1;
					break;
		        case CONFIG:
                    sprintf((void *)displayBuffer,"MENU CONF          ");
			        strcpy((void *)menuItemBuffer,"  LIMIT  | PROTECT | EXTCTRL><PARALLEL|         |         ");
					cursorItemNumber = 4;  // 5   (LIMIT)  (PROTECT)  (EXT.CONTROL)  (Paeallel)   (Chain)
					flashBlock(0);				                
					actualState =  MENUCONF1;
		            break;
				case PVS:
					sprintf((void *)displayBuffer,"MENU PV SIM        ");
					parameterTemp = pvsONOFF;
					sprintf((void *)(displayBuffer + 19),"   %s    CURVE:%3d     EDIT " ,pvsONOFF > OFF ? " ON":"OFF",curve + 1);
					if (curve == PVS_CURVE_USER)
						memcpy((void *)(displayBuffer + 19 + 16),"TAB ",4);
					cursorPatternPosition = 0;
					SET_SETTING;
			    	SET_STRING;
			    	cursorPosition = 0;
					setVFDFlashOn(0x56 ,3);
					actualState = MENUPVS;
					break;
			    case INFO:
                    sprintf((void *)displayBuffer,"MENU INFO          ");
			        sprintf((void *)menuItemBuffer," MODEL:                     >");
					memcpy((void *)(menuItemBuffer+7),&model[0],strlen((void *)model));
					sprintf((void *)(menuItemBuffer+29),   "<FIRMWARE VER.:             >");
					memcpy((void *)(menuItemBuffer+29+15),VERSION,strlen(VERSION));
					sprintf((void *)(menuItemBuffer+2*29) ,"<RS485:");
					switch(R485Baud)
					{
					    case 3:
					        sprintf((void *)(menuItemBuffer+2*29+7) ,"57600,");
							break;
					    case 2:
					        sprintf((void *)(menuItemBuffer+2*29+7) ,"38400,");
							break;
					    case 1:
					        sprintf((void *)(menuItemBuffer+2*29+7) ,"19200,");
							break;
					    case 0:
					        sprintf((void *)(menuItemBuffer+2*29+7) ," 9600,");
							break;
					}
 				    switch(rs485parityDataBits)
					{
					    case 0:
					        sprintf((void *)(menuItemBuffer+2*29+13) ,"NONE,8,");
							break;
					    case 1:
					        sprintf((void *)(menuItemBuffer+2*29+13) ,"EVEN,8,");
							break;
					    case 2:
					        sprintf((void *)(menuItemBuffer+2*29+13) ," ODD,8,");
							break;
					    case 3:
					        sprintf((void *)(menuItemBuffer+2*29+13) ,"EVEN,7,");
							break;
					    case 4:
					        sprintf((void *)(menuItemBuffer+2*29+13) ," ODD,7,");
							break;
					}
    				switch(rs485stopBits)
					{
					    case 0:
					        sprintf((void *)(menuItemBuffer+2*29+20) ,"1,");
							break;
					    case 1:
					        sprintf((void *)(menuItemBuffer+2*29+20) ,"2,");
							break;
					}
					sprintf((void *)(menuItemBuffer+2*29+22),"ADD %.2d>",chainAddr);
					sprintf((void *)(menuItemBuffer+3*29) ,"<RS232:");
					switch(R232Baud)
					{
					    case 3:
					        sprintf((void *)(menuItemBuffer+3*29+7) ,"57600,");
							break;
					    case 2:
					        sprintf((void *)(menuItemBuffer+3*29+7) ,"38400,");
							break;
					    case 1:
					        sprintf((void *)(menuItemBuffer+3*29+7) ,"19200,");
							break;
					    case 0:
					        sprintf((void *)(menuItemBuffer+3*29+7) ," 9600,");
							break;
					}
 				    switch(rs232parityDataBits)
					{
					    case 0:
					        sprintf((void *)(menuItemBuffer+3*29+13) ,"NONE,8,");
							break;
					    case 1:
					        sprintf((void *)(menuItemBuffer+3*29+13) ,"EVEN,8,");
							break;
					    case 2:
					        sprintf((void *)(menuItemBuffer+3*29+13) ," ODD,8,");
							break;
					    case 3:
					        sprintf((void *)(menuItemBuffer+3*29+13) ,"EVEN,7,");
							break;
					    case 4:
					        sprintf((void *)(menuItemBuffer+3*29+13) ," ODD,7,");
							break;
					}
    				switch(rs232stopBits)
					{
					    case 0:
					        sprintf((void *)(menuItemBuffer+3*29+20) ,"1       >");
							break;
					    case 1:
					        sprintf((void *)(menuItemBuffer+3*29+20) ,"2       >");
							break;
					}
					sprintf((void *)(menuItemBuffer+4*29), "<OPT. INSTALLED:%s >",optCard > 0 ? "GPIB   /LAN":"NONE       ");
					if (optCard > 0)
					{
						sprintf((void *)(menuItemBuffer+4*29 +21),"%.2d/LAN",GPIBAddr);
	                    sprintf((void *)(menuItemBuffer+5*29) ,"<MACaddr:%.2x:%.2x:%.2x:%.2x:%.2x:%.2x  >",MACaddress[0],MACaddress[1],MACaddress[2],MACaddress[3],MACaddress[4],MACaddress[5]);
						sprintf((void *)(menuItemBuffer+6*29), "<IP MODE:%s             >",LANIPMode > 0? "MANUAL":"AUTO  " );
						sprintf((void *)(menuItemBuffer+7*29) ,"<IP ADDR:%.3d.%.3d.%.3d.%.3d    >",currentLANIPAddr[0],currentLANIPAddr[1],currentLANIPAddr[2],currentLANIPAddr[3]);
		                sprintf((void *)(menuItemBuffer+8*29) ,"<IP MASK:%.3d.%.3d.%.3d.%.3d    >",currentLANMask[0],currentLANMask[1],currentLANMask[2],currentLANMask[3]);
	                    sprintf((void *)(menuItemBuffer+9*29) ,"<GATEWAY:%.3d.%.3d.%.3d.%.3d     ",currentLANGateway[0],currentLANGateway[1],currentLANGateway[2],currentLANGateway[3]);
						cursorItemNumber = 10;  // 10   (Model)  (F/W/ Ver.)  (Option indtslled)  (Curr. IP Mode) (Curr. IP Addr.) (Curr. IP Mask) (Curr. GatWay) (Curr. R485Baud Rate) (Curr. Rs232 Baud Rate)
					}
					else
					{
						sprintf((void *)(menuItemBuffer+4*29), "<OPT. INSTALLED:%s  ",optCard > 0 ? "GPIB   /LAN":"NONE       ");
						cursorItemNumber = 5;  // 10   (Model)  (F/W/ Ver.)  (Option indtslled)  (Curr. IP Mode) (Curr. IP Addr.) (Curr. IP Mask) (Curr. GatWay) (Curr. R485Baud Rate) (Curr. Rs232 Baud Rate)
					}
					memcpy((void *)(displayBuffer + 19),(void *)menuItemBuffer,29);
			        actualState = MENUINFOMODEL;
					flashLength[0] = 0;flashLength[1] = 0;flashLength[2] = 0;flashLength[3] = 0;flashLength[4] = 0;flashLength[5] = 0;  // F{{
					break;
				case CALIBRATION:
				    if (lastState == D_MENU)
					{
						strcpy((void *)(displayBuffer),"MENU CAL           ");
					    strcpy((void *)(displayBuffer + 19)," PLEASE INPUT PASSWORD:      ");
						strcpy(KEYINBUF,"AAAAA");
						actualState =  PASSWORD;
						passwordLength = 0;
					    cursorPosition = 0x6A;
						CLR_FAT_CAL;
						SET_SETTING;
					}
					else
					{
//							uint8_t buffer[10];
							strcpy((void *)displayBuffer,"CALIBRATION       ");
							cursorPosition = 0;
							actualState =  CAL;
							presentPoint = 1;	
							CLR_SETTING;
							if (IS_FAT_FINAL_CAL)
							{
								CLR_FAT_FINAL_CAL; //siJեA
							}
							// send output off
							onoffStatus = 0;
							verifyInput(OUTPUT_CMD,(float)onoffStatus );  //o@BO² initialzeMB(); IOX

							// ^Wh ˬdprotsw A  } m
			 				eepRead((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
							verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
							if (protsw != 0)
							{
 								
								ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
								if (protsw & BIT7)
								{
									ProtOVActivation = 1;
									verifyInput(OVPSET_CMD,master.OVPSet );
								}
								if (protsw & BIT6)
								{
									ProtOCActivation = 1;
									verifyInput(OCPSET_CMD,master.OCPSet );
								}
								if (protsw & BIT5)
								{
									ProtOPActivation = 1;
									verifyInput(OPPSET_CMD,master.OPPSet );
								}
								if (protsw & BIT4)
									CVtoCCActivation = 1;
								if (protsw & BIT3)
								    CCtoCVActivation = 1;
							}
							flashBlock(0);

//	debug ADC						for (d = 0 ;d < 1000 ;d++)
//							{
//								sprintf((void *)buffer ,"%d\r\n",Databuf[d]);
//								usbCdcTx((void *)buffer,strlen((void *)buffer));
//								delayMs(2);
//							}
//							d = 0;

					}
				    break;
	        }// end of switch(menuLevel1)
	        break;
        case 1:	 // in the second layer
		    menuLevel2 = cursorPatternPosition;
		    cursorPatternPosition = menuLevel3;
		    menuLevelPosition++; // entry 3th layer
		    switch(menuLevel1)
		    {
		        case SYSTEM:
		            switch(menuLevel2)
			        {
                        case COMM:
						    sprintf((void *)menuItemBuffer,"   GPIB  |   LAN   |  RS485 ><  RS232 |         |         ");
	        	            cursorItemNumber = 4;  // 4   (GPIB)  (LAN)  (RS485)  (RS232)
				            actualState = MENUSYSCOMM; 
							if (IS_RESTART_GPIB)
							{
							    CLR_RESTART_GPIB;
								GPIBLANRestart();// GPIB LAN}	
							}  
							sprintf((void *)displayBuffer,"MENU SYS COMM      ");
							flashBlock(0);        
				            break;
                        case MEMORY_GROUP:
						    sprintf((void *)(displayBuffer+19)," MEMORY GROUP:               ");
							sprintf(KEYINBUF,"%.1d", groupNumber);
							displayBuffer[19 + 15] = groupNumber + 0x30;// ASCII
							parameterTemp = groupNumber;
							setInputParameter(0x62,1,INTEGER,NULL , 9 , 0);
							actualState = MENUSYSMEMG;
				            break;     
                        case BEEP:
						    parameterTemp = beepActivation;
						    sprintf((void *)(displayBuffer+19)," BEEP:%s                    ",beepActivation > OFF ? " ON":"OFF");
							setVFDFlashOn(0x59, 3);
							SET_STRING;
							SET_SETTING;  // OƦrק
							actualState = MENUSYSBEEP;
				            break;             
                        case FACTORY_DEFAULT:
						    parameterTemp = 0;
						    sprintf((void *)(displayBuffer+19)," FACTORY DEFAULT:%s         ",parameterTemp > 0 ? "YES":" NO");
							setVFDFlashOn(0x64, 3);
							SET_STRING;
							SET_SETTING;  // OƦrק
							actualState = MENUSYSDEFAULT;
				            break;  
                        case POWER_ON_STATE:
							sprintf((void *)displayBuffer,"MENU SYS PON STAT  ");
						    sprintf((void *)menuItemBuffer,"   MODE  |         |         ");
							cursorItemNumber = 1;
							if (powerOnMode == 2) // USER
							{
								sprintf((void *)menuItemBuffer,"   MODE  |  V SET  |  I SET >< ON OFF |         |         ");
                                 cursorItemNumber = 4;  // 
							}
							flashBlock(0);
                            actualState = MENUSYSPON;																
				            break;   
			        }
		            break;
		        case CONFIG:
		            switch(menuLevel2)
			        {
                        case LIMIT:
		                    sprintf((void *)displayBuffer,"MENU CONF LIMIT    ");
							strcpy((void *)menuItemBuffer,"  V MIN 	|  V MAX  |  I MIN >< I MAX  |         |         ");
							cursorItemNumber = 4;//6;  // 6  P MIN  P MAX  ̨\   
	                        actualState = MENUCONFLIMIT;     
				            break;
                        case PROTECT:
    		                sprintf((void *)displayBuffer,"MENU CONF PROTECT  ");
							strcpy((void *)menuItemBuffer,"   OVP   |   OCP   |   OPP  >< CV->CC |  CC->CV |         ");
							cursorItemNumber = 5;  // 6    
							actualState = MENUCONFPROT;
				            break;     
                        case EXTCTRL:
                            sprintf((void *)displayBuffer,"MENU CONF EXTCTRL  ");
							strcpy((void *)menuItemBuffer," ENABLE  | VOLTAGE | CURRENT><PROG RNG| MON RNG |SHUT OFF ");
							cursorItemNumber = 6;  // 6    
							actualState = MENUCONFEXT;
				            break;             
                        case PARALLEL:
		                    sprintf((void *)displayBuffer,"MENU CONF PARALLEL ");
							strcpy((void *)menuItemBuffer,"   ROLE  |   MODE  |         ");
							cursorItemNumber = 2;      
						    actualState = MENUCONFPARALLEL;
				            break;  
                        case CHAIN:
		                    sprintf((void *)displayBuffer,"MENU CONF CHAIN    ");
							strcpy((void *)menuItemBuffer,"   MODE  |  ADDR   |         ");
							cursorItemNumber = 2;      
						    actualState = MENUCONFCHAIN;
				            break;   
			        }
    				flashBlock(0);
		            break;
				case PVS:
					switch(menuLevel2)
					{
						case 0:
							pvsONOFF = parameterTemp;
							if (pvsONOFF == ON)		//֫]ִNDv
							{
								timerONOFF = OFF;
								programONOFF = OFF;
 								extEnable = OFF;
								eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
								extVMode = 0;
								eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
								extIMode = 0;
								eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
								queryCurveparrmeter();
								sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
								delayMs(50);
								sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

								if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
								{
									masterState = BROADCAST;
									rs485Temp.unionbyte.byte_loc[0] = curve; //s curve
									rs485Temp.cmd = CMD_SETPVCURV;
									cmdexenum = MASTERSETINT8;
									SET_PARALLEL_GPVPARM;					 //bs rule vmp pmp material
								}
								sprintf((void *)(displayBuffer + 19),"CONTROL MODE: %s            " ,pvCtrlMode > 0 ? "CV":"CC");
								actualState	= MENUPVSCTRLMOD;
								parameterTemp = pvCtrlMode;
								setVFDFlashOn(0x61,2);
							}
							else
							{
								
								sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
								delayMs(50);
								sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

								if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
								{
									masterState = BROADCAST;
									rs485Temp.unionbyte.byte_loc[0] = curve; //s curve
									rs485Temp.cmd = CMD_SETPVCURV;
									cmdexenum = MASTERSETINT8;
									SET_PARALLEL_GPVPARM;					 //bs rule vmp pmp material
								}
								setVFDFlashOff(0x40,48);
   								VFDsign &= ~(sign_MENU);
								memset((void *)displayBuffer,' ',48);
								menuLevel1 = 0;
								menuLevel2 = 0;
								menuLevel3 = 0;
								menuLevel4 = 0;
								cursorPatternPosition = 0;
								menuLevelPosition = 0;
    							shiftStatus = 0;
								VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
								CLR_FROM_MENU;
								actualState = D_NORMAL;
								cursorPosition = 0;
								CLR_SETTING;
								CLR_STRING;
								CLR_NUMBER;
								checkPowerOnState();
							}
							break;
						case 1:// curve
							curve = parameterTemp;
							menuLevelPosition--;
							if (curve <= 100 || curve == 255)
							{
								cursorPatternPosition = 2;
								cursorPosition = 0;
								setVFDFlashOn(0x53+24,4);
								actualState = MENUPVSEDIT;
								SET_STRING;
							}
							else
							{
								parameterTemp = pvsONOFF;
								cursorPatternPosition = 0;
								SET_SETTING;
			    				SET_STRING;
			    				cursorPosition = 0;
								setVFDFlashOn(0x56 ,3);
								actualState = MENUPVS;
							}
							break;
						case 2:	 // EDIT
							if (curve != 0xFF) // not in TABLE 
							{
								delayMs(10);
								queryCurveparrmeter();
								sprintf((void *)displayBuffer,"PV SIM CURVE:%3d  ",curve + 1);
								if (curve == PVS_CURVE_USER)
									memcpy((void *)(displayBuffer +	14  ),"TAB",3);
								sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
								transRuleMaterialPattern();
								memcpy((void *)(displayBuffer+19),(void *)pvsBuffer,29);
								setInputParameter(0x53 + 6,1,INTEGER,NULL ,9 , 0);
								sprintf(KEYINBUF,"%1d",(uint8_t)Rule);
								actualState = MENUPVSEDITRECORD1;
								CLR_NUMBER;
								CLR_STRING; 
							}
							else
							{
							   cursorPatternPosition = 2;
								 menuLevel3 = 0;
								 menuLevelPosition = 1;
							   setVFDFlashOn(0x53+24 ,4);
							   cursorPosition = 0;
							   SET_STRING;
 								 reverseState();
							}
							break;
					}
					break;
		        case INFO:
					break;
				case CALIBRATION:
					if (protsw != 0) // editken
					{
						protsw = 0;	  // iJեɥOVP ,OCP
						verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
						ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
				    }
					switch(menuLevel2)
					{
					    case 0:
							calVoltageInit();
						    memcpy((void *)displayBuffer,"CALIBRATION VOLTAGE",19);
							vMeter = (vCal[presentPoint - 1] * master.vMax)/fullScale;
							switch(presentPoint)
							{
								case 1:
									if (voltPoint == 1)
									{
										sprintf(KEYINBUF,"%5.2f",vMeter);
										setInputParameter(0x59+2,5,FLOAT,NULL ,master.vMax*V_POINT1_MAX ,master.vMax*V_POINT1_MIN); // 0.05
									}
									else if(voltPoint == 2)
									{	
										sprintf(KEYINBUF,"%5.2f",vMeter);
										setInputParameter(0x59+1,5,FLOAT,NULL ,master.vMax*V_POINT1_MAX ,master.vMax*V_POINT1_MIN); // 0.05
									}
									adRangeLow = VADLOW1;adRangeHigh = VADHIGH1;//1500;
									break;
								case 2:
									if (voltPoint == 1)
									{
										sprintf(KEYINBUF,"%6.2f",vMeter);
										setInputParameter(0x59+1,6,FLOAT,NULL ,master.vMax*V_POINT2_MAX , master.vMax*V_POINT2_MIN);//0.33
									}
									else if(voltPoint == 2)
									{
										sprintf(KEYINBUF,"%6.2f",vMeter);
										setInputParameter(0x59,6,FLOAT,NULL ,master.vMax*V_POINT2_MAX , master.vMax*V_POINT2_MIN);//0.33
									}
									adRangeLow = VADLOW2;adRangeHigh = VADHIGH2;//9500;
									break;
								case 3:
									if (voltPoint == 1)
									{
										sprintf(KEYINBUF,"%6.2f",vMeter);
										setInputParameter(0x59+1,6,FLOAT,NULL ,master.vMax*V_POINT3_MAX , master.vMax*V_POINT3_MIN);//0.066
									}
									else if(voltPoint == 2)
									{
										sprintf(KEYINBUF,"%6.2f",vMeter);
										setInputParameter(0x59,6,FLOAT,NULL ,master.vMax*V_POINT3_MAX , master.vMax*V_POINT3_MIN);//0.066
									}
									adRangeLow = VADLOW3;adRangeHigh = VADHIGH3;//18000;
									break;
								case 4:
 									if (voltPoint == 1)
									{
										sprintf(KEYINBUF,"%6.2f",vMeter);
										setInputParameter(0x59+1,6,FLOAT,NULL ,master.vMax * V_POINT4_MAX , master.vMax*V_POINT4_MIN);  //0.95
									}
									else if(voltPoint == 2)
									{
										sprintf(KEYINBUF,"%6.2f",vMeter);
										setInputParameter(0x59,6,FLOAT,NULL ,master.vMax * V_POINT4_MAX, master.vMax*V_POINT4_MIN);  //0.95
									}
									adRangeLow = VADLOW4;adRangeHigh = VADHIGH4;//25500;
									break;
							}
							vMeter = atof(KEYINBUF);
							actualState = CALVOLTAGE;
							setTimerCount();
							displayFresh = 0; //GN
						    break;
						case 1:
							calCurrentInit();
						    memcpy((void *)displayBuffer,"CALIBRATION CURRENT",19);
							iMeter = (iCal[presentPoint - 1] * master.iMax)/fullScale;
							sprintf(KEYINBUF,(void *)currDisp[currPoint],iMeter);
							iMeter = atof(KEYINBUF);
							actualState = CALCURRENT;
							switch(presentPoint)
							{
							    case 1:
									if (machine1000 == 0) // 1000V
										setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_1000POINT1_MAX , master.iMax*I_1000POINT1_MIN);  // 11.9%~5.94%
									else
										setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_POINT1_MAX , master.iMax*I_POINT1_MIN);      // 4 %
									adRangeLow = IADLOW1;adRangeHigh = IADHIGH1;
									break;
								case 2:
									setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_POINT2_MAX , master.iMax*I_POINT2_MIN);	// 33 %
									adRangeLow = IADLOW2;adRangeHigh = IADHIGH2;
									break;
								case 3:
									setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_POINT3_MAX , master.iMax*I_POINT3_MIN);		// 66 %
									adRangeLow = IADLOW3;adRangeHigh = IADHIGH3;
									break;
								case 4:
									setInputParameter(0x59,7,FLOAT,NULL ,master.iMax* I_POINT4_MAX, master.iMax*I_POINT4_MIN);				// 95 %
									adRangeLow = IADLOW4;adRangeHigh = IADHIGH4;
								break;
							}
 							setTimerCount();
							displayFresh = 0; //GN
						    break;
						case 2: // OVP CAL
							memcpy((void *)displayBuffer,"CALIBRATION OVP    ",19);
							if (protsw != 0) // editken
							{
								protsw = 0;
								verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
								ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
							}
							strcpy((void *)(displayBuffer+19),"     [OK]=Execute,[ESC]=Exit ");
							if (keyType == KEY23)
								memcpy((void *)(displayBuffer + 21),"[Enter]", 7);
							SET_CAL_NOW;
							calState = 5; // into standby
							actualState = CALOVP;
						    break;
						case 3:	// OCP CAL
							memcpy((void *)displayBuffer,"CALIBRATION OCP    ",19);
							if (protsw != 0) // editken
							{
								protsw = 0;
								verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
								ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
							}
							strcpy((void *)(displayBuffer+19),"     [OK]=Execute,[ESC]=Exit ");
							if (keyType == KEY23)
								memcpy((void *)(displayBuffer + 21),"[Enter]", 7);
							SET_CAL_NOW;
							calState = 5; // into standby
							actualState = CALOCP;
						    break;
						case 4:
						    memcpy((void *)displayBuffer,"CAL. EXT CTRL VOLT ",19);
							VOL_RES_SEL_LOW;
							dacControl(DAC_VOLTAGE,(uint16_t)(DAC1V),ON); // eX1V	 AD
							if (IS_FAT_CAL)
								eepRead((uint8_t *)&extCalV[0] , EE_FAT_EXTCALV_0 , sizeof(float) * 2);
							else
								eepRead((uint8_t *)&extCalV[0] , EE_USER_EXTCALV_0 , sizeof(float) * 2);
							presentPoint = 1; 
							sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalV[presentPoint - 1]); // ഫ 1.xx Vk
							sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalV[presentPoint - 1]);
							actualState = EXTCALVOLTAGE;
							setInputParameter(0x59,6,FLOAT,NULL ,(1+0.1) , 1-0.1);	//Jd 0.9 ~1.1V
							softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ; // ȥ
						    break;
						case 5:
						    memcpy((void *)displayBuffer,"CAL. EXT CTRL CURR ",19);
							CURR_RES_SEL_LOW;
							dacControl(DAC_CURRENT,(uint16_t)(DAC1V),ON); // 1V
							if (IS_FAT_CAL)
								eepRead((uint8_t *)&extCalI[0] , EE_FAT_EXTCALI_0 , sizeof(float) * 2);
							else
								eepRead((uint8_t *)&extCalI[0] , EE_USER_EXTCALI_0 , sizeof(float) * 2);
							presentPoint = 1;
							sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalI[presentPoint - 1]); // ഫ 1.xx Vk
							sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalI[presentPoint - 1]);
							actualState = EXTCALCURRENT;
							setInputParameter(0x59,6,FLOAT,NULL ,(1+0.1) , 1-0.1);	//Jd 0.9 ~1.1V
							softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ; // ȥ
						    break;
						case 6:
						    memcpy((void *)displayBuffer,"CAL. VOLTAGE CC    ",19);
							VOL_RES_SEL_HIGH;
							CURR_RES_SEL_LOW;
							if (IS_FAT_CAL)
								eepRead((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
							else
								eepRead((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
							sprintf((void *)(displayBuffer + 19),"  Meter:%6.5f mA          ",voltagerescurr); 
							sprintf(KEYINBUF,"%6.5f",voltagerescurr);
							actualState = EXTCALRESVOLTAGE;
							setInputParameter(0x5B,7,FLOAT,NULL ,1.05 + 0.45 , 1.01 - 0.45);	//Jd 0.9 ~1.1V
							break;
						case 7:
						    memcpy((void *)displayBuffer,"CAL. CURRENT CC    ",19);
							CURR_RES_SEL_HIGH;
							VOL_RES_SEL_LOW;
							if (IS_FAT_CAL)
								eepRead((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
							else
								eepRead((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
							sprintf((void *)(displayBuffer + 19),"  Meter:%6.5f mA          ",currentrescurr); 
							sprintf(KEYINBUF,"%6.5f",currentrescurr);
							actualState = EXTCALRESCURRENT;
							setInputParameter(0x5B,7,FLOAT,NULL ,1.05 + 0.45  , 1.01 - 0.45);	//Jd 0.9 ~1.1V
							break;
						case 8:// Restre factory cal
							parameterTemp = 0; //ȥ
							sprintf((void *)(displayBuffer + 19),"RESTORE FACTORY CAL.:%s     ",parameterTemp > 0 ? "YES":" NO"); 
							setVFDFlashOn(0x68,3);
							actualState = RFACTORY;
							SET_STRING;
							SET_SETTING;
							break;
					}		
					break;
			}
			break;
		case 2:
	    	menuLevel3 = cursorPatternPosition;
	    	cursorPatternPosition = menuLevel4; //0 EDIT
	    	menuLevelPosition++;
	    	switch(menuLevel1)
	    	{
		    	case SYSTEM:
			    	switch(menuLevel2)
			    	{
                    	case COMM:
				        	setVFDFlashOff(0x40, 0x30);
				        	switch(menuLevel3)
					    	{
					        	case 0: // GPIB
							    	parameterTemp = GPIBAddr;
									sprintf(KEYINBUF,"%.2d",parameterTemp);
				                	sprintf((void *)(displayBuffer+19)," GPIB ADDR: %.2d               ",parameterTemp);
				                	setInputParameter(0x5F,2,INTEGER,NULL ,30 , 1);
			                    	actualState = MENUSYSCOMMGPIBADDR;
							    	break;
						    	case 1: // LAN
                                	sprintf((void *)displayBuffer,"MENU SYS COM LAN   ");
									strcpy((void *)menuItemBuffer,"   MODE  |         |         ");
									cursorItemNumber = 0;
									if (backupLANIPMode != LANIPMode)
										SET_RESTART_GPIB;
									backupLANIPMode = LANIPMode;
									if (LANIPMode == 1) //MENUAL
									{
						            	strcpy((void *)menuItemBuffer,"   MODE  | IP ADDR | IP MASK><IP GWAY |         |         ");
						            	cursorItemNumber = 4;      															  		    		 			
					            	}
									actualState = MENUSYSCOMLAN;
    								flashBlock(0);
						        	break;
						    	case 2: // RS485
									eepRead((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t));
									eepRead((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t));
									eepRead((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t));
									initializeRs485();
	                            	sprintf((void *)displayBuffer,"MENU SYS COM RS485 ");
									strcpy((void *)menuItemBuffer,"   BAUD  |  DATA B | STOP B ><  ADDR  |  CHAIN  |         ");
									cursorItemNumber = 5;
									if (cursorPatternPosition >= cursorItemNumber)
									    cursorPatternPosition = 0;
									actualState = MEMUSYSCOMRS485;
    								flashBlock(0);
						        	break;
								case 3: // RS232
	                            	sprintf((void *)displayBuffer,"MENU SYS COM RS232 ");
									strcpy((void *)menuItemBuffer,"   BAUD  |  DATA B | STOP B                                ");
									cursorItemNumber = 3;
									if (cursorPatternPosition >= cursorItemNumber)
									    cursorPatternPosition = 0;
									actualState = MEMUSYSCOMRS232;
    								flashBlock(0);
									break;
				        	}		            
			            	break;
                    	case MEMORY_GROUP:
			            	break;     
                    	case BEEP:
			            	break;             
                    	case FACTORY_DEFAULT:
			            	break;  
                    	case POWER_ON_STATE:
				        	switch(menuLevel3)
					    	{
						    	case 0: // MODE
					            	parameterTemp = powerOnMode;
									strcpy((void *)(displayBuffer + 19)," POWER ON STATE:              "); 
						        	switch(powerOnMode)
						        	{
						            	case 0:
							            	memcpy((void *)(displayBuffer + 19 + 16),"OFF ",4);
								        	break;
							        	case 1:
							            	memcpy((void *)(displayBuffer + 19 + 16),"LAST",4);
							            	break;
							        	case 2:
							            	memcpy((void *)(displayBuffer + 19 + 16),"USER",4);
							            	break;
						        	}
						        	setVFDFlashOn(0x63, 4);	   
						        	actualState = MENUSYSPONMODE;
						        	SET_STRING;
							    	break;
								case 1:	 // V set
									memset((void *)(displayBuffer + 19) ,' ',29);
							    	sprintf(KEYINBUF,(void *)voltDisp[voltPoint],powerOnVolt);
									strcpy((void *)displayBuffer,"MENU SYS PON USER	");
									sprintf((void *)(displayBuffer + 19 + 1),"Vset:");
									sprintf((void *)(displayBuffer + 19 + 6), (void *)voltDispUnit[voltPoint],powerOnVolt );
									actualState = MENUSYSPONUDEFV;
									setInputParameter(0x59,6,FLOAT,LIMIT_COMPARE ,master.limitVMax ,master.limitVMin);
							    	break;
								case 2:	   // I set
									memset((void *)(displayBuffer + 19) ,' ',29);
									sprintf(KEYINBUF,(void *)currDisp[currPoint],powerOnCurrent);
									strcpy((void *)displayBuffer,"MENU SYS PON USER	");
									sprintf((void *)(displayBuffer + 19 + 1),"Iset:");
									sprintf((void *)(displayBuffer + 19 + 6), (void *)currDispUnit[currPoint],powerOnCurrent );
									if (slaveNumber > 0)
										setInputParameter(0x59,7,FLOAT,LIMIT_COMPARE ,sumiMax() ,sumiMin());
									else
										setInputParameter(0x59,7,FLOAT,LIMIT_COMPARE ,master.limitIMax  ,master.limitIMin );
									actualState = MENUSYSPONUDEFI;
							    	break;
								case 3:	  // ON  OFF
									parameterTemp = powerOn_OnOff;
									strcpy((void *)displayBuffer,"MENU SYS PON USER	");
									strcpy((void *)(displayBuffer + 19)," USER ON OFF STATE:              "); 
						        	switch(powerOn_OnOff)
						        	{
						            	case 0:
							            	memcpy((void *)(displayBuffer + 19 + 19),"OFF ",4);
								        	break;
							        	case 1:
							            	memcpy((void *)(displayBuffer + 19 + 19)," ON ",4);
							            	break;
						        	}
						        	setVFDFlashOn(0x66, 4);	   
									SET_STRING;
									actualState = MENUSYSPONUDEFONOFF;
									break;
							}
							SET_SETTING;
					    	break;   
					}// end of 	switch(menuLevel2)
					break;
		    	case CONFIG:
			    	switch(menuLevel2)
			    	{
                    	case LIMIT: 
				        	switch(menuLevel3)
					    	{
						    	case 0:
						        	sprintf((void *)(displayBuffer + 19),  " VOLATGE MIN:");
									sprintf((void *)(displayBuffer + 19 + 13),(void *)voltDispUnit[voltPoint], master.limitVMin);
						        	sprintf(KEYINBUF, (void *)voltDisp[voltPoint], master.limitVMin);
									actualState = MENUCONFLIMITVMIN;
									setInputParameter(0x60,6,FLOAT,NULL ,master.vMax ,master.vMin);
									break;
								case 1:
						        	sprintf((void *)(displayBuffer + 19),  " VOLATGE MAX:");
									sprintf((void *)(displayBuffer + 19 + 13),(void *)voltDispUnit[voltPoint], master.limitVMax);
						        	sprintf(KEYINBUF, (void *)voltDisp[voltPoint], master.limitVMax);
									actualState = MENUCONFLIMITVMAX;
									setInputParameter(0x60,6,FLOAT,NULL ,master.vMax ,master.vMin); // koben 1050
							    	break;
								case 2:
									sprintf((void *)(displayBuffer + 19),  " CURRENT MIN:");
									sprintf((void *)(displayBuffer + 19 + 13),(void *)currDispUnit[currPoint], /* sumlimitIMin() */ master.limitIMin  * (slaveNumber + 1));
						        	sprintf(KEYINBUF, (void *)currDisp[currPoint], /* sumlimitIMin() */master.limitIMin  * (slaveNumber + 1) );
									actualState = MENUCONFLIMITIMIN;
									setInputParameter(0x60,7,FLOAT,NULL ,sumiMax() ,sumiMin() );
							    	break;
								case 3:
									sprintf((void *)(displayBuffer + 19),  " CURRENT MAX:");
									sprintf((void *)(displayBuffer + 19 + 13),(void *)currDispUnit[currPoint],/* sumlimitIMax() */  master.limitIMax  * (slaveNumber + 1) );
							    	sprintf(KEYINBUF, (void *)currDisp[currPoint], /* sumlimitIMax() */  master.limitIMax  * (slaveNumber + 1)  );
									actualState = MENUCONFLIMITIMAX;
									setInputParameter(0x60,7,FLOAT,NULL,sumiMax(),sumiMin() );
							    	break;
							}
							sprintf((void *)(displayBuffer + 19 + 21),"        ");
							SET_SETTING;	
					   		break;
                    	case PROTECT:
					    	switch(menuLevel3)
					    	{
						    	case 0:
           	                    	parameterTemp = ProtOVActivation;
						        	sprintf((void *)(displayBuffer + 19), " OVP:   %s                  ",ProtOVActivation > OFF ? " ON":"OFF");
									actualState = MENUCONFPROTOVP;
									break;
								case 1:
		    	  					parameterTemp = ProtOCActivation;
							    	sprintf((void *)(displayBuffer + 19), " OCP:   %s                  ",ProtOCActivation > OFF ? " ON":"OFF");
									actualState = MENUCONFPROTOCP;
							    	break;
								case 2:
									parameterTemp = ProtOPActivation;
				                	sprintf((void *)(displayBuffer + 19), " OPP:   %s                  ",ProtOPActivation > OFF ? " ON":"OFF");
									actualState = MENUCONFPROTOPP;
								    break;
								case 3:
									parameterTemp = CVtoCCActivation;
					                sprintf((void *)(displayBuffer + 19), " CV->CC:%s                  ",CVtoCCActivation > OFF ? " ON":"OFF");
									actualState = MENUCONFPROTCVCC;
								    break;
								case 4:
				    				parameterTemp = CCtoCVActivation;
					                sprintf((void *)(displayBuffer + 19), " CC->CV:%s                  ",CCtoCVActivation > OFF ? " ON":"OFF");
									actualState = MENUCONFPROTCCCV;
								    break;
							}
							setVFDFlashOn(0x5B, 3); 
							SET_SETTING;	
							SET_STRING;
				            break;     
                	    case EXTCTRL:
					        switch(menuLevel3)
						    {
							    case 1:
           		                    parameterTemp = extVMode;
							        sprintf((void *)(displayBuffer + 19), " VOLATGE:                    ");
							        switch(extVMode)
							        {
						    	        case 0:
							    	        memcpy((void *)(displayBuffer + 19 + 9) ,"FRONT",5);
							        	    break;
								        case 1:
									        memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-V",5);
								            break;
								        case 2:
									        memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-R",5);
								            break;
							        }
									actualState = MENUCONFEXTCV;
									break;
								case 2:
		    						parameterTemp = extIMode;
						            sprintf((void *)(displayBuffer + 19), " CURRENT:                    ");
							        switch(extIMode)
							        {
							            case 0:
								            memcpy((void *)(displayBuffer + 19 + 9) ,"FRONT",5);
								            break;
								        case 1:
									        memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-V",5);
								            break;
								        case 2:
									        memcpy((void *)(displayBuffer + 19 + 9) ,"EXT-R",5);
							        	    break;
							        }
									actualState = MENUCONFEXTCI;
								    break;
								case 3:
			    					parameterTemp = extProgRange;
						            sprintf((void *)(displayBuffer + 19)," PROGRAM RANGE:%s       ",extProgRange > 0? "10V/10K":" 5V/5K ");
									actualState = MENUCONFEXTCPRANGE;
								    break;
								case 4:
									parameterTemp = extMonRange;
							        sprintf((void *)(displayBuffer + 19)," MONITOR RANGE:%s           ",extMonRange > 0? "10V":" 5V");
									actualState = MENUCONFEXTCMONRNG;
								    break;
								case 5:
									parameterTemp = extShutOffLogic;
						    	    sprintf((void *)(displayBuffer + 19)," SHUT-OFF LOGIC(LOW):%s ",extShutOffLogic > FALLING_EDGE? " ON/Low":"OFF/Low");
									actualState = MENUCONFEXTCSHUT;
								    break;
								case 0:
									parameterTemp = extEnable;
							        sprintf((void *)(displayBuffer + 19)," ENABLE:");
									switch(parameterTemp)
									{
										case OFF:
											sprintf((void *)(displayBuffer + 19 + 8),"NOT ACTIVE            ");
											break;
										case AMODE:
											sprintf((void *)(displayBuffer + 19 + 8),"ACTIVE-AMODE          ");
											break;
										case BMODE:
											sprintf((void *)(displayBuffer + 19 + 8),"ACTIVE-BMODE          ");
											break;
									}
									actualState = MENUCONFEXTCENABLE;
									SET_SETTING;
									break;
							}
							flashPosition[0] = 0x5B;flashPosition[1] = 0x5C;flashPosition[2] = 0x5C;flashPosition[3] = 0x62;flashPosition[4] = 0x62;flashPosition[5] = 0x68;
							flashLength[0] = 12;flashLength[1] = 5;flashLength[2] = 5;flashLength[3] = 7;flashLength[4] = 3;flashLength[5] = 7;
							setVFDFlashOn(flashPosition[menuLevel3], flashLength[menuLevel3]);
							SET_SETTING;	
							SET_STRING;
							break;             
	                    case PARALLEL:
					        switch(menuLevel3)
						    {
							    case 1:
									parameterTemp = parallelMode;
						            sprintf((void *)(displayBuffer + 19),  " MODE:%s                   ",parallelMode > OFF ? " ON":"OFF");
									actualState = MENUCONFPARAMODE;
						    	    break;
								case 0:
									parameterTemp =	 parallelRole;
									if (parameterTemp == MASTER)
									    sprintf((void *)(displayBuffer + 19 )," ROLE: MASTER        ");
									else
									sprintf((void *)(displayBuffer + 19 )," ROLE: SLAVE %d      ",parameterTemp);
									actualState = MENUCONFPARAROLE;
								    break;
							}
							flashPosition[0] = 0x59;flashPosition[1] = 0x59;
							flashLength[1] = 3;flashLength[0] = 9;
							setVFDFlashOn(flashPosition[menuLevel3], flashLength[menuLevel3]);
							SET_SETTING;	
							SET_STRING;
							break;  
        	            case CHAIN:
							switch(menuLevel3)
							{
							    case 0:
									parameterTemp = chainMode;
					        	    sprintf((void *)(displayBuffer + 19),  "CHAIN:%s                    ",chainMode > OFF ? " ON":"OFF");
						        	setVFDFlashOn(0x59, 3);
									actualState = MENUCONFCHAINMODE;
								    SET_STRING;
								    break;
								case 1:
									parameterTemp = chainAddr;
									sprintf(KEYINBUF,"%.2d",parameterTemp);
					    	        sprintf((void *)(displayBuffer + 19),  " ADDR:      %.2d               ",chainAddr);
									setInputParameter(0x5F,2,INTEGER,NULL ,30 , 1);
									actualState = MENUCONFCHAINADDR;
								    break;
							}
							SET_SETTING;	
						    break;   
			    	}// switch of 	switch(menuLevel2)					  
					break;
				case PVS:
					switch(menuLevel2)
			    	{
						case 0:
							pvCtrlMode = parameterTemp;
							sendMBStateSetting(MEASURE_CHANNEL,PVCTRLMOD_CMD, pvCtrlMode);
							if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
							{
								masterState = BROADCAST;
								rs485Temp.unionbyte.byte_loc[0] = pvCtrlMode;
								rs485Temp.cmd = CMD_SETPVCTRLMOD;
								cmdexenum = MASTERSETINT8;
//								SCPI_485SlaveInt8(CMD_SETPVCTRLMOD ,RS485_CHAINBROADCAST ,pvCtrlMode);
							}
							pvCtrlMode = 0;
							delayMs(30);
							sendMBQuery(MEASURE_CHANNEL,PVCTRLMODQ_CMD);	 //E3
							delayMs(30);
							while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
							{
								uartBuffer[MEASURE_CHANNEL].packetCount--;
								receiveMBResponse(MEASURE_CHANNEL);
							}
							setVFDFlashOff(0x40,48);
							VFDsign &= ~(sign_MENU);
							memset((void *)displayBuffer,' ',48);
							menuLevel1 = 0;
							menuLevel2 = 0;
							menuLevel3 = 0;
							menuLevel4 = 0;
							cursorPatternPosition = 0;
							menuLevelPosition = 0;
   							shiftStatus = 0;
							VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
							CLR_FROM_MENU;
							actualState = D_NORMAL;
							cursorPosition = 0;
							CLR_SETTING;
							CLR_STRING;
							CLR_NUMBER;
							break;
					}
					break;	  
		    }// switch of switch(menuLevel1)
		    break;
		case 3:
			menuLevel4 = cursorPatternPosition;
			cursorPatternPosition = 0;
			menuLevelPosition++;
			switch(menuLevel1)
			{
		    	case SYSTEM:
		        	switch(menuLevel2)
			    	{
				    	case COMM:
					    	switch(menuLevel3)
							{	
								case 0:	  //GPIB
						        	break;
						    	case 1: //LAN
							    	switch(menuLevel4)
									{
								    	case 0://MODE
											SET_RESTART_GPIB;
									    	parameterTemp = LANIPMode;
						                	sprintf((void *)(displayBuffer+19)," LAN IP MODE: %s         ",parameterTemp > 0 ? "MANUAL":"  AUTO");
						                	setVFDFlashOn(0x61, 6);
					                    	actualState = MENUSYSCOMMLANIPMODE;
											SET_SETTING;
											SET_STRING;	// OƦrק
									    	break;
										case 1:
											SET_RESTART_GPIB; // configed IP again
			                            	memcpy((void *)LANIPAddrTemp,(void *)LANIPAddr,4);
			                            	sprintf((void *)(displayBuffer + 19) ," LAN IP ADDR:%.3d.%.3d.%.3d.%.3d ",LANIPAddrTemp[0],LANIPAddrTemp[1],LANIPAddrTemp[2],LANIPAddrTemp[3]);
					                    	actualState = MENUSYSCOMMLANIPADDR;
											setInputParameter(0x60 + (memSysCommIpPosition * 4),3,INTEGER,PT_SHIFT_RIGHT ,255 ,0);
			                            	sprintf(KEYINBUF ,"%.3d",LANIPAddrTemp[memSysCommIpPosition]);
											break;
										case 2:
											SET_RESTART_GPIB; // configed IP again
			                            	memcpy((void *)LANMaskTemp,(void *)LANMask,4);
			                            	sprintf((void *)(displayBuffer + 19) ," LAN IP MASK:%.3d.%.3d.%.3d.%.3d ",LANMaskTemp[0],LANMaskTemp[1],LANMaskTemp[2],LANMaskTemp[3]);
					                    	actualState = MENUSYSCOMMLANMASK;
         	                            	setInputParameter(0x60 + (memSysCommIpPosition * 4),3,INTEGER,PT_SHIFT_RIGHT , 255 ,0);
			                            	sprintf(KEYINBUF ,"%.3d",LANMaskTemp[memSysCommIpPosition]);
											break;
										case 3:
											SET_RESTART_GPIB;// configed IP again
			                            	memcpy((void *)LANGatewayTemp,(void *)LANGateway,4);
			                            	sprintf((void *)(displayBuffer + 19) ," LAN GATEWAY:%.3d.%.3d.%.3d.%.3d ",LANGatewayTemp[0],LANGatewayTemp[1],LANGatewayTemp[2],LANGatewayTemp[3]);
					                    	actualState = MENUSYSCOMMLANGWAY;
         	                            	setInputParameter(0x60 + (memSysCommIpPosition * 4),3,INTEGER,PT_SHIFT_RIGHT, 255 , 0);
			                            	sprintf(KEYINBUF ,"%.3d",LANGatewayTemp[memSysCommIpPosition]);
											break;
									}
							    	break;
								case 2:	  // 485
							    	switch(menuLevel4)
									{
								    	case 0://BAUD
								            parameterTemp = R485Baud;
					                        sprintf((void *)(displayBuffer+19)," RS485 BAUD:                 ");
					                        switch(parameterTemp)
					                        {
					                            case 3:
					                                sprintf((void *)(displayBuffer+19+13) ,"57600");
							                        break;
					                            case 2:
					                                sprintf((void *)(displayBuffer+19+13) ,"38400");
							                        break;
					                            case 1:
					                                sprintf((void *)(displayBuffer+19+13),"19200");
							                        break;
					                            case 0:
					                                sprintf((void *)(displayBuffer+19+13) ," 9600");
							                        break;
					                        }
					                        setVFDFlashOn(0x60, 5);
					                        actualState = MENUSYSCOMM485BAUD;
									        SET_STRING;
									        SET_SETTING; // OƦrק  
										    break;
										case 1:	// Parity Bit / Data bits
											parameterTemp = rs485parityDataBits;
											sprintf((void *)(displayBuffer+19)," PARITY/DATA BITS:           ");
					                        switch(parameterTemp)
					                        {
					                            case 0:
					                                sprintf((void *)(displayBuffer+19+18) ,"NONE/8 BITS");
							                        break;
					                            case 1:
					                                sprintf((void *)(displayBuffer+19+18) ,"EVEN/8 BITS");
							                        break;
						                        case 2:
						                            sprintf((void *)(displayBuffer+19+18) ," ODD/8 BITS");
							                        break;
						                        case 3:
						                            sprintf((void *)(displayBuffer+19+18) ,"EVEN/7 BITS");
							                        break;
							                    case 4:
							                        sprintf((void *)(displayBuffer+19+18) ," ODD/7 BITS");
							                        break;
							                }
											setVFDFlashOn(0x65, 12);
											actualState = MENUSYSCOMM485PDATA;
											SET_STRING;
											SET_SETTING; // OƦrק  
											break;
										case 2:	// Stop bits
										    parameterTemp = rs485stopBits;
											sprintf((void *)(displayBuffer+19)," STOP BITS: %s                ",parameterTemp > 0 ? "2":"1");
										    setVFDFlashOn(0x5f, 1);
										    actualState = MENUSYSCOMM485STOP;
										    SET_STRING;
										    SET_SETTING; // OƦrק  
											break;
										case 3: // CHAIN ADD
 											parameterTemp = chainAddr;
											sprintf(KEYINBUF,"%.2d",parameterTemp);
					       				    sprintf((void *)(displayBuffer + 19),  " ADDR:      %.2d               ",chainAddr);
											setInputParameter(0x5F,2,INTEGER,NULL ,30 , 1);
											actualState = MENUCONFCHAINADDR;
											SET_SETTING; // OƦrק
											break;
										case 4: // CHAIN MODE
											parameterTemp = chainMode;
					    			        sprintf((void *)(displayBuffer + 19),  "CHAIN:%s                   ",chainMode > OFF ? " ON":"OFF");
						 			        setVFDFlashOn(0x59, 3);
											actualState = MENUCONFCHAINMODE;
							    			SET_STRING;	
											SET_SETTING;										
											break;
									}// switch of menuLevel4
									break;
								case 3:	// RS232
								    switch(menuLevel4)
									{
									    case 0://BAUD
								            parameterTemp = R232Baud;
					                        sprintf((void *)(displayBuffer+19)," RS232 BAUD:                 ");
					                        switch(parameterTemp)
					                        {
					                            case 3:
					                                sprintf((void *)(displayBuffer+19+13) ,"57600");
							                        break;
					                            case 2:
					                                sprintf((void *)(displayBuffer+19+13) ,"38400");
							                        break;
					                            case 1:
					                                sprintf((void *)(displayBuffer+19+13),"19200");
							                        break;
					                            case 0:
					                                sprintf((void *)(displayBuffer+19+13) ," 9600");
							                        break;
					                        }
					                        setVFDFlashOn(0x60, 5);
					                        actualState = MENUSYSCOMM232BAUD;
									        SET_STRING;
									        SET_SETTING; // OƦrק  
										    break;
										case 1:	// Parity Bit / Data bits
											parameterTemp = rs232parityDataBits;
											sprintf((void *)(displayBuffer+19)," PARITY/DATA BITS:           ");
					                        switch(parameterTemp)
					                        {
					                            case 0:
					                                sprintf((void *)(displayBuffer+19+18) ,"NONE/8 BITS");
							                        break;
					                            case 1:
					                                sprintf((void *)(displayBuffer+19+18) ,"EVEN/8 BITS");
							                        break;
						                        case 2:
						                            sprintf((void *)(displayBuffer+19+18) ," ODD/8 BITS");
							                        break;
						                        case 3:
						                            sprintf((void *)(displayBuffer+19+18) ,"EVEN/7 BITS");
							                        break;
							                    case 4:
							                        sprintf((void *)(displayBuffer+19+18) ," ODD/7 BITS");
							                        break;
							                }
											setVFDFlashOn(0x65, 12);
											actualState = MENUSYSCOMM232PDATA;
											SET_STRING;
											SET_SETTING; // OƦrק  
											break;
										case 2:	// Stop bits
										    parameterTemp = rs232stopBits;
											sprintf((void *)(displayBuffer+19)," STOP BITS: %s                ",parameterTemp > 0 ? "2":"1");
										    setVFDFlashOn(0x5f, 1);
										    actualState = MENUSYSCOMM232STOP;
										    SET_STRING;
										    SET_SETTING; // OƦrק  
											break;
									}// switch of menuLevel4
									break;								
							} // switch of menuLevel3
							break;
						case POWER_ON_STATE:
							switch(menuLevel3)
							{
								case 0:
									break;
								case 1:
									break;
								case 2:
									break;
								case 3:// ON OFF
									powerOn_OnOff = parameterTemp;
									eepWrite((uint8_t *)&powerOn_OnOff, EE_POWERON_ONOFF ,sizeof(uint8_t)); // user on off control
									gotoUpLayer();
									gotoUpLayer();
									break;
							}
							break;
			    } // switch of menuLevel2
				break;
			} // switch of menuLevel1
	    	break;			 
    }// switch of switch(menuLevelPosition )
}
//_^WhBz
void gotoUpLayer(void)	// ^W@h
{
    CLR_DEBUG;
    dpFlag = 0;
    CLR_SETTING;
	CLR_STRING;
	setVFDFlashOff(0x40,48);
    if (actualState == D_ESC && IS_NUMBER)
	{
		CLR_NUMBER;
		reverseState();
		if (actualState == PROGRAMEDIT || actualState == PROGRAMEDITACT)
		{
			actualState = D_OK;
			lastState = PROGRAMMODE;
			menuLevel2 = cursorPatternPosition;
            cursorPatternPosition = menuLevel1;	 //EDIT
	    	SET_CHANGE;
	    	initializePVSState();
			return;
		}
		else if(actualState == PROGRAMREPEAT)
		{
			actualState = D_OK;
			lastState = PROGRAMEDIT;
			menuLevel3 = cursorPatternPosition;
            cursorPatternPosition = menuLevel2;	 
			sprintf(KEYINBUF,"%5.1f",timer);
	    	SET_CHANGE;
	    	initializePVSState();
			return;
		}
		else
		{
			if (menuLevelPosition > 0)
		    	menuLevelPosition--;
			switch(menuLevelPosition)
			{
		    	case 3:
 		        	cursorPatternPosition = menuLevel4;
					break;
		    	case 2:
		        	cursorPatternPosition = menuLevel3;
			    	break;
		    	case 1:
		        	cursorPatternPosition = menuLevel2;
					break;
		    	case 0:
			    	cursorPatternPosition = menuLevel1;
					break;
			}
		}
		if (actualState == SLEWVOLTAGE || actualState == SLEWCURRENT)
			slewNestHandler();
		else
		{
    		SET_CHANGE;
    		initializePVSState();
		}
		return;
	}
	CLR_NUMBER;
	memSysCommIpPosition = 0;
	cursorPosition = 0; // cursorOFF
	if (lastState == PROGRAMEDIT || lastState == PROGRAMEDITACT)
	{
	    cursorPatternPosition = menuLevel1; // EDIT
		actualState = PROGRAMMODE; 
	}
	else if(lastState == PROGRAMREPEAT)
	{
		actualState = D_OK;
		lastState = PROGRAMMODE;
		menuLevel2 = 0;//cursorPatternPosition;
	    cursorPatternPosition = menuLevel1; 
	}
	else
	{
    	if (menuLevelPosition > 1)
		{
	    	menuLevelPosition -= 2;
			switch(menuLevelPosition)
			{
		    	case 3:
 		        	cursorPatternPosition = menuLevel4;
					break;
		    	case 2:
		        	cursorPatternPosition = menuLevel3;
			    	break;
		    	case 1:
		        	cursorPatternPosition = menuLevel2;
					break;
		    	case 0:
			    	cursorPatternPosition = menuLevel1;
					break;
			}
	    	menuNestHandler();		
			return;
		}
    	else if (menuLevelPosition == 1)
		{
	    	menuLevelPosition--;
            if (lastState == SLEWCURRENT || lastState == SLEWVOLTAGE)
				actualState = SLEW;
			else	 
			    actualState = D_MENU; 
		}    		
    	else
    	{
 			if (IS_FROM_MENU) // Xmenu ~^_
			{
				parallelInitRun();
				if (pvsONOFF == OFF)
				{
					if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
						eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
					if (master.iSet > master.limitIMax)
					{
						master.iSet = master.limitIMax;
						eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
					}
					if (master.iSet < master.limitIMin)
					{
						master.iSet = master.limitIMin;
						eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
					}					
					if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
						eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
					eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));		
				}
			// send SRvSet						
				verifyInput(VSRSET_CMD,master.SRvSet );
			// send SRiSet						
				verifyInput(ISRSET_CMD,master.SRiSet );
			// send output off
				if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
				{
					if (powerOnMode == 1) // LAST
						eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
				}
  			}
			if (actualState != SET_ONOFF_FLAG)
			{
				CLR_FROM_MENU;
				if (lastState == TIMERRUNNING )
				{
					if ((int32_t)runningTimer > 0)
						actualState = D_NORMAL;//TIMERRUNNING;
				    else
					{
						actualState = D_NORMAL;	// OVP or OCP occur
						return;
					}	
				}
				else
				{
					if (actualState == PROGRAMREADY)
						return;
					else
					{
						if (actualState == D_PARALLELSLAVE)
							return;
						else	 
   							actualState = D_NORMAL;

					}
				}
			}
			VFDsign &= ~(sign_MENU);
			memset((void *)displayBuffer,' ',48);
			menuLevel1 = 0;
			menuLevel2 = 0;
			menuLevel3 = 0;
			menuLevel4 = 0;
			cursorPatternPosition = 0;
    	}
    }
	setVFDFlashOff(0x40, 0x30);
    SET_CHANGE;
    initializePVSState();
}

#define CALTIME		15000
uint8_t t,k = 99;

// ѪR᪺ʧ@
void initializePVSState(void)
{
    if (IS_CHANGE == 0) {
	}
	else
	{


		CLR_CHANGE;
        switch (actualState)
        {
			case SELFTEST2:
				displayFresh = 1;
				VFDsign = 0x0000FFFF;
				if (keyType == KEY23)
				{
					sprintf((void *)displayBuffer,"0123456789. MEN ENT");
					sprintf((void *)(displayBuffer + 19),"VS IS RE ESC     R+ R- PRG   ");
					displayBuffer[32] = 0xD3; // 
					displayBuffer[34] = 0xD4; // k
				}
				else
				{
					sprintf((void *)displayBuffer,"0123456789. OK1 OK2");
					sprintf((void *)(displayBuffer + 19),"             L+ L- R+ R-     ");
					displayBuffer[23] = 0xAA; // W
					displayBuffer[25] = 0xA9; // U
					displayBuffer[27] = 0xD3; // 
					displayBuffer[29] = 0xD4; // k
				}
				break;
			case SELFTEST1:
				VFDsign = 0xFFFF0000;	  // G
				for(t = 0,k = 198;t < 48 ; t++)
					displayBuffer[t] = k;		
				break;
			case D_VSET:
#ifndef  MB_NOT_IN
				clearMeasureCommand();
#endif
				if (extEnable > OFF)
				{
					if (controlState == ANALOG_CTRL && extVMode >= 1)
						reverseState();
					else
					{
   				    	VFDsign |= sign_VSET;
				    	sprintf((void *)(displayBuffer+19), " Vset:");
						sprintf((void *)(displayBuffer +19 +6),(void *)voltDispUnit[voltPoint], master.vSet);
			   		 	sprintf(KEYINBUF, (void *)voltDisp[voltPoint], master.vSet);
						setInputParameter(0x59,6,FLOAT,LIMIT_COMPARE ,master.limitVMax ,master.limitVMin);
					}
				}
				else if(pvsONOFF == ON)
					reverseState();
				else
				{
   			    	VFDsign |= sign_VSET;
			    	sprintf((void *)(displayBuffer+19), " Vset:");
					sprintf((void *)(displayBuffer +19 +6),(void *)voltDispUnit[voltPoint], master.vSet);
					sprintf((void *)(displayBuffer+19+14)," ");
			    	sprintf(KEYINBUF, (void *)voltDisp[voltPoint], master.vSet);
					setInputParameter(0x59,6,FLOAT,LIMIT_COMPARE ,master.limitVMax ,master.limitVMin);
				}				
				break;
			case D_ISET:
#ifndef  MB_NOT_IN
				clearMeasureCommand();
#endif

				if (extEnable > OFF)
				{
					if (controlState == ANALOG_CTRL && extIMode >= 1)
						reverseState();
					else
					{
	   			    	VFDsign |= sign_ISET;
				    	sprintf((void *)(displayBuffer+19), " Iset:");
						sprintf((void *)(displayBuffer+19+6) ,(void *)currDispUnit[currPoint], master.iSet);
						sprintf((void *)(displayBuffer+19+14)," ");
				    	sprintf(KEYINBUF, (void *)currDisp[currPoint], master.iSet);
						setInputParameter(0x59,7,FLOAT,LIMIT_COMPARE ,master.limitIMax  ,master.limitIMin );
					}
				}
				else if (pvsONOFF == ON)
					reverseState();
				else
				{
   			    	VFDsign |= sign_ISET;
			    	sprintf((void *)(displayBuffer+19), " Iset:");
					sprintf((void *)(displayBuffer+19+6) ,(void *)currDispUnit[currPoint],  sumiSet() );
					sprintf((void *)(displayBuffer+19+14)," ");
			    	sprintf(KEYINBUF, (void *)currDisp[currPoint],  sumiSet() );

//					if (sumiMax() < (master.OCPSet * (slaveNumber + 1)) || (ProtOCActivation == 0))
						setInputParameter(0x59,7,FLOAT,LIMIT_COMPARE ,sumlimitIMax() , sumlimitIMin() );
//					else
//						setInputParameter(0x59,7,FLOAT,LIMIT_COMPARE ,(master.OCPSet * (slaveNumber + 1)) , sumlimitIMin() /*(master.limitIMin * (slaveNumber + 1)) */);	// ISET RO ij OCP 
					displayBuffer[19+13] = 'A';	// make sure unit
				}				
				break;
			case D_OVP:
				sprintf((void *)(displayBuffer+19), "  OVP:");
				sprintf((void *)(displayBuffer + 19 + 6),(void *)voltDispUnit[voltPoint], master.OVPSet);
				sprintf((void *)(displayBuffer + 19 + 13),"  ");
				sprintf(KEYINBUF, (void *)voltDisp[voltPoint], master.OVPSet);
				setInputParameter(0x59,6,FLOAT,NULL ,master.OVPMax ,master.OVPMin);  // master.OVPMax master.OVPMin
				break;
			case D_OCP:
				sprintf((void *)(displayBuffer+19), "  OCP:");
				sprintf((void *)(displayBuffer + 19 + 6),(void *)currDispUnit[currPoint], /* sumOCPSet() */ master.OCPSet * (slaveNumber + 1));
				sprintf((void *)(displayBuffer + 19 + 14)," ");
				sprintf(KEYINBUF, (void *)currDisp[currPoint],/* sumOCPSet() */master.OCPSet * (slaveNumber + 1));
				setInputParameter(0x59,7,FLOAT,NULL ,sumOCPMax() ,sumOCPMin());
				break;
			case D_OPP:
				sprintf((void *)(displayBuffer+19), "  OPP:%7.1fW  ", master.OPPSet * (slaveNumber + 1));
				sprintf(KEYINBUF, (void *)powDisp[powPoint], master.OPPSet * (slaveNumber + 1));
				setInputParameter(0x59,7,FLOAT,NULL ,master.OPPMax * (slaveNumber + 1)  ,master.OPPMin * (slaveNumber + 1));
				break;
			case SET_METER_FLAG:
				if (IS_FROM_MENU == 0)
				{
   			    	showMeter ^= 0x01;
    		    	VFDsign = VFDsign ^ sign_METER;
				}
				reverseState();
			    break;
			case CLR_LOCAL:	 //				   // ѰLOCAL    
			    shiftStatus = 0;
				VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
				VFDsign &= ~(sign_RMT | sign_ADDR);
				displayFresh = 1;
				if (programONOFF > 0)
					actualState = PROGRAMREADY;
				else
    				actualState = D_NORMAL;
    			lastState = lastLastState;
				lastLastState = lastLastLastState;
			    break;
			case SET_ONOFF_FLAG:
				reverseState();
				if (parallelMode == ON && parallelRole == MASTER)
				{
					if (masterState > 0 && masterState <= SYNC)
					{
						softTimer[PARALLELONOFFDEBOUNCE_COUNT].count = softTimer[MAIN_COUNT].count;
						break;	// not allow ON or OFF
				 	}
					else
					{
						if ((softTimer[MAIN_COUNT].count - softTimer[PARALLELONOFFDEBOUNCE_COUNT].count) < 300 )	// ON OFF debounce for 300ms
						{
							break;
						}
						else
							softTimer[PARALLELONOFFDEBOUNCE_COUNT].count = softTimer[MAIN_COUNT].count;
					}
				}
				if (IS_FROM_MENU == 0)
				{
			    	if (programONOFF > 0)
					{
						actualState = PROGRAMRUNNING; 
//						onoffStatus ^= BIT0;
						programStart ^= BIT0; 
						if (programStart & BIT0)
						{
						    programState = 0; // start
							programCount = 0;
						}
						else
						{
						  // stop
							programState = 4;	//stop
							programStart = 0;
							TIM_Cmd(TIM2, DISABLE);
							VFDsign &= ~(sign_STAR);
						}
						displayFresh = 0; //GN
						break;
					}
			    	if (timerONOFF > OFF) //ON
					{
						runningTimer = (timerHR * 60 * 60) + (timerMN * 60) + timerSE;
						if ((int32_t)runningTimer > 0)
						{
							actualState = TIMERRUNNING;
							onoffStatus ^= BIT0; 
						//	if (parallelMode == OFF || slaveNumber == 0 )
							{
								if (onoffStatus & BIT0)
								{
									if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
									{
										if (powerOnMode == 1) // LAST
											eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
									}
/*
									if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
										eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
									if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
										eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
*/
									timerCount = 0;
									VFDsign |= sign_STAR; // 1.42
									TIM_Cmd(TIM2, ENABLE);
								}
								else
								{
									runningTimer = 0;
									runningTimer--;
									VFDsign &= ~(sign_STAR);
									TIM_Cmd(TIM2, DISABLE);
								}
							}
						}
					}
					else
					{
						if (extEnable == AMODE)//> OFF )
						{
							if ( ENABLE_CPU_PIN != SET || IS_SHOW_ENA != 0)
							{
								SET_SHOW_ENA;
								break;
							}
							if ( IS_SHOW_SO != 0)
							{
								SET_SHOW_SO;
								break;
							}
						}
						else if(extEnable == BMODE)
							break;
						if (parallelMode == ON || chainMode == ON)
						{
							if (SHUTOFF_CPU_PIN == SET)	//W x
								break; 					// emerangcy }  , on/off key iX
						}
						onoffStatus ^= BIT0;
					}
					if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
					{
						if (powerOnMode == 1) // LAST
							eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
					}
			    	if (onoffStatus == OFF)
					{
						cursorPosition = 0;
						CLR_SETTING;
						CLR_NUMBER;
					}
				}
			    break;
			case SET_OFF_FLAG:
				onoffStatus = OFF;
				if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
				{
					if (powerOnMode == 1) // LAST
						eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
				}
  				reverseState();
				break;
			case D_SHIFT:
				displayFresh = 1;
 				if (shiftStatus == 1)
				{
					shiftStatus = 0;
					VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
				}
				else
				{
					shiftStatus = 1;
					VFDsign |= (sign_SHIFT + sign_SHIFTBL);
 				}



	//		    if ( shiftStatus == 0 )
	//			{
	//		    	shiftStatus = 1;
	//				VFDsign |= (sign_SHIFT + sign_SHIFTBL);
	//			}
	//			else
//					reverseState();
			    break;
			case D_NORMAL:
			    shiftStatus = 0;
				VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
				if (programONOFF > 0)
				{
					actualState = PROGRAMRUNNING;
					sprintf((void *)(displayBuffer+19), "PRG:%.1d S:%.3d R:%.2d/%.2d",programGroup,step+1 ,totalRepeat - repeat ,totalRepeat);
				}
				if ((int32_t)runningTimer > 0)
					actualState	= TIMERRUNNING;
			    break;
		   	case RECALL:
				if (pvsONOFF == OFF && onoffStatus == OFF && (controlState == LOCAL_CTRL || (extVMode == 0 && extIMode == 0)))
				{
			   		 	sprintf((void *)(displayBuffer), "RECALL:_   GROUP:%d",groupNumber);
						sprintf((void *)(displayBuffer+19)," Vset:      V");
						sprintf((void *)(displayBuffer+34)," Iset:      A");
						cursorPatternPosition = 0;
						setInputParameter(0x47,1,INTEGER ,NULL, 9,0);
						keyInBuffer[0] = 0xff;
				}
				else
				{
					reverseState();
				}
			    shiftStatus = 0;
				VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
			    break;
			case STORE:
				if (pvsONOFF == OFF && onoffStatus == OFF && (controlState == LOCAL_CTRL || (extVMode == 0 && extIMode == 0)))
				{
					if (programONOFF == 0)// && timerONOFF == 0)
					{
				    	sprintf((void *)(displayBuffer), " SAVE:_    GROUP:%d",groupNumber);
						sprintf((void *)(displayBuffer+19)," Vset:");
						sprintf((void *)(displayBuffer+19+6),(void *)voltDispUnit[voltPoint],master.vSet);
						sprintf((void *)(displayBuffer+34)," Iset:");
						sprintf((void *)(displayBuffer+34+6),(void *)currDispUnit[currPoint],master.iSet * (slaveNumber + 1)); 
						cursorPatternPosition = 0;
						setInputParameter(0x46,1,INTEGER ,NULL, 9,0);
						keyInBuffer[0] = 0xff;
                    }
				    else
					{
							actualState = PROGRAMREADY;
					}
				}
				else
				{
					reverseState();
					gotoUpLayer();
				}
			    shiftStatus = 0;
				VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
			    break;
			case SLEW:

			    sprintf((void *)displayBuffer,"SLOPE             ");
				sprintf((void *)menuItemBuffer," VOLTAGE | CURRENT |         ");
				cursorPatternPosition = menuLevel1; // start address
				cursorItemNumber = 2;  // 2 Item
				menuLevelPosition = 0; // first layer
				switch(cursorPatternPosition)
				{
				    case 0:
						memcpy((void *)(displayBuffer + 19) ,(void *)menuItemBuffer,29);
						setVFDFlashOn(0x54,8);
						break;
					case 1:
						memcpy((void *)(displayBuffer + 19) ,(void *)menuItemBuffer,29);
						setVFDFlashOn(0x5D,9);
						break;
				}
			    shiftStatus = 0;
				VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
			    break;
			case PROGRAMMODE:
			    if (pvsONOFF == OFF && (timerONOFF == OFF && (controlState == LOCAL_CTRL || (extVMode == 0 && extIMode == 0))))
				{
					if (onoffStatus == 0 && (parallelMode != ON || parallelRole != MASTER || slaveNumber == 0) )	
					{
			    		sprintf((void *)displayBuffer,"PROGRAM FUNC      ");
						sprintf((void *)(displayBuffer+19),"   %s    PROGRAM:%.1d     EDIT  ",programONOFFTemp > OFF ? " ON":"OFF",programGroupTemp);
						cursorPatternPosition = 0;
						SET_SETTING;
						step = 0;
				    	SET_STRING;
				    	cursorPosition = 0;
						setVFDFlashOn(0x56 ,3);
						actualState = PROGRAMONOFF;
					}
					else
					{
						reverseState();
						gotoUpLayer();
					}
				}
				else
				{
    				reverseState();
					gotoUpLayer();
				}
				shiftStatus = 0;
				VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
			    break;
			case TIMEREDIT:
				if (pvsONOFF == OFF && (programONOFF == OFF && (controlState == LOCAL_CTRL || (extVMode == 0 && extIMode == 0))))
				{
			    	sprintf((void *)displayBuffer,"TIMER FUNC        ");
 					sprintf((void *)(displayBuffer+19),"TIMER:%.3dHR  %.2dMIN %.2dSEC  %s",timerHR,timerMN,timerSE,timerONOFF > OFF ? " ON":"OFF");
					parameterTemp = timerONOFF;
					switch (cursorPatternPosition)
					{ 
				    	case 0:
				       		 setInputParameter(0x59,3,INTEGER,NULL , 999 , 0); // HR parameter
							 sprintf(KEYINBUF,"%3d",timerHR);
							 setVFDFlashOn(0x59,3);
							break;
						case 1:
							setInputParameter(0x60,2,INTEGER,NULL , 59 , 0); // MIN parameter
						    break;
						case 2:
							setInputParameter(0x66,2,INTEGER,NULL , 59 , 0); // SEC parameter
					    	break;
			    	}
				}
				else
				{
					reverseState();
					gotoUpLayer();
				}
				shiftStatus = 0;
				VFDsign &= ~(sign_SHIFT + sign_SHIFTBL);
				break;
			case D_OK:
			case D_ESC:
				if (IS_MB_ERROR)	// M~ù
				{
					if (IS_BACKUP_SCREEN) //^_~ee
					{
					 	CLR_BACKUP_SCREEN;
				     	memcpy((void *)(displayBuffer + 19),(void *)displayBufferTemp,29);
					 	cursorPosition = cursorPositionTemp;
					 	CLR_NUMBER;
					 	softTimer[ERROR_MESSAGE_COUNT].flag = DISABLE;
						clearOVPOCPOPPCVCCCCCV(); // FM OTP PROTECT
						faultStatus &= BIT5;   //error AùѰ F NYC TOO HIGH(OTP FLAG)	-> FOTP  ESC  ﾹʧ@
						onoffStatus = 0;
						sendMBStateSetting(MEASURE_CHANNEL,OUTPUT_CMD, (uint8_t)onoffStatus); // OFF
						verifyInput(OUTPUT_CMD,(float)onoffStatus );	 
						CLR_MB_ERROR;
					}
					reverseState();
					return;
				}
				if (actualState == D_ESC)
				{
					errorIndex = 0;
 	   				SCPI_EventClear(&scpi_context);
  	 		 		SCPI_ErrorClear(&scpi_context);
			  	 	SCPI_RegSet(&scpi_context, SCPI_REG_OPER, 0);
   		 			SCPI_RegSet(&scpi_context, SCPI_REG_QUES, 0);
					VFDsign &= ~(sign_ERROR);
					clearOVPOCPOPPCVCCCCCV();
					clearOnTheFlyCursor();
					CLR_PARALLEL_PROTECT;
					if (IS_PARALLELMODE_SLAVE_ERROR_CONNECT || (lastState == RECALL && parallelMode == ON && parallelRole == MASTER) )
					{
						CLR_PARALLELMODE_SLAVE_ERROR_CONNECT;
						parallelMode = ON;
						parallelInitRun();					 //ssu
					}
					if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0 )//&& (masterState == QUERYCURR) )  // clear slave error state  slaveNumber > 0 means slave exist
					{
						masterState = BROADCAST;
						count300 = 0;
						rs485Temp.cmd = CMD_CLS;
						cmdexenum = MASTERQUERYCMD;	//U@^Xs
					}
				}
			    if (lastState >= D_MENU && lastState <= MENUCONFCHAINADDR )
				{						
				    if (actualState == D_OK)
					{	
					    switch(lastState)
						{
							case MENUPVSEDITRECORD1:
							case MENUPVSEDITRECORD2:
							case MENUPVSEDITRECORD3:
							case MENUPVSEDITRECORD4:
								if (atof(KEYINBUF) <= numericalInput.floatMax && atof(KEYINBUF) >= numericalInput.floatMin)
								{
									setVFDFlashOff(0x40,48);
									if (lastState == MENUPVSEDITRECORD1)
									{
										setInputParameter(0x53 + 20, 6 , FLOAT ,LIMIT_COMPARE ,master.limitVMax *0.95  ,master.limitVMin);
										sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
										transRuleMaterialPattern();
										memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer) ,29) ;
										actualState = MENUPVSEDITRECORD2;
										sprintf(KEYINBUF,(void *)voltDisp[voltPoint],Vmp);
									}
									else if(lastState == MENUPVSEDITRECORD2)
									{
										Vmp = atof(KEYINBUF);
										setInputParameter(0x53 + 6,6, FLOAT ,LIMIT_COMPARE ,/* master.pMax */sumpMax()  * 0.9,/* master.limitIMin */ sumlimitIMin() * master.limitVMin);
										sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
										transRuleMaterialPattern();
										memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer+29) ,29) ;
										actualState = MENUPVSEDITRECORD3;
										sprintf(KEYINBUF,(void *)powDisp[powPoint],Pmp * (slaveNumber + 1));
									}
									else if(lastState == MENUPVSEDITRECORD3)
									{
										{
											Pmp = atof(KEYINBUF);
											Pmp = Pmp/(slaveNumber + 1);
											Pmp = round(Pmp,around);
											setInputParameter(0x53 + 16, 6 , FLOAT ,LIMIT_COMPARE ,9 ,0);
											sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
											transRuleMaterialPattern();
											memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer + 29) ,29) ;
											actualState = MENUPVSEDITRECORD4;
											sprintf(KEYINBUF,"%1d",(uint8_t)Material);
										}
									}
									else
									{
										{
											if ((Pmp*(slaveNumber + 1) / Vmp) < (/*master.limitIMax*/ sumlimitIMax() *0.95))
											{
												Material = atof(KEYINBUF);  // send parameter Rule,Vmp,Pmp,Material to E7 board
												savePvsCurveParam();
												gotoUpLayer();
											}
											else
											{
												Pmp = ((/*master.limitIMax */sumlimitIMax() *0.949) * Vmp)/(slaveNumber + 1);
												sprintf(KEYINBUF,"%1d",(uint8_t)Material);
												sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
												transRuleMaterialPattern();
												memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer + 29) ,29) ;
												pushError(IMP_OVER_RANGE);
												reverseState();
											}
										}
									}
								}
								else
								{
									sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
									transRuleMaterialPattern();
									if (lastState == MENUPVSEDITRECORD1 || lastState == MENUPVSEDITRECORD2)
										memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer ) ,29) ;
									else
										memcpy((void *)(displayBuffer + 19),(void *)(pvsBuffer + 29) ,29) ;
									pushError(OVER_RANGE);
									reverseState();
								}
								break;
						    case MENUSYSCOMM485STOP:
								rs485stopBits = parameterTemp;
								eepWrite((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t));
								initializeRs485();
								gotoUpLayer();
							    break;
							case MENUSYSCOMM485PDATA:
								rs485parityDataBits = parameterTemp;
								eepWrite((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t));
								initializeRs485();
								gotoUpLayer();
							    break;
				    		case MENUSYSCOMM232STOP:
								rs232stopBits = parameterTemp;
								eepWrite((uint8_t *)&rs232stopBits, EE_RS232STOPBITS ,sizeof(uint8_t));
								initializeRs232();
								gotoUpLayer();
							    break;
							case MENUSYSCOMM232PDATA:
								rs232parityDataBits = parameterTemp;
								eepWrite((uint8_t *)&rs232parityDataBits, EE_RS232PARITYDATABITS ,sizeof(uint8_t));
								initializeRs232();
								gotoUpLayer();
							    break;
                            case MENUCONFLIMITVMIN:
                            case MENUCONFLIMITVMAX:
                            case MENUCONFLIMITIMIN:
                            case MENUCONFLIMITIMAX:
                            case MENUCONFLIMITPMIN:
                            case MENUCONFLIMITPMAX:
							case MENUSYSPONUDEFV:
							case MENUSYSPONUDEFI:
				    			setVFDFlashOff(0x40, 48);
	    						CLR_NUMBER;
					            dpFlag = 0;
	    			    		if (convertSettingValue() == 1)
								{
									reverseState();
    					    		return;  // ERROR MESSAGE(OVER or UNDER Range)
								}
								else
								    gotoUpLayer();
							    break;
                            case MENUCONFPROTOVP:
							    if ( parameterTemp == 1) //ON
								{
								    setVFDFlashOff(0x40,48);
								    actualState = D_OVP;
									SET_CHANGE;
									initializePVSState();
								}
								else
								{
									ProtOVActivation = parameterTemp;
								    gotoUpLayer();
									protsw &= (~BIT7);
								}
								if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
									eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
//								if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
//								{
//									masterState = BROADCAST;
//									if (protsw & BIT7)	// OVP switch
//										rs485Temp.unionbyte.byte_loc[0] = ON;
//									else
//										rs485Temp.unionbyte.byte_loc[0] = OFF;
//									rs485Temp.cmd = CMD_SETOVPONOFF;
//									cmdexenum = MASTERSETINT8;
//									processCmd(cmdexenum);
//								}
							    break;
                            case MENUCONFPROTOCP:
							    if ( parameterTemp == 1) //ON
								{
								    setVFDFlashOff(0x40,48);
								    actualState = D_OCP;
									SET_CHANGE;
									initializePVSState();
								}
								else
								{
									ProtOCActivation = parameterTemp;
								    gotoUpLayer();
									protsw &= (~BIT6);
								}
								if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
									eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
//								if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
//								{
//									masterState = BROADCAST;
//									if (protsw & BIT6)	// OCP switch
//										rs485Temp.unionbyte.byte_loc[0] = ON;
//									else
//										rs485Temp.unionbyte.byte_loc[0] = OFF;
//									rs485Temp.cmd = CMD_SETOCPONOFF;
//									cmdexenum = MASTERSETINT8;
//									processCmd(cmdexenum);
//								}
							    break;
                            case MENUCONFPROTOPP:
								
							    if ( parameterTemp == 1) //ON
								{
								    setVFDFlashOff(0x40,48);
								    actualState = D_OPP;
									SET_CHANGE;
									initializePVSState();
								}
								else
								{
									ProtOPActivation = parameterTemp;
								    gotoUpLayer();
									protsw &= (~BIT5);
								}
								if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
									eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
//								if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
//								{
//									masterState = BROADCAST;
//									if (protsw & BIT5)	// OPP switch
//										rs485Temp.unionbyte.byte_loc[0] = ON;
//									else
//										rs485Temp.unionbyte.byte_loc[0] = OFF;
//									rs485Temp.cmd = CMD_SETOPPONOFF;
//									cmdexenum = MASTERSETINT8;
//									processCmd(cmdexenum);
//								}
							    break;
                            case MENUCONFPROTCVCC:
								CVtoCCActivation = parameterTemp;
								if (CVtoCCActivation == 1)
									protsw |= BIT4;
								else
								    protsw &= (~BIT4);
								if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
									eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
//								if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
//								{
//									masterState = BROADCAST;
//									if (protsw & BIT4)	// CVCC switch
//										rs485Temp.unionbyte.byte_loc[0] = ON;
//									else
//										rs485Temp.unionbyte.byte_loc[0] = OFF;
//									rs485Temp.cmd = CMD_SETCVCCONOFF;
//									cmdexenum = MASTERSETINT8;
//									processCmd(cmdexenum);
//								}

								gotoUpLayer();
							    break;
                            case MENUCONFPROTCCCV:
								CCtoCVActivation = parameterTemp;
								if (CCtoCVActivation == 1)
									protsw |= BIT3;
								else
								    protsw &= (~BIT3);
								if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
									eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
//								if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
//								{
//									masterState = BROADCAST;
//									if (protsw & BIT3)	// CCCV switch
//										rs485Temp.unionbyte.byte_loc[0] = ON;
//									else
//										rs485Temp.unionbyte.byte_loc[0] = OFF;
//									rs485Temp.cmd = CMD_SETCCCVONOFF;
//									cmdexenum = MASTERSETINT8;
//									processCmd(cmdexenum);
//								}
								gotoUpLayer();
							   break;
                            case MENUCONFEXTCV:
								extVMode = parameterTemp;
								eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
								gotoUpLayer();
							    break;
                            case MENUCONFEXTCI:
								extIMode = parameterTemp;
								eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
								gotoUpLayer();
							    break;
                            case MENUCONFEXTCPRANGE:
								extProgRange = parameterTemp;
								eepWrite((uint8_t *)&extProgRange, EE_EXTPROGRANGE ,sizeof(uint8_t));
								gotoUpLayer();
							    break;
                            case MENUCONFEXTCMONRNG:
								extMonRange = parameterTemp;
								eepWrite((uint8_t *)&extMonRange ,EE_EXTMONRANGE ,sizeof(uint8_t));
								gotoUpLayer();
							    break;
                            case MENUCONFEXTCSHUT:
								extShutOffLogic = parameterTemp;
								eepWrite((uint8_t *)&extShutOffLogic, EE_EXTSHUTOFFLOGIC ,sizeof(uint8_t));
								gotoUpLayer();
							    break;
                            case MENUCONFEXTCENABLE:
								extEnable = parameterTemp;
								eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
								if (extEnable == OFF)
								{
									extVMode = 0;// FRONT
									extIMode = 0;
									pvsONOFF = OFF;
									sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
									eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
									eepWrite((uint8_t *)&extVMode, EE_EXTIMODE ,sizeof(uint8_t));
									CLR_SHOW_ENA;
									CLR_SHOW_SO;RS485EmergencySwitchConfig(INTERRUPT);// 	
								}
								else //
								{
									timerONOFF = OFF;
									programONOFF = OFF;
									parallelMode = OFF;
									eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
									chainMode = OFF;
									VFDsign &=  ~(sign_ADDR);
									eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
									RS485EmergencySwitchConfig(GPIO_INPUT);// 
									pvsONOFF = OFF;
									sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
								}
								checkPowerOnState();
								gotoUpLayer();
							    break; 
                            case MENUCONFPARAMODE:
								parallelMode = parameterTemp;
								initparallelMode();

								gotoUpLayer();
								if (parallelMode == ON)
								{
									softTimer[SLAVE_COUNT].flag = DISABLE;
									if (parallelRole == MASTER)
									{
										actualState = D_NORMAL;
									}
									else
									{
										actualState = D_PARALLELSLAVE;
									}
									setVFDFlashOff(0x40,48);
							    	VFDsign &= ~(sign_MENU);
									memset((void *)displayBuffer,' ',48);
									menuLevel1 = 0;
									menuLevel2 = 0;
									menuLevel3 = 0;
									menuLevel4 = 0;
									cursorPatternPosition = 0;
									menuLevelPosition = 0;
									CLR_FROM_MENU;
								}
							    break;
                            case MENUCONFPARAROLE:
								parallelRole = parameterTemp;
								eepWrite((uint8_t *)&parallelRole, EE_PARALLELROLE ,sizeof(uint8_t));
								gotoUpLayer();
							    break;
                            case MENUCONFCHAINMODE:
								chainMode = parameterTemp;
								initchainMode();
								gotoUpLayer();
							    break;
                            case MENUCONFCHAINADDR:
							    if (atoi(KEYINBUF) >= MAX_CHAINADDR || atoi(KEYINBUF) < 1)
								{
								    pushError(OVER_RANGE);//chainAddr  = 30;
									reverseState();
									return;
								}
								else
							        chainAddr  = atoi(KEYINBUF);
								eepWrite((uint8_t *)&chainAddr, EE_CHAINADDR,sizeof(uint8_t));
								gotoUpLayer();
							    break;
					        case MENUSYSCOMMGPIBADDR:
							    if (atoi(KEYINBUF) > 30)
								    GPIBAddr = 30;
								else if (atoi(KEYINBUF) < 1)
									GPIBAddr = 1;
								else
							        GPIBAddr = atoi(KEYINBUF);
								eepWrite((uint8_t *)&GPIBAddr, EE_GPIBADDR,sizeof(uint8_t));
								sendMBStateSetting(GPIB_LAN_CHANNEL,GPIBADDR_CMD, (uint8_t)GPIBAddr);
								gotoUpLayer();
								break;
							case MENUSYSCOMMLANIPMODE:
							     LANIPMode = parameterTemp;
								 eepWrite((uint8_t *)&LANIPMode, EE_LANIPMODE,sizeof(uint8_t));
								 gotoUpLayer();
							    break;
					        case MENUSYSCOMMLANIPADDR:
						    case MENUSYSCOMMLANMASK:
						    case MENUSYSCOMMLANGWAY:
								 if (memSysCommIpPosition < 3)
								 {
								    if (atoi(KEYINBUF) < 256)
									{
									    switch(lastState)
										{
								            case MENUSYSCOMMLANIPADDR:
											    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition < (4 - 1))
								                    memSysCommIpPosition++; //shift right
												sprintf(KEYINBUF ,"%.3d",LANIPAddrTemp[memSysCommIpPosition ]);
												break;
								            case MENUSYSCOMMLANMASK:
											    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition < (4 - 1))
								                    memSysCommIpPosition++; //shift right
												sprintf(KEYINBUF ,"%.3d",LANMaskTemp[memSysCommIpPosition ]);
												break;
								            case MENUSYSCOMMLANGWAY:
											    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
										        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
							                    if (memSysCommIpPosition < (4 - 1))
								                    memSysCommIpPosition++; //shift right
												sprintf(KEYINBUF ,"%.3d",LANGatewayTemp[memSysCommIpPosition ]);
												break;
								        }
									}
									else
									{
									    strcpy(KEYINBUF,"255");
									    switch(actualState)
										{
								            case MENUSYSCOMMLANIPADDR:
											    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								            case MENUSYSCOMMLANMASK:
											    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								            case MENUSYSCOMMLANGWAY:
											    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
												break;
								        }										
										memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3);
									}
									setVFDFlashOff(0x40,48);
									setInputParameter(0x60 + (memSysCommIpPosition * 4) , 3,INTEGER ,PT_SHIFT_RIGHT , 255 ,0);
									reverseState();
								}
								else // save
								{
							    	if (atoi(KEYINBUF) > numericalInput.intMax)
								    	strcpy(KEYINBUF,"255");
							    	switch(lastState)
									{
							        	case MENUSYSCOMMLANIPADDR:
									    	LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
											memcpy((void *)LANIPAddr,(void *)LANIPAddrTemp,4);
											eepWrite((uint8_t *)&LANIPAddr, EE_LANIPADDR ,4);
											break;
							        	case MENUSYSCOMMLANMASK:
									    	LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
											memcpy((void *)LANMask,(void *)LANMaskTemp,4);
											eepWrite((uint8_t *)&LANMask, EE_LANMASK ,4);
											break;
							        	case MENUSYSCOMMLANGWAY:
									    	LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
											memcpy((void *)LANGateway,(void *)LANGatewayTemp,4);
											eepWrite((uint8_t *)&LANGateway, EE_LANGATEWAY ,4);
											break;
							    	}			
									gotoUpLayer();					   // IP 4s ^Wh
								}
							    break;
						    case MENUSYSCOMM485BAUD:
							    R485Baud = parameterTemp;
								eepWrite((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t));
								initializeRs485();
								gotoUpLayer();
							    break;
						    case MENUSYSCOMM232BAUD:
							    R232Baud = parameterTemp;
								eepWrite((uint8_t *)&R232Baud, EE_R232BAUD ,sizeof(uint8_t));
								initializeRs232();
								gotoUpLayer();
							    break;

						    case MENUSYSMEMG:
							    groupNumber = atoi(KEYINBUF);
								eepWrite((uint8_t *)&groupNumber, EE_GROUPNUMBER ,sizeof(uint8_t));
								gotoUpLayer();
							    break;
						    case MENUSYSBEEP:
								beepActivation = parameterTemp;
								eepWrite((uint8_t *)&beepActivation, EE_BEEPACTIVATION , sizeof(uint8_t));

								gotoUpLayer();
							    break;
						    case MENUSYSDEFAULT:
/* wait for recall factory default
*/								if (parameterTemp == 0x01) //YES
                                {
									eepromDefaultSet();
									checkPowerOnState();
                                    setVFDFlashOn(0x53, 29);
								    strcpy((void *)(displayBuffer + 19),"  FACTORY DEFAULT RESTORED!  ");
								    dispVFD48(DISPBUF);
								    delayMs(3000);
								}
								gotoUpLayer();
							    break;
						    case RFACTORY:
/* wait for 
*/								if (parameterTemp == 0x01) //YES
                                {
									restoreFactoryCal();
								}
								gotoUpLayer();
							    break;						    
							case MENUSYSPONMODE:
							    powerOnMode = parameterTemp;
								eepWrite((uint8_t *)&powerOnMode, EE_POWERONMODE ,sizeof(uint8_t));
							    gotoUpLayer();
							    break;
							case CALOVP:
							case CALOCP:
								if (calState == 5) // standby ~iHiJ wiJե{ AiJ 
							    	calState = 6;
								reverseState();
//								actualState = lastState;
//								lastState = lastLastState;
//								lastLastState = lastLastLastState;
								break;
							case CALVOLTAGE:
							    if ((atof(KEYINBUF) >= numericalInput.floatMin && atof(KEYINBUF) <= numericalInput.floatMax) )
								{
									if ((vAdc > adRangeLow && vAdc < adRangeHigh))
									{
										uint16_t oldvCal;
										uint8_t temps[10];
										dpFlag = 0;
								    	vMeter = atof(KEYINBUF);
										if (presentPoint == 1)
											sprintf((void *)temps,"%7.4f",vMeter); // 4  5J 1.30
										else 
										    sprintf((void *)temps,"%7.3f",vMeter); // 4  5J 1.30
//										sprintf((void *)temps,(void *)voltDisp[voltPoint],vMeter); // 4  5J
										vMeter = atof((void *)temps);
										if (presentPoint >= (calPV ))
										{
											uint32_t time;
										    vCal[presentPoint - 1] = convertFloatToInt(vMeter, master.vMax, fullScale);
											oldvCal = vCal[presentPoint - 1];	//backup value
											delayMs(20);
											clearMeasureCommand();//Nbuffer Bzʥ] Bz
											time = softTimer[MAIN_COUNT].count;	   //UɶBz
											setVFDFlashOff(0x40,48);
											do
											{
												if (IS_FAT_CAL)
													sendMBCalSetting(CALVNS_CMD,presentPoint|0x80,oldvCal);//0xA7 save data
												else
								    				sendMBCalSetting(CALVNS_CMD,presentPoint,oldvCal);//0xA7 save data

 												if (IS_FAT_CAL)
													strcpy((void *)(displayBuffer + 19)," Factory calibrating ...     ");
												else
													strcpy((void *)(displayBuffer + 19),"    User calibrating ...     ");
												setVFDFlashOn(0x68 , 3);
											   	dispVFD48(DISPBUF);
												outputStatus |= CAL_BUSY_STATE;
												delayMs(2000);
												while ((outputStatus & CAL_BUSY_STATE) && (softTimer[MAIN_COUNT].count - time < CALTIME )) // check UեS?
												{
													queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,200);
											    	SET_FAT_FINAL_CAL;
												}
												vCal[presentPoint - 1] = 0xFFFF; // ] -1
												// Ū^ ˬdO_T
												if (IS_FAT_CAL)
													sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint|0x80); // 0xA5  varify
												else
													sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint); // 0xA5  varify
												delayMs(100);
												clearMeasureCommand();//Nbuffer Bzʥ] Bz
												if (displayFresh == 1)
												{
													if (presentPoint == 1)
														sprintf(KEYINBUF,"%7.4f",vMeter); //1.30
													else
														sprintf(KEYINBUF,"%7.3f",vMeter); //1.30
												}
												if (oldvCal == vCal[presentPoint - 1])
													break;
											}while ( softTimer[MAIN_COUNT].count - time < CALTIME );
											if ( softTimer[MAIN_COUNT].count - time >= CALTIME )
											{
												strcpy((void *)(displayBuffer + 19),"  PWR Calibration Time out!! ");
												dispVFD48(DISPBUF);
												setVFDFlashOff(0x40,48);
												delayMs(7000);
											}
											else
											{
											   delayMs(7000);	  // delay 6sec Fq
											   setVFDFlashOff(0x40,48);
											}
											    // Ƥ@P 
											CLR_CAL_NOW; // done
											cursorPosition = 0;
											SET_VOLTAGE_FINISH;	// qե
											presentPoint = 1;
											/* OVPե */ 
											menuLevelPosition--;
											cursorPatternPosition = 2;// OVP
											lastState = CAL;
											menuNestHandler();
											menuLevel2 = 0;			  // ESC h^  VOLTAGE {{
											CLR_NUMBER;
											break;
										}
										else
										{
											vCal[presentPoint - 1] = convertFloatToInt(vMeter, master.vMax, fullScale);;
											oldvCal = vCal[presentPoint - 1];
											delayMs(20);
											clearMeasureCommand();//Nbuffer Bzʥ] M
											do
											{
												// ФU sI
												if (IS_FAT_CAL)
													sendMBCalSetting(CALVNS_CMD,presentPoint|0x80,oldvCal);//0xA7
												else
										    		sendMBCalSetting(CALVNS_CMD,presentPoint,oldvCal);//0xA7
												delayMs(15);  //UɶBz

												vCal[presentPoint - 1] = 0xFFFF; // ] -1
												// Ū^ ˬdO_T
												if (IS_FAT_CAL)
													sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint|0x80); // 0xA5  varify
												else
													sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint); // 0xA5  varify
												delayMs(20);
												if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//ʥ]
												{
													uartBuffer[MEASURE_CHANNEL].packetCount--;
													receiveMBResponse(MEASURE_CHANNEL);
												}
												else	 //S Aݤ@
												{
													// Ū^ ˬdO_T
													if (IS_FAT_CAL)
														sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint|0x80); // 0xA5  varify
													else
														sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint); // 0xA5  varify
													delayMs(20);
													if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//ʥ]
													{
														uartBuffer[MEASURE_CHANNEL].packetCount--;
														receiveMBResponse(MEASURE_CHANNEL);
													}
												}
												if (displayFresh == 1)
												{
													if (presentPoint == 1)
														sprintf(KEYINBUF,"%6.3f",vMeter); //1.30
													else
														sprintf(KEYINBUF,"%6.2f",vMeter); //1.30
												
												}
											}while(oldvCal != vCal[presentPoint - 1]);
											// Ƥ@P iU@I
											calState = 0; // next point
											CLR_NUMBER;
											presentPoint++;
											switch(presentPoint)
											{
												case 1:
													if (voltPoint == 1)
														setInputParameter(0x59+2,5,FLOAT,NULL ,master.vMax*V_POINT1_MAX ,master.vMax*V_POINT1_MIN); // 0.05
													else if(voltPoint == 2)
														setInputParameter(0x59+1,6,FLOAT,NULL ,master.vMax*V_POINT1_MAX ,master.vMax*V_POINT1_MIN); // 0.05
													adRangeLow = VADLOW1;adRangeHigh = VADHIGH1;//1500;
													break;
												case 2:
													if (voltPoint == 1)
														setInputParameter(0x59+1,6,FLOAT,NULL ,master.vMax*V_POINT2_MAX , master.vMax*V_POINT2_MIN);//0.33
													else if(voltPoint == 2)
														setInputParameter(0x59,6,FLOAT,NULL ,master.vMax*V_POINT2_MAX , master.vMax*V_POINT2_MIN);//0.33
													adRangeLow = VADLOW2;adRangeHigh = VADHIGH2;//9500;
													break;
												case 3:
													if (voltPoint == 1)
														setInputParameter(0x59+1,6,FLOAT,NULL ,master.vMax*V_POINT3_MAX , master.vMax*V_POINT3_MIN);//0.066
													else if(voltPoint == 2)
														setInputParameter(0x59,6,FLOAT,NULL ,master.vMax*V_POINT3_MAX , master.vMax*V_POINT3_MIN);//0.066
													adRangeLow = VADLOW3;adRangeHigh = VADHIGH3;//18000;
													break;
												case 4:
				 									if (voltPoint == 1)
														setInputParameter(0x59+1,6,FLOAT,NULL ,master.vMax *V_POINT4_MAX, master.vMax*V_POINT4_MIN);  //0.95
													else if(voltPoint == 2)
														setInputParameter(0x59,6,FLOAT,NULL ,master.vMax *V_POINT4_MAX, master.vMax*V_POINT4_MIN);  //0.95
													adRangeLow = VADLOW4;adRangeHigh = VADHIGH4;//25500;
													break;
											}
											setVFDFlashOff(0x40, 48);
										}
									}
									else
										pushError(AD_OVER);
								}
								else
								   	pushError(OVER_RANGE);
								reverseState();
							    break;
							case CALCURRENT:
						    	if ((atof(KEYINBUF) >= numericalInput.floatMin && atof(KEYINBUF) <= numericalInput.floatMax))
								{
									if (iAdc > adRangeLow && iAdc < adRangeHigh)
									{
										uint16_t oldiCal;
										dpFlag = 0;
								    	iMeter = atof(KEYINBUF);
										if (presentPoint >= (calPI ))
										{
											uint32_t time;
								        	iCal[presentPoint - 1] = convertFloatToInt(iMeter, master.iMax, fullScale);
											oldiCal = iCal[presentPoint - 1];
											delayMs(20);
											clearMeasureCommand();//Nbuffer Bzʥ] Bz
											time = softTimer[MAIN_COUNT].count;
											setVFDFlashOff(0x40,48);
											do 
											{
												if (IS_FAT_CAL)
													sendMBCalSetting(CALINS_CMD,presentPoint|0x80,oldiCal);//0xAB	 save
												else
										    		sendMBCalSetting(CALINS_CMD,presentPoint,oldiCal);//0xAB	 save
												if (IS_FAT_CAL)
													strcpy((void *)(displayBuffer + 19)," Factory calibrating ...     ");
												else
													strcpy((void *)(displayBuffer + 19),"    User calibrating ...     ");
												setVFDFlashOn(0x68 , 3);
										   		dispVFD48(DISPBUF);
												delayMs(2000);	  
												outputStatus |= CAL_BUSY_STATE;
												while ((outputStatus & CAL_BUSY_STATE) && (softTimer[MAIN_COUNT].count - time < CALTIME ))
												{
													queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,200);
										    		SET_FAT_FINAL_CAL;
												}
												iCal[presentPoint - 1] = 0xFFFF; // ] -1
												if (IS_FAT_CAL)
													sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint|0x80); // 0xA9  varify
												else
													sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint); // 0xA9  varify
												delayMs(100);
												clearMeasureCommand();//Nbuffer Bzʥ] Bz
												if (displayFresh == 1)
												sprintf(KEYINBUF,(void *)currDisp[currPoint],iMeter);
												if (oldiCal == iCal[presentPoint - 1])
													break;
											}while ( softTimer[MAIN_COUNT].count - time < CALTIME);
											if ( softTimer[MAIN_COUNT].count - time >= CALTIME )
											{
												strcpy((void *)(displayBuffer + 19),"  PWR Calibration Time out!! ");
												dispVFD48(DISPBUF);
											}
											setVFDFlashOff(0x40,48);
											// Ƥ@P
											CLR_CAL_NOW; // done
											SET_CURRENT_FINISH;  //qyե
											presentPoint = 1;
												/* OCPե */ 
											menuLevelPosition--;
											cursorPatternPosition = 3;// OCP
											lastState = CAL;
											menuNestHandler();
											menuLevel2 = 1;			  // ESC h^  CURRENT {{
											CLR_NUMBER;
											break;
										}
										else
										{
											iCal[presentPoint - 1] = convertFloatToInt(iMeter, master.iMax, fullScale);
											oldiCal = iCal[presentPoint - 1];
											delayMs(20);
											clearMeasureCommand();//Nbuffer Bzʥ] M
											do 
											{
												if (IS_FAT_CAL)
													sendMBCalSetting(CALINS_CMD,presentPoint|0x80,oldiCal);//0xAB
												else
										    		sendMBCalSetting(CALINS_CMD,presentPoint,oldiCal);//0xAB
												delayMs(15);
												iCal[presentPoint - 1] = 0xFFFF; // ] -1

												if (IS_FAT_CAL)
													sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint|0x80); // 0xA9  varify
												else
													sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint); // 0xA9  varify
												delayMs(20);
												if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//ʥ]
												{
													uartBuffer[MEASURE_CHANNEL].packetCount--;
													receiveMBResponse(MEASURE_CHANNEL);
												}
												else	 //S Aݤ@
												{
													// Ū^ ˬdO_T
													if (IS_FAT_CAL)
														sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint|0x80); // 0xA9  varify
													else
														sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint); // 0xA9  varify
													delayMs(20);
													if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//ʥ]
													{
														uartBuffer[MEASURE_CHANNEL].packetCount--;
														receiveMBResponse(MEASURE_CHANNEL);
													}
												}
												if (displayFresh == 1)
												sprintf(KEYINBUF,(void *)currDisp[currPoint],iMeter);
											}while (oldiCal != iCal[presentPoint - 1]);
											// Ƥ@P iU@I
											calState = 0; // next point
											CLR_NUMBER;
											presentPoint++;
											switch(presentPoint)
											{
											    case 1:
													if (machine1000 == 0) // 1000V
														setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_1000POINT1_MAX , master.iMax*I_1000POINT1_MIN);  // 11.9%~5.94%
													else
														setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_POINT1_MAX , master.iMax*I_POINT1_MIN);      // 4 %
													adRangeLow = IADLOW1;adRangeHigh = IADHIGH1;
													break;
												case 2:
													setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_POINT2_MAX , master.iMax*I_POINT2_MIN);	// 33 %
													adRangeLow = IADLOW2;adRangeHigh = IADHIGH2;
													break;
												case 3:
													setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_POINT3_MAX , master.iMax*I_POINT3_MIN);		// 66 %
													adRangeLow = IADLOW3;adRangeHigh = IADHIGH3;
													break;
												case 4:
													setInputParameter(0x59,7,FLOAT,NULL ,master.iMax*I_POINT4_MAX , master.iMax*I_POINT4_MIN);				// 95 %
													adRangeLow = IADLOW4;adRangeHigh = IADHIGH4;
													break;
											}
											setVFDFlashOff(0x40, 48);
										}
									}
									else
										pushError(AD_OVER);
								}
								else 
								   	pushError(OVER_RANGE);
								reverseState();
							    break;
							case EXTCALRESVOLTAGE:
							case TESTEXTVCC:
								if ((atof(KEYINBUF) > numericalInput.floatMin && atof(KEYINBUF) < numericalInput.floatMax))
								{
									voltagerescurr = atof(KEYINBUF);									
									eepWrite((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
									writeUserChecksum();
									if (lastState == TESTEXTVCC)
									{
										setVFDFlashOff(0x40,48);
										dpFlag = 0;
										CLR_NUMBER;
									   	CLR_SETTING;
										CLR_STRING;
										cursorPosition = 0;
										cursorPatternPosition = menuLevel1;
										menuLevelPosition = 0;
										sprintf((void *)displayBuffer,"UI TEST           ");
										strcpy((void *)menuItemBuffer," EEPROM  |EXT_CTRL |EXT_VOLT><EXT_CURR|INT_UART |EXT_UART><EXT_V_CC| EXT_I_CC|  EXIT   ");
										cursorItemNumber = 9;  
										flashBlock(0);
										actualState = SELFTEST3;
										lastState = lastLastState;
										lastLastState = lastLastLastState;
 									}
									else
										gotoUpLayer();
								}
								else
								{
								    pushError(OVER_RANGE);
									reverseState();
								}
								break;
							case EXTCALRESCURRENT:
							case TESTEXTICC:
								if ((atof(KEYINBUF) > numericalInput.floatMin && atof(KEYINBUF) < numericalInput.floatMax))
								{
									currentrescurr = atof(KEYINBUF);									
									eepWrite((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
									writeUserChecksum();
									if (lastState == TESTEXTICC)
									{
										setVFDFlashOff(0x40,48);
										dpFlag = 0;
										CLR_NUMBER;
									   	CLR_SETTING;
										CLR_STRING;
										cursorPosition = 0;
										cursorPatternPosition = menuLevel1;
										menuLevelPosition = 0;
										sprintf((void *)displayBuffer,"UI TEST           ");
										strcpy((void *)menuItemBuffer," EEPROM  |EXT_CTRL |EXT_VOLT><EXT_CURR|INT_UART |EXT_UART><EXT_V_CC| EXT_I_CC|  EXIT    ");
										cursorItemNumber = 9;  
										flashBlock(0);
										actualState = SELFTEST3;
										lastState = lastLastState;
										lastLastState = lastLastLastState;
									}
									else
										gotoUpLayer();
								}
								else
								{
								    pushError(OVER_RANGE);
									reverseState();
								}
								break;
							case EXTCALVOLTAGE:
							case TESTEXTVOLT:
								if ((atof(KEYINBUF) > numericalInput.floatMin && atof(KEYINBUF) < numericalInput.floatMax) && (YnADCDualConvertedValue[0] > 300 && YnADCDualConvertedValue[0] < 3500))
								{
									extCalVAd[presentPoint - 1] = vADbuffer;//YnADCDualConvertedValue[0];
									extCalV[presentPoint - 1] = atof(KEYINBUF);
									if (presentPoint == 2)
									{
										mADc_v = (extCalV[1] - extCalV[0])/(extCalVAd[1] - extCalVAd[0]);
										bADc_v = extCalV[1] - (mADc_v * extCalVAd[1]);
//										bADc_v += 0.01;
										mDAc_v = (DAC9V - DAC1V)/(extCalV[1] - extCalV[0]);
										bDAc_v = DAC9V - (mDAc_v * extCalV[1]);
										eepWrite((uint8_t *)&extCalV[0],EE_USER_EXTCALV_0 ,sizeof(float) * 2);
										eepWrite((uint8_t *)&extCalVAd[0],EE_USER_EXTCALVAD_0 ,sizeof(uint16_t) * 2);
										writeUserChecksum();
										dacControl(DAC_VOLTAGE,0,ON); // eX0V	 AD 
										if (lastState == TESTEXTVOLT)
										{
											setVFDFlashOff(0x40,48);
											dpFlag = 0;
											CLR_NUMBER;
										   	CLR_SETTING;
											CLR_STRING;
											cursorPosition = 0;
											cursorPatternPosition = menuLevel1;
											menuLevelPosition = 0;
											sprintf((void *)displayBuffer,"UI TEST           ");
											strcpy((void *)menuItemBuffer," EEPROM  |EXT_CTRL |EXT_VOLT><EXT_CURR|INT_UART |EXT_UART><EXT_V_CC| EXT_I_CC|  EXIT   ");
											cursorItemNumber = 9;  
											flashBlock(0);
											actualState = SELFTEST3;
											lastState = lastLastState;
											lastLastState = lastLastLastState;

										}
										else
											gotoUpLayer();
								    }
									else
									{	
										dacControl(DAC_VOLTAGE,(uint16_t)(DAC9V),ON); // eX9V	 AD 
										presentPoint = 2;
										sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalV[presentPoint - 1]); // ഫ 1.xx Vk
										sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalV[presentPoint - 1]);
										setInputParameter(0x59,6,FLOAT,NULL ,(9+0.9) , 9-0.9);
										reverseState();
									}
								}
								else
								{
								    pushError(OVER_RANGE);
									reverseState();
								}
								break;
							case EXTCALCURRENT:
							case TESTEXTCURR:
								if (atof(KEYINBUF) > numericalInput.floatMin && atof(KEYINBUF) < numericalInput.floatMax && (YnADCDualConvertedValue[1] > 300 && YnADCDualConvertedValue[1] < 3500))
								{
									extCalIAd[presentPoint - 1] = iADbuffer;//YnADCDualConvertedValue[1];
									extCalI[presentPoint - 1] = atof(KEYINBUF);
									if (presentPoint == 2)
									{
										mADc_i = (extCalI[1] - extCalI[0])/(extCalIAd[1] - extCalIAd[0]);
										bADc_i = extCalI[1] - (mADc_i * extCalIAd[1]);
										mDAc_i = (DAC9V - DAC1V)/(extCalI[1] - extCalI[0]);
										bDAc_i = DAC9V - (mDAc_i * extCalI[1]);
										eepWrite((uint8_t *)&extCalI[0],EE_USER_EXTCALI_0 ,sizeof(float) * 2);
										eepWrite((uint8_t *)&extCalIAd[0],EE_USER_EXTCALIAD_0 ,sizeof(uint16_t) * 2);
										writeUserChecksum();
										dacControl(DAC_CURRENT,0,ON); // eX0V	 AD 
										if (lastState == TESTEXTCURR)
										{
											setVFDFlashOff(0x40,48);
											dpFlag = 0;
											CLR_NUMBER;
										   	CLR_SETTING;
											CLR_STRING;
											cursorPosition = 0;
											cursorPatternPosition = menuLevel1;
											menuLevelPosition = 0;
											sprintf((void *)displayBuffer,"UI TEST           ");
											strcpy((void *)menuItemBuffer," EEPROM  |EXT_CTRL |EXT_VOLT><EXT_CURR|INT_UART |EXT_UART><EXT_V_CC| EXT_I_CC|  EXIT   ");
											cursorItemNumber = 9;  
											flashBlock(0);
											actualState = SELFTEST3;
											lastState = lastLastState;
											lastLastState = lastLastLastState;
 										}
										else
											gotoUpLayer();
								    }
									else
									{	
										dacControl(DAC_CURRENT,(uint16_t)(DAC9V),ON); // eX9V	 AD 
										presentPoint = 2;
										sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalI[presentPoint - 1]); // ഫ 1.xx Vk
										sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalI[presentPoint - 1]);
										setInputParameter(0x59,6,FLOAT,NULL ,(9+0.9) , 9-0.9);
										reverseState();
									}
								}
								else
								{
								    pushError(OVER_RANGE);
									reverseState();
								}
								break;
							case SLEWVOLTAGE:
								tempf = atof(KEYINBUF);
							    if (tempf >= numericalInput.floatMin && tempf <= numericalInput.floatMax)
								{
								    tempf = atof(KEYINBUF);
									sprintf((void *)temps,"%4.1f",tempf);  // 45J J
									verifyInput(VSRSET_CMD,tempf );

									if (errorQueue[errorIndex - 1] == MEASURE_VERIFY_ERROR)
										reverseState();
									else
									{
										eepWrite((uint8_t *)&master.SRvSet, EE_SRVSET ,sizeof(float));
//										masterParallelSetCmdInt32(master.SRvSet,CMD_SETVSLEW);
								    	gotoUpLayer();
									}
								}
								else 
								{ 
								    pushError(OVER_RANGE);
									reverseState();
								}
							    break;
							case SLEWCURRENT:
								tempf = atof(KEYINBUF);
							    if (tempf >= numericalInput.floatMin && tempf <= numericalInput.floatMax)
								{
								    tempf = atof(KEYINBUF);
									sprintf((void *)temps,"%4.1f",tempf);  // 45J J
									verifyInput(ISRSET_CMD,tempf );
									if (errorQueue[errorIndex - 1] == MEASURE_VERIFY_ERROR)
									{
										reverseState();
									}
									else
									{
										eepWrite((uint8_t *)&master.SRiSet, EE_SRISET ,sizeof(float));
//										masterParallelSetCmdInt32(master.SRiSet,CMD_SETVSLEW);
 										gotoUpLayer();
									}
								}
								else 
								{ 
								    pushError(OVER_RANGE);
									reverseState();
								}
							    break;
							case SLEW:
							    slewNestHandler();
							    break;
							case SELFTEST3:
								selftestNestHandler();
								break;
							default:
                                menuNestHandler();
							    break;
						}// end of switch(lastState)
					}
					else // D_ESC
					{
						if ((lastState == CALOVP || lastState == CALOCP) && (calState > 5))
						{
							reverseState();
						}
						else if (lastState == MENUPVSEDITRECORD1)
						{
							setVFDFlashOff(0x40,48);
							if (IS_NUMBER)
							{
								setInputParameter(0x53 + 6,6, FLOAT ,LIMIT_COMPARE ,master.limitIMax ,master.limitIMin);
							//	sprintf(KEYINBUF,(void *)currDisp[currPoint],Rule);
								sprintf(KEYINBUF,"%1d",(uint8_t)Rule);
								sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
								transRuleMaterialPattern();
								memcpy((void *)(displayBuffer+19),(void *)pvsBuffer,29);
							    reverseState();	
							}
							else
							{
//								savePvsCurveParam();
								gotoUpLayer();
							}
 						}
						else if( lastState == MENUPVSEDITRECORD2)
						{
							setVFDFlashOff(0x40,48);
							if (IS_NUMBER)
							{
								setInputParameter(0x53 + 20,6, FLOAT ,LIMIT_COMPARE ,master.limitVMax ,master.limitVMin);
								sprintf(KEYINBUF,(void *)voltDisp[voltPoint],Vmp);
								sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber+ 1),(uint8_t)Material);
								transRuleMaterialPattern();
								memcpy((void *)(displayBuffer+19),(void *)pvsBuffer,29);
								reverseState();	
							}
							else
							{
//								savePvsCurveParam();
								gotoUpLayer();
							}
						}
						else if (lastState == MENUPVSEDITRECORD3)
						{
							setVFDFlashOff(0x40,48);
							if (IS_NUMBER)
							{
								
								setInputParameter(0x53 + 6,6, FLOAT ,LIMIT_COMPARE ,Rule ,master.limitIMin);
								sprintf(KEYINBUF,(void *)powDisp[powPoint],Pmp*(slaveNumber + 1));
								sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
								transRuleMaterialPattern();
								memcpy((void *)(displayBuffer+19),(void *)(pvsBuffer+29),29);
								reverseState();
							}
							else
							{
//								savePvsCurveParam();
								gotoUpLayer();
							}
							
						}
						else if( lastState == MENUPVSEDITRECORD4)
						{
							setVFDFlashOff(0x40,48);
							if (IS_NUMBER)
							{
								
								setInputParameter(0x53 + 20,6, FLOAT ,LIMIT_COMPARE ,Vmp ,master.limitVMin);
								sprintf(KEYINBUF,"%1d",(uint8_t)Material);
								sprintf((void *)pvsBuffer,(void *)pvSim[voltPoint], (uint8_t)Rule,Vmp,Pmp*(slaveNumber+1),(uint8_t)Material);
								transRuleMaterialPattern();
								memcpy((void *)(displayBuffer+19),(void *)(pvsBuffer+29),29);
								reverseState();
							}
							else
							{
//								savePvsCurveParam();
								gotoUpLayer();
							}
						}
						else if( lastState == EXTCALVOLTAGE || lastState == EXTCALCURRENT)
						{
							setVFDFlashOff(0x40,48);
							if (IS_NUMBER)
							{
								if(lastState == EXTCALVOLTAGE)
								{
									sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalV[presentPoint - 1]); // ഫ 1.xx Vk
									sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalV[presentPoint - 1]);
									
								}
								else if(lastState == EXTCALCURRENT)
								{
									sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalI[presentPoint - 1]); // ഫ 1.xx Vk
									sprintf(KEYINBUF ,"%6.3f",extCalI[presentPoint - 1]);
								}
								switch(presentPoint)
								{
									case 1:
										setInputParameter(0x59,6,FLOAT,NULL ,(1+0.1) , 1-0.1);	//Jd 0.9 ~1.1V
										break;
									case 2:
										setInputParameter(0x59,6,FLOAT,NULL ,(9+0.9) , 1-0.9);	//Jd 0.9 ~1.1V
										break;
								}
								reverseState();
							}
							else
								gotoUpLayer();							
						}
						else  if(lastState >= TESTEEPROM && lastState <= TESTEXTICC )
						{
							setVFDFlashOff(0x40,48);
							if (IS_NUMBER)
							{
								if(menuLevel1 == 2)
								{
									sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalV[presentPoint - 1]); // ഫ 1.xx Vk
									sprintf(KEYINBUF ,(void *)currDisp[currPoint],extCalV[presentPoint - 1]);
									if (presentPoint == 1)
											setInputParameter(0x59,6,FLOAT,NULL ,(1+0.1) , 1-0.1);	//Jd 0.9 ~1.1V
									else if(presentPoint == 2)
											setInputParameter(0x59,6,FLOAT,NULL ,(9+0.9) , 1-0.9);	//Jd 0.9 ~1.1V
								}
								else if(menuLevel1 == 3)
								{
									sprintf((void *)(displayBuffer + 19),"METER:%6.4fV  ",extCalI[presentPoint - 1]); // ഫ 1.xx Vk
									sprintf(KEYINBUF ,"%6.3f",extCalI[presentPoint - 1]);
									if (presentPoint == 1)
											setInputParameter(0x59,6,FLOAT,NULL ,(1+0.1) , 1-0.1);	//Jd 0.9 ~1.1V
									else if(presentPoint == 2)
											setInputParameter(0x59,6,FLOAT,NULL ,(9+0.9) , 1-0.9);	//Jd 0.9 ~1.1V
								}
								else if(menuLevel1 == 6)
								{
									if (IS_FAT_CAL)
										eepRead((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
									else
										eepRead((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
									sprintf((void *)(displayBuffer + 19),"  Meter:%6.5f mA          ",voltagerescurr); 
									sprintf(KEYINBUF,"%6.5f",voltagerescurr);
									setInputParameter(0x5B,7,FLOAT,NULL ,1.05 , 1.01);	
								}
								else if(menuLevel1 == 7)
								{
									if (IS_FAT_CAL)
										eepRead((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
									else
										eepRead((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
									sprintf((void *)(displayBuffer + 19),"  Meter:%6.5f mA          ",currentrescurr); 
									sprintf(KEYINBUF,"%6.5f",currentrescurr);
									setInputParameter(0x5B,7,FLOAT,NULL ,1.05 , 1.01);	//
								}
								reverseState();
							}
							else
							{
								dacControl(DAC_VOLTAGE,0,ON); // eX0V	 AD
								dacControl(DAC_CURRENT,0,ON); // eX0V	 AD
								VOL_RES_SEL_LOW;
								CURR_RES_SEL_LOW;
								dpFlag = 0;
								CLR_NUMBER;
							   	CLR_SETTING;
								CLR_STRING;
								cursorPosition = 0;
								cursorPatternPosition = menuLevel1;
								menuLevelPosition = 0;
								sprintf((void *)displayBuffer,"UI TEST           ");
								strcpy((void *)menuItemBuffer," EEPROM  |EXT_CTRL |EXT_VOLT><EXT_CURR|INT_UART |EXT_UART><EXT_V_CC| EXT_I_CC|  EXIT   ");
								cursorItemNumber = 9;  
								flashBlock(0);
								actualState = SELFTEST3;
								lastState = lastLastState;
								lastLastState = lastLastLastState;
							}
						}
						else
				        	gotoUpLayer();	 // D_ESC
					}
				}
				else
				{
                    switch(lastState)
					{	
					    case D_NORMAL:
							if (actualState == D_ESC)
							{
								if (IS_SHOW_ENA && ENABLE_CPU_PIN == SET)
								{
									if (IS_SHOW_ENA)
									{
										CLR_SHOW_ENA;
										setVFDFlashOff(0x40, 48);	
									}		  
								}
								if (extShutOffLogic == FALLING_EDGE) //off/low Logic
								{
									if (SHUTOFF_CPU_PIN != SET)
									{
										if (IS_SHOW_SO)
										{
											CLR_SHOW_SO;
											setVFDFlashOff(0x40, 48);
										}
									}
								}
								else
								{
									if (SHUTOFF_CPU_PIN == SET)
									{
										if (IS_SHOW_SO)
										{
											CLR_SHOW_SO;
											setVFDFlashOff(0x40, 48);
										}
									}
								}
								cursorPosition = 0;
								CLR_SETTING;
								CLR_NUMBER;
								if (IS_DEBUG)
								{
									CLR_DEBUG;
									strcpy((void *)displayBuffer,"                                                ");
								}
							}
							reverseState();
						    break;
					    case STORE:
							if (actualState == D_OK)
							{
							    if (keyInBuffer[0] >= '0' && keyInBuffer[0] <= '9')
								{
									save(keyInBuffer[0] - 48);
									gotoUpLayer();
								}
								else
								{
									reverseState();
								}
							}
							else
							    gotoUpLayer();//ESC
						    break;
						case RECALL:
							if (actualState == D_OK && (keyInBuffer[0] >= '0' && keyInBuffer[0] <= '9') )
							{
								if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
									eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
								if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
									eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));	
								ProtOVActivation = ProtOCActivation = ProtOPActivation = 0;
								verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
								if (protsw & BIT7)
								{
									ProtOVActivation = 1;
									verifyInput(OVPSET_CMD,master.OVPSet );
								}
								if (protsw & BIT6)
								{
									ProtOCActivation = 1;
									verifyInput(OCPSET_CMD,master.OCPSet );
								}
								if (protsw & BIT5)
								{
									ProtOPActivation = 1;
									verifyInput(OPPSET_CMD,master.OPPSet );
								}
								if (protsw & BIT4)
								{
									CVtoCCActivation = 1;
								}
								if (protsw & BIT3)
								{
	    							CCtoCVActivation = 1;
								}
								if (errorQueue[errorIndex - 1] == MEASURE_VERIFY_ERROR)
								{
   									actualState = D_NORMAL;
   									lastState = lastLastState;
									lastLastState = lastLastLastState;
								}
								else
								{
									gotoUpLayer();
								}
								parallelInitRun();
							}
							else
							{
								if (IS_NUMBER)
								{
									master.vSet = bkvSet;
									master.iSet = bkiSet;
									master.OVPSet = bkOVPSet;
									master.OCPSet = bkOCPSet;
									master.OPPSet = bkOPPSet;
								}
								gotoUpLayer(); //ESC
							}
						    break;
						case PASSWORD:
							if (actualState == D_OK)
							{
							    if (strcmp(KEYINBUF,"24680") == 0)
								{
									strcpy((void *)displayBuffer,"CALIBRATION       ");
									strcpy((void *)menuItemBuffer," VOLTAGE | CURRENT |  OVP   ><   OCP  |EXT_VOLT |EXT_CURR><EXT_V_CC| EXT_I_CC|         ");
									cursorPosition = 0;
									cursorPatternPosition = 0;
									cursorItemNumber = 8; 
									flashBlock(0);				                
									actualState =  CAL;	
									CLR_SETTING;
									SET_FAT_CAL;// tե	
								}
								else if(strcmp(KEYINBUF, "13579") == 0)
								{
									strcpy((void *)displayBuffer,"CALIBRATION       ");
									strcpy((void *)menuItemBuffer," VOLTAGE | CURRENT |  OVP   ><   OCP  |EXT_VOLT |EXT_CURR><EXT_V_CC| EXT_I_CC|R FACTORY");
									cursorPosition = 0;
									cursorPatternPosition = 0;
									cursorItemNumber = 9; 
									flashBlock(0);				                
									actualState =  CAL;	
									CLR_SETTING;
									CLR_FAT_CAL;  //USER ե
																				   
								}
								else
									reverseState();
								pvsONOFF = OFF;
								sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
 								extEnable = OFF;
								eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
								extVMode = 0;
								eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
								extIMode = 0;
								eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));								
							}
							else
							   gotoUpLayer(); //ESC
						    break;
					    case TIMERONOFF:
							if (actualState == D_OK)
							{
								uint8_t tempBuf[4] = {0,0,0,0};
							    timerONOFF = parameterTemp;
								if (timerONOFF == ON)	// ON
								{

//									parallelMode = OFF;
//									eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
									chainMode = OFF;
									VFDsign &=  ~(sign_ADDR);
									eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));

								    programONOFF = OFF;  // ֫] ִNDv
								    pvsONOFF = OFF;
									sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

									extEnable = OFF;
									eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
									extVMode = 0;
									eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
									extIMode = 0;
									eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));


									memcpy((void *)(tempBuf),(void *)(displayBuffer + 19 +13),2);
									timerMN = atoi((void *)tempBuf);
									memcpy((void *)(tempBuf),(void *)(displayBuffer + 19 +19),2);
									timerSE = atoi((void *)tempBuf);
									memcpy((void *)(tempBuf),(void *)(displayBuffer + 19 +6),3);
									timerHR = atoi((void *)tempBuf);
									eepWrite((uint8_t *)&timerHR, EE_TIMERHR ,sizeof(uint16_t));
									eepWrite((uint8_t *)&timerMN, EE_TIMERMN ,sizeof(uint8_t));
									eepWrite((uint8_t *)&timerSE, EE_TIMERSE ,sizeof(uint8_t));
									runningTimer = (timerHR * 60 * 60) + (timerMN * 60) + timerSE;
									if ((int32_t)runningTimer > 0)
									{
										actualState = SET_ONOFF_FLAG; // Wp
										onoffStatus ^= 0x01;
									}
								}
								else
								{
									runningTimer = 0xffffffff;
						    		VFDsign &= ~(sign_STAR);
	    							TIM_Cmd(TIM2, DISABLE);  //timer interrupt
								}
							}
						    gotoUpLayer();
						    break;
						case PROGRAMONOFF:
							if (actualState == D_OK)
							{
							    programONOFF = programONOFFTemp;
								programGroup = programGroupTemp;
								eepWrite((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t)); // 0 OŦ ҥHq+1}l
							    if (programONOFF == ON)  // ֫] ִNDv
								{    
 									parallelMode = OFF;
									eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
									chainMode = OFF;
									VFDsign &=  ~(sign_ADDR);
									eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));

								    timerONOFF = OFF;
									pvsONOFF = OFF;
									sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

 									extEnable = OFF;
									eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
									extVMode = 0;
									eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
									extIMode = 0;
									eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
									actualState = PROGRAMREADY;
									// = 1; // ] group 0  }OťX   1 ~ 9	i
									eepRead((uint8_t *)&totalRepeat , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
									step = 0;
									repeat = totalRepeat;
									cursorPatternPosition = 0;
								    setVFDFlashOff(0x40, 48);
									cursorPosition = 0;
									getFirstStepProgram();							
								}								
							}
							else if (actualState == D_ESC)
							{
								programONOFFTemp = programONOFF;
								programGroupTemp = programGroup;
								
							}
							gotoUpLayer();
							break;
						case PROGRAMMODE:
							if (actualState == D_OK)
							{
								setVFDFlashOff(0x40, 48);
							    switch(cursorPatternPosition)
								{
								    case 1:
										programGroupTemp = atoi(KEYINBUF);
										programGroup = programGroupTemp;
										eepWrite((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t)); // 0 OŦ ҥHq+1}l
										CLR_NUMBER;
										programONOFF = programONOFFTemp;
							    		if (programONOFF == ON)  // ֫] ִNDv
										{    				  
											parallelMode = OFF;
											eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
											chainMode = OFF;
											VFDsign &=  ~(sign_ADDR);
											eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));

								    		timerONOFF = OFF;
											pvsONOFF = OFF;
											sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

 											extEnable = OFF;
											eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
											extVMode = 0;
											eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
											extIMode = 0;
											eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
											actualState = PROGRAMREADY;
											eepRead((uint8_t *)&totalRepeat , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
											step = 0;
											repeat = totalRepeat;
											cursorPatternPosition = 0;
								    		setVFDFlashOff(0x40, 48);
											cursorPosition = 0;
											getFirstStepProgram();
										}
										else
											gotoUpLayer();
									    break;
									case 2:	// PROGRAMEDIT
										menuLevel1 = cursorPatternPosition; // memory entry point (EDIT)
									    actualState = PROGRAMEDIT;
										switch(menuLevel2)
										{
										    case 0:
												setInputParameter(0x4C,3, INTEGER ,NULL ,STEPMAX , 1);  // step parameter
											    break;
											case 1:
											    cursorPosition = 0;
												actualState = PROGRAMEDITACT;
												SET_SETTING;
												SET_STRING;
												setVFDFlashOn(0x50,3);
											    break;
										    case 2:
												setInputParameter(0x55,6, FLOAT ,LIMIT_COMPARE ,master.limitVMax ,master.limitVMin );  // voltage parameter
											    break;
										    case 3:
												setInputParameter(0x5F,7, FLOAT ,LIMIT_COMPARE , master.limitIMax ,master.limitIMin);  // current parameter
											    break;
										    case 4:
												setInputParameter(0x69,6, FLOAT ,NULL , 6000 ,0);  // timer parameter
											    break;
										}
										cursorPatternPosition = menuLevel2;
										sprintf(KEYINBUF,"%.3d",step + 1);
										readProgramParameter();
									    break;
								}
							}
							else
							{
								programONOFFTemp = programONOFF;
								programGroupTemp = programGroup;
							    gotoUpLayer(); // D_ESC
							}
							break;
						case PROGRAMREPEAT:
							if (actualState == D_OK)
							{
						    	if (cursorPatternPosition == 0)
								{
									repeatGroup[programGroup] = atoi(KEYINBUF);
									eepWrite((uint8_t *)&repeatGroup[programGroup] , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
									setInputParameter(0x6A,1,INTEGER,NULL ,9 , 0); // linkNumberGroup parameter
									sprintf(KEYINBUF ,"%.1d",linkNumberGroup[programGroup]);
									setVFDFlashOff(0x40,48);
									cursorPatternPosition = 1;
									reverseState();
								}
								else
								{
								    linkNumberGroup[programGroup] = atoi(KEYINBUF);
									eepWrite((uint8_t *)&linkNumberGroup[programGroup] , (uint16_t)(EE_LINKNUMBERGROUP + programGroup * sizeof(uint8_t)) ,sizeof(uint8_t));
									gotoUpLayer();
									lastLastLastState = lastLastState;
									lastLastState = lastState;
									lastState = actualState;
									actualState = D_ESC;
									gotoUpLayer();
									SET_SETTING;
									SET_STRING;
								}
							}
							else
							    gotoUpLayer();
						    break;
						case PROGRAMEDIT:
							if (actualState == D_OK)
							{
//								uint8_t temp[10];
								float temp1;
							    setVFDFlashOff(0x40,48);programGroup = programGroupTemp;
							    switch(cursorPatternPosition)
								{
								    case 0:	// save step
									    if ((atoi(KEYINBUF) >= 1) && (atoi(KEYINBUF) <= STEPMAX))
										{
									    	step = atoi(KEYINBUF) - 1;
											readProgramParameter();
											SET_STRING;
									    	cursorPosition = 0;
											setVFDFlashOn(0x50,3);
									    	CLR_NUMBER;
											actualState = PROGRAMEDITACT;
											cursorPatternPosition++;
											programGroup = programGroupTemp;
										}
										else
										{
											reverseState();
											pushError(OVER_RANGE);
										}
									    break;
									case 2:	 // save voltage
									    if ( atof(KEYINBUF) <= numericalInput.floatMax && atof(KEYINBUF) >= numericalInput.floatMin)
										{
									    	voltage = atof(KEYINBUF);
											*(uint16_t *)(programParameter + PROG_VOLTAGE) = convertFloatToInt(voltage, master.vMax, fullScale);
											eepWrite(&programParameter[PROG_VOLTAGE] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_VOLTAGE) ,sizeof(uint16_t));
											cursorPatternPosition++;
											sprintf(KEYINBUF,(void *)currDisp[currPoint],current);
											setInputParameter(0x5F,7,FLOAT,LIMIT_COMPARE ,master.limitIMax ,master.limitIMin); // current parameter
										}
										else
										    pushError(OVER_RANGE);
										reverseState();
									    break;
									case 3:	 //  save current
										temp1 = atof(KEYINBUF);
										temp1 = round(temp1,around);
//										sprintf((void *)temp,(void *)currDisp[currPoint],temp1);
//										temp1 = atof((void*)temp);
									    if ( temp1 <= (numericalInput.floatMax+0.000001) && temp1 >= (numericalInput.floatMin - 0.000001))
										{
											sprintf((void *)KEYINBUF,(void *)currDisp[currPoint],temp1);
											memcpy((void *)(displayBuffer + 31),(void *)KEYINBUF,strlen((void *)KEYINBUF));
									    	current = atof(KEYINBUF);
											*(uint16_t *)(programParameter + PROG_CURRENT) = convertFloatToInt(current, master.iMax, fullScale);
											eepWrite(&programParameter[PROG_CURRENT] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_CURRENT) ,sizeof(uint16_t));
											cursorPatternPosition++;
											sprintf(KEYINBUF,"%5.1f",timer);
											setInputParameter(0x69,6,FLOAT,NULL ,6000 ,0); // timer parameter
    									}
										else
										    pushError(OVER_RANGE);
										reverseState();
									    break;
									case 4:	 // save time
									    if (atof(KEYINBUF) <= numericalInput.floatMax) 
										{
											timer = atof(KEYINBUF);
											*(uint16_t *)(programParameter + PROG_TIMER) = timer * 10;
											cursorPatternPosition = 0;
											eepWrite(&programParameter[PROG_TIMER], (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_TIMER) ,sizeof(uint16_t));
											setInputParameter(0x4C,3, INTEGER ,NULL ,STEPMAX , 1);  // step parameter
											if (*(uint8_t *)(programParameter + PROG_ACT) == END) // END
											{
								    			menuLevel2 = 4;
												eepRead((uint8_t *)&repeatGroup[programGroup] , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
												eepRead((uint8_t *)&linkNumberGroup[programGroup] , (uint16_t)(EE_LINKNUMBERGROUP + programGroup * sizeof(uint8_t)) ,sizeof(uint8_t));
												if (linkNumberGroup[programGroup] == 0)
									    			sprintf((void *)(displayBuffer + 19),"REPEAT:%.2d    NEXT PROG:NONE  ",repeatGroup[programGroup]);
												else
									    			sprintf((void *)(displayBuffer + 19),"REPEAT:%.2d    NEXT PROG:%.1d     ",repeatGroup[programGroup],linkNumberGroup[programGroup]);
												actualState = PROGRAMREPEAT;
												cursorPatternPosition = menuLevel3;
												if (cursorPatternPosition == 0)
												{
									   				setInputParameter(0x5A,2,INTEGER,NULL ,99 , 0); // repeat parameter
													sprintf(KEYINBUF,"%.2d",repeatGroup[programGroup]);
												}
												else
												{
									    			setInputParameter(0x6A,1,INTEGER,NULL , 9 , 1); // linkNumber parameter
													sprintf(KEYINBUF,"%.1d",linkNumberGroup[programGroup]);
												}
												return;
											}											
											else
											{
												if (++step ==STEPMAX)
													step = 0;
												sprintf(KEYINBUF,"%.3d",step + 1);
												readProgramParameter();
											}
										}
										else
										    pushError(OVER_RANGE);
									    reverseState();
									    break;
								}
							}
							else
							    gotoUpLayer();
						    break;
						case PROGRAMEDITACT:
						    if (actualState == D_OK)
							{ 
						        cursorPatternPosition = 2;programGroup = programGroupTemp;
							    *(uint8_t *)(programParameter + PROG_ACT) = parameterTemp;
								eepWrite(&programParameter[PROG_ACT] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_ACT) ,sizeof(uint8_t));
									sprintf(KEYINBUF,(void *)voltDisp[voltPoint],voltage);
									setInputParameter(0x55,6,FLOAT,LIMIT_COMPARE , master.limitVMax ,master.limitVMin); // voltage parameter
							    	actualState = PROGRAMEDIT;
							    setVFDFlashOff(0x40,48);
						    }
							else
							    gotoUpLayer();
							break;
					    case TIMEREDIT:
							if (actualState == D_OK)
							{
						        if(cursorPatternPosition == 2) // 
							    {
									if (atoi(KEYINBUF) > numericalInput.intMax)
									{
										displayBuffer[38] = '5';
										displayBuffer[39] = '9';
										keyInBuffer[0] = '5';
										keyInBuffer[1] = '9';

										timerSE = 59;
									}
									else
									{
							 			timerSE = atoi(KEYINBUF);
									}
								    cursorPatternPosition++;
									setVFDFlashOff(0x40,48);
									setVFDFlashOn(0x5B + (cursorPatternPosition * 6),3);
									SET_STRING;
									CLR_NUMBER;
									cursorPosition = 0;
									reverseState();
									actualState = TIMERONOFF;
							    }
								else   // HR  MIN  DEC  position pressed ok -> nothing
								{	setVFDFlashOff(0x40,48);
								    switch(cursorPatternPosition)
									{
									    case 0:
											timerHR = atoi(KEYINBUF);
											setInputParameter(0x60,2,INTEGER,NULL , 59 , 0);	// min parameter
											keyInBuffer[0] = displayBuffer[32];
											keyInBuffer[1] = displayBuffer[33];
											keyInBuffer[2] = 0;	setVFDFlashOn(0x60,2);
										    break;
										case 1:
										    if (atoi(KEYINBUF) > numericalInput.intMax)
											{
											    memcpy((void *)(displayBuffer + 19 + 13),"59",2);
												strcpy(KEYINBUF,"59");
											}
											timerMN = atoi(KEYINBUF);
											keyInBuffer[0] = displayBuffer[38];
											keyInBuffer[1] = displayBuffer[39];
											keyInBuffer[2] = 0;
											setVFDFlashOn(0x66,2);
											setInputParameter(0x66,2,INTEGER,NULL , 59 ,0);	// sec parameter
										    break;
										case 2:
										    if (atoi(KEYINBUF) > numericalInput.intMax)
											{
											    memcpy((void *)(displayBuffer + 19 + 19),"59",2);
												strcpy(KEYINBUF,"59");
											}	
										    break;
									}
								    cursorPatternPosition++;
									cursorPosition = 0x5B + cursorPatternPosition * 6;
//									setVFDFlashOff(0x40,48);
									CLR_NUMBER;
									reverseState();
								}
							}
							else
							    gotoUpLayer(); // D_ESC
						    break;
						case PROGRAMREADY:
							if (actualState == D_ESC)
							{
								reverseState();
								CLR_DEBUG;
							} 
							break;
						default:				    
    						if (actualState == D_OK) 
							{
	    			    		if (convertSettingValue() == 1)
								{
									reverseState();
    					    		return;  // ERROR MESSAGE(OVER or UNDER Range)
								}
							}
    						VFDsign = VFDsign & (~sign_VSET) & (~sign_ISET);// & (~sign_OVP) & (~sign_OCP) & (~sign_OPP);
							gotoUpLayer();
							break;
					}
				}
			    break;
			case D_MENU:
				if (VFDsign & sign_OFF)
				{
					if (IS_PARALLELMODE_SLAVE_ERROR_CONNECT || lastState == RECALL )
					{
						CLR_PARALLELMODE_SLAVE_ERROR_CONNECT;
					}

/*					if (parallelMode == ON && parallelRole == MASTER && (masterState != QUERYCURR && masterState != BROADCAST) )
					{
						{
							reverseState();		 //p ܪAU MENU קKn~
							break;
						}
					}	 */
#ifndef		MB_NOT_IN 
					clearMeasureCommand();//Nbuffer Bzʥ] M
#endif				
					if (lastState == MENUPVS || lastState == MENUPVSCURVE ||  lastState == MENUPVSEDIT )	
					{
 						if (pvsONOFF == ON)		//֫]ִNDv
						{
//							parallelMode = OFF;
//							eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
//							chainMode = OFF;
//							VFDsign &=  ~(sign_ADDR);
//							eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
							timerONOFF = OFF;
							programONOFF = OFF;
 							extEnable = OFF;
							eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
							extVMode = 0;
							eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
							extIMode = 0;
							eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
							queryCurveparrmeter();
							/*
							clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
							sendMBStateSetting(MEASURE_CHANNEL,PVSCURVEQ_CMD, curve);	// D6 query curve parameter?
							Rule = 0;Vmp = 0; Pmp = 0; Material = 0;
							delayMs(70);
							clearMeasureCommand();//KPVSCURVER_CMD
							if (Rule == 0) // try again
							{
								sendMBStateSetting(MEASURE_CHANNEL,PVSCURVEQ_CMD, curve);	// D6 query curve parameter?
								delayMs(70);
								clearMeasureCommand();//KPVSCURVER_CMD
								if (Rule == 0)
									pushError(PV_SIM_DATA_ERROR);
							}	*/
						}
						sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
						delayMs(50);
						sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
//						delayMs(50);
//						percentage = 10000;
//						sendMBIntSetting( PVSSIMPOWER_CMD, percentage);					// D8 
//						pvsG = 1000; // 1000
//						pvsT = 2500; // 25
//						sendMBIntSettingFloatInt16( PVSSIMGT_CMD, 1000,2500);					// D8 

/*







						clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
						sendMBStateSetting(MEASURE_CHANNEL,PVSCURVEQ_CMD, curve);	// D6 query curve parameter?
						Rule = 0;Vmp = 0; Pmp = 0; Material = 0;
						delayMs(100);
						clearMeasureCommand();//KPVSCURVER_CMD 
						if (Rule == 0) // try again
						{
							sendMBStateSetting(MEASURE_CHANNEL,PVSCURVEQ_CMD, curve);	// D6 query curve parameter?
							delayMs(50);
							clearMeasureCommand();//KPVSCURVER_CMD
							if (Rule == 0)
								pushError(PV_SIM_DATA_ERROR);
						}	
						sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
						delayMs(50);
						sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
						delayMs(50);
						percentage = 10000;
						sendMBIntSetting( PVSSIMPOWER_CMD, percentage);					// D8 
						checkPowerOnState();
						if (pvsONOFF == ON)
						{
							timerONOFF = OFF;
							programONOFF = OFF;
 							extEnable = OFF;
							eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
							extVMode = 0;
							eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
							extIMode = 0;
							eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
						}	 */
					}		 
					setVFDFlashOff(0x40,48);
    		    	VFDsign |= sign_MENU;
					sprintf((void *)displayBuffer,"MENU              ");
					sprintf((void *)menuItemBuffer," SYSTEM  | CONFIG  | PV SIM ><  INFO  |   CAL   |         ");
					cursorPatternPosition = menuLevel1; // start address
					cursorItemNumber = 5;  // 4 Item
					menuLevelPosition = 0; //first layer
					SET_FROM_MENU;	//qmenui
					switch(cursorPatternPosition)
					{
					    case 0:
							memcpy((void *)(displayBuffer + 19) ,(void *)menuItemBuffer,29);
							setVFDFlashOn(0x54,8);
							break;
						case 3:
							memcpy((void *)(displayBuffer + 19) ,(void *)(menuItemBuffer + 29),29);
						    setVFDFlashOn(0x54,8);
						    break;
						case 1:
							memcpy((void *)(displayBuffer + 19) ,(void *)menuItemBuffer,29);
							setVFDFlashOn(0x5D,9);
							break;
						case 4:
							memcpy((void *)(displayBuffer + 19) ,(void *)(menuItemBuffer + 29),29);
						    setVFDFlashOn(0x5D,9);
						    break;
						case 2:
							memcpy((void *)(displayBuffer + 19) ,(void *)menuItemBuffer,29);
							setVFDFlashOn(0x67,8);
							break;
						case 5:
							memcpy((void *)(displayBuffer + 19) ,(void *)(menuItemBuffer + 29),29);
						    setVFDFlashOn(0x67,8);
						    break;

				    }
				}
				else
					reverseState();
				break;
            case MENUCONFPROTOVP:
            	parameterTemp = ProtOVActivation;
		        sprintf((void *)(displayBuffer + 19), " OVP:   %s        ",ProtOVActivation > OFF ? " ON":"OFF");
				setVFDFlashOn(0x5B, 3); 
				CLR_FROM_MENU;
				SET_SETTING;	
				SET_STRING;
				break;
            case MENUCONFPROTOCP:
            	parameterTemp = ProtOCActivation;
		        sprintf((void *)(displayBuffer + 19), " OCP:   %s        ",ProtOCActivation > OFF ? " ON":"OFF");
				setVFDFlashOn(0x5B, 3);
				CLR_FROM_MENU; 
				SET_SETTING;	
				SET_STRING;
				break;
            case MENUCONFPROTOPP:
            	parameterTemp = ProtOPActivation;
		        sprintf((void *)(displayBuffer + 19), " OPP:   %s        ",ProtOPActivation > OFF ? " ON":"OFF");
				setVFDFlashOn(0x5B, 3);
				CLR_FROM_MENU; 
				SET_SETTING;	
				SET_STRING;
				break;
			default:
			    menuNestHandler();
			    break;
		}
	}
}

// Ū program step master.vSet & master.iSet
void getFirstStepProgram(void)
{
	uint8_t i;
	for (i = 0  ; i < STEPMAX ;  )
	{
		eepRead((uint8_t *)&programParameter, (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + i * SIZEOF_STEP_PACKET) ,SIZEOF_STEP_PACKET);
		if (*(uint8_t *)(programParameter + PROG_ACT) == NAC) //NAC
		{
		   	i++; // check next STEP  status
		}
		else
			break;					
	}
	programRunningTimer = *(uint16_t *)(programParameter + PROG_TIMER);
	if ( programRunningTimer != 0)	 // ɶO 0 NeƨUO  U@step
	{
		timer = programRunningTimer / 10;
		// send vset
		master.vSet = ((*(uint16_t *)(programParameter + PROG_VOLTAGE)) * master.vMax)/fullScale;
		master.vSet = roundDigit(master.vSet,voltPoint);
//		sprintf((void *)temps,(void *)voltDisp[voltPoint],master.vSet);
//		master.vSet = atof((void *)temps);
		if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
		// send iset
		if (specif == V_600)
		{
			float buffer , buffer1;
			buffer1 = *(uint16_t *)(programParameter + PROG_CURRENT); 
			buffer = roundDigit(buffer1* 42925 /fullScale ,0);
			master.iSet = buffer * around ;
		}
		else
			master.iSet = ((*(uint16_t *)(programParameter + PROG_CURRENT)) * master.iMax)/fullScale;
		master.iSet = roundDigit(master.iSet,currPoint);
		master.iSet = round(master.iSet ,around);
		if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));	
 		voltage = master.vSet;
		current = master.iSet;

	}
	else
	{
		if (i == 100)
		{
			master.vSet = master.vMin;
			master.iSet = master.iMin;
			if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
				eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
			if (verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
				eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));	
			voltage = master.vSet;
			current = master.iSet;

		}
	}
	if (voltage * current > master.pMax)	// AUTO RANGE
		current = master.pMax/voltage;	
	sprintf((void *)(displayBuffer+19), "PRG:%.1d S:%.3d R:%.2d/%.2d",programGroup,step+1 ,totalRepeat - repeat ,totalRepeat);
	displayFresh = 1;
}


void sendVolatgeCurrent(void)
{
	timer = programRunningTimer / 10;
	voltage = ((*(uint16_t *)(programParameter + PROG_VOLTAGE)) * master.vMax)/fullScale;
	voltage = roundDigit(voltage,voltPoint);
	if (specif == V_600)
	{
		float buffer ;
		float buffer1;
		buffer1 = *(uint16_t *)(programParameter + PROG_CURRENT) ; 
		buffer = roundDigit(buffer1* 42925 /fullScale ,0);
		current = buffer * around ;
	}
	else
		current = ((*(uint16_t *)(programParameter + PROG_CURRENT)) * master.iMax)/fullScale;

	if (voltage * current > master.pMax)	// AUTO RANGE
		current = master.pMax/voltage;
	current = roundDigit(current,currPoint);
	current = round(current ,around);
	// send vset
	if (verifyInput(VSET_CMD,voltage ) == SUCCESS)
		eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));	
	// send iset
	if (verifyInput(ISET_CMD,current ) == SUCCESS)
		eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));	

}


// program {ǳBz
void programHandler(void)  //y{ P88 P89
{
	if (actualState == PROGRAMRUNNING)
	{
	    if (programONOFF > 0)
		{
			switch(programState)
			{
				case 0:	// ǳƸ	 , read repeat first
				    if (programGroup == 0)	// NONE   check Link programGroup
					{
					    programState = 4; // STOP
						programStart = 0;
					}
					else
					{
						eepRead((uint8_t *)&repeatGroup[programGroup] , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
						repeat = repeatGroup[programGroup];
						totalRepeat = repeat;
						if (repeat == 0xFFFF)
						{
					    	programState = 4; // STOP
							programStart = 0;
						}
						else
						{
							step = 0;	 // programGroup step Y}l
							programState++;
						}
					}
					break;
				case 1:	// check status and send out
					if (step == STEPMAX)
					{
						programState = 4; // STOP
						programStart = 0;
					}
					else
					{
						eepRead((uint8_t *)&programParameter, (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET) ,SIZEOF_STEP_PACKET);
						if (*(uint8_t *)(programParameter + PROG_ACT) == NAC) //NAC
						{
					    	step++; // check next STEP  status
						}
						else if (*(uint8_t *)(programParameter + PROG_ACT) == ON || *(uint8_t *)(programParameter + PROG_ACT) == OFF) // ON
						{
							programRunningTimer = *(uint16_t *)(programParameter + PROG_TIMER);
							if ( programRunningTimer != 0)	 // ɶO 0 NeƨUO  U@step
							{
								// send output
								onoffStatus = *(uint8_t *)(programParameter + PROG_ACT);
								if (onoffStatus == ON)
								{
									TIM_Cmd(TIM2, ENABLE);
									sendVolatgeCurrent();
									if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
									{
									}
								}
								else   // OFF
								{
									if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
									{
										
										sendVolatgeCurrent();
										TIM_Cmd(TIM2, ENABLE);
									}
								}
//								TIM_Cmd(TIM2, ENABLE);
								/* read outputStats */
						    	programState += 2;  // timeoutISR  -2 	programState = 1 read next STEP
							}
							step++;
							sprintf((void *)(displayBuffer+19), "PRG:%.1d S:%.3d R:%.2d/%.2d",programGroup,step ,totalRepeat - repeat ,totalRepeat);
							displayFresh = 1;
						}
						else if(*(uint8_t *)(programParameter + PROG_ACT) == END) // END
						{
							eepRead((uint8_t *)&linkNumberGroup[programGroup] , (uint16_t)(EE_LINKNUMBERGROUP + programGroup * sizeof(uint8_t)) ,sizeof(uint8_t));
							programRunningTimer = *(uint16_t *)(programParameter + PROG_TIMER);
							if ( programRunningTimer != 0)//ɶO 0,NTǵU	
							{
								sendVolatgeCurrent();
								// send output
								onoffStatus = ON;
								if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
								{
									if (powerOnMode == 1) // LAST
										eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
								}
								TIM_Cmd(TIM2, ENABLE);
								/* read outputStats */
								sprintf((void *)(displayBuffer+19), "PRG:%.1d S:%.3d R:%.2d/%.2d",programGroup,step + 1 ,totalRepeat - repeat ,totalRepeat);
								displayFresh = 1;
								repeat--;
								if (repeat == 0xFFFF)   // group is finish Link next program
								{
									programGroup = linkNumberGroup[programGroup];
									programState++;	// go to programState 2 , ready to read next programGroup
								}
								else
								{
						    		step = 0;			//  repeat 	 ,prgramGroup s
									programState += 2;  // timeoutISR  -2 	programState = 1 read next STEP
								}
							}
							else  // time = 0	 // ɶO 0 NeƨUO  U@step
							{
  								repeat--;
								if (repeat == 0xFFFF)   // group is finish Link next program
								{
									programGroup = linkNumberGroup[programGroup];
									programState = 0; 
								}
					    		step = 0;			//  repeat 	 ,prgramGroup s
							}	    
						}
					}
				    break;
				case 2:	//  repeat = 0,timer running   , next programGroup
				    break;
				case 3:	// ACK timer running   ,next stage is read next step
				    break;
				case 4:	// send onoffStatus for OFF
					onoffStatus = 0;
					programStart = 0;
					TIM_Cmd(TIM2, DISABLE);		  
					 // send output 
					if (verifyInput(OUTPUT_CMD,(float)onoffStatus ) == SUCCESS)
					{
						if (powerOnMode == 1) // LAST
							eepWrite((uint8_t *)&onoffStatus, EE_ONOFFSTATUS ,sizeof(uint8_t));
					}
					VFDsign &= ~(sign_STAR);				    
					step = 0;
					eepRead((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t)); // 0 OŦ ҥHq+1}l
					eepRead((uint8_t *)&programParameter, (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET) ,SIZEOF_STEP_PACKET);
					voltage = ((*(uint16_t *)(programParameter + PROG_VOLTAGE)) * master.vMax)/fullScale;
					//sprintf((void *)temps,(void *)voltDisp[voltPoint],voltage);
					//voltage = atof((void *)temps);
					voltage = roundDigit(voltage,voltPoint);
					current = ((*(uint16_t *)(programParameter + PROG_CURRENT)) * master.iMax)/fullScale;
					if (voltage * current > master.pMax)
						current = master.pMax/voltage;
				//	sprintf((void *)temps,(void *)currDisp[currPoint],current);
				//	current = atof((void *)temps);
					current = roundDigit(current,currPoint);
					current = round(current ,around);
					repeat = 0;
					actualState = PROGRAMREADY;
					getFirstStepProgram();
				    break;
		    }
		}
	}
}
// calibration {ǳBz
void calibrationHandler(void)
{
	static uint8_t flashcount = 0;
	if (IS_CAL_NOW)
	{
	    checkTimerCount(100);//200 ms
	    if (actualState == CALVOLTAGE)
		{
		   	if (IS_TIMER_COUNT_IS_READY)  //200ms flag
			{
				switch(calState)
				{
				    case 0:									
						if (IS_FAT_CAL)
							sendMBStateSetting(MEASURE_CHANNEL,CALVN_CMD, (presentPoint|0x80)); // 0xA4
						else
							sendMBStateSetting(MEASURE_CHANNEL,CALVN_CMD, presentPoint); // 0xA4
						setTimerCount();// delay 200ms
						calState++;
						break;
					case 1:
						if (IS_FAT_CAL)
							sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint|0x80); // 0xA5
						else
							sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint); // 0xA5
						setTimerCount();// delay 200ms
						calState++;
						break;
					case 3:	  // query VADC	  0xAC ->
					    if (IS_NUMBER == 0)
						{
							sendMBQuery(MEASURE_CHANNEL,VADCQ_CMD);	 // ŪUAD command
							setTimerCount();// delay 200ms
							calState++;
						}
					    break;
					case 2:		  // 0xA6 <-
					case 4:	  	  // 0xAD <-  received VADC
						if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)
						{
							uartBuffer[MEASURE_CHANNEL].packetCount--;
							if (receiveMBResponse(MEASURE_CHANNEL) != ERR )
							{  // receive 0xA6 state
								if (uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] == CALVNR_CMD)	//0xA6
								{
								    	calState = 3; // read AD
										if (displayFresh == 1)
										{
//											vMeter = 1092.3;
											if (presentPoint == 1)
											{
												if (voltPoint == 1)
												{
													if (vMeter > 100)
														sprintf(KEYINBUF,"%5.1f",vMeter);// 1.30
													else
														sprintf(KEYINBUF,"%5.2f",vMeter);// 1.30
												}
												else if(voltPoint == 2)
												{
													if (vMeter > 100)
														sprintf(KEYINBUF,"%6.2f",vMeter);// 1.47
													else
														sprintf(KEYINBUF,"%6.3f",vMeter);// 1.47
												}
											}
											else
											{
												if (voltPoint == 1)
												{
													if (vMeter > 1000)
														sprintf(KEYINBUF,"%6.1f",vMeter);// 1.30
													else
														sprintf(KEYINBUF,"%6.2f",vMeter);// 1.30
												}
												else if (voltPoint == 2)
													 sprintf(KEYINBUF,"%7.3f",vMeter);// 1.47
											}
										}
	                            }
								else if (uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] == VADCR_CMD) //0xAD
								{
										calState = 3; // read AD
								}	 
							}
						}
						else
						{
							if (softTimer[MAIN_COUNT].count > measureTick + 200) 		// if not received after 200ms, timeout
							{
								if (++calState == 5) calState = 1;
									measureTick = softTimer[MAIN_COUNT].count;	
							}
						}
					    break;
				}
			}
		}
		else if (actualState == CALCURRENT)
		{
		   	if (IS_TIMER_COUNT_IS_READY)  //200ms flag
			{
				switch(calState)
				{
				    case 0:
						if (IS_FAT_CAL)
							sendMBStateSetting(MEASURE_CHANNEL,CALIN_CMD, presentPoint|0x80); // 0xA8
						else
							sendMBStateSetting(MEASURE_CHANNEL,CALIN_CMD, presentPoint); // 0xA8
						setTimerCount();// delay 200ms
						calState++;
						break;
					case 1:
						if (IS_FAT_CAL)
							sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint|0x80); // 0xA9
						else	
							sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint); // 0xA9
						setTimerCount();// delay 200ms
						calState++;
						break;
					case 3:	  // query IADC
					    if (IS_NUMBER == 0)
						{
							sendMBQuery(MEASURE_CHANNEL,IADCQ_CMD);	 //ŪUAD command
							setTimerCount();// delay 200ms
							calState++;
						}
					    break;
					case 2:	 // 0xAA <-
					case 4:	 // 0xAF <- received IADC
						if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)
						{
							uartBuffer[MEASURE_CHANNEL].packetCount--;
							if (receiveMBResponse(MEASURE_CHANNEL) != ERR )	  // receive 0xAA state
							{  
								if (uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] == CALINR_CMD)//0xAA)
								{
							    	calState = 3;// read AD
//									iMeter = 5.4160;
									if (displayFresh == 1)
									sprintf(KEYINBUF,(void *)currDisp[currPoint],iMeter);
								}
								else if (uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] == IADCR_CMD)//0xAF)
								{
										calState = 3;
								}	 							
							}
						}
						else
						{
							if (softTimer[MAIN_COUNT].count > measureTick + 200) 		// if not received after 200ms, timeout
							{
								if (++calState == 5) calState = 1;
									measureTick = softTimer[MAIN_COUNT].count;	
							}
						}
					    break;	   
				}
			}
		}
		else if (actualState == CALOVP)
		{
				switch(calState)
				{
					case 5:
					    // standby
					    break;
					case 6:
						if (IS_FAT_CAL)
						    sendMBQuery(MEASURE_CHANNEL,FATSTARTOVPCALQ_CMD);	 // 0xB4 ->
						else
							sendMBQuery(MEASURE_CHANNEL,STARTOVPCALQ_CMD);	 // 0xB0 ->
						ovpCalState = 0xff;// change state
						CLR_VOLTAGE_FINISH;
						calState++;
						measureTick = softTimer[MAIN_COUNT].count;	// ]wݮɶ_I
						softTimer[WAIT_OVP_OCP_COUNT].count = softTimer[MAIN_COUNT].count; // ]wùܤư_I
						strcpy((void *)(displayBuffer+19),"    CALIBRATING              ");
						flashcount = 0;
						displayFresh = 1;
						break;
					case 7:		  // 0xB1 <-
						if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)
						{
							uartBuffer[MEASURE_CHANNEL].packetCount--;
							if (receiveMBResponse(MEASURE_CHANNEL) != ERR )
							{ 
							  	if (ovpCalState < 4)
								{
									switch(ovpCalState)
									{
										case 0:		// FAIL
											strcpy((void *)(displayBuffer+19),"    CALIBRATION FAIL         ");
											break;
										case 1:		// low OK
											strcpy((void *)(displayBuffer+19),"    CALIBRATION HIGH OK      ");
											break;
										case 2:		// high OK
											strcpy((void *)(displayBuffer+19),"    CALIBRATION LOW  OK      ");
											break;
										case 3:		// all OK
											if (IS_FAT_CAL)
												SET_FAT_FINAL_CAL;
											strcpy((void *)(displayBuffer+19),"    FINISHED                 ");
											CLR_SCPI_CAL; //  VFDP output PB 1.42
											break;
									}
									
									dispVFD48(DISPBUF);
									delayMs(7000);//Fq
									verifyInput(PORTSW_CMD, 0 );  // o@BOE7O  protect switch
									CLR_CAL_NOW; // done
									reverseState();
									gotoUpLayer();
									displayFresh = 1;
								}
							}
						}
						else   //ݮɶ
						{
							if (softTimer[MAIN_COUNT].count > (measureTick + (OVPCAL_TIME))) 		// if not received after 30 second, timeout
							{
								strcpy((void *)(displayBuffer+19),"    CALIBRATION TIME OUT     ");
								CLR_SCPI_CAL; //  VFDP output PB 1.42
								dispVFD48(DISPBUF);
								delayMs(1500);
								CLR_CAL_NOW; // done
								reverseState();
								gotoUpLayer();
								displayFresh = 1;
							}
							else	//ùܤ
							{
							    if (softTimer[MAIN_COUNT].count - softTimer[WAIT_OVP_OCP_COUNT].count > 250 )
								{
									displayFresh = 1;
									cursorPosition = 0;
									softTimer[WAIT_OVP_OCP_COUNT].count = softTimer[MAIN_COUNT].count;
									flashcount++;
									switch(flashcount%4)
									{
										case 0:
											memcpy((void *)(displayBuffer + 19 + 17),"   ",3);
											break;
										case 1:
											displayBuffer[19 + 17] = '.';
											break;
										case 2:
											displayBuffer[19 + 18] = '.';
											break;
										case 3:
											displayBuffer[19 + 19] = '.';
											break;
									}
								}
							}
						}
					    break;
				}
		}
		else if (actualState == CALOCP)
		{
				switch(calState)
				{
					case 5:
					    // standby
					    break;
					case 6:
						if (IS_FAT_CAL)
							sendMBQuery(MEASURE_CHANNEL,FATSTARTOCPCALQ_CMD);	 // 0xB2 ->
						else
							sendMBQuery(MEASURE_CHANNEL,STARTOCPCALQ_CMD);	 // 0xB2 ->
						ocpCalState = 0xff;// 
						CLR_CURRENT_FINISH;
						measureTick = softTimer[MAIN_COUNT].count;	// ]wݮɶ_I
						softTimer[WAIT_OVP_OCP_COUNT].count = softTimer[MAIN_COUNT].count; // ]wùܤư_I
						strcpy((void *)(displayBuffer+19),"    CALIBRATING              ");
						calState++;
						flashcount = 0;
						displayFresh = 1;
						break;
					case 7:  // 0xB3 <-	
						if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)
						{
							uartBuffer[MEASURE_CHANNEL].packetCount--;
							if (receiveMBResponse(MEASURE_CHANNEL) != ERR )
							{ 
							  	if (ocpCalState < 4)
								{
									switch(ocpCalState)
									{
										case 0:		// FAIL
											strcpy((void *)(displayBuffer+19),"    CALIBRATION FAIL         ");
											break;
										case 1:		// low OK
											strcpy((void *)(displayBuffer+19),"    CALIBRATION HIGH OK      ");
											break;
										case 2:		// high OK
											strcpy((void *)(displayBuffer+19),"    CALIBRATION LOW  OK      ");
											break;
										case 3:		// all OK
											if (IS_FAT_CAL)
												SET_FAT_FINAL_CAL;
											strcpy((void *)(displayBuffer+19),"    FINISHED                 ");
											CLR_SCPI_CAL; //  VFDP output PB 1.42
											break;
									}
									dispVFD48(DISPBUF);
									delayMs(1500);
								    verifyInput(PORTSW_CMD, 0 );   // o@BOE7O 
									CLR_CAL_NOW; // done
									reverseState();
									gotoUpLayer();
									displayFresh = 1;
								}
							}
						}
						else
						{		 //ݮɶ
							if (softTimer[MAIN_COUNT].count > (measureTick + (OCPCAL_TIME))) 		// if not received after 40 second, timeout
							{
								strcpy((void *)(displayBuffer+19),"    CALIBRATION TIME OUT     ");
								CLR_SCPI_CAL; //  VFDP output PB 1.42
								dispVFD48(DISPBUF);
								delayMs(1500);
								CLR_CAL_NOW; // done
								reverseState();
								gotoUpLayer();
								displayFresh = 1;
							}
							else //ùܤ
							{
							    if (softTimer[MAIN_COUNT].count - softTimer[WAIT_OVP_OCP_COUNT].count > 250 )
								{
									displayFresh = 1;
									cursorPosition = 0;
									softTimer[WAIT_OVP_OCP_COUNT].count = softTimer[MAIN_COUNT].count;
									flashcount++;
									switch(flashcount%4)
									{
										case 0:
											memcpy((void *)(displayBuffer + 19 + 17),"   ",3);
											break;
										case 1:
											displayBuffer[19 + 17] = '.';
											break;
										case 2:
											displayBuffer[19 + 18] = '.';
											break;
										case 3:
											displayBuffer[19 + 19] = '.';
											break;
									}
								}
							}
						}
						break;  
				}
		}
	}
	if (actualState == EXTCALVOLTAGE)
	{
		VOL_RES_SEL_LOW;
		extfilterV();
		if (softTimer[MAIN_COUNT].count - softTimer[TEMP_COUNT].count > (500 )) // 300 ms
		{
			softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ;
			sprintf((void *)(displayBuffer + 19 + 14) ,"AD:%.4d  P:%d/%d",(uint16_t)vADbuffer ,presentPoint,extCalTotalPoint);
			if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
				displayFresh = 1;
		}			
	}
	else if(actualState == EXTCALCURRENT)
	{
		CURR_RES_SEL_LOW;
		extfilterI();
		if (softTimer[MAIN_COUNT].count - softTimer[TEMP_COUNT].count > (500 )) // 300 ms
		{
			softTimer[TEMP_COUNT].count = softTimer[MAIN_COUNT].count ;
			sprintf((void *)(displayBuffer + 19 + 14) ,"AD:%.4d  P:%d/%d",(uint16_t)iADbuffer ,presentPoint,extCalTotalPoint);
			if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
				displayFresh = 1;
		}			
	}
	if (IS_SCPIEXTCAL_VOLT)
	   extfilterV(); 
	if (IS_SCPIEXTCAL_CURR)
	   extfilterI();
}


void extfilterV(void)
{
		uint16_t temp;
	/*  Bz A/D íw */
//		if (++t == 5)
		{
		getAdCh(0);

//		Databuf[d++] = ADCDualConvertedValue[0];
//		if (d == 1000)
//			d = 0;
//		sprintf((void *)buffer ,"%d\r\n",ADCDualConvertedValue[0]);
//		usbCdcTx((void *)buffer,strlen((void *)buffer));

		XnADCDualConvertedValue[0] = ADCDualConvertedValue[0];
		vADbuffer = ((YnADCDualConvertedValue[0] *(SAMPLE_WEIGHT - 1) ) + XnADCDualConvertedValue[0])/SAMPLE_WEIGHT ;
// (2)		xVdata[xVindex++] = ADCDualConvertedValue[0];
//		if (xVindex == SAMPLE_WEIGHT)
//			xVindex = 0;
//		for (vADbuffer = 0,temp = 0; temp < SAMPLE_WEIGHT ;temp++)
//			vADbuffer += xVdata[temp];
//		vADbuffer /= SAMPLE_WEIGHT;

//		xVdata[xVindex++] = ADCDualConvertedValue[0];
//		if (xVindex == SAMPLE_WEIGHT)
//		{
//			xVindex = 0;
//			for (vADbuffer = 0,temp = 0; temp < SAMPLE_WEIGHT ;temp++)
//				vADbuffer += xVdata[temp];
//			vADbuffer /= SAMPLE_WEIGHT;
//		}		
		
		YnADCDualConvertedValue[0] = vADbuffer;
		temp = vADbuffer * 10;
		if ((temp % 10) >= 5)
		{
			vADbuffer = temp/10;
			vADbuffer++;
		}
		else
			vADbuffer = temp/10;
		}
}

void extfilterI(void)
{
	/*  Bz A/D íw */
		uint16_t temp;
		getAdCh(1);
		XnADCDualConvertedValue[1] = ADCDualConvertedValue[1];
		iADbuffer = ((YnADCDualConvertedValue[1] * (SAMPLE_WEIGHT - 1)) + XnADCDualConvertedValue[1])/SAMPLE_WEIGHT;
		YnADCDualConvertedValue[1] = iADbuffer;
		temp = iADbuffer * 10;
		if ((temp % 10) >= 5)
		{
			iADbuffer = temp/10;
			iADbuffer++;
		}
		else
			iADbuffer = temp/10;

}

void HVVoltage(void)
{
	/*  Bz A/D íw */
	if (VFDflag == 1)
	{
		getAdCh(2);
		XnADCDualConvertedValue[2] = ADCDualConvertedValue[2];
		buf = ((YnADCDualConvertedValue[2] * (SAMPLE_WEIGHT - 1)) + XnADCDualConvertedValue[2])/SAMPLE_WEIGHT;
		YnADCDualConvertedValue[2] = buf;
	}
}



ErrorStatus queryStepByStep(COM_TypeDef COM ,uint8_t cmd ,uint8_t reply ,uint32_t waitTime)
{
    ErrorStatus result = SUCCESS; // 1: success  0:error
	uint32_t time1;
	while(uartBuffer[COM].packetCount != 0)
	{
		uartBuffer[COM].packetCount--;
		receiveMBResponse(COM) ;
	}
	time1 = softTimer[MAIN_COUNT].count;
	softTimer[TIME_ALARM_COUNT2].flag = DISABLE;
	while(softTimer[MAIN_COUNT].count - time1 < (waitTime * 5))
	{
		if (softTimer[TIME_ALARM_COUNT2].flag == DISABLE)
			sendMBQuery(COM,cmd);  //
		setTimerCount2();
		checkTimerCount2(waitTime);
		if ( IS_TIMER_COUNT_IS_READY2)
		{
			CLR_TIMER_COUNT_IS_READY2;
			if (uartBuffer[COM].packetCount != 0)
			{
				uartBuffer[COM].packetCount--;
				if ((receiveMBResponse(COM) != ERR)) 
				{
					if (uartBuffer[COM].simplePacket.payload[0] == reply)
					{
				    	result = SUCCESS;
				    	break;	// 0xA1   CRC okay
					}
					else
						result = ERROR;
				}
				else
					result = ERROR;
			}
			else
			{
			    result = ERROR; // S
			}
		}
	}
	if ( softTimer[MAIN_COUNT].count - time1 >= (waitTime * 5))
		return ERROR;
	else
		return result;
}


void calVoltageInit(void)
{
	// query number of Voltate point
	queryStepByStep(MEASURE_CHANNEL,CALPVQ_CMD,CALPVR_CMD ,30);
	calState = 0;
	SET_CAL_NOW;
}

void calCurrentInit(void)
{
 	// query number of Current point
 	queryStepByStep(MEASURE_CHANNEL,CALPIQ_CMD,CALPIR_CMD ,30);
	calState = 0;
	SET_CAL_NOW;
}


void setTimerCount(void)
{
    if (softTimer[TIME_ALARM_COUNT].flag == DISABLE)
	{
        softTimer[TIME_ALARM_COUNT].flag = ENABLE;
    	softTimer[TIME_ALARM_COUNT].count = softTimer[MAIN_COUNT].count;
    	CLR_TIMER_COUNT_IS_READY;
	}
}

void setTimerCount2(void)
{
    if (softTimer[TIME_ALARM_COUNT2].flag == DISABLE)
	{
        softTimer[TIME_ALARM_COUNT2].flag = ENABLE;
    	softTimer[TIME_ALARM_COUNT2].count = softTimer[MAIN_COUNT].count;
    	CLR_TIMER_COUNT_IS_READY2;
	}
}


void checkTimerCount(uint32_t time)
{
    if (softTimer[TIME_ALARM_COUNT].flag == ENABLE)
	{
		if (softTimer[MAIN_COUNT].count - softTimer[TIME_ALARM_COUNT].count > (time ))	 /* */
		{
			softTimer[TIME_ALARM_COUNT].flag = DISABLE;
			SET_TIMER_COUNT_IS_READY;
			if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
				displayFresh = 1;
		}
	}
}

void checkTimerCount2(uint32_t time)
{
    if (softTimer[TIME_ALARM_COUNT2].flag == ENABLE)
	{
		if (softTimer[MAIN_COUNT].count - softTimer[TIME_ALARM_COUNT2].count > (time ))	 /* */
		{
			softTimer[TIME_ALARM_COUNT2].flag = DISABLE;
			SET_TIMER_COUNT_IS_READY2;
			if (softTimer[ERROR_MESSAGE_COUNT].flag == DISABLE)
				displayFresh = 1;
		}
	}
}





// ѼƿJ A
void setInputParameter(uint8_t addr,uint8_t len , uint8_t point ,uint8_t fg,float max , float min)
{
    numericalInput.startAddress = addr;
	numericalInput.length = len;
	numericalInput.ft = point;
	numericalInput.flag = fg;
	numericalInput.floatMax = max;
	numericalInput.floatMin = min;
	numericalInput.intMax = max;
	numericalInput.intMin = min;
	cursorPosition = numericalInput.startAddress + numericalInput.length - 1;
	CLR_STRING;
	CLR_NUMBER;
	SET_SETTING;
	dpFlag = 0;
}

void inputNumerical(void)
{
	uint8_t i;
	if (IS_NUMBER == 0)
	{
		if (numericalInput.ft == FLOAT)
		{
			if (keyParameter.keyEvent == KEY_DP)
			{	
		   		if (dpFlag == 0)
				{		
		       		dpFlag = 1;
					for (i = 0 ; i < (numericalInput.length - 2) ; i++)
					    keyInBuffer[i] = ' ';
					keyInBuffer[i] = '0';
					keyInBuffer[i + 1] = '.';
				}
			}
			else
			{
			    for( i = 0 ; i < numericalInput.length ; i++)
	 			    keyInBuffer[i] = ' ';
				shiftBufferLeft(keyParameter.keyEvent + '0' , numericalInput.length);
			}
			showTempValue(numericalInput.startAddress);
			setVFDFlashOn(numericalInput.startAddress, numericalInput.length);
			cursorPosition = numericalInput.startAddress + numericalInput.length - 1;
			SET_NUMBER;
		}
		else
		{
			if (keyParameter.keyEvent != KEY_DP) //LpI\
		    {
				for(i = 0 ; i < numericalInput.length ; i++)
				    keyInBuffer[i] = '0';
				keyInBuffer[i] = 0;
		       	shiftBufferLeft(keyParameter.keyEvent + '0' ,numericalInput.length );
		    	memcpy((void *)(displayBuffer+ (numericalInput.startAddress - 0x40) ),(void *)keyInBuffer,numericalInput.length );
		    	setVFDFlashOn(numericalInput.startAddress , numericalInput.length);
//				cursorPosition = 0;
				SET_NUMBER;
			}

		}
	}
	else
	{
		if (numericalInput.ft == FLOAT)
		{
			if (keyParameter.keyEvent == KEY_DP)
			{	
		   		if (dpFlag == 0)
				{		
		       		dpFlag = 1;
		       		shiftBufferLeft('.' , numericalInput.length);
				}
			}
			else
			{
		   		shiftBufferLeft(keyParameter.keyEvent + '0' , numericalInput.length);
			}
			showTempValue(numericalInput.startAddress);
			setVFDFlashOn(numericalInput.startAddress, numericalInput.length);
			cursorPosition = numericalInput.startAddress + numericalInput.length - 1;
		}
		else
		{
			if (keyParameter.keyEvent != KEY_DP) //LpI\
			{
		       	shiftBufferLeft(keyParameter.keyEvent + '0' , numericalInput.length);
			   	memcpy((void *)(displayBuffer + (numericalInput.startAddress - 0x40)),(void *)keyInBuffer,numericalInput.length);
			}
			else
			{
			    if (IS_PT_SHIFT_RIGHT)
				{
				    //JƦr pI Ok U@沾 
					if (atoi(KEYINBUF) < 256)
					{
						switch(actualState)
						{
				            case MENUSYSCOMMLANIPADDR:
							    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
						        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
			                    if (memSysCommIpPosition < (4 - 1))
				                    memSysCommIpPosition++; //shift right
								sprintf(KEYINBUF ,"%.3d",LANIPAddrTemp[memSysCommIpPosition ]);
								break;
				            case MENUSYSCOMMLANMASK:
							    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
						        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
			                    if (memSysCommIpPosition < (4 - 1))
				                    memSysCommIpPosition++; //shift right
								sprintf(KEYINBUF ,"%.3d",LANMaskTemp[memSysCommIpPosition ]);
								break;
				            case MENUSYSCOMMLANGWAY:
							    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
						        memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3); //sܸư
			                    if (memSysCommIpPosition < (4 - 1))
				                    memSysCommIpPosition++; //shift right
								sprintf(KEYINBUF ,"%.3d",LANGatewayTemp[memSysCommIpPosition ]);
								break;
					    }
					}
					else
					{
						strcpy(KEYINBUF,"255");
						switch(actualState)
						{
				            case MENUSYSCOMMLANIPADDR:
							    LANIPAddrTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
								break;
				            case MENUSYSCOMMLANMASK:
							    LANMaskTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
								break;
				            case MENUSYSCOMMLANGWAY:
							    LANGatewayTemp[memSysCommIpPosition ] = atoi(KEYINBUF); // s
								break;
					    }										
						memcpy((void *)(displayBuffer + 19 + 13 + 4 * memSysCommIpPosition),KEYINBUF , 3);
					}
					setVFDFlashOff(0x40,48);
                    setInputParameter(0x60 + (memSysCommIpPosition * 4) , 3 , INTEGER , PT_SHIFT_RIGHT , 255 ,0);
				 }
			}
		}
	}
}

void runningTimerISR(void) // 0.1s _@
{
  	if(TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
	{
		if(actualState == PROGRAMRUNNING)
		{
			programCount++;
			if (programCount % 5 == 0)   // 0.5 second @ ,ıWC{{@
			{
				VFDsign ^= sign_STAR;
                displayFresh = 1;
			}
		    if (programCount >= 10)
			{
	    	    softTimer[SIGN_STAR_COUNT].count++;	   //  count
				programCount = 0;
                displayFresh = 1;
	 		}
    	    programRunningTimer--; 
			if ((int32_t)programRunningTimer == 0)
			{
				programState -= 2;
			}
		}
		else
		{
			timerCount++;
			if (timerCount % 5 == 0)	  // 0.5 second @ ,ıWC{{@
			{
				VFDsign ^= sign_STAR;
                displayFresh = 1;
			}
		    if (timerCount >= 10)
			{
	    	    runningTimer--;	   //  count
				timerCount = 0;
				displayFresh = 1;
	 		}
			if((int32_t)runningTimer == -1) // F 0 hƤ@
			{
	    		VFDsign &= ~(sign_STAR);
	    		TIM_Cmd(TIM2, DISABLE);  //timer interrupt
			}
		}
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
	}
}

void displayTmerISR(void) // 0.1s _@
{
  	if(TIM_GetITStatus(TIM5, TIM_IT_Update) != RESET)
	{
		TIM_ClearITPendingBit(TIM5, TIM_IT_Update);
	}
}

void softwareReset(void)
{
		CLR_MULTI_MASTER;
//		chainAddrSlave = 0;
		timerONOFF = OFF;
		programONOFF = OFF;
		memset((void *)transBuffer,0,256);
		pvsONOFF = OFF;
		sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
		delayMs(50);
		sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

		master.OVPSet = master.OVPMax; // 1100V / 660V
		if (verifyInput(OVPSET_CMD,master.OVPSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
		master.OCPSet = master.OCPMax; // 5.1A
		if (verifyInput(OCPSET_CMD,master.OCPSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
		master.OPPSet = master.OPPMax;// 5050W
		if (verifyInput(OPPSET_CMD,master.OPPSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
		protsw = 0;
		if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
		master.limitVMin = master.vMin;
		eepWrite((uint8_t *)&master.limitVMin, EE_LIMITVMIN ,sizeof(float));
		master.limitVMax = master.vMax; //1000
		eepWrite((uint8_t *)&master.limitVMax, EE_LIMITVMAX ,sizeof(float));
		master.limitIMin = master.iMin;
		eepWrite((uint8_t *)&master.limitIMin, EE_LIMITIMIN ,sizeof(float));
 		master.limitIMax = master.iMax; //5;//IMAX;
		eepWrite((uint8_t *)&master.limitIMax, EE_LIMITIMAX ,sizeof(float));
		limitPMin = PMIN;
		eepWrite((uint8_t *)&limitPMin, EE_LIMITPMIN ,sizeof(float));
 		limitPMax = master.pMax;//5000;
		eepWrite((uint8_t *)&limitPMax, EE_LIMITPMAX ,sizeof(float));
		master.SRvSet = VSRMax;	// 0.1V to 10V/ms
		if (verifyInput(VSRSET_CMD,master.SRvSet ) == SUCCESS)// send SRvSet
			eepWrite((uint8_t *)&master.SRvSet, EE_SRVSET ,sizeof(float));
		master.SRiSet = ISRMax;	// 0.5mA to 50mA/ms
		if (verifyInput(ISRSET_CMD,master.SRiSet ) == SUCCESS)// send SRvSet
			eepWrite((uint8_t *)&master.SRiSet, EE_SRISET ,sizeof(float));
		powerOnMode = OFF;
		powerOnVolt	= master.vMin;
		powerOnCurrent = master.iMin;
		powerOn_OnOff = OFF;
		eepWrite((uint8_t *)&powerOnMode, EE_POWERONMODE ,sizeof(uint8_t));
	// USER init	
		eepWrite((uint8_t *)&powerOn_OnOff, EE_POWERON_ONOFF ,sizeof(uint8_t)); // user on off control
		eepWrite((uint8_t *)&powerOnVolt, EE_POWERONVOLT ,sizeof(float));
		eepWrite((uint8_t *)&powerOnCurrent, EE_POWERONCURRENT ,sizeof(float));
		eepWrite((uint8_t *)&powerOn_OnOff, EE_ONOFFSTATUS ,sizeof(uint8_t));

		extVMode = 0;
		eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
		extIMode = 0;
		eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
		extProgRange = 0;
		eepWrite((uint8_t *)&extProgRange, EE_EXTPROGRANGE ,sizeof(uint8_t));
		extMonRange = 0;
		eepWrite((uint8_t *)&extMonRange, EE_EXTMONRANGE ,sizeof(uint8_t));
		extShutOffLogic = FALLING_EDGE;
		eepWrite((uint8_t *)&extShutOffLogic, EE_EXTSHUTOFFLOGIC ,sizeof(uint8_t));
		extEnable = OFF;
		eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
		parallelMode = OFF;
		eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
		parallelRole = MASTER;
		eepWrite((uint8_t *)&parallelRole, EE_PARALLELROLE ,sizeof(uint8_t));
		master.vSet = 10;
		master.iSet = 1;
		if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
		if ( verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
		eepRead((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));		// 1.37  
		eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));

		onoffStatus = 0;
		verifyInput(OUTPUT_CMD,(float)onoffStatus );
		clearOVPOCPOPPCVCCCCCV();
}


void eepromDefaultSet(void)
{
	CLR_MULTI_MASTER;
//	CLR_485_CHANNEL;
	chainAddrSlave = 0;
	timerONOFF = OFF;
	programONOFF = OFF;


		pvsONOFF = OFF;
		sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
		delayMs(50);
		sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
//		delayMs(50);
//		percentage = 10000;
//		sendMBIntSetting( PVSSIMPOWER_CMD, percentage);					// D8 
//		pvsG = 1000; // 1000
//		pvsT = 2500; // 25
//		sendMBIntSettingFloatInt16( PVSSIMGT_CMD, 1000,2500);					// D8 

		master.OVPSet = master.OVPMax; // 1100V / 660V
		if (verifyInput(OVPSET_CMD,master.OVPSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
		master.OCPSet = master.OCPMax; // 5.1A
		if (verifyInput(OCPSET_CMD,master.OCPSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
		master.OPPSet = master.OPPMax;// 5050W
		if (verifyInput(OPPSET_CMD,master.OPPSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
		protsw = 0;
		if (verifyInput(PORTSW_CMD, protsw ) == SUCCESS)
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
		master.limitVMin = master.vMin;
		eepWrite((uint8_t *)&master.limitVMin, EE_LIMITVMIN ,sizeof(float));
		master.limitVMax = master.vMax; //1000
		eepWrite((uint8_t *)&master.limitVMax, EE_LIMITVMAX ,sizeof(float));
		master.limitIMin = master.iMin;
		eepWrite((uint8_t *)&master.limitIMin, EE_LIMITIMIN ,sizeof(float));
 		master.limitIMax = master.iMax; //5;//IMAX;
		eepWrite((uint8_t *)&master.limitIMax, EE_LIMITIMAX ,sizeof(float));
		limitPMin = PMIN;
		eepWrite((uint8_t *)&limitPMin, EE_LIMITPMIN ,sizeof(float));
 		limitPMax = master.pMax;//5000;
		eepWrite((uint8_t *)&limitPMax, EE_LIMITPMAX ,sizeof(float));
		master.SRvSet = VSRMax;	// 0.1V to 10V/ms
		if (verifyInput(VSRSET_CMD,master.SRvSet ) == SUCCESS)// send SRvSet
			eepWrite((uint8_t *)&master.SRvSet, EE_SRVSET ,sizeof(float));
		master.SRiSet = ISRMax;	// 0.5mA to 50mA/ms
		if (verifyInput(ISRSET_CMD,master.SRiSet ) == SUCCESS)// send SRvSet
			eepWrite((uint8_t *)&master.SRiSet, EE_SRISET ,sizeof(float));
		powerOnMode = OFF;
		powerOnVolt	= master.vMin;
		powerOnCurrent = master.iMin;
		powerOn_OnOff = OFF;
		eepWrite((uint8_t *)&powerOnMode, EE_POWERONMODE ,sizeof(uint8_t));
	// USER init	
		eepWrite((uint8_t *)&powerOn_OnOff, EE_POWERON_ONOFF ,sizeof(uint8_t)); // user on off control
		eepWrite((uint8_t *)&powerOnVolt, EE_POWERONVOLT ,sizeof(float));
		eepWrite((uint8_t *)&powerOnCurrent, EE_POWERONCURRENT ,sizeof(float));
	// LAST init
//		eepWrite((uint8_t *)&powerOnVolt, EE_LASTVSET ,sizeof(float)); // 1.37
//		eepWrite((uint8_t *)&powerOnCurrent, EE_LASTISET ,sizeof(float));  //1.37
		eepWrite((uint8_t *)&powerOn_OnOff, EE_ONOFFSTATUS ,sizeof(uint8_t));

		R485Baud = BAUD_57600;	// 57600
		rs485parityDataBits	= 0;
		rs485stopBits = 0;
		R232Baud = 0;
		rs232parityDataBits	= 0;
		rs232stopBits = 0;

		eepWrite((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t));
		eepWrite((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t));
		eepWrite((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t));
		eepWrite((uint8_t *)&R232Baud, EE_R232BAUD ,sizeof(uint8_t));
		eepWrite((uint8_t *)&rs232parityDataBits, EE_RS232PARITYDATABITS ,sizeof(uint8_t));
		eepWrite((uint8_t *)&rs232stopBits, EE_RS232STOPBITS ,sizeof(uint8_t));

		initializeRs485(); // 
		initializeRs232(); // 

	    beepActivation = 0;// OFF
		eepWrite((uint8_t *)&beepActivation, EE_BEEPACTIVATION ,sizeof(uint8_t));
		extVMode = 0;
		eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
		extIMode = 0;
		eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
		extProgRange = 0;
		eepWrite((uint8_t *)&extProgRange, EE_EXTPROGRANGE ,sizeof(uint8_t));
		extMonRange = 0;
		eepWrite((uint8_t *)&extMonRange, EE_EXTMONRANGE ,sizeof(uint8_t));
		extShutOffLogic = FALLING_EDGE;
		eepWrite((uint8_t *)&extShutOffLogic, EE_EXTSHUTOFFLOGIC ,sizeof(uint8_t));
		extEnable = OFF;
		eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
		parallelMode = OFF;
		eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
		parallelRole = MASTER;
		eepWrite((uint8_t *)&parallelRole, EE_PARALLELROLE ,sizeof(uint8_t));
		chainMode = OFF;
		VFDsign &=  ~(sign_ADDR);
		eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
		chainAddr = 1;
		eepWrite((uint8_t *)&chainAddr, EE_CHAINADDR ,sizeof(uint8_t));
		GPIBAddr = 1;
		eepWrite((uint8_t *)&GPIBAddr, EE_GPIBADDR ,sizeof(uint8_t));
		LANIPMode = 0;// AUTO
		eepWrite((uint8_t *)&LANIPMode, EE_LANIPMODE ,sizeof(uint8_t));
		backupLANIPMode = LANIPMode;
		eepWrite((uint8_t *)&default_LANIPAddr, EE_LANIPADDR ,4);
		eepWrite((uint8_t *)&default_LANMask, EE_LANMASK ,4);
		eepWrite((uint8_t *)&default_LANGateway, EE_LANGATEWAY ,4);
		master.vSet = 10;
		master.iSet = 1;
		if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
		if ( verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
			eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
		eepRead((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));		// 1.37  
		eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));

		onoffStatus = 0;
		verifyInput(OUTPUT_CMD,(float)onoffStatus );


}

uint8_t checksum;
uint8_t chkpad[3];
uint16_t spec = 0;

void initializeMemory(void)
{
	uint16_t num;
//	uint8_t data = 0;

			
//			vfdadjcount = NORMAL_COUNT/2;
 			sprintf((void *)(displayBuffer), " Initialize Memory ");
			sprintf((void *)(displayBuffer+19), "                             ");
			dispVFD48((void *)displayBuffer);
//			for(i = 0; i < 0x1FFF ;i++)						   // clear EEPROM 8192 bytes
//				eepWrite((uint8_t *)&data, i ,sizeof(uint8_t));
			eepromDefaultSet();
			master.vSet = master.vMin;
			master.iSet = master.iMin;
// init Recall memory
			for (groupNumber = 0 ;groupNumber < 10; groupNumber++)
			{
				for (num = 0;num < 10;num++)
					save(num);
			}
			groupNumber = 0;
			eepWrite((uint8_t *)&groupNumber, EE_GROUPNUMBER ,sizeof(uint8_t));
// 	init program data
			for (programGroup = 1;programGroup < 10;programGroup++)
				 clearProgram(programGroup);
			programGroup = 1;
			eepWrite((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t));
   	
   	
			master.vSet = master.vMin;
			master.iSet = master.iMin;
			eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float)); // 1.37
			eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));  //1.37
			// initial EXT Cal.
			extCalV[0] = 1;
			extCalV[1] = 9;
			extCalI[0] = 1;
			extCalI[1] = 9;
			extCalVAd[0] = DAC1V;
			extCalVAd[1] = DAC9V;
			extCalIAd[0] = DAC1V;
			extCalIAd[1] = DAC9V;
   	
			eepWrite((uint8_t *)&extCalV[0],EE_USER_EXTCALV_0 ,sizeof(float) * 2);
			eepWrite((uint8_t *)&extCalVAd[0],EE_USER_EXTCALVAD_0 ,sizeof(uint16_t) * 2);
			eepWrite((uint8_t *)&extCalI[0],EE_USER_EXTCALI_0 ,sizeof(float) * 2);
			eepWrite((uint8_t *)&extCalIAd[0],EE_USER_EXTCALIAD_0 ,sizeof(uint16_t) * 2);
			eepWrite((uint8_t *)&checksum,EE_USER_CHECKSUM ,sizeof(uint8_t));
			voltagerescurr = 1.03;
			currentrescurr = 1.03;
			eepWrite((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
			eepWrite((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
			eepWrite((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
			eepWrite((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
			SET_FAT_CAL;
			writeUserChecksum();
			CLR_FAT_CAL;
			// initial serial & MAC address(USB ID)
//			eepWrite("000000001\0", EE_SERIALNUMBER ,10);
			cursoronoff = 0;
			eepWrite((void *)&cursoronoff,EE_CURSORONOFF,sizeof(uint8_t));
			writePatternChecksum();

			chkpad[0] = CHKPAD1;												  // gJեX
			chkpad[1] = CHKPAD2;
			chkpad[2] = CHKPAD3;
			eepWrite((uint8_t *)&chkpad, EE_CHKPAD ,sizeof(uint8_t)*3);
			if (master.vMax == VMAX60085)
				spec = VMAX60085;
			else
				spec = VMAX10005;
			eepWrite((uint8_t *)&spec, EE_SPEC ,sizeof(uint16_t));


}

void initchainMode(void)
{
	if (chainMode == ON)
	{
		CLR_MULTI_MASTER;
		chainAddrSlave = 0;
		pvsONOFF = 0;
		sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
		checkCurrentSource();
		timerONOFF = OFF;
		programONOFF = OFF;
		extVMode = 0;
		eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
		extIMode = 0;
		eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
		extEnable = OFF;
		eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
		RS485EmergencySwitchConfig(INTERRUPT);// 
		parallelMode = OFF;
		masterState = 0;slaveState = 0;CLR_SLAVE_CONFIGURED;
		slaveNumber = 0;
		clearSlaveDUT();
		softTimer[SLAVE_COUNT].flag = DISABLE;
		eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE,sizeof(uint8_t));
		eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
		eepRead((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
		verifyInput(ISET_CMD,master.iSet);	// 
		verifyInput(VSET_CMD,master.vSet);	// 
		eepRead((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t));
		eepRead((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t));
		eepRead((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t));
		initializeRs485();
		CLR_MULTI_MASTER;
		chainAddrSlave = 0;
	}
	else
		VFDsign &=  ~(sign_ADDR);
	eepWrite((uint8_t *)&chainMode, EE_CHAINMODE,sizeof(uint8_t));
}

void initparallelMode(void)
{
	uint8_t i;
	eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
	clearSlaveDUT();
	if (parallelMode == ON)
	{
		checkCurrentSource();
		RS485EmergencySwitchConfig(INTERRUPT);// 
		CLR_MULTI_MASTER;
		CLR_PARALLELMODE_SLAVE_ERROR_CONNECT;
		chainAddrSlave = 0;
		pvsONOFF = 0;
		sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
		timerONOFF = OFF;
		programONOFF = OFF;
		extVMode = 0;
		eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
		extIMode = 0;
		eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
		extEnable = OFF;
		eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
		R485Baud = BAUD_57600;// 57600
		rs485parityDataBits = 0; //N,8
		rs485stopBits = 0; // 1
		chainMode = OFF;
		VFDsign &=  ~(sign_ADDR);
		eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
		CLR_SLAVE_CONFIGURED;
		master.iSet = sumiSet();
		slaveErrorState = NONE;
//		memset((void *)&(uartBuffer[RS485_CHANNEL]) ,0, sizeof(UARTx_BUFFER));
		if (parallelRole == MASTER)
		{
			slaveIndex = 1;
			masterState = 1;
			if (slaveNumber != 0)
			{
				eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
				verifyInput(ISET_CMD,master.iSet);	// 
			}
			slaveNumber = 0;
			cmdexenum = MASTERQUERYCMD;
			rs485Temp.cmd = CMD_QID;
			for (i = 1; i <= SLAVEMAXNUM ;i++)
				slaveDUT[i]->exist = 0;
			master.address = 0;
			SYNCPinConfig(GPIO_OUTPUT);
		}
		else
		{
			slaveIndex = 0;
			slaveNumber = 0;
			protsw = 0;	  // iJslaveMode  protect switch
			verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
			slaveState = 1;
			CLR_SLAVE_CONFIGURED;
			showMeter = 0;
			VFDsign = VFDsign & (~sign_METER);
			master.address = slaveDUT[parallelRole]->address;
			SYNCPinConfig(INTERRUPT); // interrupt
		}
	}
	else
	{
		slaveNumber = 0;
		eepRead((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
		eepRead((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
		verifyInput(ISET_CMD,master.iSet);	// 
		verifyInput(VSET_CMD,master.vSet);	// 
		eepRead((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t));
		eepRead((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t));
		eepRead((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t));
		if (actualState == D_PARALLELSLAVE)	  // slave return to normal
			actualState = D_NORMAL;
	}
	initializeRs485();
}



void setProtectSwitch(void)
{

	ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
	if (protsw & BIT7)
		ProtOVActivation = 1;
	verifyInput(OVPSET_CMD,master.OVPSet );
	if (protsw & BIT6)
		ProtOCActivation = 1;
	verifyInput(OCPSET_CMD,master.OCPSet );
	if (protsw & BIT5)
		ProtOPActivation = 1;
	verifyInput(OPPSET_CMD,master.OPPSet );
	if (protsw & BIT4)
	{
		CVtoCCActivation = 1;
	}
	if (protsw & BIT3)
	{
	    CCtoCVActivation = 1;
	}

}

//void clearEEPROM(void)
//{
//	uint16_t i;
//	uint8_t data = 0;
//	for(i = 0; i < 0x1FFF ;i++)						   // clear EEPROM 8192 bytes
//	eepWrite((uint8_t *)&data, i ,sizeof(uint8_t));


//}


void readParameter(void)
{
	uint8_t i;
//	HVVoltage();

	eepRead((uint8_t *)&chkpad, EE_CHKPAD ,sizeof(uint8_t)*3);
	eepRead((uint8_t *)&spec, EE_SPEC ,sizeof(uint16_t));
	if (master.vMax == VMAX60085 && (spec != VMAX60085 && spec!= VMAX10005))
	{
		chkpad[0] = 0;												  // gJեX
		chkpad[1] = 0;
		chkpad[2] = 0;
		eepWrite((uint8_t *)&chkpad, EE_CHKPAD ,sizeof(uint8_t)*3);
	}
	if (chkpad[0] != CHKPAD1 || chkpad[1] != CHKPAD2 || chkpad[2] != CHKPAD3 && (master.vMax != 0 || master.iMax != 0)) // eeprom ~ άOs
	{
//		if (chkpad[0] != SWAPCHKPAD1 || chkpad[1] != SWAPCHKPAD2 || chkpad[2] != SWAPCHKPAD3 && (master.vMax != 0 || master.iMax != 0)) // eeprom ~ άOs
		{
			
			initializeMemory();
		}
	}
	eepRead((uint8_t *)&patternChecksum, EE_PATTERNCHECKSUM ,sizeof(uint8_t));
	if (patternChecksum != readPatternChecksum())
	{
		if ( patternChecksum == 0)
			writePatternChecksum();
		else
		{
			sprintf((void *)displayBuffer,"UI Memory Error!                               ");
			dispVFD48(DISPBUF);
			delayMs(2000);
			beep(0);
		}
	}
	eepRead((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t));
	if (R485Baud > 3)
	{
		R485Baud= 0;
		eepWrite((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t));
	if (rs485parityDataBits > 4)
	{
		rs485parityDataBits = 0;
		eepWrite((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t));
	if (rs485stopBits > 1)
	{
		rs485stopBits = 0;
		eepWrite((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&R232Baud, EE_R232BAUD ,sizeof(uint8_t));
	if (R232Baud > 3)
	{
		R232Baud= 0;
		eepWrite((uint8_t *)&R232Baud, EE_R232BAUD ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&rs232parityDataBits, EE_RS232PARITYDATABITS ,sizeof(uint8_t));
	if (rs232parityDataBits > 4)
	{
		rs232parityDataBits = 0;
		eepWrite((uint8_t *)&rs232parityDataBits, EE_RS232PARITYDATABITS ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&rs232stopBits, EE_RS232STOPBITS ,sizeof(uint8_t));
	if (rs232stopBits > 1)
	{
		rs232stopBits = 0;
		eepWrite((uint8_t *)&rs232stopBits, EE_RS232STOPBITS ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&chainAddr, EE_CHAINADDR ,sizeof(uint8_t));
    if ( chainAddr < 1 || chainAddr  >= MAX_CHAINADDR)
	{
		chainAddr = 1;
		eepWrite((uint8_t *)&chainAddr, EE_CHAINADDR ,sizeof(uint8_t));
	}
	initializeRs485(); // 
	initializeRs232(); // 
	eepRead((uint8_t *)&master.SRvSet, EE_SRVSET ,sizeof(float));
	if (master.SRvSet < VSRMIN || master.SRvSet > VSRMax)
	{
		master.SRvSet = VSRMax;
		eepWrite((uint8_t *)&master.SRvSet, EE_SRVSET ,sizeof(float));
	}
	verifyInput(VSRSET_CMD,master.SRvSet );// send SRvSet
	eepRead((uint8_t *)&master.SRiSet, EE_SRISET ,sizeof(float));
	if (master.SRiSet < ISRMIN || master.SRiSet > ISRMax)
	{
	    master.SRiSet = ISRMax;
		eepWrite((uint8_t *)&master.SRiSet, EE_SRISET ,sizeof(float));
	}
	verifyInput(ISRSET_CMD,master.SRiSet );// send SRiSet

	eepRead((uint8_t *)&beepActivation, EE_BEEPACTIVATION ,sizeof(uint8_t));
	if (beepActivation > 1 )
	{
	    beepActivation = 1;// ON
		eepWrite((uint8_t *)&beepActivation, EE_BEEPACTIVATION ,sizeof(uint8_t));
	}    
	eepRead((uint8_t *)&groupNumber, EE_GROUPNUMBER ,sizeof(uint8_t));
	if (groupNumber > 9)
	{
	    groupNumber = 0;
		eepWrite((uint8_t *)&groupNumber, EE_GROUPNUMBER ,sizeof(uint8_t));
	}
	
	for(programGroup = 9 ;programGroup > 0 ;programGroup--)
    {
		eepRead((uint8_t *)&linkNumberGroup[programGroup] , (uint16_t)(EE_LINKNUMBERGROUP + programGroup * sizeof(uint8_t)) ,sizeof(uint8_t));
		if (linkNumberGroup[programGroup] > 9)
		{
		    linkNumberGroup[programGroup] = 0;
			eepWrite((uint8_t *)&linkNumberGroup[programGroup] , (uint16_t)(EE_LINKNUMBERGROUP + programGroup * sizeof(uint8_t)) ,sizeof(uint8_t));
		}
		eepRead((uint8_t *)&repeatGroup[programGroup] , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
		if (repeatGroup[programGroup] > 100)
		{
			repeatGroup[programGroup] = 0;
			eepWrite((uint8_t *)&repeatGroup[programGroup] , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
		}
 	}
	eepRead((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t)); // 0 OŦ ҥHq+1}l
	if (programGroup < 1 ||  programGroup > 9)
	{
	    programGroup = 1;

		eepWrite((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t));
	}


	programGroupTemp = programGroup;
	eepRead((uint8_t *)&powerOnMode, EE_POWERONMODE ,sizeof(uint8_t));
	if (powerOnMode > 2)
	{
		powerOnMode = 0;
		powerOnVolt	= 0;
		powerOnCurrent = 0;
		powerOn_OnOff = 0;
		eepWrite((uint8_t *)&powerOn_OnOff, EE_POWERON_ONOFF ,sizeof(uint8_t));
		eepWrite((uint8_t *)&powerOnMode, EE_POWERONMODE ,sizeof(uint8_t));
		eepWrite((uint8_t *)&powerOnVolt, EE_POWERONVOLT ,sizeof(float));
		eepWrite((uint8_t *)&powerOnCurrent, EE_POWERONCURRENT ,sizeof(float));
	}
	eepRead((uint8_t *)&powerOnVolt, EE_POWERONVOLT ,sizeof(float));
	if (powerOnVolt > master.vMax + 40)//VMAX)
	{
		powerOnVolt = master.vMin;
		eepRead((uint8_t *)&powerOnVolt, EE_POWERONVOLT ,sizeof(float));	
	}
	eepRead((uint8_t *)&powerOnCurrent, EE_POWERONCURRENT ,sizeof(float));
	if (powerOnCurrent > master.iMax)//IMAX)
	{
		powerOnCurrent = master.iMin;
		eepRead((uint8_t *)&powerOnCurrent, EE_POWERONCURRENT ,sizeof(float));	
	}
	eepRead((uint8_t *)&powerOn_OnOff, EE_POWERON_ONOFF ,sizeof(uint8_t));
	if (powerOn_OnOff > 1)
	{
		powerOn_OnOff = 0;
		eepWrite((uint8_t *)&powerOn_OnOff, EE_POWERON_ONOFF ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
	if (extVMode > 2)
	{
		extVMode = 0;
		eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
	if (extIMode > 2)
	{
		extIMode = 0;
		eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&extProgRange, EE_EXTPROGRANGE ,sizeof(uint8_t));
	if (extProgRange > 1)
	{
		extProgRange = 0;
		eepWrite((uint8_t *)&extProgRange, EE_EXTPROGRANGE ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&extMonRange, EE_EXTMONRANGE ,sizeof(uint8_t));
	if (extMonRange > 1)
	{
		extMonRange = 0;
		eepWrite((uint8_t *)&extMonRange, EE_EXTMONRANGE ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&extShutOffLogic, EE_EXTSHUTOFFLOGIC ,sizeof(uint8_t));
	if (extShutOffLogic > 1)
	{
		extShutOffLogic = FALLING_EDGE;
		eepWrite((uint8_t *)&extShutOffLogic, EE_EXTSHUTOFFLOGIC ,sizeof(uint8_t));
	}
	if (extShutOffLogic == FALLING_EDGE)
	{
	}
	else
	{
	}
	eepRead((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
	if (extEnable > BMODE)
	{
		extEnable = OFF;
		eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
	}
	if (extEnable == OFF)
		RS485EmergencySwitchConfig(INTERRUPT);// Ұ emergency switch interrupt
	else
		RS485EmergencySwitchConfig(GPIO_INPUT);// 
		
	eepRead((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
	if ( parallelMode > ON)
	{
		parallelMode = OFF;
		eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
	}
	if (parallelMode == ON)
	{
		R485Baud = BAUD_57600;// 57600
		rs485parityDataBits = 0; //N,8
		rs485stopBits = 0; // 1
		initializeRs485();
//		RS485EmergencySwitchConfig(INTERRUPT);// Ұ emergency switch interrupt
	}
	eepRead((uint8_t *)&parallelRole, EE_PARALLELROLE ,sizeof(uint8_t));
	if ( parallelRole > SLAVEMAXNUM)
	{
		parallelRole = MASTER;
		eepWrite((uint8_t *)&parallelRole, EE_PARALLELROLE ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
	 if ( chainMode > ON)
	 {
		chainMode = OFF;
		VFDsign &=  ~(sign_ADDR);
		eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
	}
	if (chainMode == ON)
	{
		VFDsign |=  (sign_ADDR);
		RELEASE_RS485_BUS;
//		RS485EmergencySwitchConfig(INTERRUPT); // Ұ emergency switch interrupt
	}
	eepRead((uint8_t *)&GPIBAddr, EE_GPIBADDR ,sizeof(uint8_t));
    if ( GPIBAddr < 1 || GPIBAddr  > 30)
	{
		GPIBAddr = 1;
		eepWrite((uint8_t *)&GPIBAddr, EE_GPIBADDR ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&LANIPMode, EE_LANIPMODE ,sizeof(uint8_t));
    if ( LANIPMode > 1 )
	{
		LANIPMode = 0;
		eepWrite((uint8_t *)&LANIPMode, EE_LANIPMODE ,sizeof(uint8_t));
	}
	backupLANIPMode = LANIPMode;
//	if (LANIPMode == 1)// MENUAL
	{
		eepRead((uint8_t *)&LANIPAddr, EE_LANIPADDR ,4);
		eepRead((uint8_t *)&LANMask, EE_LANMASK ,4);
		eepRead((uint8_t *)&LANGateway, EE_LANGATEWAY ,4);
	}

	eepRead((uint8_t *)&master.limitVMin, EE_LIMITVMIN ,sizeof(float));
	eepRead((uint8_t *)&master.limitVMax, EE_LIMITVMAX ,sizeof(float));
	eepRead((uint8_t *)&master.limitIMin, EE_LIMITIMIN ,sizeof(float));
	eepRead((uint8_t *)&master.limitIMax, EE_LIMITIMAX ,sizeof(float));
	eepRead((uint8_t *)&limitPMin, EE_LIMITPMIN ,sizeof(float));
	eepRead((uint8_t *)&limitPMax, EE_LIMITPMAX ,sizeof(float));


	eepRead((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
	if (master.OVPSet > master.OVPMax)
	{
		master.OVPSet = master.OVPMax;
		eepWrite((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
	}
	eepRead((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
	if (master.OCPSet > master.OCPMax)
	{
		master.OCPSet = master.OCPMax;
		eepWrite((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
	}
	eepRead((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
	if (master.OPPSet > master.OPPMax)
	{
		master.OPPSet = master.OPPMax;
		eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
	}
	eepRead((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
	if(protsw & 0x07 != 0)
	{
		protsw = 0;
		eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
	}
	verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
	setProtectSwitch();
/* check eeprom external cal. */
	eepRead((uint8_t *)&checksum,EE_USER_CHECKSUM ,sizeof(uint8_t));
	if (readUserChecksum() == checksum)
	{
		eepRead((uint8_t *)&extCalV[0],EE_USER_EXTCALV_0 ,sizeof(float) * 2);
		eepRead((uint8_t *)&extCalVAd[0],EE_USER_EXTCALVAD_0 ,sizeof(uint16_t) * 2);
		eepRead((uint8_t *)&extCalI[0],EE_USER_EXTCALI_0 ,sizeof(float) * 2);
		eepRead((uint8_t *)&extCalIAd[0],EE_USER_EXTCALIAD_0 ,sizeof(uint16_t) * 2);

		eepRead((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
		if (voltagerescurr > 1.05 || voltagerescurr < 1.01)
		{
			voltagerescurr = 1.03;
			eepWrite((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
		}
		eepRead((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
		if (currentrescurr > 1.05 || currentrescurr < 1.01)
		{
			currentrescurr = 1.03;
			eepWrite((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
		}
	
		eepRead((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
		if (voltagerescurr > 1.05 || voltagerescurr < 1.01)
		{
			voltagerescurr = 1.03;
			eepWrite((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
			CLR_FAT_CAL;
			writeUserChecksum();
		}
		eepRead((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
		if (currentrescurr > 1.05 || currentrescurr < 1.01)
		{
			currentrescurr = 1.03;
			eepWrite((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
			CLR_FAT_CAL;
			writeUserChecksum();
		}
	}
	else  //ϸ
	{
		eepRead((uint8_t *)&extCalV[0],EE_FAT_EXTCALV_0 ,sizeof(float));
		if (extCalV[0] > 1.1 || extCalV[0] < 0.9)
		{
			extCalV[0] = 1;
			eepWrite((uint8_t *)&extCalV[0],EE_FAT_EXTCALV_0 ,sizeof(float));
		}
		eepWrite((uint8_t *)&extCalV[0],EE_USER_EXTCALV_0 ,sizeof(float));
			
		eepRead((uint8_t *)&extCalV[1],EE_FAT_EXTCALV_1 ,sizeof(float));
		if (extCalV[1] > 9.1 || extCalV[1] < 8.9)
		{
			extCalV[1] = 9;
			eepWrite((uint8_t *)&extCalV[1],EE_FAT_EXTCALV_1 ,sizeof(float));
			
		}
		eepWrite((uint8_t *)&extCalV[1],EE_USER_EXTCALV_1 ,sizeof(float));

		eepRead((uint8_t *)&extCalVAd[0],EE_FAT_EXTCALVAD_0 ,sizeof(uint16_t));
		if (extCalVAd[0] > (DAC1V + 50)	|| extCalVAd[0] < (DAC1V - 50))
		{
			extCalVAd[0] = DAC1V;
			eepWrite((uint8_t *)&extCalVAd[0],EE_FAT_EXTCALVAD_0 ,sizeof(uint16_t));
		}
		eepWrite((uint8_t *)&extCalVAd[0],EE_USER_EXTCALVAD_0 ,sizeof(uint16_t));

		eepRead((uint8_t *)&extCalVAd[1],EE_FAT_EXTCALVAD_1 ,sizeof(uint16_t));
		if (extCalVAd[1] > (DAC9V + 100)	|| extCalVAd[1] < (DAC9V - 100))
		{
		    extCalVAd[1] = DAC9V;
			eepWrite((uint8_t *)&extCalVAd[1],EE_FAT_EXTCALVAD_1 ,sizeof(uint16_t));
		}
		eepWrite((uint8_t *)&extCalVAd[1],EE_USER_EXTCALVAD_1 ,sizeof(uint16_t));

		eepRead((uint8_t *)&extCalI[0],EE_FAT_EXTCALI_0 ,sizeof(float) );
		if (extCalI[0] > 1.1 || extCalI[0] < 0.9)
		{
			extCalI[0] = 1;
			eepWrite((uint8_t *)&extCalI[0],EE_FAT_EXTCALI_0 ,sizeof(float) );
		}
		eepWrite((uint8_t *)&extCalI[0],EE_USER_EXTCALI_0 ,sizeof(float) );

		eepRead((uint8_t *)&extCalI[1],EE_FAT_EXTCALI_1 ,sizeof(float) );
		if (extCalI[1] > 9.1 || extCalI[1] < 8.9)
		{
			extCalI[1] = 9;
			eepWrite((uint8_t *)&extCalI[1],EE_FAT_EXTCALI_1 ,sizeof(float) );
		}
		eepWrite((uint8_t *)&extCalI[1],EE_USER_EXTCALI_1 ,sizeof(float) );

	   	eepRead((uint8_t *)&extCalIAd[0],EE_FAT_EXTCALIAD_0 ,sizeof(uint16_t));
	   	if (extCalIAd[0] > (DAC1V + 50) || extCalIAd[0] < (DAC1V - 50))
		{
			extCalIAd[0] = 	DAC1V;
			eepWrite((uint8_t *)&extCalIAd[0],EE_FAT_EXTCALIAD_0 ,sizeof(uint16_t));
		}
		eepWrite((uint8_t *)&extCalIAd[0],EE_USER_EXTCALIAD_0 ,sizeof(uint16_t));

	   	eepRead((uint8_t *)&extCalIAd[1],EE_FAT_EXTCALIAD_1 ,sizeof(uint16_t));
	   	if (extCalIAd[1] > (DAC9V + 100) || extCalIAd[1] < (DAC9V - 100))
		{
			extCalIAd[1] = 	DAC9V;
			eepWrite((uint8_t *)&extCalIAd[1],EE_FAT_EXTCALIAD_1 ,sizeof(uint16_t));
		}
		eepWrite((uint8_t *)&extCalIAd[1],EE_USER_EXTCALIAD_1 ,sizeof(uint16_t));


		eepRead((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
		if (voltagerescurr > 1.05 || voltagerescurr < 1.01)
		{
			voltagerescurr = 1.03;
			eepWrite((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
			eepWrite((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
		}
		eepRead((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
		if (currentrescurr > 1.05 || currentrescurr < 1.01)
		{
			currentrescurr = 1.03;
			eepWrite((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
			eepWrite((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
		}
		SET_FAT_CAL;
		writeUserChecksum();
		CLR_FAT_CAL;
	}
	mADc_v = (extCalV[1] - extCalV[0])/(extCalVAd[1] - extCalVAd[0]);
	bADc_v = extCalV[1] - (mADc_v * extCalVAd[1]);
//	bADc_v += 0.01;
	mDAc_v = (DAC9V - DAC1V)/(extCalV[1] - extCalV[0]);
	bDAc_v = DAC9V - (mDAc_v * extCalV[1]);
	

	mADc_i = (extCalI[1] - extCalI[0])/(extCalIAd[1] - extCalIAd[0]);
	bADc_i = extCalI[1] - (mADc_i * extCalIAd[1]);
	mDAc_i = (DAC9V - DAC1V)/(extCalI[1] - extCalI[0]);
	bDAc_i = DAC9V - (mDAc_i * extCalI[1]);
  

	if (errorIndex != 0)
	{
		E7Board = 0; // b
		clearErorrQueue();
		sprintf((void *)(displayBuffer+19), "PWR Module not found!        ");
		dispVFD48((void *)displayBuffer);
		delayMs(1500);
	}
	else
	{
		E7Board = 1; // b
	    sprintf((void *)(displayBuffer+19), "PWR Module OK                ");
		dispVFD48((void *)displayBuffer);
		delayMs(2000);
	}
	eepRead((uint8_t *)&serialNumber, EE_SERIALNUMBER ,20);
	eepRead((uint8_t *)&MACaddress, EE_MACADDRESS ,6);

	eepRead((uint8_t *)&timerHR, EE_TIMERHR ,sizeof(uint16_t));
	if (timerHR > 999)
	{
		timerHR = 0;
		eepWrite((uint8_t *)&timerHR, EE_TIMERHR ,sizeof(uint16_t));
	}
	eepRead((uint8_t *)&timerMN, EE_TIMERMN ,sizeof(uint8_t));
	if (timerMN > 59 )
	{
		timerMN = 0;
		eepWrite((uint8_t *)&timerMN, EE_TIMERMN ,sizeof(uint8_t));
	}
	eepRead((uint8_t *)&timerSE, EE_TIMERSE ,sizeof(uint8_t));
	if (timerSE > 59)
	{
		timerSE = 0;
		eepWrite((uint8_t *)&timerSE, EE_TIMERSE ,sizeof(uint8_t));
	}
	for (i = 0 ; i <= SLAVEMAXNUM ;i++) // tm slave address
		slaveDUT[i]->address = i;

}


void readProgramParameter(void)
{
	
	eepRead((uint8_t *)&programParameter, (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroupTemp + step * SIZEOF_STEP_PACKET) ,SIZEOF_STEP_PACKET);
	voltage = ((*(uint16_t *)(programParameter + PROG_VOLTAGE)) * master.vMax)/fullScale;
//	sprintf((void *)temps,(void *)voltDisp[voltPoint],voltage);
//	voltage = atof((void *)temps);
	if (specif == V_600)
	{
		float buffer ;
		float buffer1;
		buffer1 = *(uint16_t *)(programParameter + PROG_CURRENT) ; 
		buffer = roundDigit(buffer1* 42925 /fullScale ,0);
		current = buffer * around ;
	}
	else	
		current = ((*(uint16_t *)(programParameter + PROG_CURRENT)) * master.iMax)/fullScale;
	if (voltage * current > master.pMax)	// AUTO RANGE
		current = master.pMax/voltage;
	current = round(current ,around);
//	sprintf((void *)temps,(void *)currDisp[currPoint],current);
//	current = atof((void *)temps);
	timer = *(uint16_t *)(programParameter + PROG_TIMER);
	timer /= 10;
	sprintf((void *)displayBuffer,"PROG:%.1d STEP:%.3d ACT",programGroupTemp,(step+1));
	sprintf((void *)(displayBuffer + 19),"V:");
	sprintf((void *)(displayBuffer + 19 + 2),(void *)voltDispUnit[voltPoint],voltage);
	sprintf((void *)(displayBuffer + 19 + 9)," I:");
	sprintf((void *)(displayBuffer + 19 + 12),(void *)currDispUnit[currPoint],current);
	sprintf((void *)(displayBuffer + 19 + 20),"T:%6.1fS" ,timer);
	parameterTemp = *(uint8_t *)(programParameter + PROG_ACT);
	switch(parameterTemp)
	{
	   	case OFF:
	    	memcpy((void *)(displayBuffer + 16),"OFF",3); 
	    	break;
		case ON:
			memcpy((void *)(displayBuffer + 16)," ON",3);
		   	break;
		case NAC:
			memcpy((void *)(displayBuffer + 16),"NAC",3);
	    	break;
		case END:
			memcpy((void *)(displayBuffer + 16),"END",3);
	    	break;

	}
}

uint8_t readPatternChecksum(void)
{
/*
#define EE_MACADDRESS					EE_SRISET + sizeof(float)				 // 166
#define EE_MANUFACTURE					EE_MACADDRESS + 6						 // 172
#define EE_MODEL						EE_MANUFACTURE + 20						 // 192
#define EE_KEYTYPE						EE_MODEL + 20							 // 202
  */
	uint8_t checksum,i,data;
	for (i = 0,checksum = 0; i < ((EE_KEYTYPE + 1) - EE_MACADDRESS) ;i++)
	{
		eepRead((uint8_t *)&data,(EE_MACADDRESS + i) ,sizeof(uint8_t));
		checksum += data;
	} 

	return checksum;
}

void writePatternChecksum(void)
{
	uint8_t checksum;
	checksum = readPatternChecksum();
	eepWrite((uint8_t *)&checksum,EE_PATTERNCHECKSUM ,sizeof(uint8_t));
}

uint8_t readUserChecksum(void)
{
	uint8_t i,data,checksum;
	for (i = 0,checksum = 0; i < (EE_USER_CHECKSUM - EE_USER_EXTCALV_0 - 1) ; i++)
	{
		eepRead((uint8_t *)&data,(EE_USER_EXTCALV_0 + i) ,sizeof(uint8_t));
		checksum += data;  
	}
	for (i = 0; i  < (EE_FAT_VOLTAGERESCURR - EE_USER_VOLTAGERESCURR) ;i++)
	{
		eepRead((uint8_t *)&data,(EE_USER_VOLTAGERESCURR + i) ,sizeof(uint8_t));
		checksum += data;  
	}
	return checksum;
}


void writeUserChecksum(void)
{
	uint8_t checksum;
	checksum = readUserChecksum();
	eepWrite((uint8_t *)&checksum,EE_USER_CHECKSUM ,sizeof(uint8_t));
	if (IS_FAT_CAL)	// t s
	{
		uint8_t data,i;
		for (i = 0 ; i < (EE_USER_CHECKSUM - EE_USER_EXTCALV_0) ; i++)
		{
			eepRead((uint8_t *)&data,(EE_USER_EXTCALV_0 + i) ,sizeof(uint8_t));
			eepWrite((uint8_t *)&data,(EE_FAT_EXTCALV_0 + i) ,sizeof(uint8_t));
		}
		for (i = 0; i  < (EE_FAT_VOLTAGERESCURR - EE_USER_VOLTAGERESCURR) ;i++)
		{
			eepRead((uint8_t *)&data,(EE_USER_VOLTAGERESCURR + i) ,sizeof(uint8_t));
			eepWrite((uint8_t *)&data,(EE_FAT_VOLTAGERESCURR + i) ,sizeof(uint8_t));
		}
	}
}

void restoreFactoryCal(void)
{
	uint8_t i;
	restoreFactoryParameter = 0;//initial to FAIL
	for (i = 0 ; (i < 5) && (restoreFactoryParameter == 0); i++)
	{
		sendMBQuery(MEASURE_CHANNEL,RESTOREFACTORYQ_CMD);	 // 0xB8 ->
        setVFDFlashOn(0x53, 29);
	    strcpy((void *)(displayBuffer + 19),"  FACTORY CAL. RESTORED ...  ");
	    dispVFD48(DISPBUF);
	    delayMs(1000);
		if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//ʥ]
		{
			uartBuffer[MEASURE_CHANNEL].packetCount--;
		    receiveMBResponse(MEASURE_CHANNEL);
		}
	}

	eepRead((uint8_t *)&extCalV[0],EE_FAT_EXTCALV_0 ,sizeof(float) * 2);
	eepRead((uint8_t *)&extCalVAd[0],EE_FAT_EXTCALVAD_0 ,sizeof(uint16_t) * 2);
	eepRead((uint8_t *)&extCalI[0],EE_FAT_EXTCALI_0 ,sizeof(float) * 2);
	eepRead((uint8_t *)&extCalIAd[0],EE_FAT_EXTCALIAD_0 ,sizeof(uint16_t) * 2);
	eepRead((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
	eepRead((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
	eepRead((uint8_t *)&checksum,EE_FAT_CHECKSUM ,sizeof(uint8_t));

	eepWrite((uint8_t *)&extCalV[0],EE_USER_EXTCALV_0 ,sizeof(float) * 2);
	eepWrite((uint8_t *)&extCalVAd[0],EE_USER_EXTCALVAD_0 ,sizeof(uint16_t) * 2);
	eepWrite((uint8_t *)&extCalI[0],EE_USER_EXTCALI_0 ,sizeof(float) * 2);
	eepWrite((uint8_t *)&extCalIAd[0],EE_USER_EXTCALIAD_0 ,sizeof(uint16_t) * 2);
	eepWrite((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
	eepWrite((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
	eepWrite((uint8_t *)&checksum,EE_USER_CHECKSUM ,sizeof(uint8_t));

	mADc_v = (extCalV[1] - extCalV[0])/(extCalVAd[1] - extCalVAd[0]);
	bADc_v = extCalV[1] - (mADc_v * extCalVAd[1]);
//	bADc_v += 0.01;
	mDAc_v = (DAC9V - DAC1V)/(extCalV[1] - extCalV[0]);
	bDAc_v = DAC9V - (mDAc_v * extCalV[1]);

	mADc_i = (extCalI[1] - extCalI[0])/(extCalIAd[1] - extCalIAd[0]);
	bADc_i = extCalI[1] - (mADc_i * extCalIAd[1]);
	mDAc_i = (DAC9V - DAC1V)/(extCalI[1] - extCalI[0]);
	bDAc_i = DAC9V - (mDAc_i * extCalI[1]);

	if (restoreFactoryParameter == 1) // OK
	   	strcpy((void *)(displayBuffer + 19),"  FACTORY CAL. RESTORED OK   ");
	else
	   	strcpy((void *)(displayBuffer + 19),"  FACTORY CAL. RESTORED FAIL ");
	dispVFD48(DISPBUF);
	delayMs(2000);
	flashBlock(0);
}
/*
void masterBroadCastValue(uint8_t cmd ,float temp,uint8_t len)
{
	unionbyte_TypeDef buf;
	buf.ftob = temp;
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = RS485_CHAINBROADCAST; // s ت	
	rs485Packet.SA = master.address; // ӷ
	rs485Packet.Len = 1 + len ;
	rs485Packet.Cmd = cmd;//cmd;
	if (len == sizeof(uint8_t))
	{
		rs485Packet.Data[0] = buf.byte_loc[0];
	}
	else if(len == sizeof(float))
	{
		rs485Packet.Data[0] = buf.byte_loc[3]; 
		rs485Packet.Data[1] = buf.byte_loc[2];
		rs485Packet.Data[2] = buf.byte_loc[1]; 
		rs485Packet.Data[3] = buf.byte_loc[0];
	}
	rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	uartTransmit(RS485_CHANNEL, &rs485Packet.Head, rs485Packet.Len + 6);	// 6 = Head + DA + SA + Len + Sn + CRC8
	delayMs(10);
}
  */

uint16_t tempValue;

void recall(uint8_t num)
{
	eepRead((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_VSET ,sizeof(uint16_t));
	master.vSet = (tempValue * master.vMax)/fullScale;
	master.vSet = roundDigit(master.vSet,voltPoint);
	eepRead((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_ISET ,sizeof(uint16_t));
	if (specif == V_600)
	{
		float buffer , buffer1;
		buffer1 = (uint16_t)tempValue; 
		buffer = roundDigit(buffer1* 42925 /fullScale ,0);
		master.iSet = buffer * around ;

	}
	else
	{
		master.iSet = (tempValue * master.iMax)/fullScale;
	}	
	if (master.iSet * master.vSet > master.pMax)
		master.iSet = master.pMax/master.vSet;
	master.iSet = round(master.iSet ,around);
	if (verifyInput(VSET_CMD,master.vSet ) == SUCCESS)
		eepWrite((uint8_t *)&master.vSet, EE_LASTVSET ,sizeof(float));
//	if (parallelMode == ON && parallelRole == MASTER && (slaveNumber > 0))
//		masterBroadCastValue(CMD_SETV ,master.vSet,sizeof(float));
	calCurrRatio(master.iSet * (slaveNumber + 1));
	master.iSet = slaveDUT[0]->iSet;
	if ( verifyInput(ISET_CMD,master.iSet ) == SUCCESS)
		eepWrite((uint8_t *)&master.iSet, EE_LASTISET ,sizeof(float));
//	if (parallelMode == ON && parallelRole == MASTER && (slaveNumber > 0))
//		masterBroadCastValue(CMD_SETI ,master.iSet,sizeof(float));	
	eepRead((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_OVPSET ,sizeof(uint16_t));
	master.OVPSet = (tempValue * master.vMax)/fullScale;
	master.OVPSet = roundDigit(master.OVPSet,voltPoint);
	if (verifyInput(OVPSET_CMD,master.OVPSet ) == SUCCESS)
		eepWrite((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
//	if (parallelMode == ON && parallelRole == MASTER && (slaveNumber > 0))
//		masterBroadCastValue(CMD_SETOVP ,master.OVPSet,sizeof(float));

	eepRead((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_OCPSET ,sizeof(uint16_t));
	

	if (specif == V_600)
	{
		float buffer , buffer1;
		buffer1 = (uint16_t)tempValue ; 
		buffer = roundDigit(buffer1* 42925 /fullScale ,0);
	 	master.OCPSet = buffer * around ;
	}
	else	
		master.OCPSet = (tempValue * master.iMax)/fullScale;
	if (verifyInput(OCPSET_CMD,master.OCPSet ) == SUCCESS)
		eepWrite((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
//	if (parallelMode == ON && parallelRole == MASTER && (slaveNumber > 0))
//		masterBroadCastValue(CMD_SETOCP ,master.OCPSet,sizeof(float));

	eepRead((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_OPPSET ,sizeof(uint16_t));
    master.OPPSet = (tempValue * master.pMax)/fullScale;
	master.OPPSet = roundDigit(master.OPPSet,powPoint);
	if (verifyInput(OPPSET_CMD,master.OPPSet ) == SUCCESS)
		eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
//	if (parallelMode == ON && parallelRole == MASTER && (slaveNumber > 0))
//		masterBroadCastValue(CMD_SETOPP ,master.OPPSet,sizeof(float));
	eepRead((uint8_t *)&protsw,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_PROTECTSW ,sizeof(uint8_t));
	sprintf((void *)(displayBuffer+19)," Vset:");
	sprintf((void *)(displayBuffer+19+6),(void *)voltDispUnit[voltPoint],master.vSet);
	sprintf((void *)(displayBuffer+34)," Iset:");
	sprintf((void *)(displayBuffer+40),(void *)currDispUnit[currPoint],master.iSet * (slaveNumber + 1));
	displayFresh = 1;
	memoryNumber = num;
}

void save(uint8_t num)
{
	tempValue = convertFloatToInt(master.vSet, master.vMax, fullScale);
	eepWrite((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_VSET ,sizeof(uint16_t));
	tempValue = convertFloatToInt(master.iSet, master.iMax, fullScale);
	eepWrite((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_ISET ,sizeof(uint16_t));
	tempValue = convertFloatToInt(master.OVPSet, master.vMax, fullScale);
	eepWrite((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_OVPSET ,sizeof(uint16_t));
	tempValue = convertFloatToInt(master.OCPSet, master.iMax, fullScale);
	eepWrite((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_OCPSET ,sizeof(uint16_t));
	tempValue = convertFloatToInt(master.OPPSet, master.pMax, fullScale);
	eepWrite((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_OPPSET ,sizeof(uint16_t));
	eepWrite((uint8_t *)&protsw,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (num) * SIZEOF_MEM_PACKET + EE_PROTECTSW ,sizeof(uint8_t));
	displayFresh = 1;
	memoryNumber = num;

}

void clearProgram(uint8_t num)
{
	uint32_t i;
	memset((void *)programParameter, 0,	SIZEOF_STEP_PACKET);
	*(uint16_t *)(programParameter + PROG_VOLTAGE) = convertFloatToInt((float)master.vMin, master.vMax, fullScale);
	*(uint16_t *)(programParameter + PROG_CURRENT) = convertFloatToInt((float)master.iMin, master.iMax, fullScale);
	for(i = 0 ; i < STEPMAX ; i++)
	{
		eepWrite(&programParameter[0] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * num + i * SIZEOF_STEP_PACKET ) ,SIZEOF_STEP_PACKET);
	}
	linkNumberGroup[num] = 0;
	eepWrite((uint8_t *)&linkNumberGroup[num] , (uint16_t)(EE_LINKNUMBERGROUP + num * sizeof(uint8_t)) ,sizeof(uint8_t));
	repeatGroup[num] = 0;
	eepWrite((uint8_t *)&repeatGroup[num] , (uint16_t)(EE_PROGRAMGROUP_REPEAT + num * sizeof(uint16_t)) ,sizeof(uint16_t));
}


void scpiFinishCal(void) // spend too much time
{
		onoffStatus = 0;
		//verifyInput(OUTPUT_CMD,(float)onoffStatus );  //o@BO² initialzeMB(); IOX
		sendMBStateSetting(MEASURE_CHANNEL,OUTPUT_CMD, onoffStatus); // OFF
							// ^Wh ˬdprotsw A  } m
		eepRead((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
		if (protsw != 0)
		{
			//verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
			sendMBStateSetting(MEASURE_CHANNEL,PORTSW_CMD, protsw);
			ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
			if (protsw & BIT7)
			{
				ProtOVActivation = 1;
				//verifyInput(OVPSET_CMD,master.OVPSet );
				sendMBIntSetting(OVPSET_CMD, convertFloatToInt(master.OVPSet, master.vMax, fullScale));
			}
			if (protsw & BIT6)
			{
				ProtOCActivation = 1;
			//	verifyInput(OCPSET_CMD,master.OCPSet );
				sendMBIntSetting(OCPSET_CMD, convertFloatToInt(master.OCPSet, master.iMax, fullScale));
			}
			if (protsw & BIT5)
			{
				ProtOPActivation = 1;
				//verifyInput(OPPSET_CMD,master.OPPSet );
				sendMBFloatSetting(OPPSET_CMD, master.OPPSet);
			}
			if (protsw & BIT4)
				CVtoCCActivation = 1;
			if (protsw & BIT3)
			    CCtoCVActivation = 1;
		}
		else
			sendMBStateSetting(MEASURE_CHANNEL,PORTSW_CMD, 0);  // o@BOE7O  protect switch
}

void savePvsCurveParam(void)
{
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x013; //19
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = PVSCURVEPARAM_CMD;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = curve;
	unionbyte.ftob = Rule;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[3] ;	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[1] ;	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = unionbyte.byte_loc[0];
	unionbyte.ftob = Vmp;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6] = unionbyte.byte_loc[3] ;	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8] = unionbyte.byte_loc[1] ;	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[9] = unionbyte.byte_loc[0];
	unionbyte.ftob = Pmp;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[10] = unionbyte.byte_loc[3] ;	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[11] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[12] = unionbyte.byte_loc[1] ;	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[13] = unionbyte.byte_loc[0];
	unionbyte.ftob = Material;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[14] = unionbyte.byte_loc[3] ;	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[15] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[16] = unionbyte.byte_loc[1] ;	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[17] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
	calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
	{
		rs485Temp.cmd = CMD_SETPVPARAM;
		cmdexenum = MASTERSET4FLOAT;
		masterState = BROADCAST;
	}
//	delayMs(200);
}

void savePvsTableParam(void)
{
	uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
	uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x0C;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = PVSDEFNVI_CMD;	// D4
	unionbyte.itob[0] = pvsPoint;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[1];	// MSB first
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[0];
	unionbyte.ftob = pvsVoltage;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[3];	// MSB first Voltage
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = unionbyte.byte_loc[1];	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6] = unionbyte.byte_loc[0];
	unionbyte.ftob = pvsCurrent;
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7] = unionbyte.byte_loc[3];	// MSB first Current
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8] = unionbyte.byte_loc[2];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[9] = unionbyte.byte_loc[1];	
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[10] = unionbyte.byte_loc[0];
	uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
	calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
	uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
	pvsTableNumState = 0;	
	delayMs(5);
	clearMeasureCommand(); //  receive ACK or NAK
}

void pushError(uint8_t state)
{
	if (errorQueue[errorIndex - 1] !=  state)
	{
		errorQueue[errorIndex] = state;
		errorIndex++;
	}
}

uint8_t popError(void)
{
	uint8_t i ,state;
	state = errorQueue[0];
	for (i = 1; i <= errorIndex ; i++)
		errorQueue[i - 1] = errorQueue[i];
	errorIndex--;
	return state;	
}
void clearErorrQueue(void )
{
	memset((void *)errorQueue ,0, errorIndex);
	errorIndex = 0;
	
}

void queryCurveparrmeter(void)
{
	uint16_t i;
	sendMBStateSetting(MEASURE_CHANNEL,PVSCURVEQ_CMD, curve);	// D6 query curve parameter?
//	sendMBStateSetting(MEASURE_CHANNEL,PVSCURVEQ_CMD, curve);	// D6 query curve parameter?
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
	{
		masterState = BROADCAST;
		rs485Temp.unionbyte.byte_loc[0] = curve; //s curve
		rs485Temp.cmd = CMD_SETPVCURV;
		cmdexenum = MASTERSETINT8;
	}
	delayMs(20);
	Rule = 0;Vmp = 0; Pmp = 0; Material = 0;
	for (i = 0 ;(i < 80) && (Rule == 0); i++)	// 20ms * 15 == 300 ms
	{
		delayMs(2);
		rs485PacketParser();
		while (Vmp == 0 && uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
		{
			uartBuffer[MEASURE_CHANNEL].packetCount--;
			receiveMBResponse(MEASURE_CHANNEL);

		}
		if (Vmp != 0)
			break;
	}
	if (Vmp == 0)
	{
		pushError(PV_SIM_DATA_ERROR);
		beep(0);
	}
}

void queryTableparrmeter(void)
{
	uint8_t i;
//	clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
	sendMBIntSetting(PVSDEFNVIQ_CMD, pvsPoint);	// 0xDB query table parameter?
	pvsVoltage = 0; pvsCurrent = 0;
	for (i = 0 ;(i < 15) && (pvsVoltage == 0); i++)	// 20ms * 15 = 300 ms
	{
//		clearMeasureCommand();//KPVSDEFNVIR_CMD
		delayMs(20);
		while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
		{
			uartBuffer[MEASURE_CHANNEL].packetCount--;
			receiveMBResponse(MEASURE_CHANNEL);
		}

	}
}






/* |BI|ˤJ
  temp Bzƭ
  |ˤJ
  ^: Ѥ

*/
uint32_t tempj,tempk;


float round(float temp ,float num)
{
	

	tempj = (float)(temp/num  + 0.5);
	temp = (float)(tempj * num);
    return temp;

}
/* |BI|ˤJ
  temp Bzƭ
  point pIX
  ^: Ѥ

*/

float roundDigit(float temp ,uint8_t point)
{
	float temp1 = 1;
	uint32_t temp2;
	switch(point)
	{
		case 0:
			temp1 = 1;
			break;
		case 1:
			temp1 = 0.1;
			break;
		case 2:
			temp1 = 0.01;
			break;
		case 3:
			temp1 = 0.001;
			break;
		case 4:
			temp1 = 0.0001;
			break;
		case 5:
			temp = 0.00001;
			break;
	}
	temp2 = (float)(temp/temp1 + 0.5);
	temp = temp2 * temp1;
	return temp;//((float)((uint32_t)(temp/temp1+0.5) * temp1));
}



#ifdef	_DEBUG_
/**
  * @brief  Retargets the C library printf function to the USART.
  * @param  None
  * @retval None
  * @wqputcơAo˥iHϥprintfƱqf1LX
  */


int fputc(int ch, FILE *f)
{

  /* Place your implementation of fputc here */
  /* e.g. write a character to the USART */
//    USART_SendData(EVAL_COM3, (uint8_t) ch);

  /* Loop until the end of transmission */
//    while (USART_GetFlagStatus(EVAL_COM3, USART_FLAG_TC) == RESET)
//    {}
    return ch;
}


/**
  * @brief 	Retargets the C library printf function to the USART.
  * @param  None
  * @retval None
  *	@wqgetcơAo˥HϥscanfƱqf1Jƾ
*/
int fgetc(FILE *f)
{

	/* ݦf1Jƾ */
//	while (USART_GetFlagStatus(EVAL_COM3, USART_FLAG_RXNE) == RESET)
//	{}

//	return (int)USART_ReceiveData(EVAL_COM3);
	return 0;	//dummy return
}

#endif


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */ 

/**
  * @}
  */ 

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
