
#include "includes.h"

char smbuffer[256];



GPIB_PACKET gpibPacket,httpPacket,port23Packet,port5024Packet,port5025Packet;
scpi_special_number_t returnONOFF(uint8_t param);

uint8_t transBuffer[256];
static uint8_t IP_Point = 0;
uint8_t bracket; //patternJA

COM_TypeDef witchCOM ,firstWitchCOM = INITCOM;
    
    bool_t SCPI_ParamNumber(scpi_t * context, scpi_number_t * value, bool_t mandatory);
    size_t SCPI_NumberToStr(scpi_t * context, scpi_number_t * value, char * str, size_t len);

	size_t SCPI_ResultDouble(scpi_t * context, double val);
    bool_t SCPI_ParamDouble(scpi_t * context, double * value, bool_t mandatory);

/*
scpi_result_t DMM_MeasureVoltageDcQ(scpi_t * context) {
    scpi_number_t param1, param2;
    char bf[15];
    // read first parameter if present
    if (!SCPI_ParamNumber(context, &param1, false)) {
        // do something, if parameter not present
    }
    // read second paraeter if present
    if (!SCPI_ParamNumber(context, &param2, false)) {
        // do something, if parameter not present
    }
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"\tP1=%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    SCPI_NumberToStr(context, &param2, bf, 15);
	sprintf((void *)(transBuffer),"\tP2=%s\r\n", bf);	 //SѼ \tP1=DEFault\r\n
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    SCPI_ResultDouble(context, 0);
    return SCPI_RES_OK;
}


scpi_result_t DMM_ConfigureVoltageDc(scpi_t * context) {
    double param1, param2;
//    fprintf(stderr, "conf:volt:dc\r\n"); // debug command name  
	sprintf((void *)(transBuffer),"conf:volt:dc\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer)); 
    // read first parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }

    // read second paraeter if present
    if (!SCPI_ParamDouble(context, &param2, false)) {
        // do something, if parameter not present
    }
	sprintf((void *)(transBuffer),"\tP1=%lf\r\n", param1);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	sprintf((void *)(transBuffer),"\tP2=%1f\r\n", param2);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));


//    fprintf(stderr, "\tP1=%lf\r\n", param1);
//    fprintf(stderr, "\tP2=%lf\r\n", param2);

    return SCPI_RES_OK;
}
  */
static const scpi_command_t scpi_commands[] = {
    /* IEEE Mandated Commands (SCPI std V1999.0 4.1.1) */
    { "*CLS", 		SCPI_CoreCls,},		 // M errorA
    { "CLR",        SCPI_CoreClr,},		 // VSET 10,ISET 1,OUT 0
    { "*ESE", 		SCPI_CoreEse,},
    { "*ESE?", 		SCPI_CoreEseQ,},
    { "*ESR?", 		SCPI_CoreEsrQ,},
    { "*IDN?", 		SCPI_CoreIdnQ,},
    { "*OPC", 		SCPI_CoreOpc,},
    { "*OPC?", 		SCPI_CoreOpcQ,},
    { "*RST",       SCPI_CoreRst,},
    { "*SRE", 		SCPI_CoreSre,},
    { "*SRE?",		SCPI_CoreSreQ,},
    { "*STB?", 		SCPI_CoreStbQ,},
    { "*TST?", 		SCPI_CoreTstQ,},
    { "*WAI", 		SCPI_CoreWai,},

	
// Fetch
	{"FETCh:CURRent?",						SCPI_queryiOut,	},
	{"FETCh:VOLTage?",						SCPI_queryvOut,	},
	{"FETCh:POWer?",						SCPI_querypOut,	},
	{"FETCh:ALL?",							SCPI_queryvOutiOut,	},

// Measurement
	{"MEASure:CURRent?",					SCPI_measureiOut,	},
	{"MEASure:VOLTage?",					SCPI_measurevOut,	},
	{"MEASure:POWer?",						SCPI_measurepOut,	},
	{"MEASure:ALL?",						SCPI_measurepAll,	},
// Motech LPS/PPS compatible Commands
	{"ADDR?",								SCPI_queryGPIBAddr,	},
	{"ADDR",								SCPI_setGPIBAddr,	},
	{"BEEP?",								SCPI_queryBeepActivation,	},
	{"BEEP",								SCPI_setBeepActivation,	},
	{"CLR",									SCPI_clearOVPOCPOPPCVCCCCCV,	},	 // MO@A
	{"ERRor?",								SCPI_SystemErrorNextQ,	},
	{"IOUT?",								SCPI_measureiOut,	},
	{"ISET?",								SCPI_queryiSet,	},
	{"ISET",								SCPI_setiSet,	},
	{"LOCK",								SCPI_setLockStatus,	},
	{"LOCK?",								SCPI_queryLockStatus,	},
	{"OCP",									SCPI_setProtOCActivation,	},
	{"OCP?",								SCPI_queryProtOCActivation,	},
	{"OISET?",								SCPI_queryOCPSet,	},
	{"OISET",								SCPI_setOCPSet,	},
	{"OPP",									SCPI_setProtOPActivation,	},
  {"OPP?",								SCPI_queryProtOPActivation,	},
	{"OPSET?",								SCPI_queryOPPSet,	},
	{"OPSET",								SCPI_setOPPSet,	},
	{"OUT?",								SCPI_queryOnoffStatus,	},
	{"OUT",									SCPI_setOnoffStatus,	},
	{"OVP",									SCPI_setProtOVActivation,	},
	{"OVP?",								SCPI_queryProtOVActivation,	},
	{"OVSET?",								SCPI_queryOVPSet,	},
	{"OVSET",								SCPI_setOVPSet,	},
	{"STATUS?",								SCPI_queryOutputStatus,	},
	{"STATE?",								SCPI_queryOutputState,	},
	{"VERsion?",							SCPI_VERSION,	},
	{"MODEL?",								SCPI_MODEL,	},
	{"VOUT?",								SCPI_measurevOut,	},
	{"VSET?",								SCPI_queryvSet,	},
	{"VSET",								SCPI_setvSet,	},


// OUTPut
	{"OUTPut[:STATe]?",						SCPI_queryOnoffStatus,	},
	{"OUTPut[:STATe]",						SCPI_setOnoffStatus,	},
	{"OUTPut:LIMit:CURRent?",				SCPI_queryLimitCurrentMax,	},
	{"OUTPut:LIMit:CURRent",				SCPI_setLimitCurrentMax,	},
	{"OUTPut:LIMit:VOLTage?",				SCPI_queryLimitVoltageMax,	},
	{"OUTPut:LIMit:VOLTage",				SCPI_setLimitVoltageMax,	},
	{"OUTPut:PROtection:CLEar",				SCPI_clearOVPOCPOPPCVCCCCCV,	},
	{"OUTPut:SLOPe:CURRent?",				SCPI_querySRiSet,	},
	{"OUTPut:SLOPe:CURRent",				SCPI_setSRiSet,	},
	{"OUTPut:SLOPe:VOLTage?",				SCPI_querySRvSet,	},
	{"OUTPut:SLOPe:VOLTage",				SCPI_setSRvSet,	},
	{"OUTPut:MODE?",						SCPI_queryOutputStatus,	},	  // Return output mode(CV or CC)

	{"OUTut[:STATe]?",						SCPI_queryOnoffStatus,	},
	{"OUTut[:STATe]",						SCPI_setOnoffStatus,	},
	{"OUTut:LIMit:CURRent?",				SCPI_queryLimitCurrentMax,	},
	{"OUTut:LIMit:CURRent",					SCPI_setLimitCurrentMax,	},
	{"OUTut:LIMit:VOLTage?",				SCPI_queryLimitVoltageMax,	},
	{"OUTut:LIMit:VOLTage",					SCPI_setLimitVoltageMax,	},
	{"OUTut:PROtection:CLEar",				SCPI_clearOVPOCPOPPCVCCCCCV,	},
	{"OUTut:SLOPe:CURRent?",				SCPI_querySRiSet,	},
	{"OUTut:SLOPe:CURRent",					SCPI_setSRiSet,	},
	{"OUTut:SLOPe:VOLTage?",				SCPI_querySRvSet,	},
	{"OUTut:SLOPe:VOLTage",					SCPI_setSRvSet,	},
	{"OUTut:MODE?",							SCPI_queryOutputStatus,	},	  // Return output mode(CV or CC)


// BK PVS command
    /* DMM */
	{"*RCL",								SCPI_RECALL_memory,	},	  
	{"*SAV",								SCPI_SAVE_memory,	},	  


// Config setting
	{"CONFig:LIMit:CURRent:MAX?",			SCPI_queryLimitCurrentMax,	},
	{"CONFig:LIMit:CURRent:MAX"	,			SCPI_setLimitCurrentMax,	},
	{"CONFig:LIMit:CURRent:MIN?",			SCPI_queryLimitCurrentMin,	},
	{"CONFig:LIMit:CURRent:MIN"	,			SCPI_setLimitCurrentMin,	},
	{"CONFig:LIMit:VOLTage:MAX?",			SCPI_queryLimitVoltageMax,	},
	{"CONFig:LIMit:VOLTage:MAX"	,			SCPI_setLimitVoltageMax,	},
	{"CONFig:LIMit:VOLTage:MIN?",			SCPI_queryLimitVoltageMin,	},
	{"CONFig:LIMit:VOLTage:MIN"	,			SCPI_setLimitVoltageMin,	},
	{"CONFig:LIMit:POWer:MAX?",				SCPI_queryLimitPowerMax,	},
	{"CONFig:LIMit:POWer:MAX",				SCPI_setLimitPowerMax,	},
	{"CONFig:LIMit:POWer:MIN?",				SCPI_queryLimitPowerMin,	},
	{"CONFig:LIMit:POWer:MIN",				SCPI_setLimitPowerMin,	},
	{"CONFig:EXTernal:MODE?",				SCPI_queryExtEnable,	},
	{"CONFig:EXTernal:MODE",				SCPI_setExtEnable,	},
	{"CONFig:EXTernal:CURRent:MODE?",		SCPI_queryExtIMode,	},
	{"CONFig:EXTernal:CURRent:MODE",		SCPI_setExtIMode,	},
	{"CONFig:EXTernal:MONitor:RANGe?",		SCPI_queryExtMonRange,	},
	{"CONFig:EXTernal:MONitor:RANGe",		SCPI_setExtMonRange,	},
	{"CONFig:EXTernal:PROGram:RANGe?",		SCPI_queryExtProgRange,	},
	{"CONFig:EXTernal:PROGram:RANGe",		SCPI_setExtProgRange,	},
	{"CONFig:EXTernal:SHUToff?",			SCPI_queryExtShutOffLogic,	},
	{"CONFig:EXTernal:SHUToff",				SCPI_setExtShutOffLogic,	},
	{"CONFig:EXTernal:VOLTage:MODE?",		SCPI_queryExtVMode,	},
	{"CONFig:EXTernal:VOLTage:MODE",		SCPI_setExtVMode,	},
	{"CONFig:PARAllel[:STATe]?",			SCPI_queryParallelMode,	},
	{"CONFig:PARAllel[:STATe]",				SCPI_setParallelMode,	},
	{"CONFig:PARAllel:ROLE?",				SCPI_queryParallelRole,	},
	{"CONFig:PARAllel:ROLE",				SCPI_setParallelRole,	},
	{"CONFig:CHAIn[:STATe]?",				SCPI_queryChainMode,	},
	{"CONFig:CHAIn[:STATe]",				SCPI_setChainMode,	},
	{"CONFig:CHAIn:ADDress?",				SCPI_queryChainAddr,	},
	{"CONFig:CHAIn:ADDress",				SCPI_setChainAddr,	},

// Memory
	{"MEMory[:NUMber]?",					SCPI_queryMemoryNumber,	},
	{"MEMory[:NUMber]",						SCPI_setMemoryNumber,	},
	{"MEMory:ISET?",						SCPI_queryMemoryNumberOfISet,	},
	{"MEMory:ISET",							SCPI_setMemoryNumberOfISet,	},
	{"MEMory:SAVE",							SCPI_saveMemoryNumberOfVSetISettoEeprom,	},
	{"MEMory:VSET?",						SCPI_queryMemoryNumberOfVSet,	},
	{"MEMory:VSET",							SCPI_setMemoryNumberOfVSet,	},

// Program
	{"PROGram[:NUMber]?",					SCPI_queryProgramGroup,	},
	{"PROGram[:NUMber]",					SCPI_setProgramGroup,	},


	{"PROGram:CLEar",						SCPI_clearParamOfNParameter,	},
	{"PROGram:CLEar:ALL",					SCPI_clearAllParamOfNParameter,	},
	{"PROGram:NEXT?",						SCPI_queryLinkNumberGroup,	},
	{"PROGram:NEXT",						SCPI_setLinkNumberGroup,	},
	{"PROGram:REPeat?",						SCPI_queryRepeatGroup,	},
	{"PROGram:REPeat",						SCPI_setRepeatGroup,	},
	{"PROGram:STATe?",						SCPI_queryProgramONOFF,	},	 // the same query onoffStatus
	{"PROGram:STATe",						SCPI_setProgramONOFF,	},
	{"PROGram:RUN?",						SCPI_queryProgramRun,						},
	{"PROGram:STEP[:NUMber]?",				SCPI_querySetpProgramStep,	},
	{"PROGram:STEP[:NUMber]",				SCPI_setSetpProgramStep,	},


	{"PROGram:STEP:ACTion?",				SCPI_queryStepProgramAction,	},
	{"PROGram:STEP:ACTion",					SCPI_setStepProgramAction,	},
	{"PROGram:STEP:CURRent?",				SCPI_queryStepProgramCurrent,	},
	{"PROGram:STEP:CURRent",				SCPI_setStepProgramCurrent,	},
	{"PROGram:STEP:VOLTage?",				SCPI_queryStepProgramVoltage,	},
	{"PROGram:STEP:VOLTage",				SCPI_setStepProgramVoltage,	},
	{"PROGram:STEP:ONTime?",				SCPI_queryStepProgramTimer,	},
	{"PROGram:STEP:ONTime",					SCPI_setStepProgramTimer,	},
	{"PROGram:TOTAl?",						SCPI_querySetpProgramStepEND,	},
//	{"PROGram:TOTAl",						SCPI_setSetpProgramStepEND,	},
// Protection
	{"PROTection[:STATe]?",					SCPI_queryProtection,	},
	{"PROTection:CCCV?",					SCPI_queryCCtoCVActivation,	},
	{"PROTection:CCCV",						SCPI_setCCtoCVActivation,	},
	{"PROTection:CLEar",					SCPI_clearOVPOCPOPPCVCCCCCV,	},
	{"PROTection:CVCC?",					SCPI_queryCVtoCCActivation,	},
	{"PROTection:CVCC",						SCPI_setCVtoCCActivation,	},
	{"PROTection:OCP[:STATe]?",				SCPI_queryProtOCActivation,	},
	{"PROTection:OCP[:STATe]",				SCPI_setProtOCActivation,	},
	{"PROTection:OCP:LEVel?",				SCPI_queryOCPSet,	},
	{"PROTection:OCP:LEVel",				SCPI_setOCPSet,	},
	{"PROTection:OPP[:STATe]?",				SCPI_queryProtOPActivation,	},
	{"PROTection:OPP[:STATe]",				SCPI_setProtOPActivation,	},
	{"PROTection:OPP:LEVel?",				SCPI_queryOPPSet,	},
	{"PROTection:OPP:LEVel",				SCPI_setOPPSet,	},
	{"PROTection:OVP[:STATe]?",				SCPI_queryProtOVActivation,	},
	{"PROTection:OVP[:STATe]",				SCPI_setProtOVActivation,	},
	{"PROTection:OVP:LEVel?",				SCPI_queryOVPSet,	},
	{"PROTection:OVP:LEVel",				SCPI_setOVPSet,	},
// [Source]
	{"SOURce:CURRent[:LEVel]?",				SCPI_queryiSet,	},
	{"SOURce:CURRent[:LEVel]",				SCPI_setiSet,	},
	{"SOURce:CURRent:PROTection[:STATe]?",	SCPI_queryProtOCActivation,	},
	{"SOURce:CURRent:PROTection[:STATe]",	SCPI_setProtOCActivation,	},
	{"SOURce:CURRent:PROTection:LEVel?",	SCPI_queryOCPSet,	},
	{"SOURce:CURRent:PROTection:LEVel",		SCPI_setOCPSet,	},
	{"SOURce:VOLTage[:LEVel]?",				SCPI_queryvSet,	},
	{"SOURce:VOLTage[:LEVel]",				SCPI_setvSet,	},
	{"SOURce:VOLTage:PROTection[:STATe]?",	SCPI_queryProtOVActivation,	},
	{"SOURce:VOLTage:PROTection[:STATe]",	SCPI_setProtOVActivation,	},
	{"SOURce:VOLTage:PROTection:LEVel?",	SCPI_queryOVPSet,	},
	{"SOURce:VOLTage:PROTection:LEVel",		SCPI_setOVPSet,	},
	{"SOURce:POWer:PROTection[:STATe]?",	SCPI_queryProtOPActivation,	},
	{"SOURce:POWer:PROTection[:STATe]",		SCPI_setProtOPActivation,	},
	{"SOURce:POWer:PROTection:LEVel?",		SCPI_queryOPPSet,	},
	{"SOURce:POWer:PROTection:LEVel",		SCPI_setOPPSet,	},

	{"CURRent[:LEVel]?",					SCPI_queryiSet,	},
	{"CURRent[:LEVel]",						SCPI_setiSet,	},
	{"CURRent:PROTection[:STATe]?",			SCPI_queryProtOCActivation,	},
	{"CURRent:PROTection[:STATe]",			SCPI_setProtOCActivation,	},
	{"CURRent:PROTection:LEVel?",			SCPI_queryOCPSet,	},
	{"CURRent:PROTection:LEVel",			SCPI_setOCPSet,	},
	{"VOLTage[:LEVel]?",					SCPI_queryvSet,	},
	{"VOLTage[:LEVel]",						SCPI_setvSet,	},
	{"VOLTage:PROTection[:STATe]?",			SCPI_queryProtOVActivation,	},
	{"VOLTage:PROTection[:STATe]",			SCPI_setProtOVActivation,	},
	{"VOLTage:PROTection:LEVel?",			SCPI_queryOVPSet,	},
	{"VOLTage:PROTection:LEVel",			SCPI_setOVPSet,	},
	{"POWer:PROTection?",					SCPI_queryProtOPActivation,	},
	{"POWer:PROTection",					SCPI_setProtOPActivation,	},
	{"POWer:PROTection:LEVel?",				SCPI_queryOPPSet,	},
	{"POWer:PROTection:LEVel",				SCPI_setOPPSet,	},
// System
	{"SYStem:ERRor?",						    SCPI_SystemErrorNextQ,	},
	{"SYStem:BEEP?",						    SCPI_queryBeepActivation,	},
	{"SYStem:BEEP",							    SCPI_setBeepActivation,	},
	{"SYStem:GPIB:ADDRess?",				SCPI_queryGPIBAddr,	},
	{"SYStem:GPIB:ADDRess",					SCPI_setGPIBAddr,	},
	{"SYStem:GROUp?",						    SCPI_queryGroupNumber,	},
	{"SYStem:GROUp",						    SCPI_setGroupNumber,	},
	{"SYStem:IP:ADDRess?",					SCPI_queryCurrentIPAddr,	},
	{"SYStem:IP:ADDRess",					  SCPI_setCurrentIPAddr,	},
	{"SYStem:IP:CONFig?",					  SCPI_queryLANIPMode,	},
	{"SYStem:IP:CONFig",					  SCPI_setLANIPMode,	},
	{"SYStem:IP:GATEway?",					SCPI_queryCurrentGateway,	},
	{"SYStem:IP:GATEway",					  SCPI_setCurrentGateway,	},
	{"SYStem:IP:MASK?",						  SCPI_queryCurrentMask,	},
	{"SYStem:IP:MASK",						  SCPI_setCurrentMask,	},
	{"SYStem:KEY:LOCK?",					  SCPI_queryLockStatus,	},
	{"SYStem:KEY:LOCK",						  SCPI_setLockStatus,	},
	{"SYStem:POWer:CURRent?",				SCPI_queryPowerOnCurrent,	},
	{"SYStem:POWer:CURRent",				SCPI_setPowerOnCurrent,	},
	{"SYStem:POWer:STATe?",					SCPI_queryPowerOn_OnOff,	},
	{"SYStem:POWer:STATe",					SCPI_setPowerOn_OnOff,	},
	{"SYStem:POWer:TYPE?",					SCPI_queryPowerOnMode,	},
	{"SYStem:POWer:TYPE",					  SCPI_setPowerOnMode,	},
	{"SYStem:POWer:VOLTage?",				SCPI_queryPowerOnVolt,	},
	{"SYStem:POWer:VOLTage",				SCPI_setPowerOnVolt,	},
	{"SYStem:RECall:DEFault",				SCPI_recallFactoryDefaultSetting,	},
	{"SYStem:RS232:BAUDrate?",			SCPI_queryR232Baud,	},
	{"SYStem:RS232:BAUDrate",				SCPI_setR232Baud,	},
	{"SYStem:RS232:DATAbit?",				SCPI_queryRs232parityDataBits,	},
	{"SYStem:RS232:DATAbit",				SCPI_setRs232parityDataBits,	},
	{"SYStem:RS232:STOPbit?",				SCPI_queryRs232stopBits,	},
	{"SYStem:RS232:STOPbit",				SCPI_setRs232stopBits,	},
	{"SYStem:RS485:BAUDrate?",			SCPI_queryR485Baud,	},
	{"SYStem:RS485:BAUDrate",				SCPI_setR485Baud,	},
	{"SYStem:RS485:DATAbit?",				SCPI_queryRs485parityDataBits,	},
	{"SYStem:RS485:DATAbit",				SCPI_setRs485parityDataBits,	},
	{"SYStem:RS485:STOPbit?",				SCPI_queryRs485stopBits,	},
	{"SYStem:RS485:STOPbit",				SCPI_setRs485stopBits,	},
	{"SYStem:PMAX?",						    SCPI_queryPMAX,	},
	{"SYStem:CS?",							    SCPI_queryCurrentSourceState,},

// Timer
	{"TIMER[:STATe]?",						    SCPI_queryTimerONOFF,	},
	{"TIMER[:STATe]",						      SCPI_setTimerONOFF,	},
	{"TIMER:HOUR?",							      SCPI_queryTimerHR,	},
	{"TIMER:HOUR",							      SCPI_setTimerHR,	},
	{"TIMER:MINute?",						      SCPI_queryTimerMN,	},
	{"TIMER:MINute",						      SCPI_setTimerMN,	},
	{"TIMER:SECond?",						      SCPI_queryTimerSE,	},
	{"TIMER:SECond",						      SCPI_setTimerSE,	},

// PV SIM
	{"PVSIMulation:CURVe:SELEct?",		SCPI_queryPvsSelect,	},	// ϥ
	{"PVSIMulation:CURVe:SELEct",			SCPI_setPvsSelect,		},	// ϥ
	{"PVSIMulation:CURVe[:NUMber]",		SCPI_setPvsCurveNum,	},	// User
	{"PVSIMulation:CURVe[:NUMber]?",	SCPI_queryPvsCurveNum,	},	// User
	{"PVSIMulation:CURVe:PARAMeter?",	SCPI_queryPvsCurveParam,},	// User
	{"PVSIMulation:CURVe:PARAMeter",	SCPI_setPvsCurveParam,	},	// User
	
	{"PVSIMulation:POWer?",					  SCPI_queryPvsPower,		},	// 1.B4Hᤣϥ
	{"PVSIMulation:POWer",					  SCPI_setPvsPower,		},	// 1.B4Hᤣϥ
	{"PVSIMulation[:STATe]?",				  SCPI_queryPvsState,		},	// User
	{"PVSIMulation[:STATe]",				  SCPI_setPvsState,		},	// User
	{"PVSIMulation:TABLe[:NUMber]",		SCPI_setPvsTableNum,	},
	{"PVSIMulation:TABLe:PARAMeter?",	SCPI_queryPvsTableParam,},
	{"PVSIMulation:TABLe:PARAMeter",	SCPI_setPvsTableParam,	},
	{"PVSIMulation:TABLe:STARt",			SCPI_setPvsTableStart,},
	{"PVSIMulation:TABLe:STOP",				SCPI_setPvsTableStop,	},
	{"PVSIMulation:TABLe:STATe?",			SCPI_queryPvsTableNumState,	},
	{"PVSIMulation:TABLe:ARRAy",			SCPI_setPvsTableArray,	},
	{"PVSIMulation:GT",						    SCPI_setPvsGT,			},
	{"PVSIMulation:VMPPMP",					  SCPI_setPvsVmpPmp,		},
	{"PVSIMulation:FORMULa",				  SCPI_setPvsFormula,		},
	{"PVSIMulation:CONTrol:MODe",			SCPI_setPvsControlMode,	},
 	{"PVSIMulation:CONTrol:MODe?",		SCPI_queryPvsControlMode,	},


// Calibration	13579 CALibrate
	{"CALibrate:VOLTage:TOTal?", 			SCPI_calpvq_calpvr,},  	// A0 ->   A1 <-
	{"CALibrate:VOLTage:POInt?", 			SCPI_send_calvnQ,},		// query presentPoint
	{"CALibrate:VOLTage:POInt", 			SCPI_send_calvn,},  	// A4 ->  ***
	{"CALibrate:VOLTage:DATA?",				SCPI_send_calvnq,},  	// A5 ->   A6 <-  ***
	{"CALibrate:VOLTage:DATA",				SCPI_send_calvns,},  	// A7 ->  ***

	{"CALibrate:CURRent:TOTal?", 			SCPI_calpiq_calpir,},  	// A2 ->   A3 <-
	{"CALibrate:CURRent:POInt?", 			SCPI_send_calvnQ,},		// query presentPoint
	{"CALibrate:CURRent:POInt", 			SCPI_send_calin,},  	// A8 ->   ***
	{"CALibrate:CURRent:DATA?",				SCPI_send_calinq,},  	// A9 ->   AA <- ***
	{"CALibrate:CURRent:DATA",				SCPI_send_calins,},  	// AB ->   ***

	{"CALibrate:OVP:STARt",					  SCPI_send_startovpq,},  	// B0 ->  ***
	{"CALibrate:OVP:STATe?",				  SCPI_send_ovpcalstater,},	// B1 <-
	{"CALibrate:OCP:STARt",					  SCPI_send_startocpq,},  	// B2 ->  ***
	{"CALibrate:OCP:STATe?",				  SCPI_send_ocpcalstater,},	// B3 <-

	{"CALibrate:EXTVoltage:POInt?",		SCPI_send_calvnQ,},		// query presentPoint 
	{"CALibrate:EXTVoltage:POInt",		SCPI_send_EXTVoltagePoint,},	// ***
	{"CALibrate:EXTVoltage:DATA?",		SCPI_query_EXTVoltageDATA,},	// ***
	{"CALibrate:EXTVoltage:DATA",			SCPI_send_EXTVoltageDATA,},		// 
	{"CALibrate:EXTVoltage:TOTal?",		SCPI_query_EXTCalToTalPoint,},	// 
	{"CALibrate:EXTCurrent:POInt?",		SCPI_send_calvnQ,},		// query presentPoint 
	{"CALibrate:EXTCurrent:POInt",		SCPI_send_EXTCurrentPoint,},	// ***
	{"CALibrate:EXTCurrent:DATA?",		SCPI_query_EXTCurrentDATA,},	// ***
	{"CALibrate:EXTCurrent:DATA",			SCPI_send_EXTCurrentDATA,},		// 
	{"CALibrate:EXTCurrent:TOTal?",		SCPI_query_EXTCalToTalPoint,},	// 

// current scurce cal.
	{"CALibrate:EXTCurrent:CC[:STATe]",		SCPI_send_FATEXTCurrentCCState,},	// ***
	{"CALibrate:EXTCurrent:CC[:STATe]?",	SCPI_query_FATEXTCurrentCCState,},
	{"CALibrate:EXTCurrent:CC:DATA?",		SCPI_query_EXTCurrentCCDATA,},	// ***
	{"CALibrate:EXTCurrent:CC:DATA",		SCPI_send_EXTCurrentCCDATA,},	//
	 
	{"CALibrate:EXTVoltage:CC[:STATe]",		SCPI_send_FATEXTVoltageCCState,},	// ***
	{"CALibrate:EXTVoltage:CC[:STATe]?",	SCPI_query_FATEXTVoltageCCState,},
	{"CALibrate:EXTVoltage:CC:DATA?",		SCPI_query_EXTVoltageCCDATA,},	// ***
	{"CALibrate:EXTVoltage:CC:DATA",		SCPI_send_EXTVoltageCCDATA,},	//



// Calibration	24680 KALibrate
	{"KALibrate:VOLTage:TOTal?", 			SCPI_calpvq_calpvr,},  	// A0 ->   A1 <-
	{"KALibrate:VOLTage:POInt?", 			SCPI_send_calvnQ,},		// query presentPoint
	{"KALibrate:VOLTage:POInt", 			SCPI_send_FATcalvn,},  	// A4 ->	***
	{"KALibrate:VOLTage:DATA?",				SCPI_send_FATcalvnq,},  	// A5 ->   A6 <-  ***
	{"KALibrate:VOLTage:DATA",				SCPI_send_FATcalvns,},  	// A7 ->	***

	{"KALibrate:CURRent:TOTal?", 			SCPI_calpiq_calpir,},  	// A2 ->   A3 <-
	{"KALibrate:CURRent:POInt?", 			SCPI_send_calvnQ,},		// query presentPoint
	{"KALibrate:CURRent:POInt", 			SCPI_send_FATcalin,},  	// A8 ->	***
	{"KALibrate:CURRent:DATA?",				SCPI_send_FATcalinq,},  	// A9 ->   AA <-  ***
	{"KALibrate:CURRent:DATA",				SCPI_send_FATcalins,},  	// AB ->	***

	{"KALibrate:OVP:STARt",					SCPI_send_FATstartovpq,},  	// B0 ->  ***
	{"KALibrate:OVP:STATe?",				SCPI_send_ovpcalstater,},	// B1 <-
	{"KALibrate:OCP:STARt",					SCPI_send_FATstartocpq,},  	// B2 ->  ***
	{"KALibrate:OCP:STATe?",				SCPI_send_ocpcalstater,},	// B3 <-

	{"KALibrate:EXTVoltage:POInt?",			SCPI_send_calvnQ,},		// query presentPoint 
	{"KALibrate:EXTVoltage:POInt",			SCPI_send_FATEXTVoltagePoint,},	// ***
	{"KALibrate:EXTVoltage:DATA?",			SCPI_query_FATEXTVoltageDATA,},	// ***
	{"KALibrate:EXTVoltage:DATA",			SCPI_send_EXTVoltageDATA,},	// 
	{"KALibrate:EXTVoltage:TOTal?",			SCPI_query_EXTCalToTalPoint,},	// 
	{"KALibrate:EXTCurrent:POInt?",			SCPI_send_calvnQ,},		// query presentPoint 
	{"KALibrate:EXTCurrent:POInt",			SCPI_send_FATEXTCurrentPoint,},	// ***
	{"KALibrate:EXTCurrent:DATA?",			SCPI_query_FATEXTCurrentDATA,},	// ***
	{"KALibrate:EXTCurrent:DATA",			SCPI_send_EXTCurrentDATA,},	// 
	{"KALibrate:EXTCurrent:TOTal?",			SCPI_query_EXTCalToTalPoint,},	// 

// current scurce cal.
	{"KALibrate:EXTCurrent:CC[:STATe]",		SCPI_send_FATEXTCurrentCCState,},	// ***
	{"KALibrate:EXTCurrent:CC[:STATe]?",	SCPI_query_FATEXTCurrentCCState,},
	{"KALibrate:EXTCurrent:CC:DATA?",		SCPI_query_FATEXTCurrentCCDATA,},	// ***
	{"KALibrate:EXTCurrent:CC:DATA",		SCPI_send_FATEXTCurrentCCDATA,},	//
	 
	{"KALibrate:EXTVoltage:CC[:STATe]",		SCPI_send_FATEXTVoltageCCState,},	// ***
	{"KALibrate:EXTVoltage:CC[:STATe]?",	SCPI_query_FATEXTVoltageCCState,},
	{"KALibrate:EXTVoltage:CC:DATA?",		SCPI_query_FATEXTVoltageCCDATA,},	// ***
	{"KALibrate:EXTVoltage:CC:DATA",		SCPI_send_FATEXTVoltageCCDATA,},	//
	{"KALibrate:DUMP?",					    SCPI_paramRcall,},


	{"ABORt",								SCPI_abortCALAction,},	// 

// UI transparent USB & UART
	{"STARTDLE7",							SCPI_DownLoadE7,	},
	{"STARTDLE1",							SCPI_DownLoadE1,	},
	{"STARTDLEG",							SCPI_DownLoadEG,	},
	{"ENDDL",								SCPI_Restart,},
// UI serial & MACaddress(USB id) setting
	{"SYStem:SERial?",						SCPI_querySerialNumber,	},
	{"SYStem:SERial",						SCPI_setSerialNumber,	},
	{"KALibrate:MANUFacture?",				SCPI_queryManufacture,	},
	{"KALibrate:MANUFacture",				SCPI_setManufacture,	},
	{"KALibrate:MODel?",					SCPI_MODEL,	},
	{"KALibrate:MODel",						SCPI_setModel,	},
	{"KALibrate:KEY?",						SCPI_queryKey,	},
	{"KALibrate:KEY",						SCPI_setKey,	},
	{"PRODuction:SERial?",					SCPI_querySerialNumber,	},
	{"PRODuction:SERial",					SCPI_setSerialNumber,	},
	{"PRODuction:MANUFacture?",				SCPI_queryManufacture,	},
	{"PRODuction:MANUFacture",				SCPI_setManufacture,	},
	{"PRODuction:MODel?",					SCPI_MODEL,	},
	{"PRODuction:MODel",					SCPI_setModel,	},		    
	{"PRODuction:KEY?",						SCPI_queryKey,	},
	{"PRODuction:KEY",						SCPI_setKey,	},
	{"CAL:MAC?",							SCPI_queryMACaddress,	},
	{"CAL:MAC",								SCPI_setMACaddress,	},

    /* Required SCPI commands (SCPI std V1999.0 4.2.1) */
    {"SYSTem:ERRor?", 						SCPI_SystemErrorNextQ,},
    {"SYSTem:ERRor:NEXT?", 					SCPI_SystemErrorNextQ,},
    {"SYSTem:ERRor:COUNt?", 				SCPI_SystemErrorCountQ,},
    {"SYSTem:VERSion?", 					SCPI_VERSION,},	   // 16


#ifdef _PARALLEL_COMMAND	  /* RS485 RO */
/* tαRO */
	{"CADR", 								SCPI_setChainAddrSlave,},
	{"CADR?", 								SCPI_queryChainAddrSlave,},
	{"CCLS", 								SCPI_485Cls,},
	{"CRST", 								SCPI_485Rst,},
	{"CIDN?", 								SCPI_485Idn,},
	{"CREV?", 								SCPI_485Rev,},
	{"CSN?", 								SCPI_485Sn,},
	{"CST?", 								SCPI_485St,},
	{"CCLR?", 								SCPI_485Clr,},
/* XRO */
	{"CPV", 								SCPI_485setVset,},
	{"CPV?", 								SCPI_485queryVset,},
	{"CMV?", 								SCPI_485queryVout,},
	{"CPC", 								SCPI_485setIset,},
	{"CPC?", 								SCPI_485queryIset,},
	{"CMC?", 								SCPI_485queryIout,},
	{"CDVC?", 								SCPI_485queryVoutIout,},
	{"COUT", 								SCPI_485setOutput,},
	{"COUT?", 								SCPI_485queryOutput,},
	{"COV", 								SCPI_485setOVPSet,},
	{"COV?", 								SCPI_485queryOVPSet,},
	{"COVP", 								SCPI_485setOVPSwitch,},
	{"COVP?", 								SCPI_485queryOVPSwitch,},
	{"COC", 								SCPI_485setOCPSet,},
	{"COC?", 								SCPI_485queryOCPSet,},
	{"COCP", 								SCPI_485setOCPSwitch,},
	{"COCP?", 								SCPI_485queryOCPSwitch,},
	{"COP", 								SCPI_485setOPPSet,},
	{"COP?", 								SCPI_485queryOPPSet,},
	{"COPP", 								SCPI_485setOPPSwitch,},
	{"COPP?", 								SCPI_485queryOPPSwitch,},
	{"CMODE?", 								SCPI_queryMode,},

	/*
	EX:
	CADR 2		]w Ū ID = 2} 
	CPVCURV 2	]wϥ ID 2 curve 2
	CPVPARM?	߰ ID2 ,curve2  Rule,Vmp,Pmp,Material 
	*/
	{"CPVPARM?",							SCPI_485queryPVSIMParamter,},
	/*
	CPVPARM Rule,Vmp,Pmp,Material	    ]w Rule,Vmp,Pmp,Material
	*/
	{"CPVPARM",								SCPI_485setPVSIMParameter,},
	/*
	CPVCURV?    ߰ bϥέ@ curve
	*/
	{"CPVCURV?",							SCPI_485queryPVSIMCurve,},
	/*
	CPVCURV x   ]wnϥέ@ curve  1~101  ()
	*/
	{"CPVCURV",								SCPI_485setPVSIMCurve,},
	/*
	CPVSTATE  ON|OFF    ]w PVSIM}
	*/
	{"CPVSTATE",							SCPI_485setPVState,},
	/*
	CPVSTATE?  ߰ ثePVSIM}A
	 */
	{"CPVSTATE?", 							SCPI_485queryPVState,},
	/*
	CPVPOW  Set the simulated output power from 0 ~ 100%
	 */
	{"CPVPOW", 								SCPI_485SetPVPower,},
	/*
	CPVPOW?  Return  the simulated output power from 0 ~ 100%
	 */
	{"CPVPOW?", 							SCPI_485queryPVPower,},

	/*
	CPVTABLEPOINT Set the point number n of the user defined V/I table
	 */
	{"CPVTABLEPOINT", 						SCPI_485SetPVTablePoint,},

	/*
	CPVTABPARM  Set the parameters (voltage and current) of the table point number n
	 */
	{"CPVTABPARM", 							SCPI_485SetPVTableParm,},
	/*
	CPVTABPARM?  Return the parameters (voltage and current) of the table point number n
	 */
	{"CPVTABPARM?", 						SCPI_485queryPVTableParm,},

   /*
	CPVTABSTART	Start the user defined V/I table loading
	 */
	{"CPVTABSTART",							SCPI_485PVStart,},

	/*
	CPVTABSTOP	Stop the user defined V/I table loading
	 */
	{"CPVTABSTOP", 							SCPI_485PVStop,},
	/*
	CPVTABSTATE?	Return the previous write status of table point, 0=not OK, 1=OK
	 */
	{"CPVTABSTATE?",						SCPI_485queryPVTabState,},
	/*
	CMAXPOWER?		Return max power
	 */
	{"CMAXPOWER?",							SCPI_485querymaxPower,},
/*
	CPVGT (ӫ,ū)  pvsG,pvsT
*/
	{"CPVGT",								SCPI_485PVpvsGpvsT,},
/*
	CPVFM  formula, material
*/
	{"CPVFM",								SCPI_485PVFM,},
/*
	CPVVMPPMP  pvsvmp,pvspmp
*/
	{"CPVVMPPMP",							SCPI_485PVvmppmp,},
/*
	GPVTABNUM (}Cjp) pvsarray  128~4096
*/
	{"CPVTABARRAY",							SCPI_485PVTableArray,},



/*
	 CADR m w SLAVE m
*/
	{"CPARALLELROLE",						SCPI_485setParallelRole,},
/*
    query CADR m  SLAVE m
*/
	{"CPARALLELROLE?",						SCPI_485queryParallelRole,},
/*
	 CADR m w CADR m
*/
	{"CCHAINADDRESS",						SCPI_485setChainAddress,},
/*
    query CADR m  CADR m
*/
	{"CCHAINADDRESS?",						SCPI_485queryChainAddress,},

  {"CPVCTRLMOD",							SCPI_485setPVCtrlMode,},
/*
	 query PV TABLE CRC CHECK
*/	
  {"CPVTABQCRC?",								SCPI_485PVTABQueryCRC,},
	{"CPVCSHDQE9?",								SCPI_485PVSHDQueryE9,},
	

/* PBRO */
	{"GRST", 									SCPI_485RSTbroadcast,},
	{"GCLS", 									SCPI_485CLSbroadcast,},
	{"GCLR", 									SCPI_485CLRbroadcast,},
	{"GPV", 									SCPI_485VSETbroadcast,},
	{"GPC", 									SCPI_485ISETbroadcast,},
	{"GOUT", 									SCPI_485OUTbroadcast,},
	{"GOV", 									SCPI_485OVPSetbroadcast,},
	{"GOVP", 									SCPI_485OVPSwitchBroadcast,},
	{"GOC", 									SCPI_485OCPSetbroadcast,},
	{"GOCP", 									SCPI_485OCPSwitchBroadcast,},
	{"GDVC?", 								SCPI_485queryVoutIoutBroadcast,},
	/*
	sRO
	GPVPARA Rule,Vmp,Pmp,Material
	*/
	{"GPVPARM",								SCPI_485PVSIMParamBroadcast,},
	/*
	sRO
	GPVSTATE ON|OFF
	*/
	{"GPVSTATE",							SCPI_485PVStateBroadcast,},



 /*
GPVPOW	Set the simulated output power from 0 ~ 100%
*/
	{"GPVPOW",								SCPI_485PVPowerBroadcast,},
/*
GPVTABLEPOINT	Set the point number n of the user defined V/I table
*/
	{"GPVTABLEPOINT",					SCPI_485PVTableBroadcast,},
/*
GPVTABSTART	Start the user defined V/I table loading
*/
	{"GPVTABSTART",						SCPI_485PVStartBroadcast,},
/*
GPVTABSTOP	Stop the user defined V/I table loading
*/
	{"GPVTABSTOP",						SCPI_485PVStopBroadcast,},

/*
  GPVTABPARM	point,voltage,current
*/
	{"GPVTABPARM",						SCPI_485PVSIMTabParamBroadcast,},
/*
	 GPVCURV 1~101 or 255
*/
	{"GPVCURV",								SCPI_485setPVSIMCurveBroadcast,},
/*
	GPVTABNUM (}Cjp) pvsarray  128~4096
*/
	{"GPVTABARRAY",						SCPI_485PVTableArrayBroadcast,},
/*
	GPVGT (ӫ,ū)  pvsG,pvsT
*/
	{"GPVGT",									SCPI_485PVpvsGpvsTBroadcast,},
/*
	GPVFM  formula, material
*/
	{"GPVFM",									SCPI_485PVFMBroadcast,},
/*
	GPVVMPPMP  pvsvmp,pvspmp
*/
	{"GPVVMPPMP",							SCPI_485PVvmppmpBroadcast,},

	/*
CHAIN MODE	PV SIM suy{ 
===============================
GECHO OFF
GCHAINSTATE OFF
GCHAINSTATE ON	
CADR 1
CIDN?
CADR 2
CIDN?
CADR 3
CIDN?	
GECHO ON
GDEVICE?	
GDVC?	
GCSTATUS?	
.
.
.	
GPVFM 1,2
GPVVMPPMP 65,100
GPVGT 1000,25
GPVSTATE 1
GOUT 1
.
.
.
GPVFM 1,2
GPVVMPPMP 65,100
GPVGT 750,25
.
.
.
GPVFM 1,2
GPVVMPPMP 65,100
GPVGT 500,25
.
.
.
GOUT 0
GECHO OFF
	
	
================================	
	*/
	
	
	
	
	{"GECHO",										SCPI_485setEcho,},
	{"GECHO?",									SCPI_485queryEcho,},

	{"GDEVICE?",								SCPI_485querytotalSlave,},
	{"GCSTATUS?",								SCPI_485queryConnectStatus,},

/*
	GPARALLELSTATE broadcast parallel Mode ON or OFF
*/
	{"GPARALLELSTATE",					SCPI_485setParallelState,},

/*
	GCHAINSTATE broadcast Chain Mode ON or OFF
*/

	{"GCHAINSTATE",							SCPI_485setChainState,},
	{"GPARALLELDEBUG",					SCPI_485setparallelDebug,},
	{"GPVCTRLMOD",							SCPI_485setPVCtrlModeBroadCast,},
	
/*
   Shadow ...
*/	
	
  // Voc,Isc,Vmp,Imp,Beta  float,float,float,float,float	
	{"GPVSHDPARM",							SCPI_485PVShdParmBroadcast,},  // E5
	// PV num ,G ,T  Type Sequence ( 1 ~ 7 ),Irradiance Value,Temperature ( Ex. 25.5 => 255 )
	{"GPVSHDNGT",								SCPI_485PVShdNGTBroadcast,},  // E6
	// Total Parallel Number ( Maximum is 64)
	{"GPVSHDPARALLELNUM",				SCPI_485PVShdParallelNumBroadcast,}, // E7
	// Count of Parallel Number,Count of Type1,Count of Type2,Count of Type3,Count of Type4,Count of Type5,Count of Type6,Count of Type7
	{"GPVSHDPARALLELPARM",			SCPI_485PVShdParallelParmBroadcast,}, // E8
	// After sending E5 and E6, will receive E9, then send E8
//  {"GPVSHDBBCOK",							SCPI_485PVShdBBCOKBroadcast,}, // E9
	// Set Shadow Simulation Mode 0: OFF, 1: ON
	{"GPVSHDSIMMOD",						SCPI_485PVShdSimModBroadcast,}, // EA
  {"GPVTABWCRC",								SCPI_485PVTABWriteCRC,},	
	
#endif

// below is not used

//    {"STATus:QUEStionable?", 				SCPI_StatusQuestionableEventQ,},
//    {"STATus:QUEStionable:EVENt?", 		SCPI_StatusQuestionableEventQ,},
//    {"STATus:QUEStionable:ENABle", 		SCPI_StatusQuestionableEnable,},
//    {"STATus:QUEStionable:ENABle?", 		SCPI_StatusQuestionableEnableQ,},

//    {"STATus:PRESet", 					SCPI_StatusPreset,},

//    {"MEASure:VOLTage:DC?", 				DMM_MeasureVoltageDcQ,},
//    {"CONFigure:VOLTage:DC", 				DMM_ConfigureVoltageDc,},
//    {"MEASure:VOLTage:DC:RATio?", 		SCPI_StubQ,},
//    {"MEASure:VOLTage:AC?", 				SCPI_StubQ,},
//    {"MEASure:CURRent:DC?", 				SCPI_StubQ,},
//    {"MEASure:CURRent:AC?", 				SCPI_StubQ,},
//    {"MEASure:RESistance?", 				SCPI_StubQ,},
//    {"MEASure:FRESistance?", 				SCPI_StubQ,},
//    {"MEASure:FREQuency?",				SCPI_StubQ,},
//    {"MEASure:PERiod?", 					SCPI_StubQ,},
//    {"SYSTem:COMMunication:TCPIP:CONTROL?", SCPI_SystemCommTcpipControlQ,},

    SCPI_CMD_LIST_END
};

/*
 * multipliers IEEE 488.2-1992 tab 7-2
 * 1E18         EX
 * 1E15         PE
 * 1E12         T
 * 1E9          G
 * 1E6          MA (use M for OHM and HZ)
 * 1E3          K
 * 1E-3         M (disaalowed for OHM and HZ)
 * 1E-6         U
 * 1E-9         N
 * 1E-12        P
 * 1E-15        F
 * 1E-18        A
 */

/*
 * units definition IEEE 488.2-1992 tab 7-1
 */
const scpi_unit_def_t scpi_units_def[] = {
    /* voltage */
    {/* name */ "UV",   /* unit */ SCPI_UNIT_VOLT,      /* mult */ 1e-6},
    {/* name */ "MV",   /* unit */ SCPI_UNIT_VOLT,      /* mult */ 1e-3},
    {/* name */ "V",    /* unit */ SCPI_UNIT_VOLT,      /* mult */ 1},
    {/* name */ "KV",   /* unit */ SCPI_UNIT_VOLT,      /* mult */ 1e3},

    /* current */
    {/* name */ "UA",   /* unit */ SCPI_UNIT_AMPER,     /* mult */ 1e-6},
    {/* name */ "MA",   /* unit */ SCPI_UNIT_AMPER,     /* mult */ 1e-3},
    {/* name */ "A",    /* unit */ SCPI_UNIT_AMPER,     /* mult */ 1},
    {/* name */ "KA",   /* unit */ SCPI_UNIT_AMPER,     /* mult */ 1e3},

    /* resistance */
    {/* name */ "OHM",  /* unit */ SCPI_UNIT_OHM,       /* mult */ 1},
    {/* name */ "KOHM", /* unit */ SCPI_UNIT_OHM,       /* mult */ 1e3},
    {/* name */ "MOHM", /* unit */ SCPI_UNIT_OHM,       /* mult */ 1e6},

    /* frequency */
    {/* name */ "HZ",   /* unit */ SCPI_UNIT_HERTZ,     /* mult */ 1},
    {/* name */ "KHZ",  /* unit */ SCPI_UNIT_HERTZ,     /* mult */ 1e3},
    {/* name */ "MHZ",  /* unit */ SCPI_UNIT_HERTZ,     /* mult */ 1e6},
    {/* name */ "GHZ",  /* unit */ SCPI_UNIT_HERTZ,     /* mult */ 1e9},

    /* temperature */
    {/* name */ "CEL",  /* unit */ SCPI_UNIT_CELSIUS,   /* mult */ 1},

    /* time */
    {/* name */ "PS",   /* unit */ SCPI_UNIT_SECONDS,   /* mult */ 1e-12},
    {/* name */ "NS",   /* unit */ SCPI_UNIT_SECONDS,   /* mult */ 1e-9},
    {/* name */ "US",   /* unit */ SCPI_UNIT_SECONDS,   /* mult */ 1e-6},
    {/* name */ "MS",   /* unit */ SCPI_UNIT_SECONDS,   /* mult */ 1e-3},
    {/* name */ "S",    /* unit */ SCPI_UNIT_SECONDS,   /* mult */ 1},
    {/* name */ "MIN",  /* unit */ SCPI_UNIT_SECONDS,   /* mult */ 60},
    {/* name */ "HR",   /* unit */ SCPI_UNIT_SECONDS,   /* mult */ 3600},

    SCPI_UNITS_LIST_END,
};

/*
 * Special number values definition
 */
const scpi_special_number_def_t scpi_special_numbers_def[] = {
    {/* name */ "MINimum",      /* type */ SCPI_NUM_MIN},
    {/* name */ "MAXimum",      /* type */ SCPI_NUM_MAX},
    {/* name */ "DEFault",      /* type */ SCPI_NUM_DEF},
    {/* name */ "UP",           /* type */ SCPI_NUM_UP},
    {/* name */ "DOWN",         /* type */ SCPI_NUM_DOWN},
    {/* name */ "NAN",          /* type */ SCPI_NUM_NAN},
    {/* name */ "INF",          /* type */ SCPI_NUM_INF},
    {/* name */ "NINF",         /* type */ SCPI_NUM_NINF},

	{/* name */ "FRONt",        /* type */ SCPI_PARM_FRONT},
	{/* name */ "EXTV",         /* type */ SCPI_PARM_EXTV},
	{/* name */ "EXTR",         /* type */ SCPI_PARM_EXTR},
	{/* name */ "5V",         	/* type */ SCPI_PARM_MON5V},
	{/* name */ "10V",         	/* type */ SCPI_PARM_MON10V},
	{/* name */ "5V|5K",       	/* type */ SCPI_PARM_PROG5V5K},
	{/* name */ "10V|10K",     	/* type */ SCPI_PARM_PROG10V10K},
	{/* name */ "MASTER",     	/* type */ SCPI_PARM_MASTER},
	{/* name */ "SLAVEA",     	/* type */ SCPI_PARM_SLAVEA},
	{/* name */ "SLAVEB",     	/* type */ SCPI_PARM_SLAVEB},
	{/* name */ "SLAVEC",     	/* type */ SCPI_PARM_SLAVEC},


	{/* name */ "NAC",			/* type */ SCPI_PARM_NAC},
	{/* name */ " ON",			/* type */ SCPI_PARM_ACT},
	{/* name */ "END",			/* type */ SCPI_PARM_END},
	{/* name */ "STATic",		/* type */ SCPI_PARM_STATIC},
	{/* name */ "MANUal",		/* type */ SCPI_PARM_MANUAL},
	{/* name */ "DHCP",			/* type */ SCPI_PARM_DHCP},
	{/* name */ "AUTO",			/* type */ SCPI_PARM_AUTO},

	{/* name */ "OFF",			/* type */ SCPI_PARM_OFF},
	{/* name */ "LAST",			/* type */ SCPI_PARM_LAST},
	{/* name */ "USER",			/* type */ SCPI_PARM_USER},

	{/* name */ "USB",			/* type */ SCPI_PARM_USB},
	{/* name */ "GPIB",			/* type */ SCPI_PARM_GPIB},
	{/* name */ "ETHERNET",		/* type */ SCPI_PARM_ETHERNET},
	{/* name */ "485",			/* type */ SCPI_PARM_485},
	{/* name */ "232",			/* type */ SCPI_PARM_232},
	{/* name */ "ON",			/* type */ SCPI_PARM_ON},
 	{/* name */ "NONE",			/* type */ SCPI_PARM_NONE},
	{/* name */ "AMODE",		/* type */ SCPI_PARM_AMODE},
 	{/* name */ "BMODE",		/* type */ SCPI_PARM_BMODE},
	{/* name */ "9600",			/* type */ SCPI_PARM_9600},
	{/* name */ "19200",		/* type */ SCPI_PARM_19200},
	{/* name */ "38400",		/* type */ SCPI_PARM_38400},
	{/* name */ "57600",		/* type */ SCPI_PARM_57600},

	{/* name */ "NONE8",		/* type */ SCPI_PARM_NONE8},
	{/* name */ "EVEN8",		/* type */ SCPI_PARM_EVEN8},
	{/* name */ "ODD8",			/* type */ SCPI_PARM_ODD8},
	{/* name */ "EVEN7",		/* type */ SCPI_PARM_EVEN7},
	{/* name */ "ODD7",			/* type */ SCPI_PARM_ODD7},
	{/* name */ "CC",			/* type */ SCPI_PARM_CC},
	{/* name */ "CV",			/* type */ SCPI_PARM_CV},



    SCPI_SPECIAL_NUMBERS_LIST_END,
};






static scpi_interface_t scpi_interface = {
    /* error */ SCPI_Error,
    /* write */ SCPI_Write,
    /* control */ SCPI_Control,
    /* flush */ SCPI_Flush,
    /* reset */ SCPI_Reset,
    /* test */ SCPI_Test,
};

enum _locate_text_states {
    STATE_FIRST_WHITESPACE,
    STATE_TEXT_QUOTED,
    STATE_TEXT,
    STATE_LAST_WHITESPACE,
    STATE_COMMA,
    STATE_ERROR
};
typedef enum _locate_text_states locate_text_states;


struct _locate_text_nfa {
    locate_text_states state;
    int32_t startIdx;
    int32_t stopIdx;
    size_t i;
};
typedef struct _locate_text_nfa locate_text_nfa;


#define SCPI_INPUT_BUFFER_LENGTH 256
static char scpi_input_buffer[SCPI_INPUT_BUFFER_LENGTH];

static scpi_reg_val_t scpi_regs[SCPI_REG_COUNT];
static size_t patternSeparatorPos(const char * pattern, size_t len);
static size_t cmdSeparatorPos(const char * cmd, size_t len);
static size_t cmdTerminatorPos(const char * cmd, size_t len);
static size_t cmdlineSeparatorPos(const char * cmd, size_t len);
static const char * cmdlineSeparator(const char * cmd, size_t len);
static const char * cmdlineTerminator(const char * cmd, size_t len);
static const char * cmdlineNext(const char * cmd, size_t len);
static bool_t cmdMatch(const char * pattern, const char * cmd, size_t len);

static void paramSkipBytes(scpi_t * context, size_t num);
static void paramSkipWhitespace(scpi_t * context);
static bool_t paramNext(scpi_t * context, bool_t mandatory);

/* basic FIFO */
static fifo_t local_error_queue;



scpi_t scpi_context;

  
/*
scpi_t scpi_context = {
    .cmdlist = scpi_commands,
    .buffer = {
        .length = SCPI_INPUT_BUFFER_LENGTH,
        .data = scpi_input_buffer,
    },
    .interface = &scpi_interface,
    .registers = scpi_regs,
    .units = scpi_units_def,
    .special_numbers = scpi_special_numbers_def,
};

  */


/**
 * Initialize SCPI context structure
 * @param context
 * @param command_list
 * @param buffer
 * @param interface
 */
void SCPI_Init(scpi_t * context) {
	context->cmdlist = scpi_commands;
	context->buffer.length = SCPI_INPUT_BUFFER_LENGTH;
    context->buffer.position = 0;
	context->buffer.data = scpi_input_buffer;
	context->interface = &scpi_interface;
	context->registers = scpi_regs;
	context->units = scpi_units_def;
	context->special_numbers = scpi_special_numbers_def;
	context->cmdLevel = 0;  										// add by ken
    SCPI_ErrorInit(context);
}
/**
 * Find pattern separator position
 * @param pattern
 * @param len - max search length
 * @return position of separator or len
 */
size_t patternSeparatorColon(const char * pattern, size_t len) {	// add by ken
																	// add by ken
    char * separator = strnpbrk(pattern, len, ":");					// add by ken
    if (separator == NULL) {										// add by ken
        return len;													// add by ken
    } else {														// add by ken
        return separator - pattern;									// add by ken
    }																// add by ken
}																	// add by ken



/**
 * Cycle all patterns and search matching pattern. Execute command callback.
 * @param context
 * @result TRUE if context->paramlist is filled with correct values
 */
static bool_t findCommand(scpi_t * context, const char * cmdline_ptr, size_t cmdline_len, size_t cmd_len) {
    int32_t i;
    const scpi_command_t * cmd;
    for (i = 0; context->cmdlist[i].pattern != NULL; i++) {						
        cmd = &context->cmdlist[i];		
        
		if (cmdMatch(cmd->pattern/*+j*/, cmdline_ptr, cmd_len)) {
			if (/*context->cmdLevel == 0 && */cmd->pattern[0] != '*')		// add by ken
			{														// add by ken
				int len = strlen(cmd->pattern);						// add by ken    
				for(context->cmdLevel = 0,i = 0 ; i < len ; i++)	// add by ken
				{													// add by ken
					if (cmd->pattern[i] == ':')						// add by ken	 find pattern path with :
						context->cmdLevel++;						// add by ken	 ppath`
				}													// add by ken
			}														// add by ken
            context->paramlist.cmd = cmd;							//ثeѨ쪺RO
            context->paramlist.parameters = cmdline_ptr + cmd_len;	//ثeROѼư_l}
            context->paramlist.length = cmdline_len - cmd_len;		//ثeROѼƪ
            return TRUE;
        }
    }
    return FALSE;
}

/**
 * Write data to SCPI output
 * @param context
 * @param data
 * @param len - lenght of data to be written
 * @return number of bytes written
 */
static size_t writeData(scpi_t * context, const char * data, size_t len) {
    return context->interface->write(context, data, len);
}

/**
 * Flush data to SCPI output
 * @param context
 * @return
 */
static int flushData(scpi_t * context) {
    if (context && context->interface && context->interface->flush) {
        return context->interface->flush(context);
    } else {
        return SCPI_RES_OK;
    }
}



/**
 * Zapis nove radky na SCPI vystup
 * @param context
 * @return pocet zapsanych znaku
 */
static size_t writeNewLine(scpi_t * context) {
    if (context->output_count > 0) {
        size_t len;
        len = writeData(context, "\r\n", 2);
        flushData(context);
        return len;
    } else {
        return 0;
    }
}


/**
 * Process command
 * @param context
 */
static void processCommand(scpi_t * context) {
    const scpi_command_t * cmd = context->paramlist.cmd;

    context->cmd_error = FALSE;
    context->output_count = 0;
    context->input_count = 0;

    SCPI_DEBUG_COMMAND(context);
    /* if callback exists - call command callback */
    if (cmd->callback != NULL) {
        if ((cmd->callback(context) != SCPI_RES_OK) && !context->cmd_error) {
            SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
        }
    }

    /* conditionaly write new line */
   	writeNewLine(context);

    /* skip all whitespaces */
    paramSkipWhitespace(context);

    /* set error if command callback did not read all parameters */
    if (context->paramlist.length != 0 && !context->cmd_error) {
        SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
    }
}








/**
 * Interface to the application. Adds data to system buffer and try to search
 * command line termination. If the termination is found or if len=0, command
 * parser is called.
 * 
 * @param context
 * @param data - data to process
 * @param len - length of data
 * @return 
 */
int SCPI_Input(scpi_t * context, const char * data, size_t len) {
    int result = 0;
    const char * cmd_term;
    if (len == 0) {
        context->buffer.data[context->buffer.position] = 0;
        result = SCPI_Parse(context, context->buffer.data, context->buffer.position);
        context->buffer.position = 0;
    } else {
        size_t buffer_free;
        int ws;
        buffer_free = context->buffer.length - context->buffer.position;
        if (len > (buffer_free - 1)) {
            return -1;
        }
        memcpy(&context->buffer.data[context->buffer.position], data, len);
        context->buffer.position += len;
        context->buffer.data[context->buffer.position] = 0;

        ws = skipWhitespace(context->buffer.data, context->buffer.position);  //oRO_l}
        cmd_term = cmdlineTerminator(context->buffer.data + ws, context->buffer.position - ws);	//oRO(CRLFe)m
        if (cmd_term != NULL) {
            int curr_len = cmd_term - context->buffer.data; //oRO
            result = SCPI_Parse(context, context->buffer.data + ws, curr_len - ws);
            memmove(context->buffer.data, cmd_term, context->buffer.position - curr_len);
            context->buffer.position -= curr_len;
        }
    }

    return result;
}





/**
 * Parse one command line
 * @param context
 * @param data - complete command line
 * @param len - command line length
 * @return 1 if the last evaluated command was found
 */
int SCPI_Parse(scpi_t * context, const char * data, size_t len) {
  int result = 0;
	size_t backupFlag = 0;
  const char * cmdline_end = data + len; //RO
  const char * cmdline_ptr = data;	   //ROY
	const char * cmdline_end1,* cmdline_ptr1,* cmdline_end2 = NULL,* cmdline_ptr2 = NULL;  											// add by ken
  size_t cmd_len;
  size_t cmdline_len;
	int i = 0,j = 0;																	// add by ken
  if (context == NULL) {
        return -1;
  }

	cmd_len = cmdlineSeparatorPos(cmdline_ptr, cmdline_end - cmdline_ptr);// ";\r\n"  add by ken
	cmdline_end1	=  (const char *)context->command+cmd_len; 							// add by ken  wqC@ROYP
	cmdline_ptr1	=  (const char *)context->command;									    // add by ken
	context->cmdLevel = 0;																                // add by ken
//	memset((void *)context->command ,0,256);											      // add by ken  oB|
  while (cmdline_ptr < cmdline_end) 
	{	// ઴MROC
    result = 0;
		if (*cmdline_ptr != '*')														// add by ken  
		{																				  // add by ken
			if (*cmdline_ptr == ':')		  					// add by ken ԶiӪROĤ@ӭY: pathY}l
			{								  											// add by ken
				cmdline_ptr++;				  							// add by ken
				context->cmdLevel = 0; // root				// add by ken
				i = 0;																// add by ken
				cmd_len--;														// add by ken
			}								  											// add by ken
			cmdline_end1	=  (const char *)context->command+ i + cmd_len; 			// add by ken
			cmdline_ptr1	=  (const char *)context->command;							      // add by ken
			memcpy((void *)(cmdline_ptr1 + i),(void *)cmdline_ptr ,cmd_len);		// add by ken  ᭱O몺ثepath᭱
			context->command[i+cmd_len]= 0;	  																	// add by ken  
		}																				// add by ken
		else																		// add by ken
		{																				// add by ken
			backupFlag = 1;
			cmdline_ptr2 = cmdline_ptr1;												// add by ken  Ƥ
			cmdline_end2 = cmdline_end1;												// add by ken
			cmdline_ptr1 = cmdline_ptr;													// add by ken  *}Y path
			cmdline_end1 = cmdline_end;													// add by ken
		}																				// add by ken
		cmd_len = cmdTerminatorPos(cmdline_ptr1, cmdline_end1 - cmdline_ptr1);			  // "; \r\n\t" edit by ken  p줣tѼƪ
		cmdline_len = cmdlineSeparatorPos(cmdline_ptr1, cmdline_end1 - cmdline_ptr1);	// ";\r\n"	  edit by ken  pU@
		if (cmdline_ptr[cmdline_len] == ';')
			context->semicolon_num = 1;
    if (cmd_len > 0) 
		{
//		context->cmdLevel = 0;	//add by ken 1.37
      if(findCommand(context, cmdline_ptr1, cmdline_len, cmd_len)) 
			{	  			// edit by ken
        processCommand(context);  // RO
			  context->semicolon_num = 0;
        result = 1;
      } 
			else 
			{
         SCPI_ErrorPush(context, SCPI_ERROR_UNDEFINED_HEADER);
      }
    }
    cmdline_ptr = cmdlineNext(cmdline_ptr, cmdline_end - cmdline_ptr);// ROCвU@ROY(:)
		cmd_len = cmdlineSeparatorPos(cmdline_ptr, cmdline_end - cmdline_ptr);			// ";\r\n" add by ken  pU@
		if (backupFlag == 1)		   													  //
		{																				              //
			backupFlag = 0;																      //
			cmdline_ptr1 = cmdline_ptr2;												// add by ken  Ƥ
			cmdline_end1 = cmdline_end2;												// add by ken
		}
		if (bracket == 1)			  													// EX: PROGram 1;PROGram?  = PROGRAM:NUM 1;NUM?
		{																				// EX: PROGRAM:STEP 1;STEP?	= PROGRAM:STEP:NUM 1;NUM?
			bracket = 0;
			for(i = 0,j = 0; i < (cmdline_end1 - cmdline_ptr1) ; i++)
			{
				if (context->command[i] == ':')
				{
					j++;
				}
			}
//			if (context->cmdLevel - j == 1)	//  1.43 mark
//				context->cmdLevel--;
		}
		for (i = 0, j = 0 ; j < context->cmdLevel && cmd_len > 0 && i < (cmdline_end1 - cmdline_ptr1) ; i++)					// add by ken
		{																				// add by ken
			if (context->command[i] == ':' || context->command[i] == ' ' || context->command[i] == '?')	// '?',' ' 令 : 											// add by ken  Dثepath :}
			{
				context->command[i] = ':'; // replace   ex:> PROG:STEP 1 => PROG:STEP: 
				j++; 																	// add by ken
			}
		}																				  // add by ken
  }
  return result;
}

/**
 * Count white spaces from the beggining
 * @param cmd - command
 * @param len - max search length
 * @return number of white spaces
 */
size_t skipWhitespace(const char * cmd, size_t len) {
    size_t i;
    for (i = 0; i < len; i++) {
        if (!isspace((unsigned char)cmd[i])) {
            return i;
        }
    }
    return len;
}

/**
 * Find command line terminator
 * @param cmd - input command
 * @param len - max search length
 * @return pointer to command line terminator or NULL
 */
const char * cmdlineTerminator(const char * cmd, size_t len) {
    return strnpbrk(cmd, len, "\r\n");
}

/**
 * Find command line separator position
 * @param cmd - input command
 * @param len - max search length
 * @return position of line separator or len
 */
size_t cmdlineSeparatorPos(const char * cmd, size_t len) {
    const char * separator = cmdlineSeparator(cmd, len);
    if (separator == NULL) {
        return len;
    } else {
        return separator - cmd;
    }
}
/**
 * Find command termination character
 * @param cmd - input command
 * @param len - max search length
 * @return position of terminator or len
 */
size_t cmdTerminatorPos(const char * cmd, size_t len) {
    const char * terminator = strnpbrk(cmd, len, "; \r\n\t");
    if (terminator == NULL) {
        return len;
    } else {
        return terminator - cmd;
    }
}

/**
 * Match string constant to one of special number values
 * @param specs specifications of special numbers (patterns)
 * @param str string to be recognised
 * @param len length of string
 * @param value resultin value
 * @return TRUE if str matches one of specs patterns
 */
static bool_t translateSpecialNumber(const scpi_special_number_def_t * specs, const char * str, size_t len, scpi_number_t * value) {
    int i;

    value->value = 0.0;
    value->unit = SCPI_UNIT_NONE;
    value->type = SCPI_NUM_NUMBER;

    if (specs == NULL) {
        return FALSE;
    }

    for (i = 0; specs[i].name != NULL; i++) {
        if (matchPattern(specs[i].name, strlen(specs[i].name), str, len)) {
            value->type = specs[i].type;
            return TRUE;
        }
    }

    return FALSE;
}

/**
 * Convert string describing unit to its representation
 * @param units units patterns
 * @param unit text representation of unknown unit
 * @param len length of text representation
 * @return pointer of related unit definition or NULL
 */
static const scpi_unit_def_t * translateUnit(const scpi_unit_def_t * units, const char * unit, size_t len) {
    int i;
    
    if (units == NULL) {
        return NULL;
    }
    
    for (i = 0; units[i].name != NULL; i++) {
        if (compareStr(unit, len, units[i].name, strlen(units[i].name))) {
            return &units[i];
        }
    }

    return NULL;
}


/**
 * Transform number to base units
 * @param context
 * @param unit text representation of unit
 * @param len length of text representation
 * @param value preparsed numeric value
 * @return TRUE if value parameter was converted to base units
 */
static bool_t transformNumber(scpi_t * context, const char * unit, size_t len, scpi_number_t * value) {
    size_t s;
    const scpi_unit_def_t * unitDef;
    s = skipWhitespace(unit, len);

    if (s == len) {
        value->unit = SCPI_UNIT_NONE;
        return TRUE;
    }

    unitDef = translateUnit(context->units, unit + s, len - s);

    if (unitDef == NULL) {
        SCPI_ErrorPush(context, SCPI_ERROR_INVALID_SUFFIX);
        return FALSE;
    }

    value->value *= unitDef->mult;
    value->unit = unitDef->unit;

    return TRUE;
}


/**
 * Parse parameter as number, number with unit or special value (min, max, default, ...)
 * @param context
 * @param value return value
 * @param mandatory if the parameter is mandatory
 * @return 
 */
bool_t SCPI_ParamNumber(scpi_t * context, scpi_number_t * value, bool_t mandatory) {
    bool_t result;
    const char * param;
    size_t len;
    size_t numlen;

    /* read parameter and shift to the next one */
    result = SCPI_ParamString(context, &param, &len, mandatory);
    /* value not initializes */
    if (!value) {
        return FALSE;
    }
    value->type = SCPI_NUM_DEF;
    /* if parameter was not found, return TRUE or FALSE according
     * to fact that parameter was mandatory or not */
    if (!result) {
        return mandatory ? FALSE : TRUE;
    }
    /* convert string to special number type */
    if (translateSpecialNumber(context->special_numbers, param, len, value)) {
        /* found special type */
		switch(value->type)
		{
			case SCPI_PARM_FRONT:
			case SCPI_PARM_MON5V:
			case SCPI_PARM_PROG5V5K:
			case SCPI_PARM_STATIC:
			case SCPI_PARM_MANUAL:
			
			case SCPI_PARM_OFF:	
			case SCPI_PARM_USB:
			case SCPI_PARM_NONE:
			case SCPI_PARM_9600:
			case SCPI_PARM_NONE8:
			case SCPI_PARM_MASTER:
			case SCPI_PARM_CC:
				value->value = 0;
				break;
			case SCPI_PARM_EXTV:
			case SCPI_PARM_MON10V:
			case SCPI_PARM_PROG10V10K:
			case SCPI_PARM_ACT:
			case SCPI_PARM_DHCP:
			case SCPI_PARM_AUTO:
			case SCPI_PARM_LAST:
			case SCPI_PARM_GPIB:
			case SCPI_PARM_ON:
			case SCPI_PARM_AMODE:
			case SCPI_PARM_19200:
			case SCPI_PARM_EVEN8:
			case SCPI_PARM_SLAVEA:
			case SCPI_PARM_CV:
				value->value = 1;
				break;
			case SCPI_PARM_NAC:
			case SCPI_PARM_EXTR:
			case SCPI_PARM_USER:
			case SCPI_PARM_ETHERNET:
			case SCPI_PARM_BMODE:
			case SCPI_PARM_38400:
			case SCPI_PARM_ODD8:
			case SCPI_PARM_SLAVEB:
				value->value = 2;
				break;
			case SCPI_PARM_485:
			case SCPI_PARM_END:
			case SCPI_PARM_57600:
			case SCPI_PARM_EVEN7:
			case SCPI_PARM_SLAVEC:
				value->value = 3;
				break;
			case SCPI_PARM_232:
			case SCPI_PARM_ODD7:
				value->value = 4;
				break;
				
		}
        return TRUE;
    }
    /* convert text from double - no special type */
    numlen = strToDouble(param, &value->value);
    /* transform units of value */
    if (numlen <= len) {
        return transformNumber(context, param + numlen, len - numlen, value);
    }
    return FALSE;
}

/**
 * Write result delimiter to output
 * @param context
 * @return number of bytes written
 */
static size_t writeDelimiter(scpi_t * context) {
    if (context->output_count > 0) {
        return writeData(context, ", ", 2);
    } else {
        return 0;
    }
}



/**
 * Write double walue to the result
 * @param context
 * @param val
 * @return 
 */
size_t SCPI_ResultDouble(scpi_t * context, double val) {
    char buffer[32];
    size_t result = 0;
    size_t len = doubleToStr(val, buffer, sizeof (buffer));
    result += writeDelimiter(context);
    result += writeData(context, buffer, len);
    context->output_count++;
    return result;

}

/**
 * Parse double parameter
 * @param context
 * @param value
 * @param mandatory
 * @return 
 */
bool_t SCPI_ParamDouble(scpi_t * context, double * value, bool_t mandatory) {
    const char * param;
    size_t param_len;
    size_t num_len;

    if (!value) {
        return FALSE;
    }

    if (!SCPI_ParamString(context, &param, &param_len, mandatory)) {
        return FALSE;
    }

    num_len = strToDouble(param, value);

    if (num_len != param_len) {
        SCPI_ErrorPush(context, SCPI_ERROR_SUFFIX_NOT_ALLOWED);
        return FALSE;
    }

    return TRUE;
}


//IEEE488

/**
 * Update register value
 * @param context
 * @param name - register name
 */
static void regUpdate(scpi_t * context, scpi_reg_name_t name) {
    SCPI_RegSet(context, name, SCPI_RegGet(context, name));
}

/**
 * Update STB register according to value and its mask register
 * @param context
 * @param val value of register
 * @param mask name of mask register (enable register)
 * @param stbBits bits to clear or set in STB
 */
static void regUpdateSTB(scpi_t * context, scpi_reg_val_t val, scpi_reg_name_t mask, scpi_reg_val_t stbBits) {
    if (val & SCPI_RegGet(context, mask)) {
        SCPI_RegSetBits(context, SCPI_REG_STB, stbBits);
    } else {
        SCPI_RegClearBits(context, SCPI_REG_STB, stbBits);
    }
}

/**
 * Get register value
 * @param name - register name
 * @return register value
 */
scpi_reg_val_t SCPI_RegGet(scpi_t * context, scpi_reg_name_t name) {
    if ((name < SCPI_REG_COUNT) && (context->registers != NULL)) {
        return context->registers[name];
    } else {
        return 0;
    }
}

/**
 * Wrapper function to control interface from context
 * @param context
 * @param ctrl number of controll message
 * @param value value of related register
 */
static size_t writeControl(scpi_t * context, scpi_ctrl_name_t ctrl, scpi_reg_val_t val) {
    if (context && context->interface && context->interface->control) {
        return context->interface->control(context, ctrl, val);
    } else {
        return 0;
    }
}

/**
 * Set register value
 * @param name - register name
 * @param val - new value
 */
void SCPI_RegSet(scpi_t * context, scpi_reg_name_t name, scpi_reg_val_t val) {
    bool_t srq = FALSE;
    scpi_reg_val_t mask;

    if ((name >= SCPI_REG_COUNT) || (context->registers == NULL)) {
        return;
    }
    

    /* set register value */
    context->registers[name] = val;

    /** @TODO: remove recutsion */
    switch (name) {
        case SCPI_REG_STB:
            mask = SCPI_RegGet(context, SCPI_REG_SRE);
            mask &= ~STB_SRQ;
            if (val & mask) {
                val |= STB_SRQ;
                srq = TRUE;
            } else {
                val &= ~STB_SRQ;
            }
            break;
        case SCPI_REG_SRE:
            regUpdate(context, SCPI_REG_STB);
            break;
        case SCPI_REG_ESR:
            regUpdateSTB(context, val, SCPI_REG_ESE, STB_ESR);
            break;
        case SCPI_REG_ESE:
            regUpdate(context, SCPI_REG_ESR);
            break;
        case SCPI_REG_QUES:
            regUpdateSTB(context, val, SCPI_REG_QUESE, STB_QES);
            break;
        case SCPI_REG_QUESE:
            regUpdate(context, SCPI_REG_QUES);
            break;
        case SCPI_REG_OPER:
            regUpdateSTB(context, val, SCPI_REG_OPERE, STB_OPS);
            break;
        case SCPI_REG_OPERE:
            regUpdate(context, SCPI_REG_OPER);
            break;
            
            
        case SCPI_REG_COUNT:
            /* nothing to do */
            break;
    }
    /* set updated register value */
    context->registers[name] = val;

    if (srq) {
        writeControl(context, SCPI_CTRL_SRQ, SCPI_RegGet(context, SCPI_REG_STB));
    }
}

/**
 * Set register bits
 * @param name - register name
 * @param bits bit mask
 */
void SCPI_RegSetBits(scpi_t * context, scpi_reg_name_t name, scpi_reg_val_t bits) {
    SCPI_RegSet(context, name, SCPI_RegGet(context, name) | bits);
}

/**
 * Clear register bits
 * @param name - register name
 * @param bits bit mask
 */
void SCPI_RegClearBits(scpi_t * context, scpi_reg_name_t name, scpi_reg_val_t bits) {
    SCPI_RegSet(context, name, SCPI_RegGet(context, name) & ~bits);
}



/* program sub */


/**
 * Clear event register
 * @param context
 */
void SCPI_EventClear(scpi_t * context) {
    /* TODO */
    SCPI_RegSet(context, SCPI_REG_ESR, 0);
}

/*  CLR for AGILENT 603xA FAMILY
    only VSET 10
         VSET 1
         OUTP 0
         clear someerror


*/
scpi_result_t SCPI_CoreClr(scpi_t * context) {
//  SCPI_EventClear(context);
//  SCPI_ErrorClear(context);
//  SCPI_RegSet(context, SCPI_REG_OPER, 0);
//  SCPI_RegSet(context, SCPI_REG_QUES, 0);
//  VFDsign &= ~(sign_ERROR);
//  if (IS_MB_ERROR)	// M~ù
//  {
//    if (IS_BACKUP_SCREEN) //^_~ee
//    {
//      CLR_BACKUP_SCREEN;
//      memcpy((void *)(displayBuffer + 19),(void *)displayBufferTemp,29);
//      cursorPosition = cursorPositionTemp;
//      CLR_NUMBER;
//      softTimer[ERROR_MESSAGE_COUNT].flag = DISABLE;
//      faultStatus = 0;   //error AùѰ
//      CLR_MB_ERROR;
//    }
//  }
		master.vSet = 10;
		master.iSet = 1;
		verifyInput(VSET_CMD,master.vSet );
		verifyInput(ISET_CMD,master.iSet );
		onoffStatus = 0;
		verifyInput(OUTPUT_CMD,(float)onoffStatus );
//		clearOVPOCPOPPCVCCCCCV1();

  return SCPI_RES_OK;

}




/**
 * *CLS - This command clears all status data structures in a device. 
 *        For a device which minimally complies with SCPI. (SCPI std 4.1.3.2)
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreCls(scpi_t * context) {
  SCPI_EventClear(context);
  SCPI_ErrorClear(context);
  SCPI_RegSet(context, SCPI_REG_OPER, 0);
  SCPI_RegSet(context, SCPI_REG_QUES, 0);
  VFDsign &= ~(sign_ERROR);
  CLR_PARALLELMODE_SLAVE_ERROR_CONNECT;
  if (IS_SHOW_ENA && ENABLE_CPU_PIN == SET)
  {
    if (IS_SHOW_ENA)
    {
      CLR_SHOW_ENA;
      setVFDFlashOff(0x40, 48);	
    }		  
  }
  if (extShutOffLogic == 0) //off/low Logic
  {
    if (SHUTOFF_CPU_PIN != SET)
    {
      if (IS_SHOW_SO)
      {
        CLR_SHOW_SO;
        setVFDFlashOff(0x40, 48);
      }
    }
  }
  else
  {
    if (SHUTOFF_CPU_PIN == SET)
    {
      if (IS_SHOW_SO)
      {
        CLR_SHOW_SO;
        setVFDFlashOff(0x40, 48);
      }
    }
  }
  if (IS_MB_ERROR)	// M~ù
  {
    if (IS_BACKUP_SCREEN) //^_~ee
    {
      CLR_BACKUP_SCREEN;
      memcpy((void *)(displayBuffer + 19),(void *)displayBufferTemp,29);
      cursorPosition = cursorPositionTemp;
      CLR_NUMBER;
      softTimer[ERROR_MESSAGE_COUNT].flag = DISABLE;
      faultStatus = 0;   //error AùѰ
      CLR_MB_ERROR;
    }
  }
  if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)  // clear slave error state  slaveNumber > 0 means slave exist
  {
    masterState = BROADCAST;
    count300 = 0;
    rs485Temp.cmd = CMD_CLS;
    cmdexenum = MASTERQUERYCMD;
    slaveErrorState = NONE;
  }
  return SCPI_RES_OK;
}

/**
 * *ESE
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreEse(scpi_t * context) {
    int32_t new_ESE;
    if (SCPI_ParamInt(context, &new_ESE, TRUE)) {
        SCPI_RegSet(context, SCPI_REG_ESE, new_ESE);
    }
    return SCPI_RES_OK;
}

/**
 * *ESE?
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreEseQ(scpi_t * context) {
    SCPI_ResultInt(context, SCPI_RegGet(context, SCPI_REG_ESE));
    return SCPI_RES_OK;
}

/**
 * *ESR?
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreEsrQ(scpi_t * context) {
    SCPI_ResultInt(context, SCPI_RegGet(context, SCPI_REG_ESR));
    SCPI_RegSet(context, SCPI_REG_ESR, 0);
    return SCPI_RES_OK;
}

/**
 * *IDN?
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreIdnQ(scpi_t * context) {
//    SCPI_ResultString(context, SCPI_MANUFACTURE);
//    SCPI_ResultString(context, SCPI_DEV_NAME);		
//	SCPI_ResultString(context, (void *)serialNumber);
//    SCPI_ResultString(context, SCPI_DEV_VERSION);
	memset((void *)transBuffer,0,256);
	strcat((void *)transBuffer,(void *)manufacture);
	strcat((void *)transBuffer," ,");
	strcat((void *)transBuffer,(void *)model);
	strcat((void *)transBuffer," ,");
	strcat((void *)transBuffer,(void *)serialNumber);
	strcat((void *)transBuffer," ,");
 	strcat((void *)transBuffer,SCPI_DEV_VERSION);
	strcat((void *)transBuffer,"\r\n");
 	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    return SCPI_RES_OK;
}

scpi_result_t SCPI_VERSION(scpi_t * context) {
	memset((void *)transBuffer,0,256);
	strcat((void *)transBuffer,SCPI_DEV_VERSION);
	strcat((void *)transBuffer,"/");
	memcpy((void *)(transBuffer + strlen((void *)transBuffer)) , (void *)(measurementInf + 16) ,5);
	transBuffer[strlen((void *)transBuffer) + 5 + 1] = 0;
	strcat((void *)transBuffer,"/");
	memcpy((void *)(transBuffer + strlen((void *)transBuffer)) , (void *)(pfcInf + 16) ,5);
	transBuffer[strlen((void *)transBuffer) + 5 + 1] = 0;
	strcat((void *)transBuffer,"/");
	memcpy((void *)(transBuffer + strlen((void *)transBuffer)) , (void *)(gpibInf + 22) ,6);
	transBuffer[strlen((void *)transBuffer) + 6 + 1] = 0;
	strcat((void *)transBuffer,"\r\n");
 	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    return SCPI_RES_OK;
}
scpi_result_t SCPI_MODEL(scpi_t * context) {
    SCPI_ResultString(context, (void *)model);
    return SCPI_RES_OK;
}

/**
 * *OPC
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreOpc(scpi_t * context) {
    SCPI_RegSetBits(context, SCPI_REG_ESR, ESR_OPC);
    return SCPI_RES_OK;
}

/**
 * *OPC?
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreOpcQ(scpi_t * context) {
    /* Operation is always completed */
    SCPI_ResultInt(context, 1);
    return SCPI_RES_OK;
}

/**
 * *RST
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreRst(scpi_t * context) {
    if (context && context->interface && context->interface->reset) {
        return context->interface->reset(context);
    }
    return SCPI_RES_OK;
}

/**
 * *SRE
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreSre(scpi_t * context) {
    int32_t new_SRE;
    if (SCPI_ParamInt(context, &new_SRE, TRUE)) {
        SCPI_RegSet(context, SCPI_REG_SRE, new_SRE);
    }
    return SCPI_RES_OK;
}

/**
 * *SRE?
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreSreQ(scpi_t * context) {
    SCPI_ResultInt(context, SCPI_RegGet(context, SCPI_REG_SRE));
    return SCPI_RES_OK;
}

/**
 * *STB?
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreStbQ(scpi_t * context) {
    SCPI_ResultInt(context, SCPI_RegGet(context, SCPI_REG_STB));
    return SCPI_RES_OK;
}

/**
 * *TST?
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreTstQ(scpi_t * context) {
    int result = 0;
    if (context && context->interface && context->interface->test) {
        result = context->interface->test(context);
    }
    SCPI_ResultInt(context, result);
    return SCPI_RES_OK;
}

/**
 * *WAI
 * @param context
 * @return 
 */
scpi_result_t SCPI_CoreWai(scpi_t * context) {
    (void) context;
    /* NOP */
    return SCPI_RES_OK;
}








/**
 * Command stub function
 * @param context
 * @return 
 */
scpi_result_t SCPI_Stub(scpi_t * context) {
    (void) context;
    return SCPI_RES_OK;
}

/**
 * Query command stub function
 * @param context
 * @return 
 */



/**
 * SYSTem:ERRor[:NEXT]?
 * @param context
 * @return 
 */
scpi_result_t SCPI_SystemErrorNextQ(scpi_t * context) {
    int16_t err = SCPI_ErrorPop(context);

    SCPI_ResultInt(context, err);
	if (err == 0)
		VFDsign &= ~(sign_ERROR);
    SCPI_ResultText(context, SCPI_ErrorTranslate(err));

    return SCPI_RES_OK;
}

/**
 * SYSTem:ERRor:COUNt?
 * @param context
 * @return 
 */
scpi_result_t SCPI_SystemErrorCountQ(scpi_t * context) {
    SCPI_ResultInt(context, SCPI_ErrorCount(context));

    return SCPI_RES_OK;
}

/**
 * SYSTem:VERSion?
 * @param context
 * @return 
 */
//scpi_result_t SCPI_SystemVersionQ(scpi_t * context) {
//    SCPI_ResultString(context, SCPI_DEV_VERSION);
//    return SCPI_RES_OK;
//}



/**
 * STATus:QUEStionable[:EVENt]?
 * @param context
 * @return 
 */
//scpi_result_t SCPI_StatusQuestionableEventQ(scpi_t * context) {
    /* return value */
//    SCPI_ResultInt(context, SCPI_RegGet(context, SCPI_REG_QUES));

    /* clear register */
//    SCPI_RegSet(context, SCPI_REG_QUES, 0);

//    return SCPI_RES_OK;
//}

/**
 * STATus:QUEStionable:ENABle?
 * @param context
 * @return 
 */
//scpi_result_t SCPI_StatusQuestionableEnableQ(scpi_t * context) {
    /* return value */
//    SCPI_ResultInt(context, SCPI_RegGet(context, SCPI_REG_QUESE));

//    return SCPI_RES_OK;
//}

/**
 * STATus:QUEStionable:ENABle
 * @param context
 * @return 
 */
//scpi_result_t SCPI_StatusQuestionableEnable(scpi_t * context) {
//    int32_t new_QUESE;
//    if (SCPI_ParamInt(context, &new_QUESE, TRUE)) {
//        SCPI_RegSet(context, SCPI_REG_QUESE, new_QUESE);
//    }
//    return SCPI_RES_OK;
//}

/**
 * STATus:PRESet
 * @param context
 * @return 
 */
//scpi_result_t SCPI_StatusPreset(scpi_t * context) {
    /* clear STATUS:... */
//    SCPI_RegSet(context, SCPI_REG_QUES, 0);
//    return SCPI_RES_OK;
//}

/**
 * Parse string parameter
 * @param context
 * @param value
 * @param len
 * @param mandatory
 * @return 
 */
bool_t SCPI_ParamString(scpi_t * context, const char ** value, size_t * len, bool_t mandatory) {
    size_t length;

    if (!value || !len) {
        return FALSE;
    }

    if (!paramNext(context, mandatory)) {
        return FALSE;
    }

    if (locateStr(context->paramlist.parameters, context->paramlist.length, value, &length)) {	 // rs value צb length
        paramSkipBytes(context, length);  //U@Ѽ
        paramSkipWhitespace(context);
        if (len) {
            *len = length;
        }
        return TRUE;
    }

    return FALSE;
}



/**
 * Perform locateText automaton to search string pattern
 * @param nfa stores automaton state
 * @param c current char processed
 */
static bool_t locateTextAutomaton(locate_text_nfa * nfa, unsigned char c) {
    switch(nfa->state) {
        /* first state locating only white spaces */
        case STATE_FIRST_WHITESPACE:
            if(isspace(c)) {
                nfa->startIdx = nfa->stopIdx = nfa->i + 1;
            } else if (c == ',') {
                nfa->state = STATE_COMMA;
            } else if (c == '"') {
                nfa->startIdx = nfa->i + 1;
                nfa->state = STATE_TEXT_QUOTED;
            } else {
                nfa->startIdx = nfa->i;
                nfa->stopIdx = nfa->i + 1;
                nfa->state = STATE_TEXT;
            }
            break;
        /* state locating any text inside "" */
        case STATE_TEXT_QUOTED:
            if(c == '"') {
                nfa->state = STATE_LAST_WHITESPACE;
                nfa->stopIdx = nfa->i;
            }
            break;
        /* locate text ignoring quotes */
        case STATE_TEXT:
            if (c == ',') {
                nfa->state = STATE_COMMA;
            } else if (!isspace(c)) {
                nfa->stopIdx = nfa->i + 1;
            }
            break;
        /* locating text after last quote */
        case STATE_LAST_WHITESPACE:
            if (c == ',') {
                nfa->state = STATE_COMMA;
            } else if (!isspace(c)) {
                nfa->state = STATE_ERROR;
            }
            break;

        default:
            break;
    }

    /* if it is terminating state, break from for loop */
    if ((nfa->state == STATE_COMMA) || (nfa->state == STATE_ERROR)) {
        return FALSE;
    } else {
        return TRUE;
    }
}

/**
 * Test locate text state, if it is correct final state
 */
static bool_t isFinalState(locate_text_states state) {
    return (
        ((state) == STATE_COMMA)
        || ((state) == STATE_LAST_WHITESPACE)
        || ((state) == STATE_TEXT) ||
        ((state) == STATE_FIRST_WHITESPACE)
    );
}

/**
 * Locate text in string. Text is separated by two ""
 *   example: "text", next parameter
 *   regexp: ^[ \t\r\n]*"([^"]*)"[ \t\r\n]*,?
 *   regexp: ^[ \t\r\n]*([^,]*)[ \t\r\n]*,?
 * @param str1 string to be searched
 * @param len1 length of string
 * @param str2 result
 * @param len2 length of result
 * @return string str1 contains text and str2 was set
 */
bool_t locateText(const char * str1, size_t len1, const char ** str2, size_t * len2) {
    locate_text_nfa nfa;
    nfa.state = STATE_FIRST_WHITESPACE;
    nfa.startIdx = 0;
    nfa.stopIdx = 0;

    for (nfa.i = 0; nfa.i < len1; nfa.i++) {
        if(FALSE == locateTextAutomaton(&nfa, str1[nfa.i])) {
            break;
        }
    }

    if (isFinalState(nfa.state)) {

        if (str2) {
            *str2 = &str1[nfa.startIdx];
        }

        if (len2) {
            *len2 = nfa.stopIdx - nfa.startIdx;
        }
        return TRUE;
    }
    return FALSE;
}




/**
 * Parse text parameter (can be inside "")
 * @param context
 * @param value
 * @param len
 * @param mandatory
 * @return 
 */
bool_t SCPI_ParamText(scpi_t * context, const char ** value, size_t * len, bool_t mandatory) {
    size_t length;

    if (!value || !len) {
        return FALSE;
    }

    if (!paramNext(context, mandatory)) {
        return FALSE;
    }

    if (locateText(context->paramlist.parameters, context->paramlist.length, value, &length)) {
        paramSkipBytes(context, length);
        if (len) {
            *len = length;
        }
        return TRUE;
    }

    return FALSE;
}





/**
 * Find the first occurrence in str of a character in set.
 * @param str
 * @param size
 * @param set
 * @return 
 */
char * strnpbrk(const char *str, size_t size, const char *set) {
    const char *scanp;
    long c, sc;
    const char * strend = str + size;

    while ((strend != str) && ((c = *str++) != 0)) {
        for (scanp = set; (sc = *scanp++) != '\0';)
            if (sc == c)
                return ((char *) (str - 1));
    }
    return (NULL);
}


/**
 * Find pattern separator position
 * @param pattern
 * @param len - max search length
 * @return position of separator or len
 */
size_t patternSeparatorPos(const char * pattern, size_t len) {

    char * separator = strnpbrk(pattern, len, "?:[]");
    if (separator == NULL) {
        return len;
    } else {
        return separator - pattern;
    }
}

/**
 * Find command separator position
 * @param cmd - input command
 * @param len - max search length
 * @return position of separator or len
 */
size_t cmdSeparatorPos(const char * cmd, size_t len) {
    char * separator = strnpbrk(cmd, len, ":?");
    size_t result;
    if (separator == NULL) {
        result = len;
    } else {
        result = separator - cmd;
    }

    return result;
}



/**
 * Find command line separator
 * @param cmd - input command
 * @param len - max search length
 * @return pointer to line separator or NULL
 */
const char * cmdlineSeparator(const char * cmd, size_t len) {
    return strnpbrk(cmd, len, ";\r\n");
}




/**
 * Compare pattern and command
 * @param pattern
 * @param cmd - command
 * @param len - max search length
 * @return TRUE if pattern matches, FALSE otherwise
 */
bool_t cmdMatch(const char * pattern, const char * cmd, size_t len) {
    int result = FALSE;
	const char * pattern_ptr = pattern;
    int pattern_len = strlen(pattern); //SCPI_strnlen(pattern, len);  edit by ken
    const char * pattern_end = pattern + pattern_len;

    const char * cmd_ptr = cmd;
    size_t cmd_len = SCPI_strnlen(cmd, len);
    const char * cmd_end = cmd + cmd_len;

    while (1) {
        int pattern_sep_pos = patternSeparatorPos(pattern_ptr, pattern_end - pattern_ptr);	//	"?:[]"
        int cmd_sep_pos = cmdSeparatorPos(cmd_ptr, cmd_end - cmd_ptr);						//  ":?"   

        if (matchPattern(pattern_ptr, pattern_sep_pos, cmd_ptr, cmd_sep_pos)) {
            pattern_ptr = pattern_ptr + pattern_sep_pos;
            cmd_ptr = cmd_ptr + cmd_sep_pos;
            result = TRUE;
			if (pattern_ptr[0]	== '[' )  							  // [:xxx] eii add by ken
			{														  // add
				bracket = 1;											// has A
				pattern_ptr = pattern_ptr + 1;						  // add by ken
				if (cmd_ptr == cmd_end || cmd_ptr[0] == '?')		  // add by ken
				 	pattern_ptr = strnpbrk(pattern_ptr, pattern_end - pattern_ptr, "]") + 1;// add by ken
			}														  // add by ken
			else if	 (pattern_ptr[0]	== ']')						  // add by ken
			{														  // add by ken
				pattern_ptr = pattern_ptr + 1;						  // add by ken
			}												          // add by ken
			/* command is complete */
            if ((pattern_ptr == pattern_end) && (cmd_ptr >= cmd_end)) {
                break;
            }

            /* pattern complete, but command not */
            if ((pattern_ptr == pattern_end) && (cmd_ptr < cmd_end)) {
                result = FALSE;
                break;
            }

            /* command complete, but pattern not */
            if (cmd_ptr >= cmd_end) {
                result = FALSE;
                break;
            }

            /* both command and patter contains command separator at this position */
            if ((pattern_ptr[0] == cmd_ptr[0]) && ((pattern_ptr[0] == ':') || (pattern_ptr[0] == '?'))) {	 // edit by ken
                pattern_ptr = pattern_ptr + 1;																 // edit
                cmd_ptr = cmd_ptr + 1;																		 // edit
             } 
			 else {																						 //edit
       		   	result = FALSE;
     		     break;
            }																								 //edit
        } else {

            result = FALSE;
            break;
        }
    }

    return result;
}

/**
 * Find next part of command
 * @param cmd - input command
 * @param len - max search length
 * @return Pointer to next part of command
 */
const char * cmdlineNext(const char * cmd, size_t len) {
    const char * separator = cmdlineSeparator(cmd, len);
    if (separator == NULL) {
        return cmd + len;
    } else {
        return separator + 1;
    }
}


/**
 * Skip num bytes from the begginig of parameters
 * @param context
 * @param num
 */
void paramSkipBytes(scpi_t * context, size_t num) {
    if (context->paramlist.length < num) {
        num = context->paramlist.length;
    }
    context->paramlist.parameters += num;
    context->paramlist.length -= num;
}

/**
 * Skip white spaces from the beggining of parameters
 * @param context
 */
void paramSkipWhitespace(scpi_t * context) {
    size_t ws = skipWhitespace(context->paramlist.parameters, context->paramlist.length);
    paramSkipBytes(context, ws);
}

/**
 * Find next parameter
 * @param context
 * @param mandatory
 * @return 
 */
bool_t paramNext(scpi_t * context, bool_t mandatory) {
    paramSkipWhitespace(context);
    if (context->paramlist.length == 0) {
        if (mandatory) {
            SCPI_ErrorPush(context, SCPI_ERROR_MISSING_PARAMETER);
        }
        return FALSE;
    }
    if (context->input_count != 0) {
        if (context->paramlist.parameters[0] == ',') {
            paramSkipBytes(context, 1);
            paramSkipWhitespace(context);
        } else {
            SCPI_ErrorPush(context, SCPI_ERROR_INVALID_SEPARATOR);
            return FALSE;
        }
    }
    context->input_count++;
    return TRUE;
}

/**
 * Find next parameter IP
 * @param context
 * @param mandatory
 * @return 
 */
bool_t paramNextIP(scpi_t * context, bool_t mandatory) {
    paramSkipWhitespace(context);
    if (context->paramlist.length == 0) {
        if (mandatory) {
            SCPI_ErrorPush(context, SCPI_ERROR_MISSING_PARAMETER);
        }
        return FALSE;
    }
    if (context->input_count != 0) {
        if (context->paramlist.parameters[0] == ',') {
            paramSkipBytes(context, 1);
            paramSkipWhitespace(context);
        } else {
            SCPI_ErrorPush(context, SCPI_ERROR_INVALID_SEPARATOR);
            return FALSE;
        }
    }
    context->input_count++;
    return TRUE;
}




size_t SCPI_Write(scpi_t * context, const char * data, size_t len) {
    (void) context;
	scpiuartTransmit(witchCOM, (void *)data, strlen((void *)data));
    return fwrite(data, 1, len, stdout);
}

scpi_result_t SCPI_Flush(scpi_t * context) {    
    return SCPI_RES_OK;
}

int SCPI_Error(scpi_t * context, int_fast16_t err) {
    (void) context;
	VFDsign |= (sign_ERROR);
	beep(1); // long beep error message not return and modify with beep tone
    return 0;
}

scpi_result_t SCPI_Control(scpi_t * context, scpi_ctrl_name_t ctrl, scpi_reg_val_t val) {
    if (SCPI_CTRL_SRQ == ctrl) {
       // fprintf(stderr, "**SRQ: 0x%X (%d)\r\n", val, val);
		sprintf((void *)(transBuffer),"**SRQ: 0x%X (%d)\r\n", val, val);
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));

    } else {
      //  fprintf(stderr, "**CTRL %02x: 0x%X (%d)\r\n", ctrl, val, val);
		sprintf((void *)(transBuffer),"**CTRL %02x: 0x%X (%d)\r\n", ctrl, val, val);
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));

    }
    return SCPI_RES_OK;
}

scpi_result_t SCPI_Test(scpi_t * context) {
	sprintf((void *)(transBuffer),"**Test\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    return SCPI_RES_OK;
}
void checkPowerOnState(void);
scpi_result_t SCPI_Reset(scpi_t * context) {
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)  // clear slave error state  slaveNumber > 0 means slave exist
	{
	   	masterState = BROADCAST;
   		rs485Temp.cmd = CMD_RST;
	    cmdexenum = MASTERQUERYCMD;
		  processCmd(cmdexenum);
    }
	  if (softTimer[SCPI_RESET_COUNT].flag == DISABLE)
		{
			softTimer[SCPI_RESET_COUNT].flag = ENABLE;
			softTimer[SCPI_RESET_COUNT].count = softTimer[MAIN_COUNT].count;
	    SET_SCPI_RESET;
		}
		
//	softwareReset();
//	actualState = D_NORMAL;
    return SCPI_RES_OK;
}



/* ERROR */


struct error_reg {
    int16_t from;
    int16_t to;
    scpi_reg_val_t bit;
};

#define ERROR_DEFS_N	8

static const struct error_reg errs[ERROR_DEFS_N] = {
    {-100, -199, ESR_CER}, /* Command error (e.g. syntax error) ch 21.8.9    */
    {-200, -299, ESR_EER}, /* Execution Error (e.g. range error) ch 21.8.10  */
    {-300, -399, ESR_DER}, /* Device specific error -300, -399 ch 21.8.11    */
    {-400, -499, ESR_QER}, /* Query error -400, -499 ch 21.8.12              */
    {-500, -599, ESR_PON}, /* Power on event -500, -599 ch 21.8.13           */
    {-600, -699, ESR_URQ}, /* User Request Event -600, -699 ch 21.8.14       */
    {-700, -799, ESR_REQ}, /* Request Control Event -700, -799 ch 21.8.15    */
    {-800, -899, ESR_OPC}, /* Operation Complete Event -800, -899 ch 21.8.16 */
};


/**
 * Translate error number to string
 * @param err - error number
 * @return Error string representation
 */
const char * SCPI_ErrorTranslate(int16_t err) {
    switch (err) {
        case 0: return "No error";
        case SCPI_ERROR_SYNTAX: return "Syntax error";
        case SCPI_ERROR_INVALID_SEPARATOR: return "Invalid separator";
        case SCPI_ERROR_UNDEFINED_HEADER: return "Undefined header";
        case SCPI_ERROR_PARAMETER_NOT_ALLOWED: return "Parameter not allowed";
        case SCPI_ERROR_MISSING_PARAMETER: return "Missing parameter";
        case SCPI_ERROR_INVALID_SUFFIX: return "Invalid suffix";
        case SCPI_ERROR_SUFFIX_NOT_ALLOWED: return "Suffix not allowed";
        default: return "Unknown error";
    }
}

/**
 * Return number of errors/events in the queue
 * @param context
 * @return 
 */
int32_t SCPI_ErrorCount(scpi_t * context) {
    int16_t result = 0;

    /*
     * // FreeRTOS
     * result = uxQueueMessagesWaiting((xQueueHandle)context->error_queue);
     */

    /* basic FIFO */
    fifo_count((fifo_t *)context->error_queue, &result);

    return result;
}



static void SCPI_ErrorAddInternal(scpi_t * context, int16_t err) {
    /*
     * // FreeRTOS
     * xQueueSend((xQueueHandle)context->error_queue, &err, 0);
     */

    /* basic FIFO */
    fifo_add((fifo_t *)context->error_queue, err);
}




/**
 * Push error to queue
 * @param context - scpi context
 * @param err - error number
 */
void SCPI_ErrorPush(scpi_t * context, int16_t err) {

    int i;

    SCPI_ErrorAddInternal(context, err);

    for(i = 0; i < ERROR_DEFS_N; i++) {
        if ((err <= errs[i].from) && (err >= errs[i].to)) {
            SCPI_RegSetBits(context, SCPI_REG_ESR, errs[i].bit);
        }
    }

    if (context) {
        if (context->interface && context->interface->error) {
            context->interface->error(context, err);
        }

        context->cmd_error = TRUE;
    }
}

/**
 * Pop error from queue
 * @param context - scpi context
 * @return error number
 */
int16_t SCPI_ErrorPop(scpi_t * context) {
    int16_t result = 0;

    /*
     * // FreeRTOS
     * if (pdFALSE == xQueueReceive((xQueueHandle)context->error_queue, &result, 0)) {
     *   result = 0;
     * }
     */

    /* basic FIFO */
    fifo_remove((fifo_t *)context->error_queue, &result);

    return result;
}

/**
 * Clear error queue
 * @param context - scpi context
 */
void SCPI_ErrorClear(scpi_t * context) {
    /*
     * // FreeRTOS
     * xQueueReset((xQueueHandle)context->error_queue);
     */

    /* basic FIFO */
    fifo_clear((fifo_t *)context->error_queue);
}


void fifo_init(fifo_t * fifo) {
    fifo->wr = 0;
    fifo->rd = 0;
    fifo->size = FIFO_SIZE;
}

void fifo_clear(fifo_t * fifo) {
    fifo->wr = 0;
    fifo->rd = 0;
}

bool_t fifo_add(fifo_t * fifo, int16_t value) {
    /* FIFO full? */
    if (fifo->wr == ((fifo->rd + fifo->size) % (fifo->size + 1))) {
        fifo_remove(fifo, NULL);
    }
    fifo->data[fifo->wr] = value;
    fifo->wr = (fifo->wr + 1) % (fifo->size + 1); 
    return TRUE;
}

bool_t fifo_remove(fifo_t * fifo, int16_t * value) {
    /* FIFO empty? */
    if (fifo->wr == fifo->rd) {
        return FALSE;
    }

    if(value) {
        *value = fifo->data[fifo->rd];
    }
    fifo->rd = (fifo->rd + 1) % (fifo->size + 1);

    return TRUE;
}

bool_t fifo_count(fifo_t * fifo, int16_t * value) {
    *value = fifo->wr - fifo->rd;
    if (*value < 0) {
        *value += (fifo->size + 1);
    }
    return TRUE;
}

/**
 * Convert special number type to its string representation
 * @param specs specifications of special numbers (patterns)
 * @param type type of special number
 * @return String representing special number or NULL
 */
static const char * translateSpecialNumberInverse(const scpi_special_number_def_t * specs, scpi_special_number_t type) {
    int i;

    if (specs == NULL) {
        return NULL;
    }
    
    for (i = 0; specs[i].name != NULL; i++) {
        if (specs[i].type == type) {
            return specs[i].name;
        }
    }

    return NULL;
}

/**
 * Convert unit definition to string
 * @param units units definitions (patterns)
 * @param unit type of unit
 * @return string representation of unit
 */
static const char * translateUnitInverse(const scpi_unit_def_t * units, const scpi_unit_t unit) {
    int i;
    
    if (units == NULL) {
        return NULL;
    }
    
    for (i = 0; units[i].name != NULL; i++) {
        if ((units[i].unit == unit) && (units[i].mult == 1)) {
            return units[i].name;
        }
    }

    return NULL;
}

/**
 * Parse integer parameter
 * @param context
 * @param value
 * @param mandatory
 * @return 
 */					   
bool_t SCPI_ParamAscii(scpi_t * context, uint8_t * value, bool_t mandatory) {
    const char * param;
    size_t param_len;
    if (!value) {
        return FALSE;
    }
    if (!SCPI_ParamText(context, &param, &param_len, mandatory)) {  //I ѼƬOrꪬp
        return FALSE;
    }
	memcpy(value,param,param_len);
    return TRUE;
}



/**
 * Convert scpi_number_t to string
 * @param context
 * @param value number value
 * @param str target string
 * @param len max length of string
 * @return number of chars written to string
 */
size_t SCPI_NumberToStr(scpi_t * context, scpi_number_t * value, char * str, size_t len) {
    const char * type;
    const char * unit;
    size_t result;

    if (!value || !str) {
        return 0;
    }

    type = translateSpecialNumberInverse(context->special_numbers, value->type);

    if (type) {
        strncpy(str, type, len);
        return min(strlen(type), len);
    }

    result = doubleToStr(value->value, str, len);

    unit = translateUnitInverse(context->units, value->unit);

    if (unit) {
        strncat(str, " ", len);
        strncat(str, unit, len);
        result += strlen(unit) + 1;
    }

    return result;
}

/**
 * Parse integer parameter
 * @param context
 * @param value
 * @param mandatory
 * @return 
 */
bool_t SCPI_ParamInt(scpi_t * context, int32_t * value, bool_t mandatory) {
    const char * param;
    size_t param_len;
    size_t num_len;

    if (!value) {
        return FALSE;
    }

    if (!SCPI_ParamString(context, &param, &param_len, mandatory)) {  //I ѼƬOrꪬp
        return FALSE;
    }

    num_len = strToLong(param, value); // rs param

    if (num_len != param_len) {
        SCPI_ErrorPush(context, SCPI_ERROR_SUFFIX_NOT_ALLOWED);
        return FALSE;
    }

    return TRUE;
}





bool_t SCPI_Param(scpi_t * context, int32_t * value, bool_t mandatory) {
    const char * param;
    size_t param_len;
    size_t num_len;

    if (!value) {
        return FALSE;
    }

    if (!SCPI_ParamString(context, &param, &param_len, mandatory)) {  //I ѼƬOrꪬp
        return FALSE;
    }

    num_len = strToLong(param, value); // rs param

    if (num_len != param_len) {
        SCPI_ErrorPush(context, SCPI_ERROR_SUFFIX_NOT_ALLOWED);
        return FALSE;
    }

    return TRUE;
}


/**
 * Write integer value to the result
 * @param context
 * @param val
 * @return 
 */
size_t SCPI_ResultInt(scpi_t * context, int32_t val) {
    char buffer[12];
    size_t result = 0;
    size_t len = longToStr(val, buffer, sizeof (buffer));
    result += writeDelimiter(context);
    result += writeData(context, buffer, len);
    context->output_count++;
    return result;
}



/**
 * Write string withn " to the result
 * @param context
 * @param data
 * @return 
 */
size_t SCPI_ResultText(scpi_t * context, const char * data) {
    size_t result = 0;
    result += writeDelimiter(context);
    result += writeData(context, "\"", 1);
    result += writeData(context, data, strlen(data));
    result += writeData(context, "\"", 1);
    context->output_count++;
    return result;
}

/**
 * Write raw string result to the output
 * @param context
 * @param data
 * @return 
 */
size_t SCPI_ResultString(scpi_t * context, const char * data) {
    size_t len = strlen(data);
    size_t result = 0;
    result += writeDelimiter(context);
    result += writeData(context, data, len);
    context->output_count++;
    return result;
}

/**
 * Compare two strings with exact length
 * @param str1
 * @param len1
 * @param str2
 * @param len2
 * @return TRUE if len1==len2 and "len" characters of both strings are equal
 */
bool_t compareStr(const char * str1, size_t len1, const char * str2, size_t len2) {
    if (len1 != len2) {
        return FALSE;
    }

    if (SCPI_strncasecmp(str1, str2, len2) == 0) {
        return TRUE;
    }

    return FALSE;
}

/**
 * Converts double value to string
 * @param val   double value
 * @param str   converted textual representation
 * @param len   string buffer length
 * @return number of bytes written to str (without '\0')
 */
size_t doubleToStr(double val, char * str, size_t len) {
    return snprintf(str, len, "%lg", val);
}

/**
 * Converts string to signed 32bit integer representation
 * @param str   string value
 * @param val   32bit integer result
 * @return      number of bytes used in string
 */
size_t strToLong(const char * str, int32_t * val) {
    char * endptr;
	if (IP_Point == 1)
    	*val = strtol(str, &endptr, 10);  // H10iഫ kenken
	else
		*val = strtol(str, &endptr, 0);	  // H10iഫ I 0x H16iഫ
    return endptr - str;
}
/**
 * Converts string to double representation
 * @param str   string value
 * @param val   double result
 * @return      number of bytes used in string
 */
size_t strToDouble(const char * str, double * val) {
    char * endptr;
    *val = strtod(str, &endptr);
    return endptr - str;
}



/**
 * Perform locateStr automaton to search string pattern
 * @param nfa stores automaton state
 * @param c current char processed
 */
static bool_t locateStrAutomaton(locate_text_nfa * nfa, unsigned char c) {
    switch(nfa->state) {
        /* first state locating only white spaces */
        case STATE_FIRST_WHITESPACE:
            if(isspace(c)) {
                nfa->startIdx = nfa->stopIdx = nfa->i + 1;
            } else if (c == ',') {
                nfa->state = STATE_COMMA;
            } else {
                nfa->startIdx = nfa->i;
                nfa->stopIdx = nfa->i + 1;
                nfa->state = STATE_TEXT;
            }
            break;
        /* locate text ignoring quotes */
        case STATE_TEXT:
            if (c == ',') {
                nfa->state = STATE_COMMA;
            } else if (!isspace(c)) {
                nfa->stopIdx = nfa->i + 1;
            }
            break;

        default:
            break;            
    }

    /* if it is terminating state, break from for loop */
    if ((nfa->state == STATE_COMMA) || (nfa->state == STATE_ERROR)) {
        return FALSE;
    } else {
        return TRUE;
    }
}


/**
 * Locate string in string.
 *   regexp: ^[ \t\r\n]*([^,]*)[ \t\r\n]*,?
 * @param str1 string to be searched
 * @param len1 length of string
 * @param str2 result
 * @param len2 length of result
 * @return string str1 contains text and str2 was set
 */
bool_t locateStr(const char * str1, size_t len1, const char ** str2, size_t * len2) {
    locate_text_nfa nfa;
    nfa.state = STATE_FIRST_WHITESPACE;
    nfa.startIdx = 0;
    nfa.stopIdx = 0;
	

    for (nfa.i = 0; nfa.i < len1; nfa.i++) {
	    if (IP_Point == 1 && str1[nfa.i] == '.')  // F192.168.001.001 iJ
			*(char *)(str1 + nfa.i) = ',';		  // '.' e˦ ',' 
        if(FALSE == locateStrAutomaton(&nfa, str1[nfa.i])) {
            break;
        }
    }

    if (isFinalState(nfa.state)) {

        if (str2) {
            *str2 = &str1[nfa.startIdx];
        }

        if (len2) {
            *len2 = nfa.stopIdx - nfa.startIdx;
        }
        return TRUE;
    }
    return FALSE;
}

/**
 * Converts signed 32b integer value to string
 * @param val   integer value
 * @param str   converted textual representation
 * @param len   string buffer length
 * @return number of bytes written to str (without '\0')
 */
size_t longToStr(int32_t val, char * str, size_t len) {
    uint32_t x = 1000000000L;
    int_fast8_t digit;
    size_t pos = 0;

    if (val == 0) {
        if (pos < len) str[pos++] = '0';
    } else {
        if (val < 0) {
            val = -val;
            if (pos < len) str[pos++] = '-';
        }

        while ((val / x) == 0) {
            x /= 10;
        }

        do {
            digit = (uint8_t) (val / x);
            if (pos < len) str[pos++] = digit + '0';
            val -= digit * x;
            x /= 10;
        } while (x && (pos < len));
    }

    if (pos < len) str[pos] = 0;
    return pos;
}


/**
 * Match pattern and str. Pattern is in format UPPERCASElowercase
 * @param pattern
 * @param pattern_len
 * @param str
 * @param str_len
 * @return 
 */
bool_t matchPattern(const char * pattern, size_t pattern_len, const char * str, size_t str_len) {
    int pattern_sep_pos_short = patternSeparatorShortPos(pattern, pattern_len);
    return compareStr(pattern, pattern_len, str, str_len) ||
            compareStr(pattern, pattern_sep_pos_short, str, str_len);
}

/**
 * Pattern is composed from upper case an lower case letters. This function
 * search the first lowercase letter
 * @param pattern
 * @param len - max search length
 * @return position of separator or len
 */
size_t patternSeparatorShortPos(const char * pattern, size_t len) {
    size_t i;
    for (i = 0; (i < len) && pattern[i]; i++) {
        if (islower((unsigned char)pattern[i])) {
            return i;
        }
    }
    return i;
}

void SCPI_ErrorInit(scpi_t * context) {
    /*
     * // FreeRTOS
     * context->error_queue = (scpi_error_queue_t)xQueueCreate(100, sizeof(int16_t));
     */

    /* basic FIFO */
    context->error_queue = (scpi_error_queue_t)&local_error_queue;
    fifo_init((fifo_t *)context->error_queue);
}


size_t BSD_strnlen(const char *s, size_t maxlen)
{
	size_t len;
	
	for (len = 0; len < maxlen; len++, s++) {
		if (!*s)
			break;
	}
	return (len);
}


scpi_result_t SCPI_RECALL_memory(scpi_t * context)
{
	int32_t param;
    // read first parameter if present
	if (!SCPI_ParamInt(context, &param, TRUE)) {
		return SCPI_RES_ERR;
	}
	else
	{
		if (param >= 0 && param < 10)
		{
			recall((uint8_t)param);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
	
}


scpi_result_t SCPI_SAVE_memory(scpi_t * context)
{
	int32_t param;
	if (!SCPI_ParamInt(context, &param, TRUE)) {
		return SCPI_RES_ERR;
	}
	else
	{
		if (param >= 0 && param < 10)
		{
			save((uint8_t)param);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);	
			return SCPI_RES_ERR;
		}
	}
}
/*
	A0  CALPV? V query the number of calibration points for voltage 
	A1  Response the number of calibration points for voltage

*/
scpi_result_t SCPI_calpvq_calpvr(scpi_t * context) {
	clearMeasureCommand();//Nbuffer Bzʥ] M
	if (protsw != 0) // editken
	{
		protsw = 0;	  // iJեɥOVP ,OCP
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
    }
    queryStepByStep(MEASURE_CHANNEL,CALPVQ_CMD,CALPVR_CMD ,20);	   // A0 ->   A1 <-
//	SCPI_ResultInt(context, calPV);
	sprintf((void *)transBuffer ,"%d\r\n",calPV);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    return SCPI_RES_OK;
}

/*
   A4 CALVn V set to voltage calibration at point n
*/
scpi_result_t SCPI_send_calvn(scpi_t * context) {
    int32_t param;
	CLR_FAT_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else
	{
		if (param >= 1 && param <= 4)//calPV)
		{
			sendMBStateSetting(MEASURE_CHANNEL,CALVN_CMD, param); // 0xA4
			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}

scpi_result_t SCPI_send_FATcalvn(scpi_t * context) {
    int32_t param;
	SET_FAT_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else
	{
		if (param >= 1 && param <= 4)//calPV)
		{
			sendMBStateSetting(MEASURE_CHANNEL,CALVN_CMD, param | 0x80); // 0xA4
			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}



/*
   return current calibration point n
*/
scpi_result_t SCPI_send_calvnQ(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",presentPoint);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));

   	return SCPI_RES_OK;
}



/*
	A5 	CALVn? V query the DAC count and calibration count of the voltage calibration point n
	A6 	Response the DAC count and calibration count of the voltage calibration point n
*/
scpi_result_t SCPI_send_calvnq(scpi_t * context) {
	clearMeasureCommand();//Nbuffer Bzʥ] M
	sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint); // 0xA5  varify
	delayMs(20);
	if 	(uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
	    receiveMBResponse(MEASURE_CHANNEL);			  // A6 <-
	}
	if (voltPoint == 1)
	{
		if (presentPoint == 1)
			sprintf((void *)(transBuffer),"%4.1f\r\n",vMeter );// 1.30
		else
			sprintf((void *)(transBuffer),"%5.1f\r\n",vMeter );// 1.30
	}
	else if (voltPoint == 2)
	{
		if (presentPoint == 1)
			sprintf((void *)(transBuffer),"%5.2f\r\n",vMeter );// 1.30
		else
			sprintf((void *)(transBuffer),"%6.2f\r\n",vMeter );// 1.30
	}
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
void debugMeasurementOut(void);

scpi_result_t SCPI_send_FATcalvnq(scpi_t * context) {
	clearMeasureCommand();//Nbuffer Bzʥ] M
	sendMBStateSetting(MEASURE_CHANNEL,CALVNQ_CMD, presentPoint|0x80); // 0xA5  varify
	delayMs(20);
	if 	(uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		if (receiveMBResponse(MEASURE_CHANNEL) != ERR )// A6 <-
		{
		   if (uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] == CALVNR_CMD)	//0xA6
		   {
				if (voltPoint == 1)
				{
					if (presentPoint == 1)
						sprintf((void *)(transBuffer),"%4.1f\r\n",vMeter );// 1.30
					else
						sprintf((void *)(transBuffer),"%5.1f\r\n",vMeter );// 1.30
				}
				else if(voltPoint == 2)
				{
					if (presentPoint == 1)
						sprintf((void *)(transBuffer),"%5.2f\r\n",vMeter );// 1.30
					else
						sprintf((void *)(transBuffer),"%6.2f\r\n",vMeter );// 1.30
				}
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	   		}
	 	}
    }
	return SCPI_RES_OK;
}



/*
  A7 SAVECALVn V save the voltage calibration count of point n
*/
scpi_result_t SCPI_send_calvns(scpi_t * context) {
	double  param1,Max = 70,Min = 30;
	CLR_FAT_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // read first parameter if present
		return SCPI_RES_ERR;
    }    // do something, if parameter not present
	else{
		switch(presentPoint)
		{
			case 1:
				Max = master.vMax * V_POINT1_MAX;
				Min = master.vMax * V_POINT1_MIN;
				break;
			case 2:
				Max = master.vMax * V_POINT2_MAX;  
				Min = master.vMax * V_POINT2_MIN;
				break;
			case 3:
				Max = master.vMax * V_POINT3_MAX; 
				Min =  master.vMax * V_POINT3_MIN;
				break;
			case 4:
				Max =  master.vMax * V_POINT4_MAX ;
				Min = master.iMax * V_POINT4_MIN;
				break;
		}
		if (param1 >= Min && param1 <= Max)
			sendMBCalSetting(CALVNS_CMD,presentPoint,convertFloatToInt(param1, master.vMax, fullScale));//0xA7 save data
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}	
		if (presentPoint == 4)
		{
			uint32_t time;
			delayMs(2000);
			outputStatus |= CAL_BUSY_STATE;
			time = softTimer[MAIN_COUNT].count;
			while ((outputStatus & CAL_BUSY_STATE) && (softTimer[MAIN_COUNT].count - time < 10000 )) // check UեS?
			{
				queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,200);
			}
			onoffStatus = 0;
			verifyInput(OUTPUT_CMD,(float)onoffStatus );  //o@BO² initialzeMB(); IOX
							// ^Wh ˬdprotsw A  } m
			eepRead((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (protsw != 0)
			{
				verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
				ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
				if (protsw & BIT7)
				{
					ProtOVActivation = 1;
					verifyInput(OVPSET_CMD,master.OVPSet );
				}
				if (protsw & BIT6)
				{
					ProtOCActivation = 1;
					verifyInput(OCPSET_CMD,master.OCPSet );
				}
				if (protsw & BIT5)
				{
					ProtOPActivation = 1;
					verifyInput(OPPSET_CMD,master.OPPSet );
				}
				if (protsw & BIT4)
					CVtoCCActivation = 1;
				if (protsw & BIT3)
				    CCtoCVActivation = 1;
			}
		}
    	return SCPI_RES_OK;
	}
}
scpi_result_t SCPI_send_FATcalvns(scpi_t * context) {
	double  param1,Max = 70,Min = 30;
	SET_FAT_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // read first parameter if present
		return SCPI_RES_ERR;
    }    // do something, if parameter not present
	else{
		switch(presentPoint)
		{
			case 1:
				Max = master.vMax * V_POINT1_MAX;
				Min = master.vMax * V_POINT1_MIN;
				break;
			case 2:
				Max = master.vMax * V_POINT2_MAX;  
				Min = master.vMax * V_POINT2_MIN;
				break;
			case 3:
				Max = master.vMax * V_POINT3_MAX; 
				Min =  master.vMax * V_POINT3_MIN;
				break;
			case 4:
				Max =  master.vMax * V_POINT4_MAX ;
				Min = master.iMax * V_POINT4_MIN;
				break;
		}
		if (param1 >= Min && param1 <= Max)
			sendMBCalSetting(CALVNS_CMD,presentPoint|0x80,convertFloatToInt(param1, master.vMax, fullScale));//0xA7 save data
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}	
		if (presentPoint == 4)
		{
			uint32_t time;
			delayMs(2000);
			outputStatus |= CAL_BUSY_STATE;
			time = softTimer[MAIN_COUNT].count;
			while ((outputStatus & CAL_BUSY_STATE) && (softTimer[MAIN_COUNT].count - time < 10000 )) // check UեS?
			{
				queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,200);
			}
			onoffStatus = 0;
			verifyInput(OUTPUT_CMD,(float)onoffStatus );  //o@BO² initialzeMB(); IOX
							// ^Wh ˬdprotsw A  } m
			eepRead((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (protsw != 0)
			{
				verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
				ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
				if (protsw & BIT7)
				{
					ProtOVActivation = 1;
					verifyInput(OVPSET_CMD,master.OVPSet );
				}
				if (protsw & BIT6)
				{
					ProtOCActivation = 1;
					verifyInput(OCPSET_CMD,master.OCPSet );
				}
				if (protsw & BIT5)
				{
					ProtOPActivation = 1;
					verifyInput(OPPSET_CMD,master.OPPSet );
				}
				if (protsw & BIT4)
					CVtoCCActivation = 1;
				if (protsw & BIT3)
				    CCtoCVActivation = 1;
			}
			CLR_FAT_CAL;  
		}
    	return SCPI_RES_OK;
	}
}


/*
   A2 CALPI? V query the number of calibration points for current
   A3 Response the number of calibration points for current

*/
scpi_result_t SCPI_calpiq_calpir(scpi_t * context) {
	clearMeasureCommand();//Nbuffer Bzʥ] M
	if (protsw != 0) // editken
	{
		protsw = 0;	  // iJեɥOVP ,OCP
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
    }
    queryStepByStep(MEASURE_CHANNEL,CALPIQ_CMD,CALPIR_CMD ,20);	  // A2 ->   A3 <-
	sprintf((void *)transBuffer ,"%d\r\n",calPI);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    return SCPI_RES_OK;
}

/*
   A8 CALIn V set to current calibration at point n
*/
scpi_result_t SCPI_send_calin(scpi_t * context) {
    int32_t param;
	CLR_FAT_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else{
		if (param >= 1 && param <= 4)//calPI)
		{
			sendMBStateSetting(MEASURE_CHANNEL,CALIN_CMD, param); // 0xA8
			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}

scpi_result_t SCPI_send_FATcalin(scpi_t * context) {
    int32_t param;
	SET_FAT_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else{
		if (param >= 1 && param <= 4)//calPI)
		{
			sendMBStateSetting(MEASURE_CHANNEL,CALIN_CMD, param|0x80); // 0xA8
			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}


/*
	A9 	CALVn? V query the DAC count and calibration count of the voltage calibration point n
	AA 	Response the DAC count and calibration count of the voltage calibration point n
*/
scpi_result_t SCPI_send_calinq(scpi_t * context) {
	clearMeasureCommand();//Nbuffer Bzʥ] M	   
	sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint); // 0xA9  varify
	delayMs(20);
	if 	(uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
//	while (uartBuffer[MEASURE_CHANNEL].packetCount == 0);	//ʥ]
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);			  // AA <-
	}
//	sprintf((void *)(transBuffer),"%.4e\r\n",iMeter );	   //
	sprintf((void *)(transBuffer),"%7.4f\r\n",iMeter ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}

scpi_result_t SCPI_send_FATcalinq(scpi_t * context) {
	clearMeasureCommand();//Nbuffer Bzʥ] M	   
	sendMBStateSetting(MEASURE_CHANNEL,CALINQ_CMD, presentPoint|0x80); // 0xA9  varify
	delayMs(20);
	if 	(uartBuffer[MEASURE_CHANNEL].packetCount != 0)
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);			  // AA <-
	}
	sprintf((void *)(transBuffer),"%7.4f\r\n",iMeter ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
  AB SAVECALVn V save the voltage calibration count of point n
*/
scpi_result_t SCPI_send_calins(scpi_t * context) {
	double  param1,Max = 0.25,Min = 0.15;
	CLR_FAT_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // read first parameter if present
		return SCPI_RES_ERR;
    }    // do something, if parameter not present
	else{
		switch(presentPoint)
		{
			case 1:
				if (machine1000 == 0) // 1000V
				{
					Max = master.iMax * I_1000POINT1_MAX;
					Min = master.iMax * I_1000POINT1_MIN;
				}
				else
				{
					Max = master.iMax * I_POINT1_MAX;
					Min = master.iMax * I_POINT1_MIN;
				}
				break;
			case 2:
				Max = master.iMax * I_POINT2_MAX;  
				Min = master.iMax * I_POINT2_MIN;
				break;
			case 3:
				Max = master.iMax * I_POINT3_MAX; 
				Min =  master.iMax * I_POINT3_MIN;
				break;
			case 4:
				Max =  master.iMax * I_POINT4_MAX;
				Min = master.iMax * I_POINT4_MIN;
				break;
		}
		if (param1 >= Min && param1 <= Max)
			sendMBCalSetting(CALINS_CMD,presentPoint,convertFloatToInt(param1, master.iMax, fullScale));//0xAB save data
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}	

		if (presentPoint == 4)
		{
			uint32_t time;
			delayMs(1000);
			outputStatus |= CAL_BUSY_STATE;
			time = softTimer[MAIN_COUNT].count;
			while ((outputStatus & CAL_BUSY_STATE) && (softTimer[MAIN_COUNT].count - time < 10000 )) // check UեS?
			{
				queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,200);
			}
			onoffStatus = 0;
			verifyInput(OUTPUT_CMD,(float)onoffStatus );  //o@BO² initialzeMB(); IOX
							// ^Wh ˬdprotsw A  } m
			eepRead((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (protsw != 0)
			{
				verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
				ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
				if (protsw & BIT7)
				{
					ProtOVActivation = 1;
					verifyInput(OVPSET_CMD,master.OVPSet );
				}
				if (protsw & BIT6)
				{
					ProtOCActivation = 1;
					verifyInput(OCPSET_CMD,master.OCPSet );
				}
				if (protsw & BIT5)
				{
					ProtOPActivation = 1;
					verifyInput(OPPSET_CMD,master.OPPSet );
				}
				if (protsw & BIT4)
					CVtoCCActivation = 1;
				if (protsw & BIT3)
				    CCtoCVActivation = 1;
			}
		}
    	return SCPI_RES_OK;
	}
}
double param1;
scpi_result_t SCPI_send_FATcalins(scpi_t * context) {
	double  Max = 0.25,Min = 0.15;
	SET_FAT_CAL;
    clearMeasureCommand();//Nbuffer Bzʥ] M
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // read first parameter if present
		return SCPI_RES_ERR;
    }    // do something, if parameter not present
	else{
		switch(presentPoint)
		{
			case 1:
				if (machine1000 == 0) // 1000V
				{
					Max = master.iMax * I_1000POINT1_MAX;
					Min = master.iMax * I_1000POINT1_MIN;
				}
				else
				{
					Max = master.iMax * I_POINT1_MAX;
					Min = master.iMax * I_POINT1_MIN;
				}				break;
			case 2:
				Max = master.iMax * I_POINT2_MAX;  
				Min = master.iMax * I_POINT2_MIN;
				break;
			case 3:
				Max = master.iMax * I_POINT3_MAX; 
				Min =  master.iMax * I_POINT3_MIN;
				break;
			case 4:
				Max =  master.iMax * I_POINT4_MAX;
				Min = master.iMax * I_POINT4_MIN;
				break;
		}
		if (param1 >= Min && param1 <= Max)
			sendMBCalSetting(CALINS_CMD,presentPoint|0x80,convertFloatToInt(param1, master.iMax, fullScale));//0xAB save data
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}	
		if (presentPoint == 4)
		{
			uint32_t time;
			delayMs(1000);
			outputStatus |= CAL_BUSY_STATE;
			time = softTimer[MAIN_COUNT].count;
			while ((outputStatus & CAL_BUSY_STATE) && (softTimer[MAIN_COUNT].count - time < 10000 )) // check UեS?
			{
				queryStepByStep(MEASURE_CHANNEL, OUTPUTQ_CMD,OUTPUTR_CMD ,200);
			}
			onoffStatus = 0;
			verifyInput(OUTPUT_CMD,(float)onoffStatus );  //o@BO² initialzeMB(); IOX
							// ^Wh ˬdprotsw A  } m
			eepRead((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (protsw != 0)
			{
				verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
				ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
				if (protsw & BIT7)
				{
					ProtOVActivation = 1;
					verifyInput(OVPSET_CMD,master.OVPSet );
				}
				if (protsw & BIT6)
				{
					ProtOCActivation = 1;
					verifyInput(OCPSET_CMD,master.OCPSet );
				}
				if (protsw & BIT5)
				{
					ProtOPActivation = 1;
					verifyInput(OPPSET_CMD,master.OPPSet );
				}
				if (protsw & BIT4)
					CVtoCCActivation = 1;
				if (protsw & BIT3)
				    CCtoCVActivation = 1;
			}
			CLR_FAT_CAL;
		}
    	return SCPI_RES_OK;
	}
}



/*
  B0 Start the OVP calibration procedure of user data
*/
scpi_result_t SCPI_send_startovpq(scpi_t * context) {
	CLR_FAT_CAL;
	SET_SCPI_CAL;
	SET_START_SCPIOVPOCP_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
	if (protsw != 0) // editken
	{
		protsw = 0;	  // iJեɥOVP ,OCP
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
    }
	sendMBQuery(MEASURE_CHANNEL,STARTOVPCALQ_CMD);	 // 0xB0 ->
	ovpCalState = 0;
    return SCPI_RES_OK;
}
scpi_result_t SCPI_send_FATstartovpq(scpi_t * context) {
	SET_FAT_CAL;
	SET_SCPI_CAL;
	SET_START_SCPIOVPOCP_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
	if (protsw != 0) // editken
	{
		protsw = 0;	  // iJեɥOVP ,OCP
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
    }
	sendMBQuery(MEASURE_CHANNEL,FATSTARTOVPCALQ_CMD);	 // 0xB4 ->
	ovpCalState = 0;
    return SCPI_RES_OK;
}



/*
  B1 Response the OVP calibration state of user data, FAIL = 0, Low OK = 1, High OK = 2, All OK = 3
*/
scpi_result_t SCPI_send_ovpcalstater(scpi_t * context) {

	sprintf((void *)transBuffer ,"%d\r\n",ovpCalState);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}




/*
  B2 Start the OCP calibration procedure of user data
*/
scpi_result_t SCPI_send_startocpq(scpi_t * context) {
	CLR_FAT_CAL;
	SET_SCPI_CAL;
	SET_START_SCPIOVPOCP_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
	if (protsw != 0) // editken
	{
		protsw = 0;	  // iJեɥOVP ,OCP
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
    }
	sendMBQuery(MEASURE_CHANNEL,STARTOCPCALQ_CMD);	 // 0xB2 ->
	ocpCalState	= 0;
    return SCPI_RES_OK;
}

scpi_result_t SCPI_send_FATstartocpq(scpi_t * context) {
	SET_FAT_CAL;
	SET_SCPI_CAL;
	SET_START_SCPIOVPOCP_CAL;
	clearMeasureCommand();//Nbuffer Bzʥ] M
	if (protsw != 0) // editken
	{
		protsw = 0;	  // iJեɥOVP ,OCP
		verifyInput(PORTSW_CMD, protsw ); // send protect switch to MB board
		ProtOVActivation = ProtOCActivation = ProtOPActivation = CVtoCCActivation = CCtoCVActivation = 0;
    }
	sendMBQuery(MEASURE_CHANNEL,FATSTARTOCPCALQ_CMD);	 // 0xB6 ->
	ocpCalState = 0;
    return SCPI_RES_OK;
}


/*
  B3 Response the OCP calibration state of user data, FAIL = 0, Low OK = 1, High OK = 2, All OK = 3
*/

scpi_result_t SCPI_send_ocpcalstater(scpi_t * context) {


	sprintf((void *)transBuffer ,"%d\r\n",ocpCalState);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
    return SCPI_RES_OK;
}

scpi_result_t SCPI_send_EXTVoltagePoint(scpi_t * context) {

    int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else
	{
		CLR_FAT_CAL;
		if (param == 1 )
		{
			VOL_RES_SEL_LOW;
			dacControl(DAC_VOLTAGE,(uint16_t)(DAC1V),ON); // eX1V	 AD
			eepRead((uint8_t *)&extCalV[0] , EE_USER_EXTCALV_0 , sizeof(float) * 2);
			SET_SCPIEXTCAL_VOLT;
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else if(param == 2)
		{
			VOL_RES_SEL_LOW;
			dacControl(DAC_VOLTAGE,(uint16_t)(DAC9V),ON); // eX9V	 AD 
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}

scpi_result_t SCPI_send_FATEXTVoltagePoint(scpi_t * context) {

    int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else
	{
		SET_FAT_CAL;
		if (param == 1 )
		{
			VOL_RES_SEL_LOW;
			dacControl(DAC_VOLTAGE,(uint16_t)(DAC1V),ON); // eX1V	 AD
			eepRead((uint8_t *)&extCalV[0] , EE_FAT_EXTCALV_0 , sizeof(float) * 2);
			SET_SCPIEXTCAL_VOLT;
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else if(param == 2)
		{
			VOL_RES_SEL_LOW;
			dacControl(DAC_VOLTAGE,(uint16_t)(DAC9V),ON); // eX9V	 AD 
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}



scpi_result_t SCPI_send_EXTVoltageDATA(scpi_t * context){
	double  param1,Max = 1.1,Min = 0.9;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // read first parameter if present
		return SCPI_RES_ERR;
    }    // do something, if parameter not present
	else{
		switch(presentPoint)
		{
			case 1:
				Max = 1.2;Min = 0.8;
				break;
			case 2:
				Max = 9.9;  Min = 8.1;
				break;
		}
		if (param1 >= Min && param1 <= Max)
		{
			extCalVAd[presentPoint - 1] = vADbuffer;//YnADCDualConvertedValue[0];
			extCalV[presentPoint - 1] = param1;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}	
		if (presentPoint == 2)
		{
			mADc_v = (extCalV[1] - extCalV[0])/(extCalVAd[1] - extCalVAd[0]);
			bADc_v = extCalV[1] - (mADc_v * extCalVAd[1]);
			mDAc_v = (DAC9V - DAC1V)/(extCalV[1] - extCalV[0]);
			bDAc_v = DAC9V - (mDAc_v * extCalV[1]);
			eepWrite((uint8_t *)&extCalV[0],EE_USER_EXTCALV_0 ,sizeof(float) * 2);
			eepWrite((uint8_t *)&extCalVAd[0],EE_USER_EXTCALVAD_0 ,sizeof(uint16_t) * 2);
			writeUserChecksum();
			CLR_FAT_CAL;
			dacControl(DAC_VOLTAGE,0,ON); // eX0V	 AD 
			CLR_SCPIEXTCAL_VOLT;
	    }
    	return SCPI_RES_OK;
	}
}
scpi_result_t SCPI_query_EXTVoltageDATA(scpi_t * context){
	CLR_FAT_CAL;
	sprintf((void *)(transBuffer),"%7.4f\r\n",extCalV[presentPoint - 1] );	 // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
scpi_result_t SCPI_query_FATEXTVoltageDATA(scpi_t * context){
	SET_FAT_CAL;
	sprintf((void *)(transBuffer),"%7.4f\r\n",extCalV[presentPoint - 1] ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}





scpi_result_t SCPI_send_EXTCurrentPoint(scpi_t * context) {

    int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else
	{
		CLR_FAT_CAL;
		if (param == 1 )
		{
			CURR_RES_SEL_LOW;
			dacControl(DAC_CURRENT,(uint16_t)(DAC1V),ON); // eX1V	 AD
			eepRead((uint8_t *)&extCalI[0] , EE_USER_EXTCALI_0 , sizeof(float) * 2);
			SET_SCPIEXTCAL_CURR;			
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else if(param == 2)
		{
			CURR_RES_SEL_LOW;
			dacControl(DAC_CURRENT,(uint16_t)(DAC9V),ON); // eX9V	 AD 
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}

scpi_result_t SCPI_send_FATEXTCurrentPoint(scpi_t * context) {

    int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE) ) {
		return SCPI_RES_ERR;
    }
	else
	{
		SET_FAT_CAL;
		if (param == 1 )
		{
			CURR_RES_SEL_LOW;
			dacControl(DAC_CURRENT,(uint16_t)(DAC1V),ON); // eX1V	 AD
			eepRead((uint8_t *)&extCalI[0] , EE_FAT_EXTCALI_0 , sizeof(float) * 2);
			SET_SCPIEXTCAL_CURR;			
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else if(param == 2)
		{
			CURR_RES_SEL_LOW;
			dacControl(DAC_CURRENT,(uint16_t)(DAC9V),ON); // eX9V	 AD 
  			presentPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
 		}
	}
}



scpi_result_t SCPI_send_EXTCurrentDATA(scpi_t * context){
	double  param1,Max = 1.1,Min = 0.9;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // read first parameter if present
		return SCPI_RES_ERR;
    }    // do something, if parameter not present
	else{
		switch(presentPoint)
		{
			case 1:
				Max = 1.1;Min = 0.9;
				break;
			case 2:
				Max = 9.9;  Min = 8.1;
				break;
		}
		if (param1 >= Min && param1 <= Max)
		{
			extCalIAd[presentPoint - 1] = iADbuffer;//YnADCDualConvertedValue[1];
			extCalI[presentPoint - 1] = param1;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}	
		if (presentPoint == 2)
		{
			mADc_i = (extCalI[1] - extCalI[0])/(extCalIAd[1] - extCalIAd[0]);
			bADc_i = extCalI[1] - (mADc_i * extCalIAd[1]);
			mDAc_i = (DAC9V - DAC1V)/(extCalI[1] - extCalI[0]);
			bDAc_i = DAC9V - (mDAc_i * extCalI[1]);
			eepWrite((uint8_t *)&extCalI[0],EE_USER_EXTCALI_0 ,sizeof(float) * 2);
			eepWrite((uint8_t *)&extCalIAd[0],EE_USER_EXTCALIAD_0 ,sizeof(uint16_t) * 2);
			writeUserChecksum();
			CLR_FAT_CAL;
			dacControl(DAC_CURRENT,0,ON); // eX0V	 AD 
			CLR_SCPIEXTCAL_CURR;
	    }
    	return SCPI_RES_OK;
	}
}

scpi_result_t SCPI_query_EXTCurrentDATA(scpi_t * context){
	CLR_FAT_CAL;
	sprintf((void *)(transBuffer),"%7.4f\r\n",extCalI[presentPoint - 1] ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
scpi_result_t SCPI_query_FATEXTCurrentDATA(scpi_t * context){
	SET_FAT_CAL;
	sprintf((void *)(transBuffer),"%7.4f\r\n",extCalI[presentPoint - 1] ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}



scpi_result_t SCPI_query_EXTCalToTalPoint(scpi_t * context) {

	sprintf((void *)transBuffer ,"%d\r\n",extCalTotalPoint);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}



scpi_result_t SCPI_send_FATEXTCurrentCCState(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param1.value == 0 || param1.value == 1)	{
			if (param1.value == 1)
			{
				CURR_RES_SEL_HIGH;
			    SET_SCPIEXTCAL_CURR;
			}
			else
			{
				CURR_RES_SEL_LOW;
				CLR_SCPIEXTCAL_CURR;
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

scpi_result_t SCPI_query_FATEXTCurrentCCState(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	if (IS_CURR_RES == Bit_SET)
		param1.type = SCPI_PARM_ON;
	else
		param1.type = SCPI_PARM_OFF;
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
				 
scpi_result_t SCPI_send_FATEXTCurrentCCDATA(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (param1 >= 1.01 && param1 <= 1.05)
		{
			currentrescurr = param1;
			eepWrite((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
			SET_FAT_CAL;
			writeUserChecksum();
			CLR_FAT_CAL;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
}

scpi_result_t SCPI_query_FATEXTCurrentCCDATA(scpi_t * context) {
	eepRead((uint8_t *)&currentrescurr,EE_FAT_CURRENTRESCURR ,sizeof(float));
	sprintf((void *)(transBuffer),"%6.5f\r\n",currentrescurr ); //
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}

scpi_result_t SCPI_send_EXTCurrentCCDATA(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (param1 >= 1.01 && param1 <= 1.05)
		{
			currentrescurr = param1;
			eepWrite((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
			CLR_FAT_CAL;
			writeUserChecksum();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
}

scpi_result_t SCPI_query_EXTCurrentCCDATA(scpi_t * context) {
	eepRead((uint8_t *)&currentrescurr,EE_USER_CURRENTRESCURR ,sizeof(float));
	sprintf((void *)(transBuffer),"%6.5f\r\n",currentrescurr ); //
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}




scpi_result_t SCPI_send_FATEXTVoltageCCState(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param1.value == 0 || param1.value == 1)	{
			if (param1.value == 1)
			{
				VOL_RES_SEL_HIGH;
				SET_SCPIEXTCAL_VOLT;
			}
			else
			{
				VOL_RES_SEL_LOW;
				CLR_SCPIEXTCAL_VOLT;
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

scpi_result_t SCPI_query_FATEXTVoltageCCState(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	if (IS_VOL_RES == Bit_SET)
		param1.type = SCPI_PARM_ON;
	else
		param1.type = SCPI_PARM_OFF;
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));

	return SCPI_RES_OK;
}
				 
scpi_result_t SCPI_send_FATEXTVoltageCCDATA(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (param1 >= 1.01 && param1 <= 1.05)
		{
			voltagerescurr = param1;
			eepWrite((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
			SET_FAT_CAL;
			writeUserChecksum();
			CLR_FAT_CAL;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
}

scpi_result_t SCPI_query_FATEXTVoltageCCDATA(scpi_t * context) {
	eepRead((uint8_t *)&voltagerescurr,EE_FAT_VOLTAGERESCURR ,sizeof(float));
	sprintf((void *)(transBuffer),"%6.5f\r\n",voltagerescurr ); //
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}

scpi_result_t SCPI_send_EXTVoltageCCDATA(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (param1 >= 1.01 && param1 <= 1.05)
		{
			voltagerescurr = param1;
			eepWrite((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
			CLR_FAT_CAL;
			writeUserChecksum();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
}

scpi_result_t SCPI_query_EXTVoltageCCDATA(scpi_t * context) {
	eepRead((uint8_t *)&voltagerescurr,EE_USER_VOLTAGERESCURR ,sizeof(float));
	sprintf((void *)(transBuffer),"%6.5f\r\n",voltagerescurr ); //
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}



/*
	Set master.limitIMax
*/
scpi_result_t SCPI_setLimitCurrentMax(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (((float)param1 >= sumiMin()) && ((float)param1 <= sumiMax()))
//		if ((float)param1 >= sumlimitIMin() && (float)param1 <= sumlimitIMax())
		{
			master.limitIMax = (float)param1/(slaveNumber + 1);
			eepWrite((uint8_t *)&master.limitIMax, EE_LIMITIMAX ,sizeof(float));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)  // clear slave error state  slaveNumber > 0 means slave exist
			{
				masterState = BROADCAST;
 				rs485Temp.unionbyte.ftob = master.limitIMax;
				rs485Temp.cmd = CMD_SETLIMITIMAX;
				cmdexenum = MASTERSETFLOAT;
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
	
}
/*
   query master.limitIMax
*/
scpi_result_t SCPI_queryLimitCurrentMax(scpi_t * context) {
	sprintf((void *)(transBuffer),"%7.4f\r\n",sumlimitIMax() ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set master.limitIMin
*/
scpi_result_t SCPI_setLimitCurrentMin(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (((float)param1 >= sumiMin()) && ((float)param1 <= sumiMax()))
//		if ((float)param1 >= sumlimitIMin() && (float)param1 <= sumlimitIMax())
		{
			master.limitIMin = (float)param1/(slaveNumber + 1);
			eepWrite((uint8_t *)&master.limitIMin, EE_LIMITIMIN ,sizeof(float));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)  // clear slave error state  slaveNumber > 0 means slave exist
			{
				masterState = BROADCAST;
 				rs485Temp.unionbyte.ftob = master.limitIMin;
				rs485Temp.cmd = CMD_SETLIMITIMIN;
				cmdexenum = MASTERSETFLOAT;
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
}
/*
   query master.limitIMin
*/
scpi_result_t SCPI_queryLimitCurrentMin(scpi_t * context) {
	sprintf((void *)(transBuffer),"%7.4f\r\n",sumlimitIMin() ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}


/*
	Set master.limitVMax
*/
scpi_result_t SCPI_setLimitVoltageMax(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if ((float)param1 >= master.vMin && (float)param1 <= master.vMax)
		{
			master.limitVMax = (float)param1;
			eepWrite((uint8_t *)&master.limitVMax, EE_LIMITVMAX ,sizeof(float));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)  // clear slave error state  slaveNumber > 0 means slave exist
			{
				masterState = BROADCAST;
 				rs485Temp.unionbyte.ftob = master.limitVMax;
				rs485Temp.cmd = CMD_SETLIMITVMAX;
				cmdexenum = MASTERSETFLOAT;
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
	
}
/*
   query master.limitVMax
*/
scpi_result_t SCPI_queryLimitVoltageMax(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.limitVMax ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set master.master.limitVMin
*/
scpi_result_t SCPI_setLimitVoltageMin(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if ((float)param1 >= master.vMin && (float)param1 <= master.vMax)
		{
			master.limitVMin = (float)param1;
			eepWrite((uint8_t *)&master.limitVMin, EE_LIMITVMIN ,sizeof(float));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)  // clear slave error state  slaveNumber > 0 means slave exist
			{
				masterState = BROADCAST;
 				rs485Temp.unionbyte.ftob = master.limitVMin;
				rs485Temp.cmd = CMD_SETLIMITVMIN;
				cmdexenum = MASTERSETFLOAT;
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}
/*
   query master.limitVMin
*/
scpi_result_t SCPI_queryLimitVoltageMin(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.limitVMin ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}






/*
	Set limitPMax
*/
scpi_result_t SCPI_setLimitPowerMax(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if ((float)param1 >= PMIN && (float)param1 <= master.pMax)
		{
			limitPMax = (float)param1;
			eepWrite((uint8_t *)&limitPMax, EE_LIMITPMAX ,sizeof(float));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_OK;
		}
	}
}
/*
   query limitPMax
*/
scpi_result_t SCPI_queryLimitPowerMax(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)powDisp[powPoint],limitPMax ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set limitPMin
*/
scpi_result_t SCPI_setLimitPowerMin(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if ((float)param1 >= PMIN && (float)param1 <= master.pMax)
		{
			limitPMin = (float)param1;
			eepWrite((uint8_t *)&limitPMin, EE_LIMITPMIN ,sizeof(float));
		 	return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
}
/*
   query limitPMin
*/
scpi_result_t SCPI_queryLimitPowerMin(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)powDisp[powPoint],limitPMin ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}


/* EXAMPLE

    if (!SCPI_ParamInt(context, &param, TRUE)) {      // TRUE \  , SaѼ  |^ Missing parameter
		return SCPI_RES_ERR;						  // SѼƱqo̵	 
    }
	else{
		SCPI_ResultInt(context, param);				   //ѼƦb]w 	 
		return SCPI_RES_OK;
	}

    if (!SCPI_ParamInt(context, &param, false)) {     //  false \  , SѼƤ^ Missing parameter T
													  // SѼƱqo̵
    }
	else{
		SCPI_ResultInt(context, param);				  // ѼƦb]w 
	}
	return SCPI_RES_OK;
*/






/*
   query extEnable
*/
scpi_result_t SCPI_queryExtEnable(scpi_t * context) {

	scpi_number_t param1;
	char bf[15];
	switch(extEnable)
	{
		case 0:
			param1.type = SCPI_PARM_OFF;
			break;
		case 1:
			param1.type = SCPI_PARM_AMODE;
			break;
		case 2:
			param1.type = SCPI_PARM_BMODE;
			break;
	} 
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));



	return SCPI_RES_OK;
}
/*
   Set extEnable
*/

scpi_result_t SCPI_setExtEnable(scpi_t * context) {

	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_AMODE || param1.type == SCPI_PARM_BMODE )&& (param1.value < 3))	{
			extEnable = param1.value;
			eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
			if (extEnable == ON) // extEnable = ON
			{
				timerONOFF = OFF;
				programONOFF = OFF;
				pvsONOFF = OFF;
				parallelMode = OFF;
				eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
				chainMode = OFF;
				VFDsign &=  ~(sign_ADDR);
				eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
				sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off
				checkPowerOnState();
			}
			else // extEnable = OFF
			{
				extVMode = 0;
				eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
				extIMode = 0;
				eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}



/*
   query extIMode
*/
scpi_result_t SCPI_queryExtIMode(scpi_t * context) {
	scpi_number_t param1;
    char bf[15];
		switch(extIMode)
	{
		case 0:
			param1.type = SCPI_PARM_FRONT;
			break;
		case 1:
			param1.type = SCPI_PARM_EXTV;
			break;
		case 2:
			param1.type = SCPI_PARM_EXTR;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set extIMode
*/

scpi_result_t SCPI_setExtIMode(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_FRONT || param1.type == SCPI_PARM_EXTV || param1.type == SCPI_PARM_EXTR )&& (param1.value < 3))	{
			extIMode = param1.value ;
			eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query extVMode
*/
scpi_result_t SCPI_queryExtVMode(scpi_t * context) {
	scpi_number_t param1;
    char bf[15];
		switch(extVMode)
	{
		case 0:
			param1.type = SCPI_PARM_FRONT;
			break;
		case 1:
			param1.type = SCPI_PARM_EXTV;
			break;
		case 2:
			param1.type = SCPI_PARM_EXTR;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;	
}
/*
   Set extVMode
*/

scpi_result_t SCPI_setExtVMode(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_FRONT || param1.type == SCPI_PARM_EXTV || param1.type == SCPI_PARM_EXTR )&& (param1.value < 3))	{
			extVMode = param1.value ;
			eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}




/*
   query extProgRange
*/
scpi_result_t SCPI_queryExtProgRange(scpi_t * context) {
	scpi_number_t param1;
    char bf[15];
		switch(extProgRange)
	{
		case 0:
			param1.type = SCPI_PARM_PROG5V5K;
			break;
		case 1:
			param1.type = SCPI_PARM_PROG10V10K;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set extProgRange
*/

scpi_result_t SCPI_setExtProgRange(scpi_t * context) {

	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_PROG5V5K || param1.type == SCPI_PARM_PROG10V10K  )&& (param1.value < 2) )	{
			extProgRange = param1.value ;
			eepWrite((uint8_t *)&extProgRange, EE_EXTPROGRANGE ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query extMonRange
*/
scpi_result_t SCPI_queryExtMonRange(scpi_t * context) {
	scpi_number_t param1;
    char bf[15];
		switch(extMonRange)
	{
		case 0:
			param1.type = SCPI_PARM_MON5V;
			break;
		case 1:
			param1.type = SCPI_PARM_MON10V;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set extMonRange
*/

scpi_result_t SCPI_setExtMonRange(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_MON5V || param1.type == SCPI_PARM_MON10V  )&& (param1.value < 2))	{
			extMonRange = param1.value ;
			eepWrite((uint8_t *)&extMonRange, EE_EXTMONRANGE ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
/*
   query extShutOffLogic
*/
scpi_result_t SCPI_queryExtShutOffLogic(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(extShutOffLogic);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set extShutOffLogic
*/

scpi_result_t SCPI_setExtShutOffLogic(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			extShutOffLogic = param1.value;
			eepWrite((uint8_t *)&extShutOffLogic, EE_EXTSHUTOFFLOGIC ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query parallelMode
*/
scpi_result_t SCPI_queryParallelMode(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(parallelMode);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set parallelMode
*/

scpi_result_t SCPI_setParallelMode(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			parallelMode = param1.value;
			eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}



/*
   query ParallelRole
*/
scpi_result_t SCPI_queryParallelRole(scpi_t * context) {
	if (parallelRole == 0)
		sprintf((void *)(transBuffer),"MASTER\r\n");
	else
		sprintf((void *)(transBuffer),"SLAVE%2d\r\n", parallelRole);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set ParallelRole
*/

scpi_result_t SCPI_setParallelRole(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER)  && (param1.value <= SLAVEMAXNUM))	{
			parallelRole = param1.value ;
			eepWrite((uint8_t *)&parallelRole, EE_PARALLELROLE ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query chainMode
*/
scpi_result_t SCPI_queryChainMode(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(chainMode);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set chainMode
*/

scpi_result_t SCPI_setChainMode(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			chainMode = param1.value;
			eepWrite((uint8_t *)&chainMode, EE_CHAINMODE,sizeof(uint8_t));
	//		if (chainMode == ON)
			{
				VFDsign |=  (sign_ADDR);
				RELEASE_RS485_BUS;
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query chainAddr
*/
scpi_result_t SCPI_queryChainAddr(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",chainAddr);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set chainAddr
*/

scpi_result_t SCPI_setChainAddr(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param > 0 && param < MAX_CHAINADDR)	{
			chainAddr = param;
			eepWrite((uint8_t *)&chainAddr, EE_CHAINADDR,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query Protection
*/
scpi_result_t SCPI_queryProtection(scpi_t * context) {
	 uint8_t temp ;
	if(outputStatus & OVP_STATE) 
	{
	   temp = 1;
	}
	else if(outputStatus & OCP_STATE)
	{
	    temp = 2;
	}
	else if(outputStatus & OPP_STATE)
	{
		temp = 3;
	}
	else if(outputStatus & CV_CC_STATE)
	{
	    temp = 4;
	}
	else if(outputStatus & CC_CV_STATE)
	{
	   temp = 5;
	}
	else
	{
	    temp = 0;
	}
	sprintf((void *)transBuffer ,"%d\r\n",temp);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}

scpi_special_number_t returnONOFF(uint8_t param)
{
	if (param == 0)
		return SCPI_PARM_OFF;
	else		
		return SCPI_PARM_ON;
}

/*
   query ProtOVActivation
*/
scpi_result_t SCPI_queryProtOVActivation(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(ProtOVActivation);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set ProtOVActivation
*/

scpi_result_t SCPI_setProtOVActivation(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			ProtOVActivation = param1.value;
			if (param1.value == 1)
				protsw |= BIT7;
			else
				protsw &= ~BIT7;
			verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				masterState = BROADCAST;
				if (protsw & BIT7)	// OVP switch
					rs485Temp.unionbyte.byte_loc[0] = ON;
				else
					rs485Temp.unionbyte.byte_loc[0] = OFF;
				rs485Temp.cmd = CMD_SETOVPONOFF;
				cmdexenum = MASTERSETINT8;
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query ProtOCActivation
*/
scpi_result_t SCPI_queryProtOCActivation(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(ProtOCActivation);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set ProtOCActivation
*/

scpi_result_t SCPI_setProtOCActivation(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			ProtOCActivation = param1.value;
			if (param1.value == 1)
				protsw |= BIT6;
			else
				protsw &= ~BIT6;
			verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				masterState = BROADCAST;
				if (protsw & BIT6)	// OVP switch
					rs485Temp.unionbyte.byte_loc[0] = ON;
				else
					rs485Temp.unionbyte.byte_loc[0] = OFF;
				rs485Temp.cmd = CMD_SETOCPONOFF;
				cmdexenum = MASTERSETINT8;
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query ProtOPActivation
*/
scpi_result_t SCPI_queryProtOPActivation(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(ProtOPActivation);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set ProtOPActivation
*/

scpi_result_t SCPI_setProtOPActivation(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			ProtOPActivation = param1.value;
			if (param1.value == 1)
				protsw |= BIT5;
			else
				protsw &= ~BIT5;
			verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				masterState = BROADCAST;
				if (protsw & BIT5)	// OVP switch
					rs485Temp.unionbyte.byte_loc[0] = ON;
				else
					rs485Temp.unionbyte.byte_loc[0] = OFF;
				rs485Temp.cmd = CMD_SETOPPONOFF;
				cmdexenum = MASTERSETINT8;
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query CVtoCCActivation
*/
scpi_result_t SCPI_queryCVtoCCActivation(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(CVtoCCActivation);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set CVtoCCActivation
*/

scpi_result_t SCPI_setCVtoCCActivation(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			CVtoCCActivation = param1.value;
			if (param1.value == 1)
				protsw |= BIT4;
			else
				protsw &= ~BIT4;
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				masterState = BROADCAST;
				if (protsw & BIT4)	// OVP switch
					rs485Temp.unionbyte.byte_loc[0] = ON;
				else
					rs485Temp.unionbyte.byte_loc[0] = OFF;
				rs485Temp.cmd = CMD_SETCVCCONOFF;
				cmdexenum = MASTERSETINT8;
			}

			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query CCtoCVActivation
*/
scpi_result_t SCPI_queryCCtoCVActivation(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(CCtoCVActivation);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set CCtoCVActivation
*/

scpi_result_t SCPI_setCCtoCVActivation(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			CCtoCVActivation = param1.value;
			if (param1.value == 1)
				protsw |= BIT3;
			else
				protsw &= ~BIT3;
			eepWrite((uint8_t *)&protsw, EE_PROTSW ,sizeof(uint8_t));
			if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
				masterState = BROADCAST;
				if (protsw & BIT4)	// OVP switch
					rs485Temp.unionbyte.byte_loc[0] = ON;
				else
					rs485Temp.unionbyte.byte_loc[0] = OFF;
				rs485Temp.cmd = CMD_SETCCCVONOFF;
				cmdexenum = MASTERSETINT8;
			}

			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

scpi_result_t SCPI_clearOVPOCPOPPCVCCCCCV(scpi_t * context) {
   	clearOVPOCPOPPCVCCCCCV();
	if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)  // clear slave error state  slaveNumber > 0 means slave exist
	{
	   	masterState = BROADCAST;
   		rs485Temp.cmd = CMD_CLR;
	   	cmdexenum = MASTERQUERYCMD;
    }
    return SCPI_RES_OK;
}



/*
   query master.OVPSet
*/
scpi_result_t SCPI_queryOVPSet(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.OVPSet ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set master.OVPSet
*/
scpi_result_t SCPI_setOVPSet(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if ((float)param1 >= master.OVPMin && (float)param1 <= master.OVPMax)
		{
			master.OVPSet =(float) param1;
			verifyInput(OVPSET_CMD,master.OVPSet );
			eepWrite((uint8_t *)&master.OVPSet, EE_REALOVPSET ,sizeof(float));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}

/*
   query master.OCPSet
*/
scpi_result_t SCPI_queryOCPSet(scpi_t * context) {
//	sprintf((void *)(transBuffer),"%.4e\r\n",master.OCPSet );
	sprintf((void *)(transBuffer),"%7.4f\r\n",master.OCPSet );	//1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set master.OCPSet
*/
scpi_result_t SCPI_setOCPSet(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if ((float)param1 >= sumOCPMin() && (float)param1 <= sumOCPMax())
		{
			master.OCPSet = (float)param1;
			verifyInput(OCPSET_CMD,master.OCPSet );
			eepWrite((uint8_t *)&master.OCPSet, EE_REALOCPSET ,sizeof(float));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}


/*
   query master.OPPSet
*/
scpi_result_t SCPI_queryOPPSet(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)powDisp[powPoint],master.OPPSet ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set master.OPPSet
*/
scpi_result_t SCPI_setOPPSet(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if ((float)param1 >= master.OPPMin && (float)param1 <= master.OPPMax)
		{
			master.OPPSet = (float)param1;
			verifyInput(OPPSET_CMD,master.OPPSet );
			eepWrite((uint8_t *)&master.OPPSet, EE_REALOPPSET ,sizeof(float));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}


/*
   query iOut
*/
scpi_result_t SCPI_queryiOut(scpi_t * context) {
	sprintf((void *)(transBuffer),"%7.4f\r\n",/* showsumofiOut */  sumiOut() ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   query vOut
*/
scpi_result_t SCPI_queryvOut(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.vOut ); // 1.30
	strcat((void *)(transBuffer),"\r\n");

	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}

/*
   query pOut
*/
scpi_result_t SCPI_querypOut(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)powDisp[powPoint],master.vOut * /* showsumofiOut */  sumiOut() ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}

/*
   query vOut,iOut
*/
scpi_result_t SCPI_queryvOutiOut(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.vOut ); 
	strcat((void *)(transBuffer)," ,");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	sprintf((void *)(transBuffer),"%7.4f\r\n",/* showsumofiOut */  sumiOut() ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}


 /*
   measure iOut
*/
scpi_result_t SCPI_measureiOut(scpi_t * context) {
//	clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
	sendMBQuery(MEASURE_CHANNEL,IREADQ_CMD);
//	clearMeasureCommand();//Ū^
	delayMs(30);
	while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}
	sprintf((void *)(transBuffer),"%7.4f\r\n",/* showsumofiOut */  sumiOut() ); // 1.47
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   measure vOut
*/
scpi_result_t SCPI_measurevOut(scpi_t * context) {
//	clearMeasureCommand();//Nbuffer Bzʥ] Ʊ
	sendMBQuery(MEASURE_CHANNEL,VREADQ_CMD);
//	clearMeasureCommand();//Ū^
	delayMs(30);
	while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.vOut ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}


/*
   measure pOut
*/
scpi_result_t SCPI_measurepOut(scpi_t * context) {
//	delayMs(5);
//	while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
//	{
//		uartBuffer[MEASURE_CHANNEL].packetCount--;
//		receiveMBResponse(MEASURE_CHANNEL);
//	}
	sendMBQuery(MEASURE_CHANNEL,VREADQ_CMD);
	sendMBQuery(MEASURE_CHANNEL,IREADQ_CMD);
	delayMs(30);
	while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}

	sprintf((void *)(transBuffer),(void *)powDisp[powPoint],master.vOut * /* showsumofiOut */  sumiOut() ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}

scpi_result_t SCPI_measurepAll(scpi_t * context) {
//	delayMs(5);
//	while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
//	{
//		uartBuffer[MEASURE_CHANNEL].packetCount--;
//		receiveMBResponse(MEASURE_CHANNEL);
//	}
	sendMBQuery(MEASURE_CHANNEL,VREADQ_CMD);
	sendMBQuery(MEASURE_CHANNEL,IREADQ_CMD);
	delayMs(30);
	while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}
	if (voltPoint == 1)	  // 1000v qpI@
		sprintf((void *)(transBuffer),"%6.1f,%7.4f\r\n",master.vOut , /* showsumofiOut */  sumiOut());	// 1.43
	else if(voltPoint == 2)	// 600v qpI
		sprintf((void *)(transBuffer),"%6.2f,%7.4f\r\n",master.vOut , /* showsumofiOut */  sumiOut());	// 1.43
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}



/*
   query vSet
*/
scpi_result_t SCPI_queryvSet(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.vSet ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set vSet
*/
uint8_t tempBuf1[10];
float testfloat;
uint32_t testint32;
scpi_result_t SCPI_setvSet(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (/* (float)param1 >= master.limitVMin && */(float)param1 <= master.limitVMax)
		{
      if ((float)param1 < 5)
				param1 = 5;
			verifyInput(VSET_CMD,(float)param1 ); // send vset  no need to save value	  */
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}

/*
   query iSet
*/
scpi_result_t SCPI_queryiSet(scpi_t * context) {
	sprintf((void *)(transBuffer),"%7.4f\r\n",master.iSet * (slaveNumber + 1)); //
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
	Set iSet
*/
scpi_result_t SCPI_setiSet(scpi_t * context) {
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		if (((float)param1 >= sumiMin()) && ((float)param1 <= sumiMax()))
		{
			calCurrRatio((float)param1);
			verifyInput(ISET_CMD,slaveDUT[0]->iSet ); // send iset  no need to save value
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}


float scpi_iSet;
float scpi_vSet; //for scpi command 


/*
   query memoryNumber
*/
scpi_result_t SCPI_queryMemoryNumber(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",memoryNumber);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set memoryNumber
*/

scpi_result_t SCPI_setMemoryNumber(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param < 10)
		{
			memoryNumber = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query memoryNumber of iSet
*/
scpi_result_t SCPI_queryMemoryNumberOfISet(scpi_t * context) {
    uint16_t tempValue;
	int8_t temps1[10];
	float temp;
	eepRead((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (memoryNumber) * SIZEOF_MEM_PACKET + EE_ISET ,sizeof(uint16_t));
	temp = (tempValue * master.iMax)/fullScale;
	sprintf((void *)temps1,(void *)currDisp[currPoint],temp);
	temp = atof((void *)temps1);
	sprintf((void *)(transBuffer),"%7.4f\r\n",temp * (slaveNumber + 1) ); // 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set memoryNumber	of iSet
*/

scpi_result_t SCPI_setMemoryNumberOfISet(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= sumlimitIMin() || (float)param <= sumlimitIMax())
		{
			scpi_iSet =(float) param/(slaveNumber + 1);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query memoryNumber of vSet
*/
scpi_result_t SCPI_queryMemoryNumberOfVSet(scpi_t * context) {
    uint16_t tempValue;
	uint8_t temps1[10];
	float temp;
	eepRead((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (memoryNumber) * SIZEOF_MEM_PACKET + EE_VSET ,sizeof(uint16_t));
	temp = (tempValue * master.vMax)/fullScale;
	sprintf((void *)temps1,(void *)voltDisp[voltPoint],temp);
	temp = atof((void *)temps1);
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],temp ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set memoryNumber	of vSet
*/

scpi_result_t SCPI_setMemoryNumberOfVSet(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= master.limitVMin || (float)param <= master.limitVMax)
		{
			scpi_vSet = (float)param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   save iSet & vSet to memoryNumber of groupNumber
*/
scpi_result_t SCPI_saveMemoryNumberOfVSetISettoEeprom(scpi_t * context) {
    uint16_t tempValue;
	tempValue = convertFloatToInt(scpi_vSet, master.vMax, fullScale);
	eepWrite((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (memoryNumber) * SIZEOF_MEM_PACKET + EE_VSET ,sizeof(uint16_t));
	tempValue = convertFloatToInt(scpi_iSet, master.iMax, fullScale);
	eepWrite((uint8_t *)&tempValue,EE_MEMORY_GROUP + (groupNumber * TOTALNUMBER * SIZEOF_MEM_PACKET) + (memoryNumber) * SIZEOF_MEM_PACKET + EE_ISET ,sizeof(uint16_t));
	return SCPI_RES_OK;
}




/*
   query onoffStatus
*/
scpi_result_t SCPI_queryOnoffStatus(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	if (outputStatus & ON_STATE)
		onoffStatus = 1;
	else
		onoffStatus = 0;
	param1.type = returnONOFF(onoffStatus);			
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
extern uint8_t programStart;

void initializePVSState(void);
/*
   Set onoffStatus
*/
scpi_result_t SCPI_setOnoffStatus(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	
		{
			if (OVPOccurred == 0 && OCPOccurred == 0 && OPPOccurred == 0 && VCPOccurred == 0 && CVPOccurred	== 0 && !(IS_MODEL_CONFLICT) )
			{
				if (param1.value == 1)
					onoffStatus = 0;
				else
					onoffStatus = 1;
				if (programONOFF > OFF)
					programStart = onoffStatus;
				lastLastLastState = lastLastState;
				lastLastState = lastState;
				lastState = actualState;
				actualState = SET_ONOFF_FLAG; //
				SET_CHANGE;
				initializePVSState();
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}



/*
   query SRvSet
*/
scpi_result_t SCPI_querySRvSet(scpi_t * context) {
	clearMeasureCommand();
	if (queryStepByStep(MEASURE_CHANNEL, VSRQ_CMD,VSRR_CMD ,20) == SUCCESS) // varify
	{
		sprintf((void *)(transBuffer),"%4.1f\r\n",master.SRvSet ); // 1.30
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		return SCPI_RES_OK;
	}
	else
		return SCPI_RES_ERR;
}
/*
   Set SRvSet
*/

scpi_result_t SCPI_setSRvSet(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= VSRMIN && (float)param <= VSRMax)	{  // 0.1mV~4mv
			master.SRvSet = (float)param;
			verifyInput(VSRSET_CMD,master.SRvSet );// send SRvSet
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query SRiSet
*/
scpi_result_t SCPI_querySRiSet(scpi_t * context) {
	clearMeasureCommand();
	if (queryStepByStep(MEASURE_CHANNEL, ISRQ_CMD,ISRR_CMD ,20) == SUCCESS) // varify
	{
		sprintf((void *)(transBuffer),"%4.1f\r\n",master.SRiSet ); // 1.30
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		return SCPI_RES_OK;
	}
	else
		return SCPI_RES_ERR;

}
/*
   Set SRiSet
*/

scpi_result_t SCPI_setSRiSet(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= ISRMIN && (float)param <= ISRMax)	{  //0.3mA~20mA
			master.SRiSet = (float)param;
			verifyInput(ISRSET_CMD,master.SRiSet );// send SRiSet
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query outputStatus

#define ON_STATE			BIT15
#define CV_STATE			BIT14
#define CC_STATE			BIT13
#define CP_STATE			BIT12
#define OVP_STATE			BIT11
#define OCP_STATE			BIT10
#define OPP_STATE			BIT9
#define CV_CC_STATE			BIT8
#define CC_CV_STATE			BIT7
#define CAL_BUSY_STATE		BIT6


*/
scpi_result_t SCPI_queryOutputStatus(scpi_t * context) {
	if (outputStatus & ON_STATE)
	{
		if (VFDsign & sign_CC)//if (outputStatus & CC_STATE)
			sprintf((void *)transBuffer,"CC\r\n");
 		if (VFDsign & sign_CV)//if (outputStatus & CV_STATE)
			sprintf((void *)transBuffer,"CV\r\n");
		if (~(outputStatus & CC_STATE) )
		{
			if (~(outputStatus & CV_STATE) )
				strcat((void *)transBuffer, "\r\n");
		}
	}
	else
		sprintf((void *)transBuffer,"OFF\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}



/*
   query programGroup
*/
scpi_result_t SCPI_queryProgramGroup(scpi_t * context) {
//	SCPI_ResultInt(context,  programGroup);
	sprintf((void *)transBuffer ,"%d\r\n",programGroup);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set programGroup
*/

scpi_result_t SCPI_setProgramGroup(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param > 0 && param < 10)  // 1 ~ 9
		{
			programGroup = param;
			eepWrite((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t)); // 0 OŦ ҥHq+1}l
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query linkNumberGroup
*/
scpi_result_t SCPI_queryLinkNumberGroup(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",linkNumberGroup[programGroup]);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set linkNumberGroup
*/

scpi_result_t SCPI_setLinkNumberGroup(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER) && (param1.value >= 0 && param1.value <10))	{
			linkNumberGroup[programGroup] = param1.value;
			eepWrite((uint8_t *)&linkNumberGroup[programGroup] , (uint16_t)(EE_LINKNUMBERGROUP + programGroup * sizeof(uint8_t)) ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}

/*
   query repeatGroup
*/
scpi_result_t SCPI_queryRepeatGroup(scpi_t * context) {
//	SCPI_ResultInt(context,  repeatGroup[programGroup]);
	sprintf((void *)transBuffer ,"%d\r\n",repeatGroup[programGroup]);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set repeatGroup
*/

scpi_result_t SCPI_setRepeatGroup(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param >= 0 && param < 100)
		{
			repeatGroup[programGroup] = param;
			eepWrite((uint8_t *)&repeatGroup[programGroup] , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   clear parameter of n programGroup
*/
scpi_result_t SCPI_clearParamOfNParameter(scpi_t * context) {
	clearProgram(programGroup);
	return SCPI_RES_OK;
}


/*
   clear parameter of n programGroup
*/
scpi_result_t SCPI_clearAllParamOfNParameter(scpi_t * context) {
	for (programGroup = 1;programGroup < 10;programGroup++)
		 clearProgram(programGroup);
	programGroup = 1;
	eepWrite((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t));
  	return SCPI_RES_OK;
}

extern uint8_t programStart;
/* 
  query programRun

  */
scpi_result_t SCPI_queryProgramRun(scpi_t * context){

	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(programStart);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));

	return SCPI_RES_OK;
}


/* 
  query programONOFF

  */
scpi_result_t SCPI_queryProgramONOFF(scpi_t * context){

	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(programONOFF);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;


}


/*
   Set programONOFF
*/

scpi_result_t SCPI_setProgramONOFF(scpi_t * context) {

	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			programONOFF = param1.value;
			programONOFFTemp = programONOFF;
			programGroupTemp = programGroup;
			eepWrite((uint8_t *)&programGroup ,(uint16_t)(EE_PROGRAMGROUP + 1),sizeof(uint8_t)); // 0 OŦ ҥHq+1}l
			lastLastLastState = lastLastState;
			lastLastState = lastState;
			lastState = actualState;
		    if (programONOFF == ON)  //  programONOFF = ON ֫] ִNDv
			{    
				parallelMode = OFF;
				eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
				chainMode = OFF;
				VFDsign &=  ~(sign_ADDR);
				eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
			    timerONOFF = OFF;
				pvsONOFF = OFF;
				sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

				extEnable = OFF;
				eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
				extVMode = 0;
				eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
				extIMode = 0;
				eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));

				actualState = PROGRAMREADY;
				// = 1; // ] group 0  }OťX   1 ~ 9	i
				eepRead((uint8_t *)&totalRepeat , (uint16_t)(EE_PROGRAMGROUP_REPEAT + programGroup * sizeof(uint16_t)) ,sizeof(uint16_t));
				step = 0;
				repeat = totalRepeat;
				cursorPatternPosition = 0;
			  setVFDFlashOff(0x40, 48);
				cursorPosition = 0;
				getFirstStepProgram();							
			}								
			else  // programONOFF = OFF
			{
			   actualState = D_NORMAL;
			   programState = 4;	//stop
			   programStart = 0;
			   TIM_Cmd(TIM2, DISABLE);
			   VFDsign &= ~(sign_STAR);
			   onoffStatus = 0;
			   verifyInput(OUTPUT_CMD,(float)onoffStatus );
			}
 			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query SetpProgramStep
*/
scpi_result_t SCPI_querySetpProgramStep(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",step + 1);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set SetpProgramStep
*/

scpi_result_t SCPI_setSetpProgramStep(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		param--;
		if (param >= 0 && param <= 99)
		{
			step = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   Set SetpProgramStepEND	 @XB
   PROG:TOTA 
*/

scpi_result_t SCPI_setSetpProgramStepEND(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		param--;
		if (param >= 1 && param <= 100)
		{
			uint8_t temp = END;// END
			eepWrite(&temp , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + (param) * SIZEOF_STEP_PACKET + EE_PROGRAM_ACT) ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
/*
   query SetpProgramStep
*/
scpi_result_t SCPI_querySetpProgramStepEND(scpi_t * context) {
	uint8_t temp , act;
	for (temp = 0; temp < 100 ;temp++)
	{
		eepRead(&act , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + (temp) * SIZEOF_STEP_PACKET + EE_PROGRAM_ACT) ,sizeof(uint8_t));
		if (act == END) // END
		{
			break;
		}
	}
	if (temp == 100)
	{
		temp = 0;	// no end
	    sprintf((void *)transBuffer ,"%d\r\n",temp );
	}
	else
		sprintf((void *)transBuffer ,"%d\r\n",temp + 1);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}





/*
   query SetpprogramAction
*/
scpi_result_t SCPI_queryStepProgramAction(scpi_t * context) {

	scpi_number_t param1;
	char bf[15];
	eepRead(&programParameter[PROG_ACT] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_ACT) ,sizeof(uint8_t));
	switch(programParameter[PROG_ACT])
	{
		case OFF:
			param1.type = SCPI_PARM_OFF;
			break;
		case ON:
			param1.type = SCPI_PARM_ON;
			break;
		case NAC:
			param1.type = SCPI_PARM_NAC;
			break;
		case END:
			param1.type = SCPI_PARM_END;
			break;

	} 
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set StepprogramAction
*/

scpi_result_t SCPI_setStepProgramAction(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON || param1.type == SCPI_PARM_NAC || param1.type == SCPI_PARM_END )&& (param1.value <= END))	{
			programParameter[PROG_ACT] = param1.value;
			eepWrite(&programParameter[PROG_ACT] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_ACT) ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}


/*
   query SetpprogramVoltage
*/
scpi_result_t SCPI_queryStepProgramVoltage(scpi_t * context) {
	float tempfloat;
	int8_t temps1[10];
	eepRead(&programParameter[PROG_VOLTAGE] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_VOLTAGE) ,sizeof(uint16_t));
	tempfloat = ((*(uint16_t *)(programParameter + PROG_VOLTAGE)) * master.vMax)/fullScale;
	sprintf((void *)temps1,(void *)voltDisp[voltPoint],tempfloat);
	tempfloat = atof((void *)temps1);
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],tempfloat ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set StepprogramVoltage
*/

scpi_result_t SCPI_setStepProgramVoltage(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= master.limitVMin && (float)param <= master.limitVMax)
		{
			voltage = (float)param;
			*(uint16_t *)(programParameter + PROG_VOLTAGE) = convertFloatToInt(voltage, master.vMax, fullScale);
			eepWrite(&programParameter[PROG_VOLTAGE] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_VOLTAGE) ,sizeof(uint16_t));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

		 
/*
   query SetpprogramCurrent
*/
scpi_result_t SCPI_queryStepProgramCurrent(scpi_t * context) {
	float tempfloat;
	int8_t temps1[10];
	eepRead(&programParameter[PROG_CURRENT] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_CURRENT) ,sizeof(uint16_t));
	if (specif == V_600)
	{
		float buffer , buffer1;
		buffer1 = *(uint16_t *)(programParameter + PROG_CURRENT); 
		buffer = roundDigit(buffer1* 42925 /fullScale ,0);
		tempfloat = buffer * around ;
	}
	else	
		tempfloat = ((*(uint16_t *)(programParameter + PROG_CURRENT)) * master.iMax)/fullScale;
	sprintf((void *)temps1,(void *)currDisp[currPoint],tempfloat);
	tempfloat = atof((void *)temps1);
//	sprintf((void *)(transBuffer),"%.4e\r\n",iSet );
	sprintf((void *)(transBuffer),"%7.4f\r\n",tempfloat );
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set StepprogramCurrent
*/
//double param10;
scpi_result_t SCPI_setStepProgramCurrent(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= sumlimitIMin() && (float)param <= sumlimitIMax())
		{
			current = round((float)param,around);
			*(uint16_t *)(programParameter + PROG_CURRENT) = convertFloatToInt(current, master.iMax, fullScale);
			eepWrite(&programParameter[PROG_CURRENT] , (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_CURRENT) ,sizeof(uint16_t));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
		 
/*
   query SetpprogramTimer
*/
scpi_result_t SCPI_queryStepProgramTimer(scpi_t * context) {
	float tempfloat;
	eepRead(&programParameter[PROG_TIMER], (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_TIMER) ,sizeof(uint16_t));
	programRunningTimer = *(uint16_t *)(programParameter + PROG_TIMER);
	tempfloat = programRunningTimer;
	tempfloat /= 10;
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],tempfloat  ); // 1.30
	strcat((void *)(transBuffer),"\r\n");

	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set StepprogramTimer
*/

scpi_result_t SCPI_setStepProgramTimer(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param <= 6000)
		{
			timer = (float)param;
			*(uint16_t *)(programParameter + PROG_TIMER) = timer * 10;
			eepWrite(&programParameter[PROG_TIMER], (uint16_t)((SIZEOF_STEP_PACKET * STEPMAX) * programGroup + step * SIZEOF_STEP_PACKET + EE_PROGRAM_TIMER) ,sizeof(uint16_t));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


/*
   query timerONOFF
*/
scpi_result_t SCPI_queryTimerONOFF(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(timerONOFF);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set timerONOFF
*/

scpi_result_t SCPI_setTimerONOFF(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			timerONOFF = param1.value;
			if (timerONOFF == ON)	   // timerONOFF = ON
			{
			  programONOFF = OFF;
				pvsONOFF = OFF;
				sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// D0 pvs mode on/off

				extEnable = OFF;
				eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
				extVMode = 0;
				eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
				extIMode = 0;
				eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
//				parallelMode = OFF;
//				eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
				chainMode = OFF;
				VFDsign &=  ~(sign_ADDR);
				eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		return SCPI_RES_ERR;
		}					 
	}
}



/*
   query timerHR
*/
scpi_result_t SCPI_queryTimerHR(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",timerHR);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set timerHR
*/

scpi_result_t SCPI_setTimerHR(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param < 1000)
		{
			timerHR = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query timerMN
*/
scpi_result_t SCPI_queryTimerMN(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",timerMN);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set timerMN
*/

scpi_result_t SCPI_setTimerMN(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param < 60)
		{
			timerMN = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query timerSE
*/
scpi_result_t SCPI_queryTimerSE(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n",timerSE);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set timerSE
*/

scpi_result_t SCPI_setTimerSE(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param < 60)
		{
			timerSE = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query beepActivation
*/
scpi_result_t SCPI_queryBeepActivation(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(beepActivation);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set beepActivation
*/

scpi_result_t SCPI_setBeepActivation(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
				beepActivation = param1.value;
				eepWrite((uint8_t *)&beepActivation, EE_BEEPACTIVATION , sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}


/*
   query GPIBAddr
*/
scpi_result_t SCPI_queryGPIBAddr(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n", GPIBAddr);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set GPIBAddr
*/

scpi_result_t SCPI_setGPIBAddr(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param >= 1 && param <= 30)
		{
			GPIBAddr = param;
			verifyGPIBLANInput(GPIBADDR_CMD,GPIBAddr,NULL,NULL,NULL,NULL,NULL);
			eepWrite((uint8_t *)&GPIBAddr, EE_GPIBADDR,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query LANIPMode
*/
scpi_result_t SCPI_queryLANIPMode(scpi_t * context) {
	scpi_number_t param1;
	char bf[15];
	switch(LANIPMode)
	{
		case 0:
			param1.type = SCPI_PARM_AUTO;
			break;
		case 1:
			param1.type = SCPI_PARM_MANUAL;
			break;
	} 
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set LANIPMode
*/

scpi_result_t SCPI_setLANIPMode(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_STATIC || param1.type == SCPI_PARM_MANUAL || param1.type == SCPI_PARM_AUTO || param1.type == SCPI_PARM_DHCP) && (param1.value < 2)) 
		{	
			LANIPMode = param1.value;
			LANIPMode ^= 0x01;	 //ϦV tX
			eepWrite((uint8_t *)&LANIPMode, EE_LANIPMODE,sizeof(uint8_t));
			GPIBLANRestart();
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query groupNumber
*/
scpi_result_t SCPI_queryGroupNumber(scpi_t * context) {
	sprintf((void *)transBuffer ,"%d\r\n", groupNumber);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set groupNumber
*/

scpi_result_t SCPI_setGroupNumber(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param < 10)
		{
			groupNumber = param;
			eepWrite((uint8_t *)&groupNumber, EE_GROUPNUMBER ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
								

/*
   query CurrentIPAddr
*/
scpi_result_t SCPI_queryCurrentIPAddr(scpi_t * context) {
	sprintf((void *)(transBuffer),"%.3d.%.3d.%.3d.%.3d\r\n",currentLANIPAddr[0],currentLANIPAddr[1],currentLANIPAddr[2],currentLANIPAddr[3]);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set CurrentIPAddr
*/

scpi_result_t SCPI_setCurrentIPAddr(scpi_t * context) {

	int32_t param1,param2,param3,param4; 
	IP_Point = 1;
    if (!SCPI_ParamInt(context, &param1, TRUE)) { 
	    IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param2, TRUE)) { 
	    IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param3, TRUE)) {
	    IP_Point = 0; 
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param4, TRUE)) { 
	    IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
	if (param1 < 256 && param2 < 256 && param3 < 256 && param4 < 256)
	{
		LANIPAddr[0] = param1;
		LANIPAddr[1] = param2;
		LANIPAddr[2] = param3;
		LANIPAddr[3] = param4;
		if (LANIPMode == 1) //MANUAL
			eepWrite((uint8_t *)&currentLANIPAddr, EE_LANIPADDR ,4);
		GPIBLANRestart();// GPIB LAN}	
		IP_Point = 0;
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		IP_Point = 0;
		return SCPI_RES_ERR;
	}					 
}
								

/*
   query CurrentMask
*/
scpi_result_t SCPI_queryCurrentMask(scpi_t * context) {
	sprintf((void *)(transBuffer),"%.3d.%.3d.%.3d.%.3d\r\n",currentLANMask[0],currentLANMask[1],currentLANMask[2],currentLANMask[3]);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set CurrentMask
*/

scpi_result_t SCPI_setCurrentMask(scpi_t * context) {
	int32_t param1,param2,param3,param4;
	IP_Point = 1;
    if (!SCPI_ParamInt(context, &param1, TRUE)) { 
	    IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param2, TRUE)) { 
	    IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param3, TRUE)) {
	    IP_Point = 0; 
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param4, TRUE)) {
	     IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
	if (param1 < 256 && param2 < 256 && param3 < 256 && param4 < 256)
	{
		LANMask[0] = param1;
		LANMask[1] = param2;
		LANMask[2] = param3;
		LANMask[3] = param4;
		if (LANIPMode == 1) //MANUAL
			eepWrite((uint8_t *)&currentLANMask, EE_LANMASK ,4);
		GPIBLANRestart();
		IP_Point = 0;
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		IP_Point = 0;
		return SCPI_RES_ERR;
	}					 
	
}
								

/*
   query CurrentGateway
*/
scpi_result_t SCPI_queryCurrentGateway(scpi_t * context) {
	sprintf((void *)(transBuffer),"%.3d.%.3d.%.3d.%.3d\r\n",currentLANGateway[0],currentLANGateway[1],currentLANGateway[2],currentLANGateway[3]);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set CurrentGateway
*/

scpi_result_t SCPI_setCurrentGateway(scpi_t * context) {
	int32_t param1,param2,param3,param4;
	IP_Point = 1;
    if (!SCPI_ParamInt(context, &param1, TRUE)) {  
	   	IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param2, TRUE)) {
	    IP_Point = 0; 
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param3, TRUE)) { 
	    IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
    if (!SCPI_ParamInt(context, &param4, TRUE)) {  
	   	IP_Point = 0;
		return SCPI_RES_ERR;											 
    }
	if (param1 < 256 && param2 < 256 && param3 < 256 && param4 < 256)
	{
		LANGateway[0] = param1;
		LANGateway[1] = param2;
		LANGateway[2] = param3;
		LANGateway[3] = param4;
		if (LANIPMode == 1) //MANUAL
			eepWrite((uint8_t *)&currentLANGateway, EE_LANGATEWAY,4);
		GPIBLANRestart();
		IP_Point = 0;
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		IP_Point = 0;
		return SCPI_RES_ERR;
	}					 
	
}
								

/*
   query lockStatus
*/
scpi_result_t SCPI_queryLockStatus(scpi_t * context) {
//	SCPI_ResultInt(context,  lockStatus);

	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(lockStatus);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set lockStatus
*/

scpi_result_t SCPI_setLockStatus(scpi_t * context) {

	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			lockStatus = param1.value;
			if (lockStatus)
				VFDsign = VFDsign | sign_LOCK;
			else
				VFDsign = VFDsign & ~(sign_LOCK);
			printVFDsign();
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
					


/*
   query powerOnVolt
*/
scpi_result_t SCPI_queryPowerOnVolt(scpi_t * context) {
	sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],powerOnVolt ); // 1.30
	strcat((void *)(transBuffer),"\r\n");
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set powerOnVolt
*/

scpi_result_t SCPI_setPowerOnVolt(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= master.limitVMin && (float)param <= master.limitVMax)	{  
			powerOnVolt = (float)param;
			eepWrite((uint8_t *)&powerOnVolt, EE_POWERONVOLT ,sizeof(float));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query powerOnCurrent
*/
scpi_result_t SCPI_queryPowerOnCurrent(scpi_t * context) {
	sprintf((void *)(transBuffer),"%7.4f\r\n",powerOnCurrent );	// 1.30
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set powerOnVolt
*/

scpi_result_t SCPI_setPowerOnCurrent(scpi_t * context) {
	double param;
    if (!SCPI_ParamDouble(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((float)param >= sumlimitIMin() && (float)param <= sumlimitIMax())	{  
			powerOnCurrent = param;
			eepWrite((uint8_t *)&powerOnCurrent, EE_POWERONCURRENT ,sizeof(float));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   query powerOnMode
*/
scpi_result_t SCPI_queryPowerOnMode(scpi_t * context) {

	scpi_number_t param1;
	char bf[15];
	switch(powerOnMode)
	{
		case 0:
			param1.type = SCPI_PARM_OFF;
			break;
		case 1:
			param1.type = SCPI_PARM_LAST;
			break;
		case 2:
			param1.type = SCPI_PARM_USER;
			break;
	} 
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
/*
   Set powerOnMode
*/

scpi_result_t SCPI_setPowerOnMode(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_LAST || param1.type == SCPI_PARM_USER )&& (param1.value < 3))	{
			if (param1.value > 0)
				powerOnMode = param1.value ;
			else
				powerOnMode = param1.value;
			eepWrite((uint8_t *)&powerOnMode, EE_POWERONMODE ,sizeof(uint8_t));
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
					
/*
   query powerOn_OnOff
*/
scpi_result_t SCPI_queryPowerOn_OnOff(scpi_t * context) {
	scpi_number_t param1;
	char bf[15]; 
	param1.type = returnONOFF(powerOn_OnOff);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
/*
   Set powerOn_OnOff
*/

scpi_result_t SCPI_setPowerOn_OnOff(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
			powerOn_OnOff = param1.value;
			eepWrite((uint8_t *)&powerOn_OnOff, EE_POWERON_ONOFF ,sizeof(uint8_t)); // user on off control
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
					
/*
   recall factory default setting
*/
scpi_result_t SCPI_recallFactoryDefaultSetting(scpi_t * context) {
	 eepromDefaultSet();
	return SCPI_RES_OK;
}



/*
   query R485Baud
*/
scpi_result_t SCPI_queryR485Baud(scpi_t * context) {

	scpi_number_t param1;
    char bf[15];
		switch(R485Baud)
	{
		case 0:
			param1.type = SCPI_PARM_9600;
			break;
		case 1:
			param1.type = SCPI_PARM_19200;
			break;
		case 2:
			param1.type = SCPI_PARM_38400;
			break;
		case 3:
			param1.type = SCPI_PARM_57600;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;	
}
/*
   Set R485Baud
*/

scpi_result_t SCPI_setR485Baud(scpi_t * context) {

	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_9600 || param1.type == SCPI_PARM_19200 || param1.type == SCPI_PARM_38400 || param1.type == SCPI_PARM_57600)&& (param1.value < 4))	{
			R485Baud = param1.value ;
			eepWrite((uint8_t *)&R485Baud, EE_R485BAUD ,sizeof(uint8_t)); // 
			initializeRs485();

			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}


}

/*
   query rs485parityDataBits
*/
scpi_result_t SCPI_queryRs485parityDataBits(scpi_t * context) {

	scpi_number_t param1;
    char bf[15];
		switch(rs485parityDataBits)
	{
		case 0:
			param1.type = SCPI_PARM_NONE8;
			break;
		case 1:
			param1.type = SCPI_PARM_EVEN8;
			break;
		case 2:
			param1.type = SCPI_PARM_ODD8;
			break;
		case 3:
			param1.type = SCPI_PARM_EVEN7;
			break;
		case 4:
			param1.type = SCPI_PARM_ODD7;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;	
}
/*
   Set rs485parityDataBits
*/

scpi_result_t SCPI_setRs485parityDataBits(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_NONE8 || param1.type == SCPI_PARM_EVEN8 || param1.type == SCPI_PARM_ODD8 || param1.type == SCPI_PARM_EVEN7 || param1.type == SCPI_PARM_ODD7)&& (param1.value < 5))	{
			rs485parityDataBits = param1.value;
			eepWrite((uint8_t *)&rs485parityDataBits, EE_RS485PARITYDATABITS ,sizeof(uint8_t)); //
			initializeRs485();
			return SCPI_RES_OK; 
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}
/*
   query rs485stopBits
*/
scpi_result_t SCPI_queryRs485stopBits(scpi_t * context) {


	sprintf((void *)transBuffer ,"%d\r\n", (rs485stopBits + 1));
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;



}
/*
   Set rs485stopBits
*/

scpi_result_t SCPI_setRs485stopBits(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ( param == 1 ||  param == 2)
		{
			rs485stopBits = param - 1;
			eepWrite((uint8_t *)&rs485stopBits, EE_RS485STOPBITS ,sizeof(uint8_t)); //
			initializeRs485();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}


}

/*
  query master.pMax
*/

scpi_result_t SCPI_queryPMAX(scpi_t * context) {
	sprintf((void *)transBuffer ,"%6.1f\r\n", master.pMax);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}		

/*
  query currentSourceState
*/

scpi_result_t SCPI_queryCurrentSourceState(scpi_t * context) {
	checkCurrentSource();	
	sprintf((void *)transBuffer ,"%d,%d\r\n", currentSourceState,ADCDualConvertedValue[1]);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}		
/*
   query R232Baud
*/
scpi_result_t SCPI_queryR232Baud(scpi_t * context) {
	scpi_number_t param1;
    char bf[15];
		switch(R232Baud)
	{
		case 0:
			param1.type = SCPI_PARM_9600;
			break;
		case 1:
			param1.type = SCPI_PARM_19200;
			break;
		case 2:
			param1.type = SCPI_PARM_38400;
			break;
		case 3:
			param1.type = SCPI_PARM_57600;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;	
}
/*
   Set R232Baud
*/

scpi_result_t SCPI_setR232Baud(scpi_t * context) {

	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_9600 || param1.type == SCPI_PARM_19200 || param1.type == SCPI_PARM_38400 || param1.type == SCPI_PARM_57600)&& (param1.value < 4))	{
			R232Baud = param1.value;
			eepWrite((uint8_t *)&R232Baud, EE_R232BAUD ,sizeof(uint8_t)); // 
			initializeRs232();

			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}

/*
   query rs232parityDataBits
*/
scpi_result_t SCPI_queryRs232parityDataBits(scpi_t * context) {
	scpi_number_t param1;
    char bf[15];
		switch(rs232parityDataBits)
	{
		case 0:
			param1.type = SCPI_PARM_NONE8;
			break;
		case 1:
			param1.type = SCPI_PARM_EVEN8;
			break;
		case 2:
			param1.type = SCPI_PARM_ODD8;
			break;
		case 3:
			param1.type = SCPI_PARM_EVEN7;
			break;
		case 4:
			param1.type = SCPI_PARM_ODD7;
			break;
	}
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;	

}
/*
   Set rs232parityDataBits
*/

scpi_result_t SCPI_setRs232parityDataBits(scpi_t * context) {
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_NONE8 || param1.type == SCPI_PARM_EVEN8 || param1.type == SCPI_PARM_ODD8 || param1.type == SCPI_PARM_EVEN7 || param1.type == SCPI_PARM_ODD7)&& (param1.value < 5))	{
			rs232parityDataBits = param1.value ;
			eepWrite((uint8_t *)&rs232parityDataBits, EE_RS232PARITYDATABITS ,sizeof(uint8_t)); //
			initializeRs232();
			return SCPI_RES_OK; 
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}
/*
   query rs232stopBits
*/
scpi_result_t SCPI_queryRs232stopBits(scpi_t * context) {


	sprintf((void *)transBuffer ,"%d\r\n", (rs232stopBits + 1));
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;


}
/*
   Set rs232stopBits
*/

scpi_result_t SCPI_setRs232stopBits(scpi_t * context) {
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ( param ==  1 ||  param == 2)
		{
			rs232stopBits = param - 1;
			eepWrite((uint8_t *)&rs232stopBits, EE_RS232STOPBITS ,sizeof(uint8_t)); //
			initializeRs232();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}


}

		
/*
   query serialNumber
*/

scpi_result_t SCPI_querySerialNumber(scpi_t * context) {
	uint8_t bf[23];
	memset((void *)bf,0,23);
	strcpy((void *)bf ,(void *)serialNumber);
	strcat((void *)bf ,"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
uint8_t paramBuffer[20];
		
/*
   set serialNumber
*/
scpi_result_t SCPI_setSerialNumber(scpi_t * context) {
		memset((void *)paramBuffer,0,20);
    	if (!SCPI_ParamAscii(context, &paramBuffer[0], TRUE)) {     
			return SCPI_RES_ERR;											 
    	}
		else{
			eepWrite((uint8_t *)&paramBuffer, EE_SERIALNUMBER ,20);
			eepRead((uint8_t *)&serialNumber, EE_SERIALNUMBER ,20);
		}
	return SCPI_RES_OK;
}


/*
   query Manufacture
*/

scpi_result_t SCPI_queryManufacture(scpi_t * context) {
	uint8_t bf[23];
	memset((void *)bf,0,23);
	strcpy((void *)bf ,(void *)manufacture);
	strcat((void *)bf ,"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}

/*
   set Manufacture
*/
scpi_result_t SCPI_setManufacture(scpi_t * context) {
		memset((void *)paramBuffer,0,20);
    	if (!SCPI_ParamAscii(context, &paramBuffer[0], TRUE)) {     
			return SCPI_RES_ERR;											 
    	}
		else{
			eepWrite((uint8_t *)&paramBuffer, EE_MANUFACTURE ,20);
			writePatternChecksum();
			eepRead((uint8_t *)&manufacture, EE_MANUFACTURE ,20);
		}
	return SCPI_RES_OK;
}

/*
   query Model
*/



/*
   set Model
*/
scpi_result_t SCPI_setModel(scpi_t * context) {
		memset((void *)paramBuffer,0,20);
    	if (!SCPI_ParamAscii(context, &paramBuffer[0], TRUE)) {     
			return SCPI_RES_ERR;											 
    	}
		else{
			eepWrite((uint8_t *)&paramBuffer, EE_MODEL ,20);
			writePatternChecksum();
			eepRead((uint8_t *)&model, EE_MODEL ,20);
		}
	return SCPI_RES_OK;
}


/*
   query Key
*/

scpi_result_t SCPI_queryKey(scpi_t * context) {
	uint8_t bf[4];
	memset((void *)bf,0,4);
	bf[0] = keyType + 0x30;
	strcat((void *)bf ,"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}

/*
   set Key
*/
scpi_result_t SCPI_setKey(scpi_t * context) {

	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ( param < 2)
		{
			keyType = param;
			eepWrite((uint8_t *)&keyType, EE_KEYTYPE ,sizeof(uint8_t)); //
			writePatternChecksum();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}









/*
   query MACaddress
*/
extern uint8_t MACaddress[6];
scpi_result_t SCPI_queryMACaddress(scpi_t * context) {
	uint8_t bf[20];
	sprintf((void *)bf,"%02X:%02X:%02X:%02X:%02X:%02X\r\n",MACaddress[0],MACaddress[1],MACaddress[2],MACaddress[3],MACaddress[4],MACaddress[5]);
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
		

int ascii_to_hex(char ch)
{
	char ch_tmp;
	int hex_val = -1;
	// Nrনpg, o˴NΦAP_jpg
	ch_tmp = tolower(ch);
	// asciiX '0' ~ '9'OsƦb@_, 'a' ~ 'z']OsƤ@_
	// ]NO '1' = '0' + 1, 'b' = 'a' + 1
	// QγoӯSʨӰasciiMhexഫ
	if ((ch_tmp >= '0') && (ch_tmp <= '9'))
 	{
		// JasciiXO'0' ~ '9'
		hex_val = ch_tmp - '0';
	}
	else if ((ch_tmp >= 'a') && (ch_tmp <= 'f'))
	{
		// JasciiXO'a' ~ 'f'
		hex_val = ch_tmp - 'a' + 10;
	}
	return hex_val;
}
/*
   set MACaddress
   	00:17:F8:XX:XX:XX
*/

scpi_result_t SCPI_setMACaddress(scpi_t * context) {
		memset((void *)paramBuffer,0,20);
    	if (!SCPI_ParamAscii(context, &paramBuffer[0], TRUE)) {     
			return SCPI_RES_ERR;											 
    	}
		else{
			uint8_t i;
			for(i = 0;i < 6; i++)
			{
				if (ascii_to_hex(paramBuffer[i * 3]) != -1)
				{
					MACaddress[i] = ascii_to_hex(paramBuffer[i * 3]);
					MACaddress[i] <<= 4;
				}
				else
					return SCPI_RES_ERR;// Xkr
				if 	(ascii_to_hex(paramBuffer[i * 3 + 1]) != -1)
					MACaddress[i] |= ascii_to_hex(paramBuffer[i * 3 + 1]);
				else
					return SCPI_RES_ERR; // Xkr
			}
			eepWrite((uint8_t *)&MACaddress, EE_MACADDRESS ,sizeof(MACaddress));
			writePatternChecksum();
			eepRead((uint8_t *)&MACaddress, EE_MACADDRESS ,sizeof(MACaddress));
		}
	return SCPI_RES_OK;
}




void initGPIBLAN9600(void);
void initVCPUSB9600(void);



scpi_result_t SCPI_DownLoadE7(scpi_t * context) {
	disableGPIBLAN();
	delayMs(50);
	lastLastLastState = lastLastState;
	lastLastState = lastState;
	lastState = actualState;
	actualState = STARTDLE7;
	setVFDFlashOff(0x40, 48);
	cursorPosition = 0;
	transparentDEVICE = MEASURE_CHANNEL;
	if (witchCOM == USB_VCP_CHANNEL)
		transparentHOST = VCP_TO_COMport;
	else if(witchCOM == RS232_CHANNEL)
		transparentHOST = RS232_TO_COMport;
	else if(witchCOM == RS485_CHANNEL)
		transparentHOST = RS485_TO_COMport;
#ifdef 	I_WATCH_DOG
/* Reload IWDG counter */
    IWDG_ReloadCounter();  
#endif

	return SCPI_RES_OK;
}


scpi_result_t SCPI_DownLoadE1(scpi_t * context) {
	disableGPIBLAN();
	delayMs(50);
	lastLastLastState = lastLastState;
	lastLastState = lastState;
	lastState = actualState;
	actualState = STARTDLE1;
	setVFDFlashOff(0x40, 48);
	cursorPosition = 0;
	transparentDEVICE = MEASURE_CHANNEL;
	if (witchCOM == USB_VCP_CHANNEL)
		transparentHOST = VCP_TO_COMport;
	else if(witchCOM == RS232_CHANNEL)
		transparentHOST = RS232_TO_COMport;
	else if(witchCOM == RS485_CHANNEL)
		transparentHOST = RS485_TO_COMport;
#ifdef 	I_WATCH_DOG
/* Reload IWDG counter */
    IWDG_ReloadCounter();  
#endif

	return SCPI_RES_OK;
}
extern uint8_t GPIBStatus;
scpi_result_t SCPI_DownLoadEG(scpi_t * context) {

	GPIBStatus = 0;
	sendMBQuery(GPIB_LAN_CHANNEL,RST_REQ_CMD);// GPIB LAN}
	delayMs(200); 	  //GPIB}
	sendMBStateSetting(GPIB_LAN_CHANNEL,BOOT_CMD, 1); // GPIB LANiJ boot mode
	sendMBQuery(GPIB_LAN_CHANNEL,BOOTSTATEQ_CMD);	 // query GPIB Start?
	delayMs(15);
#ifdef 	I_WATCH_DOG
/* Reload IWDG counter */
    IWDG_ReloadCounter();  
#endif
	while (uartBuffer[GPIB_LAN_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[GPIB_LAN_CHANNEL].packetCount--;
		receiveMBResponse(GPIB_LAN_CHANNEL);
	}
	if (GPIBStatus == 1)
	{
		disableMeasure();
		lastLastLastState = lastLastState;
		lastLastState = lastState;
		lastState = actualState;
		actualState = STARTDLEG;
		setVFDFlashOff(0x40, 48);
		cursorPosition = 0;
		transparentDEVICE = GPIB_LAN_CHANNEL;
		if (witchCOM == USB_VCP_CHANNEL)
			transparentHOST = VCP_TO_COMport;
		else if(witchCOM == RS232_CHANNEL)
			transparentHOST = RS232_TO_COMport;
		else if(witchCOM == RS485_CHANNEL)
			transparentHOST = RS485_TO_COMport;
		initGPIBLAN9600();
#ifdef 	I_WATCH_DOG
/* Reload IWDG counter */
    IWDG_ReloadCounter();  
#endif
		return SCPI_RES_OK;	// yes GPIB in Boot
	}
	else
		return SCPI_RES_ERR;










//	return SCPI_RES_OK;
}

scpi_result_t SCPI_Restart(scpi_t * context) {
	NVIC_SystemReset(); // software reset
 	return SCPI_RES_OK;
}

	
scpi_result_t SCPI_abortCALAction(scpi_t * context) {
	scpiFinishCal();
	return SCPI_RES_OK;
}



scpi_result_t SCPI_queryPvsSelect(scpi_t * context){
	clearMeasureCommand();
	sendMBQuery(MEASURE_CHANNEL,PVSSTATEQ_CMD);	//D9 
	clearMeasureCommand();					   // receive DA
	sprintf((void *)(transBuffer),"%d\r\n", curve + 1);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}
// Set curve
scpi_result_t SCPI_setPvsCurveNum(scpi_t * context){
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param > 0 && param <= 101) || (param == 256)  )	// 1 ~ 101  (PC Host ) 
		{
			curve = param - 1;
			sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
			if(parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
			  masterState = BROADCAST;
				rs485Temp.unionbyte.byte_loc[0] = (uint8_t)param;
				rs485Temp.cmd = CMD_SETPVCURV;
				cmdexenum = MASTERSETINT8;
				processCmd(cmdexenum);
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}

// query curve
scpi_result_t SCPI_queryPvsCurveNum(scpi_t * context){

	sprintf((void *)(transBuffer),"%d\r\n", curve + 1);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}


//  curve select
scpi_result_t SCPI_setPvsSelect(scpi_t * context){
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param > 0 && param <= 101  || (param == 256) )	// 1 ~ 101  (PC Host ) 
		{
			curve = param - 1;
			sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}

// Query Rule Vmp Pmp Material
scpi_result_t SCPI_queryPvsCurveParam(scpi_t * context){
	queryCurveparrmeter();
	if (voltPoint == 1)
		sprintf((void *)(transBuffer),"%.1d,%6.1f,%6.1f,%.1d\r\n", (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
	else
		sprintf((void *)(transBuffer),"%.1d,%6.2f,%6.2f,%.1d\r\n", (uint8_t)Rule,Vmp,Pmp*(slaveNumber + 1),(uint8_t)Material);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));

	return SCPI_RES_OK;
}
// Set Rul Vmp Pmp Material
scpi_result_t SCPI_setPvsCurveParam(scpi_t * context){
	double param1,param2,param3,param4;

    // read first parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read second paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
    // read 3th parameter if present
    if (!SCPI_ParamDouble(context, &param3, true)) {
        return SCPI_RES_ERR;
    }
    // read 4th paraeter if present
    if (!SCPI_ParamDouble(context, &param4, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
	if ((uint8_t)param1 > 3 || (uint8_t)param1 < 1)
        return SCPI_RES_ERR;// Rule
	if (((float)param2 > master.limitVMax *0.95) || (float)param2 < master.limitVMin)
		return SCPI_RES_ERR;// Vmp
	if (((float)param3 > /* master.pMax */sumpMax()  *0.9) || (float)param3 < (master.limitVMin * sumlimitIMin()))
		return SCPI_RES_ERR;// Pmp
	if ((uint8_t)param1 == 2)//kW 2  Ѽu 1,2
	{
		if ((uint8_t)param4 > 3 || (uint8_t)param4 < 1)
        return SCPI_RES_ERR;// Material
	}
	else //kW 1,3  Ѽƥu 1,2
	{
		if ((uint8_t)param4 > 2 || (uint8_t)param4 < 1)
        return SCPI_RES_ERR;// Material
	}
	if (((float)param3 / (float)param2) > (sumlimitIMax() *0.95))
		return SCPI_RES_ERR; // Imp too high

	Rule = (float)param1;Vmp = (float)param2;Pmp = (float)param3/(slaveNumber + 1);Material = (float)param4;
	savePvsCurveParam();	 // D1
	return SCPI_RES_OK;
}

scpi_result_t SCPI_queryPvsPower(scpi_t * context){

	float temp;
	temp = percentage;
	temp /= 100;
	sprintf((void *)(transBuffer),"%6.2f\r\n", temp);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));

	return SCPI_RES_OK;
}
scpi_result_t SCPI_setPvsPower(scpi_t * context){

	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if ((param1.type == SCPI_NUM_NUMBER) &&  param1.value <= 100)
		{
			percentage = (uint16_t)param1.value * 100;
			sendMBIntSetting( PVSSIMPOWER_CMD, percentage);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}



scpi_result_t SCPI_queryPvsState(scpi_t * context){
	scpi_number_t param1;
	char bf[15];
	pvsONOFF = 0;
	clearMeasureCommand();
	sendMBQuery(MEASURE_CHANNEL,PVSSTATEQ_CMD);
	clearMeasureCommand();
	param1.type = returnONOFF(pvsONOFF);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
scpi_result_t SCPI_setPvsState(scpi_t * context){
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
//			sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
//			delayMs(50);
			pvsONOFF = param1.value;
			sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// pvs mode on/off
			if(parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
			{
			  	masterState = BROADCAST;
				rs485Temp.unionbyte.byte_loc[0] = pvsONOFF;
				rs485Temp.cmd = CMD_SETPVSTATE;
				cmdexenum = MASTERSETINT8;
			}
			if (pvsONOFF == ON)  // pvsONOFF = ON
			{
			    timerONOFF = OFF;
				programONOFF = OFF;
				extEnable = OFF;
				eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
				extVMode = 0;
				eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
				extIMode = 0;
				eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
			}
			else
			  checkPowerOnState(); // return vset iset
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


// Set the point number n of the user defined V/I table
scpi_result_t SCPI_setPvsTableNum(scpi_t * context){
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param > 0 && param <= 1024 )	// 1 ~ 1024
		{
			pvsPoint = param;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
// Query the parameters (point ,voltage and current) of the table point number n
scpi_result_t SCPI_queryPvsTableParam(scpi_t * context){
	clearMeasureCommand();
	sendMBIntSetting( PVSDEFNVIQ_CMD,pvsPoint);
	delayMs(5);
	clearMeasureCommand();
	if (voltPoint == 1)
		sprintf((void *)(transBuffer),"%d,%6.1f,%7.4f\r\n", pvsPoint,pvsVoltage,pvsCurrent);
	else
		sprintf((void *)(transBuffer),"%d,%6.2f,%7.4f\r\n", pvsPoint,pvsVoltage,pvsCurrent);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}


union	{ uint8_t byte_loc[4];uint16_t itob[2];   float ftob; } scpiunionbyte;


// Set the parameters (voltage and current) of the table point number n
scpi_result_t SCPI_setPvsTableParam(scpi_t * context){
	double param0,param1,param2;
    // read first parameter if present
    if (!SCPI_ParamDouble(context, &param0, true)) {
        return SCPI_RES_ERR;
    }
    // read first parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read second paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
   	if ((float)param1 < 0 || (float)param1 > master.limitVMax)
   	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		return SCPI_RES_ERR;
	}	
   	if ((float)param2 < 0 || (float)param2 > sumlimitIMax())
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		return SCPI_RES_ERR;
	}	
	pvsPoint = (uint16_t)param0 ;pvsVoltage = (float)param1; pvsCurrent = (float)param2;
//	clearMeasureCommand();//  receive ACK or NAK
	savePvsTableParam();
	return SCPI_RES_OK;
}

// Return the previous write status of table point, 0=not OK, 1=OK
scpi_result_t SCPI_queryPvsTableNumState(scpi_t * context){
	sprintf((void *)(transBuffer),"%1d\r\n", pvsTableNumState);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	pvsTableNumState = 0;// not OK
	return SCPI_RES_OK;
}
// Start the user defined V/I table loading
scpi_result_t SCPI_setPvsTableStart(scpi_t * context){
	sendMBQuery(MEASURE_CHANNEL,PVSSTARTLOAD_CMD);	// D3
	return SCPI_RES_OK;
}
// Stop the user defined V/I table loading
scpi_result_t SCPI_setPvsTableStop(scpi_t * context){
    sendMBQuery(MEASURE_CHANNEL,PVSSTOPLOAD_CMD);	// D5
	return SCPI_RES_OK;
}

// set pvsG pvsT
scpi_result_t SCPI_setPvsGT(scpi_t * context){
	scpi_number_t param1 ,param2;
	uint16_t param3;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	if (!SCPI_ParamNumber(context, &param2, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	
		if ((param2.type == SCPI_NUM_NUMBER) &&  param2.value <= 100)
		{
//			pvsG = (float)param1.value;
//			pvsT = (uint16_t)param2.value * 100;
			param3 = (float)param2.value * 100;
			sendMBIntSettingFloatInt16( PVSSIMGT_CMD, (float)param1.value,param3);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}


}
// set Vmp Pmp conversions to voc isc imp  //ram by pass data is ok
scpi_result_t SCPI_setPvsVmpPmp(scpi_t * context){
	scpi_number_t param1 ,param2;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	if (!SCPI_ParamNumber(context, &param2, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
//	pvsvmp = (float)param1.value;
//	pvspmp = (float)param2.value;
	sendMBIntSettingFloatFloat( PVSVMPPMP_CMD, (float)param1.value,(float)param2.value);
	return SCPI_RES_OK;
}

// set formula material

scpi_result_t SCPI_setPvsFormula(scpi_t * context){
	scpi_number_t param1 ,param2;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	if (!SCPI_ParamNumber(context, &param2, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	if ((param1.type == SCPI_NUM_NUMBER) && (param2.type == SCPI_NUM_NUMBER) &&  param1.value <= 3 &&  param2.value <= 3)
	{
//		pvsformula = (int8_t)param1.value;
//		pvsmaterial = (int8_t)param2.value;
		sendMBIntSettingInt8Int8( PVSFM_CMD, (int8_t)param1.value,(int8_t)param2.value);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
    	return SCPI_RES_ERR;
	}
}

// set VI table array number
scpi_result_t SCPI_setPvsTableArray(scpi_t * context){
	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	
	if (param1.value >= 128 && param1.value <= 4096)
	{
//		pvsarray = (int16_t)param1.value;
		sendMBIntSetting(PVSTABARRAY_CMD, (int16_t)param1.value);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	   	return SCPI_RES_ERR;
	}
}

// set pv sim control mode	  0: CC ,1: CV
scpi_result_t SCPI_setPvsControlMode(scpi_t * context){
	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	
	if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_CC || param1.type == SCPI_PARM_CV )&& (param1.value < 2))	   // CC or CV
	{
		pvCtrlMode = (uint8_t) param1.value;
		sendMBStateSetting(MEASURE_CHANNEL,PVCTRLMOD_CMD, pvCtrlMode);
	
		if (parallelMode == ON && parallelRole == MASTER && slaveNumber > 0)
		{
			masterState = BROADCAST;
			rs485Temp.unionbyte.byte_loc[0] = pvCtrlMode;
			rs485Temp.cmd = CMD_SETPVCTRLMOD;
			cmdexenum = MASTERSETINT8;
		}		
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	   	return SCPI_RES_ERR;
	}
}

// query pv sim control mode
scpi_result_t SCPI_queryPvsControlMode(scpi_t * context){
	scpi_number_t param1;
	char bf[15];
	pvCtrlMode = 0;
	sendMBQuery(MEASURE_CHANNEL,PVCTRLMODQ_CMD);	 //E3
	delayMs(30);
	while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
	{
		uartBuffer[MEASURE_CHANNEL].packetCount--;
		receiveMBResponse(MEASURE_CHANNEL);
	}
	switch(pvCtrlMode)
	{
		case 0:
			param1.type = SCPI_PARM_CC;
			break;
		case 1:
			param1.type = SCPI_PARM_CV;
			break;
	} 
    SCPI_NumberToStr(context, &param1, bf, 15);
	sprintf((void *)(transBuffer),"%s\r\n", bf);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}



#ifdef _PARALLEL_COMMAND





void SCPI_485SlaveCmd(uint8_t cmd)
{
	translate485Cmd(cmd,chainAddrSlave,chainAddr);	// chainaAddr QUERY chainAddrSlave
	if (rs485AnitCollisionBuffer.Count == 0)
		receivedRS485Packet();
}

void SCPI_485SlavePVTableParameter(uint8_t cmd ,uint8_t des ,uint16_t point,float volt ,float curr)
{
	unionbyte_TypeDef bpoint,buf,buf1;
	buf.ftob = volt;
	buf1.ftob = curr;
	bpoint.itob[0] = point;
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(uint16_t) +sizeof(float) + sizeof(float);
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = bpoint.byte_loc[1]; 
	rs485Packet.Data[1] = bpoint.byte_loc[0];
	rs485Packet.Data[2] = buf.byte_loc[3]; 
	rs485Packet.Data[3] = buf.byte_loc[2];
	rs485Packet.Data[4] = buf.byte_loc[1]; 
	rs485Packet.Data[5] = buf.byte_loc[0];
	rs485Packet.Data[6] = buf1.byte_loc[3]; 
	rs485Packet.Data[7] = buf1.byte_loc[2];
	rs485Packet.Data[8] = buf1.byte_loc[1]; 
	rs485Packet.Data[9] = buf1.byte_loc[0];
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();

}

void SCPI_485SlavePVParameter(uint8_t cmd ,uint8_t des ,float isc1 ,float voc1,float imp1 ,float vmp1)
{
	unionbyte_TypeDef buf,buf1,buf2,buf3;
	buf.ftob = isc1;
	buf1.ftob = voc1;
	buf2.ftob = imp1;
	buf3.ftob = vmp1;

	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + 4 + 4 + 4 + 4 ;
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = buf.byte_loc[3]; 
	rs485Packet.Data[1] = buf.byte_loc[2];
	rs485Packet.Data[2] = buf.byte_loc[1]; 
	rs485Packet.Data[3] = buf.byte_loc[0];
	rs485Packet.Data[4] = buf1.byte_loc[3]; 
	rs485Packet.Data[5] = buf1.byte_loc[2];
	rs485Packet.Data[6] = buf1.byte_loc[1]; 
	rs485Packet.Data[7] = buf1.byte_loc[0];
	rs485Packet.Data[8] = buf2.byte_loc[3]; 
	rs485Packet.Data[9] = buf2.byte_loc[2];
	rs485Packet.Data[10] = buf2.byte_loc[1]; 
	rs485Packet.Data[11] = buf2.byte_loc[0];
	rs485Packet.Data[12] = buf3.byte_loc[3]; 
	rs485Packet.Data[13] = buf3.byte_loc[2];
	rs485Packet.Data[14] = buf3.byte_loc[1]; 
	rs485Packet.Data[15] = buf3.byte_loc[0];
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1]  = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();

}

void SCPI_485SlaveInt32(uint8_t cmd ,uint8_t des ,uint32_t temp )
{
	unionbyte_TypeDef buf;
	buf.ltob = temp;
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(uint32_t) ;
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = buf.byte_loc[3]; 
	rs485Packet.Data[1] = buf.byte_loc[2];
	rs485Packet.Data[2] = buf.byte_loc[1]; 
	rs485Packet.Data[3] = buf.byte_loc[0];
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();
}

void SCPI_485SlaveFloat(uint8_t cmd ,uint8_t des ,float temp )
{
	unionbyte_TypeDef buf;
	buf.ftob = temp;
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(float) ;
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = buf.byte_loc[3]; 
	rs485Packet.Data[1] = buf.byte_loc[2];
	rs485Packet.Data[2] = buf.byte_loc[1]; 
	rs485Packet.Data[3] = buf.byte_loc[0];
	if (rs485Packet.DA == RS485_CHAINBROADCAST )
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();
}


void SCPI_485SlaveInt16(uint8_t cmd ,uint8_t des ,int16_t temp)
{
	unionbyte_TypeDef buf;
	buf.itob[0] = temp;
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(uint16_t) ;
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = buf.byte_loc[1]; 
	rs485Packet.Data[1] = buf.byte_loc[0];
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();
}

void SCPI_485SlaveFloatInt16(uint8_t cmd ,uint8_t des ,float temp ,int16_t temp1)
{
	unionbyte_TypeDef buf;
	buf.ftob = temp;
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(float) + sizeof(uint16_t) ;
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = buf.byte_loc[3]; 
	rs485Packet.Data[1] = buf.byte_loc[2];
	rs485Packet.Data[2] = buf.byte_loc[1]; 
	rs485Packet.Data[3] = buf.byte_loc[0];
	buf.itob[0] = temp1;
	rs485Packet.Data[4] = buf.byte_loc[1]; 
	rs485Packet.Data[5] = buf.byte_loc[0];
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();
}

void SCPI_485SlaveInt8Int8(uint8_t cmd ,uint8_t des ,int8_t temp ,int8_t temp1)
{
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(int8_t) + sizeof(uint8_t) ;
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = temp; 
	rs485Packet.Data[1] = temp1;
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();
}

void SCPI_485SlaveFloatFloat(uint8_t cmd ,uint8_t des ,float temp ,float temp1)
{
	unionbyte_TypeDef buf;
	buf.ftob = temp;
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(float) + sizeof(float) ;
	rs485Packet.Cmd = cmd;//cmd;
	rs485Packet.Data[0] = buf.byte_loc[3]; 
	rs485Packet.Data[1] = buf.byte_loc[2];
	rs485Packet.Data[2] = buf.byte_loc[1]; 
	rs485Packet.Data[3] = buf.byte_loc[0];
	buf.ftob = temp1;
	rs485Packet.Data[4] = buf.byte_loc[3]; 
	rs485Packet.Data[5] = buf.byte_loc[2];
	rs485Packet.Data[6] = buf.byte_loc[1]; 
	rs485Packet.Data[7] = buf.byte_loc[0];
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();
}




void SCPI_485SlaveInt8(uint8_t cmd ,uint8_t des ,uint8_t temp)
{
	rs485Packet.Head = RS485_HEAD;
	rs485Packet.DA = des; // ت	
	rs485Packet.SA = chainAddr; // ӷ
	rs485Packet.Len = 1 + sizeof(uint8_t) ;
	rs485Packet.Cmd = cmd;//cmd;
	*(uint8_t *)rs485Packet.Data = temp;
	if (rs485Packet.DA == RS485_CHAINBROADCAST)
		rs485Packet.Data[rs485Packet.Len - 1] = rs485Packet.Serial = specifyNumber();
	else
		rs485Packet.Data[rs485Packet.Len - 1] = 0xFF;
	rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
	rs485AntiCollision();
	receivedRS485Packet();
}





void setValue(uint8_t rs485_cmd,uint8_t MB_cmd ,float value ,float* desValue,float Max ,float Min)
{
	if (chainAddrSlave == chainAddr)	// a
	{
			if (value >= Min && value <= Max)
			{
				*desValue = value;
				verifyInput(MB_cmd,*desValue ); // send vset  no need to save value
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				sprintf((void *)transBuffer,"Range error\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
	}
	else
			SCPI_485SlaveFloat(rs485_cmd ,chainAddrSlave ,value);
}


scpi_result_t	SCPI_setChainAddrSlave(scpi_t * context)   // CADR
{
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param > 0 && param < MAX_CHAINADDR)	{
			if (IS_MULTI_MASTER)
			{
				sprintf((void *)transBuffer,"Multi master\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				chainAddrSlave = param;
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

// query ChainAddrSlave
scpi_result_t	SCPI_queryChainAddrSlave(scpi_t * context)	 // CADR?
{
    sprintf((void *)transBuffer,"%d\r\n",chainAddrSlave);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer ));
	return SCPI_RES_OK;
}





scpi_result_t	SCPI_485Cls(scpi_t * context)
{	
													   // CCLS
	if (/* chainMode == ON && */chainAddrSlave > 0 )
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			SCPI_CoreCls(&scpi_context);
			sprintf((void *)transBuffer,"OK\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_CLS);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}
scpi_result_t	SCPI_485Rst(scpi_t * context)			   // CRST
{
	
	if (/* chainMode == ON &&*/ chainAddrSlave > 0 )
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			SCPI_CoreRst(&scpi_context);
			sprintf((void *)transBuffer,"OK\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_RST);
		return SCPI_RES_OK;	
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}


scpi_result_t	SCPI_485Idn(scpi_t * context)			   // CIDN?
{
	if (/*chainMode == ON && */chainAddrSlave > 0)
	{
//			CLR_RS485_BROADCAST_ECHO;
		rs485Id[chainAddrSlave].id = chainAddrSlave;
		if (chainAddrSlave == chainAddr)	// a
		{
			SCPI_CoreIdnQ(&scpi_context);
			rs485Id[chainAddrSlave].exist = 1;
			rs485Id[chainAddrSlave].disconnect = 0;//su
		}
		else
			SCPI_485SlaveCmd(CMD_QIDN);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}


scpi_result_t	SCPI_485Rev(scpi_t * context)	 // CREV?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
			  SCPI_VERSION(&scpi_context);
		else
			SCPI_485SlaveCmd(CMD_QREV);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t	SCPI_485Sn(scpi_t * context)  // CSN?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
			  SCPI_querySerialNumber(&scpi_context);
		else
			SCPI_485SlaveCmd(CMD_QSN);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

void returnState(void)
{
			uint8_t i;
		 	rs485Packet.Data[0] = 0;
			if (protsw & BIT7)				   // OVP
				rs485Packet.Data[0] |= BIT7;
			if (protsw & BIT6)				   // OCP
				rs485Packet.Data[0] |= BIT6;
			if (protsw & BIT5)				   // OPP
				rs485Packet.Data[0] |= BIT5;
			if (protsw & BIT4)				   // CV CC
				rs485Packet.Data[0] |= BIT4;
			if (protsw & BIT3)				   // CC CV
				rs485Packet.Data[0] |= BIT3;
			if (outputStatus & ON_STATE)  		// on/off
				rs485Packet.Data[0] |= BIT2;

		 	rs485Packet.Data[1] = 0;
			if (outputStatus & OVP_STATE)		// OVP flag
				rs485Packet.Data[1] |= BIT7;
			if (outputStatus & OVP_STATE)		// OCP flag
				rs485Packet.Data[1] |= BIT6;
			if (outputStatus & OPP_STATE)		// OPP flag
				rs485Packet.Data[1] |= BIT5;	
			if (outputStatus & CC_CV_STATE)		// CC_CV flag
				rs485Packet.Data[1] |= BIT4;	
			if (outputStatus & CV_CC_STATE)		// CV_CC flag
				rs485Packet.Data[1] |= BIT3;
			if (IS_PFC_VIN_TOO_LOW)				// AC low
				rs485Packet.Data[1] |= BIT2;
			if (IS_NTC_TOO_HIGH)				// OTP flag
				rs485Packet.Data[1] |= BIT1; 	
			rs485Packet.Data[2] = 0;
			for	(i = 0 ; i < 3 ;i ++)
			{
				transBuffer[i*2] = rs485Packet.Data[i];
				transBuffer[i*2+1] =	rs485Packet.Data[i];
				transBuffer[i*2+1] &= 0x0f;
				transBuffer[i*2] >>= 4;
				transBuffer[i*2] &= 0x0f;
				if (transBuffer[i*2] < 10)
					transBuffer[i*2] += 0x30;
				else
					transBuffer[i*2] += 0x37;
				if (transBuffer[i*2+1] < 10)
					transBuffer[i*2+1] += 0x30;
				else
					transBuffer[i*2+1] += 0x37;
			}
			memcpy((void *)(transBuffer+6) ,"\r\n\0",3);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
}


scpi_result_t	SCPI_485St(scpi_t * context)	  // CST?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
			returnState();
		else
			SCPI_485SlaveCmd(CMD_QSTB);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t SCPI_queryOutputState(scpi_t * context)
{
	returnState();
   	return SCPI_RES_OK;
}


scpi_result_t	SCPI_485Clr(scpi_t * context)	 // CCLR?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			SCPI_clearOVPOCPOPPCVCCCCCV(&scpi_context);
			sprintf((void *)transBuffer,"OK\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_CLR);

		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t	SCPI_485setVset(scpi_t * context)	 // CPV
{
	double  param1;
//	CLR_RS485_BROADCAST_ECHO;
    if (!SCPI_ParamDouble(context, &param1, TRUE) /*&& (chainMode == ON )*/) {
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		setValue(CMD_SETV,VSET_CMD ,(float)param1 ,&master.vSet,master.limitVMax ,master.limitVMin);
		return SCPI_RES_OK;
	}
}

scpi_result_t	SCPI_485queryVset(scpi_t * context)	 // CPV?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.vSet ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QSETV);
		return SCPI_RES_OK;
	}
	else
		return SCPI_RES_ERR;
}

scpi_result_t	SCPI_485queryVout(scpi_t * context)	 // CMV?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.vOut ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QVOLT);
		return SCPI_RES_OK;
	}
	else
		return SCPI_RES_ERR;
}

scpi_result_t	SCPI_485setIset(scpi_t * context)	 // CPC
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE) /*&& chainMode == ON*/) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
//		CLR_RS485_BROADCAST_ECHO;
		setValue(CMD_SETI,ISET_CMD ,(float)param1 ,&master.iSet,master.limitIMax ,master.limitIMin);
		return SCPI_RES_OK;
	}
}

scpi_result_t	SCPI_485queryIset(scpi_t * context)	 // CPC?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)currDisp[currPoint],master.iSet ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QSETI);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t	SCPI_485queryIout(scpi_t * context)	 // CMC?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)currDisp[currPoint],master.iOut ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QCURR);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}


scpi_result_t	SCPI_485setOutput(scpi_t * context)	 // COUT
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param1.value == 0 || param1.value == 1)	{
//			CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				onoffStatus = param1.value;
				verifyInput(OUTPUT_CMD,(float)onoffStatus );
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
				return SCPI_RES_OK;	
			}
			else
			{
				SCPI_485SlaveInt8(CMD_SETOUTPUT ,chainAddrSlave ,(uint8_t)param1.value);
				return SCPI_RES_OK;
			}
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

scpi_result_t	SCPI_485queryOutput(scpi_t * context)  //COUT?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			char bf[15];
			if (outputStatus & ON_STATE)
			{
				sprintf((void *)bf,"ON\r\n");
			}
			else
				sprintf((void *)bf,"OFF\r\n");
			scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
			return SCPI_RES_OK;
		}
		else
			SCPI_485SlaveCmd(CMD_QOUTONOFF);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}


scpi_result_t	SCPI_485setOVPSet(scpi_t * context)	 //COV
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
//		CLR_RS485_BROADCAST_ECHO;
		setValue(CMD_SETOVP,OVPSET_CMD ,(float)param1 ,&master.OVPSet ,master.OVPMax ,master.OVPMin);
		return SCPI_RES_OK;
	}
}

scpi_result_t	SCPI_485queryOVPSet(scpi_t * context)  //COV?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{
//		CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.OVPSet ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QOVP);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t	SCPI_485setOVPSwitch(scpi_t * context) //COVP
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if (param1.value == 0 || param1.value == 1)	{
//				CLR_RS485_BROADCAST_ECHO;
				if (chainAddrSlave == chainAddr)	// a
				{
					ProtOVActivation = param1.value;
					if (param1.value == 1)
						protsw |= BIT7;
					else
						protsw &= ~BIT7;
					verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
					return SCPI_RES_OK;
				}
				else
				{
					SCPI_485SlaveInt8(CMD_SETOVPONOFF ,chainAddrSlave ,(float)param1.value);
					return SCPI_RES_OK;
				}
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}

scpi_result_t	SCPI_485queryOVPSwitch(scpi_t * context)  // COVP?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			char bf[15];
			if (protsw & BIT7)
				sprintf((void *)bf,"ON\r\n");
			else
				sprintf((void *)bf,"OFF\r\n");
			scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
			return SCPI_RES_OK;
		}
		else
			SCPI_485SlaveCmd(CMD_QOVPONOFF);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}

}

scpi_result_t	SCPI_485setOCPSet(scpi_t * context)	  //COC
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{	//CLR_RS485_BROADCAST_ECHO;
		setValue(CMD_SETOCP,OCPSET_CMD ,(float)param1 ,&master.OCPSet ,sumOCPMax() ,sumOCPMin());
		return SCPI_RES_OK;
	}

}

scpi_result_t	SCPI_485queryOCPSet(scpi_t * context)	//COC?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)currDisp[currPoint],master.OCPSet ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QOCP);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t	SCPI_485setOCPSwitch(scpi_t * context)	//COCP
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if (param1.value == 0 || param1.value == 1)	{
//				CLR_RS485_BROADCAST_ECHO;
				if (chainAddrSlave == chainAddr)	// a
				{
					ProtOCActivation = param1.value;
					if (param1.value == 1)
						protsw |= BIT6;
					else
						protsw &= ~BIT6;
					verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
					return SCPI_RES_OK;
				}
				else
				{
					SCPI_485SlaveInt8(CMD_SETOCPONOFF ,chainAddrSlave ,(float)param1.value);
					return SCPI_RES_OK;
				}
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}


}


scpi_result_t	SCPI_485queryOCPSwitch(scpi_t * context) //COCP?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			char bf[15];
			if (protsw & BIT6)
				sprintf((void *)bf,"ON\r\n");
			else
				sprintf((void *)bf,"OFF\r\n");
			scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
			return SCPI_RES_OK;
		}
		else
			SCPI_485SlaveCmd(CMD_QOCPONOFF);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}


scpi_result_t	SCPI_485setOPPSet(scpi_t * context)	 //COP
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)) { // SET ݪk  read first parameter if not present error -109 missing parameter
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{	//CLR_RS485_BROADCAST_ECHO;
		setValue(CMD_SETOPP,OPPSET_CMD ,(float)param1 ,&master.OPPSet ,master.OPPMax ,master.OPPMin);
		return SCPI_RES_OK;
	}
}

scpi_result_t	SCPI_485queryOPPSet(scpi_t * context) //COP?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)powDisp[powPoint],master.OPPSet ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QOPP);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t	SCPI_485setOPPSwitch(scpi_t * context) //COPP
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
			if (param1.value == 0 || param1.value == 1)	{
//				CLR_RS485_BROADCAST_ECHO;
				if (chainAddrSlave == chainAddr)	// a
				{
					ProtOPActivation = param1.value;
					if (param1.value == 1)
						protsw |= BIT5;
					else
						protsw &= ~BIT5;
					verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
					return SCPI_RES_OK;
				}
				else
				{
					SCPI_485SlaveInt8(CMD_SETOPPONOFF ,chainAddrSlave ,(uint8_t)param1.value);
					return SCPI_RES_OK;
				}
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}

scpi_result_t	SCPI_485queryOPPSwitch(scpi_t * context) //COPP?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			char bf[15];
			if (protsw & BIT5)
				sprintf((void *)bf,"ON\r\n");
			else
				sprintf((void *)bf,"OFF\r\n");
			scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
			return SCPI_RES_OK;
		}
		else
			SCPI_485SlaveCmd(CMD_QOPPONOFF);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t	SCPI_485queryVoutIout(scpi_t * context) //CDVC?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],master.vOut ); 
			strcat((void *)(transBuffer)," , ");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			sprintf((void *)(transBuffer),(void *)currDisp[currPoint],master.iOut ); 
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			return SCPI_RES_OK;
		}
		else
			SCPI_485SlaveCmd(CMD_QVI);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}
/* RS485 set PVSIM curve */ 
scpi_result_t	SCPI_485setPVSIMCurve(scpi_t * context)	// CPVCURV
{
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param > 0 && param <= 101  || (param == 256) )	// 1 ~ 101  (PC Host ) 
		{	//CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				curve = param - 1;
				sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
				return SCPI_RES_OK;
			}
			else
			{
				SCPI_485SlaveInt8(CMD_SETPVCURV ,chainAddrSlave ,curve);
				return SCPI_RES_OK;			
			}
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}

}

/* RS485 query PVSIM curve */
scpi_result_t	SCPI_485queryPVSIMCurve(scpi_t * context)	// CPVCURV?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			clearMeasureCommand();
			sendMBQuery(MEASURE_CHANNEL,PVSSTATEQ_CMD);	//D9 
			clearMeasureCommand();					   // receive DA
			sprintf((void *)(transBuffer),"%d\r\n", curve + 1);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			return SCPI_RES_OK;
		}
		else
			SCPI_485SlaveCmd(CMD_QPVCURV);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}	
}

/* RS485 PVSIM parameter broad cast

  Rule,Vmp,Pmp,Material
*/

scpi_result_t	SCPI_485setPVSIMParameter(scpi_t * context)	// 	CPVPARM
{
	double param1,param2,param3,param4;
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read 3th paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
    // read 4th parameter if present
    if (!SCPI_ParamDouble(context, &param3, true)) {
        return SCPI_RES_ERR;
    }
    // read 5th paraeter if present
    if (!SCPI_ParamDouble(context, &param4, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
	if ((uint8_t)param1 > 3 || (uint8_t)param1 < 1)
        return SCPI_RES_ERR;// Rule
	if (((float)param2 > master.limitVMax *0.95) || (float)param2 < master.limitVMin)
		return SCPI_RES_ERR;// Vmp
	if (((float)param3 > /* master.pMax */sumpMax()  *0.9) || (float)param3 < (master.limitVMin * sumlimitIMin()))
		return SCPI_RES_ERR;// Pmp
	if ((uint8_t)param1 == 2)//kW 2  Ѽu 1,2
	{
		if ((uint8_t)param4 > 3 || (uint8_t)param4 < 1)
        return SCPI_RES_ERR;// Material
	}
	else //kW 1,3  Ѽƥu 1,2
	{
		if ((uint8_t)param4 > 2 || (uint8_t)param4 < 1)
        return SCPI_RES_ERR;// Material
	}	
	if (((float)param3 / (float)param2) > (sumlimitIMax() *0.95))
		return SCPI_RES_ERR; // Imp too high
//	CLR_RS485_BROADCAST_ECHO;
	if (chainAddrSlave == chainAddr)	// a
	{
		Rule = (float)param1;Vmp = (float)param2;Pmp = (float)param3/(slaveNumber+1);Material = (float)param4;
		savePvsCurveParam();	 // D1 
		sprintf((void *)transBuffer,"OK\r\n");
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	}
	else
		SCPI_485SlavePVParameter(CMD_SETPVPARAM ,chainAddrSlave ,param1 ,param2,param3/(slaveNumber+1) ,param4);
	return SCPI_RES_OK;
}


scpi_result_t	SCPI_485queryPVSIMParamter(scpi_t * context)   // CPVPARM?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	
//	    CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			queryCurveparrmeter();
			if (voltPoint == 1)
				sprintf((void *)(transBuffer),"%.1d,%6.1f,%6.2f,%.1d\r\n", (uint8_t)Rule,Vmp,Pmp*(slaveNumber+1),(uint8_t)Material);
			else
				sprintf((void *)(transBuffer),"%.1d,%6.2f,%6.2f,%.1d\r\n", (uint8_t)Rule,Vmp,Pmp*(slaveNumber+1),(uint8_t)Material);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			return SCPI_RES_OK;
		}
		else
			SCPI_485SlaveCmd(CMD_QPVPARAM);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

/*
  RS485  SET PVSIM ON/OFF STATE 
*/
scpi_result_t	SCPI_485setPVState(scpi_t * context)	  // CPVSTATE
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	{
//			CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
//				sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
//				delayMs(50);
				pvsONOFF = param1.value;
				sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// pvs mode on/off
				if (pvsONOFF == ON)  // pvsONOFF = ON
				{
			    	timerONOFF = OFF;
					programONOFF = OFF;
					extEnable = OFF;
					eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
					extVMode = 0;
					eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
					extIMode = 0;
					eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
//					parallelMode = OFF;
//					eepWrite((uint8_t *)&parallelMode, EE_PARALLELMODE ,sizeof(uint8_t));
				//	chainMode = OFF;
				//	VFDsign &=  ~(sign_ADDR);
				//	eepWrite((uint8_t *)&chainMode, EE_CHAINMODE ,sizeof(uint8_t));
				}
				else
					checkPowerOnState();
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				SCPI_485SlaveInt8(CMD_SETPVSTATE ,chainAddrSlave ,(uint8_t)param1.value);
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
scpi_result_t	SCPI_485queryPVState(scpi_t * context)	 // CPVSTATE?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			scpi_number_t param1;
			char bf[15];
			clearMeasureCommand();
			sendMBQuery(MEASURE_CHANNEL,PVSSTATEQ_CMD);
			clearMeasureCommand();
			param1.type = returnONOFF(pvsONOFF);
    		SCPI_NumberToStr(context, &param1, bf, 15);
			strcat((void *)(bf),"\r\n");
			scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
		}
		else
			SCPI_485SlaveCmd(CMD_QPVSTATE);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t SCPI_485SetPVPower(scpi_t * context)	// CPVPOW
{
	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if ((param1.type == SCPI_NUM_NUMBER) &&  param1.value <= 100)
		{	//CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				percentage = param1.value * 100;
				sendMBIntSetting( PVSSIMPOWER_CMD, percentage);
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				SCPI_485SlaveFloat(CMD_SETPVPOW ,chainAddrSlave ,(float)param1.value);
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}
scpi_result_t SCPI_485queryPVPower(scpi_t * context)  // CPVPOW?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)transBuffer ,"%5.2f\r\n", (float)percentage/100);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QPVPOW);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}


scpi_result_t SCPI_485SetPVTablePoint(scpi_t * context)	   // CPVTABLEPOINT
{
	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if (/* (param1.type == SCPI_NUM_NUMBER)  && */  (uint16_t)param1.value <= 1024)
		{	//CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				pvsPoint = (uint16_t)param1.value ;
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				SCPI_485SlaveInt16(CMD_SETPVTABLEPOINT ,chainAddrSlave ,(int16_t)param1.value);
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}

scpi_result_t SCPI_485SetPVTableParm(scpi_t * context)	  // CPVTABPARM
{
	double param0,param1,param2;
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param0, true)) {
        return SCPI_RES_ERR;
    }
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read 3th paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
   	if ((float)param1 < 0 || (float)param1 > master.limitVMax)
   	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		return SCPI_RES_ERR;
	}	
   	if ((float)param2 < 0 || (float)param2 > sumlimitIMax())
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		return SCPI_RES_ERR;
	}	
	if (chainAddrSlave == chainAddr)	// a
	{	
	//	CLR_RS485_BROADCAST_ECHO;
		uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;
		uartBuffer[MEASURE_CHANNEL].simplePacket.length = 0x0C;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = PVSDEFNVI_CMD; // D4
		scpiunionbyte.itob[0] = (uint16_t)param0;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = scpiunionbyte.byte_loc[1];	// MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = scpiunionbyte.byte_loc[0];
		scpiunionbyte.ftob = param1;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = scpiunionbyte.byte_loc[3];	// MSB first  voltage
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = scpiunionbyte.byte_loc[2];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = scpiunionbyte.byte_loc[1];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6] = scpiunionbyte.byte_loc[0];
		scpiunionbyte.ftob = param2;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7] = scpiunionbyte.byte_loc[3];	// MSB first  current
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8] = scpiunionbyte.byte_loc[2];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[9] = scpiunionbyte.byte_loc[1];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[10] = scpiunionbyte.byte_loc[0];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] 
		= calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
		uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);
//		delayMs(5);
//		clearMeasureCommand();//  receive ACK or NAK
		sprintf((void *)transBuffer,"OK\r\n");
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	}
	else
	{
		SCPI_485SlavePVTableParameter(CMD_SETPVTABPARM ,chainAddrSlave ,(uint16_t)param0,(float)param1 ,(float)param2);
	}
	return SCPI_RES_OK;
}
scpi_result_t SCPI_485queryPVTableParm(scpi_t * context)  // CPVTABPARM?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			clearMeasureCommand();
			sendMBIntSetting( PVSDEFNVIQ_CMD,pvsPoint);
			delayMs(5);
			clearMeasureCommand();
			if (voltPoint == 1)
				sprintf((void *)(transBuffer),"%d,%6.1f,%7.4f\r\n",pvsPoint, pvsVoltage,pvsCurrent);
			else
				sprintf((void *)(transBuffer),"%d,%6.2f,%7.4f\r\n", pvsPoint ,pvsVoltage,pvsCurrent);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QPVTABPARM);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t SCPI_485PVStart(scpi_t * context)	  //  CPVTABSTART
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sendMBQuery(MEASURE_CHANNEL,PVSSTARTLOAD_CMD);	// D3
		}
		else
			SCPI_485SlaveCmd(CMD_SETPVTABSTART);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}
scpi_result_t SCPI_485PVStop(scpi_t * context)	 //	 CPVTABSTOP
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	
		//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sendMBQuery(MEASURE_CHANNEL,PVSSTOPLOAD_CMD);	// D5
		}
		else
			SCPI_485SlaveCmd(CMD_SETPVTABSTOP);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}
scpi_result_t SCPI_485queryPVTabState(scpi_t * context)	 //	CPVTABSTATE?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	
		//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)(transBuffer),"%1d\r\n", pvsTableNumState);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			pvsTableNumState = 0;// not OK
		}
		else
		{
			CLR_RS485_BROADCAST_ECHO; //SO[J
			SCPI_485SlaveCmd(CMD_QPVTABSTATE);
		}
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}
scpi_result_t SCPI_485querymaxPower(scpi_t * context)  //  CMAXPOWER?
{
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	
		//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)transBuffer ,"%6.1f\r\n", master.pMax);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QMAXPOW);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}
															 
/*
    CPVTABNUM  pvsarray(int16)
*/

scpi_result_t SCPI_485PVTableArray(scpi_t * context){	 // CPVTABNUM  pvsarray(int16)

	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if (param1.value == 128 || param1.value == 256 || param1.value == 512 || param1.value == 1024 
			|| param1.value == 2048 || param1.value == 4096)
		{	//CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				// local
				sendMBIntSetting(PVSTABARRAY_CMD, (uint16_t)param1.value);
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				SCPI_485SlaveInt16(CMD_SETTABARRAY ,chainAddrSlave ,(int16_t)param1.value);
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}





scpi_result_t SCPI_485PVpvsGpvsT(scpi_t * context){	 //	CPVGT (ӫ,ū)  pvsG(float),pvsT(int16)
	double param1,param2;
	uint16_t param3;
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read 3th paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
//	pvsG = (float)param1; pvsT = (float)param2 * 100;
    param3 = (float)param2 * 100;
	if (chainAddrSlave == chainAddr)	// a
	{	
	//	CLR_RS485_BROADCAST_ECHO;
		// local
		sendMBIntSettingFloatInt16( PVSSIMGT_CMD, (float)param1,param3 );
	}
	else
	{
		SCPI_485SlaveFloatInt16(CMD_SETPVGT ,chainAddrSlave ,(float)param1 ,param3 );
	}
	return SCPI_RES_OK;
}
/*
	CPVFM  formula, material
*/

scpi_result_t SCPI_485PVFM(scpi_t * context){			 //	CPVFM  formula, material
	double param1,param2;
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read 3th paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
//	pvsformula = (int8_t)param1;
//	pvsmaterial = (int8_t)param2;
	if (chainAddrSlave == chainAddr)	// a
	{	
	//	CLR_RS485_BROADCAST_ECHO;
		// local
		sendMBIntSettingInt8Int8( PVSFM_CMD, (int8_t)param1,(int8_t)param2);
	}
	else
	{
		SCPI_485SlaveInt8Int8(CMD_SETPVFM ,chainAddrSlave ,(int8_t)param1 ,(int8_t)param2);
	}
	return SCPI_RES_OK;
}
/*
	CPVVMPPMP  pvsvmp,pvspmp
*/

scpi_result_t SCPI_485PVvmppmp(scpi_t * context){		 //	CPVVMPPMP  pvsvmp,pvspmp

	double param1,param2;
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read 3th paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
//	pvsvmp = (float)param1;
//	pvspmp = (float)param2;
	if (chainAddrSlave == chainAddr)	// a
	{	
	//	CLR_RS485_BROADCAST_ECHO;
		// local
		sendMBIntSettingFloatFloat( PVSVMPPMP_CMD, (float)param1,(float)param2);
	}
	else
	{
		SCPI_485SlaveFloatFloat(CMD_SETVMPPMP ,chainAddrSlave ,(float)param1 ,(float)param2);
	}
	return SCPI_RES_OK;

}

/*
  Set Parallel Role
*/
scpi_result_t SCPI_485setParallelRole(scpi_t * context){	// CPARALLELROLE
	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if ((param1.type == SCPI_NUM_NUMBER) && (param1.value >= 1 && param1.value <= SLAVEMAXNUM))
		{	//CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				parallelRole = (int8_t)param1.value ;
				eepWrite((uint8_t *)&parallelRole, EE_PARALLELROLE ,sizeof(uint8_t));
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				SCPI_485SlaveInt8(CMD_SETPARALLELROLE ,chainAddrSlave ,(int8_t)param1.value);
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}
/*
  Query parallel Role?
*/
scpi_result_t SCPI_485queryParallelRole(scpi_t * context){	// CPARALLELROLE?
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			if ( parallelRole == 0)
				sprintf((void *)transBuffer ,"MASTER\r\n");
			else
				sprintf((void *)transBuffer ,"SLAVE%2d\r\n", parallelRole);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QPARALLELROLE);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

/*
  Set Chain Address
*/
scpi_result_t SCPI_485setChainAddress(scpi_t * context){	// CCHAINADDRESS
	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if ((param1.type == SCPI_NUM_NUMBER) &&  (param1.value >= 1 && param1.value < MAX_CHAINADDR))
		{	//CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				chainAddr = (int8_t)param1.value ;
				eepWrite((uint8_t *)&chainAddr, EE_CHAINADDR,sizeof(uint8_t));
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				SCPI_485SlaveInt8(CMD_SETCHAINADDRESS ,chainAddrSlave ,(int8_t)param1.value);
			}
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}
/*
  Query Chain Mode Address?
*/
scpi_result_t SCPI_485queryChainAddress(scpi_t * context){	// CCHAINADDRESS?
	if (/*chainMode == ON  && */chainAddrSlave > 0)
	{	//CLR_RS485_BROADCAST_ECHO;
		if (chainAddrSlave == chainAddr)	// a
		{
			sprintf((void *)transBuffer ,"%2d\r\n", chainAddr);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
			SCPI_485SlaveCmd(CMD_QCHAINADDRESS);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

									 
/*
  RS485  SET PVSIM control mode  CC or CV 
*/
scpi_result_t	SCPI_485setPVCtrlMode(scpi_t * context)	  // CPVCTRLMOD
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_CC || param1.type == SCPI_PARM_CV )&& (param1.value < 2))	{
			if (chainAddrSlave == chainAddr)	// a
			{
				sendMBStateSetting(MEASURE_CHANNEL,PVCTRLMOD_CMD, (uint8_t) param1.value);
				pvCtrlMode = (uint8_t) param1.value;
				sprintf((void *)transBuffer,"OK\r\n");
				scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
			}
			else
			{
				SCPI_485SlaveInt8(CMD_SETPVCTRLMOD ,chainAddrSlave ,(uint8_t)param1.value);
			}
			return SCPI_RES_OK;
		}
		else{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}




/***************************************************************************/
/******************** RS485 BroadCast command below ************************/
/***************************************************************************/


scpi_result_t	SCPI_485RSTbroadcast(scpi_t * context)			  //  GRST
{
		
		if (/*chainMode == ON  && */chainAddrSlave > 0)
		{	
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;
				rs485PacketSerialNumberFlag	= 0;	
				memset((void *)broadcastOKCount	,0,32);	
				totalSlave = 0;	
			}

			memset((void *)rs485Id , 0 ,sizeof(rs485Id_TypDef) * MAX_CHAINADDR);
			translate485Cmd(CMD_RST,RS485_CHAINBROADCAST,chainAddr);
			SCPI_CoreRst(&scpi_context);
			return SCPI_RES_OK;	
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
			return SCPI_RES_ERR;
		}
}
scpi_result_t	SCPI_485CLSbroadcast(scpi_t * context)			  //  GCLS
{
	{
//		if (/*chainMode == ON  && */chainAddrSlave > 0)
//		{	
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			SCPI_CoreCls(&scpi_context);
			translate485Cmd(CMD_CLS,RS485_CHAINBROADCAST,chainAddr);
			return SCPI_RES_OK;
//		}
//		else
//		{
//			SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
//			return SCPI_RES_ERR;
//		}
	}
}

scpi_result_t	SCPI_485CLRbroadcast(scpi_t * context)			  //  GCLR
{
	{
		if (/*chainMode == ON && */chainAddrSlave > 0 )
		{	
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			SCPI_clearOVPOCPOPPCVCCCCCV(&scpi_context);
			translate485Cmd(CMD_CLR,RS485_CHAINBROADCAST,chainAddr);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
			return SCPI_RES_ERR;
		}
	}
}

scpi_result_t	SCPI_485VSETbroadcast(scpi_t * context)			  //  GPV
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE) /*&& (chainMode == ON )*/) {
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
	   	if ((float)param1 >= master.limitVMin && (float)param1 <= master.limitVMax )
	   	{	
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			SCPI_485SlaveFloat(CMD_SETV ,RS485_CHAINBROADCAST ,(float)param1);
			verifyInput(VSET_CMD,(float)param1 );
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}		
	}
}
scpi_result_t	SCPI_485queryVoutIoutBroadcast(scpi_t * context) //GDVC?
{
	if (broadcastEcho == ON)
	{
		uint8_t count;
		float volt,curr;
		SET_RS485_BROADCAST_ECHO;
		for (volt = 0,curr = 0,count = 0 ; count < MAX_CHAINADDR;count++)
		{
			volt += rs485SlavevOut[count];
			curr += rs485SlaveiOut[count];
		}
		volt /= totalSlave;
		sprintf((void *)(transBuffer),(void *)voltDisp[voltPoint],volt ); 
		strcat((void *)(transBuffer)," , ");
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		sprintf((void *)(transBuffer),(void *)currDisp[currPoint],curr ); 
		strcat((void *)(transBuffer),"\r\n");
		scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		SET_RS485_CHAIN_MASTER;
		
		return SCPI_RES_OK;
	}
	else
		return SCPI_RES_ERR;
}

scpi_result_t	SCPI_485ISETbroadcast(scpi_t * context)			  //  GPC
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE) /*&& (chainMode == ON )*/) {
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		{
		   	if ((float)param1 >= sumlimitIMin() && (float)param1 <= sumlimitIMax())
		   	{	
				if (broadcastEcho == ON)
				{	 
					SET_RS485_BROADCAST_ECHO;
					SET_RS485_CHAIN_MASTER;					
				}
				SCPI_485SlaveFloat(CMD_SETI ,RS485_CHAINBROADCAST ,(float)param1);
				verifyInput(ISET_CMD,(float)param1 ); 
				return SCPI_RES_OK;
			}
			else
			{
				SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
				return SCPI_RES_ERR;
			}		
	   	}
	}
}

scpi_result_t	SCPI_485OUTbroadcast(scpi_t * context)			  //  GOUT
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else
	{
			if (param1.value == 0 || param1.value == 1 )	
			{	
				if (broadcastEcho == ON )
				{	 
					SET_RS485_BROADCAST_ECHO;
					SET_RS485_CHAIN_MASTER;
				}
				softTimer[RS485_QVI_BROADCAST_COUNT].count = softTimer[MAIN_COUNT].count;					
				SCPI_485SlaveInt8(CMD_SETOUTPUT ,RS485_CHAINBROADCAST ,(uint8_t)param1.value);
				verifyInput(OUTPUT_CMD,(float)param1.value);
				return SCPI_RES_OK;
			}
			else
			{
				SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
				return SCPI_RES_ERR;
			}					 
	}
}

scpi_result_t	SCPI_485OVPSetbroadcast(scpi_t * context)		  //  GOV
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE)/* && (chainMode == ON )*/) {
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		{
			if ((float)param1 >= master.OVPMin && (float)param1 <= master.OVPMax)
			{	
				if (broadcastEcho == ON )
				{	 
					SET_RS485_BROADCAST_ECHO;
					SET_RS485_CHAIN_MASTER;					
				}
				SCPI_485SlaveFloat(CMD_SETOVP ,RS485_CHAINBROADCAST ,(float)param1);
				verifyInput(OVPSET_CMD,(float)param1  );
				return SCPI_RES_OK;
			}
			else
			{
				SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
				return SCPI_RES_ERR;
			}		
		}
	}
}

scpi_result_t	SCPI_485OVPSwitchBroadcast(scpi_t * context)	  //  GOVP
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE) /*&& (chainMode == ON )*/) {     
		return SCPI_RES_ERR;											 
    }
	else
	{
		{
			if (param1.value == 0 || param1.value == 1)	
			{	
				if (broadcastEcho == ON )
				{	 
					SET_RS485_BROADCAST_ECHO;
					SET_RS485_CHAIN_MASTER;					
				}
				ProtOVActivation = param1.value;
				if (param1.value == 1)
					protsw |= BIT7;
				else
					protsw &= ~BIT7;
				SCPI_485SlaveInt8(CMD_SETOVPONOFF ,RS485_CHAINBROADCAST ,ProtOVActivation);
				verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
				return SCPI_RES_OK;
			}
			else
			{
				SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
				return SCPI_RES_ERR;
			}
		}
	}
}

scpi_result_t	SCPI_485OCPSetbroadcast(scpi_t * context)		  //  GOC
{
	double  param1;
    if (!SCPI_ParamDouble(context, &param1, TRUE) /*&& (chainMode == ON )*/) {
		return SCPI_RES_ERR;
	}    // do something, if parameter not present
	else
	{
		{
			if ((float)param1 >= sumOCPMin() && (float)param1 <= sumOCPMax())
			{	
				if (broadcastEcho == ON )
				{	 
					SET_RS485_BROADCAST_ECHO;
					SET_RS485_CHAIN_MASTER;					
				}
				SCPI_485SlaveFloat(CMD_SETOCP ,RS485_CHAINBROADCAST ,(float)param1);
				verifyInput(OCPSET_CMD,(float)param1   );
				return SCPI_RES_OK;
			}
			else
			{
				SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
				return SCPI_RES_ERR;
			}
		}
	}
}

scpi_result_t	SCPI_485OCPSwitchBroadcast(scpi_t * context)	  //  GOCP
{
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)/* && (chainMode == ON )*/) {     
		return SCPI_RES_ERR;											 
    }
	else
	{
			{			
				if (param1.value == 0 || param1.value == 1)	
				{	
					if (broadcastEcho == ON )
					{	 
						SET_RS485_BROADCAST_ECHO;
						SET_RS485_CHAIN_MASTER;					
					}
					ProtOCActivation = param1.value;
					if (param1.value == 1)
						protsw |= BIT6;
					else
						protsw &= ~BIT6;
					SCPI_485SlaveInt8(CMD_SETOCPONOFF ,RS485_CHAINBROADCAST ,ProtOCActivation);
					verifyInput(PORTSW_CMD, protsw ); // send protect switch to DC-DC board
					return SCPI_RES_OK;
				}
				else
				{
					SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
					return SCPI_RES_ERR;
				}
			}
	}
}

scpi_result_t SCPI_queryMode(scpi_t * context)		// CMODE   OFF CV CC
{
	
	if (/*chainMode == ON && */chainAddrSlave > 0)
	{
		{	//CLR_RS485_BROADCAST_ECHO;
			if (chainAddrSlave == chainAddr)	// a
			{
				char bf[15];
				if (outputStatus & ON_STATE)
				{
					if (VFDsign & sign_CV)//if (outputStatus & CV_STATE)
						sprintf((void *)bf,"CV\r\n");
					if (VFDsign & sign_CC)//else if(outputStatus & CC_STATE)
						sprintf((void *)bf,"CC\r\n");
				}
				else
					sprintf((void *)bf,"OFF\r\n");
				scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
				return SCPI_RES_OK;
			}
			else
				SCPI_485SlaveCmd(CMD_QOUT);
		}
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

/* broad cast 
   Rule,Vmp,Pmp,Material

*/
float tempa,tempb;
scpi_result_t	SCPI_485PVSIMParamBroadcast(scpi_t * context)	  // GPVPARM
{
	double param1,param2,param3,param4;
	
	if (/*chainMode == ON &&*/ chainAddrSlave > 0)
	{
	    // read first parameter if present
	    // read second parameter if present
    	if (!SCPI_ParamDouble(context, &param1, true)) {
        	return SCPI_RES_ERR;
    	}
    	// read 3th paraeter if present
    	if (!SCPI_ParamDouble(context, &param2, true)) {
        	return SCPI_RES_ERR;// do something, if parameter not present
    	}
    	// read 4th parameter if present
    	if (!SCPI_ParamDouble(context, &param3, true)) {
	        return SCPI_RES_ERR;
    	}
    	// read 5th paraeter if present
    	if (!SCPI_ParamDouble(context, &param4, true)) {
	        return SCPI_RES_ERR;// do something, if parameter not present
	    }
		if ((uint8_t)param1 > 3 || (uint8_t)param1 < 1)
    	    return SCPI_RES_ERR;// Rule
		if (((float)param2 > master.limitVMax *0.95) || (float)param2 < master.limitVMin)
			return SCPI_RES_ERR;// Vmp
		if (((float)param3 > /* master.pMax */sumpMax()  *0.9) || (float)param3 < (master.limitVMin * sumlimitIMin()))
			return SCPI_RES_ERR;// Pmp
		if ((uint8_t)param1 == 2)//kW 2  Ѽu 1,2
		{
			if ((uint8_t)param4 > 3 || (uint8_t)param4 < 1)
					return SCPI_RES_ERR;// Material
		}
		else //kW 1,3  Ѽƥu 1,2
		{
			if ((uint8_t)param4 > 2 || (uint8_t)param4 < 1)
					return SCPI_RES_ERR;// Material
		}		
		if (((float)param3 / (float)param2) > (sumlimitIMax() *0.95))
			return SCPI_RES_ERR; // Imp too high

		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}			
		// a
		Rule = (float)param1;Vmp = (float)param2;Pmp = (float)param3/(slaveNumber+1);Material = (float)param4;
		// D1	 a
		savePvsCurveParam();
		// broadcast 
		SCPI_485SlavePVParameter(CMD_SETPVPARAM ,RS485_CHAINBROADCAST ,param1 ,param2,param3 ,param4);
		return SCPI_RES_OK;
    }
	else
		return SCPI_RES_ERR;
}


/* broad cast 
   curve 

*/
/*	
scpi_result_t	SCPI_485PVCurveBroadcast(scpi_t * context)	  // GPVCURV
{
    
	double param0;
	if(  chainMode == ON &&  chainAddrSlave > 0)
	{
	    // read first parameter if present
    	if (!SCPI_ParamDouble(context, &param0, true)) {
        	return SCPI_RES_ERR;
    	}
		if ((uint8_t)param0 < 1 || (uint8_t)param0 > 101)
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
		 SET_RS485_BROADCAST_ECHO;broadcastOKCount = 0;
			// a
			curve = (uint8_t)param0 - 1;
			// broadcast 
			SCPI_485SlaveInt8(CMD_SETPVCURV ,RS485_CHAINBROADCAST ,(uint8_t)param0);
			if (broadcastEcho == ON)
			{	 
				broadcastOKCount++;
				SET_RS485_CHAIN_MASTER;					
			}
			return SCPI_RES_OK;
    }
	else
	{
		return SCPI_RES_ERR;
	}
}
  */
scpi_result_t	SCPI_485PVStateBroadcast(scpi_t * context)	// GPVSTATE
{
	scpi_number_t param1;
	
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	
		{
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			SCPI_485SlaveInt8(CMD_SETPVSTATE ,RS485_CHAINBROADCAST ,(uint8_t)param1.value);
			pvsONOFF = param1.value;
			sendMBStateSetting(MEASURE_CHANNEL,PVSMODE_CMD, pvsONOFF);		// pvs mode on/off
			if (pvsONOFF == ON)  // pvsONOFF = ON
			{
		    	timerONOFF = OFF;
				programONOFF = OFF;
				extEnable = OFF;
				eepWrite((uint8_t *)&extEnable, EE_EXTENABLE ,sizeof(uint8_t));
				extVMode = 0;
				eepWrite((uint8_t *)&extVMode, EE_EXTVMODE ,sizeof(uint8_t));
				extIMode = 0;
				eepWrite((uint8_t *)&extIMode, EE_EXTIMODE ,sizeof(uint8_t));
			}
			else
				checkPowerOnState();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

scpi_result_t SCPI_485PVPowerBroadcast(scpi_t * context)	// GPVPOW
{
	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if ((param1.type == SCPI_NUM_NUMBER) &&  param1.value <= 100)
		{	
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			percentage = param1.value * 100;
			// local
		    sendMBIntSetting( PVSSIMPOWER_CMD, percentage);
			// broadcast
			SCPI_485SlaveFloat(CMD_SETPVPOW ,RS485_CHAINBROADCAST ,(float)param1.value);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}

scpi_number_t paramf;
scpi_result_t SCPI_485PVTableBroadcast(scpi_t * context)   // GPVTABLEPOINT
{
//	scpi_number_t param1;
	if (!SCPI_ParamNumber(context, &paramf, TRUE)) {     
		return SCPI_RES_ERR;											 
    }	else
	{
		if ((uint16_t)paramf.value > 0 && (uint16_t)paramf.value <= 1024)
		{	
			if (broadcastEcho == ON)
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			pvsPoint = (uint16_t)paramf.value ;
			SCPI_485SlaveInt16(CMD_SETPVTABLEPOINT ,RS485_CHAINBROADCAST ,(int16_t)paramf.value);
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
	    	return SCPI_RES_ERR;
		}
	}
}
scpi_result_t SCPI_485PVStartBroadcast(scpi_t * context)   // GPVTABSTART
{
 	if (/*chainMode == ON && */chainAddrSlave > 0)
	{	
		if (broadcastEcho == ON)
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}
		translate485Cmd(CMD_SETPVTABSTART,RS485_CHAINBROADCAST,chainAddr);
		sendMBQuery(MEASURE_CHANNEL,PVSSTARTLOAD_CMD);	// D3
		return SCPI_RES_OK;	
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}

scpi_result_t SCPI_485PVStopBroadcast(scpi_t * context)	  // GPVTABSTOP
{
	
 	if (/*chainMode == ON && */chainAddrSlave > 0)
	{	
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}
		translate485Cmd(CMD_SETPVTABSTOP,RS485_CHAINBROADCAST,chainAddr);
		sendMBQuery(MEASURE_CHANNEL,PVSSTOPLOAD_CMD);	// D5
		return SCPI_RES_OK;	
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}
}


/* broad cast 
   pvsVoltage ,pvsCurrent

*/

scpi_result_t	SCPI_485PVSIMTabParamBroadcast(scpi_t * context)	  // GPVTABPARM
{
	double param0,param1,param2;
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param0, true)) {
        return SCPI_RES_ERR;
    }	
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read 3th paraeter if present
    if (!SCPI_ParamDouble(context, &param2, true)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
   	if ((float)param1 < 0 || (float)param1 > master.limitVMax)
   	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		return SCPI_RES_ERR;
	}	
   	if ((float)param2 < 0 || (float)param2 > sumlimitIMax())
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
		return SCPI_RES_ERR;
	}
	if (broadcastEcho == ON )
	{	 
		SET_RS485_BROADCAST_ECHO;
		SET_RS485_CHAIN_MASTER;					
	}
	pvsPoint = (uint16_t)param0;pvsVoltage = (float)param1; pvsCurrent = (float)param2;
	// local
	savePvsTableParam();
	// broadcast
	SCPI_485SlavePVTableParameter(CMD_SETPVTABPARM ,RS485_CHAINBROADCAST ,pvsPoint,pvsVoltage ,pvsCurrent);
	return SCPI_RES_OK;
}



/* RS485 set PVSIM curve broadcast*/ 
scpi_result_t	SCPI_485setPVSIMCurveBroadcast(scpi_t * context)	// GPVCURV
{
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param > 0 && param <= 101  || (param == 256) )	// 1 ~ 101  (PC Host ) 
		{	
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			curve = param - 1;
			// local
			sendMBStateSetting(MEASURE_CHANNEL,PVSCURVESELECT_CMD, curve);	// D2 pvs curve select
			// broadcast
			SCPI_485SlaveInt8(CMD_SETPVCURV ,RS485_CHAINBROADCAST ,curve);

			return SCPI_RES_OK;			
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

scpi_result_t SCPI_485PVTableArrayBroadcast(scpi_t * context){	 // GPVTABNUM  pvsarray(int16)
	int32_t param;
    if (!SCPI_ParamInt(context, &param, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if (param >= 128 && param <= 4096)	
		{	
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			// local
			sendMBIntSetting(PVSTABARRAY_CMD, (uint16_t)param);
			// broadcast
			SCPI_485SlaveInt16(CMD_SETTABARRAY ,RS485_CHAINBROADCAST ,(uint16_t)param);

			return SCPI_RES_OK;			
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}



}


scpi_result_t SCPI_485PVpvsGpvsTBroadcast(scpi_t * context){	 //	GPVGT (ӫ,ū)  pvsG(float),pvsT(int16)
	double param1,param2;
	uint16_t param3;
    // read second parameter if present
    if (!SCPI_ParamDouble(context, &param1, true)) {
        return SCPI_RES_ERR;
    }
    // read 3th paraeter if present
    if (!SCPI_ParamDouble(context, &param2, false)) {
        return SCPI_RES_ERR;// do something, if parameter not present
    }
	if (broadcastEcho == ON )
	{	 							  
		SET_RS485_BROADCAST_ECHO;
		SET_RS485_CHAIN_MASTER;					
	}
//	pvsG = (float)param1; pvsT = (float)param2 * 100;

	param3 = (float)param2 * 100;
	// local
	sendMBIntSettingFloatInt16( PVSSIMGT_CMD,(float)param1,param3);
	// broadcast
	SCPI_485SlaveFloatInt16(CMD_SETPVGT ,RS485_CHAINBROADCAST ,(float)param1 ,param3 );
	return SCPI_RES_OK;




}
/*
	GPVFM  formula, material
*/

scpi_result_t SCPI_485PVFMBroadcast(scpi_t * context){			 //	GPVFM  formula, material
	scpi_number_t param1 ,param2;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	if (!SCPI_ParamNumber(context, &param2, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	if ((param1.type == SCPI_NUM_NUMBER) && (param2.type == SCPI_NUM_NUMBER) &&  param1.value <= 3 &&  param2.value <= 3)
	{
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}
//		pvsformula = (int8_t)param1.value;
//		pvsmaterial = (int8_t)param2.value;
		// local
		sendMBIntSettingInt8Int8( PVSFM_CMD, (int8_t)param1.value,(int8_t)param2.value);
		// broadcast
	    SCPI_485SlaveInt8Int8(CMD_SETPVFM ,RS485_CHAINBROADCAST ,(int8_t)param1.value ,(int8_t)param2.value);
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
    	return SCPI_RES_ERR;
	}
}
/*
	GPVVMPPMP  pvsvmp,pvspmp
*/

scpi_result_t SCPI_485PVvmppmpBroadcast(scpi_t * context){		 //	GPVVMPPMP  pvsvmp,pvspmp
	scpi_number_t param1 ,param2;
	if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	if (!SCPI_ParamNumber(context, &param2, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}
//		pvsvmp = (float)param1.value;
//		pvspmp = (float)param2.value;
		// local
		sendMBIntSettingFloatFloat( PVSVMPPMP_CMD, (float)param1.value,(float)param2.value);
		// broadcast
	    SCPI_485SlaveFloatFloat(CMD_SETVMPPMP ,RS485_CHAINBROADCAST ,(float)param1.value ,(float)param2.value);

		return SCPI_RES_OK;
}





scpi_result_t SCPI_485setEcho(scpi_t * context)	 // GECHO
{
	scpi_number_t param1;
	uint8_t i;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else
	{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	
		{
			// local
			if (currentSourceState == ONE_SOURCE)
			{
				if ((uint8_t)param1.value)
				{
					SET_RS485_CHAIN_MASTER;	 //MASTER
					SET_RS485_BROADCAST_ECHO;
					for (totalSlave = 0, i = 0 ; i < MAX_CHAINADDR ; i++)	   // check how many total device?
					{
						if (rs485Id[i].exist == 1)
							rs485Id[i].timer[CMD_QVI_COUNT] = softTimer[MAIN_COUNT].count;	
						totalSlave += rs485Id[i].exist;
					}
				}
				broadcastEcho = ON; // FnIǥXh
				SCPI_485SlaveInt8(CMD_SETECHO ,RS485_CHAINBROADCAST ,(uint8_t)param1.value | (currentSourceState << 4)); // OiD slave qyA
 				while(rs485AnitCollisionBuffer.Count != 0)
				{
					rs485TransmitRetroactive();
				}
				broadcastEcho = (uint8_t)param1.value;
				if (broadcastEcho == 0)
				{
					CLR_RS485_CHAIN_MASTER;
					CLR_RS485_DETECT_HOLD_BUS;
					CLR_RS485_BROADCAST_ECHO;
					RELEASE_RS485_BUS; clearErorrQueue();
					rs485ErrorConnect[0] = rs485ErrorConnect[1] = 0;
					rs485PacketSerialNumberFlag	= 0;	
					memset((void *)broadcastOKCount	,0,32);		
					memset((void *)rs485Id , 0 ,sizeof(rs485Id_TypDef) * MAX_CHAINADDR);
					memset((void *)&rs485AnitCollisionBuffer , 0, sizeof(rs485AntiCollisionBuffer_TypDef));
					memset((void *)rs485SlavevOut , 0 , sizeof(float) * MAX_CHAINADDR);
					memset((void *)rs485SlaveiOut , 0 , sizeof(float) * MAX_CHAINADDR);
					totalSlave = 0;
					softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].count = softTimer[MAIN_COUNT].count;
					softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].flag = ENABLE;
				}
				return SCPI_RES_OK;
			}
			else if(currentSourceState == CURRENT_SOURCE_NOT_EXIST || currentSourceState == DB25_NOT_INSTALL)
			{	
				broadcastEcho = (uint8_t)param1.value;
				if (broadcastEcho)
				{ 
					SET_RS485_CHAIN_MASTER;	  // MASTER
					SET_RS485_BROADCAST_ECHO; //^
					for (totalSlave = 0, i = 0 ; i < MAX_CHAINADDR ; i++) // check how many total divice?
					{
						if (rs485Id[i].exist == 1)
							rs485Id[i].timer[CMD_QVI_COUNT] = softTimer[MAIN_COUNT].count;	
						totalSlave += rs485Id[i].exist;
					}
					SCPI_485SlaveInt8(CMD_SETECHO ,RS485_CHAINBROADCAST ,broadcastEcho | (currentSourceState << 4)); // OiD slave qyA
				}
				else  // broadcastEcho = 0
				{
					masterState = 0;
					slaveIndex = 0;
					CLR_RS485_CHAIN_MASTER;
					CLR_RS485_DETECT_HOLD_BUS;
					CLR_RS485_BROADCAST_ECHO;
					RELEASE_RS485_BUS; clearErorrQueue();
					rs485PacketSerialNumberFlag	= 0;	
					memset((void *)broadcastOKCount	,0,32);	
					rs485ErrorConnect[0] = rs485ErrorConnect[1] = 0;	
					memset((void *)rs485Id , 0 ,sizeof(rs485Id_TypDef) * MAX_CHAINADDR);
					memset((void *)&rs485AnitCollisionBuffer , 0, sizeof(rs485AntiCollisionBuffer_TypDef));
					memset((void *)rs485SlavevOut , 0 , sizeof(float) * MAX_CHAINADDR);
					memset((void *)rs485SlaveiOut , 0 , sizeof(float) * MAX_CHAINADDR);
					totalSlave = 0;
					softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].count = softTimer[MAIN_COUNT].count;
					softTimer[DELAY_CLR_PREVENT_TO_JAM_COUNT].flag = ENABLE;
					delayMs(3);
					SCPI_485SlaveInt8(CMD_SETECHO ,RS485_CHAINBROADCAST ,broadcastEcho | (currentSourceState << 4)); // OiD slave qyA
					delayMs(3);
					SCPI_485SlaveInt8(CMD_SETECHO ,RS485_CHAINBROADCAST ,broadcastEcho | (currentSourceState << 4)); // OiD slave qyA
					delayMs(3);
					SCPI_485SlaveInt8(CMD_SETECHO ,RS485_CHAINBROADCAST ,broadcastEcho | (currentSourceState << 4)); // OiD slave qyA
				}
				return SCPI_RES_OK;
			}
			else
				return SCPI_RES_ERR; // multi source
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}
	}
}

scpi_result_t SCPI_485queryEcho(scpi_t * context)	// GECHO?
{
	scpi_number_t param1;
	char bf[15];
	param1.type = returnONOFF(broadcastEcho);
    SCPI_NumberToStr(context, &param1, bf, 15);
	strcat((void *)(bf),"\r\n");
	scpiuartTransmit(witchCOM, (void *)bf, strlen((void *)bf));
	return SCPI_RES_OK;
}
scpi_result_t SCPI_485querytotalSlave(scpi_t * context)	// GDEVICE?
{
	sprintf((void *)transBuffer,"%d\r\n",totalSlave);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	return SCPI_RES_OK;
}


scpi_result_t SCPI_485queryConnectStatus(scpi_t * context)	// GCSTATUS?
{
	sprintf((void *)transBuffer,"%x%x\r\n",rs485ErrorConnect[1],rs485ErrorConnect[0]);
	scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
	SET_RS485_BROADCAST_ECHO;
	return SCPI_RES_OK;
}


scpi_result_t SCPI_485setParallelState(scpi_t * context){	// GPARALLELSTATE
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	
		{
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			SCPI_485SlaveInt8(CMD_SETPARALLELSTATE ,RS485_CHAINBROADCAST ,(uint8_t)param1.value);
			delayMs(100);
			parallelMode = param1.value;
			initparallelMode();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}
scpi_result_t SCPI_485setChainState(scpi_t * context){	// GCHAINSTATE
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	
		{
				if (broadcastEcho == ON )
				{	 
					SET_RS485_BROADCAST_ECHO;
					SET_RS485_CHAIN_MASTER;					
				}
			SCPI_485SlaveInt8(CMD_SETCHAINSTATE ,RS485_CHAINBROADCAST ,(uint8_t)param1.value);
			delayMs(100);
			chainMode = param1.value;
			initchainMode();
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}

/*
   set parallelDebug 
*/

scpi_result_t SCPI_485setparallelDebug(scpi_t * context){	// GPARALLELDEBUG
	scpi_number_t param1;
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_OFF || param1.type == SCPI_PARM_ON )&& (param1.value < 2))	
		{
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			SCPI_485SlaveInt8(CMD_SETPARALLELDEBUG ,RS485_CHAINBROADCAST ,(uint8_t)param1.value);
			parallelDebug = param1.value;
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}


 scpi_result_t	SCPI_485setPVCtrlModeBroadCast(scpi_t * context)	// GPVCTRLMOD
{
	scpi_number_t param1;
	
    if (!SCPI_ParamNumber(context, &param1, TRUE)) {     
		return SCPI_RES_ERR;											 
    }
	else{
		if ((param1.type == SCPI_NUM_NUMBER || param1.type == SCPI_PARM_CC || param1.type == SCPI_PARM_CV )&& (param1.value < 2))	
		{
			if (broadcastEcho == ON )
			{	 
				SET_RS485_BROADCAST_ECHO;
				SET_RS485_CHAIN_MASTER;					
			}
			SCPI_485SlaveInt8(CMD_SETPVCTRLMOD ,RS485_CHAINBROADCAST ,(uint8_t)param1.value);
			pvCtrlMode = param1.value;
			sendMBStateSetting(MEASURE_CHANNEL,PVCTRLMOD_CMD, pvCtrlMode);		// pvs mode on/off
			return SCPI_RES_OK;
		}
		else
		{
			SCPI_ErrorPush(context, SCPI_ERROR_PARAMETER_NOT_ALLOWED);
			return SCPI_RES_ERR;
		}					 
	}
}




/* SHADOW COMMAND
	2015 / 4 /15
  PVS SIM  Shadow program PC scpi command control Measurement board...
*/


scpi_result_t	SCPI_485PVShdParmBroadcast(scpi_t * context){ // GPVSHDPARM E5
	double param1,param2,param3,param4,param5;
	if ( chainAddrSlave > 0)
	{
	    // read first parameter if present
		if (!SCPI_ParamDouble(context, &param1, true)) {
        	return SCPI_RES_ERR;
   	}		
	    // read second parameter if present
   	if (!SCPI_ParamDouble(context, &param2, true)) {
        	return SCPI_RES_ERR;
   	}
    	// read 3th paraeter if present
   	if (!SCPI_ParamDouble(context, &param3, true)) {
        	return SCPI_RES_ERR;// do something, if parameter not present
   	}
    	// read 4th parameter if present
   	if (!SCPI_ParamDouble(context, &param4, true)) {
	        return SCPI_RES_ERR;
   	}
    	// read 5th paraeter if present
   	if (!SCPI_ParamDouble(context, &param5, true)) {
	        return SCPI_RES_ERR;// do something, if parameter not present
    }
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}			
		// a
		uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
		uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(float) * 5; //
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = PVSHDPARME5_CMD;//0xE5; // CMD
		unionbyte.ftob = (float)param1;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = unionbyte.byte_loc[3];	// MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[2];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[1];	
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param2;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = unionbyte.byte_loc[3];	// MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6] = unionbyte.byte_loc[2];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7] = unionbyte.byte_loc[1];	
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param3;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[9] = unionbyte.byte_loc[3];	// MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[10] = unionbyte.byte_loc[2];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[11] = unionbyte.byte_loc[1];	
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[12] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param4;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[13] = unionbyte.byte_loc[3];	// MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[14] = unionbyte.byte_loc[2];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[15] = unionbyte.byte_loc[1];	
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[16] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param5;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[17] = unionbyte.byte_loc[3];	// MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[18] = unionbyte.byte_loc[2];
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[19] = unionbyte.byte_loc[1];	
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[20] = unionbyte.byte_loc[0];
		
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
		calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
		uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);

		// broadcast 

		rs485Packet.Head = RS485_HEAD;
		rs485Packet.DA = RS485_CHAINBROADCAST; // ت	
		rs485Packet.SA = chainAddr; // ӷ
		rs485Packet.Len = 1 + sizeof(float ) * 5;
		rs485Packet.Cmd = CMD_SETPVSHDE5;//cmd;
		unionbyte.ftob = (float)param1;	//Voc
		rs485Packet.Data[0] = unionbyte.byte_loc[3]; 
		rs485Packet.Data[1] = unionbyte.byte_loc[2];
		rs485Packet.Data[2] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[3] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param2; // Isc
		rs485Packet.Data[4] = unionbyte.byte_loc[3]; 
		rs485Packet.Data[5] = unionbyte.byte_loc[2];
		rs485Packet.Data[6] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[7] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param3; // Vmp
		rs485Packet.Data[8] = unionbyte.byte_loc[3]; 
		rs485Packet.Data[9] = unionbyte.byte_loc[2];
		rs485Packet.Data[10] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[11] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param4; // Imp
		rs485Packet.Data[12] = unionbyte.byte_loc[3]; 
		rs485Packet.Data[13] = unionbyte.byte_loc[2];
		rs485Packet.Data[14] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[15] = unionbyte.byte_loc[0];
		unionbyte.ftob = (float)param5; // beta
		rs485Packet.Data[16] = unionbyte.byte_loc[3]; 
		rs485Packet.Data[17] = unionbyte.byte_loc[2];
		rs485Packet.Data[18] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[19] = unionbyte.byte_loc[0];
	
		rs485Packet.Data[rs485Packet.Len - 1]  = rs485Packet.Serial = specifyNumber();
		
		rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
		rs485AntiCollision();
		receivedRS485Packet();

		return SCPI_RES_OK;
    }	
	else
		return SCPI_RES_ERR;	

}
scpi_result_t	SCPI_485PVShdNGTBroadcast(scpi_t * context){ // GPVSHDNGT  E6
	double param1,param2,param3;
	if ( chainAddrSlave > 0)
	{
	    // read first parameter if present
		if (!SCPI_ParamDouble(context, &param1, true)) {
        	return SCPI_RES_ERR;
   	}		
	    // read second parameter if present
   	if (!SCPI_ParamDouble(context, &param2, true)) {
        	return SCPI_RES_ERR;
   	}
    	// read 3th paraeter if present
   	if (!SCPI_ParamDouble(context, &param3, true)) {
        	return SCPI_RES_ERR;// do something, if parameter not present
   	}
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}			
		// a
		uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
		uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(uint8_t) + sizeof(uint16_t) * 2; //
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = 0xE6; // CMD

		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = (uint8_t)param1;	//  NUM MSB first
		unionbyte.itob[0] = (uint16_t)param2;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[1];	// G MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param3;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[1];	// T MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = unionbyte.byte_loc[0];
		
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
		calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
		uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);

		// broadcast 

		rs485Packet.Head = RS485_HEAD;
		rs485Packet.DA = RS485_CHAINBROADCAST; // ت	
		rs485Packet.SA = chainAddr; // ӷ
		rs485Packet.Len = 1 + sizeof(uint8_t) + sizeof(uint16_t) * 2;
		rs485Packet.Cmd = CMD_SETPVSHDE6;//cmd;
		rs485Packet.Data[0] = (uint8_t)param1; // NUM  
		unionbyte.itob[0] = (uint16_t)param2; //  G
		rs485Packet.Data[1] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[2] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param3; //  T
		rs485Packet.Data[3] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[4] = unionbyte.byte_loc[0];
	
		rs485Packet.Data[rs485Packet.Len - 1]  = rs485Packet.Serial = specifyNumber();
		
		rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
		rs485AntiCollision();
		receivedRS485Packet();

		return SCPI_RES_OK;
  }	
	else
		return SCPI_RES_ERR;	
	
	
}	
scpi_result_t	SCPI_485PVShdParallelNumBroadcast(scpi_t * context){ // PVSHDPARALLELNUM E7
	double param1;
	if ( chainAddrSlave > 0)
	{
	    // read first parameter if present
		if (!SCPI_ParamDouble(context, &param1, true)) {
        	return SCPI_RES_ERR;
   	}		
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}			
		// a
		uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
		uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(uint8_t); //
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = 0xE7; // CMD

		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = (uint8_t)param1;	//  parallel number  MSB first
		
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
		calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
		uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);

		// broadcast 

		rs485Packet.Head = RS485_HEAD;
		rs485Packet.DA = RS485_CHAINBROADCAST; // ت	
		rs485Packet.SA = chainAddr; // ӷ
		rs485Packet.Len = 1 + sizeof(uint8_t);
		rs485Packet.Cmd = CMD_SETPVSHDE7;//cmd;
		rs485Packet.Data[0] = (uint8_t)param1; // NUM  
	
		rs485Packet.Data[rs485Packet.Len - 1]  = rs485Packet.Serial = specifyNumber();
		
		rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
		rs485AntiCollision();
		receivedRS485Packet();

		return SCPI_RES_OK;
  }	
	else
		return SCPI_RES_ERR;	
}
scpi_result_t	SCPI_485PVShdParallelParmBroadcast(scpi_t * context){ // GPVSHDPARALLELPARM E8
	double param1,param2,param3,param4,param5,param6,param7,param8;
	if ( chainAddrSlave > 0)
	{
	    // read first parameter if present
		if (!SCPI_ParamDouble(context, &param1, true)) {
        	return SCPI_RES_ERR;
   	}		
	    // read second parameter if present
   	if (!SCPI_ParamDouble(context, &param2, true)) {
        	return SCPI_RES_ERR;
   	}
    	// read 3th paraeter if present
   	if (!SCPI_ParamDouble(context, &param3, true)) {
        	return SCPI_RES_ERR;// do something, if parameter not present
   	}
		 // 4th
		if (!SCPI_ParamDouble(context, &param4, true)) {
        	return SCPI_RES_ERR;
   	}		
	    // read 5th parameter if present
   	if (!SCPI_ParamDouble(context, &param5, true)) {
        	return SCPI_RES_ERR;
   	}
    	// read 6th paraeter if present
   	if (!SCPI_ParamDouble(context, &param6, true)) {
        	return SCPI_RES_ERR;// do something, if parameter not present
   	}		
    	// read 7th paraeter if present
   	if (!SCPI_ParamDouble(context, &param7, true)) {
        	return SCPI_RES_ERR;// do something, if parameter not present
   	}				
    	// read 8th paraeter if present
   	if (!SCPI_ParamDouble(context, &param8, true)) {
        	return SCPI_RES_ERR;// do something, if parameter not present
   	}						
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}			
		// a
		uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
		uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(uint8_t) + sizeof(uint16_t) * 7; //
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = 0xE8; // CMD

		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = (uint8_t)param1;	//  parallel count MSB first
		unionbyte.itob[0] = (uint16_t)param2;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[2] = unionbyte.byte_loc[1];	// type1 MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[3] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param3;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[4] = unionbyte.byte_loc[1];	// type2 MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[5] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param4;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[6] = unionbyte.byte_loc[1];	// type3 MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[7] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param5;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[8] = unionbyte.byte_loc[1];	// type4 MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[9] = unionbyte.byte_loc[0];		
		unionbyte.itob[0] = (uint16_t)param6;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[10] = unionbyte.byte_loc[1];	// type5 MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[11] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param7;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[12] = unionbyte.byte_loc[1];	// type6 MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[13] = unionbyte.byte_loc[0];		
		unionbyte.itob[0] = (uint16_t)param8;
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[14] = unionbyte.byte_loc[1];	// type7 MSB first
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[15] = unionbyte.byte_loc[0];				
		
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
		calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
		uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);

		// broadcast 

		rs485Packet.Head = RS485_HEAD;
		rs485Packet.DA = RS485_CHAINBROADCAST; // ت	
		rs485Packet.SA = chainAddr; // ӷ
		rs485Packet.Len = 1 + sizeof(uint8_t) + sizeof(uint16_t)*7;
		rs485Packet.Cmd = CMD_SETPVSHDE8;//cmd;
		rs485Packet.Data[0] = (uint8_t)param1; // parallel count  
		unionbyte.itob[0] = (uint16_t)param2; //  type1
		rs485Packet.Data[1] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[2] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param3; //  type2
		rs485Packet.Data[3] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[4] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param4; //  type3
		rs485Packet.Data[5] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[6] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param5; //  type4
		rs485Packet.Data[7] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[8] = unionbyte.byte_loc[0];		
		unionbyte.itob[0] = (uint16_t)param6; //  type5
		rs485Packet.Data[9] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[10] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param7; //  type6
		rs485Packet.Data[11] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[12] = unionbyte.byte_loc[0];
		unionbyte.itob[0] = (uint16_t)param8; //  type7
		rs485Packet.Data[13] = unionbyte.byte_loc[1]; 
		rs485Packet.Data[14] = unionbyte.byte_loc[0];		
	
		rs485Packet.Data[rs485Packet.Len - 1]  = rs485Packet.Serial = specifyNumber();
		
		rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
		rs485AntiCollision();
		receivedRS485Packet();

		return SCPI_RES_OK;
  }	
	else
		return SCPI_RES_ERR;	
}
scpi_result_t	SCPI_485PVShdSimModBroadcast(scpi_t * context){ // GPVSHDSIMMOD EA
	double param1;
	if ( chainAddrSlave > 0)
	{
	    // read first parameter if present
		if (!SCPI_ParamDouble(context, &param1, true)) {
        	return SCPI_RES_ERR;
   	}		
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}			
		// a
		uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
		uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + sizeof(uint8_t); //
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = PVSSHDSIMMODE_CMD;//0xEA; // CMD

		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[1] = (uint8_t)param1;	//  SIM MODE  MSB first
		
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
		calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
		uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);

		if ((uint8_t)param1 == 1)
			SET_PVSSHDSIMMOD_ON;
		else
			CLR_PVSSHDSIMMOD_ON;
		// broadcast 

		rs485Packet.Head = RS485_HEAD;
		rs485Packet.DA = RS485_CHAINBROADCAST; // ت	
		rs485Packet.SA = chainAddr; // ӷ
		rs485Packet.Len = 1 + sizeof(uint8_t);
		rs485Packet.Cmd = CMD_SETPVSHDEA;//cmd;
		rs485Packet.Data[0] = (uint8_t)param1; // SIM MODE  
	
		rs485Packet.Data[rs485Packet.Len - 1]  = rs485Packet.Serial = specifyNumber();
		
		rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
		rs485AntiCollision();
		receivedRS485Packet();

		return SCPI_RES_OK;
  }	
	else
		return SCPI_RES_ERR;	
}

uint8_t buildBasicCurveOK; // Aǰe E5,E6ƫ ,E9 RO,~bDOUE8 ,ѼƬE9 RO

const char * param;
scpi_result_t SCPI_485PVTABWriteCRC(scpi_t * context){ // GPVTABWCRC
    size_t len;
		if (!SCPI_ParamString(context, &param, &len, true)) {
        return SCPI_RES_ERR;
    }
		if (broadcastEcho == ON )
		{	 
			SET_RS485_BROADCAST_ECHO;
			SET_RS485_CHAIN_MASTER;					
		}	
		// a
		uartBuffer[MEASURE_CHANNEL].simplePacket.head = SIMPLE;	  // MPPT write to E7
		uartBuffer[MEASURE_CHANNEL].simplePacket.length = 2 + len; //
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[0] = PVTABCRC_CMD; // 0xEB CMD

		memcpy((void *)(uartBuffer[MEASURE_CHANNEL].simplePacket.payload + 1) , (void *)param , len);
		
		uartBuffer[MEASURE_CHANNEL].simplePacket.payload[uartBuffer[MEASURE_CHANNEL].simplePacket.length - 1] = 
		calculateCrc8(&uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 1);
		uartTransmit(MEASURE_CHANNEL, &uartBuffer[MEASURE_CHANNEL].simplePacket.head, uartBuffer[MEASURE_CHANNEL].simplePacket.length + 2);

		// broadcast 

		rs485Packet.Head = RS485_HEAD;
		rs485Packet.DA = RS485_CHAINBROADCAST; // ت	
		rs485Packet.SA = chainAddr; // ӷ
		rs485Packet.Len = 1 + len;
		rs485Packet.Cmd = CMD_SETPVTABCRC;//cmd;
		
		memcpy((void *)(rs485Packet.Data) , (void *)param , len);
	
		rs485Packet.Data[rs485Packet.Len - 1]  = rs485Packet.Serial = specifyNumber();
		
		rs485Packet.Data[rs485Packet.Len] = rs485Packet.CRC8 = calculateCrc8(&rs485Packet.Head,rs485Packet.Len + 5 );
		rs485AntiCollision();
		receivedRS485Packet();		
		
		return SCPI_RES_OK;
		
}

scpi_result_t	SCPI_485PVSHDQueryE9(scpi_t * context){ // CPVCSHDQE9
	if (chainAddrSlave > 0)
	{	
		if (chainAddrSlave == chainAddr)	// a
		{
			if (buildBasicCurveOK)
				transBuffer[0] = '1';
				 // OK
			else
				transBuffer[0] = '0'; // not yet
			strcpy((void *)(transBuffer + 1) ,"\r\n" );
			scpiuartTransmit(witchCOM,(void *)transBuffer , strlen((void *)transBuffer));
			buildBasicCurveOK = 0;
		}
		else
		{	
			CLR_RS485_BROADCAST_ECHO;
			SCPI_485SlaveCmd(CMD_PVSHDE9Q);
		}
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}		

}


uint8_t pvTabCRC[10] = {0x39,0x41 ,0x42,0,0,0,0,0,0,0};
scpi_result_t	SCPI_485PVTABQueryCRC(scpi_t * context){ // CPVTABQCRC


	if (chainAddrSlave > 0)
	{	
		if (chainAddrSlave == chainAddr)	// a
		{
			sendMBQuery(MEASURE_CHANNEL,PVTABCRCQ_CMD);	//EC
			delayMs(50);										// receive ED
			while (uartBuffer[MEASURE_CHANNEL].packetCount != 0)	//Nbuffer Bzʥ] M
			{
				uartBuffer[MEASURE_CHANNEL].packetCount--;
				receiveMBResponse(MEASURE_CHANNEL);
			}					   
			strcpy((void *)(transBuffer),(void *)pvTabCRC);
			strcat((void *)(transBuffer),"\r\n");
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
		else
		{
			CLR_RS485_BROADCAST_ECHO;
			SCPI_485SlaveCmd(CMD_PVTABCRCQ);
		}
		return SCPI_RES_OK;
	}
	else
	{
		SCPI_ErrorPush(context, SCPI_ERROR_EXECUTION_ERROR);
		return SCPI_RES_ERR;
	}		
	
	
}














/*	 
  Dump E7 parameter 1~44
       E6 parameter 45~54

 1  VOLTAGE SET A[0]
 2  VOLTAGE SET A[1]
 3  VOLTAGE SET A[2]
 4  VOLTAGE SET B[0]
 5  VOLTAGE SET B[1]
 6  VOLTAGE SET B[2]
 7  VOLTAGE READ A[0]
 8  VOLTAGE READ A[1]
 9  VOLTAGE READ A[2]
10  VOLTAGE READ B[0]
11  VOLTAGE READ B[1]
12  VOLTAGE READ B[2]
13  VOLTAGE SET COUNT[0]
14  VOLTAGE SET COUNT[1]
15  VOLTAGE SET COUNT[2]
16  VOLTAGE SET COUNT[3]
17  VOLTAGE READ COUNT[0]
18  VOLTAGE READ COUNT[1]
19  VOLTAGE READ COUNT[2]
20  VOLTAGE READ COUNT[3]
21  OVP_A
22  OVP_B
23  CURRENT SET A[0]
24  CURRENT SET A[1]
25  CURRENT SET A[2]
26  CURRENT SET B[0]
27  CURRENT SET B[1]
28  CURRENT SET B[2]
29  CURRENT READ A[0]
30  CURRENT READ A[1]
31  CURRENT READ A[2]
32  CURRENT READ B[0]
33  CURRENT READ B[1]
34  CURRENT READ B[2]
35  CURRENT SET COUNT[0]
36  CURRENT SET COUNT[1]
37  CURRENT SET COUNT[2]
38  CURRENT SET COUNT[3]
39  CURRENT READ COUNT[0]
40  CURRENT READ COUNT[1]
41  CURRENT READ COUNT[2]
42  CURRENT READ COUNT[3]
43  OCP_A
44  OCP_B
45  EXT VOLT AD1
46	EXT VOLT AD2
47	EXT VOLT LOW
48	EXT VOLT HIGH
49	EXT VOLT CONST CURRENT
50  EXT CURR AD1
51	EXT CURR AD2
52	EXT CURR LOW
53	EXT CURR HIGH
54	EXT CURR CONST CURRENT

*/

scpi_result_t SCPI_paramRcall(scpi_t * context)
{
	uint8_t i,bf[15];
	float tempfloat;
	uint16_t tempint16;
	delayMs(50);
	clearMeasureCommand();//Nbuffer Bzʥ] M
	for(i = 0 ; i < 44 ;i++)
	{
		sendMBStateSetting(MEASURE_CHANNEL,DUMPQ_CMD, i);
		delayMs(30);
		if (uartBuffer[MEASURE_CHANNEL].packetCount != 0)
		{
			uartBuffer[MEASURE_CHANNEL].packetCount--;
			receiveMBResponse(MEASURE_CHANNEL);
			scpiuartTransmit(witchCOM, (void *)transBuffer, strlen((void *)transBuffer));
		}
	}
	eepRead((uint8_t *)&tempint16,EE_FAT_EXTCALVAD_0 ,sizeof(uint16_t));
	sprintf((void *)bf ,"%d\r\n" ,tempint16);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempint16,EE_FAT_EXTCALVAD_1 ,sizeof(uint16_t));
	sprintf((void *)bf ,"%d\r\n" ,tempint16);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempfloat,EE_FAT_EXTCALV_0 ,sizeof(float));
	sprintf((void *)bf ,"%7.5f\r\n" ,tempfloat);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempfloat,EE_FAT_EXTCALV_1 ,sizeof(float));
	sprintf((void *)bf ,"%7.5f\r\n" ,tempfloat);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempfloat,EE_FAT_VOLTAGERESCURR ,sizeof(float));
	sprintf((void *)bf ,"%7.5f\r\n" ,tempfloat);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempint16,EE_FAT_EXTCALIAD_0 ,sizeof(uint16_t));
	sprintf((void *)bf ,"%d\r\n" ,tempint16);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempint16,EE_FAT_EXTCALIAD_1 ,sizeof(uint16_t));
	sprintf((void *)bf ,"%d\r\n" ,tempint16);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempfloat,EE_FAT_EXTCALI_0 ,sizeof(float));
	sprintf((void *)bf ,"%7.5f\r\n" ,tempfloat);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempfloat,EE_FAT_EXTCALI_1 ,sizeof(float));
	sprintf((void *)bf ,"%7.5f\r\n" ,tempfloat);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));

	eepRead((uint8_t *)&tempfloat,EE_FAT_CURRENTRESCURR ,sizeof(float));
	sprintf((void *)bf ,"%7.5f\r\n" ,tempfloat);
	scpiuartTransmit(witchCOM, (void *)bf ,strlen((void *)bf));
	return SCPI_RES_OK;
}





#endif



















